// $Header: /teamproj/cvsroot/teamb/bkasrc/au/edu/swin/synergy/kernel/BCommandComplete.java,v 1.5 1999/10/01 04:30:47 tp079519 Exp $

package au.edu.swin.synergy.kernel;

import java.util.EventObject;

/**
 * After an event has been processed by a plugin
 * @see BCommandEvent
 * @concurrency
 * @copyright 1999 Synergy Software
 * @rref
 * @author John Newbigin
 */

public abstract class BCommandComplete
{
    
    /**
     * An error has occured in the processing of the event
     */
    public static int kError = - 1;
    
    /**
     * An intermediate success code.  Completion will be called again
     */
    public static int kPending = 0;
    
    
    /**
     * The event was processed successfully
     */
    public static int kSuccess = 1;
    
    /**
     * An error occured in the communications layer.  Results are undefined
     */
    public static int kNetError = - 2;

	/**
	 * No plugins have called complete so this is the default completion
	 */
    public static int kDefault = - 3;
    
    /**
     * this method is invoked when a pluing calls doCompletion on an event
     * @post all handling of the event has been completed
     * @pre the event has been dispatched
     * @throws none
     * @return void
     * @param The event object
     * @param the return status
     */
    
    public abstract void doComplete( BCommandEvent event, int status );
}
