/**
 * Please complete these missing tags
 * @see
 * @concurrency
 * @copyright
 * @rref
 * @author
 */
// $Header: /teamproj/cvsroot/teamb/bkasrc/au/edu/swin/synergy/kernel/BCommandEvent.java,v 1.10 1999/10/12 04:49:21 tp079519 Exp $

package au.edu.swin.synergy.kernel;

import java.util.EventObject;
import java.io.Serializable;
import java.io.IOException;
import au.edu.swin.synergy.lib.BStringList;
import au.edu.swin.synergy.plugin.server.BSocketObjectPipe;
import au.edu.swin.synergy.debug.Debug;

// This is the event which is passed around
/**
 * This is the base class for all events sent through the kernel.<P>
 * 
 */

public class BCommandEvent extends EventObject implements Serializable
{
	public static final long serialVersionUID = -1747592701797559370L;
    
    public static final int kLocal = 0;
    // no network capability
    public static final int kServer = 1;
    // send this event to the server
    public static final int kServerDone = 2;
    // server completed event
    public static final int kClient = 3;
    // send this event to a/all client(s)
    public static final int kClientDone = 4;
    // client completed event
    protected int networkStatus = kLocal;
    
    transient BSocketObjectPipe pipe = null;
    // add data elements in here....
    private boolean undoable = false;
    private transient BCommandComplete completionObject = null;
    protected int index;
    protected int connectionID = -1;
    
    public static int kBroadcast = - 1;
    private int completionStatus;

	private boolean autoComplete = true;
    
    
    
    /**
     * Default constructor
     */
    
    public BCommandEvent()
    {
        super( null );
    }
	
    /**
     * This constructor calls the super constructor and sets the source to the specified object
     * @param source the plugin sending the sevent
     */
    
    public BCommandEvent( Object source )
    {
        super( source );
        // other stuff...
    }
	
    /**
     * Returns this events completion object
     * @return the completion object.  This may be null if no object has been specified
     */
    
    public BCommandComplete getCompletionObject()
    {
        return completionObject;
    }
	
    /**
     * Set this events completion object
     * @post the completion object has been saved
     */
    
    public void setCompletionObject( BCommandComplete object )
    {
        completionObject = object;
    }
	
    /**
     * This method is not used and is subject to be removed
     * @return true if the event can be undone
     */
    
    public boolean getUndoable()
    {
        return undoable;
    }
	
    /**
     * This method is not used and is subject to be removed 
     * @post the undo status has been updated
     * @param fUndoable the new undo status
     */
    
    public void setUndoable( boolean fUndoable )
    {
        undoable = fUndoable;
    }
	
    /**
     * get the the pipe that this event came from
     * @return the SocketObjectPipe
     */
    
    public BSocketObjectPipe getPipe()
    {
        return pipe;
    }
	
    /**
     * set the Pipe
     */
    
    public void setPipe( BSocketObjectPipe fPipe )
    {
        pipe = fPipe;
    }
	
    /**
     * Please complete the missing tags for getIndex
     * @param
     * @return
     * @pre
     * @post
     */
    public int getIndex()
    {
        return index;
    }
    /**
     * Please complete the missing tags for setIndex
     * @param
     * @return
     * @pre
     * @post
     */
    
    public void setIndex( int fIndex )
    {
        index = fIndex;
    }
    /**
     * Please complete the missing tags for getConnectionID
     * @param
     * @return
     * @pre
     * @post
     */
    
    public int getConnectionID()
    {
        return connectionID;
    }
    /**
     * Please complete the missing tags for getNetworkStatus
     * @param
     * @return
     * @pre
     * @post
     */
    
    public int getNetworkStatus()
    {
        return networkStatus;
    }
    /**
     * Please complete the missing tags for setNetworkStatus
     * @param
     * @return
     * @pre
     * @post
     */
    
    public void setNetworkStatus( int fNetworkStatus )
    {
        networkStatus = fNetworkStatus;
    }
    /**
     * Please complete the missing tags for getCompletionStatus
     * @param
     * @return
     * @pre
     * @post
     */
    
    public int getCompletionStatus()
    {
        return completionStatus;
    }
    /**
     * Please complete the missing tags for setConnectionID
     * @param
     * @return
     * @pre
     * @post
     */
    
    public void setConnectionID( int fConnectionID )
    {
        connectionID = fConnectionID;
    }
    /**
     * Please complete the missing tags for setCompletionStatus
     * @param
     * @return
     * @pre
     * @post
     */
    
    public void setCompletionStatus( int fCompletionStatus )
    {
        completionStatus = fCompletionStatus;
    }
    /**
     * Please complete the missing tags for doInit
     * @param
     * @return
     * @pre
     * @post
     */
    
    public boolean doInit( BStringList params )
    {
        return false;
    }
    /**
     * Please complete the missing tags for doComplete
     * @post
     * @pre
     * @throws
     * @return
     * @param
     */
    
    public void doComplete( int status )
    {
		synchronized(this)
		{
			completionCount++;
		}
		
        if( completionObject != null )
        {
            //completionObject.doComplete( this, status );
			new BCallCompletion(status).run();
        }
    }

	/**
	 * Completion management
	 * if the thread count is decremented to 0 and completion count is
	 * still 0 then we call completion with a status code which indicates
	 * that no plugins processed the event
	 *
	 * a plugin can process the event, and not call completion which
	 * still means the completion count is still 0
	 */
	private int threadCount = 0;
	private int completionCount = 0;

	public void setAutoComplete(boolean fAutoComplete)
	{
		autoComplete = fAutoComplete;
	}

	public boolean getAutoComplete()
	{
		return autoComplete;
	}

	public void setThreadCount(int count)
	{
		synchronized(this)
		{
			threadCount = count;
		}
	}

	public void decrementThreadCount()
	{
		boolean callCompletion = false;
		
		synchronized(this)
		{
			threadCount--;

			if(threadCount == 0)
			{
				if(completionCount == 0)
				{
					// call completion (in a new thread?)
					callCompletion = true;
				}
			}
		}

		if(callCompletion && autoComplete)
		{
			// issues relating to events sent to the server need to be addressed...
			Debug.doPrintln("Uncompleted event netstatus = " + networkStatus + " connection ID = " + connectionID);

			if(networkStatus == kLocal || (networkStatus == kServer && connectionID != -1))
			{
				Debug.doPrintln("Default calling the completion object for " + this.getClass().getName());
				doComplete(BCommandComplete.kDefault);
			}
		}

	}

	class BCallCompletion extends Thread
	{
		int status;

		public BCallCompletion(int fStatus)
		{
			status = fStatus;
		}
		
		public void run()
		{
			try
			{
	            completionObject.doComplete( BCommandEvent.this, status );
			}
			catch(Exception e)
			{
				Debug.doPrintln("Completion object has thrown an exception", e);
			}
		}
	}
}
