// $Header: /teamproj/cvsroot/teamb/bkasrc/au/edu/swin/synergy/kernel/Bka.java,v 1.6 1999/10/12 04:49:21 tp079519 Exp $

package au.edu.swin.synergy.kernel;

import java.lang.String;
import au.edu.swin.synergy.lib.BStringList;
import au.edu.swin.synergy.debug.Debug;

/**
 * Kernel loader
 * Loads the kernel and then boots it
 *
 * @Author John Newbigin
 * @Copyright Synergy Software 1999
 * @see n/a
 * @concurrency static instance
 * @rref tristans book
 */

public class Bka
{
    /**
     * static main method.  To run Bka, type
	 * java au.edu.swin.synergy.kernel.Bka
	 * This will create a new kernel and pass it the command line parameters
     * @post the kernel is running
     * @param a list of configuration files
     */
    public static void main( String [] args )
    {
        Debug.doPrintln( "Bka started" );
        System.out.println( "TeamB kernel architecture" );
        
        // get the list of files to load
        BStringList files = new BStringList();
        if( args.length > 0 )
        {
            for( int i = 0; i < args.length; i++ )
            {
                files.add( args [ i ] );
                Debug.doPrintln( "using conf file " + args [ i ] );
            }
        }
        else
        {
            files.add( "modules.conf" );
            Debug.doPrintln( "using default modules.conf" );
        }
        
        BKernel kernel = new BKernel( files );
        kernel.boot();
    }
}
