//$

package au.edu.swin.synergy.lib;

import javax.swing.ComboBoxModel;

/** 
 * Provides a generic means of placing items in a JComboBox
 *
 * @author Matthew Evans
 */
public class BComboBoxModel extends BListModel implements ComboBoxModel
{
   /**
    * Represents the item that is currently selected in a JComboBox 
    */
   private Object selectedItem = null;
   

   /**
    * Returns the item that is currently selected in a JComboBox 
    *
    * @return the object that is currently selected
    */
   public Object getSelectedItem()
   {
      return this.selectedItem;
   }
   
   /**
    * Sets the item that is currently selected in a JComboBox 
    *
    * @param item the item that is currently selected
    */
   public void setSelectedItem(Object item)
   {
      this.selectedItem = item;
   }
}
