// $Header: /teamproj/cvsroot/teamb/bkasrc/au/edu/swin/synergy/lib/BDynamicPane.java,v 1.10 1999/10/16 02:32:52 tp079210 Exp $

//Title:        Module 13
//Version:
//Copyright:    Copyright (c) 1998
//Author:       Tristan Austin
//Company:      Synergy
//Description:  This is the Window Manager plugin for the BKA

package au.edu.swin.synergy.lib;

import java.awt.*;
import java.awt.event.MouseMotionListener;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;

import javax.swing.*;
import javax.swing.plaf.metal.MetalLookAndFeel;

import au.edu.swin.synergy.debug.Debug;

/**
 * This class allows the user to change the size of the
 * pane in the direction specified by the creator. It is
 * intended to be placed in the edges of a BorderLayout.
 *
 * @author Tristan Austin
 * Please complete these missing tags
 * @copyright
 */
public class BDynamicPane extends JPanel
{
    BorderLayout borderLayout1 = new BorderLayout();
    JPanel contentPane = new JPanel();
    BDynamicPaneDivider divider = new BDynamicPaneDivider();
    BorderLayout borderLayout2 = new BorderLayout();

    /**
     * The darker of the two synergy blues
     */
    Color synergyDarkBlue =  new Color(0x3A, 0x51, 0x95);

    /**
     * The darker of the two synergy blues
     */
    Color synergyLightBlue =  new Color(0xB8, 0xCC, 0xE8);

    /**
     * The parent to re-layout after the move
     */
    private Container targetParent = null;

    /**
     * The divider size
     */
    private int dividerSize = 3;

    /**
     * The location the divider is at
     */
    private String dividerLocation = BorderLayout.EAST;
    
    /**
     * The mouse listener for the divider
     */
    private DragListener mouseListener = new DragListener();
    
    /**
     * Indicates whether this has been initialised or not
     */
    private boolean isInitialised = false;

    /**
     * The value to change when resizing
     */
    private Dimension lastSize = null;

    /**
     * This is what the divider sits on when it is being dragged
     */
    Window floatingDivider = null;

    /**
     * This is the maximum left and top values the divider can go to
     */
    Point maxTopLeft = new Point(0, 0);

    /**
     * This is the maximum bottom and right values the divider can go to
     */
    Point maxBottomRight = new Point(5000, 5000);

	/**
	 * is the divider currently being dragged
	 */
	private boolean isDragging = false;

    /**
     * This is the width of the pane when dragging starts
     */
    int startWidth = 0;

    /**
     * This is the height of the pane when dragging starts
     */
    int startHeight = 0;

    /**
     * This indicates the step size for resizing
     */
    int stepSize = -1;


    Frame parent = null;


    /**
     * Sets the location of the divider on the split pane. It can
     * be on one of the four sides.
     *
     * @param   newDividerLocation BorderLayout.EAST BorderLayout.NORTH BorderLayout.SOUTH BorderLayout.WEST
     * Please complete the missing tags for BDynamicPane
     * @return
     * @pre
     * @post
     */
    public BDynamicPane( Frame parent, String dividerLocation )
    {
        this.jbInit();
        this.parent = parent;
        this.setDividerLocation( dividerLocation );
    }

    /**
     * Gets the divider location of this BSplitPane
     *
     * @return BorderLayout.EAST BorderLayout.NORTH BorderLayout.SOUTH BorderLayout.WEST
     * Please complete the missing tags for getDividerLocation
     * @param
     * @pre
     * @post
     */
    public String getDividerLocation()
    {
        return dividerLocation;
    }

    /**
     * When the dynamic pane is resizing, you can specify
     * the incrementing values so that it snaps to certain
     * sizes when the user releases the mouse.
     *
     * @param   stepSize    The step size in pixels
     */
    public void setStepSize(int stepSize)
    {
        this.stepSize = stepSize;
    }

    /**
     * When the dynamic pane is resizing, you can specify
     * the incrementing values so that it snaps to certain
     * sizes when the user releases the mouse.
     * <p>
     * This method will get the step size currently set
     *
     * @param   The step size in pixels, -1 if none
     */
    public int getStepSize()
    {
        return this.stepSize;
    }

    /**
     * Sets the maximum top and left values the
     * divider can go to
     *
     * @param   maxTopLeft  The limits
     */
    public void setMaxTopLeft(Point maxTopLeft)
    {
        this.maxTopLeft = maxTopLeft;
    }

    /**
     * Sets the maximum bottom and right values the
     * divider can go to
     *
     * @param   maxTopLeft  The limits
     */
    public void setMaxBottomRight(Point maxBottomRight)
    {
        this.maxBottomRight = maxBottomRight;
    }

    /**
     * Sets the container which needs to be layed out
     * when the divider moves. If this isn't set, the
     * direct parent of this panel will be used.
     *
     * @param   targetParent    The container to layout
     * Please complete the missing tags for setTargetParent
     * @return
     * @pre
     * @post
     */
    public void setTargetParent( Container targetParent )
    {
        this.targetParent = targetParent;
    }
    
    /**
     * Sets whether this dynamic pane has been initialised or not
     *
     * @param initialised True if it has, false otherwise
     * Please complete the missing tags for setInitialised
     * @return
     * @pre
     * @post
     */
    public void setInitialised( boolean initialised )
    {
        this.isInitialised = initialised;
    }
    
    /**
     * Sets the location of the divider on the split pane. It can
     * be on one of the four sides.
     *
     * @param   newDividerLocation BorderLayout.EAST BorderLayout.NORTH BorderLayout.SOUTH BorderLayout.WEST
     * Please complete the missing tags for setDividerLocation
     * @return
     * @pre
     * @post
     */
    public void setDividerLocation( String newDividerLocation )
    {
        this.dividerLocation = newDividerLocation;
        super.addImpl( this.divider, newDividerLocation, - 1 );
    }

    /**
     * Indicates whether this dynamic pane has been initialised or not
     *
     * @return True if it has, false otherwise
     * Please complete the missing tags for isInitialised
     * @param
     * @pre
     * @post
     */
    public boolean isInitialised()
    {
        return this.isInitialised;
    }
    
    /**
     * This redirects added components to the content pane
     *
     * @param   component   The component being added
     * @param   constraints The constraints for the addition
     * @param   index   The index to add it at
     * Please complete the missing tags for addImpl
     * @return
     * @pre
     * @post
     */
    protected void addImpl( Component component, Object constraints, int index )
    {
        this.contentPane.add( component, constraints, index );
    }

    /**
     * When this is called, it will change the mouse
     * pointer to the appropriate icon depending on
     * the orientation of the divider.
     *
     * @param   drag    True to change to resize pointer, false to change back
     * Please complete the missing tags for setMousePointer
     * @return
     * @pre
     * @post
     */
    private void setMousePointer( boolean drag )
    {
        //See what cursor to set to
        if( drag )
        {
            //Determine whether to go north-south or east-west
            if( this.dividerLocation == BorderLayout.EAST || this.dividerLocation == BorderLayout.WEST )
            {
                this.divider.setCursor( Cursor.getPredefinedCursor( Cursor.E_RESIZE_CURSOR ) );
            }
            else
            {
                this.divider.setCursor( Cursor.getPredefinedCursor( Cursor.N_RESIZE_CURSOR ) );
            }
        }
        else
        {
            //Change it back to the default cursor
            this.divider.setCursor( Cursor.getPredefinedCursor( Cursor.DEFAULT_CURSOR ) );
        }
    }
    
    /**
     * Initialises the GUI
     * Please complete the missing tags for jbInit
     * @param
     * @return
     * @pre
     * @post
     */
    private void jbInit()
    {
        this.setLayout( borderLayout1 );
        contentPane.setBackground( SystemColor.desktop );
        contentPane.setSize( 50, 50 );
        contentPane.setPreferredSize( divider.getSize() );
        divider.setBackground( this.synergyLightBlue );
        divider.setSize( this.dividerSize, this.dividerSize );
        divider.setPreferredSize( divider.getSize() );
        contentPane.setLayout( borderLayout2 );
        super.addImpl( contentPane, BorderLayout.CENTER, - 1 );
        super.addImpl( divider, this.dividerLocation, - 1 );
        this.divider.addMouseMotionListener( this.mouseListener );
        this.divider.addMouseListener( this.mouseListener );
        this.setPreferredSize( contentPane.getSize() );
    }

    /**
     * Sets the divider size to the given value
     *
     * @param   newSize The new size in pixels
     */
    public void setDividerSize(int newSize)
    {
        this.dividerSize = newSize;

        this.divider.setSize(newSize, newSize);
    }

    /**
     * When the divider is dragged, this method handles the redrawing of the
	 * fake divider.
     *
     * @event   event   The drag event fired
     * Please complete the missing tags for dividerDragged
     * @param
     * @return
     * @pre
     * @post
     */
    private synchronized void dividerDragged( java.awt.event.MouseEvent event )
    {
        Component source = (Component)event.getSource();
        Point screenLocation = source.getLocationOnScreen();
        int xValue;
        int yValue;

        //Make sure there is a divider to move
        if (this.floatingDivider != null)
        {
            if( this.dividerLocation == BorderLayout.EAST)
            {
                xValue = screenLocation.x + event.getX();
                if (xValue > this.getLocationOnScreen().x && xValue < this.maxBottomRight.x)
                {
                    this.floatingDivider.setLocation(xValue, this.floatingDivider.getLocation().y );
                }
            }
            else if (this.dividerLocation == BorderLayout.WEST)
            {
                xValue = screenLocation.x + event.getX();
                if (xValue > this.maxTopLeft.x && xValue < screenLocation.x + this.getWidth())
                {
                    this.floatingDivider.setLocation(xValue, this.floatingDivider.getLocation().y );
                }
            }
            else if( this.dividerLocation == BorderLayout.NORTH)
            {
                yValue = screenLocation.y + event.getY();

                if (yValue < screenLocation.y + this.getHeight() && yValue > this.maxTopLeft.y)
                {
                    this.floatingDivider.setLocation(this.floatingDivider.getLocation().x, yValue);
                }
            }
            else if (this.dividerLocation == BorderLayout.SOUTH)
            {
                yValue = screenLocation.y + event.getY();

                if (yValue > screenLocation.y - this.getHeight() && yValue < this.maxBottomRight.y)
                {
                    this.floatingDivider.setLocation(this.floatingDivider.getLocation().x, yValue);
                }
            }
        }
    }

    /**
     * This will initialise the floating divider
     */
	private synchronized void startDrag( MouseEvent event )
	{
        Point location = this.divider.getLocationOnScreen();
		//If the parent hasn't been set, set it now
        if( this.targetParent == null )
        {
            this.targetParent = this.getParent();
        }

        floatingDivider = new Window(this.parent);
        floatingDivider.setLayout(new BorderLayout());
        floatingDivider.add((Component)this.divider.clone());
        floatingDivider.setSize(this.divider.getSize());
        floatingDivider.setLocation(location);
        floatingDivider.setVisible(true);

        //Indicate where we started from
        startWidth = this.getWidth();
        startHeight = this.getHeight();

		this.isDragging = true;
	}

    /**
     * This will remove the floating divider and stop dragging
     */
	private synchronized void stopDrag( MouseEvent event )
	{
        Component source = (Component)event.getSource();
        Point screenLocation = source.getLocationOnScreen();
        int newWidth = this.getWidth();
        int newHeight = this.getHeight();
        int dividerWidth = Math.min( this.divider.getSize().width, this.divider.getSize().height );
        Point dividerPoint = this.floatingDivider.getLocationOnScreen();
        int x = screenLocation.x - dividerPoint.x;
        int y = screenLocation.y - dividerPoint.y;

		//no longer dragging
		this.isDragging = false;

        if( this.dividerLocation == BorderLayout.EAST )
        {
            newWidth = this.getWidth() - x;
        }
        else if( this.dividerLocation == BorderLayout.WEST )
        {
            newWidth = this.getWidth() + x;
        }
        else if( this.dividerLocation == BorderLayout.NORTH )
        {
            newHeight = this.getHeight() + y;
        }
        else if( this.dividerLocation == BorderLayout.SOUTH )
        {
            newHeight = this.getHeight() - y;
        }

        //Get rid of the divider
        if (this.floatingDivider != null)
        {
            this.floatingDivider.setVisible(false);
            this.floatingDivider.dispose();
            this.floatingDivider = null;
        }

        //If the parent hasn't been set, set it now
        if( this.targetParent == null )
        {
            this.targetParent = this.getParent();
        }

        //Need to snap to a certain size
        if (this.stepSize >= 0)
        {
            Debug.doPrintln("Doing step size");
            int widthDiff = newWidth % (this.stepSize - this.dividerSize);
            int heightDiff = newHeight % (this.stepSize - this.dividerSize);

            Debug.doPrintln("New width: " + newWidth);
            Debug.doPrintln("Difference: " + widthDiff);

            //Determine the snap to value for width
            if (widthDiff < (this.stepSize/2))
            {
                newWidth -= widthDiff;
            }
            else
            {
                newWidth += (this.stepSize - widthDiff);
            }

            //Determine the snap to value for height
            if (heightDiff < (this.stepSize/2))
            {
                newHeight -= heightDiff;
            }
            else
            {
                newHeight += (this.stepSize - heightDiff);
            }

            Debug.doPrintln("Snapped width: " + newWidth);
        }

        //Set the new size
        this.setSize( Math.max( dividerWidth, newWidth ), Math.max( dividerWidth, newHeight ) );
        this.setPreferredSize( this.getSize() );

        //Relayout and paint the screen
        this.doLayout();
        this.targetParent.doLayout();
        this.targetParent.validate();
        this.targetParent.repaint();//*/

	}

    /**
     * This is overriden in order to set the correct
     * constraints whenever the size changes in by any means
     *
     * @param   width   The new width of the pane
     * @param   height  The new height of the pane
     */
    public void setSize(int width, int height)
    {
        Point dividerPoint;

        //Set the size
        super.setSize(width, height);

        if (this.isShowing())
        {
            //Determine where the window is
            dividerPoint = this.getLocationOnScreen();

            if( this.dividerLocation == BorderLayout.EAST )
            {
                this.maxTopLeft.x = dividerPoint.x + width;
            }
            else if( this.dividerLocation == BorderLayout.WEST )
            {
                this.maxBottomRight.x = dividerPoint.x;
            }
            else if( this.dividerLocation == BorderLayout.NORTH )
            {
                this.maxBottomRight.y = dividerPoint.y;
            }
            else if( this.dividerLocation == BorderLayout.SOUTH )
            {
                this.maxTopLeft.y = dividerPoint.y + height;
            }
        }
    }

    /**
     * This is overriden in order to set the correct
     * constraints whenever the size changes in by any means
     *
     * @param   size The new size of the pane
     */
    public void setSize(Dimension size)
    {
        setSize(size.width, size.height);
    }

    /**
     * Handles program flow for when the user drags the mouse
     * over a registered component
     */
    private class DragListener extends MouseAdapter implements MouseMotionListener
    {
        /**
         * Sends the mouse event to the appropriate method
         * in the main class
         *
         * @param   mouseEvent  The drag event fired
         */
        public void mouseDragged( MouseEvent mouseEvent )
        {
            BDynamicPane.this.dividerDragged( mouseEvent );
        }

        /**
         * When the mouse enters the divider it will set
         * the mouse pointer to the drag icon.
         *
         * @param   mouseEvent
         */
        public void mouseEntered( MouseEvent mouseEvent )
        {
            BDynamicPane.this.setMousePointer( true );
        }

        /**
         * When the mouse leaves the divider it will set
         * the mouse pointer to default icon.
         *
         * @param   mouseEvent
         */
        public void mouseExitted( MouseEvent mouseEvent )
        {
            BDynamicPane.this.setMousePointer( false );
        }

		/** 
		 * When the mouse is pressed, start drawing the
		 * fake divider..
		 */
		public void mousePressed( MouseEvent mouseEvent )
		{
			BDynamicPane.this.startDrag( mouseEvent );
		}

		/** 
		 * When the mouse is released, stop drawing the
		 * fake divider..
		 */
		public void mouseReleased( MouseEvent mouseEvent )
		{
			BDynamicPane.this.stopDrag( mouseEvent );
		}
        
        /**
         * Simply implemented to satsify the interface
         *
         * @param   mouseEvent  The drag event fired
         */
        public final void mouseMoved( MouseEvent mouseEvent )
        {
            /*Not implemented*/
        }
    }
}




