// $Header: /teamproj/cvsroot/teamb/bkasrc/au/edu/swin/synergy/lib/BListModel.java,v 1.5 1999/09/15 07:31:10 tp079210 Exp $


package au.edu.swin.synergy.lib;

import javax.swing.AbstractListModel;

import java.util.Vector;

/**
 * Provides a generic means of placing items in a JList
 * or anything else that accepts a ListModel and have more
 * control over its contents.
 *
 * @author Tristan Austin
 * Please complete these missing tags
 * @copyright
 */
public class BListModel extends AbstractListModel
{
    /**
     * The content of the list model
     */
    protected Vector listContent = new Vector();
    
    /**
     * This will get the number of elements in the list
     *
     * @return The size of the list as an int
     * Please complete the missing tags for getSize
     * @param
     * @pre
     * @post
     */
    public int getSize()
    {
        int size = 0;
        
        size = this.listContent.size();
        
        return size;
    }
    
    /**
     * Returns the component at the specified index.
     * <blockquote>
     * <b>Note:</b> Although this method is not deprecated, the preferred
     *    method to use is <tt>get(int)</tt>, which implements the
     *    <tt>List</tt> interface defined in the 1.2 Collections framework.
     * </blockquote>
     * @param      index   an index into this list.
     * @return     the component at the specified index.
     * @exception  ArrayIndexOutOfBoundsException  if the <tt>index</tt>
     *             is negative or not less than the current size of this
     *             list.
     *             given.
     * @see #get(int)
     * Please complete the missing tags for getElementAt
     * @return
     * @pre
     * @post
     */
    public Object getElementAt( int index )
    {
        return this.listContent.elementAt( index );
    }
    
    
    /**
     * This will set the given element at the specified
     * index. Any element already in this location will be overwritten
     *
     * @param   index   The location to set the element
     * @param   element The element to set
     * Please complete the missing tags for set
     * @return
     * @pre
     * @post
     */
    public void set( int index, Object element )
    {
        this.fireContentsChanged( this, index, index );
        this.listContent.set( index, element );
    }
    
    /**
     * By using this method to set the contents of the
     * model, either initially or to update them, and it will
     * retain the current selection settings.
     *
     * @param   updatedContents The contents of the list
     * Please complete the missing tags for setContents
     * @return
     * @pre
     * @post
     */
    public void setContents( Vector updatedContents )
    {
        this.listContent = updatedContents;
        
        //Notify the listeners
        this.fireContentsChanged( this, 0, this.listContent.size() );
    }
    
    /**
     * Adds the specified component to the end of this list.
     *
     * @param   obj   the component to be added.
     * @see Vector#addElement(Object)
     * Please complete the missing tags for addElement
     * @return
     * @pre
     * @post
     */
    public void addElement( Object obj )
    {
        int index;
        
        //We need the size to notify the listeners
        index = this.listContent.size();
        this.listContent.addElement( obj );
        
        //Notify the listeners
        fireIntervalAdded( this, index, index );
    }
    
    /**
     * This will remove the element at the given location
     * from the list.
     *
     * @param   index The index of the element to remove
     * @throws IndexOutOfBoundsException if the index is outside the bounds of the content
     * Please complete the missing tags for removeElementAt
     * @return
     * @pre
     * @post
     */
    public void removeElementAt( int index )
    {
        this.listContent.removeElementAt( index );
        this.fireIntervalRemoved( this, index, index );
    }
    
    /**
     * This will remove the given element from the list
     *
     * @param   element The element to remove
     * Please complete the missing tags for removeElement
     * @return
     * @pre
     * @post
     */
    public void removeElement( Object element )
    {
        int index;
        
        index = this.listContent.indexOf( element );
        
        //Only remove it if it was found
        if( index >= 0 )
        {
            this.listContent.removeElementAt( index );
            this.fireIntervalRemoved( this, index, index );
        }
    }
    
    /**
     * Removes all components from this list and sets its size to zero.
     * <blockquote>
     * <b>Note:</b> Although this method is not deprecated, the preferred
     *    method to use is <tt>clear()</tt>, which implements the
     *    <tt>List</tt> interface defined in the 1.2 Collections framework.
     * </blockquote>
     *
     * @see #clear()
     * @see Vector#removeAllElements()
     * Please complete the missing tags for removeAllElements
     * @param
     * @return
     * @pre
     * @post
     */
    public void removeAllElements()
    {
        int index1;
        
        index1 = this.listContent.size() - 1;
        this.listContent.removeAllElements();
        
        //Make sure there was something to begin with
        if( index1 >= 0 )
        {
            fireIntervalRemoved( this, 0, index1 );
        }
    }
    
    /**
     * Gets the index of the specified element.
     *
     * @return The index in the list, -1 if it doens't exist
     * Please complete the missing tags for indexOf
     * @param
     * @pre
     * @post
     */
    public int indexOf( Object element )
    {
        int index = - 1;
        
        index = this.listContent.indexOf( element );
        
        //Return the result
        return index;
    }

    /**
     * This will fire the contents changed event to all
     * the List objects containing this model. This is
     * handy if the display text changes and needs to
     * be updated.
     */
    public void doRefresh()
    {
        this.fireContentsChanged( this, 0, this.getSize());
    }
}
