// $Header: /teamproj/cvsroot/teamb/bkasrc/au/edu/swin/synergy/lib/BSelectionListener.java,v 1.6 1999/09/06 00:19:21 tp079210 Exp $


package au.edu.swin.synergy.lib;

import javax.swing.*;
import javax.swing.event.ListSelectionListener;
import javax.swing.event.ListSelectionEvent;

import au.edu.swin.synergy.plugin.mod13.bwt.BSwingUtilities;

/**
 * This will detect selection events in the group lists
 * and change the state of the given buttons to reflect
 * the available options.
 *
 * @author Tristan Austin
 * Please complete these missing tags
 * @copyright
 */
public class BSelectionListener implements ListSelectionListener
{
    /**
     * The list of buttons to enable/disable
     */
    private JButton button = null;

    /**
     * The selection model to determine what selections have been made
     */
    private ListSelectionModel selectionModel = null;

    /**
     * This is what state the buttons should be set to when selected
     */
    private boolean selectedState;

    /**
     * This creates a new listener and sets the buttons
     * to change the state of.
     *
     * @param   buttons The array of JButtons to update
     * Please complete the missing tags for BSelectionListener
     * @return
     * @pre
     * @post
     */
    public BSelectionListener( ListSelectionModel selectionModel, JButton button )
    {
        this(selectionModel, button, true);
    }

    /**
     * This creates a new listener and sets the buttons
     * to change the state of.
     *
     * @param   buttons The array of JButtons to update
     * Please complete the missing tags for BSelectionListener
     * @return
     * @pre
     * @post
     */
    public BSelectionListener( ListSelectionModel selectionModel, JButton button, boolean selectionState )
    {
        this.button = button;
        this.selectionModel = selectionModel;
        this.selectedState = selectionState;
    }

    /**
     * When the user changes the current selection of
     * the registered list of users or groups, this method
     * will be called. It will run through the list of buttons
     * to enable/disable as required and change their state.
     * <p>
     * If an item in the registered list is selected, the buttons
     * will all be enabled, if no item is selected, they will
     * all be disabled.
     *
     * @author Tristan Austin
     * Please complete the missing tags for valueChanged
     * @param
     * @return
     * @pre
     * @post
     */
    public void valueChanged( ListSelectionEvent selectionEvent )
    {
        this.setStates();
    }

    /**
     * When this is called it will set the state of the button
     * this selection listener is responsible for.
     */
    protected void setStates()
    {
        boolean enable =  this.selectedState && !this.selectionModel.isSelectionEmpty();

        //Make sure there are buttons to run through
        BSwingUtilities.setJComponentEnabled(button, enable );
    }

    /**
     * This will set the state the buttons will be set to
     * when an item is selected. That is, if you pass in false,
     * the buttons will not be enabled when an item is selected,
     * where as if you set it to true, it will. It is true by default.
     *
     * @param   selectedState   The state to set the buttons to when items are selected
     */
    public void setSelectedState(boolean selectedState)
    {
        this.selectedState = selectedState;
        this.setStates();
    }
}
