// $Header: /teamproj/cvsroot/teamb/bkasrc/au/edu/swin/synergy/lib/BSplitPane.java,v 1.3 1999/08/28 10:20:18 tp079519 Exp $
package au.edu.swin.synergy.lib;

import javax.swing.JSplitPane;
import java.awt.Graphics;
import java.awt.Component;
import java.awt.event.ComponentListener;
import java.awt.event.ComponentEvent;

/**
 * Extends JSplitPane so that you can specify the divider location
 * before the split pane becomes visible.
 *
 * @author Tristan Austin
 * Please complete these missing tags
 * @copyright
 */
public class BSplitPane extends JSplitPane implements ComponentListener
{
    /**
     * This is the location the divider will be set at
     * when the split pane becomes visible
     */
    int dividerLocation = 0;
    
    /**
     * Indicates whether the split pane has been painted before
     */
    boolean isInitialised = false;
    
    /**
     * Indicates whether we are currently buffering some changes or not
     */
    boolean buffering = false;
    
    /**
     * The reference to the opposite split pain which is affected by
     * the relocation of the divider in this split pane.
     */
    BSplitPane oppositeSplitPane = null;
    
    
    /**
     * Creates a new BSplitPane with the given divider
     * orientation
     *
     * @param       dividerOrientation BSplitPane.VERTICAL_SPLIT BSplitPane.HORIZONTAL_SPLIT
     * Please complete the missing tags for BSplitPane
     * @return
     * @pre
     * @post
     */
    public BSplitPane( int dividerOrientation )
    {
        super( dividerOrientation );
    }
    
    /**
     * If moving the divider in this split pane affects the location
     * of another split pane, setting that pane here will enable this
     * split pane to keep the other in the same location as it
     * was before.
     *
     * @param       oppositeSplitPane       The split pane to keep still
     * Please complete the missing tags for setOppositeSplitPane
     * @return
     * @pre
     * @post
     */
    public void setOppositeSplitPane( BSplitPane oppositeSplitPane )
    {
        Component leftComponent = this.getLeftComponent();
        this.oppositeSplitPane = oppositeSplitPane;
        
        
        //Make sure there was a component given
        if( leftComponent != null )
        {
            leftComponent.addComponentListener( this );
        }
        
    }
    
    
    /**
     * Performs the same operation as the super class, sets the
     * divider location to the specified value in pixels. It also
     * stores a copy of the value so that if the split pane isn't
     * yet visible, it can set it again when it is.
     *
     * @param newDividerLocation    The divider location to set to
     * Please complete the missing tags for setDividerLocation
     * @return
     * @pre
     * @post
     */
    public void setDividerLocation( int newDividerLocation )
    {
        System.out.println( "Divider location set" );
        this.dividerLocation = newDividerLocation;
        super.setDividerLocation( this.dividerLocation );
    }
    
    /**
     * Sets the buffering state to that specified
     *
     * @param       buffering       True to buffer, false otherwise
     * Please complete the missing tags for setBuffering
     * @return
     * @pre
     * @post
     */
    public void setBuffering( boolean buffering )
    {
        this.buffering = buffering;
    }
    
    /**
     * Indicates whether this split pane has been initialised
     * yet or not. Initialised indicating that the divider location
     * has not been set.
     *
     * @return True if it has, false otherwise
     * Please complete the missing tags for isInitialised
     * @param
     * @pre
     * @post
     */
    public boolean isInitialised()
    {
        return this.isInitialised;
    }
    /**
     * When the split pane is first validated, the divider is set
     * to the pre-specified location
     * Please complete the missing tags for paintComponent
     * @param
     * @return
     * @pre
     * @post
     */
    public void paintComponent( Graphics graphics )
    {
        if( ! buffering )
        {
            //Recall the super class paintComponent            
            super.paintComponent( graphics );
            
            //Set the divider location if this is the first time
            if( ! this.isInitialised )
            {
                this.isInitialised = true;
                super.setDividerLocation( this.dividerLocation );
            }
        }
    }
    
    /**
     * When a registered component is hidden, this method is called.
     *
     * @param       componentEvent  The event fired
     * Please complete the missing tags for componentHidden
     * @return
     * @pre
     * @post
     */
    public void componentHidden( ComponentEvent componentEvent )
    {
    }
    
    /**
     * When a registered component is moved, this method is called.
     *
     * @param       componentEvent  The event fired
     * Please complete the missing tags for componentMoved
     * @return
     * @pre
     * @post
     */
    public void componentMoved( ComponentEvent componentEvent )
    {
    }
    
    /**
     * This will reset the location of the divider to whatever was
     * specified directly, as opposed to where it was moved to
     * by user intervention.
     * Please complete the missing tags for resetDividerLocation
     * @param
     * @return
     * @pre
     * @post
     */
    public void resetDividerLocation()
    {
        System.out.println( "Reset:Resetting divider location to: " + this.dividerLocation );
        System.out.println( "Reset:Actual divider location is: " + this.getDividerLocation() );
        super.setDividerLocation( this.dividerLocation );
    }
    
    /**
     * When a registered component is hidden, this method is called.
     *
     * @param       componentEvent  The event fired
     * Please complete the missing tags for componentResized
     * @return
     * @pre
     * @post
     */
    public void componentResized( ComponentEvent componentEvent )
    {
        int locationDifference = this.getDividerLocation() - this.dividerLocation;
        ;
        
        System.out.println( "Initial Location: " + this.dividerLocation );
        System.out.println( "New location: " + this.getDividerLocation() );
        System.out.println( "Difference is: " + locationDifference );
        
        this.dividerLocation = this.getDividerLocation();
        
        
        //Check the opposite split pane
        if( this.oppositeSplitPane != null && this.oppositeSplitPane.isInitialised() )
        {
            System.out.println( "Opposite Location: " + this.oppositeSplitPane.getDividerLocation() );
            this.oppositeSplitPane.setBuffering( true );
            
            //Only bother if it's changed
            if( locationDifference != 0 )
            {
                this.oppositeSplitPane.resetDividerLocation();
                //this.oppositeSplitPane.setDividerLocation(this.oppositeSplitPane.getDividerLocation() - locationDifference);
            }
            this.oppositeSplitPane.setBuffering( false );
            this.oppositeSplitPane.repaint();
        }
        
    }
    
    /**
     * When a registered component is hidden, this method is called.
     *
     * @param       componentEvent  The event fired
     * Please complete the missing tags for componentShown
     * @return
     * @pre
     * @post
     */
    public void componentShown( ComponentEvent componentEvent )
    {
    }
    
}
