// $Header: /teamproj/cvsroot/teamb/bkasrc/au/edu/swin/synergy/lib/BStringList.java,v 1.9 1999/10/08 08:23:41 tp079519 Exp $

package au.edu.swin.synergy.lib;

import java.lang.String;
import java.util.Vector;
import java.io.Serializable;
import au.edu.swin.synergy.debug.Debug;

/**
 *
 * This is a string list class
 * Designed to make life easy for managing a list of strings (No supprises there:)
 * @Author John Newbigin
 * @see
 * @concurrency
 * @copyright
 * @rref
 */

public class BStringList implements Serializable
{
    private Vector vector = null;

	private String delimiters = " \t";
    
    /**
     * Creates an empty string list
     */
    
    public BStringList()
    {
        vector = new Vector();
    }

    /**
     * Parse the param string and create a string list
     * Tokens are seperated by white space unless surrounded in "quotes"
     */
    public BStringList(String param)
    {
		this();
        // take cmd and break up according to spaces...
		// this is "how the" commands work
		
        String line = null;

		// 0 == normal
		// 1 == in quotes
		
		int state = 0;
		if(param == null)
		{
			param = "";
		}
        
        for( int i = 0; i < param.length(); i++ )
        {
            char c = param.charAt( i );
			if(state == 0)
			{
				if(delimiters.indexOf(c) != -1)
				{
					// add the line
					if(line != null)
					{
						add(line);
					}
					line = null;
				}
				else if(c == '"')
				{
					// go into state 1
					state = 1;
				}
				else
				{
					// just add the char
					if(line == null)
					{
						line = new String();
					}
					line = line + c;
				}
			}
			else if(state == 1)
			{
				if(c == '"')
				{
					// go back to state 0
					state = 0;
				}
				else
				{
					// just add the char
					if(line == null)
					{
						line = new String();
					}
					line = line + c;
				}
			}
			else
			{
				Debug.doPrintln("Unknown state");
			}
        }
		if(line != null)
		{
			add(line);
		}
    }
    
    /**
     * Please complete the missing tags for get
     * @post
     * @pre
     * @throws
     * @return
     * @param
     */
    
    public String get( int index )
    {
        return( String ) vector.get( index );
    }

	public void set(int index, String str)
	{
		vector.set(index, str);
	}
    /**
     * Please complete the missing tags for getCount
     * @post
     * @pre
     * @throws
     * @return
     * @param
     */
    
    public int getCount()
    {
        return vector.size();
    }
    /**
     * Please complete the missing tags for add
     * @post
     * @pre
     * @throws
     * @return
     * @param
     */
    
    public void add( String str )
    {
        vector.add( str );
    }
    /**
     * Please complete the missing tags for remove
     * @post
     * @pre
     * @throws
     * @return
     * @param
     */
    
    public void remove( int index )
    {
        vector.remove( index );
    }

	public void remove( String str )
	{
		vector.remove(str);
	}

    /**
     * This will return a new BStringList containing
     * only the values in this string list between
     * the indexes provided.
     *
     * @param   beginIndex  Where to start inclusive
     * @param   endIndex    Where to end exclusive
     * @return The elements in this BStringList between the two indexes in a new BStringList
     */
    public BStringList getSubstringList(int beginIndex, int endIndex)
    {
        BStringList stringList = new BStringList();

        //Run through the existing list and add everything between the two to the new one
        for (int i = beginIndex; i < endIndex; i++)
        {
            stringList.add(this.get(i));
        }

        //Return the sublist
        return stringList;
    }

    /**
     * Please complete the missing tags for assign
     * @post
     * @pre
     * @throws
     * @return
     * @param
     */
    
    /**
     *  This accepts a string with \n which are used to seperate
     *  the lines in the stringlist
     */
    
    public void assign( String str )
    {
        String newString = new String();
        
        for( int i = 0; i < str.length(); i++ )
        {
            char c = str.charAt( i );
            if( c == 10 )
            {
                add( newString );
                newString = new String();
            }
            else
            {
                newString = newString + c;
            }
        }
        add( newString );
    }
    /**
     * Please complete the missing tags for clear
     * @post
     * @pre
     * @throws
     * @return
     * @param
     */
    
    public void clear()
    {
        vector.clear();
    }
    /**
     * Please complete the missing tags for insert
     * @post
     * @pre
     * @throws
     * @return
     * @param
     */
    
    public void insert( int index, String str )
    {
        vector.insertElementAt( str, index );
    }

    /**
     * Enumerates the contents of the Stringlist
     */
    public String toString()
    {
        return this.vector.toString();
    }
}

