//$Header: /teamproj/cvsroot/teamb/bkasrc/au/edu/swin/synergy/lib/BTreeUtil.java,v 1.3 1999/10/05 16:48:28 tp082177 Exp $

package au.edu.swin.synergy.lib;

import au.edu.swin.synergy.lib.BTreeNode;
import au.edu.swin.synergy.lib.BTreeModelInterface;

import au.edu.swin.synergy.debug.Debug;

import javax.swing.event.*;
import javax.swing.event.*;
import javax.swing.tree.*;
import javax.swing.tree.*;


public class BTreeUtil
{
	public static BTreeNode [] getPathToRoot( BTreeNode last, int depth )
	{
		BTreeNode [] retNodes = null;
		int len;

		if ( last != null )
		{
			retNodes = getPathToRoot( (BTreeNode)last.getParent(), depth + 1 );
			len = retNodes.length;
			retNodes[ len - depth - 1 ] = last;
			Debug.doPrintln("Added " + last + " to obj [] at pos " + (len-depth -1) );
		}
		else
		{
			retNodes = new BTreeNode[ depth ];
			Debug.doPrintln("Created obj [] of size " + depth );
		}

		return retNodes;
	}

	public static void fireNodesInserted( BTreeNode cur, TreeModelEvent me )
	{
		if ( cur != null )
		{
			if (cur instanceof BTreeModelInterface)
			{
				BTreeModelInterface model = (BTreeModelInterface)cur;
				model.fireInserted( me );
			}
			else
			{
				fireNodesInserted( (BTreeNode)cur.getParent(), me );
			}
		}
	}

	public static void fireNodesRemoved (BTreeNode node, TreeModelEvent modelEvent)
	{
		if (node != null)
		{
			if (node instanceof BTreeModelInterface)
			{
				BTreeModelInterface model = (BTreeModelInterface) node;
				model.fireRemoved( modelEvent );
			}
			else
			{
				fireNodesRemoved( (BTreeNode) node.getParent(), modelEvent );
			}
		}
	}
}