
/**
 * Utility class for saving 
 * Vectors
 *
 * @author Imron Alston
 * @copyright Team Synergy 1999
 *
 */

package au.edu.swin.synergy.lib.io;

import au.edu.swin.synergy.lib.io.BSaveable;
import au.edu.swin.synergy.lib.io.BDataFile;

import au.edu.swin.synergy.debug.Debug;

import java.util.Vector;
import java.awt.*;

public class BVectorIO
{
	

	public static boolean save( BDataFile file, Vector vect, String location )
	{
		try
		{
			if ( vect.size() > 0 )
			{
				file.addData("location", location);
				for ( int i = 0; i < vect.size(); i++)
				{
					file.save( (BSaveable)vect.get(i) );
				}
			}
		}
		catch( Exception e )
		{
			Debug.doPrintln("Error saving vector to file " + e );
			e.printStackTrace();
		}
		
		return true;
	}

	public static Vector load( BDataFile file, String location )
	{
		Vector result = new Vector();

		String tmp = file.getData("location", null);

		if ( tmp != null && tmp.equals( location ) )
		{
			while( true )
			{				
				Object object = file.autoLoad();
				if(object == null)
				{
					Debug.doPrintln("Load vector Finished");
					break;
				}
				Debug.doPrintln("Load Vector got an object");
				result.add( object );
			}
		}


		return result;
	}

}
