//

package au.edu.swin.synergy.plugin.addressbook;

import au.edu.swin.synergy.lib.BTreeNode;
import java.io.*;

/**
 *  The BAddress object stores values relevant to a single address in
 *  an BAddressBook object.
 *
 *  @author Matthew Evans
 */
public class BAddress implements Serializable
{
    /**
     *  The name of the addressee.  
     */
    private String name;
    
    /**
     *  The address of the addressee.
     */
    private String address;
    
    /**
     *  The BAddress constructor accepts name and address values, and sets
     *  them.
     *
     *  @author Matthew Evans
     */
    public BAddress (String name, String address)
    {
        this.name = name;
        this.address = address;
    }
    
    /**
     *  This method set's the class variable 'addressee' to @param name
     */
    public void setName(String name)
    {
        this.name = name;
    }
    

	 /**
     *  This method set's the class variable 'address' to @param address
     */
    public void setAddress (String address)
    {
        this.address = address;
    }
    
    /**
     *  This method returns the class variable 'addressee'.
     */
    public String getName()
    {
        return this.name;
    }
    
    /**
     *  This method returns the class variable 'address'.
     */
    public String getAddress()
    {
        return this.address;
    }
    
    /**
     * Overrides the toString() method in java.lang.Object
     */
    public String toString()
    {
        //return (this.getName() + " <" + this.getAddress() + ">");
		return name;
    }
} 
