//$Header: /teamproj/cvsroot/teamb/bkasrc/au/edu/swin/synergy/plugin/addressbook/BAddressBookGui.java,v 1.21 1999/10/21 22:18:43 tp079210 Exp $

package au.edu.swin.synergy.plugin.addressbook;

import au.edu.swin.synergy.kernel.BPlugin;
import au.edu.swin.synergy.debug.Debug;
import au.edu.swin.synergy.kernel.BCommandEvent;
import au.edu.swin.synergy.kernel.BCommandComplete;
import au.edu.swin.synergy.plugin.mod13.event.BAddMenuItemCE;
import au.edu.swin.synergy.plugin.mod13.event.BAddWindowCE;
import au.edu.swin.synergy.plugin.mod13.event.BCloseWindowCE;
import au.edu.swin.synergy.plugin.addressbook.event.BAddressBookCE;
import au.edu.swin.synergy.plugin.addressbook.event.BAddressDisplayCE;
import au.edu.swin.synergy.plugin.server.event.BGetNetworkStatusCE;
import au.edu.swin.synergy.plugin.mod13.event.BAddToolBarCE;
import au.edu.swin.synergy.plugin.userdb.BUser;
import au.edu.swin.synergy.plugin.userman.event.BGetUsersCE;
import au.edu.swin.synergy.plugin.client.event.BLoginCompleteCE;
import au.edu.swin.synergy.plugin.client.event.BLogoutCompleteCE;
import au.edu.swin.synergy.lib.BStringList;
import au.edu.swin.synergy.lib.BListModel;
import au.edu.swin.synergy.lib.BTreeModel;
import au.edu.swin.synergy.lib.BTreeNode;
import au.edu.swin.synergy.lib.BGridBagConstraints;
import au.edu.swin.synergy.plugin.command.event.BStandardOutCE;

import au.edu.swin.synergy.plugin.dialect.BDialect;
import au.edu.swin.synergy.plugin.dialect.BString;

import au.edu.swin.synergy.plugin.mod13.bwt.BSwingUtilities;

import javax.swing.*;
import javax.swing.tree.*;
import javax.swing.event.*;
import javax.swing.border.*;
import java.awt.*;
import java.awt.event.*;
import java.util.*;

public class BAddressBookGui extends BPlugin
{
   private boolean serverAvailable = false;

   public void setup (BStringList params)
   {
      addAddressBookMenu();
	  addAddressBookToolBar();
   }
    
   public void onBCommandEvent ( Object source, BCommandEvent event )
   {
      if (event instanceof BAddressDisplayCE)
      {
         addAddressBookWindow((BAddressDisplayCE)event);
      }
      else if(event instanceof BLoginCompleteCE)
      {
         serverAvailable = true;
      }
      else if(event instanceof BLogoutCompleteCE)
      {
         serverAvailable = false;
      }
   }

   /**
     * Return a list of plugin dependancies
	 *
     * @return a list of plugins such as "au.edu.swin.synergy.plugin.mod13.BWindowManager"
	 * or null if there are no dependancies
     */

    public BStringList getDependancies()
	{
		BStringList result = new BStringList();
		result.add("au.edu.swin.synergy.plugin.mod13.BWindowManager");
		return result;
	}

   private void addAddressBookMenu ()
   {
      JMenuItem addressMenuItem = new JMenuItem (  );
      BAddMenuItemCE event = new BAddMenuItemCE ( this, addressMenuItem, new BString(this, "addressbook"), new BString(this, BAddMenuItemCE.kMessagingMenu));

      addressMenuItem.addActionListener ( new onAddressDisplay () );
      dispatchEvent ( event );
   }

   private void addAddressBookToolBar()
   { 
	  String path = new String ( "/au/edu/swin/synergy/plugin/addressbook/images/" );

   	  JButton addressBookButton = new JButton(BSwingUtilities.getImage(this, path + "addressbook.gif"));
	  addressBookButton.addActionListener(new onAddressDisplay());
	  addressBookButton.setToolTipText((new BString(this, "addressbook")).toString());

	  BAddToolBarCE addToolbar = new BAddToolBarCE(this, 80);
	  addToolbar.addButton(addressBookButton);
	  dispatchEvent(addToolbar);
   }

   private void addAddressBookWindow(BAddressDisplayCE displayAddressBook)
   {
      BAddressBookWindow addressBookWindow;
      addressBookWindow = new BAddressBookWindow(this, displayAddressBook);

      BAddWindowCE addWindow = new BAddWindowCE(this, addressBookWindow, new BString(this, "addressbook"));
      addWindow.setDialog(true);
      
      Debug.doPrintln("BAddressBookGui: Adding an address book window");

      dispatchEvent(addWindow);
   }

   /**
    * Displays an informative message to the client for address book-related
    * errors.
    *
    * @param message the message to display in a JOptionPane
    */
   public void displayAddressMessage(String message)
   {
   		BStandardOutCE output = new BStandardOutCE(this, message);
		this.dispatchEvent(output);
   }

    /**
     *  Catches action events from the addressMenuItem
     *
     *  @author Matthew Evans
     */
    class onAddressDisplay implements java.awt.event.ActionListener
    {
        public void actionPerformed( ActionEvent e )
        {
            addAddressBookWindow( null );
        }
    }
    

 
   /**
    * The GUI for the addressbook
    *
    * @author Matthew Evans
    */
   public class BAddressBookWindow extends JPanel implements ActionListener, TreeSelectionListener
   {
		//GUI Components
      JLabel nameLabel = new JLabel();
      JLabel addressLabel = new JLabel();
      JTextField nameField = new JTextField();
      JTextField addressField = new JTextField();
      JLabel addressListLabel = new JLabel();
      JButton addButton = new JButton();
      JList receiversList = new JList();
      JButton selectButton = new JButton();
      JButton rejectButton = new JButton();
      JButton modifyButton = new JButton();
      JButton removeButton = new JButton();
      JLabel selectedAddresseeLabel = new JLabel();
      JButton okButton = new JButton();
      JButton cancelButton = new JButton();
      JLabel toLabel = new JLabel();
  		JRadioButton toClientButton = new JRadioButton();
	  	JRadioButton toServerButton = new JRadioButton();

      BevelBorder loweredBorder = new BevelBorder(BevelBorder.LOWERED);
      EtchedBorder etchedBorder = new EtchedBorder();
      TitledBorder addressListBorder = new TitledBorder(etchedBorder, "Address List", TitledBorder.LEFT, TitledBorder.TOP);
      TitledBorder receiversListBorder = new TitledBorder(etchedBorder, "To", TitledBorder.LEFT, TitledBorder.TOP);

      GridBagLayout gridBagLayout1 = new GridBagLayout();
      GridBagLayout gridBagLayout2 = new GridBagLayout();
      GridBagLayout gridBagLayout3 = new GridBagLayout();
      GridBagLayout gridBagLayout4 = new GridBagLayout();
      GridBagLayout gridBagLayout5 = new GridBagLayout();
      BorderLayout borderLayout1 = new BorderLayout();

	  BAddressDisplayCE displayRequest = null;
      BAddressBookGui parent;

		DefaultMutableTreeNode rootNode;
      DefaultTreeModel treeModel;
      JTree addressBookTree;
    
      JScrollPane treeScrollPane = new JScrollPane();
      
       /**
        * The user model representing the list of users
        */
       private BListModel receiversListModel = new BListModel();

       /**
        *  Identifies whether the user is editing the name and address fields
        */
       boolean editing = false;
    
       /**
        *  Maintains whether the user is modifying an existing address
        */
       boolean modifying = false;
    
      /** Initailises components on the dialog, adding
       *  listeners, etc.
       *
       *  @author Matthew Evans
       */
      public BAddressBookWindow(BAddressBookGui parent, BAddressDisplayCE displayRequest)
      {
         this.parent = parent;
         this.displayRequest = displayRequest;
         
         setLayout(new GridBagLayout());
         setSize(466,387);
         
        // DETAILS PANEL
        JPanel detailsPanel = new JPanel();
        detailsPanel.setLayout(gridBagLayout2);
        detailsPanel.add(nameLabel, new BGridBagConstraints(0, 0, 1, 1, 0.0, 0.0
	        ,GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(0, 5, 0, 0), 0, 0) );
        detailsPanel.add(addressLabel, new BGridBagConstraints(0, 1, 1, 1, 0.0, 0.0
   	     ,GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(0, 5, 0, 0), 0, 0) );
        detailsPanel.add(nameField, new BGridBagConstraints(1, 0, 1, 1, 2.0, 0.0
      	  ,GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL, new Insets(5, 5, 0, 5), 0, 0) );
        detailsPanel.add(addressField, new BGridBagConstraints(1, 1, 1, 1, 2.0, 0.0
	        ,GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL, new Insets(5, 5, 5, 5), 0, 0) );
        detailsPanel.add(addButton, new BGridBagConstraints(2, 0, 1, 1, 0.0, 0.0
	        ,GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(5, 5, 5, 5), 0, 0) );

        JPanel radioPanel = new JPanel();
        radioPanel.setLayout(borderLayout1);
        radioPanel.add(toClientButton, BorderLayout.NORTH);
        radioPanel.add(toServerButton, BorderLayout.CENTER);

        detailsPanel.add(radioPanel, new BGridBagConstraints(2, 1, 1, 1, 0.0, 0.0
   	     ,GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(5, 5, 5, 5), 0, 0) );

        this.add(detailsPanel, new BGridBagConstraints(0, 0, 3, 1, 0.0, 0.0
      	  ,GridBagConstraints.CENTER, GridBagConstraints.BOTH, new Insets(5, 5, 0, 5), 0, 0) );

        // ADDRESS LIST PANEL
		 rootNode = new DefaultMutableTreeNode();
		 treeModel = new DefaultTreeModel(rootNode);
		 addressBookTree = new JTree(treeModel);
         treeScrollPane.getViewport().add(addressBookTree, null);

        JPanel listPanel = new JPanel();
        listPanel.setLayout(gridBagLayout3);
        listPanel.setBorder(addressListBorder);

        listPanel.add(treeScrollPane, new BGridBagConstraints(0, 0, 1, 1, 1.0, 1.0
	        ,GridBagConstraints.CENTER, GridBagConstraints.BOTH, new Insets(2, 5, 5, 5), 0, 0) );

        this.add(listPanel, new BGridBagConstraints(0, 1, 1, 3, 1.0, 1.0
   	     ,GridBagConstraints.CENTER, GridBagConstraints.BOTH, new Insets(0, 5, 0, 0), 0, 0) );

        JPanel modifyPanel = new JPanel();
        modifyPanel.add(removeButton);
        modifyPanel.add(modifyButton);
        this.add(modifyPanel, new BGridBagConstraints(0, 4, 1, 1, 1.0, 0.0
      	  ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(0, 0, 0, 0), 0, 0) );

        this.add(selectedAddresseeLabel, new BGridBagConstraints(1, 4, 2, 1, 0.0, 0.0
	        ,GridBagConstraints.WEST, GridBagConstraints.HORIZONTAL, new Insets(5, 5, 5, 5), 0, 0) );

        //BUTTON PANEL
        JPanel buttonPanel = new JPanel();
        buttonPanel.add(okButton);
        buttonPanel.add(cancelButton);
        this.add(buttonPanel, new BGridBagConstraints(0, 5, 3, 1, 1.0, 0.0
   	     ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(5, 5, 5, 5), 0, 0) );

    
         //only display toPanel and select/reject buttons if the address book 
         //was opened from a mail window
        if (displayRequest != null)
        {
            receiversList.setModel(this.receiversListModel);
            this.receiversList.setCellRenderer(new BAddressListRenderer());
      
           //ACCEPT REJECT BUTTON PANEL
           JPanel acceptRejectPanel = new JPanel();
           acceptRejectPanel.setLayout(gridBagLayout4);
   
           acceptRejectPanel.add(selectButton, new BGridBagConstraints( 0, 0, 1, 1, 1.0, 1.0
              , GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets( 5, 5, 5, 5 ), 0, 0 ) );
   
           acceptRejectPanel.add(rejectButton, new BGridBagConstraints( 0, 1, 1, 1, 1.0, 1.0
              , GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets( 5, 5, 5, 5 ), 0, 0 ) );
   
           this.add(acceptRejectPanel, new BGridBagConstraints(1, 1, 1, 1, 0.0, 1.0
              ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(5, 0, 5, 0), 0, 0) );
   
           //TO PANEL
           JPanel toPanel = new JPanel();
           toPanel.setLayout(gridBagLayout5);
           toPanel.setBorder(receiversListBorder);
   
		   JScrollPane receiversScrollPane = new JScrollPane();
		   receiversScrollPane.getViewport().add(receiversList, null);
           toPanel.add(receiversScrollPane, new BGridBagConstraints(0, 0, 1, 1, 1.0, 1.0
              ,GridBagConstraints.CENTER, GridBagConstraints.BOTH, new Insets(5, 5, 5, 5), 0, 0) );
   
           this.add(toPanel, new BGridBagConstraints(2, 1, 1, 3, 1.0, 1.0
              ,GridBagConstraints.CENTER, GridBagConstraints.BOTH, new Insets(0, 0, 5, 5), 0, 0) );
   
           /*selectButton.setEnabled(false);
           rejectButton.setEnabled(false);
           receiversList.setEnabled(false);*/
        }
            
		
			ButtonGroup buttonGroup = new ButtonGroup();
			buttonGroup.add(toServerButton);
			buttonGroup.add(toClientButton);
			toClientButton.setSelected(true);
         
         if (!serverAvailable)
         {
            toServerButton.setEnabled(false);
         }
			
         addButton.requestFocus();
         nameField.setEditable(false);
         addressField.setEditable(false);

        
         //add listeners
         okButton.addActionListener(this);
         cancelButton.addActionListener(this);
         addButton.addActionListener(this);
         nameField.addActionListener(this);
         addressField.addActionListener(this);
         selectButton.addActionListener(this);
         rejectButton.addActionListener(this);
         removeButton.addActionListener(this);
         modifyButton.addActionListener(this);
         addressBookTree.addTreeSelectionListener(this);

	   	 //Set up the dialect stuff
   		 this.doDialect();
		 doInitialiseAddressList();
      }

   	/**
   	 * Adds a new node to the address book tree
   	 */
   
      private DefaultMutableTreeNode addTreeNode( Object child, DefaultMutableTreeNode parent )
      {	
         return addTreeNode( parent, child, true );
      }
   
   	/** 
   	 * generic method for adding a new leaf to a tree
   	 */
   
      private DefaultMutableTreeNode addTreeNode( DefaultMutableTreeNode parent, Object child, boolean shouldBeVisible)
      {
         DefaultMutableTreeNode childNode = new DefaultMutableTreeNode( child );
         treeModel.insertNodeInto( childNode, parent, parent.getChildCount());

      	 //Ensure that user can see new tree node
         if (shouldBeVisible)
         {
            addressBookTree.scrollPathToVisible( new TreePath(childNode.getPath()) );
         }

         return childNode;
      }
   
	  /**
	   * This will set all the gui text values for the current Locale
	   */
	  protected void doDialect()
	  {
	  	BSwingUtilities.setJLabelText(nameLabel, BDialect.getString(this, "name"));
        BSwingUtilities.setJLabelText(addressLabel, BDialect.getString(this, "address"));
        BSwingUtilities.setJLabelText(addressListLabel, BDialect.getString(this, "addressList"));
        BSwingUtilities.setJLabelText(toLabel, BDialect.getString(this, "to"));
        BSwingUtilities.setJButtonText(addButton, BDialect.getString(this, "new"));
        BSwingUtilities.setJButtonText(selectButton, BDialect.getString(this, "shiftRight"));
        BSwingUtilities.setJButtonText(rejectButton, BDialect.getString(this, "shiftLeft"));
        BSwingUtilities.setJButtonText(modifyButton, BDialect.getString(this, "modify"));
        BSwingUtilities.setJButtonText(removeButton, BDialect.getString(this, "remove"));
        BSwingUtilities.setJButtonText(okButton, BDialect.getString("ok"));
        BSwingUtilities.setJButtonText(cancelButton, BDialect.getString("cancel"));
        BSwingUtilities.setJButtonText(toClientButton, BDialect.getString(this, "toClientAB"));
        BSwingUtilities.setJButtonText(toServerButton, BDialect.getString(this, "toServerAB"));
        BSwingUtilities.setJButtonText(toServerButton, BDialect.getString(this, "toServerAB"));

        BSwingUtilities.setUserObject(rootNode, BDialect.getString(this, "addresses"));

        BSwingUtilities.setBorderTitle(addressListBorder, BDialect.getString(this, "addressList"));
        BSwingUtilities.setBorderTitle(receiversListBorder, BDialect.getString(this, "to"));
	  }

         /**
          * This method calls the appropriate procedure should an action occur.
          */
         public void actionPerformed(java.awt.event.ActionEvent event)
         {
            Object object = event.getSource();
            if (object == okButton)
               okButton_ActionPerformed();
            else if (object == cancelButton)
               closeAddressWindow();
             else if (object == addButton)
                 processNameAndAddressFields();
             else if (object == addressField)
                 processNameAndAddressFields();
             else if (object == selectButton)
		           addToReceiversList();
             else if (object == rejectButton)
                 removeFromReceiversList();
            else if (object == removeButton)
               removeAddress();
            else if (object == modifyButton)
               modifyAddress();
         }

	
       public void valueChanged(TreeSelectionEvent event) 
       {
		   DefaultMutableTreeNode aNode = (DefaultMutableTreeNode) addressBookTree.getLastSelectedPathComponent();
       
		   if (aNode != null && aNode.getUserObject() instanceof BAddress)
		   {
           BAddress selectedAddress = (BAddress) aNode.getUserObject();
 
			  displayAddress(selectedAddress);
		   }
		   else
		   {
			  displayAddress(new BAddress("",""));
		   }

		   resetEditProperties();
        }
          
       /**
        *  This method displays the addressee's name and address for
        *  the currently selected item from displayList, in selectedAddresseeLabel.
        */
       void displayAddress(BAddress selectedAddress)
       {
           //selectedAddresseeLabel.setText(selectedAddress);
		   nameField.setText(selectedAddress.getName());
		   addressField.setText(selectedAddress.getAddress());
       }
	
       /**
        *  Called when the reject button is pressed, to move a person from the
        *  receiversList back to the displayList.
        */
       void removeFromReceiversList()
       {
           if (receiversList.getSelectedValues() != null)
           {
               Object [] selectedAddresses = receiversList.getSelectedValues();

               for (int i = 0; i < selectedAddresses.length; i++)
               {
                   receiversListModel.removeElement(selectedAddresses[i]);
               }
           }
       }
    
       /**
        *  This method copies the selected addressees from the displayList to the
        *  receiversList.
        *
        */
       void addToReceiversList()
       {
           DefaultMutableTreeNode aNode = (DefaultMutableTreeNode) addressBookTree.getLastSelectedPathComponent();
           
		     if (aNode.getUserObject() instanceof BAddress)
           {
              receiversListModel.addElement((BAddress) aNode.getUserObject());
           }
       }
    
   
      /**
       *  This method places the details of the selected addressee into the
       *  name and address fields on the address book dialog, to be
       *  modified by the user.  It notifies the dialog that it is now modifying an
       *  address, and performs a few more related activities.
       */
      void modifyAddress()
      {
         DefaultMutableTreeNode aNode = (DefaultMutableTreeNode) addressBookTree.getLastSelectedPathComponent();
         
		 if (aNode != null && aNode.getUserObject() instanceof BAddress)
       {
             if (editing)
             {
                BAddress addressToModify = (BAddress) aNode.getUserObject();
                nameField.setText(addressToModify.getName());
                addressField.setText(addressToModify.getAddress());
             }
             else
             {
                editing = true;
             }

             nameField.setEditable(true);
             addressField.setEditable(true);
             addButton.setText(BDialect.getString(this, "submit"));
             modifyButton.setEnabled(false);
             removeButton.setEnabled(false);
             modifying = true;
             
        }
      }
    
      /**
       *  This method is called when the removeButton is clicked, and deletes
       *  any selected items in the displayList from the address book on the server.
       */
      void removeAddress()
      {
         DefaultMutableTreeNode selectedNode = (DefaultMutableTreeNode) addressBookTree.getLastSelectedPathComponent();
           
		   if (selectedNode.getUserObject() instanceof BAddress)
         {
            BAddressBookCE removeEvent = new BAddressBookCE(this, BAddressBookCE.kRemoveAddress, new BAddressBookCC());
            removeEvent.setAddress((BAddress) selectedNode.getUserObject());

				if (toServerButton.isSelected())
               parent.dispatchEventServer(removeEvent);
				else
				   parent.dispatchEvent(removeEvent);

            //resetEditProperties();
         }
       }

      /**
       *  This method is called when the OKButton is clicked.  If this
       *  dialog was opened from a messageDialog, the addresses in the 
       *  receiveList are copied to the 'To' field on the messageDialog.
       *  Finally, the addressDialog is closed.
       *
       *  @author Matthew Evans
       */
      void okButton_ActionPerformed()
      {
         if(receiversListModel != null && receiversListModel.getSize() > 0)
         {
             BListModel receiversListModel = (BListModel)receiversList.getModel();
      
             BAddress aReceiver = (BAddress)receiversListModel.getElementAt(0);
             String receivers = aReceiver.toString();
		    
             for (int i = 1; i < receiversListModel.getSize(); i++)
             {
                 aReceiver = (BAddress)receiversListModel.getElementAt(i);
                 receivers = receivers + BDialect.getString(this, "addressSeparator") + aReceiver.toString();
             }
		    
             displayRequest.setReceivers(receivers);
             displayRequest.doComplete(BCommandEvent.kClientDone);
         }
		
         closeAddressWindow();
      }

      void closeAddressWindow()
      {
         BCloseWindowCE closeWindow = new BCloseWindowCE( parent, this );
         parent.dispatchEvent( closeWindow );
      }
   
       /**
        *  This method gets a Vector of addreses contianed in the address book on the
        *  server, copies it to localCopy, a BAddressBookDialog class variable, and 
        *  displays each addressee's name in the displayList.
        */
      public void doInitialiseAddressList()
      {
         //displayListModel.setAddresses(new Vector());
         Debug.doPrintln("AddressBookWindow: requesting addresses");
         
         if (serverAvailable)
         {
            parent.dispatchEventServer(new BAddressBookCE(parent, BAddressBookCE.kListAddressBook, new BAddressBookCC()));

            Debug.doPrintln("AddressBookWindow: requesting logged users");
            BGetUsersCE getUsers = new BGetUsersCE( parent, new BGetUsersCC() );
            parent.dispatchEventServer(getUsers);
         }
         else
         {
            parent.dispatchEvent(new BAddressBookCE(parent, BAddressBookCE.kListAddressBook, new BAddressBookCC()));
         }
      }


      /**
        *  If the user is currently modifying an address, the modified address will be processed.
        *  Otherwise, the user will be adding an address, and so the new address will 
        *  be added to the address book.
        */
      void processNameAndAddressFields()
      {
         if (!editing)
         {
             nameField.setEditable(true);
             addressField.setEditable(true);
             nameField.setText("");
             addressField.setText("");
             addButton.setText(BDialect.getString(this, "submit"));
             modifying = false;
             editing = true;
         }
         else
         {
           if ((nameField.getText().trim().length() == 0) || (addressField.getText().trim().length() == 0))
			  {
               displayAddressMessage(BDialect.getString(this, "noNameAddress"));
			  }
           else if (nameField.getText().indexOf(BDialect.getString(this, "addressSeparator")) != -1)
           {
               displayAddressMessage(BDialect.getString(this, "noSeparators"));
           }
           else
           {
              BAddress newAddress = new BAddress(nameField.getText(), addressField.getText());
    	        BAddressBookCE addressBookRequest;
               
               if (!modifying)
               {
                   Debug.doPrintln("AddressBookWindow: adding new address");
                   addressBookRequest = new BAddressBookCE(this, BAddressBookCE.kAddAddress, new BAddressBookCC());
                   addressBookRequest.setAddress(newAddress);
               }
               else
               {
                   Debug.doPrintln("AddressBookWindow: modifying current address");
                   addressBookRequest = new BAddressBookCE(this, BAddressBookCE.kUpdateAddress, new BAddressBookCC());
                   addressBookRequest.setModifyAddress(newAddress);
				   
				      DefaultMutableTreeNode aNode = (DefaultMutableTreeNode) addressBookTree.getLastSelectedPathComponent();
           
				      if (aNode.getUserObject() instanceof BAddress)
				      {
					       addressBookRequest.setAddress((BAddress) aNode.getUserObject()); 
				      }

               }
            
                if (toServerButton.isSelected())
                   BAddressBookGui.this.dispatchEventServer(addressBookRequest);
                else
                   BAddressBookGui.this.dispatchEvent(addressBookRequest);
            
               addButton.requestFocus();
               resetEditProperties();
           }
         }
      }
    
      /**
       *  This method sets the dialog components to their default states.
       *
       *  @author Matthew Evans
       */
      void resetEditProperties()
      {
          nameField.setEditable(false);
          addressField.setEditable(false);
          
          modifying = false;
          editing = false;
          addButton.setText(BDialect.getString(this, "new"));
          modifyButton.setEnabled(true);
          removeButton.setEnabled(true);
      }
	
	
   
      /**
       * The renderer for the JList model
       *
       * @author Tristan Austin
       */
       class BAddressListRenderer extends JLabel implements ListCellRenderer
       {
         /**
          * Creates a new cell renderer
          */
           public BAddressListRenderer()
           {
               setOpaque(true);
           }

           /**
            * Gets the component to place in the list
            *
            * @param list  the list to put it in
            * @param value The component the render
            * @param index the index it is at
            * @param isSelected  Whether it is selected or not
            * @param cellHasfocus   Indicates whether it has the focus or not
            */
           public Component getListCellRendererComponent(JList list, Object value, int index, boolean isSelected, boolean cellHasFocus)
           {
               this.setText(value.toString());
               this.setBackground(isSelected ? Color.blue : Color.white);
               this.setForeground(isSelected ? Color.white : Color.black);
               return this;
           }
       }


    /**
     * 
     */
    class BAddressBookCC extends BCommandComplete
    {
        /**
         * Called when the address action has been performed
         *
         * @param   event   The event that was originally fired
         * @param   status  The success status of the operation
         */
        public void doComplete( BCommandEvent event, int status )
        {
            Debug.doPrintln("BAddressBookGui: BAddressBookCC: caught completed event=> " + event.toString());

            if (event.getCompletionStatus() == BCommandComplete.kNetError)
               displayAddressMessage(BDialect.getString(this, "networkError"));
            else if (event.getCompletionStatus() == BCommandComplete.kError)
               displayAddressMessage(BDialect.getString(this, "error"));
            else
               handleNormalCompletion((BAddressBookCE) event);
        }

        /**
         *  Called if the corresponding address book process was a success
         *
         * @param addressEvent: the BAddressBookCE object that was fired
         */
        public void handleNormalCompletion(BAddressBookCE addressEvent)
        {
            String bookLocation = new String(BDialect.getString(this, "clientAddressBook"));
			   Object args[] = null;

            if (addressEvent.getNetworkStatus() == BCommandEvent.kServerDone)
               bookLocation = new String(BDialect.getString(this, "serverAddressBook"));

			   args = new Object[]{bookLocation};

            if (addressEvent.getRequest() == BAddressBookCE.kListAddressBook)
            {
               if (addressEvent.getCompletionStatus() == BCommandComplete.kError)
                  displayAddressMessage(BDialect.formatText(BDialect.getString(this, "addressBookError"), args));
               else
               {
                  BAddressBookWindow.this.addTreeNode(bookLocation, rootNode);
                  
                  Vector addresses = addressEvent.getAddressList();
   
                  for (int i=0; i < addresses.size(); i++)
                  {
                    BAddressBookWindow.this.addTreeNode(addresses.elementAt(i), (DefaultMutableTreeNode) rootNode.getLastChild());
                  }
               }
            }
            else if (addressEvent.getRequest() == BAddressBookCE.kAddAddress)
            {
               if (addressEvent.getCompletionStatus() == BCommandComplete.kError)
			      {
                  displayAddressMessage(BDialect.formatText(BDialect.getString(this, "addingAddressError"), args));
			      }
               else
               {
				     DefaultMutableTreeNode treeBranch = getTreeBranch(bookLocation);
                  
                  if (treeBranch != null)
                  {
      					 Debug.doPrintln("BAddressBookCC: adding new address to display:" + addressEvent.getAddress());
		      			 BAddressBookWindow.this.addTreeNode(addressEvent.getAddress(), treeBranch);
				      }
                  
                  resetEditProperties();
               }
            }
            else if (addressEvent.getRequest() == BAddressBookCE.kUpdateAddress)
            {
               if (addressEvent.getCompletionStatus() == BCommandComplete.kError)
			      {
                  displayAddressMessage(BDialect.formatText(BDialect.getString(this, "updatingAddressError"), args));
				   }
               else
               {
                  DefaultMutableTreeNode treeBranch = getTreeBranch(bookLocation);

                  if (treeBranch != null)
                  {
                      DefaultMutableTreeNode addressLeaf = (DefaultMutableTreeNode) treeBranch.getFirstChild();
      
                      while (addressLeaf != null)
                      {
                        if(addressLeaf.getUserObject() == addressEvent.getAddress())
                        {
                           TreePath path = new TreePath(addressLeaf.getPath());
                           treeModel.valueForPathChanged(path, addressEvent.getModifyAddress());
                           break;
                        }
      
                        addressLeaf = addressLeaf.getNextSibling();
					       }
                   }
                  
                  resetEditProperties();
               }
            }
            else if (addressEvent.getRequest() == BAddressBookCE.kRemoveAddress)
            {
               if (addressEvent.getCompletionStatus() == BCommandComplete.kError)
			      {
                  displayAddressMessage(BDialect.formatText(BDialect.getString(this, "removingAddressError"), args));
			      }
               else
               {
                  DefaultMutableTreeNode treeBranch = getTreeBranch(bookLocation);
                  
                  if (treeBranch != null)
                  {
					     DefaultMutableTreeNode addressLeaf = (DefaultMutableTreeNode) treeBranch.getFirstChild();

					    while (addressLeaf != null)
					    {
					   	if(addressLeaf.getUserObject() == addressEvent.getAddress())
					   	{
                        Debug.doPrintln("removing node from tree");
	                    treeModel.removeNodeFromParent(addressLeaf);
					   	  break;
					   	}

					   	addressLeaf = addressLeaf.getNextSibling();
					    }
                  }
                  
               }
            }
        }
        
        private DefaultMutableTreeNode getTreeBranch(String name)
        {
 				DefaultMutableTreeNode treeBranch = (DefaultMutableTreeNode) rootNode.getFirstChild();

            while (treeBranch != null)
			   {
			     String branchTitle = (String) treeBranch.getUserObject();

               if (branchTitle.equals(name))
               {
                  return treeBranch;
               }

			     treeBranch = treeBranch.getNextSibling();
	  		   }

				return null;
        }
    }

    /**
     * An instance of this class is passed along with the BGetUserCE event
     * so that it's <code>doComplete</code> method may be called by the
     * target plugin when the list of available users has been obtained.
     * <p>
     * At this point the available users are displayed in a Jlist with other address
     * entries
     *
     * @author John Newbigin & Matthew Evans
     */
    class BGetUsersCC extends BCommandComplete
    {
        /**
         * When the users have been retrieved this method is called
         *
         * @param   event   The event that was originally fired
         * @param   status  The success status of the operation
         */
        public void doComplete( BCommandEvent event, int status )
        {
            Debug.doPrintln( "got list of users" );
            BGetUsersCE e = ( BGetUsersCE ) event;
            Vector users = e.getUsers();
            
           if (users == null)
           {
              users = new Vector();
           }
           
  		     BAddressBookWindow.this.addTreeNode(BDialect.getString(this, "loggedInUsers"), rootNode);
		   
		     for (int i = 0; i < users.size(); i++)
		     {
			     BAddressBookWindow.this.addTreeNode(users.elementAt(i), (DefaultMutableTreeNode) rootNode.getLastChild());
		     }

        }

     }
   }   
}
