

package au.edu.swin.synergy.plugin.addressbook.event;

import au.edu.swin.synergy.kernel.BCommandEvent;
import au.edu.swin.synergy.kernel.BCommandComplete;
import au.edu.swin.synergy.lib.BStringList;

/**
 * This event notifies the address book gui to open
 *
 * @author Matthew Evans
 */
public class BAddressDisplayCE extends BCommandEvent
{
   /**
    * Identifies whether the address book is being opened from a mail window
    * or the menu
    */
   //boolean fromMailGui;

   /**
    * The list of selected address names selected in the BAddressBookGui
    */
   String receivers = null;
   

   /**
    * Creates an instance of BAddressDisplayCE with the origin set.
    *
    * @param source the origin of this event
    */
   public BAddressDisplayCE(Object source, BCommandComplete complete)//, boolean fromMailGui)
   {
      super(source);
      this.setCompletionObject(complete);
      //this.fromMailGui = fromMailGui;
   } 

   /**
    * 
    *
    * @return true if started from the mail gui; false otherwise (started from menu)
    */
/*   public boolean isFromMailGui()
   {
      return this.fromMailGui;
   }*/

   /**
    * Sets a list of receivers for a mail message window
    *
    * @param selectedRecievers the collection of receivers selected on a
    *    BAddressBookGui
    */
   public void setReceivers(String selectedReceivers)
   {
      this.receivers = selectedReceivers;
   }

   /**
    * Returns a list of receivers for a mail message window
    *
    * @return the recievers selected in the BAddressBookgui
    */
   public String getReceivers()
   {
      return this.receivers;
   }
} 
