// $Header: /teamproj/cvsroot/teamb/bkasrc/au/edu/swin/synergy/plugin/broadcastcli/BBroadcastCli.java,v 1.14 1999/10/15 13:41:05 tp079519 Exp $

   package au.edu.swin.synergy.plugin.broadcastcli;

   import java.lang.String;
   import au.edu.swin.synergy.kernel.BPlugin;
   import au.edu.swin.synergy.kernel.BCommandEvent;
   import au.edu.swin.synergy.kernel.BCommandComplete;
   import au.edu.swin.synergy.kernel.event.BBootCE;

   import au.edu.swin.synergy.kernel.BKernel;
   import java.net.DatagramSocket;
   import java.net.DatagramPacket;
   import au.edu.swin.synergy.plugin.broadcastsvr.BBroadcastSvr;
   import javax.swing.AbstractListModel;
   import au.edu.swin.synergy.lib.BStringList;
   import au.edu.swin.synergy.plugin.broadcastcli.event.BGetServersCE;
   import au.edu.swin.synergy.debug.Debug;
   import java.math.BigInteger;
   import au.edu.swin.synergy.plugin.command.BOnCommand;
   import au.edu.swin.synergy.plugin.command.event.BRegisterCmdCE;
   import java.io.InputStream;
   import java.io.PrintStream;
   import au.edu.swin.synergy.lib.BStringList;
   import au.edu.swin.synergy.lib.BSleep;
   import java.net.InetAddress;


/**
 * Sample plugin
 * @Author John Newbigin
 * @Copyright Synergy Software 1999
 * @see
 * @concurrency
 * @rref
 */

   public class BBroadcastCli extends BPlugin
   {
      int change = 1;
    /**
     * Please complete the missing tags for setup
     * @post
     * @pre
     * @throws
     * @return
     * @param
     */
   
      BServerListModel serverListModel = new BServerListModel();
    /**
     * Please complete the missing tags for setup
     * @param
     * @return
     * @pre
     * @post
     */
   
      public void setup(BStringList params)
      {
      // register command line commands        
         dispatchEvent( new BRegisterCmdCE( this, "findserver", new OnFindServer() ) );
      
        //serverListModel.addServer( "localhost" );
      }
    /**
     * Please complete the missing tags for doSendRequest
     * @param
     * @return
     * @pre
     * @post
     */
   
   
      public void doSendRequest()
      {
        // use UDP multicast...
      
      
         try
         {	
            byte [] array = new byte [ 1 ];
            BigInteger port = BigInteger.valueOf( BBroadcastSvr.kPortNumber + change );
            byte [] portArray = port.toByteArray();
            Debug.doPrintln("Array Size = " + portArray.length + " value " + new BigInteger(portArray).intValue());	
         
            DatagramSocket senderSocket = new DatagramSocket();
            DatagramPacket data = null;
			
			
			if(BBroadcastSvr.getAddressClass() == 'B')
			{
        	    Debug.doPrintln( "Sent request to all class B subnets");
				// if this is a class B, then we will look on all subnets
   				for(int i=0; i<=255; i++)
				{
	        	    data = new DatagramPacket( portArray, portArray.length, BBroadcastSvr.getClassBBroadcastAddress(i) , BBroadcastSvr.kPortNumber );
    	        	senderSocket.send( data );
				}
			}
			else
			{
				data = new DatagramPacket( portArray, portArray.length, BBroadcastSvr.getBroadcastAddress(), BBroadcastSvr.kPortNumber );
   		        senderSocket.send( data );
       		    Debug.doPrintln( "Sent request to " + data.getAddress().getHostAddress() );
			}

      }
            catch( Exception e )
            {
               Debug.doPrintln( "Error sending server broadcast request: " + e );
            }
      
      
      }
    /**
     * Please complete the missing tags for onBCommandEvent
     * @post
     * @pre
     * @throws
     * @return
     * @param
     */
   
      public void onBCommandEvent( Object source, BCommandEvent event )
      {
         if( event instanceof BBootCE )
         {
            start();
         }
         else if( event instanceof BGetServersCE )
         {
            Debug.doPrintln( "Request for the server list model" );
            BGetServersCE e = ( BGetServersCE ) event;
            e.setServerListModel( serverListModel );
            e.doComplete( BCommandComplete.kSuccess );
            doSendRequest();
         }
      }
    /**
     * Please complete the missing tags for addTestMenu
     * @post
     * @pre
     * @throws
     * @return
     * @param
     */
   
      void start()
      {
         boolean success = false;
         while(success == false)
         {
            try
            {
               byte [] array = new byte [ 1 ];
            
               DatagramSocket receiverSocket = new DatagramSocket( BBroadcastSvr.kPortNumber + change );
            	//DatagramSocket receiverSocket = new DatagramSocket();
               Debug.doPrintln( "Got Datagram Socket at port " + receiverSocket.getLocalPort() );
               BigInteger port = BigInteger.valueOf( BBroadcastSvr.kPortNumber + change );
               byte [] portArray = port.toByteArray();
               Debug.doPrintln("Array Size = " + portArray.length );
               success = true;
            
               // wait for responses...
               while( true )
               {
                  DatagramPacket response = new DatagramPacket( array, 1 );
                  receiverSocket.receive( response );
                  Debug.doPrintln( "Server at " + response.getAddress().getHostName() );
                  serverListModel.addServer( response.getAddress().getHostName() );
               }
            }
               catch( Exception e )
               {
                  Debug.doPrintln( "Error recieving datagram: " + e );
                  success = false;
                  change++;
               }
         }
      }
   
      class OnFindServer implements BOnCommand
      {
         public int onCommand( BStringList params, InputStream in, PrintStream out )
         {
		 	out.println("Looking for servers, please wait");
			serverListModel.removeAllElements();
            doSendRequest();
            BSleep.doSleep(5000);
			out.println("Found " + serverListModel.getSize() + " servers");
			for(int i=0; i < serverListModel.getSize(); i++)
			{
				out.println((String)serverListModel.getElementAt(i));
			}
            return 0;
         }
      
         public String getHelp( BStringList params )
         {
            return "broadcast for the servers on the local network";
         }
      }
   
   }
