// $Header: /teamproj/cvsroot/teamb/bkasrc/au/edu/swin/synergy/plugin/broadcastsvr/BBroadcastSvr.java,v 1.10 1999/09/07 08:16:02 tp079519 Exp $

   package au.edu.swin.synergy.plugin.broadcastsvr;

   import java.lang.String;
   import au.edu.swin.synergy.kernel.BPlugin;
   import au.edu.swin.synergy.kernel.BCommandEvent;
   import au.edu.swin.synergy.kernel.event.BBootCE;

   import au.edu.swin.synergy.kernel.BKernel;
   import java.net.DatagramSocket;
   import java.net.DatagramPacket;
   import java.net.InetAddress;
   import java.math.BigInteger;
   import au.edu.swin.synergy.debug.Debug;
   import au.edu.swin.synergy.lib.BStringList;



/**
 * Sample plugin
 * @Author John Newbigin
 * @Copyright Synergy Software 1999
 * @see
 * @concurrency
 * @rref
 */

   public class BBroadcastSvr extends BPlugin
   {
      public static final int kPortNumber = 9000;
   
    /**
     * Return the appropriate broadcast address
     * Please complete the missing tags for getBroadcastAddress
     * @param
     * @return
     * @pre
     * @post
     */
      static public InetAddress getBroadcastAddress()
      {
         InetAddress result = null;
         try
         {
            String address = InetAddress.getLocalHost().getHostAddress();
            // we need to chop off the last number and set it to 255
            int lastDot = address.lastIndexOf( "." );
            address = address.substring( 0, lastDot ) + ".255";
         
            result = InetAddress.getByName( address );
         }
            catch( Exception E )
            {
            }
         return result;
      }
   
      static public InetAddress getClassBBroadcastAddress(int i)
      {
         InetAddress result = null;
         try
         {
            String address = InetAddress.getLocalHost().getHostAddress();
            int lastDot = address.lastIndexOf( "." );
            address = address.substring( 0, lastDot );
            lastDot = address.lastIndexOf( "." );
            address = address.substring( 0, lastDot ) + "." + i + ".255";
         
            result = InetAddress.getByName( address );
         }
            catch( Exception E )
            {
            }
         return result;
      }

	  static public char getAddressClass()
	  {
         try
         {
	  	String address = InetAddress.getLocalHost().getHostAddress();
		int firstDot = address.indexOf(".");
		int n = Integer.parseInt(address.substring(0, firstDot));
		if(n >= 0 && n <= 127)
		{
			return 'A';
		}
		else if(n >= 128 && n <= 191)
		{
			return 'B';
		}
		else if(n >= 192 && n <= 223)
		{
			return 'C';
		}
		else if(n >= 224 && n <= 239)
		{
			return 'D';
		}
		else if(n >= 240 && n <= 247)
		{
			return 'E';
		}
		}
        catch( Exception E )
           {
           }
		return '?';
   	  }
	  
    /**
     * Please complete the missing tags for setup
     * @post
     * @pre
     * @throws
     * @return
     * @param
     */
   
      public void setup(BStringList params)
      {
      }
    /**
     * Please complete the missing tags for onBCommandEvent
     * @post
     * @pre
     * @throws
     * @return
     * @param
     */
   
      public void onBCommandEvent( Object source, BCommandEvent event )
      {
         if( event instanceof BBootCE )
         {
            announce();
            start();
         }
      }
    /**
     * Send a broadcast when we first boot
     * @post
     * @pre
     * @throws
     * @return
     * @param
     */
   
      void announce()
      {
         try
         {
            byte [] array = new byte [ 1 ];
         
            DatagramSocket senderSocket = new DatagramSocket();
            DatagramPacket data = new DatagramPacket( array, 1, BBroadcastSvr.getBroadcastAddress(), kPortNumber + 1 );
         
            senderSocket.send( data );
            Debug.doPrintln( "Broadcast notification sent to " + data.getAddress().getHostName() );
         }
            catch( Exception e )
            {
               Debug.doPrintln( "Error sending server broadcast: " , e );
            }
      
      }
    /**
     * Please complete the missing tags for start
     * @param
     * @return
     * @pre
     * @post
     */
   
   
      void start()
      {
         try
         {
            DatagramSocket senderSocket = new DatagramSocket();
            DatagramSocket receiverSocket = new DatagramSocket( kPortNumber );
         
            while( true )
            {
               byte [] array = new byte [ 2 ];
               DatagramPacket data = new DatagramPacket( array, 2 );
               receiverSocket.receive( data );
            	 Debug.doPrintln( "port no. sent: " +  new BigInteger(data.getData()).intValue() );
               Debug.doPrintln( "got request from " + data.getAddress().getHostName() );
               Debug.doPrintln( "sending response to " + data.getAddress().getHostName() );
               //Debug.doPrintln( "client at port " + data.getPort() );
            
               //DatagramPacket response = new DatagramPacket( array, 1, data.getAddress(), kPortNumber + 1 );
               DatagramPacket response = new DatagramPacket( array, 1, data.getAddress(), new BigInteger(data.getData()).intValue() );
               senderSocket.send( response );
            }
         }
            catch( Exception e )
            {
            }
      }
   
   }
