/**
 * Please complete these missing tags
 * @see
 * @concurrency
 */
// $Header: /teamproj/cvsroot/teamb/bkasrc/au/edu/swin/synergy/plugin/client/BClient.java,v 1.24 1999/10/16 04:30:34 tp079519 Exp $

package au.edu.swin.synergy.plugin.client;

import java.lang.String;
import au.edu.swin.synergy.kernel.BPlugin;
import au.edu.swin.synergy.kernel.BCommandEvent;
import au.edu.swin.synergy.kernel.BCommandComplete;
import au.edu.swin.synergy.kernel.event.BBootCE;

import au.edu.swin.synergy.plugin.client.event.BNetLoginCE;
import au.edu.swin.synergy.plugin.client.event.BNetLogoutCE;

import au.edu.swin.synergy.plugin.userdb.event.BUserUpdatedCE;

import au.edu.swin.synergy.kernel.BKernel;
import au.edu.swin.synergy.kernel.BCommandEvent;

import au.edu.swin.synergy.plugin.server.BSocketObjectPipe;
import au.edu.swin.synergy.debug.Debug;

import java.net.Socket;
import java.net.UnknownHostException;
import java.net.NoRouteToHostException;
import java.net.ConnectException;
import java.io.IOException;
import java.lang.Runnable;
import java.lang.Thread;
import java.util.Vector;
import au.edu.swin.synergy.plugin.server.event.BGetNetworkStatusCE;
import au.edu.swin.synergy.plugin.server.event.BRegisterFilterCE;

import au.edu.swin.synergy.plugin.command.BOnCommand;
import au.edu.swin.synergy.plugin.command.event.BRegisterCmdCE;
import java.io.InputStream;
import java.io.PrintStream;
import au.edu.swin.synergy.lib.BStringList;
import au.edu.swin.synergy.plugin.server.BServer;
import au.edu.swin.synergy.plugin.server.BNetCredentials;
import au.edu.swin.synergy.plugin.userdb.event.BAuthUserCE;
import au.edu.swin.synergy.plugin.client.event.BLoginCompleteCE;
import au.edu.swin.synergy.plugin.client.event.BLogoutCompleteCE;
import au.edu.swin.synergy.plugin.userdb.BUser;
import au.edu.swin.synergy.plugin.client.event.BGetUserCE;
import au.edu.swin.synergy.kernel.BBlockingComplete;
import au.edu.swin.synergy.plugin.command.event.BEnableRemoteCE;

import au.edu.swin.synergy.plugin.help.BHelpItem;
import au.edu.swin.synergy.plugin.help.BHelpUtil;
import au.edu.swin.synergy.plugin.help.BHelpTreeModel;
import au.edu.swin.synergy.plugin.help.event.BRegisterHelpCE;

/**
 * Client side network plugin
 * @Author John Newbigin
 * @Copyright Synergy Software 1999
 * @rref Tristans Book
 */


public class BClient extends BPlugin implements Runnable
{
    Socket socket = null;
    int portNumber = - 1;
    BSocketObjectPipe pipe = null;

    boolean connected = false;

    Vector sentEvents = new Vector();

    static int nextIndex = 0;

	private Vector filters = new Vector();

	private BUser loggedInUser = null;
    String hostName = null;

    /**
     * Return a list of plugin dependancies
	 * This is currently not used by the kernel
     * @return a list of plugins such as "au.edu.swin.synergy.plugin.mod13.BWindowManager"
	 * or null if there are no dependancies
     */

    public BStringList getDependancies()
	{
		BStringList result = new BStringList();
		result.add("au.edu.swin.synergy.plugin.broadcastcli.BBroadcastCli");
		return result;
	}
	
    /**
     * Please complete the missing tags for setup
     * @post
     * @pre
     * @throws
     * @return
     * @param
     */

    public void setup(BStringList params)
    {
		// register command line commands
		dispatchEvent( new BRegisterCmdCE( this, "login", new OnLogin() ) );
		dispatchEvent( new BRegisterCmdCE( this, "logout", new OnLogout() ) );
        dispatchEvent( new BRegisterCmdCE( this, "whoami", new onWhoAmI() ) );

    }
    /**
     * Please complete the missing tags for onBCommandEvent
     * @post
     * @pre
     * @throws
     * @return
     * @param
     */

    public void onBCommandEvent( Object source, BCommandEvent event )
    {
		if ( event instanceof BBootCE )
		{
			registerHelp ();
		}
        else if( event instanceof BNetLoginCE )
        {
            BNetLoginCE e = ( BNetLoginCE ) event;

            if( socket == null )
            {
                try
                {
					hostName = e.getHostName();
                    socket = new Socket( e.getHostName(), e.getPortNumber() );
                    pipe = new BSocketObjectPipe( socket , false, filters);
                    new Thread( this ).start();
                    // the receive thread
                    connected = true;

					// do the authentication
					if(performAuthentication(e.getCredentials()))
					{
						// send out a logged in event
						e.setError(0);
						dispatchEvent(new BLoginCompleteCE(this, hostName, e.getCredentials().getUsername()));
					}
					else
					{
						// set the error status
						e.setError(1);
						e.setMessage("Authentication failed");

						// close the socket
						socket.close();
						loggedInUser = null;
					}

                    event.doComplete( BCommandComplete.kSuccess );
                }
				catch( UnknownHostException E)
				{
					Debug.doPrintln("Host not found");
					e.setMessage("Host not found " + e.getHostName() + ".  Check the host name before trying again");
                    event.doComplete( BCommandComplete.kError );
                    socket = null;
					connected = false;
				}
				catch( NoRouteToHostException E)
				{
					Debug.doPrintln("No route to host");
					e.setMessage("No route to host " + e.getHostName() + ".  This generaly indicates a network problem between you machine and the specified host");
                    event.doComplete( BCommandComplete.kError );
                    socket = null;
					connected = false;
				}
				catch( ConnectException E)
				{
					Debug.doPrintln("Host not found");
					e.setMessage("Connection refused.  Either there is no server running on the specified machine, or it is too heavily loaded to accept new connections");
                    event.doComplete( BCommandComplete.kError );
                    socket = null;
					connected = false;
				}
                catch( Exception E )
                {
					Debug.doPrintln("Connect to server", E);
					e.setMessage(E.getMessage());
                    event.doComplete( BCommandComplete.kError );
                    socket = null;
					connected = false;
                }
            }
            else
            {
                // raise an exception?
                Debug.doPrintln( "Already logged in" );
                event.doComplete( BCommandComplete.kError );
            }
        }
        else if( event instanceof BNetLogoutCE )
        {
            if( connected )
            {
                try
                {
                    socket.close();
                    socket = null;
                    event.doComplete( BCommandComplete.kSuccess );
                }
                catch( Exception E )
                {
                    event.doComplete( BCommandComplete.kNetError );
					Debug.doPrintln("Logging out", 1);
                }
                socket = null;
                connected = false;
            }
			// this is now done by the receive thread
			//dispatchEvent(new BLogoutCompleteCE(this));
        }
		else if( event instanceof BGetNetworkStatusCE)
		{
			BGetNetworkStatusCE statusEvent = (BGetNetworkStatusCE) event;
			statusEvent.setStatus(BGetNetworkStatusCE.kServer);
			if(connected)
			{
				statusEvent.setConnections(1);
			}
			else
			{
				statusEvent.setConnections(0);
			}
			statusEvent.doComplete(BCommandComplete.kSuccess);
		}
		else if(event instanceof BRegisterFilterCE)
		{
			Debug.doPrintln("Registering socket filter");
			BRegisterFilterCE filterEvent = (BRegisterFilterCE) event;
			filters.add(filterEvent.getFilter());
			event.doComplete(BCommandComplete.kSuccess);
		}
        else if( event instanceof BGetUserCE )
        {
            BGetUserCE getUserEvent = ( BGetUserCE ) event;
            getUserEvent.setUser( loggedInUser );
            getUserEvent.doComplete( BCommandComplete.kSuccess );
        }
        else if (event instanceof BUserUpdatedCE)
        {
            //A user has been updated on the server, need to see if it's ours
            BUser updatedUser = ((BUserUpdatedCE)(event)).getUpdatedUser();

            //See if the logged in user was the one that changed
            if (this.loggedInUser.equals(updatedUser))
            {
                //If so replace it
                this.loggedInUser = updatedUser;
            }
        }
        else if( event.getNetworkStatus() == BCommandEvent.kServer )
        {
            if( connected )
            {
                try
                {
                    Debug.doPrintln( "sending event" );
                    synchronized( sentEvents )
                    {
                        // add the event to a list of pending results...
                        event.setIndex( nextIndex++ );
                        sentEvents.add( event );
                        Debug.doPrintln( "event sent " + sentEvents.size() );
                    }
                    pipe.doNetDataSend( event );
                }
                catch( IOException exception )
                {
                    Debug.doPrintln("Network error: ", exception);
                    event.doComplete( BCommandComplete.kNetError );
                }
            }
            else
            {
                // we are not logged in....
                event.doComplete( BCommandComplete.kNetError );
            }
        }
		if(event instanceof BLoginCompleteCE)
		{
			dispatchEvent(new BEnableRemoteCE(this, true));
		}
		else if(event instanceof BLogoutCompleteCE)
		{
			dispatchEvent(new BEnableRemoteCE(this, false));
		}
    }
    /**
     * Please complete the missing tags for run
     * @post
     * @pre
     * @throws
     * @return
     * @param
     */
	private void registerHelp ()
	{
			BHelpTreeModel tree = new BHelpTreeModel ( "Client" );
			String path = "/au/edu/swin/synergy/plugin/client/help/";
			BHelpItem log = new BHelpItem ( "Login In and Out of a Server", path + "log_in_out.html" );

			tree.addHelpItem ( null, log );

			BRegisterHelpCE event = new BRegisterHelpCE ( this, tree );
			dispatchEvent ( event );
	}

    public void run()
    {
        // read stuff....
        boolean quit = false;

        while( ! quit )
        {
            try
            {
                BCommandEvent event = pipe.doNetDataRead();

                if( event == null )
                {
                    Debug.doPrintln( "Got null object" );
					dispatchEvent(new BLogoutCompleteCE(this));
                    quit = true;
					flushOutstandingEvents();
                    break;
                }
                else if( event.getNetworkStatus() == BCommandEvent.kServerDone )
                {
                    event.setPipe( pipe );
                    // process the event inside the object....?
                    Debug.doPrintln( "Got object" );
                    doProcess( event );
                }
                else if( event.getNetworkStatus() == BCommandEvent.kClient )
                {
                    Debug.doPrintln( "Got a server initiated event" );
                    event.setCompletionObject( new Completion() );
                    dispatchEvent( event );
                    Debug.doPrintln( "Event dispatched" );
                }
            }
            catch( Exception e )
            {
                Debug.doPrintln( "Incoming event: " , e );
                quit = true;
            }
        }

        // close it all down...
        try
        {
            pipe = null;
            socket.close();
            socket = null;
        }
        catch( Exception e )
        {
            Debug.doPrintln( "Error on shutdown: " + e );
        }
    }
    /**
     * Please complete the missing tags for doProcess
     * @post
     * @pre
     * @throws
     * @return
     * @param
     */

    void doProcess( BCommandEvent event )
    {
        // and incoming network event (this should be a responce)
        Debug.doPrintln( "Got a responce" );
        // we need to find the original completeion object...

        boolean callCompletion = false;

        synchronized( sentEvents )
        {
            for( int i = 0; i < sentEvents.size(); i++ )
            {
                BCommandEvent e = ( BCommandEvent ) sentEvents.get( i );
                if( e.getIndex() == event.getIndex() )
                {
                    event.setCompletionObject( e.getCompletionObject() );
                    callCompletion = true;
                    if( event.getCompletionStatus() != BCommandComplete.kPending )
                    {
                        sentEvents.remove( i );
                    }
                    Debug.doPrintln( "" + sentEvents.size() + " events in queue" );
                    break;
                }
            }
        }
        if( callCompletion )
        {
            Debug.doPrintln( "Calling original completion object" );
			try
			{

				// we now do this in a new thread so the completion object
				// can still send network events and block.
				new BCallCompletion(event).start();
	            //event.doComplete( event.getCompletionStatus() );

			}
			catch(Exception E)
			{
				Debug.doPrintln("Exception in completion object", E);
			}
        }
    }

    void flushOutstandingEvents()
    {
        // and incoming network event (this should be a responce)
        Debug.doPrintln( "Flushing outstanding events" );

		while(sentEvents.size() > 0)
		{
            BCommandEvent e = ( BCommandEvent ) sentEvents.get( 0 );
			e.doComplete( BCommandComplete.kNetError);
			sentEvents.remove(0);
		}
    }


	private boolean performAuthentication(BNetCredentials credentials)
	{
		BBlockingComplete complete = new BBlockingComplete();
		BAuthUserCE authEvent = new BAuthUserCE(this, credentials, complete);
        dispatchEventServer( authEvent );

		complete.waitForEvent();

		if(complete.getStatus() == BCommandComplete.kSuccess)
		{
			authEvent = (BAuthUserCE) complete.getEvent();
			if(authEvent.getStatus() == BAuthUserCE.kSuccess)
			{
				loggedInUser = authEvent.getUser();
				return true;
			}
		}
		return false;
	}

    class Completion extends BCommandComplete
    {
        public void doComplete( BCommandEvent event, int status )
        {
            Debug.doPrintln( "event complete" );
            // send back to the originating pipe...
            event.setNetworkStatus( BCommandEvent.kClientDone );
            event.setCompletionStatus( status );

            try
            {
                pipe.doNetDataSend( event );
                Debug.doPrintln( " and sent" );
            }
            catch( IOException exception )
            {
                Debug.doPrintln( "Error sending completed event: " + exception );
            }
        }
    }

    class OnLogin implements BOnCommand
    {
        public int onCommand( BStringList params, InputStream in, PrintStream out )
        {
			/////////////////////////////////////////////////////////////
			// fast login for testing only...
			if(params.getCount() == 1)
			{
				params.add("localhost");
				params.add("user");
				params.add("password");
			}
			/////////////////////////////////////////////////////////////

			if(params.getCount() == 4)
			{
				hostName = params.get(1);

				BBlockingComplete complete = new BBlockingComplete();

                BNetLoginCE loginEvent = new BNetLoginCE( this, hostName, BServer.kPortNumber, params.get(2), params.get(3) );
				loginEvent.setCompletionObject(complete);
				dispatchEvent(loginEvent);

				complete.waitForEvent();
				if(complete.getStatus() == BCommandComplete.kSuccess)
				{
					loginEvent = (BNetLoginCE) complete.getEvent();
					if(loginEvent.isLoggedIn())
					{
						out.println("Logged in");
					}
					else
					{
						out.println("Error logging in to server");
					}
				}
				else
				{
					out.println("Error logging in to server");
				}
			}
			else
			{
				out.println("Wrong number of arguments");
			}
			return 0;
        }

        public String getHelp( BStringList params )
        {
            return "Login to a remote server\n" +
			       "Usage: login hostname username password";
        }
    }

    class OnLogout implements BOnCommand
    {
        public int onCommand( BStringList params, InputStream in, PrintStream out )
        {
			dispatchEvent(new BNetLogoutCE(this));
			return 0;
        }

        public String getHelp( BStringList params )
        {
            return "Logout from a remote server\n" +
			       "Usage: logout";
        }
    }

    class onWhoAmI implements BOnCommand
    {
        public int onCommand( BStringList params, InputStream in, PrintStream out )
        {
            if( loggedInUser == null )
            {
                out.println( "Not logged in" );
            }
            else
            {
                out.println( loggedInUser.getName() + " " + loggedInUser.getFullName() );
            }
            return 0;
        }

        public String getHelp( BStringList params )
        {
            return "Who am I logged in as?";
        }
    }

	class BCallCompletion extends Thread
	{
		BCommandEvent event = null;

		public BCallCompletion(BCommandEvent fEvent)
		{
			event = fEvent;
		}

		public void run()
		{
			event.doComplete( event.getCompletionStatus() );
		}
	}
}
