/**
 * Please complete these missing tags
 * @see
 * @concurrency
 */
// $Header: /teamproj/cvsroot/teamb/bkasrc/au/edu/swin/synergy/plugin/clientgui/BClientGui.java,v 1.27 1999/10/17 05:42:37 tp079210 Exp $

package au.edu.swin.synergy.plugin.clientgui;

import java.lang.String;
import au.edu.swin.synergy.kernel.BPlugin;
import au.edu.swin.synergy.kernel.BCommandEvent;
import au.edu.swin.synergy.kernel.BCommandComplete;
import au.edu.swin.synergy.kernel.event.BBootCE;

import au.edu.swin.synergy.plugin.client.event.BNetLoginCE;
import au.edu.swin.synergy.plugin.client.event.BNetLogoutCE;
import au.edu.swin.synergy.plugin.client.event.BLoginCompleteCE;
import au.edu.swin.synergy.plugin.client.event.BLogoutCompleteCE;
import au.edu.swin.synergy.kernel.BKernel;

import au.edu.swin.synergy.plugin.mod13.event.BAddWindowCE;
import au.edu.swin.synergy.plugin.mod13.event.BAddMenuCE;
import au.edu.swin.synergy.plugin.mod13.event.BAddMenuItemCE;
import au.edu.swin.synergy.plugin.command.event.BStandardOutCE;

import javax.swing.JMenuItem;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;

import au.edu.swin.synergy.plugin.server.BNetCredentials;
import au.edu.swin.synergy.plugin.userdb.event.BAuthUserCE;

import au.edu.swin.synergy.plugin.broadcastcli.event.BGetServersCE;
import au.edu.swin.synergy.plugin.broadcastcli.BServerListModel;
import au.edu.swin.synergy.debug.Debug;
import au.edu.swin.synergy.plugin.userdb.BUser;
import au.edu.swin.synergy.plugin.client.event.BGetUserCE;
import au.edu.swin.synergy.plugin.command.event.BRegisterCmdCE;
import au.edu.swin.synergy.plugin.command.BOnCommand;
import au.edu.swin.synergy.lib.BStringList;
import java.io.InputStream;
import java.io.PrintStream;
import au.edu.swin.synergy.plugin.mod13.bwt.BDialog;
import au.edu.swin.synergy.plugin.mod13.bwt.BDialogDone;
import au.edu.swin.synergy.plugin.mod13.event.BAddStatusCE;

import au.edu.swin.synergy.plugin.server.BServer;

import au.edu.swin.synergy.plugin.dialect.BString;
import au.edu.swin.synergy.plugin.dialect.BDialect;
import au.edu.swin.synergy.plugin.dialect.event.BDialectChangeCE;
import javax.swing.ComboBoxModel;
import javax.swing.*;
import java.awt.*;
import au.edu.swin.synergy.plugin.mod13.bwt.BSwingUtilities;

/**
 * Client GUI plugin
 * @Author John Newbigin
 * @Copyright Synergy Software 1999
 * @rref Tristans Book
 */


public class BClientGui extends BPlugin
{
    String hostName = "localhost";
    BLoginDlg dlg = null;
    boolean loggedIn = false;
    
    /**
     * Please complete the missing tags for setup
     * @post
     * @pre
     * @throws
     * @return
     * @param
     */
    
    JMenuItem loginMenuItem = new JMenuItem(  );
    JMenuItem logoutMenuItem = new JMenuItem(  );
    JLabel statusLabel = new JLabel( );

    public void setup(BStringList params)
    {
        // add login menu item
        loginMenuItem.addActionListener( new onLogin() );
        BAddMenuItemCE event = new BAddMenuItemCE( this, new BString( this, "menuName" ));
		event.setPreferredMenuMnemonic(new BString( this, "menuKey" ));
		event.addMenuItem(loginMenuItem, new BString(this, "login") );
        
        // add logout menu item
        logoutMenuItem.addActionListener( new onLogout() );
		logoutMenuItem.setEnabled(false);
        event.addMenuItem( logoutMenuItem, new BString(this, "logout"));
        dispatchEvent( event );


		addLoginStatus();
       
		this.doDialect();
    }

    /**
     * Return a list of plugin dependancies
	 *
     * @return a list of plugins such as "au.edu.swin.synergy.plugin.mod13.BWindowManager"
	 * or null if there are no dependancies
     */

    public BStringList getDependancies()
	{
		BStringList result = new BStringList();
		result.add("au.edu.swin.synergy.plugin.mod13.BWindowManager");
		return result;
	}

    /**
     * Sets the text of the GUI to appropriate values for
     * the current dialect.
     */
    protected void doDialect()
    {
    	BSwingUtilities.setJLabelText(statusLabel, BDialect.getString(this, "notLoggedIn"));
	Object args[] = new Object[]{getShortHostName()};

	if (this.loggedIn)
	{
		BSwingUtilities.setJLabelText(statusLabel, BDialect.getString(this, "loggedInTo", args));
	}
	else
	{
		BSwingUtilities.setJLabelText(statusLabel, BDialect.getString(this, "notLoggedIn"));
	}
    }

	/**
	 * Gets the host name part of the FQDN
	 */
	private String getShortHostName()
	{
		int i = hostName.indexOf('.');
		if(i == -1)
		{
			// there is no domain part
			return hostName;
		}
		else
		{
			// return only the host name
			return hostName.substring(0, i);
		}
	}
	
    /**
     * Please complete the missing tags for onBCommandEvent
     * @post
     * @pre
     * @throws
     * @return
     * @param
     */
	 
  
 
    
    public void onBCommandEvent( Object source, BCommandEvent event )
    {
		if(event instanceof BLoginCompleteCE)
		{
			BLoginCompleteCE loginEvent = (BLoginCompleteCE)event;

			hostName = loginEvent.getHostName();
			loggedIn = true;
			Object args[] = new Object[]{getShortHostName()};
			BSwingUtilities.setJLabelText(statusLabel, BDialect.getString(this, "loggedInTo", args));
			setMenuStatus(false, true);
		}
		else if(event instanceof BLogoutCompleteCE)
		{
			setMenuStatus(true, false);
			//SwingUtilities.invokeLater(new BSetJLabelText(statusLabel, "Not logged in"));
			BSwingUtilities.setJLabelText(statusLabel, BDialect.getString(this, "notLoggedIn"));
		}
		else if (event instanceof BDialectChangeCE)
		{
			this.doDialect();

            //Update the login dialog as well
            if (this.dlg != null)
            {
                this.dlg.doDialect();
            }
		}
    }

    private void addLoginStatus()
    {
        JPanel status = new JPanel();
        BAddStatusCE addStatus = new BAddStatusCE( this, status );
        GridLayout layout = new GridLayout( 1, 0 );

        status.setLayout( layout );

        statusLabel.setVerticalAlignment( SwingConstants.CENTER );
        statusLabel.setHorizontalAlignment( SwingConstants.CENTER );
        status.add( statusLabel );
        status.setToolTipText( "Current login status" );

        dispatchEvent( addStatus );
    }

	private void setMenuStatus(boolean login, boolean logout)
	{
		//SwingUtilities.invokeLater(new BSetJComponentEnabled(loginMenuItem, login));
		BSwingUtilities.setJComponentEnabled(loginMenuItem, login);
		//SwingUtilities.invokeLater(new BSetJComponentEnabled(logoutMenuItem, logout));
		BSwingUtilities.setJComponentEnabled(logoutMenuItem, logout);
	}

    class onLogin implements java.awt.event.ActionListener
    {
        public void actionPerformed( ActionEvent e )
        {
            dlg = new BLoginDlg( BClientGui.this, new BOnClose() );
            BGetServersCE serverEvent = new BGetServersCE( this, new BGetServersCC( dlg ) );
            dispatchEvent( serverEvent );
            
            dlg.show();
            
        }
    }
    
    class BOnClose implements BDialogDone
    {
        public void onClose( BDialog sender, int status )
        {
            if( status == BDialog.kOK )
            {
				hostName = dlg.getHostName();
                BNetLoginCE loginEvent = new BNetLoginCE( this, hostName, BServer.kPortNumber, dlg.getUsername(), dlg.getPassword() );
                loginEvent.setCompletionObject( new BLoginCC() );
                dispatchEvent( loginEvent );
				BSwingUtilities.setJLabelText(statusLabel, "In progress");
				setMenuStatus(false, false);
            }
        }
    }
    
    
    
    class BGetServersCC extends BCommandComplete
    {
        BLoginDlg dlg = null;
        public BGetServersCC( BLoginDlg fDlg )
        {
            dlg = fDlg;
        }
        
        public void doComplete( BCommandEvent event, int status )
        {
            BGetServersCE e = ( BGetServersCE ) event;
            dlg.setServerListModel( e.getServerListModel() );
        }
    }
    
    class BLoginCC extends BCommandComplete
    {
        public void doComplete( BCommandEvent event, int status )
        {
			BNetLoginCE loginEvent = (BNetLoginCE) event;
            if( status == BCommandComplete.kSuccess )
            {

				if(loginEvent.isLoggedIn())
				{
                    Object args[] = new Object[]{getShortHostName()};
					BSwingUtilities.setJLabelText(statusLabel, BDialect.getString(this, "loggedInTo", args));
					setMenuStatus(false, true);
				}
				else
				{
  		            Debug.doPrintln( "Login failed" );
					BSwingUtilities.setJLabelText(statusLabel, BDialect.getString(this, "notLoggedIn"));
                    Object args[] = new Object[]{loginEvent.getMessage()};
                    doMessage(BDialect.getString(this, "loginFail", args), BStandardOutCE.kError);
					setMenuStatus(true, false);
				}
            }
			else
			{
	            Debug.doPrintln( "Login failed" );
				BSwingUtilities.setJLabelText(statusLabel, BDialect.getString(this, "notLoggedIn"));
                Object args[] = new Object[]{loginEvent.getMessage()};
                doMessage(BDialect.getString(this, "loginFail", args), BStandardOutCE.kError);
				setMenuStatus(true, false);
			}
        }
    }

    /**
     * Display a message using standard out
     */
    protected void doMessage(String message, int messageType)
    {
        BStandardOutCE standardOutCE = new BStandardOutCE(this, message, false, messageType, null);
        this.dispatchEvent(standardOutCE);
    }

    class onLogout implements java.awt.event.ActionListener
    {
        public void actionPerformed( ActionEvent e )
        {
            // send a logout
            BNetLogoutCE event = new BNetLogoutCE( this );
            dispatchEvent( event );
			setMenuStatus(true, false);
			//SwingUtilities.invokeLater(new BSetJLabelText(statusLabel, "Not logged in"));
			BSwingUtilities.setJLabelText(statusLabel, "Not logged in");
        }
    }
}

