// $Header: /teamproj/cvsroot/teamb/bkasrc/au/edu/swin/synergy/plugin/clock/BClock.java,v 1.6 1999/10/16 23:11:26 tp079210 Exp $

package au.edu.swin.synergy.plugin.clock;

import java.lang.String;
import au.edu.swin.synergy.kernel.BPlugin;
import au.edu.swin.synergy.kernel.BCommandEvent;
import au.edu.swin.synergy.kernel.event.BBootCE;

import au.edu.swin.synergy.kernel.BKernel;
import au.edu.swin.synergy.plugin.mod13.event.BAddMenuItemCE;
import au.edu.swin.synergy.plugin.mod13.event.BAddWindowCE;
import au.edu.swin.synergy.plugin.mod13.event.BAddStatusCE;
import au.edu.swin.synergy.plugin.mod13.event.BAddPanelCE;
import au.edu.swin.synergy.plugin.mod13.event.BAddMenuCE;
import au.edu.swin.synergy.plugin.mod13.event.BSelectPanelCE;
import au.edu.swin.synergy.plugin.mod13.event.BRemovePanelCE;

import au.edu.swin.synergy.debug.Debug;

import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.awt.FlowLayout;
import java.awt.GridLayout;
import java.awt.Font;

import java.util.Date;
import javax.swing.JLabel;
import java.text.SimpleDateFormat;
import javax.swing.JMenuItem;
import javax.swing.JMenu;
import javax.swing.JPanel;
import javax.swing.SwingConstants;
import au.edu.swin.synergy.lib.BStringList;


/**
 * Sample plugin
 * @Author Tristan, John Newbigin
 * @Copyright Synergy Software 1999
 * @see
 * @concurrency 
 * @rref
 */

public class BClock extends BPlugin
{
    JLabel timeLabel = new JLabel( "Time: xx:xx" );
    
    //SimpleDateFormat dateFormatter = new SimpleDateFormat( "hh:mm:ss" );
    SimpleDateFormat dateFormatter = new SimpleDateFormat( "hh:mm" );
    
    public void setup(BStringList params)
    {
		addClockStatus();
	}

    /**
     * Return a list of plugin dependancies
	 *
     * @return a list of plugins such as "au.edu.swin.synergy.plugin.mod13.BWindowManager"
	 * or null if there are no dependancies
     */

    public BStringList getDependancies()
	{
		BStringList result = new BStringList();
		result.add("au.edu.swin.synergy.plugin.mod13.BWindowManager");
		return result;
	}
    
    public void onBCommandEvent( Object source, BCommandEvent event )
    {
    }
    
    private void addClockStatus()
    {
        JPanel status = new JPanel();
        BAddStatusCE addStatus = new BAddStatusCE( this, status, -1000 );
        GridLayout layout = new GridLayout( 1, 0 );
        
        status.setLayout( layout );

        timeLabel.setVerticalAlignment( SwingConstants.CENTER );
        timeLabel.setHorizontalAlignment( SwingConstants.CENTER );
        status.add( timeLabel );
        status.setToolTipText( "The current time" );

        dispatchEvent( addStatus );

        TimeTest timeThread = new TimeTest();
        timeThread.start();
    }

    class TimeTest extends Thread
    {
        public void run()
        {
            try
            {
                while( true )
                {
                    timeLabel.setText( dateFormatter.format( new Date() ) );
                    
                    //Wait for a second
                    this.join( 1000 );
                }
            }
            catch( InterruptedException ieException )
            {
                ieException.printStackTrace();
            }
        }
    }
}
