/**
 * Please complete these missing tags
 * @see
 * @concurrency
 * @rref
 */
// $Header: /teamproj/cvsroot/teamb/bkasrc/au/edu/swin/synergy/plugin/command/BCommandLine.java,v 1.40 1999/10/16 06:58:11 tp079519 Exp $

package au.edu.swin.synergy.plugin.command;

import java.lang.String;

import au.edu.swin.synergy.kernel.BPlugin;
import au.edu.swin.synergy.kernel.BCommandEvent;
import au.edu.swin.synergy.kernel.BCommandComplete;
import au.edu.swin.synergy.kernel.BBlockingComplete;
import au.edu.swin.synergy.kernel.event.BBootCE;

import au.edu.swin.synergy.plugin.test2.event.BTestCE;
import au.edu.swin.synergy.kernel.BKernel;
import au.edu.swin.synergy.lib.BStringList;
import au.edu.swin.synergy.lib.BSleep;
import au.edu.swin.synergy.debug.Debug;
import au.edu.swin.synergy.debug.Assertion;

import java.util.Hashtable;
import java.util.Enumeration;
import java.util.Set;
import java.util.Iterator;
import au.edu.swin.synergy.plugin.command.event.BRegisterCmdCE;
import au.edu.swin.synergy.plugin.command.event.BUnRegisterCmdCE;
import au.edu.swin.synergy.plugin.command.event.BSetCmdStreamCE;
import au.edu.swin.synergy.plugin.command.event.BStandardOutCE;
import au.edu.swin.synergy.plugin.command.event.BHandleStdOutCE;
import au.edu.swin.synergy.plugin.command.event.BExecuteCommandCE;
import au.edu.swin.synergy.plugin.command.event.BGetEnvironmentCE;
import au.edu.swin.synergy.plugin.command.event.BEnableRemoteCE;

import au.edu.swin.synergy.plugin.server.event.BGetUserCE;
import au.edu.swin.synergy.plugin.userdb.BUser;
import au.edu.swin.synergy.plugin.userdb.BPrivileged;

import au.edu.swin.synergy.lib.BInputReader;


import java.lang.Class;
import java.lang.ClassNotFoundException;
import java.lang.Exception;

import java.io.InputStream;
import java.io.OutputStream;
import java.io.PrintStream;
import java.io.IOException;
import java.io.FileReader;
import java.io.LineNumberReader;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.File;
import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;

import java.lang.Runnable;

/**
 * Command line plugin
 * @Author John Newbigin
 * @Copyright Synergy Software 1999
 */

public class BCommandLine extends BPlugin implements BEnvironment
{
    private PrintStream out = System.out;

    private InputStream in = System.in;
	private OutputStream stdinRedirector = null;
	int lineNumber;

    private boolean run = true;
	private boolean echoPrompt = false;

    private Hashtable commands = new Hashtable();
	private boolean handleStdEvents = true;

	private Hashtable environment = new Hashtable();

	private BStringList history = new BStringList();
	private int historyCount = 0;

	private boolean booted = false;
	private boolean remoteEnabled = false;

    /**
     * Please complete the missing tags for onBCommandEvent
     * @post
     * @pre
     * @throws
     * @return
     * @param
     */

    public void setup(BStringList params)
    {
		// registering commands provided by the command line
        dispatchEvent( new BRegisterCmdCE( this, "quit", new onQuit() ) );
        dispatchEvent( new BRegisterCmdCE( this, "load", new onLoad() ) );
        dispatchEvent( new BRegisterCmdCE( this, "unload", new onUnLoad() ) );
        dispatchEvent( new BRegisterCmdCE( this, "list", new onList() ) );
        dispatchEvent( new BRegisterCmdCE( this, "help", new onHelp() ) );
		dispatchEvent( new BRegisterCmdCE( this, "exec", new onExec() ) );
		dispatchEvent( new BRegisterCmdCE( this, "debug", new onDebug() ) );
		dispatchEvent( new BRegisterCmdCE( this, "set", new onSet() ) );
		dispatchEvent( new BRegisterCmdCE( this, "echo", new onEcho() ) );
		dispatchEvent( new BRegisterCmdCE( this, "history", new onHistory() ) );
		dispatchEvent( new BRegisterCmdCE( this, "sleep", new onSleep() ) );

		setEnvironment("clobber", "off");
		setEnvironment("prompt", "# > ");

		// and parameters are taken as scripts to execute...
		//Debug.doPrintln("count = " + params.getCount());
		for(int i=1; i<params.getCount(); i++)
		{
			Debug.doPrintln("Executing " + params.get(i));
			process( new BStringList("exec " + params.get(i)), in, out );
		}

    }
    /**
     * Please complete the missing tags for onBCommandEvent
     * @param
     * @return
     * @pre
     * @post
     */

    public void onBCommandEvent( Object source, BCommandEvent event )
    {
        if( event instanceof BBootCE )
        {
			booted = true;
            event.doComplete( BCommandComplete.kPending );

            start();
        }
        else if( event instanceof BRegisterCmdCE )
        {
            BRegisterCmdCE e = ( BRegisterCmdCE ) event;

            if( e.getCommand() != null && e.getOnCommand() != null )
            {
                Debug.doPrintln( "registering command " + e.getCommand() );
                commands.put( e.getCommand(), e );
                e.doComplete( BCommandComplete.kSuccess );
            }
            else
            {
                e.doComplete( BCommandComplete.kError );
            }
        }
        else if( event instanceof BUnRegisterCmdCE )
        {
            BUnRegisterCmdCE e = ( BUnRegisterCmdCE ) event;

            if( e.getCommand() != null )
            {
                Debug.doPrintln( "unregistering command " + e.getCommand() );
                commands.remove( e.getCommand() );
                e.doComplete( BCommandComplete.kSuccess );
            }
            else
            {
                e.doComplete( BCommandComplete.kError );
            }
        }
		else if( event instanceof BGetEnvironmentCE )
		{
			BGetEnvironmentCE environmentEvent = (BGetEnvironmentCE) event;
			environmentEvent.setEnvironment(this);
			event.doComplete(BCommandComplete.kSuccess);
		}
        else if( event instanceof BSetCmdStreamCE )
        {
            BSetCmdStreamCE streamEvent = ( BSetCmdStreamCE ) event;
            Debug.doPrintln( "Assigning new IO streams" );
            if(streamEvent.getInputStream() != null)
			{
				InputStream oldInput = in;
				in = streamEvent.getInputStream();

				try
				{
					oldInput.close();
				}
				catch(IOException exception)
				{
					Debug.doPrintln("Error setting new IO streams: " + exception);
				}
			}

            if(streamEvent.getOutputStream() != null)
			{
                out = streamEvent.getOutputStream();
				Debug.setOutputStream(out);
				System.setErr( out );
			}
   		    echoPrompt = streamEvent.getEcho();

            event.doComplete( BCommandComplete.kSuccess );
        }
		else if(event instanceof BExecuteCommandCE)
		{
			// check for admin access
			if(event.getNetworkStatus() == BCommandEvent.kServer)
			{
				if(event.getConnectionID() == -1)
				{
					// on the client, we should not respond...
					//event.doComplete(BCommandComplete.kError);

					// on the server though...!
				}
				else
				{
					// get the user from the connection
					BGetUserCE getUserEvent = new BGetUserCE(this, event.getConnectionID(), null);
					BBlockingComplete complete = dispatchEventAndWait(getUserEvent);
					if(complete.getStatus() == BCommandComplete.kSuccess)
					{
						getUserEvent = (BGetUserCE)complete.getEvent();
						BUser user = getUserEvent.getUser();
						if(user.getPrivilege() == BPrivileged.kAdministrator)
						{
							// Ok to proceed
							Debug.doPrintln("Executing command");

							BExecuteCommandCE executeEvent = (BExecuteCommandCE) event;


							// we need a way to say input == EOF and to store output into a string list...
							InputStream inputStream = new ByteArrayInputStream(new byte[0]);
							OutputStream outputStream = new ByteArrayOutputStream();


							process(executeEvent.getCommand(), inputStream, new PrintStream(outputStream));

							// get the result back
							BStringList results = new BStringList();
							results.assign(outputStream.toString());
							executeEvent.setResult(results, 0);


							event.doComplete(BCommandComplete.kSuccess);
						}
						else
						{
							event.doComplete(BCommandComplete.kError);
						}
					}
					else
					{
						event.doComplete(BCommandComplete.kError);
					}
				}
			}
			else
			{
				event.doComplete(BCommandComplete.kError);
			}


		}
		else if(event instanceof BEnableRemoteCE)
		{
			BEnableRemoteCE enableEvent = (BEnableRemoteCE) event;
			if(enableEvent.getEnableRemote())
			{
				if(!remoteEnabled)
				{
					dispatchEvent( new BRegisterCmdCE( this, "r", new onRemote() ) );
					remoteEnabled = true;
				}
			}
			else
			{
				if(remoteEnabled)
				{
					dispatchEvent( new BUnRegisterCmdCE( this, "r" ));
					remoteEnabled = false;
				}
			}
		}
		else if(event instanceof BHandleStdOutCE)
		{
			BHandleStdOutCE stdEvent = (BHandleStdOutCE) event;
			handleStdEvents = stdEvent.getHandleEvents();
			stdEvent.doComplete(BCommandComplete.kSuccess );

		}
		else if(event instanceof BStandardOutCE)
		{
			if(handleStdEvents)
			{
					BStandardOutCE stdEvent = (BStandardOutCE) event;

					switch(stdEvent.getMessageType())
					{
						case BStandardOutCE.kError:
						{
							out.print("Error: ");
							break;
						}
						case BStandardOutCE.kWarning:
						{
							out.print("Warning: ");
							break;
						}
						case BStandardOutCE.kInfo:
						{
							out.print("Information: ");
							break;
						}
						case BStandardOutCE.kQuestion:
						{
							out.print("Question: ");
							break;
						}
						default:
						{
							Assertion.doAssert(false, "Invalid messageType");
							break;
						}
					}
					out.println(stdEvent.getMessage());

					// do we need to get a responce?
					if(stdEvent.isResponseRequired())
					{
						Assertion.doAssert(stdEvent.getUserResponseOption() == BStandardOutCE.kYesNoCancelOption, "NYI");
						switch(stdEvent.getUserResponseOption())
						{
							case BStandardOutCE.kDefaultOption:
							{
								// this should never happen
								break;
							}
							case BStandardOutCE.kYesNoOption:
							{
								out.print("(Y)es/(N)o :");
								break;
							}
							case BStandardOutCE.kYesNoCancelOption:
							{
								out.print("(Y)es/(N)o/(C)ancel :");
								break;
							}
							case BStandardOutCE.kOkCancelOption:
							{
								out.print("(O)K/(C)ancel :");
								break;
							}
							default:
							{
								Assertion.doAssert(false, "Invalid responseOption");
							}
						}
						// get the input
						// any of "oOyY\n" -> true
						// and of "nNcC<esc>" -> false
						try
						{
							while(true)
							{
								int c = in.read();
								if(c == -1)
								{
									break;
								}
								else if("oOyY\n".indexOf((char)c) != -1)
								{
									stdEvent.setUserResponse(BStandardOutCE.kYes);
								}
								else if("cC\033".indexOf((char)c) != -1)
								{
									stdEvent.setUserResponse(BStandardOutCE.kCancel);
								}
                                else if("nN".indexOf((char)c) != -1)
                                {
                                    stdEvent.setUserResponse(BStandardOutCE.kNo);
                                }
							}
						}
						catch(IOException e)
						{
							// this is possibly bad, but it <i>should</i> never happen
							stdEvent.setUserResponse(BStandardOutCE.kCancel);
						}
				}
				stdEvent.doComplete(BCommandComplete.kSuccess);
			}
		}
    }

	public String getEnvironment(String key)
	{
		synchronized(environment)
		{
			return (String)environment.get(key);
		}
	}

	public void setEnvironment(String key, String value)
	{
		synchronized(environment)
		{
			environment.remove(key);
			environment.put(key, value);
		}
	}

    /**
     * Please complete the missing tags for process
     * @post
     * @pre
     * @throws
     * @return
     * @param
     */

    void process( BStringList cmdLine, InputStream defaultInputStream, PrintStream defaultOutputStream )
    {
		// we need to handle some high level things here....

		// do $var subustution
		for(int i=0; i<cmdLine.getCount(); i++)
		{
			if(cmdLine.get(i).startsWith("$"))
			{
				String variable = cmdLine.get(i).substring(1);
				String value = getEnvironment(variable);
				if(value == null)
				{
					cmdLine.set(i, "");
				}
				else
				{
					cmdLine.set(i, value);
				}
			}
		}

		// look for redirection...
		InputStream inStream = defaultInputStream;
		PrintStream outStream = defaultOutputStream;

		boolean closeInStream = false;
		boolean closeOutStream = false;

		// "<" ">" and ">>"
		try
		{

				int i=0;
				while (i<cmdLine.getCount())
				{
					if(cmdLine.get(i).equals("<"))
					{
						Debug.doPrintln("Redirect input stream");
						cmdLine.remove(i);
						String fileName = cmdLine.get(i);
						cmdLine.remove(i);
						File file = new File(fileName);
						if(file.exists())
						{
							inStream = new FileInputStream(fileName);
							closeInStream = true;
						}
						else
						{
							out.println("Input file does not exist");
							return;
						}
					}
					else if(cmdLine.get(i).equals(">"))
					{
						Debug.doPrintln("Redirect output stream");
						cmdLine.remove(i);
						String fileName = cmdLine.get(i);
						cmdLine.remove(i);
						File file = new File(fileName);

						if(file.exists())
						{
							// see if we can clobber it
							if(getEnvironment("clobber").equals("on"))
							{
								file.delete();
							}
							else
							{
								out.println("Output file exists and clobber is off");
								return;
							}
						}

						outStream = new PrintStream(new FileOutputStream(fileName, false));
						closeOutStream = true;
					}
					else if(cmdLine.get(i).equals(">>"))
					{
						Debug.doPrintln("Redirect output stream (append)");
						cmdLine.remove(i);
						String fileName = cmdLine.get(i);
						cmdLine.remove(i);
						outStream = new PrintStream(new FileOutputStream(fileName, true));
						closeOutStream = true;
					}
					else if(cmdLine.get(i).equals("|"))
					{
						Debug.doPrintln("Pipe output");
						Debug.doPrintln("NYI");
						cmdLine.remove(i);
					}
					i++;
				}

				// remove escapes for < and > chars
				// \> -> >n
				// \< -> <

				for(int esc=0; esc < cmdLine.getCount(); esc++)
				{
					StringBuffer unescaped = new StringBuffer(cmdLine.get(esc));
					int index = 0;
					while(index < unescaped.toString().length())
					{
						if(unescaped.charAt(index) == '\\')
						{
							unescaped.deleteCharAt(index);
						}
						index++;
					}
					cmdLine.set(esc, unescaped.toString());
				}

				if( cmdLine.getCount() > 0 )
				{
					String cmd = cmdLine.get( 0 );

					if(cmd.startsWith("!"))
					{
						runProgram(cmdLine, inStream, outStream);
					}
					else
					{
						BRegisterCmdCE onCommand = ( BRegisterCmdCE ) commands.get( cmd );
						if( onCommand == null )
						{
							defaultOutputStream.println( "Unknown command " + cmd );
							defaultOutputStream.println( "" );
						}
						else
						{
							// we need to allow a way for this to return IO to the command line
							// when the user presses break (^C?)
							setEnvironment("command", cmd);
							int result = onCommand.getOnCommand().onCommand( cmdLine, inStream, outStream );
							setEnvironment("return", "" + result);
						}
					}
				}

				if(closeInStream)
				{
					inStream.close();
				}
				if(closeOutStream)
				{
					outStream.close();
				}
		}
		catch(IOException e)
		{
			out.println(e.getMessage());
		}

    }

	private boolean runProgram(BStringList cmdLine, InputStream inStream, OutputStream outStream)
	{
		// we have to put the parameters into a list...

		// if the last command is an '&' then we should run it in the background...
		String [] cmdarray = new String[cmdLine.getCount()];
		cmdarray[0] = cmdLine.get(0).substring(1);
		for(int j=1; j<cmdLine.getCount(); j++)
		{
			cmdarray[j] = cmdLine.get(j);
		}
		Debug.doPrintln("Executing command");
		try
		{
			Process process = Runtime.getRuntime().exec(cmdarray);
			// we need to create a pump to take stdout and send it to out...
			StreamPump stdout = new StreamPump(process.getInputStream(), outStream);
			StreamPump stderr = new StreamPump(process.getErrorStream(), outStream);
			//StreamPump stdin = new StreamPump(in, process.getOutputStream());
			stdinRedirector = process.getOutputStream();
			
			process.waitFor();
			stdout.close();
			stderr.close();
			//stdin.close();

			stdinRedirector = null;
			return true;
		}
		catch(Exception E)
		{
			Debug.doPrintln("Error running program", E);
			return false;
		}
	}

    /**
     * Please complete the missing tags for start
     * @post
     * @pre
     * @throws
     * @return
     * @param
     */

    private void start()
    {
		while( run )
		{
	        while( run )
	        {
				String prompt = getEnvironment("prompt");
				int i=0;
				while(i < prompt.length())
				{
					char c = prompt.charAt(i);
					if(c == '#')
					{
						out.print("" + lineNumber);
					}
					else
					{
						out.print(c);
					}
					i++;
				}


				out.flush();
	            try
	            {
	                String command = "";
					while(true)
					{
						int c = in.read();
						if(c == '\n')
						{
							lineNumber++;
							break;
						}
						else if(c == '\r')
						{
							// ignore
						}
						else if(c == -1)
						{
							// could have been a ^C.... ?
							throw new IOException("End of stream");
//							Debug.doPrintln("Go back to the prompt!");
//							out.println("EOF");
						}
						else
						{
							command = command + (char)c;
						}
					}

					// here is where we do history...
					if(command.startsWith("!"))
					{
						String location = command.substring(1);
						if(location.equals("!"))
						{
							// do last command
							command = history.get(history.getCount() - 1);
						}
						else
						{
							try
							{
								int index = Integer.parseInt(location);
								if(index < 0)
								{
									// go back i commands
									// remember i is -ve, so we add
									command = history.get(lineNumber + index - 1);
								}
								else
								{
									// execute the i'th command
									command = history.get(index);
								}
							}
							catch(NumberFormatException e)
							{
								// pass this command to the shell....?
							}
						}
					}

					if(echoPrompt)
					{
						out.println(command);
					}

	                process( new BStringList( command ), in, out );

					history.add(command);

					}
	            catch( Exception E )
	            {
	                //Debug.doPrintln( "Error " + E );
					break;
	            }
	        }
		}
        getKernel().doShutdown();
    }

	class StreamPump extends Thread
	{
		InputStream in = null;
		OutputStream out = null;
		
		StreamPump(InputStream fInput, OutputStream fOut)
		{
			in = fInput;
			out = fOut;
			this.start();
		}
		
		public void run()
		{
			try
			{
				while(true)
				{
					int c = in.read();
					if(c == -1)
					{
						Debug.doPrintln("Stream pump done");
						break;
					}
					out.write(c);
				}
			}
			catch(Exception e)
			{
				Debug.doPrintln("Stream pump done");
			}
		}

		public void close()
		{
			try
			{
				in.close();
			}
			catch(Exception e)
			{
			}
		}
	}
	


    class onQuit implements BOnCommand
    {
        public int onCommand( BStringList params, InputStream in, PrintStream out )
        {
            //run = false;
			getKernel().doShutdown();
            return 0;
        }

        public String getHelp( BStringList params )
        {
            return "Quit the current application";
        }
    }

    class onLoad implements BOnCommand
    {
        public int onCommand( BStringList params, InputStream in, PrintStream out )
        {
			if(params.getCount() > 1)
			{
				params.remove(0);
	            BPlugin plugin = getKernel().loadModule( params, booted );
			}
			else
			{
				out.println("Missing required parameter");
			}
            return 0;
        }

        public String getHelp( BStringList params )
        {
            return "Load a bka plugin\n" +
			"Usage: load plugin [parameters]";
        }
    }

    class onUnLoad implements BOnCommand
    {
        public int onCommand( BStringList params, InputStream in, PrintStream out )
        {
			if(params.getCount() > 1)
			{
				for(int i=1; i<params.getCount(); i++)
				{
		            getKernel().unloadModule( params.get(i) );
				}
			}
			else
			{
				out.println("Missing required parameter");
			}
            return 0;
        }

        public String getHelp( BStringList params )
        {
            return "Unload a currently loaded plugin\n" +
			"Usage: unload plugin [plugin...]";
        }
    }

    class onList implements BOnCommand
    {
        public int onCommand( BStringList params, InputStream in, PrintStream out )
        {
            BStringList modules = getKernel().getModuleList();
            for( int i = 0; i < modules.getCount(); i++ )
            {
                out.println( modules.get( i ) );
            }
            return 0;
        }

        public String getHelp( BStringList params )
        {
            return "List the loaded modules";
        }
    }

	/**
	 * execs a file, by running each line...
	 * simply reads a file line by line,
	 * and then calls process on that line.
	 */
	class onExec implements BOnCommand
	{
		public int onCommand( BStringList params, InputStream in, PrintStream out )
        {
			String name = null;

			if ( params.getCount() > 1 )
			{
				name = params.get( 1 );
			}
			else
			{
				Debug.doPrintln( "Exec - wrong number of parameters" );
			}

			try
			{
				FileReader fileReader = new FileReader( name );
				LineNumberReader script = new LineNumberReader( fileReader );

				while( true )
				{
					String line = script.readLine();
					if( line == null )
					{
						break;
					}

					// we need to strip and comment
					int commentStart = line.indexOf( '#' );
					if( commentStart >= 0 )
					{
						line = line.substring( 0, commentStart );
					}
					line = line.trim();

					if( line.length() > 0 )
					{
						//process( createCmdLine(line) );
						process( new BStringList(line), in, out );
					}
				}

			}
			catch( Exception E )
			{
				Debug.doPrintln( "Error executing " + name + ": " + E );
				return -1;
			}



            return 0;
        }

        public String getHelp( BStringList params )
        {
            return "Executes a script file.\nUsage: exec <filename>";
        }
	}

    class onHelp implements BOnCommand
    {
        public int onCommand( BStringList params, InputStream in, PrintStream out )
        {
            if( params.getCount() > 1 )
            {
                String cmd = params.get( 1 );
                BRegisterCmdCE onCommand = ( BRegisterCmdCE ) commands.get( cmd );
                if( onCommand == null )
                {
                    out.println( "Unknown command " + cmd );
                    out.println( "" );
                }
                else
                {
                    out.println( onCommand.getOnCommand().getHelp( params ) );
                }
            }
            else
            {
                out.println( "Available commands" );
                Enumeration e = commands.elements();

                while( e.hasMoreElements() )
                {
                    BRegisterCmdCE event = ( BRegisterCmdCE ) e.nextElement();
                    out.println( event.getCommand() );
                }
            }
            return 0;
        }

        public String getHelp( BStringList params )
        {
            return "You can get help on a particular command by typing\nhelp <command>";
        }
    }


	class onDebug implements BOnCommand
    {
        public int onCommand( BStringList params, InputStream in, PrintStream out )
        {
            if( params.getCount() > 1 )
            {
				if(params.get(1).equalsIgnoreCase("on"))
				{
					Debug.debugLevel = Debug.kPrintLevel;
				}
				else if(params.get(1).equalsIgnoreCase("off"))
				{
					Debug.debugLevel = Debug.kWarningLevel;
				}
				else
				{
					out.println("Unknown option");
				}
            }
            else
            {
				out.println("Missing required parameter");
            }
            return 0;
        }

        public String getHelp( BStringList params )
        {
            return "Turn debug on and off\n" +
			"Usage: debug [on|off]";
        }
    }

	class onSet implements BOnCommand
    {
        public int onCommand( BStringList params, InputStream in, PrintStream out )
        {
			if( params.getCount() == 1)
			{
				Set s = null;
				synchronized(environment)
				{
					s = environment.keySet();
				}

				Iterator i = s.iterator();
				while(i.hasNext())
				{
					String key = (String) i.next();
					out.print(key);
					String value = getEnvironment(key);
					if(value != null)
					{
						out.print(" = " + value);
					}
					out.println("");
				}
			}
			else if( params.getCount() == 2 )
            {
				setEnvironment(params.get(1), "");
			}
			else if( params.getCount() == 4 )
			{
				if(params.get(2).equals("="))
				{
					setEnvironment(params.get(1), params.get(3));
				}
				else
				{
					out.println("Missing required parameter");
				}
			}
            else
            {
				out.println("Missing required parameter");
            }
            return 0;
        }

        public String getHelp( BStringList params )
        {
            return "Set environment variables\n" +
			"Usage: set [key [ = value ] ]";
        }
    }

	class onEcho implements BOnCommand
    {
        public int onCommand( BStringList params, InputStream in, PrintStream out )
        {
			for(int i=1; i<params.getCount(); i++)
			{
				out.print(params.get(i) + " ");
			}
			out.println("");
            return 0;
        }

        public String getHelp( BStringList params )
        {
            return "Echo all expanded parameters";
        }
    }

	class onHistory implements BOnCommand
    {
        public int onCommand( BStringList params, InputStream in, PrintStream out )
        {
			for(int i=1; i<history.getCount(); i++)
			{
				out.println("" + i + " " + history.get(i));
			}
            return 0;
        }

        public String getHelp( BStringList params )
        {
            return "Show the command history";
        }
    }

	class onRemote implements BOnCommand
    {
        public int onCommand( BStringList params, InputStream in, PrintStream out )
        {
			params.remove(0);
			BExecuteCommandCE event = new BExecuteCommandCE(this, params, null);
			BBlockingComplete complete = dispatchEventServerAndWait(event);
			if(complete.getStatus() == BCommandComplete.kSuccess)
			{
				event = (BExecuteCommandCE) complete.getEvent();
				BStringList results = event.getResult();
				for(int i=0; i<results.getCount(); i++)
				{
					out.println(results.get(i));
				}
			}
			else
			{
				out.println("Error executing command");
			}
            return 0;
        }

        public String getHelp( BStringList params )
        {
            return "Execute a command on the server\n" +
				   "Usage: r command [args]";
        }
    }

	class onSleep implements BOnCommand
    {
        public int onCommand( BStringList params, InputStream in, PrintStream out )
        {
			if(params.getCount() == 2)
			{
				long time = Long.parseLong(params.get(1));
				Debug.doPrintln("Sleeping for " + time);
				if(time < 0)
				{
					out.println("Invalid time");
				}
				else
				{
					BSleep.doSleep(time);
				}
			}
			else
			{
				out.println("missing parameter");
			}
            return 0;
        }

        public String getHelp( BStringList params )
        {
            return "Sleep for a specified number of milliseconds\n" +
				   "Usage: sleep milliseconds";
        }
    }
}
