// $Header: /teamproj/cvsroot/teamb/bkasrc/au/edu/swin/synergy/plugin/crypt/BCrypt.java,v 1.4 1999/10/09 14:40:19 tp079519 Exp $

package au.edu.swin.synergy.plugin.crypt;

import java.lang.String;
import au.edu.swin.synergy.kernel.BPlugin;
import au.edu.swin.synergy.kernel.BCommandEvent;
import au.edu.swin.synergy.kernel.event.BBootCE;

import au.edu.swin.synergy.plugin.command.BOnCommand;
import au.edu.swin.synergy.plugin.command.event.BRegisterCmdCE;
import java.io.InputStream;
import java.io.PrintStream;
import java.io.IOException;
import au.edu.swin.synergy.lib.BStringList;
import au.edu.swin.synergy.lib.io.BSaveable;
import au.edu.swin.synergy.lib.io.BDataFile;
import au.edu.swin.synergy.debug.Debug;

/*import is.hi.logir.cryptonite.*;
import is.hi.logir.cryptonite.keys.*;
import is.hi.logir.cryptonite.modes.*;
import is.hi.logir.cryptonite.protocols.*;
import is.hi.logir.cryptonite.io.*;*/

import java.io.OutputStream;
import java.io.InputStream;
import au.edu.swin.synergy.plugin.server.BSessionSetup;
import au.edu.swin.synergy.plugin.server.BStreamSet;
import au.edu.swin.synergy.plugin.server.event.BRegisterFilterCE;

/**
 * Network cryptography plugin
 * @Author John Newbigin
 * @Copyright Synergy Software 1999
 * @see
 * @concurrency The inner class needs some kind of synchronization protection...
 * @rref
 */

public class BCrypt extends BPlugin
{
    
    public void setup(BStringList params)
    {
		BRegisterFilterCE filterEvent = new BRegisterFilterCE(this, new BXOrFilter(), null);
		//BRegisterFilterCE filterEvent = new BRegisterFilterCE(this, new BCryptFilter(), null);
		dispatchEvent(filterEvent);
	}
    
    public void onBCommandEvent( Object source, BCommandEvent event )
    {
    }

/*	class BCryptFilter implements BSessionSetup
	{
		public BStreamSet setStreams(boolean isServer, InputStream inputStream, OutputStream outputStream)
		{
			BStreamSet result = new BStreamSet();
			try
      		{
				CipherKey secret = new DESKey();

        		CipherStream csc = null;
				
        		// insert encryption here....
				if(isServer)
				{
            		Debug.doPrintln("creating encryption server");
	    			csc = makeServerCS(inputStream, outputStream);
				}
				else
				{
            		Debug.doPrintln("creating encryption client");
	    			csc = makeClientCS(inputStream, outputStream);
				}

				result.setInputStream(csc.getInputStream());
				result.setOutputStream(csc.getOutputStream());
	      	}
      		catch(Exception e)
      		{
				Debug.doPrintln("Error istalling crypt filter: " + e);
      		}
			return result;

		}
	
	}
	
    private CipherStreamClient makeClientCS(InputStream inputStream, OutputStream outputStream) throws Exception
    {
                return new CipherStreamClient(inputStream,
                                              outputStream,
                                              new DHKeyExClient(512,"TriDESKey"),
                                              new EncryptOFB(64),
                                              new DecryptOFB(64)
                                             );
        }
    


        private CipherStreamServer makeServerCS(InputStream inputStream, OutputStream outputStream) throws Exception
	{
                return new CipherStreamServer(inputStream,
                                              outputStream,
                                              new DHKeyExServer(512,"TriDESKey"),
                                              new EncryptOFB(64),
                                              new DecryptOFB(64)
                                             );
        }*/

	class XOrInputStream extends InputStream
	{
		InputStream stream;

		XOrInputStream(InputStream fStream)
		{
			stream = fStream;
		}

		public int read() throws IOException
		{
			int c = stream.read();
			return c ^ 0x55;
		}
	}

	class XOrOutputStream extends OutputStream
	{
		OutputStream stream;

		XOrOutputStream(OutputStream fStream)
		{
			stream = fStream;
		}

		public void write(int b) throws IOException
		{
			stream.write(b ^ 0x55);
		}
	}
	class BXOrFilter implements BSessionSetup
	{
		public BStreamSet setStreams(boolean isServer, InputStream inputStream, OutputStream outputStream)
		{
			BStreamSet result = new BStreamSet();
			try
      		{
				result.setInputStream(new XOrInputStream(inputStream));
				result.setOutputStream(new XOrOutputStream(outputStream));
	      	}
      		catch(Exception e)
      		{
				Debug.doPrintln("Error istalling xor filter: ", e);
      		}
			return result;
		}
	}

}
