/**
 *
 * Interface for all diagrams..
 * A diagram is something that can be shown in a viewport.
 * So for instance, you might have a modeller diagram,
 * and a notation builder diagram.
 *
 * @author Imron Alston
 * @copyright team synergy 1999
 */

//$Header: /teamproj/cvsroot/teamb/bkasrc/au/edu/swin/synergy/plugin/diagram/BDiagram.java,v 1.13 1999/10/16 04:39:39 tp079479 Exp $

package au.edu.swin.synergy.plugin.diagram;



import java.util.Vector;



import au.edu.swin.synergy.plugin.diagram.BDrawable;
import au.edu.swin.synergy.math.BScalarRect;
import au.edu.swin.synergy.math.BScalarPoint;


public interface BDiagram
{



    public Vector getPlaceableDrawables();
    public void addDrawable( BDrawable drawable );
	public void createDrawable( String name, BScalarPoint pos );
	public void addVisibleDrawablesToList( Vector visibleList, BScalarRect bounds );

	public BDrawable startAdd( BDrawable drawable, BScalarPoint pos, BDrawable under );
	public boolean continueAdd( BScalarPoint pos, BDrawable under );
	public void dragAdd( BScalarPoint deltaXY, BDrawable under );
	public boolean stopAdd( BScalarPoint pos, BDrawable under, int modifiers );
	public void delete( BDrawable drawable );
	public void bringSelectionToFront( Vector selection );
	public void sendSelectionToBack( Vector selection );

}
