/**
 * Please complete these missing tags
 * @author
 * @copyright
 */


//$Header: /teamproj/cvsroot/teamb/bkasrc/au/edu/swin/synergy/plugin/diagram/BDiagramPlugin.java,v 1.30 1999/10/21 06:31:07 tp079511 Exp $

package au.edu.swin.synergy.plugin.diagram;

import au.edu.swin.synergy.kernel.BPlugin;
import au.edu.swin.synergy.kernel.BCommandEvent;
import au.edu.swin.synergy.kernel.BCommandComplete;
import au.edu.swin.synergy.kernel.event.BBootCE;

import au.edu.swin.synergy.plugin.mod13.event.BAddPanelCE;
import au.edu.swin.synergy.plugin.mod13.event.BRemovePanelCE;
import au.edu.swin.synergy.plugin.mod13.bwt.BWindowAdapter;
import au.edu.swin.synergy.plugin.mod13.bwt.BWindowEvent;

import au.edu.swin.synergy.plugin.prefs.event.BAddPrefsCE;
import au.edu.swin.synergy.plugin.prefs.event.BUpdatePrefsCE;

import au.edu.swin.synergy.plugin.dialect.BString;
import au.edu.swin.synergy.plugin.dialect.event.BDialectChangeCE;

import au.edu.swin.synergy.plugin.diagram.BViewportPrefs;
import au.edu.swin.synergy.plugin.diagram.BDrawablePalette;
import au.edu.swin.synergy.plugin.diagram.event.BRegisterViewportCE;
import au.edu.swin.synergy.plugin.diagram.event.BGetViewportCE;
import au.edu.swin.synergy.lib.BStringList;
import au.edu.swin.synergy.debug.Debug;

import au.edu.swin.synergy.plugin.help.BHelpItem;
import au.edu.swin.synergy.plugin.help.BHelpUtil;
import au.edu.swin.synergy.plugin.help.BHelpTreeModel;
import au.edu.swin.synergy.plugin.help.event.BRegisterHelpCE;

import au.edu.swin.synergy.plugin.editmanager.event.BRegisterUndoCE;

import java.awt.*;
import javax.swing.tree.*;
import java.util.Vector;

public class BDiagramPlugin extends BPlugin
{

    private BDrawablePalette palette = null;
	private Vector viewportList = null;
	BViewportPrefs vpPrefs = null;

	/**
	* Initial and current attributes for every viewport.
	*/
	boolean rulerEnabled;
	boolean gridEnabled;
	boolean snapEnabled;
	Color rulerColour;
	Color gridColour;
    Color backColour;
	int minSpacing;
	int majSpacing;
	int gridType;

	private BViewport selectedViewport;

    /**
     * Please complete the missing tags for setup
     * @param
     * @return
     * @pre
     * @post
     */

    public void setup(BStringList params)
    {
        BAddPanelCE addCE = null;
        BAddPrefsCE addPrefs = null;

		this.viewportList = new Vector();
		initViewport ();

        this.palette = new BDrawablePalette();
		this.palette.setSize( 68, 68);
		addCE = new BAddPanelCE( this, this.palette, new BString(this, "ToolPalette"), BAddPanelCE.kRight, false );
		addCE.setStepSize(37);					
		this.dispatchEvent( addCE );

		

		vpPrefs = new BViewportPrefs ();
		initVpPrefs ();
		addPrefs = new BAddPrefsCE ( this, vpPrefs, new BString ( this, "Viewport" ), new BString ( this, "ToolTip" ) );
		addPrefs.addWindowListener ( new prefsListener () );
		this.dispatchEvent ( addPrefs );
    }

	public void registerHelp ()
	{
		try
		{
			BHelpTreeModel tree = new BHelpTreeModel ( "Modeller" );
			String path = "/au/edu/swin/synergy/plugin/diagram/help/";

			BHelpItem m = new BHelpItem ( "Modeller", path + "modeller.html" );

			DefaultMutableTreeNode displayOptions;
			BHelpItem dOpts = new BHelpItem ( "Display Options", path + "displayopt.html" );
			BHelpItem g = new BHelpItem ( "Grid", path + "grid.html" );
			BHelpItem p = new BHelpItem ( "Panning", path + "panning.html" );
			BHelpItem sp = new BHelpItem ( "Split Pane", path + "splitpane.html" );
			BHelpItem z = new BHelpItem ( "Zooming", path + "zooming.html" );

			BHelpItem dObj = new BHelpItem ( "Drawing Objects", path + "drawingobj.html" );
			BHelpItem op = new BHelpItem ( "Object Properties", path + "objprop.html" );
			BHelpItem so = new BHelpItem ( "Selecting Objects", path + "selectobj.html" );
			
			tree.addHelpItem ( null, m );

			displayOptions = tree.addBranch ( null, "Display Options" );
			tree.addHelpItem ( displayOptions, dOpts ); 
			tree.addHelpItem ( displayOptions, g ); 
			tree.addHelpItem ( displayOptions, p ); 
			tree.addHelpItem ( displayOptions, sp ); 
			tree.addHelpItem ( displayOptions, z ); 

			tree.addHelpItem ( null, dObj );
			tree.addHelpItem ( null, op );
			tree.addHelpItem ( null, so );

			BRegisterHelpCE event = new BRegisterHelpCE ( this, tree );
			dispatchEvent ( event );
		}
		catch ( Exception e )
		{
			e.printStackTrace ();
		}		

	}

    /**
     * Return a list of plugin dependancies
	 *
     * @return a list of plugins such as "au.edu.swin.synergy.plugin.mod13.BWindowManager"
	 * or null if there are no dependancies
     */

    public BStringList getDependancies()
	{
		BStringList result = new BStringList();
		result.add("au.edu.swin.synergy.plugin.mod13.BWindowManager");
		return result;
	}

	public void doOnBRegisterViewportCE( BRegisterViewportCE event )
	{
		BViewport view = event.getBViewport();
		view.setDiagramPlugin(this);
		int index = this.viewportList.indexOf( view );
		boolean regView = event.isRegister ();
		BAddPanelCE addCE = null;
		BRemovePanelCE removeCE = null;

		//if the viewport doesn't exist, then must be registering it
		if ( index < 0 )
		{
			if ( regView )
			{
				
				Debug.doPrintln ( "Adding viewport to update list" );
				this.viewportList.add( view );

				
			}

			view.setDrawablePalette( this.palette );
			doUpdateViewport( view );
		}
		else //otherwise, unregister it..
		{
			this.viewportList.removeElementAt( index );
		}
	}

    /**
     * Please complete the missing tags for onBCommandEvent
     * @param
     * @return
     * @pre
     * @post
     */

	/**
	* Initialise viewport attributes, so when get events are recieved for this data
	* corrent data may be returned.  Keeps data centralised and makes sure all viewports
	* have the same state.
	* Here, at the moment, using default values, this should be changed to reading values
	* from file.
	*
	* @author Christian Karolos
	* @date 20/9/99
	*/
	private void initViewport ()
	{
		rulerEnabled = true;
		gridEnabled = true;
		snapEnabled = false;
		gridType = BViewportPrefs.kLines;
		rulerColour = Color.black;
		gridColour = Color.blue;
        backColour = Color.lightGray;
		minSpacing = 1;
		majSpacing = 5;

	}

	private void initVpPrefs ()
	{
		vpPrefs.setRulerCheck ( rulerEnabled );
		vpPrefs.setGridCheck ( gridEnabled );
		vpPrefs.setRulerColour ( rulerColour );
		vpPrefs.setGridColour ( gridColour );
        vpPrefs.setBackColour ( backColour );
		vpPrefs.setMinVal ( minSpacing );
		vpPrefs.setMajVal ( majSpacing );
		vpPrefs.setSnap ( snapEnabled );
		vpPrefs.setGridType ( gridType );
	}

	public void doUpdateViewports()
	{
		Debug.doPrintln ( "updating all viewport prefs." );
		BViewport curViewport = null;

		int i, size;

		// Update our attributes.
		rulerEnabled = vpPrefs.isRulerEnabled ();
		gridEnabled = vpPrefs.isGridEnabled ();
		snapEnabled = vpPrefs.isSnapEnabled ();
		rulerColour = vpPrefs.getRulerColour ();
		gridColour = vpPrefs.getGridColour ();
		minSpacing = vpPrefs.getMinVal ();
		majSpacing = vpPrefs.getMajVal ();
		gridType = vpPrefs.getGridType ();
        backColour = vpPrefs.getBackColour ();

		size = this.viewportList.size();

		for ( i = 0; i < size; i++ )
		{
			curViewport = (BViewport)this.viewportList.elementAt( i );
			doUpdateViewport( curViewport );


		}

	}

	private void doUpdateViewport( BViewport curViewport )
	{
		curViewport.enableRuler ( rulerEnabled );
		curViewport.enableGrid ( gridEnabled );
		curViewport.enableSnap ( snapEnabled );
		curViewport.setGridType ( gridType );
		curViewport.setMinorRulerSpace ( minSpacing );
		curViewport.setMajorRulerSpace ( majSpacing );
		curViewport.setGridColour ( gridColour );
		curViewport.setRulerColour ( rulerColour );
        curViewport.setBackground ( backColour );
		curViewport.repaint ();
	}



    public void onBCommandEvent( Object source, BCommandEvent event )
    {
		if ( event instanceof BRegisterViewportCE )
		{
			Debug.doPrintln("setting the palette!!");
			doOnBRegisterViewportCE( (BRegisterViewportCE)event );
		}
		else if ( event instanceof BBootCE )
		{
			registerHelp ();
		}
		else if ( event instanceof BUpdatePrefsCE )
		{
			doUpdateViewports( );
		}
		else if ( event instanceof BDialectChangeCE )
		{
			vpPrefs.doDialect ();
		}
		else if ( event instanceof BGetViewportCE )
		{
		 	BGetViewportCE viewportEvent = (BGetViewportCE) event;
/*			if(viewportList.size() > 0)
			{
				viewportEvent.setViewport((BViewport) viewportList.get(0));
			}*/
			viewportEvent.setViewport(selectedViewport);
			viewportEvent.doComplete(BCommandComplete.kSuccess);
		}
    }

	private class prefsListener extends BWindowAdapter
	{
		public void windowOpened ( BWindowEvent e )
		{
/*			if (nodeEditor != null)
			{
				veiwportPrefs.setRulerCheck ( nodeEditor.isRulerEnabled () );
				veiwportPrefs.setGridCheck ( nodeEditor.isGridEnabled () );
				veiwportPrefs.setMinVal ( Integer.toString ( nodeEditor.getMinorRulerSpace () ) );
				veiwportPrefs.setMajVal ( Integer.toString ( nodeEditor.getMajorRulerSpace () ) );
				veiwportPrefs.setGridColour ( nodeEditor.getGridColour () );
			}*/
		}
	}

	public void setSelectedViewport(BViewport fViewport)
	{
		selectedViewport = fViewport;
	}
}

