/**
 * BDrawableButton - a class that overides the jtogglebutton
 * and draws the image on the buttons itself...
 * also stores a BDrawable with it, so when people click
 * it, they know what BDrawable it represents..
 *
 * @author Imron Alston
 * @copyright team synergy 1999
 */
//$Header: /teamproj/cvsroot/teamb/bkasrc/au/edu/swin/synergy/plugin/diagram/BDrawableButton.java,v 1.9 1999/10/15 05:06:01 tp079479 Exp $

package au.edu.swin.synergy.plugin.diagram;

import javax.swing.*;
import java.awt.*;


import au.edu.swin.synergy.plugin.diagram.BDrawable;
import au.edu.swin.synergy.math.BScalar;
import au.edu.swin.synergy.math.BScalarRect;
import au.edu.swin.synergy.math.BScalarPoint;

import au.edu.swin.synergy.debug.Debug;

public class BDrawableButton extends JToggleButton
{
	
	public static final int kPreferredWidth = 30;
	public static final int kPreferredHeight = 30;
	public static final Dimension kPreferredSize = new Dimension( kPreferredWidth, kPreferredHeight );
	public static final BScalarPoint halfWH = new BScalarPoint( kPreferredWidth >> 1, kPreferredHeight >> 1);

    protected BDrawable drawable = null;

	


	public BDrawableButton()
	{
		super();
		this.setFocusPainted( false );

	
	}

    /**
     * Please complete the missing tags for getDrawable
     * @param
     * @return
     * @pre
     * @post
     */
    
    public BDrawable getDrawable()
    {
        return this.drawable;
    }
    /**
     * Please complete the missing tags for setDrawable
     * @param
     * @return
     * @pre
     * @post
     */
    
    public void setDrawable( BDrawable drawable )
    {
        this.drawable = drawable;
        
        if( drawable != null )
        {
//            this.setText( drawable.getName() );
            this.setToolTipText( drawable.getName() );
			this.setIcon( drawable );
        }
    }
    
    /**
     * Sets the drawable to null..
     *
     * Please complete the missing tags for cleanup
     * @param
     * @return
     * @pre
     * @post
     */
    public void cleanup()
    {
        this.drawable = null;
    }


}