
/**
 * Class for the sizer graphic..
 *
 */

package au.edu.swin.synergy.plugin.diagram;

import java.awt.*;

public class BSizer
{
	public static final int kSizerHalfW = 3;
	public static final int kSizerHalfH = 3;
	public static final int kSizerW = kSizerHalfW * 2;
	public static final int kSizerH = kSizerHalfH * 2;
	public static final Color kSizerColour = Color.green;

	private int x1, y1, x2, y2;


	public BSizer()
	{
		this.setVals( 0, 0, 0, 0 );
	}

	public BSizer( int x1, int y1, int x2, int y2 )
	{
		this.setVals( x1, y2, x2, y2 );
	}

	public final void setVals( int x1, int y1, int x2, int y2 )
	{
		this.x1 = x1;
		this.x2 = x2;
		this.y1 = y1;
		this.y2 = y2;
	}

	public final void setPos( int x1, int y1 )
	{
		this.x1 = x1 - kSizerHalfW;
		this.y1 = y1 - kSizerHalfH;
		this.x2 = x1 + kSizerHalfW;
		this.y2 = y1 + kSizerHalfH;

	}

	public final boolean contains( Point pt )
	{
		return ( pt.x > x1 && pt.x < x2 && pt.y > y1 && pt.y < y2 );
	}

	public final void render( Graphics2D g2 )
	{
		g2.fillRect( x1, y1, kSizerW, kSizerH );
	}

}