
/**
 * class BViewWindowFactory
 *
 * creates and free BViewWindows
 */

package au.edu.swin.synergy.plugin.diagram;

import au.edu.swin.synergy.plugin.diagram.BViewWindow;
import au.edu.swin.synergy.debug.Debug;


import java.util.LinkedList;



public class BViewWindowFactory
{
	private static LinkedList windowList = new LinkedList();

	public static BViewWindow getBViewWindow()
	{
		BViewWindow result = null;

		synchronized ( windowList )
		{
			if ( windowList.size() > 0 )
			{
				Debug.doPrintln("Getting BViewWindow from free list");
				result = (BViewWindow)windowList.removeFirst();
			}
			else
			{
				Debug.doPrintln("Allocating new BViewWindow");
				result = new BViewWindow();

			}
		}

		result.init();
		return result;
	}

	public static void releaseBViewWindow( BViewWindow bvWindow )
	{
		if (bvWindow == null ) return;
		synchronized ( windowList )
		{
			Debug.doPrintln("Putting BViewWindow on the free list");
			windowList.addFirst( bvWindow );
		}
	}

}