// $Header: /teamproj/cvsroot/teamb/bkasrc/au/edu/swin/synergy/plugin/diagram/BViewport.java,v 1.108 1999/10/17 23:03:04 tp079568 Exp $
/**
 * Please complete these missing tags
 * @author
 * @copyright
 */


package au.edu.swin.synergy.plugin.diagram;

import java.awt.*;
import java.awt.geom.*;
import java.awt.event.*;
import javax.swing.*;
import java.util.Hashtable;
import java.io.IOException;
import java.awt.datatransfer.Clipboard;
import java.awt.datatransfer.ClipboardOwner;
import java.awt.datatransfer.Transferable;
import java.awt.datatransfer.DataFlavor;
import java.awt.datatransfer.UnsupportedFlavorException;

import java.util.Vector;
import java.awt.event.MouseEvent;
import javax.swing.JPanel;
import javax.swing.event.MouseInputListener;
import java.lang.Math;
import java.lang.Integer;
import java.lang.Thread;
import javax.swing.undo.*;
import java.awt.print.*;

import au.edu.swin.synergy.plugin.diagram.BDiagram;
import au.edu.swin.synergy.plugin.diagram.BGrid;
import au.edu.swin.synergy.plugin.diagram.BRuler;
import au.edu.swin.synergy.plugin.diagram.BDrawablePalette;
import au.edu.swin.synergy.plugin.diagram.BViewportPrefs;
import au.edu.swin.synergy.plugin.diagram.BViewWindow;
import au.edu.swin.synergy.shapes.BPropPanel;
import au.edu.swin.synergy.debug.Debug;
import au.edu.swin.synergy.math.BScalar;
import au.edu.swin.synergy.math.BScalarRect;
import au.edu.swin.synergy.math.BScalarPoint;
//import au.edu.swin.synergy.shapes.BPrimitive;
import au.edu.swin.synergy.shapes.BRectangle;
import au.edu.swin.synergy.kernel.BPlugin;
import au.edu.swin.synergy.plugin.mod13.event.BAddWindowCE;
import au.edu.swin.synergy.plugin.editmanager.BTransferable;
import au.edu.swin.synergy.plugin.editmanager.BUndoManager;
import au.edu.swin.synergy.plugin.dialect.BDialect;
import au.edu.swin.synergy.plugin.dialect.BString;
import au.edu.swin.synergy.lib.BSplitable;
import au.edu.swin.synergy.plugin.modeller.event.BSelectionListener;
import au.edu.swin.synergy.plugin.modeller.event.BSelectionEvent;
import au.edu.swin.synergy.plugin.dialect.BString;
import au.edu.swin.synergy.plugin.dialect.BDialect;
import au.edu.swin.synergy.plugin.command.event.BStandardOutCE;




public class BViewport extends JPanel implements MouseInputListener, BView, BSplitable, Printable
{
	private static final BScalar kMinDepth = new BScalar( 0.025f );
	private static final BScalar kMaxDepth = new BScalar( 2.0f );
    private static final float kDefaultDepth = 0.125f;

	private static final int kVoidState = 0;
	private static final int kMoveState = 1;
	private static final int kResizeState = 2;
	private static final int kAddingState = 3;
	private static final int kScrollState = 4;
	private static final int kDragBoxState = 5;
	private static final int kZoomState = 6;
    private static final int kPopupState = 7;

	public static final int kExclusiveSelect = 1;
	public static final int kAdditiveSelect = 2;

	private static final String kDelCommand = "delete";
    private static final String kCutCommand = "cut";
    private static final String kCopyCommand = "copy";
    private static final String kPasteCommand = "paste";
	private static final String kZoomInCommand = "zoomin";
	private static final String kZoomOutCommand = "zoomout";

    public final int kAdded = 0;
    public final int kRemoved = 1;
	public final int kMoved = 2;
	public final int kResized = 3;

	private static final int kExclusiveSelectMask = MouseEvent.BUTTON1_MASK;
	private static final int kAdditiveSelectMask = (MouseEvent.BUTTON1_MASK | MouseEvent.CTRL_MASK);
	private static final int kDragMask = MouseEvent.BUTTON1_MASK;
	private static final int kScrollMask = MouseEvent.BUTTON3_MASK | MouseEvent.SHIFT_MASK;
    private static final int kPopupMask = MouseEvent.BUTTON3_MASK;
	private static final int kZoomMask = (MouseEvent.BUTTON3_MASK | MouseEvent.CTRL_MASK);
	private static final int kAddDrawableMask = MouseEvent.BUTTON1_MASK;
	private static final int kStickyButtonMask = kAddDrawableMask | MouseEvent.SHIFT_MASK;
	private static final int kProportionalSize = MouseEvent.CTRL_MASK;
	


	private static final int kMinorLineLen = 4;
	private static final int kMajorLineLen = 12;

    private BPlugin parent = null;
    private BDiagramPlugin diagramPlugin = null;
    private BDiagram diagram = null;
    private BDrawablePalette drawablePalette = null;

    private Vector visibleDrawables = null;
	private Vector selection = null;

	private int curState = BViewport.kVoidState;
	private Point oldPoint = null;

	private BDrawable newDrawable = null;
	private BDrawable prevHit = null;
	private BDrawable resizeDrawable = null;
	private int resizeSizer = BDrawable.kNotHit;
	private boolean moved = false;

	private BRectangle dragBounds = null;

	private BScalar z = null;
	private BScalar ooz = null;
	private BScalarPoint halfWH = null;
	private BScalarRect viewCoords = null;
	private BScalarRect viewBounds = null;
	private BScalarPoint xFormPoint = null;
	private BScalar zInc = null;
	private BScalarPoint origin = null;
	private BScalarPoint deltaWH = null;
	private BScalarPoint deltaXY = null;

	private int oldHValue;
	private int oldVValue;

	private int minorRulerSpacing;
	private int majorRulerSpacing;
	private BasicStroke rulerStroke;
	private Color rulerColour;
	private Font rulerFont;
	private int initFontSize;

	private Color gridColour;
	private BasicStroke gridStroke = null;
	private boolean rulerOn;
	private boolean gridOn;
	private boolean dragging = false;
	private boolean snapToGrid = true;

	private BGrid grid = null;
	private BRuler ruler = null;

    /** Temp stuff used when rendering rulers **/
    private FontMetrics fm;
    private int avgStrLen;
    private int avgStrHeight;
    private float majDist;
    private int textXInterval;
    private int textYInterval;

	private int frameCounter = 0;

    private JPopupMenu popup = null;
    private JMenuItem propPopupItem = null;
	private JMenuItem sendPopupItem = null;
	private JMenuItem bringPopupItem = null;
    private BPropPanel currPropPanel = null;
	private BViewActionListener keyListener = null;

    private Hashtable editSupporters = new Hashtable();
    private Hashtable undoManagers = new Hashtable();
    private UndoableEditSupport editSupport = null;
    private BUndoManager undoManager = null;


	private Vector listeners = null;

	private boolean firstSetBounds = true;
	private BScalarPoint firstScroll = null;


	private BScalarPoint moveDelta = null;

	private BDrawable curAdd = null;
	private int sizerNum = BDrawable.kNotHit;


    /**
     * Please complete the missing tags for BViewport
     * @param
     * @return
     * @pre
     * @post
     */


    public BViewport( BPlugin par )
    {
        super( true );

		

		float dash [] = {2.0f};

		this.keyListener = new BViewActionListener();

		Debug.doPrintln(par.getClass().getName());

        this.parent = par;

        this.addMouseMotionListener( this );
        this.addMouseListener( this );


		this.selection = new Vector();
        this.visibleDrawables = new Vector();

		this.dragBounds = new BRectangle();
		this.dragBounds.setOutlineColour( Color.blue );
		this.dragBounds.setDoFill( false );
		this.dragBounds.setStroke( new BasicStroke( 1.0f, BasicStroke.CAP_BUTT, BasicStroke.JOIN_BEVEL,
								  0.0f, dash, 0.0f ) );


		this.z = new BScalar( kDefaultDepth );

		this.ooz = new BScalar( 1 );
		this.ooz.reciprocal( this.z );

		this.viewCoords = new BScalarRect();
		this.viewBounds = new BScalarRect();

		this.xFormPoint = new BScalarPoint();
		this.zInc = new BScalar( 0.05f );
		this.origin = new BScalarPoint( 0, 0 );
		this.halfWH = new BScalarPoint( 0, 0 );
		this.deltaWH = new BScalarPoint(0, 0);
		this.deltaXY = new BScalarPoint(0, 0);
		this.moveDelta = new BScalarPoint( 0, 0 );

		this.gridStroke = new BasicStroke( 0.0f );
		rulerStroke = new BasicStroke ( 1 );

		this.grid = new BGrid( this );
		this.ruler = new BRuler ( this );

		this.listeners = new Vector();

		this.firstScroll = new BScalarPoint();

        initPopup ();


        //Register the keyboard commands
		this.registerKeyboardAction( this.keyListener, kDelCommand, KeyStroke.getKeyStroke( KeyEvent.VK_DELETE, 0 ), WHEN_FOCUSED );
        this.registerKeyboardAction( this.keyListener, kCutCommand, KeyStroke.getKeyStroke( KeyEvent.VK_X, InputEvent.CTRL_MASK ), WHEN_FOCUSED);
        this.registerKeyboardAction( this.keyListener, kCopyCommand, KeyStroke.getKeyStroke( KeyEvent.VK_C, InputEvent.CTRL_MASK ), WHEN_FOCUSED );
        this.registerKeyboardAction( this.keyListener, kPasteCommand, KeyStroke.getKeyStroke( KeyEvent.VK_V, InputEvent.CTRL_MASK ), WHEN_FOCUSED );
		this.registerKeyboardAction( this.keyListener, kZoomInCommand, KeyStroke.getKeyStroke( KeyEvent.VK_EQUALS, InputEvent.CTRL_MASK ), WHEN_FOCUSED );
		this.registerKeyboardAction( this.keyListener, kZoomOutCommand, KeyStroke.getKeyStroke( KeyEvent.VK_MINUS, InputEvent.CTRL_MASK ), WHEN_FOCUSED );
    }

    public void initPopup ()
    {
		
		popup = new JPopupMenu ();

        propPopupItem = new JMenuItem ( BDialect.getString ( this, "properties" ) );
        propPopupItem.addActionListener ( new onProperties () );
		popup.add ( propPopupItem );

		sendPopupItem = new JMenuItem( BDialect.getString( this, "sendback") );
		sendPopupItem.addActionListener ( new onProperties () );
		popup.add ( sendPopupItem );

		bringPopupItem = new JMenuItem( BDialect.getString( this, "bringfront") );
		bringPopupItem.addActionListener ( new onProperties () );
		popup.add ( bringPopupItem );
        
    }

	public void refreshPalette()
	{
		
		if( this.drawablePalette != null && this.diagram != null )
        {
            this.drawablePalette.setDrawables( this.diagram.getPlaceableDrawables() );
        }
		else
		{
			if ( this.drawablePalette == null )
			{
				Debug.doPrintln("Refreshing the palette and drawablePalette is null");
			}
			else
			{
				Debug.doPrintln("Refreshing the palette and drawablePalette isn't null");
			}

			if ( this.diagram == null )
			{
				Debug.doPrintln("the diagram is null");
			}
		}
	}

	public void disablePalette()
	{
		
		if ( this.drawablePalette != null )
		{
			this.drawablePalette.setDisabled( true );
		}
	}

	public void dontScrollOnInit()
	{
		
		this.firstSetBounds = false;
	}

	public void setBounds( int x, int y, int w, int h )
    {
		super.setBounds( x, y, w, h );

		

		this.deltaWH.setLocation( w, h );
		this.deltaWH.decWH( this.viewCoords );

		this.deltaWH.half();

		this.halfWH.incXY( this.deltaWH );

		this.deltaWH.scale( this.z );

		this.viewCoords.incXY( this.deltaWH );

		this.viewCoords.setSize( w, h );

		if ( this.firstSetBounds )
		{
			this.firstSetBounds = false;
			this.startScroll();
			this.firstScroll.setLocation( this.halfWH );
			this.firstScroll.scale( this.z );

//			Debug.doPrintln("About to scroll by " + this.firstScroll );

			this.scroll(this.firstScroll);
			this.curState = kVoidState;
		}
    }

    /**
     * Please complete the missing tags for setDiagram
     * @param
     * @return
     * @pre
     * @post
     */

    public void setDiagram( BDiagram diagram )
    {
		
        this.diagram = diagram;

        if( this.drawablePalette != null )
        {
            this.drawablePalette.setDrawables( this.diagram.getPlaceableDrawables() );
        }

		repaint();
    }

	 /**
	  * Returns the diagram the viewport contains
	  *
	  * @return the diagram contained in this viewport
	  */
	 public BDiagram getDiagram()
	 {	
		
		 return this.diagram;
	 }
	 
    /**
     * Please complete the missing tags for setDrawablePalette
     * @param
     * @return
     * @pre
     * @post
     */

    public void setDrawablePalette( BDrawablePalette drawablePalette )
    {
		
        this.drawablePalette = drawablePalette;

        if( this.diagram != null )
        {
            this.drawablePalette.setDrawables( this.diagram.getPlaceableDrawables() );
        }

		repaint();
    }
    

	public void setGridType ( int type )
	{
		
		if ( type == BViewportPrefs.kDotted )
		{
			this.grid.setDots ( true );
		}
		else if ( type == BViewportPrefs.kLines )
		{
			this.grid.setDots ( false );
		}
	}

	/**
	 * print to the graphics context...
	 * currently ignore the pageIndex...i.e. always print the same page..
	 * turns off the grids/rulers for printing...
	 */
	public int print(Graphics graphics, PageFormat pageFormat, int pageIndex) throws PrinterException
	{
		
		boolean oldGrid, oldRule;

		Debug.doPrintln("Printing a viewport page " + pageIndex);

		if(pageIndex > 0)
		{
			return Printable.NO_SUCH_PAGE;
		}
		else
		{

			//turn off the rulers/grids just for printing...
			oldGrid = gridOn;
			oldRule = rulerOn;
	
			gridOn = false;
			rulerOn = false;
	
			//paint the graphics...
			render( graphics );
	
			//restore the state of the rulers/grids...
			gridOn = oldGrid;
			rulerOn = oldRule;
	
			return Printable.PAGE_EXISTS;
		}
	}


	public void repaint()
	{
		BViewWindow viewWindow = null;

		
		if ( this.getParent() instanceof BViewWindow )
		{
			viewWindow = (BViewWindow)this.getParent();
			viewWindow.updateViewports();
		}
		try
		{
			Thread.sleep(1);
		}
		catch(Exception e )
		{
		}
		super.repaint();
	}

	public void specialRepaint()
	{
		super.repaint();
	}

	/**
     * Please complete the missing tags for paintComponent
     * @param
     * @return
     * @pre
     * @post
     */
    public void paintComponent( Graphics g )
    {
		
        super.paintComponent( g );
		render( g );
    }


	public void render( Graphics g )
	{
		
		Graphics2D g2 = ( Graphics2D ) g;
		BDrawable cur = null;
		int i, size;

		if( this.diagram == null ) return;		

		this.viewBounds.setBounds( 0, 0, 0, 0 );
		this.viewBounds.decXY( this.halfWH );
		this.viewBounds.incWH( this.halfWH );
		this.viewBounds.incWH( this.halfWH );
		this.viewBounds.scale( this.z );
		this.viewBounds.incXY( this.viewCoords );

		this.visibleDrawables.clear();

		this.diagram.addVisibleDrawablesToList( this.visibleDrawables, this.viewBounds);
		size = visibleDrawables.size();

		if ( this.gridOn )
		{
//			this.drawGrid( g );
			this.grid.render( g2, minorRulerSpacing, majorRulerSpacing);
		}

		//transform all the visible drawables to viewcoords..
		for ( i = 0; i < size; i++ )
		{
			cur = (BDrawable)visibleDrawables.elementAt( i );
			cur.transform( this, this.origin, this.frameCounter );
		}

		//render all the visible drawables to the screen...
		for ( i = 0; i < size; i++ )
		{
			cur = (BDrawable)visibleDrawables.elementAt( i );
			cur.render( (Graphics2D)g );
		}

		// Render this last so it is always on top.
		if ( this.rulerOn )
		{
			this.drawRuler ( g );
//			this.ruler.render ( g2, minorRulerSpacing, majorRulerSpacing );
		}

		//render the drag box if necessary
		if ( this.curState == kDragBoxState )
		{
//			Debug.doPrintln("Rendering the dragBox");
			this.dragBounds.transform( this, this.origin, this.frameCounter );
			this.dragBounds.render( (Graphics2D) g );
//			Thread.dumpStack();
		}

		this.frameCounter++;
	}


    /**
     * Please complete the missing tags for mouseClicked
     * @param
     * @return
     * @pre
     * @post
     */


	public void backTransformPoint( BScalarPoint pt )
	{
		
		pt.decXY( this.halfWH );
		pt.scale( this.z );
		pt.incXY( this.viewCoords );
	}


    public void mouseClicked( MouseEvent e )
    {
    }
    /**
     * Please complete the missing tags for mouseEntered
     * @param
     * @return
     * @pre
     * @post
     */

    public void mouseEntered( MouseEvent e )
    {
		this.specialRepaint();
    }
    /**
     * Please complete the missing tags for mouseExited
     * @param
     * @return
     * @pre
     * @post
     */

    public void mouseExited( MouseEvent e )
    {
    }
    /**
     * Please complete the missing tags for mousePressed
     * @param
     * @return
     * @pre
     * @post
     */

    public void mousePressed( MouseEvent e )
    {

		
		BDrawable d = this.drawablePalette.getSelectedDrawable();
		int hitResult = BDrawable.kNotHit;
		Point pt = null;
		int modifiers = e.getModifiers();

		if ( !this.hasFocus() )
		{
			this.requestFocus();
		}

		if ( diagramPlugin != null)
		{
			diagramPlugin.setSelectedViewport(this);
		}

		pt = e.getPoint();

		this.xFormPoint.setLocation( pt );
		this.backTransformPoint( this.xFormPoint );

		
		//if the toolbar isn't the pointer, then add a new drawable..
		if ( d != null )
		{
			switch ( modifiers )
			{
				case kStickyButtonMask:
				case kAddDrawableMask:
					if( this.curState == kVoidState )
					{
						this.startAdd( d, pt);
					}
					else if ( this.curState == kAddingState && e.getClickCount() < 2 )
					{
						this.continueAdd( pt);
					}
					break;
				case kScrollMask:
					this.startScroll();
					break;
				case kZoomMask:
					this.startZoom();
					break;

			}
		}
		else // toolbar is null...
		{
			hitResult = this.getHit( pt );

			switch( hitResult )
			{
				case BDrawable.kHitBounds:

					switch( modifiers )
					{
						case kExclusiveSelectMask:
							this.select( this.prevHit, BViewport.kExclusiveSelect );
							this.startMove(this.xFormPoint);
							break;
						case kAdditiveSelectMask:
							this.select( this.prevHit, BViewport.kAdditiveSelect );
							this.startMove( this.xFormPoint);
							break;
						case kScrollMask:
							this.startScroll();
							break;
						case kZoomMask:
							this.startZoom();
							break;
                        case kPopupMask:
                            this.startPopup ();
                            break;
					}
					break;

				case BDrawable.kNotHit:

					switch( modifiers )
					{
						case kDragMask:
							this.startDrag( this.xFormPoint );
							break;
						case kScrollMask:
							this.startScroll();
							break;
						case kZoomMask:
							this.startZoom();
							break;
					}
					break;
				default: // should be BDrawable.kHitSizer + XX where x is a number pertaining to the sizer that was hit..
					this.startResize( this.prevHit, this.xFormPoint, hitResult );
					break;

			}
		}

		repaint();
		this.oldPoint = pt;
		dragging = true;
    }
    /**
     * Please complete the missing tags for mouseReleased
     * @param
     * @return
     * @pre
     * @post
     */

    public void mouseReleased( MouseEvent e )
    {
		
		Point pt = e.getPoint();
		dragging = false;
		int mod = e.getModifiers();

        int hitResult = getHit ( pt );

		this.xFormPoint.setLocation( pt );
		this.backTransformPoint( this.xFormPoint );

		switch( this.curState )
		{
			case kDragBoxState:
				this.stopDrag( this.xFormPoint );
				break;
			case kResizeState:
				this.stopResize( this.xFormPoint, true );
				break;
			case kMoveState:
				this.stopMove(this.xFormPoint, true);
				break;
			case kAddingState:
				if( e.getClickCount() >= 2 && ( mod & MouseEvent.BUTTON1_MASK) == MouseEvent.BUTTON1_MASK)
				{
					Debug.doPrintln("Double click");
					//nasty hack...use button 2 mask to indicate double click...
					mod |= MouseEvent.BUTTON2_MASK;
				}
				this.stopAdd( pt, mod, true );
				break;
            case kPopupState:
                this.stopPopup ( hitResult, e.getX (), e.getY () );
                break;
			default:
				this.curState = kVoidState;
				break;
		}

		if ( this.curState != kAddingState && e.getModifiers() != kStickyButtonMask && this.drawablePalette != null )
		{
			this.drawablePalette.resetCurSel();
		}
		
		if ( this.curState != kAddingState )
		{
			this.curState = kVoidState;
		}

		repaint();
    }
    /**
     * Please complete the missing tags for mouseDragged
     * @param
     * @return
     * @pre
     * @post
     */

    public void mouseDragged( MouseEvent e )
    {
		
		Point pt = e.getPoint();

		if ( false && (e.getModifiers() & kProportionalSize) == kProportionalSize )
		{
			if ( pt.x < pt.y )
			{
				pt.y = pt.x;
			}
			else
			{
				pt.x = pt.y;
			}
		}

		this.deltaXY.setLocation( pt );
		this.deltaXY.decXY( this.oldPoint );
		this.deltaXY.scale( this.z );

		this.xFormPoint.setLocation( pt );
		this.backTransformPoint( this.xFormPoint );

		switch( this.curState )
		{

			case kMoveState:
				this.dragMove( deltaXY );
				break;
			case kScrollState:
				this.scroll( deltaXY );
				break;
			case kDragBoxState:
				this.dragDrag( deltaXY );
				break;
			case kZoomState:
				if ( deltaXY.xLessThan(0) )
				{
					this.zoomIn();
				}
				else if ( deltaXY.xGreaterThan(0) )
				{
					this.zoomOut();
				}
				break;
			case kResizeState:
				this.dragResize( deltaXY );
				break;
			case kAddingState:
				this.dragAdd( deltaXY );
				break;
		}

		this.oldPoint = pt;
    }
    /**
     * Please complete the missing tags for mouseMoved
     * @param
     * @return
     * @pre
     * @post
     */

    public void mouseMoved( MouseEvent e )
    {
		
		BDrawable hit = null;
		int i, size;
		boolean oldHighlighted = false;
		boolean changed = false;

		Point pt = e.getPoint();

		if( this.diagram == null ) return;

        this.moved = true;

		this.xFormPoint.setLocation( pt );
		this.backTransformPoint( this.xFormPoint );





		size = visibleDrawables.size();

		//check hit backwards...
		for ( i = size - 1; i >= 0; i-- )
		{
			hit = (BDrawable)visibleDrawables.elementAt( i );

			oldHighlighted = hit.isHighlighted();

			if ( hit.checkXFormHit( pt ) != BDrawable.kNotHit )
			{
				hit.setHighlighted( true );
			}
			else
			{
				hit.setHighlighted( false );
			}

			if ( oldHighlighted != hit.isHighlighted() )
			{
				changed = true;
			}
		}

		this.oldPoint = pt;

//		if ( changed )
		{
			specialRepaint();
		}

    }

	/*
	 * Sets the value of this.prevHit to the
	 * drawable that was hit, or null if there was no hit..
	 */
	private int getHit( Point pt )
	{
		
		BDrawable cur = null;
		int result = BDrawable.kNotHit;
		int i, size;

		if( this.diagram == null )
		{
			this.prevHit = null;
			return BDrawable.kNotHit;
		}

		this.prevHit = null;

		size = visibleDrawables.size();

		//check hit backwards..due to drawables rendered last will be on top..
		for ( i = size - 1; i >= 0; i-- )
		{
			cur = (BDrawable)visibleDrawables.elementAt( i );

			result = cur.checkXFormHit( pt );
			if ( result != BDrawable.kNotHit )
			{
				this.prevHit = cur;
				break;
			}
		}

		return result;
	}

	public void select( BDrawable drawable, int type )
	{
		
		if ( !drawable.isSelected() )
		{
			if ( type == BViewport.kExclusiveSelect )
			{
				this.unselectAll();
			}

			this.selection.add( drawable );
			drawable.setSelected( true );

		}
		else
		{
			if ( type == BViewport.kAdditiveSelect )
			{
				this.selection.remove( drawable );
				drawable.setSelected( false );
			}
		}

		this.fireSelection();
	}

	public void unselectAll()
	{
		
		BDrawable curDrawable = null;
		int i, size;

		size = this.selection.size();
		for ( i = 0; i < size; i++ )
		{
			curDrawable = (BDrawable)this.selection.elementAt( i );
			curDrawable.setSelected( false );
		}
		this.selection.clear();

		this.fireSelection();

	}

	public void bringSelectionToFront()
	{
		
		if ( this.diagram != null )
		{
			this.diagram.bringSelectionToFront( this.selection );
			this.repaint();
		}
	}

	public void sendSelectionToBack()
	{
		
		if ( this.diagram != null )
		{
			this.diagram.sendSelectionToBack( this.selection );
			this.repaint();
		}
	}

    /**
     * This will take the currently selected items, place
     * a copy of them on the system clipboard and delete
     * the selection.
     */
    public void doCutSelection()
    {
		
        Vector selectionClone = (Vector)selection.clone();
        BDrawable drawable;
        Clipboard clipBoard;
        BTransferable cutData;

        //Make sure the selection can be deleted
        if (this.doDeleteSelection(true))
        {
            this.doCopySelection(selectionClone);
        }
    }

    /**
     * Sets the undo manager to use
     *
     * @param   key The named value for this undo manager
     * @param   undoManager The undo manager
     */
    public void setEditSupport(Object key, UndoableEditSupport editSupport, BUndoManager undoManager)
    {
		Debug.doPrintln("recursive?");
        this.editSupporters.put(key, editSupport);
        this.undoManagers.put(key, undoManager);

        //Make sure
        if (this.undoManager != null && this.undoManager != undoManager)
        {
            this.undoManager.relinquishUndoManager();
        }

        this.editSupport = editSupport;
        this.undoManager = undoManager;

        //Set this as the current undo manager
        this.undoManager.setUndoManager();
    }

    /**
     * This will tell the viewport to use the edit support
     * matching the given key
     *
     * @param   key The key for the edit support to use
     */
    public void relinquishUndoManager()
    {
        if (this.undoManager != null)
        {
            this.undoManager.relinquishUndoManager();
        }
    }

    /**
     * Call this when the window is being closed never to be undone again
     */
    public void unregisterUndoManager(Object key)
    {
        BUndoManager newUndoManager = null;
        //Make sure they've been set
        if (this.editSupporters.containsKey(key))
        {
            Debug.doPrintln("Unregistering undo manager: ");
            this.editSupport = (UndoableEditSupport)this.editSupporters.get(key);
            newUndoManager = (BUndoManager)this.undoManagers.get(key);
            newUndoManager.unregisterUndoManager(this);
        }
    }

    /**
     * This will tell the viewport to use the edit support
     * matching the given key
     *
     * @param   key The key for the edit support to use
     */
    public void setCurrentEditSupport(Object key)
    {
        BUndoManager newUndoManager = null;
        //Make sure they've been set
        if (this.editSupporters.containsKey(key))
        {
            Debug.doPrintln("Changing to new undo manager: ", Debug.kWarningLevel);
            this.editSupport = (UndoableEditSupport)this.editSupporters.get(key);
            newUndoManager = (BUndoManager)this.undoManagers.get(key);
        }
        else
            Debug.doPrintln("New undo manager not found", Debug.kWarningLevel);

        if (this.undoManager != null && this.undoManager != newUndoManager)
        {
            Debug.doPrintln("Relinquishing old undo manager: ", Debug.kWarningLevel);
            undoManager.relinquishUndoManager();
        }
        else if (newUndoManager != null)
        {
            Debug.doPrintln("Making switch: ", Debug.kWarningLevel);
            //Set this as the current undo manager
            this.undoManager = newUndoManager;
            this.undoManager.setUndoManager();
        }
    }

    /**
     * Takes the currently selected items and places a
     * copy of them on the clipboard.
     */
    public void doCopySelection(Vector currentSelection)
    {
		
        Vector selectionCopy = new Vector(currentSelection.size());
        BDrawable drawable;
        Clipboard clipBoard;
        BTransferable cutData;

        //Need to actually copy the data
        for (int i = 0; i < currentSelection.size(); i++)
        {
			Debug.doPrintln("Copying element number " + i );
            drawable = (BDrawable)currentSelection.elementAt(i);
            selectionCopy.addElement(drawable.newInstance());
        }

        //Place the data on the clipboard
        cutData = new BTransferable(selectionCopy);
        clipBoard = Toolkit.getDefaultToolkit().getSystemClipboard();
        clipBoard.setContents(cutData, new BClipboardOwner());
    }

    /**
     * This will paste the contents of the clipboard to the model
     */
    public void doPasteDrawables()
    {
		
        Clipboard clipBoard = Toolkit.getDefaultToolkit().getSystemClipboard();
        Transferable data = clipBoard.getContents(this);
        BDrawable drawable;

        if (data instanceof BTransferable)
        {
            try
            {
                Class theClass = Class.forName("java.util.Vector");
                Vector newDrawables = (Vector)data.getTransferData(new DataFlavor(theClass, "Model Nodes"));

                //Runs through and adds all the drawables to the diagram
                for (int i = 0; i < newDrawables.size(); i++)
                {
                    drawable = (BDrawable)newDrawables.elementAt(i);
				//	BScalarPoint addPoint = drawable.getPos();
                	Point point = new Point(drawable.getPos().getX(), drawable.getPos().getY());
					

/*					if(drawable instanceof BModelElement)
					{
						BModelElement element = (BModelElement) drawable;

						if(diagram instanceof BModel)
						{
							Debug.doPrintln("Setting the package on this element");
							BModel model = (BModel) diagram;
							element.resolveLoadedObject(model);
						}
					}*/

                    //I have no idea what I'm supposed to call

					this.diagram.addDrawable( drawable.newInstance() );
					drawable.doPasted(diagram);

                    //this.startAdd(drawable, point);
					//this.stopAdd(point, 0, true);
					//drawable.setPos(addPoint);
                }
            }
            catch(ClassNotFoundException cnfException)
            {
                Debug.doPrintln("Pasting from clipboard: ", cnfException);
            }
            catch(IOException ioException)
            {
                Debug.doPrintln("Pasting from clipboard: ", ioException);
            }
            catch(UnsupportedFlavorException noDataException)
            {
                Debug.doPrintln("Pasting from clipboard: ", noDataException);
            }
        }

        //Repaint the viewport
        this.repaint();
    }

    /**
     * This will call the undo method on the edit manager to
     * undo the last command undone.
     */
    public void doUndo()
    {
    }

    /**
     * This will call the redo method on the edit manager to
     * redo the last command undone.
     */
    public void doRedo()
    {
    }

	public boolean doDeleteSelection(boolean isUndoable)
	{
		
		BDrawable curDrawable = null;
		BStandardOutCE errorMsg = null;
		boolean ok = true;
		String reason = null;
		int i, size;

		//make sure all the selected things can be deleted...
		size = this.selection.size();
		for ( i = 0; i < size && ok; i++ )
		{
			curDrawable = (BDrawable)this.selection.elementAt( i );           
			reason = curDrawable.isDeletable();

			ok &= reason == null;
		}

		if ( ok ) //if all of them can be deleted, then delete them all.......
		{

			
			size = this.selection.size();

			BDrawable [] da = new BDrawable[size];
			for ( i = 0; i < size; i++ )
			{
				curDrawable = (BDrawable)this.selection.elementAt( i );
				this.diagram.delete( curDrawable );
				da[i] = curDrawable;

			}

			//Only add an undoable thing if it is required
            if(isUndoable && editSupport != null )
            {
                Debug.doPrintln("Adding kRemoved to undo manager", Debug.kWarningLevel);
                BScalarPoint point = null;
                BUndoableEdit undoEdit = new BUndoableEdit(da, point, kRemoved);
                this.editSupport.postEdit(undoEdit);
            }

			this.unselectAll();
		}
		else
		{
			errorMsg = new BStandardOutCE(this , reason);
			errorMsg.setMessageType( BStandardOutCE.kWarning );
			this.parent.dispatchEvent( errorMsg );
			Debug.doPrintln("Not ok to delete " + reason);
		}

		this.repaint();

        return ok;
	}

	public void continueAdd( Point pt )
	{
		
		getHit( pt );

		this.xFormPoint.setLocation( pt );
		this.backTransformPoint( this.xFormPoint );

		if ( this.diagram.continueAdd( this.xFormPoint, this.prevHit ) )
		{
            			
			this.curState = kAddingState;
		}
		else // diagram wont let it be added....
		{
		}

	}


	public void startAdd( BDrawable drawable, Point pt)
	{
		
		getHit( pt );

		this.xFormPoint.setLocation( pt );
		this.backTransformPoint( this.xFormPoint );

		this.curAdd = this.diagram.startAdd( drawable, this.xFormPoint, this.prevHit );

		if ( this.curAdd != null )
		{            
			drawable.transform( this, this.origin, this.frameCounter );
			this.curState = kAddingState;

		}
		else // diagram wont let it be added....
		{
		}
	}

	public void dragAdd( BScalarPoint deltaXY )
	{
		
		this.diagram.dragAdd( deltaXY, this.prevHit );
		this.repaint();
	}

	public void stopAdd( Point pt, int modifiers, boolean isUndoable )
	{
		
		getHit( pt );
		this.xFormPoint.setLocation( pt );
		this.backTransformPoint( this.xFormPoint );
		if ( this.diagram.stopAdd( this.xFormPoint, this.prevHit, modifiers ) )
		{			
			this.curState = kVoidState;			
			this.select( curAdd, kExclusiveSelect );

			//Only add an undoable thing if it is required
            if(isUndoable && editSupport != null )
            {
                Debug.doPrintln("Adding kAdded to undo manager", Debug.kWarningLevel);
				BScalarPoint point = new BScalarPoint( this.xFormPoint );
                BUndoableEdit undoEdit = new BUndoableEdit(this.curAdd, point, kAdded);
                this.editSupport.postEdit(undoEdit);
            }
			this.curAdd = null;
		}
	}

	public void startDrag( BScalarPoint pt )
	{
		
		this.curState = kDragBoxState;
		this.unselectAll();		
		this.dragBounds.startResize( BDrawable.kSizerSouthEast );
		this.dragBounds.setLocalXY( pt );
		this.dragBounds.setLocalWH( 0, 0 );
	}

	public void dragDrag( BScalarPoint deltaXY )
	{
		
		int w, h;
		int x1, y1, x2, y2;

		this.dragBounds.dragResize( deltaXY );
		this.repaint();
	}

	public void stopDrag( BScalarPoint pt )
	{
		
		int i, size;
		BDrawable cur = null;

		this.dragBounds.stopResize();

		size = this.visibleDrawables.size();

		for ( i = 0; i < size; i++ )
		{
			cur = (BDrawable)this.visibleDrawables.elementAt( i );
			if ( cur.isInside( this.dragBounds.getBounds() ) )
			{
				this.select( cur, kAdditiveSelect );
			}
		}

		this.curState = kVoidState;
		this.dragBounds.setLocalXY( pt );
		this.dragBounds.setLocalWH( 0, 0 );

		this.repaint();
	}

	public void startMove( BScalarPoint pt )
	{	
		
		this.curState = kMoveState;
		int i;
		int size;
		BDrawable curDrawable = null;

		this.moveDelta.setLocation( pt );

		size = this.selection.size();

		for ( i = 0; i < size; i++ )
		{
			curDrawable = (BDrawable)this.selection.elementAt( i );
			curDrawable.startMove();

		}

	}



	public void dragMove( BScalarPoint deltaXY )
	{
		
		int i;
		int size;
		BDrawable curDrawable = null;

		

		size = this.selection.size();

		for ( i = 0; i < size; i++ )
		{
			curDrawable = (BDrawable)this.selection.elementAt( i );
			curDrawable.dragMove( deltaXY );

		}
		repaint();
	}


	public void stopMove( BScalarPoint pt, boolean undoable )
	{
		
		this.curState = kMoveState;
		int i;
		int size;
		BDrawable curDrawable = null;

		size = this.selection.size();

		//do this backwards to get -ve..
		this.moveDelta.decXY( pt );
		
		BDrawable da [] = new BDrawable[size];

		for ( i = 0; i < size; i++ )
		{
			curDrawable = (BDrawable)this.selection.elementAt( i );
			curDrawable.stopMove();
			
			if ( this.snapToGrid )
			{
				curDrawable.snapToGrid( this.minorRulerSpacing );
			}

			da[i] = curDrawable;

		}

		Debug.doPrintln("" + moveDelta );
		if ( undoable && (moveDelta.xGreaterThan(0) || moveDelta.yGreaterThan(0)) && editSupport != null )
		{
			Debug.doPrintln("Adding kMoved to undo manager", Debug.kWarningLevel);
            BScalarPoint point = new BScalarPoint( this.moveDelta );
            BUndoableEdit undoEdit = new BUndoableEdit(da, point, kMoved);
            this.editSupport.postEdit(undoEdit);
		}
		this.curState = kVoidState;
	}

	public void undoMove( BDrawable [] drawable, BScalarPoint point)
	{
		
		int i;

		this.unselectAll();
		for ( i = 0; i < drawable.length; i++ )
		{
			drawable[i].startMove();
			drawable[i].dragMove( point );
			drawable[i].stopMove();
			this.select( drawable[i], kAdditiveSelect );
		}
	}

	public void undoRemove( BDrawable [] drawable )
	{
		
		int i;
		this.unselectAll();
		for ( i = 0; i < drawable.length; i++ )
		{
			this.diagram.addDrawable( drawable[i] );			
			this.select( drawable[i], kAdditiveSelect );
		}
	}

	public void startResize( BDrawable drawable, BScalarPoint point, int sizer )
	{
		
		this.curState = kResizeState;
		this.sizerNum = sizer;
		this.resizeDrawable = drawable;
		this.resizeDrawable.startResize( sizer );
		this.moveDelta.setLocation( point );
	}

	public void dragResize( BScalarPoint deltaXY )
	{
		
		this.resizeDrawable.dragResize( deltaXY );
		this.repaint();
	}

	public void stopResize( BScalarPoint point, boolean undoable )
	{
		
		this.resizeDrawable.stopResize();
	
		if ( undoable && editSupport != null )
		{
			Debug.doPrintln("Adding kResized to undo manager", Debug.kWarningLevel);
			//do this backwards to get -ve..
			this.moveDelta.decXY( point );
            BScalarPoint tpoint = new BScalarPoint( this.moveDelta );
            BUndoableEdit undoEdit = new BUndoableEdit(this.resizeDrawable, tpoint, this.sizerNum, kResized);
            this.editSupport.postEdit(undoEdit);			
		}

		this.resizeDrawable = null;		
		this.curState = kVoidState;
	}

	public void undoResize( BDrawable drawable, BScalarPoint point, int sizerNum )
	{
		
		drawable.startResize( sizerNum );
		drawable.dragResize( point );
		drawable.stopResize();
	}

    public void stopPopup ( int hitRes, int x, int y )
    {
		
        if ( hitRes == BDrawable.kHitBounds )
        {
            Debug.doPrintln ( "Hit something and stopping popup!" );

			this.select( this.prevHit, BViewport.kExclusiveSelect );
            currPropPanel = this.prevHit.getPropertyPanel ();
            if ( currPropPanel == null )
            {
                // Disable the property menu item.
                Debug.doPrintln ( "popup disabled." );
                propPopupItem.setEnabled ( false );
				

            }
            else
            {
                Debug.doPrintln ( "popup ENABLED" );
                propPopupItem.setEnabled ( true );
				
            }

			sendPopupItem.setEnabled( true );
			bringPopupItem.setEnabled( true );            
        }
		else
		{
			sendPopupItem.setEnabled( false );
			bringPopupItem.setEnabled( false );
		}

		popup.show ( this, x, y );
    }

	

    public void startPopup ()
    {
		
        this.curState = kPopupState;
    }

	public void startZoom()
	{
		
		this.curState = kZoomState;
	}

	public void startScroll()
	{
		
		this.curState = kScrollState;
	}


	public void scroll( BScalarPoint deltaXY )
	{
		
		this.viewCoords.decXY( deltaXY );
		specialRepaint();
	}

	public void zoomIn()
	{
		
		this.z.sub( this.zInc );
		if ( this.z.lessThan( BViewport.kMinDepth ) )
		{
			this.z.setValue( BViewport.kMinDepth );
		}
		this.ooz.reciprocal( this.z );


		specialRepaint();
	}

	public void zoomOut()
	{
		
		this.z.add( this.zInc );
		if ( this.z.greaterThanOrEqualTo( BViewport.kMaxDepth ) )
		{
			this.z.setValue( BViewport.kMaxDepth );
		}
		this.ooz.reciprocal( this.z );

		specialRepaint();

	}

	public int calcYOffset ( int spacing )
	{
		
		int mid = viewCoords.getY ();
		int something = mid % spacing;

		mid -= something;

		// While greater than posi of top-left corner of view pos.
		while ( mid > viewBounds.getY () )
		{
			mid -= spacing;
		}

		// put us back into view again.
		mid += spacing;
		// Subtract top-left...
		mid -= viewBounds.getY ();

		return mid;
	}

	public int calcXOffset ( int spacing )
	{
		
		int mid = viewCoords.getX ();
		int something = mid % spacing;

		mid -= something;

		// While greater than posi of top-left corner of view pos.
		while ( mid > ( viewBounds.getX () ) )
		{
			mid -= spacing;
		}

		// put us back into view again.
		mid += spacing;
		// Subtract top-left...
		mid -= viewBounds.getX ();

		return mid;
	}

	public void drawGrid( Graphics g )
	{
		
		Graphics2D g2 = ( Graphics2D ) g;
		int gridSpacing = minorRulerSpacing * majorRulerSpacing;

		// In this function, used just to fill a param.
		int tempVal = 0;
        BasicStroke oldStroke;

		int viewportW = viewBounds.getWidth ();
		int viewportH = viewBounds.getHeight ();

		int panelH = this.getHeight ();
		int panelW = this.getWidth ();

		// Offset into the panel.
		int xOffset = calcXOffset ( gridSpacing );
		int yOffset = calcYOffset ( gridSpacing );

		// Position once "ooz" factor been applied.
		float pos;

		g2.setColor ( gridColour );

		int xVal = viewBounds.getX () + xOffset;
		int yVal = viewBounds.getY () + yOffset;

		for ( ; xOffset < viewportW; xOffset += gridSpacing, xVal += gridSpacing )
		{
			pos = ( float ) xOffset * ooz.getFloatValue ();
            if ( xVal == 0 )
            {
                oldStroke = ( BasicStroke ) g2.getStroke ();
                // Center line, change stroke...
                g2.setStroke ( new BasicStroke ( 3.0f ) );

      			g2.drawLine ( ( int ) pos, 0, ( int ) pos, panelH );

                g2.setStroke ( oldStroke );

            }
            else
            {
			    g2.drawLine ( ( int ) pos, 0, ( int ) pos, panelH );
            }
		}

		for ( ; yOffset < viewportH; yOffset += gridSpacing, yVal += gridSpacing )
		{
			pos = ( float ) yOffset * ooz.getFloatValue ();
            if ( yVal == 0 )
            {
                oldStroke = ( BasicStroke ) g2.getStroke ();
                // Hit center line, change stroke again...
                g2.setStroke ( new BasicStroke ( 3.0f ) );
    			g2.drawLine ( 0, ( int ) pos, panelW, ( int ) pos );
                g2.setStroke ( oldStroke );
            }
            else
            {
			    g2.drawLine ( 0, ( int ) pos, panelW, ( int ) pos );
            }
		}
	}

	public void drawRuler ( Graphics g )
	{
		
		Graphics2D g2 = ( Graphics2D ) g;

		Font currFont = g2.getFont ();
		int viewportW = viewBounds.getWidth ();
		int viewportH = viewBounds.getHeight ();

		int majorSpacing = minorRulerSpacing * majorRulerSpacing;

        fm = g2.getFontMetrics ( currFont );

		// Offset into the panel.
		int xOffset = calcXOffset ( minorRulerSpacing );
		int yOffset = calcYOffset ( minorRulerSpacing );

		float pos;

        // Average length of ruler string
        avgStrLen = fm.stringWidth ( "-0000" );
        avgStrHeight = fm.getHeight ();

        majDist = ( float ) majorSpacing * ooz.getFloatValue ();

        // we only want to render ruler identifiers every...
        float tmpX = ( ( float ) avgStrLen / majDist ) + 0.5f;
        float tmpY = ( ( float ) avgStrHeight / majDist ) + 0.5f;

        textXInterval = Math.round ( tmpX );
        textYInterval = Math.round ( tmpY );
        // major line.  Add 0.5 so we always round up.

		int xVal = viewBounds.getX () + xOffset;
		int yVal = viewBounds.getY () + yOffset;

		g2.setStroke ( rulerStroke );
		g2.setColor ( rulerColour );

		for ( ; xOffset < viewportW; xOffset += minorRulerSpacing, xVal += minorRulerSpacing )
		{
			pos = ( float ) xOffset * ooz.getFloatValue ();
            if ( ( xVal % ( majorSpacing * textXInterval ) ) == 0 )
			{
				g2.drawLine ( ( int ) pos, 0, ( int ) pos, kMajorLineLen );
				// Render text.
				g2.drawString ( Integer.toString ( xVal ), ( int ) pos, kMajorLineLen + kMinorLineLen );
			}
			else if ( xVal % ( minorRulerSpacing * textXInterval ) == 0 )
			{
				g2.drawLine ( ( int ) pos, 0, ( int ) pos, kMinorLineLen );
			}
		}

		for ( ; yOffset < viewportH; yOffset += minorRulerSpacing, yVal += minorRulerSpacing )
		{
			pos = ( float ) yOffset * ooz.getFloatValue ();
			if ( ( yVal % ( majorSpacing * textYInterval ) ) == 0 )
			{
				g2.drawLine ( 0, ( int ) pos, kMajorLineLen, ( int ) pos );
				// Scale and render text.
				g2.drawString ( Integer.toString ( yVal ), kMinorLineLen, ( int ) pos );
			}
			else if ( yVal % ( minorRulerSpacing * textYInterval ) == 0 )
			{
				g2.drawLine ( 0, ( int ) pos, kMinorLineLen, ( int ) pos );
			}
		}
	}

	public void enableGrid ( boolean enable )
	{
		
		gridOn = enable;
		if ( !gridOn )
		{
			snapToGrid = false;
			Debug.doPrintln ( "setGrid to false" );
		}
	}

	public boolean isGridEnabled ()
	{
		
		return gridOn;
	}

	public boolean isSnapEnabled ()
	{
		
		return snapToGrid;
	}

	public void enableSnap ( boolean snap )
	{
		
		snapToGrid = snap;
	}

	public void enableRuler ( boolean enable )
	{
		
		if ( enable )
		{
			Debug.doPrintln ( "Turning rulers on." );
		}
		else
		{
			Debug.doPrintln ( "Turing rulers OFF" );
		}
		rulerOn = enable;
	}

	public boolean isRulerEnabled ()
	{
		
		return rulerOn;
	}

	public void setMinorRulerSpace ( int space )
	{
		
		Debug.doPrintln ( "setting minor spacing to " + space );
		minorRulerSpacing = space;
	}

	public int getMinorRulerSpace ()
	{
		
		return minorRulerSpacing;
	}

	public void setMajorRulerSpace ( int space )
	{
		
		Debug.doPrintln ( "setting major spacing to " + space );
		majorRulerSpacing = space;
	}

	public int getMajorRulerSpace ()
	{
		
		return majorRulerSpacing;
	}

	public void setGridColour ( Color c )
	{
		
		Debug.doPrintln ( "Setting grid colour to " + c );
//		gridColour = c;
		this.grid.setGridColour ( c );
	}

	public Color getGridColour ()
	{
		
		return gridColour;
	}

	public void setRulerColour ( Color c )
	{
		
		Debug.doPrintln ( "Setting ruler colour to " + c );
		rulerColour = c;
//		this.ruler.setRulerColour ( c );
	}

	public Color getRulerColour ()
	{
		
		return rulerColour;
	}

	/**
	 * What to do when the scroll bar is clicked...
	 */
	public void adjustmentValueChanged( AdjustmentEvent e )
	{
		
		Adjustable source = e.getAdjustable();
		int value = e.getValue();
		int dv;

		if ( source.getOrientation() == Adjustable.VERTICAL )
		{
			dv = this.oldVValue - value; //do this backwards to get -ve value :)
			this.xFormPoint.setLocation( 0, dv );
			this.oldVValue = value;
		}
		else if (source.getOrientation() == Adjustable.HORIZONTAL )
		{
			dv = this.oldHValue - value; //do this backwards to get -ve value :)
			this.xFormPoint.setLocation( dv, 0 );
			this.oldHValue = value;
		}

		this.scroll( this.xFormPoint );
	}

    

	public void setHorzAdjustable( Adjustable horz )
	{
		
	}

	public void setVertAdjustable( Adjustable vert )
	{
		
	}

	public void removeHorzAdjustable()
	{
		
	}
	public void removeVertAdjustable()
	{
		
	}

	public BSplitable getNewView()
	{
		
		// Copy everything...well almost everything.
		BViewport view = new BViewport ( parent );

		// Just reference copy these...novelty functionality achieved by this.
		view.diagram = this.diagram;
		view.drawablePalette = this.drawablePalette;
				
		view.curState = this.curState;
								
		view.resizeSizer = this.resizeSizer;
		view.moved = this.moved;
		
		view.visibleDrawables.clear();
		view.selection = this.selection;

		// Now to the important stuff, this needs to be instanciated.
		view.z.setValue( this.z );
		view.ooz.setValue( this.ooz );
		view.halfWH.setLocation(this.halfWH );
		view.viewCoords.setBounds( this.viewCoords );
		view.viewBounds.setBounds( this.viewBounds );
		view.xFormPoint.setLocation( this.xFormPoint );
		view.zInc.setValue( this.zInc );
		view.origin.setLocation( this.origin );
		view.deltaWH.setLocation( this.deltaWH );
		view.deltaXY.setLocation( this.deltaXY );

		// I think the following will go at a later stage.
		view.minorRulerSpacing = this.minorRulerSpacing;
		view.majorRulerSpacing = this.majorRulerSpacing;
		view.rulerStroke = this.rulerStroke;
		view.rulerColour = this.rulerColour;
		view.rulerFont = this.rulerFont;
		view.initFontSize = this.initFontSize;

		view.gridColour = this.gridColour;
		view.gridStroke = this.gridStroke;
		view.rulerOn = this.rulerOn;
		view.gridOn = this.gridOn;
		view.dragging = this.dragging;
		view.snapToGrid = this.snapToGrid;

		view.editSupport = this.editSupport;
		view.listeners = this.listeners;

		// The above should be deleted due to the following classes...
		view.grid = new BGrid( view );
		view.grid.setGridColour( this.grid.getGridColour() );
		view.grid.setDots( this.grid.getDots() );
		view.ruler = this.ruler;

		view.setBackground ( this.getBackground () );
		view.frameCounter = 0;//this.frameCounter;

		view.popup = this.popup;
		view.propPopupItem = this.propPopupItem;
		view.sendPopupItem = this.sendPopupItem;
		view.bringPopupItem = this.bringPopupItem;
		view.currPropPanel = this.currPropPanel;

		view.firstSetBounds = false;

		return view;
	}

	public BScalar getZ()
	{
		
		return this.z;
	}

	public BScalar getOOZ()
	{
		
		return this.ooz;
	}

	public int getHalfWidth()
	{
		
		return this.halfWH.getX();
	}

	public int getHalfHeight()
	{
		
		return this.halfWH.getY();
	}

	public int getXPos()
	{
		
		return viewCoords.getX();
	}

	public int getYPos()
	{
		
		return viewCoords.getY();
	}

	public BScalarRect getViewCoords()
	{
		
		return viewCoords;
	}

	public BScalarRect getViewBounds()
	{
		
		return viewBounds;
	}

	public BScalarPoint getHalfWH()
	{
		
		return halfWH;
	}

	public void addSelectionListener( BSelectionListener l )
	{
		
		Debug.doPrintln("adding selection listener");
		this.listeners.add( l );
		Debug.doPrintln("added selection listener");
	}

	public void removeSelectionListener( BSelectionListener l )
	{
		
		this.listeners.remove( l );
	}

	public void fireSelection()
	{
		
		int i;
		int size;
		BSelectionListener l = null;
		BSelectionEvent e = new BSelectionEvent( this, this.selection );
		
		size = this.listeners.size();
		for ( i = 0; i < size; i++ )
		{
			l = (BSelectionListener)this.listeners.elementAt( i );
			l.onSelection( e );
		}
	}


    private class onProperties implements ActionListener
    {
        public void actionPerformed ( ActionEvent e )
        {
			
			Object source = e.getSource();

			if ( source == propPopupItem )
			{
				BAddWindowCE event = new BAddWindowCE ( this, new BGlobalPropPanel ( parent, BViewport.this, currPropPanel ), new BString ( this, "properties" ) );
				parent.dispatchEvent ( event );
			}
			else if ( source == sendPopupItem )
			{
				BViewport.this.sendSelectionToBack();
			}
			else if ( source == bringPopupItem )
			{
				BViewport.this.bringSelectionToFront();
			}
        }
    }

    private class BViewActionListener implements ActionListener
    {
    	public void actionPerformed( ActionEvent e )
    	{
			
    		Object source = e.getSource();
            String actionCommand = e.getActionCommand();

            Debug.doPrintln(actionCommand, Debug.kWarningLevel);

			//am allowed to do == because it's a static reference..
			if ( actionCommand == kDelCommand )
			{
				BViewport.this.doDeleteSelection(true);
			}
            else if (actionCommand == kCutCommand)
            {
                BViewport.this.doCutSelection();
            }
			else if ( actionCommand == kCopyCommand)
			{
				Debug.doPrintln("Doing a copy");
				BViewport.this.doCutSelection();// BViewport.this.selection);
			}
            else if (actionCommand == kPasteCommand)
            {
                BViewport.this.doPasteDrawables();
            }
			else if ( actionCommand == kZoomInCommand)
			{
				BViewport.this.zoomIn();
			}
			else if ( actionCommand == kZoomOutCommand)
			{
				BViewport.this.zoomOut();
			}
    	}
    }

    /**
     * Need to give the clipboard something to talk to
     *
     * @author Tristan Austin
     */
    public class BClipboardOwner implements ClipboardOwner
	{
        /**
         * When the clipboard contents change, this method is called.
         */
		public void lostOwnership(Clipboard clipboard, Transferable contents)
		{
			
			Debug.doPrintln("Lost ownership of clipboard");
		}
	}

    /**
     * Every time an edit is made, this will be used to
     * determine what to do when it is undone or redone.
     *
     * @author Tristan Austin
     */
    public class BUndoableEdit extends AbstractUndoableEdit
    {
        /**
         * Indicates whether something was added or deleted
         */
        int type = kAdded;

        /**
         * The item that was affected
         */
        BDrawable drawable;

        /**
         * The point it came from or went to
         */
        BScalarPoint bsPoint;

		/**
		 *arbitrary integer param
		 */
		int param;


		/**
		 * an array of items that have been affected..
		 */
		BDrawable [] drawableArray;

		Point point;

        /**
         * Creates a new undoable event for the specified drawable
         * and type.
         *
         * @param   drawable    The element affected
         * @param   point   The location it was removed from or added to
         * @param   type    Whether it was added or removed
         */
        public BUndoableEdit(BDrawable drawable, BScalarPoint point, int type)
        {
            super();
			
            this.type = type;
            this.drawable = drawable;
            this.bsPoint =  point;
        }

		public BUndoableEdit(BDrawable drawable, Point point, int type)
        {
            super();
			
            this.type = type;
            this.drawable = drawable;
            this.point =  point;
        }

		public BUndoableEdit(BDrawable [] drawable, BScalarPoint point, int type)
        {
            super();
			
            this.type = type;
            this.drawableArray = drawable;
            this.bsPoint =  point;
        }

		public BUndoableEdit(BDrawable drawable, BScalarPoint point, int param, int type)
        {
            super();
			
            this.type = type;
			this.param = param;
            this.drawable= drawable;
            this.bsPoint =  point;
        }

        /**
         * Undo the edit that was made.
         */
        public void undo() throws CannotUndoException
        {
			
            super.undo();

			switch( type )
			{
				case kAdded:					            
					BViewport.this.selection.clear();
					BViewport.this.selection.add(this.drawable);
					BViewport.this.doDeleteSelection(false);
					break;
            
				case kRemoved:
					BViewport.this.undoRemove( this.drawableArray );

					break;
				case kMoved:
					BViewport.this.undoMove( this.drawableArray, this.bsPoint );	
					break;
				case kResized:
					BViewport.this.undoResize( this.drawable, this.bsPoint, this.param );
					break;
				default:
				    throw new CannotUndoException();						
            }

			BViewport.this.repaint();
        }

         /**
         * Re-apply the edit, assuming that it has been undone.
         */
        public void redo() throws CannotRedoException
        {
			
            super.redo();
            if (type == kAdded)
            {				
                BViewport.this.diagram.addDrawable(this.drawable);
            }
            else if (type == kRemoved)
            {
                BViewport.this.doDeleteSelection(false);
            }
			else if ( type == kMoved )
			{
				this.bsPoint.neg();				
				BViewport.this.undoMove( this.drawableArray, this.bsPoint );
				this.bsPoint.neg();
			}
			else if ( type == kResized )
			{
				this.bsPoint.neg();
				BViewport.this.undoResize( this.drawable, this.bsPoint, this.param );
				this.bsPoint.neg();
			}
            else
            {
                throw new CannotRedoException();
            }

			BViewport.this.repaint();
        }

        /**
         * Returns an appropriate description of the operation this edit
         * represents.
         *
         * @see	#getUndoPresentationName
         * @see	#getRedoPresentationName
         */
        public String getPresentationName()
        {
			
            String presentationName = "";

            if (this.type == kRemoved)
            {
                presentationName = "delete";
            }
            else if (this.type == kAdded)
            {
                presentationName = "add";
            }
			else if ( this.type == kMoved )
			{
				presentationName = "move";
			}

            return presentationName;
        }

        /**
         * If getPresentationName() returns "", returns
         * AbstractUndoableEdit.UndoName. Otherwise returns
         * AbstractUndoableEdit.UndoName followed by a space and
         * getPresentationName()
         *
         * @see #getPresentationName
         */
        public String getUndoPresentationName()
        {
			
            String name = getPresentationName();
            if (name != "")
            {
                name = UndoName + " " + name;
            }
            else
            {
                name = UndoName;
            }

            return name;
        }

        /**
         * If getPresentationName() returns "", returns
         * AbstractUndoableEdit.RedoName. Otherwise returns
         * AbstractUndoableEdit.RedoName followed by a space and
         * getPresentationName()
         *
         * @see #getPresentationName
         */
        public String getRedoPresentationName()
        {
			
            String name = getPresentationName();
            if (name != "")
            {
                name = RedoName + " " + name;
            }
            else
            {
                name = RedoName;
            }

            return name;
        }
    }

    public void setDiagramPlugin(BDiagramPlugin fDiagramPlugin)
	{
		
		Debug.doPrintln("I got me a diagramPlugin");
		diagramPlugin = fDiagramPlugin;
	}

}
