// $Header: /teamproj/cvsroot/teamb/bkasrc/au/edu/swin/synergy/plugin/diagram/event/BRegisterViewportCE.java,v 1.2 1999/10/08 09:44:08 tp079511 Exp $

package au.edu.swin.synergy.plugin.diagram.event;

import au.edu.swin.synergy.kernel.BCommandEvent;

import au.edu.swin.synergy.plugin.diagram.BViewport;


/**
 * Event for setting the palette of a diagram. 
 * This event should only be called one per
 * viewport object to register it.
 * Calling the event twice on the same viewport will unregister it.
 * 
 * Once registered, the viewport will maintain an internal reference
 * to the palette which it will then use to notify the palette of
 * any events, and the diagram will keep an internal reference to the
 * viewport, to notify it of relevant things.
 *
 */
public class BRegisterViewportCE extends BCommandEvent
{
    // add data elements in here....

    BViewport theViewport = null;
    boolean registerMe;

    public BRegisterViewportCE ( Object source, BViewport viewport, boolean reg )
	{
		this ( source, viewport );
		registerMe = reg;
	}

	public BRegisterViewportCE( Object source, BViewport viewport )
    {
        super( source );
		this.theViewport = viewport;
		registerMe = true;
    }
    
    public BViewport getBViewport()
    {
        return theViewport;
    }	

	public boolean isRegister ()
	{
		return registerMe;
	}
}
