// $Header: /teamproj/cvsroot/teamb/bkasrc/au/edu/swin/synergy/plugin/directsvr/BDirectMessageSvr.java,v 1.10 1999/09/07 08:16:04 tp079519 Exp $


package au.edu.swin.synergy.plugin.directsvr;

import au.edu.swin.synergy.kernel.BPlugin;
import au.edu.swin.synergy.kernel.*;
import au.edu.swin.synergy.plugin.smtpsvr.event.BMailCE;
import au.edu.swin.synergy.plugin.directsvr.event.BDirectMailCE;
import au.edu.swin.synergy.plugin.mailclient.BMessage;
import au.edu.swin.synergy.plugin.server.event.BGetSessionsCE;
import au.edu.swin.synergy.plugin.server.BServerSession;
import au.edu.swin.synergy.plugin.userdb.BUser;
import au.edu.swin.synergy.plugin.server.event.BGetUserCE;
import au.edu.swin.synergy.lib.BStringList;
import au.edu.swin.synergy.debug.Debug;
import java.util.Vector;


/**
 * BDirectMessageSvr acts as the server for internal direct mail distribution
 * fro cohesion clients
 *
 * @author Matthew Evans
 * Please complete these missing tags
 * @copyright
 */
public class BDirectMessageSvr extends BPlugin
{
    /**
     * The message data for each new mail event received
     */
    BMessage messageData = null;
    
    /**
     * list of all intended direct msg recipients of a BMessage
     */
    Vector directReceivers = null;
    
    /**
     * setup the DirectMessageSvr
     * Please complete the missing tags for setup
     * @param
     * @return
     * @pre
     * @post
     */
    public void setup(BStringList params)
    {
        //nothing needed as yet
    }
    
    /**
     * Obtains a sub-list of the receivers list in a BMessage object, which
     * contains only direct message receipients
     *
     * @param allReceivers the original list of receivers in a BMessage object
     * Please complete the missing tags for setDirectRecipients
     * @return
     * @pre
     * @post
     */
    public void setDirectRecipients( BStringList allReceivers )
    {
        //initialise the collection
        this.directReceivers = new Vector();
        
        for( int i = 0; i < allReceivers.getCount(); i++ )
        {
            //check this is a direct msg receiver (and not a smtp receiver)
            if( allReceivers.get( i ).indexOf( "@" ) == - 1 )
            {
                this.directReceivers.addElement( allReceivers.get( i ) );
            }
        }
    }
    
    /**
     * Listens for mail events, and if one is detected, the event is forwarded
     * to the sendMessage()
     *
     * @param the source of the command event
     * @param the event
     * Please complete the missing tags for onBCommandEvent
     * @return
     * @pre
     * @post
     */
    public void onBCommandEvent( Object source, BCommandEvent event )
    {
        if( event instanceof BMailCE )
        {
            Debug.doPrintln( "\nBDirectMsgSvr: onCE: received a BMailCE" );

            //set current message data
            BMailCE mailEvent = ( BMailCE ) event;
            this.messageData = mailEvent.getMessage();

				BGetUserCE getUserEvent = new BGetUserCE(this, event.getConnectionID(), null);
				BBlockingComplete getUserComplete = dispatchEventServerAndWait(getUserEvent);

				if(getUserComplete.getStatus() == BCommandComplete.kSuccess)
				{
					getUserEvent = (BGetUserCE) getUserComplete.getEvent();
					BUser userDetails = getUserEvent.getUser();

					messageData.setSender(userDetails.getName());
		         //set the list of direct recipients up from the entire list of 
            	//recipients for this message
	            setDirectRecipients( messageData.getReceivers() );
   	         
      	      //only continue further processing if a direct recipient exists in 
         	   //the list of recievers from the BMessage
            	if( this.directReceivers.size() > 0 )
	            {
   	             //send a new get sessions CE to retrieve the currently logged user sessions
      	          BGetSessionsCE getSessions = new BGetSessionsCE( this, new BGetSessionsCC() );
         	       dispatchEvent( getSessions );
            	}
				}
				else
				{
					Debug.doPrintln("error sending Direct message");
				}
        }
    }
    
    /**
     * Send the message to any email receivers in te mail event
     *
     * @param the session ID of an intended reciepient of the message
     * Please complete the missing tags for sendMessage
     * @return
     * @pre
     * @post
     */
    public void sendMessage( String user, int sessionID )
    {
        BDirectMailCE directMessage = new BDirectMailCE(this, messageData);
        
        dispatchEventTo( directMessage, sessionID );
        Debug.doPrintln( "forwarded direct message to user: " + user );
    }
    
    
    /**
     * An instance of this class is passed along with the BGetUserCE event
     * so that it's <code>doComplete</code> method may be called by the
     * target plugin when the list of available users has been obtained.
     * <p>
     * At this point the available users are displayed in the BUserManagerGUI dialog.
     *
     * @author John Newbigin
     */
    class BGetSessionsCC extends BCommandComplete
    {
        /**
         * When the users have been retrieved this method is called
         *
         * @param   event   The event that was originally fired
         * @param   status  The success status of the operation
         */
        public void doComplete( BCommandEvent event, int status )
        {
            Debug.doPrintln( "got list of sessions" );
            BGetSessionsCE getSessionsCE = ( BGetSessionsCE ) event;
            BStringList receivers = messageData.getReceivers();
            //Vector sessions = getSessionsCE.getSessions ();
            
            for( int i = 0; i < getSessionsCE.getCount(); i++ )
            {
                Debug.doPrintln( "looking through sessions" );
                BServerSession session = getSessionsCE.getSession( i );
                BUser sessionUser = session.getUser();
                
                Debug.doPrintln( "\nBDirectMsgSvr: BGetSessionsCC: doComplete: looking for user: " + sessionUser.getName() + " in direct message receivers list" );
                
                //send the message if this session's user is an intended receipient
                if( directReceivers.contains( sessionUser.getName() ) )
                {
                    Debug.doPrintln( "\nBDirectMsgSvr: BGetSessionsCC: doComplete: found user: " + sessionUser.getName() + ". Sending message." );
                    sendMessage( sessionUser.getName(), session.getID() );
                }
            }
        }
    }
    
}

