package au.edu.swin.synergy.plugin.editmanager;

/**
 * The edit proxy will enable other classes to communicate
 * relatively directly to the edit manager without having to
 * send command events across the network every time.
 * <p>
 * Calling methods on here results in methods being called
 * in the edit manager in order to enable and disable
 * the the cut, copy and paste methods in the edit manager.
 *
 * @author Tristan Austin
 */
public class BEditProxy
{
	/**
	 * The edit manager to inform of the state of the edit items
	 */
	BEditManager editManager;

	/**
	 * Creates a new edit manager proxy to allow
	 * remote setting of the menu item states
	 *
	 * @param	editManager	The edit manager to act as proxy for
	 */
	protected BEditProxy(BEditManager editManager)
	{
	}

	/**
	 * This will set the cut/copy combination of the edit
	 * menu to the enabled state specified.
	 *
	 * @param	cutEnabled	True to enable, false to disable
	 */
	public void setCutCopyEnabled(boolean cutEnabled)
	{
		editManager.setCutCopyEnabled(cutEnabled);
	}

	
	/**
	 * This will set the paste menu item of the edit
	 * menu to the enabled state specified.
	 *
	 * @param	pasteEnabled	True to enable, false to disable
	 */
	public void setPasteEnabled(boolean pasteEnabled)
	{
		editManager.setPasteEnabled(pasteEnabled);
	}
}
