package au.edu.swin.synergy.plugin.help;

import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import java.net.URL;
import java.awt.*;
import java.io.IOException;

import au.edu.swin.synergy.debug.Debug;
import au.edu.swin.synergy.plugin.mod13.bwt.BSwingUtilities;
import au.edu.swin.synergy.plugin.mod13.event.BCloseWindowCE;
import au.edu.swin.synergy.plugin.dialect.BDialect;

public class BCohesionAboutPanel extends JPanel
{
	JLabel aboutLabel;
    JTabbedPane aboutPane = new JTabbedPane();
    BorderLayout borderLayout1 = new BorderLayout();
    JPanel jPanel1 = new JPanel();
    JPanel gplPanel = new JPanel();
    JEditorPane gplViewer = new JEditorPane();
    BorderLayout borderLayout2 = new BorderLayout();
    JScrollPane scrollPane = new JScrollPane();
    JPanel bottomPanel = new JPanel();
    boolean isLoaded = false;
    JButton okButton = new JButton();
    BHelp helpPlugin;

    /**
     * Creates the about box and initliases its contents
     */
	public BCohesionAboutPanel (BHelp helpPlugin)
	{
        this.helpPlugin = helpPlugin;
        this.setLayout(borderLayout1);
        gplViewer.setContentType("text/html");
        gplViewer.setEditable(false);
        gplPanel.setLayout(borderLayout2);
        this.add(aboutPane, BorderLayout.CENTER);
		ImageIcon aboutImage = BSwingUtilities.getImage(this, "/au/edu/swin/synergy/plugin/help/images/about.gif");
		JLabel label = new JLabel(aboutImage);
		aboutPane.add(label, BDialect.getString(this, "synergy"));
        aboutPane.add(gplPanel, BDialect.getString(this, "gpl"));
        gplPanel.add(scrollPane, BorderLayout.CENTER);
        scrollPane.getViewport().add(gplViewer);
        aboutPane.addChangeListener(new AllPurposeListener());
        this.add(bottomPanel, BorderLayout.SOUTH);
        bottomPanel.setLayout(new FlowLayout(FlowLayout.RIGHT));
        bottomPanel.add(okButton);
        okButton.addActionListener(new AllPurposeListener());
        BSwingUtilities.setJButtonText(okButton, BDialect.getString("ok"));
	}


    /**
     * Sets the file to display
     */
    protected void setFile()
    {
        URL pageURL = getClass().getResource("/au/edu/swin/synergy/plugin/help/gpl.html");

        try
        {
            synchronized(this)
            {
                gplViewer.setPage(pageURL);
            }

        }
        catch(IOException ioException)
        {
            Debug.doPrintln("Couldn't load page: ", ioException);
        }
    }

    /**
     * This will notify us when the user selects the tab. The first
     * time we're going to load up the html file.
     */
    protected class AllPurposeListener implements ChangeListener, ActionListener
    {
        /**
         * Called when the state changes
         *
         * @param   changeEvent The change event fired
         */
        public void stateChanged(ChangeEvent changeEvent)
        {
            if (!isLoaded)
            {
                if (aboutPane.getSelectedComponent() == gplPanel)
                {
                    setFile();
                    isLoaded = true;
                }
            }
        }

        /**
         * Called when the user clicks the ok button. This will close
         * the dialog.
         *
         * @param   actionEvent The event fired
         */
        public void actionPerformed(ActionEvent actionEvent)
        {
            BCloseWindowCE closeWindow = new BCloseWindowCE(this, BCohesionAboutPanel.this);
            synchronized(BCohesionAboutPanel.this)
            {
                helpPlugin.dispatchEvent(closeWindow);
            }
        }
    }
}
