// $Header: /teamproj/cvsroot/teamb/bkasrc/au/edu/swin/synergy/plugin/help/BContentTab.java,v 1.19 1999/10/15 06:13:03 tp079210 Exp $
/**
 * Please complete these missing tags
 * @author
 * @copyright
 */
package au.edu.swin.synergy.plugin.help;

import javax.swing.*;
import javax.swing.event.*;
import java.awt.*;
import java.awt.event.*;
import java.net.URL;
import javax.swing.tree.TreePath;
import javax.swing.tree.DefaultMutableTreeNode;
import javax.swing.tree.DefaultTreeCellRenderer;

import au.edu.swin.synergy.plugin.help.BHelpUtil;
import au.edu.swin.synergy.plugin.help.BHelpManager;
import au.edu.swin.synergy.plugin.help.BHelpItem;
import au.edu.swin.synergy.debug.Debug;

import au.edu.swin.synergy.plugin.dialect.BDialect;
import au.edu.swin.synergy.plugin.mod13.bwt.BSwingUtilities;

public class BContentTab extends JPanel
{
    BHelpManager helpManager;

	DefaultTreeCellRenderer cellRenderer;
    JLabel searchLabel;
    JTree helpTree;
    JScrollPane scrollingContentTree;
	URL url;
	URL itemUrl;
	URL openUrl;
	URL closedUrl;

    /**
     * Please complete the missing tags for BContentTab
     * @param
     * @return
     * @pre
     * @post
     */

    public BContentTab( BHelpManager hm )
    {
		searchLabel = new JLabel ( BDialect.getString ( this, "contentsearch" ) );

        setSize( 400, 500 );

        helpManager = hm;
		helpManager.setTabRef ( this );
		cellRenderer = new DefaultTreeCellRenderer ();

		ImageIcon item = BSwingUtilities.getImage(this, "/au/edu/swin/synergy/plugin/help/icons/item.gif");
		ImageIcon open = BSwingUtilities.getImage(this, "/au/edu/swin/synergy/plugin/help/icons/open.gif");
		ImageIcon closed = BSwingUtilities.getImage(this, "/au/edu/swin/synergy/plugin/help/icons/closed.gif");

		// May have to get the icons via resources.  Work on this tomorrow.
		cellRenderer.setLeafIcon ( item );
		cellRenderer.setOpenIcon ( open );
		cellRenderer.setClosedIcon ( closed );

        helpTree = new JTree( helpManager.getModel() );
		helpTree.addMouseListener ( new onMouseClicks () );
		helpTree.addTreeSelectionListener ( new onTreeSelection () );
		helpTree.registerKeyboardAction ( new onEnterPressed (), KeyStroke.getKeyStroke ( KeyEvent.VK_ENTER, 0 ), JComponent.WHEN_FOCUSED );
		helpTree.setCellRenderer ( cellRenderer );


        scrollingContentTree = new JScrollPane( helpTree );

        setLayout( new GridBagLayout() );
        GridBagConstraints c = new GridBagConstraints();

        BHelpUtil.setConst( c, 0, 0, 1, 1, BHelpUtil.kNone, BHelpUtil.kW, BHelpUtil.kLightWeight );
        add( searchLabel, c );

        BHelpUtil.setConst( c, 0, 1, 1, 10, BHelpUtil.kBoth, BHelpUtil.kCenter, BHelpUtil.kHeavyWeight );
        add( scrollingContentTree, c );
    }

	public void doDialect ()
	{
		BSwingUtilities.setJLabelText ( searchLabel, BDialect.getString ( this, "contentsearch" ) );
	}

	public URL getUrl ()
	{
		return url;
	}

	public boolean isItemSelected ()
	{
		Debug.doPrintln ( "url is : " + url );
		return ( url != null );
	}

	public class onTreeSelection implements TreeSelectionListener
	{
		public void valueChanged ( TreeSelectionEvent e )
		{
			TreePath path = e.getNewLeadSelectionPath ();
			if ( path != null )
			{
				DefaultMutableTreeNode node = ( DefaultMutableTreeNode ) path.getLastPathComponent ();
				if ( node != null )
				{
					if ( node.isLeaf () )
					{
						BHelpItem hItem = ( BHelpItem ) node.getUserObject ();
						Debug.doPrintln ( "\n\nLeaf chosen : " + hItem );
						url = getClass ().getResource ( hItem.getAbs () );
						if ( url == null )
						{
							Debug.doPrintln ( "Couldn't get " + hItem.getItemName () + "'s absolute path." );
						}
					}
					else
					{
						url = null;
					}
					helpManager.setCurrentUrl ( url );
				}
			}
		}
	}

	private class onEnterPressed implements ActionListener
	{
		public void actionPerformed ( ActionEvent evt )
		{
			Debug.doPrintln ( "Two mouse clicks have been registered." );
			TreePath path = helpTree.getSelectionPath ();
			if ( path != null )
			{
				DefaultMutableTreeNode node = ( DefaultMutableTreeNode ) path.getLastPathComponent ();

				if ( node != null && node.isLeaf () )
				{
					BHelpItem item = ( BHelpItem ) node.getUserObject ();
					url = getClass ().getResource ( item.getAbs () );
					if ( url == null )
					{
						Debug.doPrintln ( "Couldn't get " + item.getItemName () + "'s absolute path." );
					}
					helpManager.jumpToPage ( url );
				}
			}
		}
	}

	 private class onMouseClicks extends MouseAdapter
	 {
		public void mouseClicked ( MouseEvent e )
		{
			if ( e.getClickCount () == 2 )
			{
				Debug.doPrintln ( "Two mouse clicks have been registered." );
				TreePath selectedPath = helpTree.getPathForLocation ( e.getX (), e.getY () );

				if ( selectedPath != null )
				{
					DefaultMutableTreeNode node = ( DefaultMutableTreeNode ) selectedPath.getLastPathComponent ();

					if ( node != null && node.isLeaf ())
					{
						BHelpItem item = ( BHelpItem ) node.getUserObject ();
						url = getClass ().getResource ( item.getAbs () );
						if ( url == null )
						{
							Debug.doPrintln ( "Couldn't get " + item.getItemName () + "'s absolute path." );
						}
						helpManager.jumpToPage ( url );
					}
				}
			}
		}
	 }
}
