// $Header: /teamproj/cvsroot/teamb/bkasrc/au/edu/swin/synergy/plugin/help/BFindTab.java,v 1.22 1999/09/23 08:52:35 tp079511 Exp $
/**
 * Please complete these missing tags
 * @author
 * @copyright
 * @bugs If help is open while new plugin is loaded, index will not be auto updated with latest items.
 */
package au.edu.swin.synergy.plugin.help;

import javax.swing.*;
import javax.swing.event.*;
import javax.swing.text.*;
import java.awt.*;
import java.awt.event.*;
import java.util.Vector;
import java.util.StringTokenizer;
import java.lang.String;
import java.net.URL;
import java.io.InputStream;
import java.io.File;
import java.io.StringWriter;

import au.edu.swin.synergy.plugin.help.BHelpUtil;
import au.edu.swin.synergy.plugin.help.BHelpItem;
import au.edu.swin.synergy.plugin.help.BHelpManager;
import au.edu.swin.synergy.debug.Debug;

import au.edu.swin.synergy.plugin.dialect.BDialect;
import au.edu.swin.synergy.plugin.mod13.bwt.BSwingUtilities;

public class BFindTab extends JPanel
{
    static final int kContain = 0;
    static final int kSimilar = 1;

    BHelpManager helpManager;
	URL url = null;

    JLabel searchLabel;
	JLabel statusLabel = new JLabel ();

    DefaultListModel listModel = new DefaultListModel();
    JList foundItemList = new JList( listModel );
    JScrollPane scrollingItemList = new JScrollPane( foundItemList );

    String[] containStrings = new String[2];

    JComboBox containBox;
	JButton searchButton;
    JTextField searchItem = new JTextField();
    GridBagLayout gbl = new GridBagLayout();
    /**
     * Please complete the missing tags for BFindTab
     * @param
     * @return
     * @pre
     * @post
     */

    public BFindTab( BHelpManager hm )
    {
        setSize( 400, 500 );

		searchLabel = new JLabel ( BDialect.getString ( this, "findsearch" ) );
		containStrings[0] = BDialect.getString ( this, "contain" );
		containStrings[1] = BDialect.getString ( this, "similar" );
		containBox = new JComboBox ( containStrings );
		searchButton = new JButton ( BDialect.getString ( this, "searchbutton" ) );

        setLayout( gbl );

        foundItemList.setSelectionMode( ListSelectionModel.SINGLE_SELECTION );
		foundItemList.addListSelectionListener ( new onListSelection () );
		foundItemList.addMouseListener ( new onMouseClicks () );
		foundItemList.registerKeyboardAction ( new onEnterPressed (), KeyStroke.getKeyStroke ( KeyEvent.VK_ENTER, 0 ), JComponent.WHEN_FOCUSED );

        GridBagConstraints c = new GridBagConstraints();

        BHelpUtil.setConst( c, 0, 0, 1, 1, BHelpUtil.kNone, BHelpUtil.kSW, BHelpUtil.kLightWeight );
        add( searchLabel, c );

        BHelpUtil.setConst( c, 0, 1, 1, 1, BHelpUtil.kHoriz, BHelpUtil.kW, BHelpUtil.kLightWeight );
        add( containBox, c );

        BHelpUtil.setConst( c, 1, 1, 2, 1, BHelpUtil.kHoriz, BHelpUtil.kW, BHelpUtil.kLightWeight );
        add( searchItem, c );
		searchItem.addActionListener ( new onSearchButton () );

        BHelpUtil.setConst( c, 0, 2, 1, 1, BHelpUtil.kHoriz, BHelpUtil.kW, BHelpUtil.kLightWeight );
		add ( statusLabel, c );

        BHelpUtil.setConst( c, 1, 2, 1, 1, BHelpUtil.kHoriz, BHelpUtil.kW, BHelpUtil.kLightWeight );
		add ( searchButton, c );
		searchButton.addActionListener ( new onSearchButton () );

        BHelpUtil.setConst( c, 0, 4, 2, 4, BHelpUtil.kBoth, BHelpUtil.kW, BHelpUtil.kHeavyWeight );
        add( scrollingItemList, c );

        helpManager = hm;
		helpManager.setTabRef ( this );
    }

	/**
	* Will update text on this tab to cater for current locale.
	*/
	public void doDialect ()
	{		
		BSwingUtilities.setJLabelText ( searchLabel, BDialect.getString ( this, "findsearch" ) );
		BSwingUtilities.setJButtonText ( searchButton, BDialect.getString ( this, "searchbutton" ) );
		containStrings[0] = BDialect.getString ( this, "contain" );
		containStrings[1] = BDialect.getString ( this, "similar" );
	}

    /**
     * Returns the url of the currently selected help item.
     * @return URL of selected item.
     */
	public URL getUrl ()
	{
		return url;
	}

	public boolean isItemSelected ()
	{
		Debug.doPrintln ( "url is : " + url );
		return ( url != null );
	}

    public void insertListItem( BHelpItem item )
    {
		Debug.doPrintln ( "Inserting " + item + " into list model" );
        listModel.addElement( item );
    }

    /**
     * Clears list contained in find box.
     * @post List is clear of any items.
     */
    public void clearList()
    {
        listModel.clear();
    }

    /**
     * Searches for an exact match or "urlText" in "searchStr".
     * @param urlText Text which has been extracted from a help page.
	 * @param searchStr String which we are looking for.
     * @return True if "searchStr" found in "urlText".
     * @pre Search text box contains some text.
     */
    public boolean findContains( String urlText, String searchStr )
    {
		boolean found = false;
		StringTokenizer st = new StringTokenizer ( urlText, "!. \n,?:;" );

		Debug.doPrintln ( "\n\nSearching for : " + searchStr + " : in\n" + urlText );
		while ( st.hasMoreTokens () && !found )
		{
			if ( st.nextToken ().compareToIgnoreCase ( searchStr ) == 0 )
			{
				found = true;
			}
		}
        // Get all items from manager.
        // Search for particular string adhering to condition
        // Add each item to list.

		return found;
    }

	public boolean findSimilar ( String urlText, String searchStr )
	{
		boolean found = false;

		Debug.doPrintln ( "\n\nSearching for : " + searchStr + " : in\n" + urlText );
		if ( urlText.toUpperCase ().indexOf ( searchStr.toUpperCase () ) >= 0 )
		{
			found = true;
		}

		return found;
	}

	 private class onMouseClicks extends MouseAdapter
	 {
		public void mouseClicked ( MouseEvent e )
		{
			int index = foundItemList.locationToIndex ( e.getPoint () );
			BHelpItem item = ( BHelpItem ) listModel.getElementAt ( index );
			if ( item != null )
			{
				if ( e.getClickCount () == 2 )
				{
					Debug.doPrintln ( "Two mouse clicks have been registered." );
					// Automatically display selected page.
					url = getClass ().getResource ( item.getAbs () );

					helpManager.jumpToPage ( url );
				}
			}
		}
	 }

	private class onListSelection implements ListSelectionListener
	{
		public void valueChanged ( ListSelectionEvent e )
		{
			BHelpItem item = ( BHelpItem ) foundItemList.getSelectedValue ();

			// So we keep a record of the possible page user wants to display.
			url = getClass ().getResource ( item.getAbs () );
			if ( url == null )
			{
				Debug.doPrintln ( "Couldn't get " + item.getItemName () + "'s absolute path." );
			}
			else
			{			
				helpManager.setCurrentUrl ( url );
			}
		}
	}

	private class onEnterPressed implements ActionListener
	{
		public void actionPerformed ( ActionEvent evt )
		{
			Debug.doPrintln ( "Enter has been pressed." );
			// Automatically display selected page.
			BHelpItem item = ( BHelpItem ) foundItemList.getSelectedValue ();

			if ( item != null )
			{
				url = getClass ().getResource ( item.getAbs () );

				if ( url == null )
				{
					Debug.doPrintln ( "Couldn't get " + item.getItemName () + "'s absolute path." );
				}
				else
				{
					helpManager.jumpToPage ( url );
				}
			}
		}
	}

	private boolean setUpPane ( JEditorPane pane, BHelpItem hi )
	{
		boolean success = false;

		try
		{
			URL tempUrl = getClass ().getResource ( hi.getAbs () );
			if ( tempUrl != null )
			{
				success = true;
				InputStream in = tempUrl.openStream ();
				int fileSize;
				String fileString;

				if ( ( fileSize = hi.getSize () ) > 0 )
				{
					byte[] byteArray = new byte [ fileSize ];
					in.read ( byteArray, 0, fileSize );
					fileString = new String ( byteArray );
				}
				else
				{
					StringWriter sWriter = new StringWriter ();
					int b;
					while ( ( b = in.read () ) != -1 )
					{
						sWriter.write ( b );
					}
					fileString = new String ( sWriter.toString () );
					// Could also set size to length of string.
					hi.setSize ( fileString.length () );
				}
				in.close ();

				pane.setText ( fileString );
			}
			else
			{
				Debug.doPrintln ( "Couldn't get " + hi.getItemName () + "'s absolute path.", Debug.kWarningLevel );
			}
		}
		catch ( Exception e )
		{
			Debug.doPrintln ( "Exception : " + e.getMessage () );
		}

		return success;
	}

	private class onSearchButton implements ActionListener
	{
		public void actionPerformed ( ActionEvent event )
		{
			BSwingUtilities.setJLabelText ( statusLabel, BDialect.getString ( this, "statussearch" ) );
			clearList ();

			Vector items = helpManager.getItems ();
			BHelpItem currentHelpItem;
			String urlText;
			int index;
			int count = 0;
			URL tempUrl;
			boolean itemFound;
			JEditorPane searchPane = new JEditorPane ();

			searchPane.setEditable ( false );
			searchPane.setContentType ( "text/html" );

			ElementIterator iter;
			Element element;
			for ( index = 0; index < items.size (); index++ )
			{
				try
				{
					itemFound = false;
					currentHelpItem = ( BHelpItem ) items.elementAt ( index );
					if ( setUpPane ( searchPane, currentHelpItem ) )
					{
						iter = new ElementIterator ( searchPane.getDocument () );
						element = iter.first ();
						while ( ( element != null ) && !itemFound ) // hasNext ();
						{
							if ( element.isLeaf () )
							{
								Document edoc = element.getDocument ();
								int beginning = element.getStartOffset ();
								int end = element.getEndOffset ();
								String text = null;
								int length = edoc.getLength ();
								try
								{
									if ( edoc != null )
									{
										text = edoc.getText ( beginning, end - beginning );
									}
								}
								catch ( BadLocationException ble )
								{
									Debug.doPrintln ( "Exception : " + ble.getMessage (), Debug.kWarningLevel );
								}

								if ( text != null && text.trim ().length () > 0 )
								{
									if ( containBox.getSelectedIndex () == kContain )
									{
										if ( ( itemFound = findContains ( text, searchItem.getText ().trim () ) ) )
										{
											insertListItem ( currentHelpItem );
											count++;
										}
									}
									else if ( containBox.getSelectedIndex () == kSimilar )
									{
										if ( ( itemFound = findSimilar ( text, searchItem.getText ().trim () ) ) )
										{
											insertListItem ( currentHelpItem );
											count++;
										}
									}

								}
							}
							element = iter.next ();
						}
					}
				}
				catch ( Exception e )
				{
					Debug.doPrintln ( e.getMessage (), Debug.kWarningLevel );
				}
			}
			BSwingUtilities.setJLabelText ( statusLabel, BDialect.getString ( this, "statuscomplete" ) + count );
		}
	}
}
