// $Header: /teamproj/cvsroot/teamb/bkasrc/au/edu/swin/synergy/plugin/help/BHelp.java,v 1.33 1999/10/17 03:28:20 tp079511 Exp $
/**
 * Please complete these missing tags
 * @author
 * @copyright
 */
package au.edu.swin.synergy.plugin.help;

import javax.swing.*;
import java.awt.Dimension;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.BorderLayout;
import java.lang.String;

import au.edu.swin.synergy.kernel.BPlugin;
import au.edu.swin.synergy.kernel.BCommandEvent;

import au.edu.swin.synergy.plugin.mod13.event.BAddToolBarCE;
import au.edu.swin.synergy.kernel.event.BBootCE;
import au.edu.swin.synergy.plugin.mod13.event.BAddMenuItemCE;
import au.edu.swin.synergy.plugin.mod13.event.BAddMenuCE;
import au.edu.swin.synergy.plugin.mod13.event.BAddWindowCE;
import au.edu.swin.synergy.plugin.mod13.bwt.BWindowAdapter;
import au.edu.swin.synergy.plugin.mod13.bwt.BWindowEvent;
import au.edu.swin.synergy.plugin.mod13.bwt.BSwingUtilities;
import au.edu.swin.synergy.plugin.help.event.BRegisterHelpCE;

import au.edu.swin.synergy.plugin.help.BHelpManager;
import au.edu.swin.synergy.plugin.help.BHelpScreen;

import au.edu.swin.synergy.plugin.dialect.BString;
import au.edu.swin.synergy.plugin.dialect.event.BDialectChangeCE;

import au.edu.swin.synergy.lib.BStringList;
import au.edu.swin.synergy.plugin.dialect.BDialect;

import au.edu.swin.synergy.debug.Debug;

public class BHelp extends BPlugin
{
    // Done like this for the moment for testing purposes.
    // Will be done through mod13 later on.
    BHelpManager helpManager;

	BHelpScreen helpScreen;

    JMenuItem helpItem;
    JMenuItem aboutItem;

    JButton speedButton = null;

    BCohesionAboutPanel aboutBox = null;

    /**
     * Please complete the missing tags for setup
     * @param
     * @return
     * @pre
     * @post
     */

    public void setup(BStringList params)
    {
		helpManager = new BHelpManager ( this );
        helpScreen = new BHelpScreen ( helpManager, this );
        speedButton = new JButton ( BSwingUtilities.getImage (this, "/au/edu/swin/synergy/plugin/help/icons/help.gif") );
        speedButton.addActionListener ( new onSpeedButton () );
        speedButton.setRequestFocusEnabled ( false );
        // Just while no icon is set.
        speedButton.setPreferredSize ( new Dimension ( 16, 16 ) );
        registerMenu();

        // Ensure that this button is always placed last.
        BAddToolBarCE e = new BAddToolBarCE ( this, -10 );
        e.addButton ( speedButton );
        dispatchEvent ( e );

        this.doDialect ();
    }
    /**
     * Please complete the missing tags for onBCommandEvent
     * @param
     * @return
     * @pre
     * @post
     */

    public void onBCommandEvent( Object souce, BCommandEvent event )
    {
        // Receive such events to add plugin data to help.
        if( event instanceof BBootCE )
        {
            // do boot stuff.

        }
        else if( event instanceof BRegisterHelpCE )
        {
            // Get info out of event and give it to the help manager.
            BRegisterHelpCE e = ( BRegisterHelpCE ) event;

            synchronized( helpManager )
            {
                helpManager.addHelpModule( e.getHelpModel() );
            }
        }
		else if ( event instanceof BDialectChangeCE )
		{
			this.doDialect ();
		}
    }
    /**
     * Please complete the missing tags for registerMenu
     * @param
     * @return
     * @pre
     * @post
     */

    private void registerMenu()
    {
		aboutItem = new JMenuItem ();
        aboutItem.addActionListener( new onAbout() );
		helpItem = new JMenuItem ("helpme");
        helpItem.addActionListener( new onHelpContents() );

        BAddMenuItemCE addMenuItems = new BAddMenuItemCE( this, aboutItem, new BString(this, "about"), new BString(this, "menuName") );
        addMenuItems.addSeparator();
        addMenuItems.addMenuItem(helpItem, new BString(this, "helpcontents"));
		addMenuItems.setPreferredMenuMnemonic(new BString(this, "menuKey"));

        //Set alignment
        addMenuItems.setLocationPolicy(BAddMenuCE.kAlwaysRightAligned);

        dispatchEvent( addMenuItems );
    }

	public void doDialect ()
	{
        BSwingUtilities.setToolTip ( speedButton, BDialect.getString ( this, "help" ) );
		helpManager.doDialect ();
		helpScreen.doDialect ();
	}

    private void displayHelp ()
    {
        BAddWindowCE event = new BAddWindowCE( this, helpScreen, new BString(this, "help") );
//		event.setDialog ( true );
		event.setModal ( false );
        event.addWindowListener ( new helpWindowListener () );

        dispatchEvent( event );
    }

    public class onHelpContents implements ActionListener
    {
		JPanel helpPanel = new JPanel ();

        public void actionPerformed( ActionEvent e )
        {
            Debug.doPrintln ( "Displaying help..." );
            displayHelp ();
        }
    }

    public class onSpeedButton implements ActionListener
    {
        public void actionPerformed ( ActionEvent e )
        {
            displayHelp ();
        }
    }

    public class onAbout implements ActionListener
    {
        public void actionPerformed( ActionEvent e )
        {
            if (aboutBox == null)
            {
                aboutBox = new BCohesionAboutPanel(BHelp.this);
            }
            
            BAddWindowCE event = new BAddWindowCE( this, aboutBox, new BString(this, "about") );
			event.setDialog ( true );
			event.setModal ( false );

            dispatchEvent( event );
        }
    }


	public class helpWindowListener extends BWindowAdapter
	{
		public void windowOpened ( BWindowEvent windowEvent )
		{
			helpManager.clearIndexList ();
			helpManager.updateIndex ();
		}
	}
}
