// $Header: /teamproj/cvsroot/teamb/bkasrc/au/edu/swin/synergy/plugin/help/BHelpManager.java,v 1.25 1999/10/17 22:31:30 tp079568 Exp $
/**
 * Please complete these missing tags
 * @author Christian Karolos
 * @copyright
 */
package au.edu.swin.synergy.plugin.help;

import au.edu.swin.synergy.plugin.help.BHelpViewpane;
import au.edu.swin.synergy.plugin.help.BHelpTreeModel;
import au.edu.swin.synergy.plugin.help.BIndexTab;
import au.edu.swin.synergy.plugin.help.BContentTab;
import au.edu.swin.synergy.plugin.help.BFindTab;
import au.edu.swin.synergy.debug.Debug;
import au.edu.swin.synergy.kernel.BPlugin;
import au.edu.swin.synergy.plugin.mod13.event.BAddWindowCE;
import au.edu.swin.synergy.plugin.mod13.bwt.BWindowEvent;
import au.edu.swin.synergy.plugin.mod13.bwt.BWindowAdapter;
import au.edu.swin.synergy.plugin.mod13.bwt.BSwingUtilities;

import au.edu.swin.synergy.plugin.dialect.BString;
import au.edu.swin.synergy.plugin.dialect.BDialect;

import javax.swing.JButton;
import javax.swing.tree.*;
import javax.swing.*;
import java.util.Vector;
import java.util.Enumeration;
import java.net.URL;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;

public class BHelpManager
{
    DefaultMutableTreeNode rootNode;
    DefaultTreeModel helpTreeModel;
	URL currentUrl;
	URL homeUrl;
	JButton displayButtonRef;
	BHelpViewpane viewpane;
	BPlugin owner;

	boolean displayViewable;
	BIndexTab indexTabRef;
	BContentTab contentTabRef;
	BFindTab findTabRef;
    /**
     * Please complete the missing tags for BHelpManager
     * @param
     * @return
     * @pre
     * @post
     */

    public BHelpManager( BPlugin parent )
    {
		try
		{
			owner = parent;
			rootNode = new DefaultMutableTreeNode( BDialect.getString ( this, "rootnode" ) );
			helpTreeModel = new DefaultTreeModel( rootNode );
			// Initialise with home page.
			homeUrl = new URL ( "/au/edu/swin/synergy/plugin/help/main.html" );
		}
		catch ( Exception e )
		{
			Debug.doPrintln ( "Exception : " + e.getMessage () );
		}
    }

	public void doDialect ()
	{
		// This should really go through all help items and
		// update, but I think, as Tristen would say "after
		// wednesday"!

		DefaultMutableTreeNode node = ( DefaultMutableTreeNode ) helpTreeModel.getRoot ();
        BSwingUtilities.setUserObject(node, BDialect.getString ( this, "rootnode" ));
	}

    public void setViewpane ( BHelpViewpane vp )
    {
        viewpane = vp;
    }

	public void setTabRef ( JComponent tab )
	{
		if ( tab instanceof BContentTab )
		{
			contentTabRef = ( BContentTab ) tab;
		}
		else if ( tab instanceof BIndexTab )
		{
			indexTabRef = ( BIndexTab ) tab;
		}
		else if ( tab instanceof BFindTab )
		{
			findTabRef = ( BFindTab ) tab;
		}
		else
		{
			Debug.doPrintln ( "Tab not supported by this help manager." );
		}
	}

    /**
     * Please complete the missing tags for getItems
     * @param
     * @return
     * @pre
     * @post
     */
	public void registerDisplayButton ( JButton button )
	{
		displayButtonRef = button;

		displayButtonRef.addActionListener ( new onDisplay () );

		// Button should be defaulted to disabled when loaded.
		displayButtonRef.setEnabled ( false );
	}

	public void validateDisplay ( JComponent comp )
	{
		boolean enable = false;
		// Better to do this using interface or polymorphism, but for now...
		if ( comp instanceof BContentTab )
		{
			enable = contentTabRef.isItemSelected ();
			currentUrl = contentTabRef.getUrl ();
		}
		else if ( comp instanceof BIndexTab )
		{
			enable = indexTabRef.isItemSelected ();
			currentUrl = indexTabRef.getUrl ();
		}
		else if ( comp instanceof BFindTab )
		{
			enable = findTabRef.isItemSelected ();
			currentUrl = findTabRef.getUrl ();
		}
		else
		{
			Debug.doPrintln ( "Validate Display - component instance of nothing" );
		}

		displayButtonRef.setEnabled ( enable );
	}

    /**
     * Please complete the missing tags for getItems
     * @param
     * @return
     * @pre
     * @post
     */

	public URL getHome ()
	{
		Class c = getClass ();
		URL homePage = null;
		if ( c == null )
		{
			Debug.doPrintln ( "CLASS == NULL", Debug.kWarningLevel );
		}
		else
		{
			homePage = c.getResource ( "/au/edu/swin/synergy/plugin/help/main.html" );
		}

		return homePage;
	}

    /**
     * When user double clicks on node, they can call this to
	 * jump straight to the associated page without clicking
	 * "Display".
     * @param
     * @return
     * @pre
     * @post
     */
	public void jumpToPage ( URL url )
	{
		Debug.doPrintln ( "Jumping to page" );
/*		if ( displayViewable == false )
		{
			// If not viewable then display.
			displayViewpane ();
		}
/**/
		// So we know which page is currently displayed.
		setCurrentUrl ( url );
		viewpane.setHelpPage ( url );
	}

    /**
     * To include the ability of updating the index when plugins are
	 * loaded during run-time, this is called to make sure the index
	 * has all the latest items.
     * @param
     * @return
     * @pre
     * @post
     */
	public void updateIndex ()
	{
		Debug.doPrintln ( "BHelpManger.updateIndex ()" );
		if ( indexTabRef != null )
		{
			Vector leaves = getItems ();
			indexTabRef.doInitList ( leaves );
		}
		else
		{
			Debug.doPrintln ( "Reference to Index tab hasn't been set in HELP MANAGER" );
		}
	}

	public void clearIndexList ()
	{
		if ( indexTabRef != null )
		{
			indexTabRef.clearList ();
		}
		else
		{
			Debug.doPrintln ( "Reference to Index tab hasn't been set in HELP MANAGER" );
		}
	}

    /**
     * Please complete the missing tags for getItems
     * @param
     * @return
     * @pre
     * @post
     */
	public void setCurrentUrl ( URL url )
	{
		currentUrl = url;

		// Button has been registered...
		if ( displayButtonRef != null )
		{
			if ( currentUrl != null )
			{
				displayButtonRef.setEnabled ( true );
			}
			else
			{
				displayButtonRef.setEnabled ( false );
			}
		}
		else
		{
			Debug.doPrintln ( "\nDisplay button ref hasn't been set in HELP MANAGER!\n" );
		}
	}

    /**
     * Please complete the missing tags for getItems
     * @param
     * @return
     * @pre
     * @post
     */
	public URL getCurrentUrl ()
	{
		return currentUrl;
	}

    /**
     * Please complete the missing tags for getModel
     * @param
     * @return
     * @pre
     * @post
     */

    public DefaultTreeModel getModel()
    {
        return helpTreeModel;
    }
    /**
     * Please complete the missing tags for getItems
     * @param
     * @return
     * @pre
     * @post
     */

    public Vector getItems()
    {
        DefaultMutableTreeNode node;
        Vector items = new Vector( 5, 5 );

		Debug.doPrintln ( "\nBHelpManager.getItems()\n\n" );
        for( Enumeration enum = rootNode.breadthFirstEnumeration(); enum.hasMoreElements(); )
        {
            node = ( DefaultMutableTreeNode ) enum.nextElement();
            if( node.isLeaf() )
            {
				Debug.doPrintln ( "Inserting following node to item list : " + node );
                items.add( node.getUserObject () );
            }
        }

        return items;
    }
    /**
     * Please complete the missing tags for addHelpModule
     * @param
     * @return
     * @pre
     * @post
     */

    public void addHelpModule( BHelpTreeModel model )
    {
        DefaultMutableTreeNode branch = model.getRoot();
        if( branch != null )
        {
            helpTreeModel.insertNodeInto( branch, rootNode, rootNode.getChildCount() );
        }
    }

	private void displayViewpane ()
	{
		viewpane = new BHelpViewpane ( this );
		BAddWindowCE event = new BAddWindowCE ( this, viewpane, new BString(this, "helpcontents" ));
		event.setDialog ( true );
		event.setModal ( false );
		event.addWindowListener ( new displayWindowListener () );

		owner.dispatchEvent ( event );
	}

    public class onDisplay implements ActionListener
    {
        public void actionPerformed( ActionEvent e )
        {
/*			if ( !displayViewable )
			{
				Debug.doPrintln ( "Creating viewpane" );
				Debug.doPrintln ( "VIEWABLE" );
				displayViewpane ();
			}
/**/
			viewpane.setHelpPage ( getCurrentUrl () );
        }
    }

	public class displayWindowListener extends BWindowAdapter
	{
		public void windowClosing ( BWindowEvent windowEvent )
		{
			// When display hit, we can tell whether we need to reopen the window.
			Debug.doPrintln ( "viewable false" );
			displayViewable = false;
		}

		public void windowOpened ( BWindowEvent windowEvent )
		{
			Debug.doPrintln ( "viewable true" );
			displayViewable = true;
		}
	}

}
