// $Header:

/**
*
* @author Christian Karolos
* @date 28/9/99
*/

package au.edu.swin.synergy.plugin.help;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

import au.edu.swin.synergy.plugin.help.BHelpViewpane;
import au.edu.swin.synergy.plugin.help.BHelpTabbedPane;
import au.edu.swin.synergy.plugin.help.BHelpManager;

import au.edu.swin.synergy.kernel.BPlugin;

import au.edu.swin.synergy.plugin.dialect.BDialect;

import au.edu.swin.synergy.plugin.mod13.event.BCloseWindowCE;
import au.edu.swin.synergy.plugin.mod13.bwt.BSwingUtilities;

import au.edu.swin.synergy.debug.Debug;

public class BHelpScreen extends JPanel
{
    BHelpTabbedPane tabs;
    BHelpViewpane view;

    JButton displayButton;
    JButton closeButton;

    BPlugin parent;

    BCloseWindowCE closeEvent;

    public BHelpScreen ( BHelpManager hm, BPlugin plugRef )
    {
        parent = plugRef;

        tabs = new BHelpTabbedPane ( hm );
        view = new BHelpViewpane ( hm );
        hm.setViewpane ( view );

        displayButton = new JButton ( BDialect.getString ( this, "displaybutton" ) );
        hm.registerDisplayButton ( displayButton );

        closeButton = new JButton ( BDialect.getString ( this, "closebutton" ) );
        closeButton.addActionListener ( new onClose () );

        closeEvent = new BCloseWindowCE ( this, this );

        initPanel ();
    }

    private void initPanel ()
    {
        setSize ( 600, 550 );
        setLayout ( new GridBagLayout () );
        GridBagConstraints c = new GridBagConstraints ();

        setConst ( c, 0, 0, 2, 1, GridBagConstraints.CENTER, GridBagConstraints.BOTH, 0, 1 );
        add ( tabs, c );

        setConst ( c, 2, 0, 1, 2, GridBagConstraints.CENTER, GridBagConstraints.BOTH, 1, 1 );
        add ( view, c );

        setConst ( c, 0, 1, 1, 1, GridBagConstraints.CENTER, GridBagConstraints.NONE, 0, 0 );
        add ( closeButton, c );

        setConst ( c, 1, 1, 1, 1, GridBagConstraints.CENTER, GridBagConstraints.NONE, 0, 0 );
        add ( displayButton, c );

    }

    public void doDialect ()
    {
        BSwingUtilities.setJButtonText ( displayButton, BDialect.getString ( this, "displaybutton" ) );
        BSwingUtilities.setJButtonText ( closeButton, BDialect.getString ( this, "closebutton" ) );

        tabs.doDialect ();
        view.doDialect ();
    }

	/**
	* Custom made function for plotting labels and combo boxes on a panel.
	* Panel shouldn't be expandable, so concerning attribs are fixed.
	*/
	public void setConst( GridBagConstraints gbc, int x, int y, int w, int h, int anc, int fill, int wx, int wy )
	{
		gbc.gridx = x;
		gbc.gridy = y;
		gbc.gridwidth = w;
		gbc.gridheight = h;
		gbc.fill = fill;
		gbc.anchor = anc;
		gbc.insets = new Insets ( 5, 5, 5, 5 );

		// Only a light weight so things don't expand too much.
		gbc.weightx = wx;
		gbc.weighty = wy;
		gbc.ipady = 5;
		gbc.ipadx = 5;
	}   

    private class onClose implements ActionListener
    {
        public void actionPerformed ( ActionEvent e )
        {
            parent.dispatchEvent ( closeEvent );
        }
    }
}