package au.edu.swin.synergy.plugin.help;

import javax.swing.tree.*;
import java.lang.String;

public class BHelpTreeModel
{
    DefaultTreeModel treeModel;
    DefaultMutableTreeNode rootNode;

    public BHelpTreeModel ( String rootTitle )
    {
        rootNode = new DefaultMutableTreeNode ( rootTitle );
        treeModel = new DefaultTreeModel ( rootNode );
    }

    public DefaultMutableTreeNode addBranch ( DefaultMutableTreeNode parent, String label )
    {
        return addObject ( parent, label );
    }

    public void addHelpItem ( DefaultMutableTreeNode parent, BHelpItem item )
    {
        addObject ( parent, item );
    }

    private DefaultMutableTreeNode addObject ( DefaultMutableTreeNode parent, Object o )
    {
        DefaultMutableTreeNode child = new DefaultMutableTreeNode ( o );

        if ( parent == null )
        {
            parent = rootNode;
        }

        treeModel.insertNodeInto ( child, parent, parent.getChildCount () );

        return child;
    }

    public DefaultTreeModel getModel ()
    {
        return treeModel;
    }

    public DefaultMutableTreeNode getRoot ()
    {
        return rootNode;
    }
}