// $Header: /teamproj/cvsroot/teamb/bkasrc/au/edu/swin/synergy/plugin/help/BIndexTab.java,v 1.20 1999/09/23 08:52:36 tp079511 Exp $
/**
 * Please complete these missing tags
 * @author
 * @copyright
 */
package au.edu.swin.synergy.plugin.help;

import javax.swing.*;
import javax.swing.event.*;
import javax.swing.text.*;
import java.awt.*;
import java.awt.event.*;
import java.util.Vector;
import java.util.Collections;
import java.net.URL;

import au.edu.swin.synergy.plugin.help.BHelpUtil;
import au.edu.swin.synergy.plugin.help.BHelpManager;
import au.edu.swin.synergy.plugin.help.BHelpItem;
import au.edu.swin.synergy.debug.Debug;

import au.edu.swin.synergy.plugin.dialect.BDialect;
import au.edu.swin.synergy.plugin.mod13.bwt.BSwingUtilities;

public class BIndexTab extends JPanel// implements BHelpInterface (?)
{
    BHelpManager helpManager;

    JTextField searchField = new JTextField();
    JList itemList;
    DefaultListModel itemListModel;
    JScrollPane scrollingItemList;
    JLabel searchLabel;
	URL url = null;
    /**
     * Please complete the missing tags for BIndexTab
     * @param
     * @return
     * @pre
     * @post
     */

    public BIndexTab( BHelpManager hm )
    {
        super( new GridBagLayout() );

		searchLabel = new JLabel( BDialect.getString ( this, "indexsearch" ) );

        setSize( 400, 500 );

        GridBagConstraints c = new GridBagConstraints();
        BHelpUtil.setConst( c, 0, 0, 1, 1, BHelpUtil.kNone, BHelpUtil.kSW, BHelpUtil.kLightWeight );
        this.add( searchLabel, c );

        BHelpUtil.setConst( c, 0, 1, 1, 1, BHelpUtil.kHoriz, BHelpUtil.kW, BHelpUtil.kLightWeight );
        this.add( searchField, c );
		searchField.getDocument ().addDocumentListener ( new onKeyTyped () );
		searchField.addActionListener ( new onEnterPressed () );

        itemListModel = new DefaultListModel();
        itemList = new JList( itemListModel );
		itemList.addListSelectionListener ( new onListSelection () );
		itemList.addMouseListener ( new onMouseClicks () );
		itemList.registerKeyboardAction ( new onEnterPressed (), KeyStroke.getKeyStroke ( KeyEvent.VK_ENTER, 0 ), JComponent.WHEN_FOCUSED );

        scrollingItemList = new JScrollPane( itemList );
        BHelpUtil.setConst( c, 0, 2, 1, 4, BHelpUtil.kBoth, BHelpUtil.kCenter, BHelpUtil.kHeavyWeight );
        this.add( scrollingItemList, c );

        helpManager = hm;
		helpManager.setTabRef ( this );
    }

	/**
	* Will update all text associated with this panel to suite
	* current locale.
	*/
	public void doDialect ()
	{
		BSwingUtilities.setJLabelText ( searchLabel, BDialect.getString ( this, "indexsearch" ) );
	}
	
    /**
     * Please complete the missing tags for insertListItem
     * @param
     * @return
     * @pre
     * @post
     */

	public URL getUrl ()
	{
		return url;
	}

	public boolean isItemSelected ()
	{
		Debug.doPrintln ( "url is : " + url );
		return ( url != null );
	}

    public void insertListItem( BHelpItem item )
    {
        itemListModel.addElement( item );
    }
    /**
     * Please complete the missing tags for clearList
     * @param
     * @return
     * @pre
     * @post
     */

    public void clearList()
    {
        itemListModel.clear();
    }
    /**
     * Please complete the missing tags for doInitList
     * @param
     * @return
     * @pre
     * @post
     */

    public void doInitList( Vector items )
    {
        // Get items from manager.
        Vector toSortList = items;

        // Sort.
		Debug.doPrintln ( "Sorting list..." );
        Collections.sort( toSortList );

        // Insert to list.
        insertToListModel( toSortList );
    }
    /**
     * Please complete the missing tags for getItems
     * @param
     * @return
     * @pre
     * @post
     */

    private void insertToListModel( Vector items )
    {
		BHelpItem hi;
        for( int i = 0; i < items.size(); i++ )
        {
			hi = ( BHelpItem ) items.elementAt ( i );
			Debug.doPrintln ( "Inserting " + hi.toString () );
            itemListModel.addElement ( hi );
        }
    }

	private class onKeyTyped implements DocumentListener
	{
		public void insertUpdate ( DocumentEvent evt )
		{
			select ( searchField.getText () );
		}

		public void removeUpdate ( DocumentEvent evt )
		{
			select ( searchField.getText () );
		}

		public void changedUpdate ( DocumentEvent evt )
		{
			Debug.doPrintln ( "Changed Update just been called." );
		}
	}

	private void select ( String text )
	{
		BHelpItem item = null;
		boolean found = false;
		int i = 0;
		int size = itemListModel.getSize ();
		if ( size > 0 )
		{
			for ( i = 0; i < size && !found; i++ )
			{
				item = ( BHelpItem ) itemListModel.getElementAt ( i );
				found = item.getItemName ().toUpperCase ().startsWith ( text.toUpperCase () );
			}
			if ( found )
			{
				// i is increments when loop exits.  Could be done another way
				// but, is works, is good.
				itemList.setSelectedValue ( item, true );
			}
		}
	}

	private class onListSelection implements ListSelectionListener
	{
		public void valueChanged ( ListSelectionEvent e )
		{
			BHelpItem item = ( BHelpItem ) itemList.getSelectedValue ();

			// Keep our own record
			url = getClass ().getResource ( item.getAbs () );
			if ( url == null )
			{
				Debug.doPrintln ( "Couldn't get " + item.getItemName () + "'s absolute path." );
			}

			helpManager.setCurrentUrl ( url );
		}
	}

	private class onEnterPressed implements ActionListener
	{
		public void actionPerformed ( ActionEvent evt )
		{
			Debug.doPrintln ( "Enter has been pressed." );
			// Automatically display selected page.
			BHelpItem item = ( BHelpItem ) itemList.getSelectedValue ();

			if ( item != null )
			{
				url = getClass ().getResource ( item.getAbs () );
				if ( url == null )
				{
					Debug.doPrintln ( "Couldn't get " + item.getItemName () + "'s absolute path." );
				}
				
				helpManager.jumpToPage ( url );
			}
		}
	}

    /**
     * Please complete the missing tags for getItems
     * @param
     * @return
     * @pre
     * @post
     */
	 private class onMouseClicks extends MouseAdapter
	 {
		public void mouseClicked ( MouseEvent e )
		{
			int index = itemList.locationToIndex ( e.getPoint () );
			BHelpItem item = ( BHelpItem ) itemListModel.getElementAt ( index );
			if ( item != null )
			{
				if ( e.getClickCount () == 1 )
				{
					searchField.setText ( item.getItemName () );
				}
				else if ( e.getClickCount () == 2 )
				{
					Debug.doPrintln ( "Two mouse clicks have been registered." );
					// Automatically display selected page.
					url = getClass ().getResource ( item.getAbs () );
					if ( url == null )
					{
						Debug.doPrintln ( "Couldn't get " + item.getItemName () + "'s absolute path." );
					}

					helpManager.jumpToPage ( url );
				}
			}
		}
	 }
}
