

//$Header: /teamproj/cvsroot/teamb/bkasrc/au/edu/swin/synergy/plugin/metamodeller/BConnectNodeRule.java,v 1.3 1999/09/06 09:41:35 tp079479 Exp $

package au.edu.swin.synergy.plugin.metamodeller;

import java.io.Serializable;

public class BConnectNodeRule implements Serializable
{
	public static final boolean kDefaultValue = false;

	private boolean arcGrid[][][] = null;
	private int numArcs, numNodes;

	public BConnectNodeRule( int numArcs, int numNodes )
	{				
		int i, j, k;

		this.numArcs = numArcs;
		this.numNodes = numNodes;
		this.arcGrid = new boolean[ numArcs ][ numNodes ][ numNodes ];

		for ( i = 0; i < numArcs; i++ )
		{
			for ( j = 0; j < numNodes; j++ )
			{
				for ( k = 0; k < numNodes; k++ )
				{
					this.arcGrid[i][j][k] = BConnectNodeRule.kDefaultValue;
				}
			}
			
		}
	}

	public final boolean evalConnect( int arc, int start, int end )
	{
		boolean result = BConnectNodeRule.kDefaultValue;

		if ( arc < this.numArcs && start < this.numNodes && end < this.numNodes )
		{
			result = this.arcGrid[arc][start][end];
		}

		return result;
	}

	public final boolean evalStartConnect( int arc, int start )
	{
		boolean result = BConnectNodeRule.kDefaultValue;
		int i;

		if ( arc < this.numArcs && start < this.numNodes )
		{
			for ( i = 0; i < this.numNodes && !result; i++ )
			{
				result = this.arcGrid[arc][start][i];
			}
		}

		return result;
	}

	public final void setConnect( int arc, int start, int end, boolean value )
	{		
		if ( arc < this.numArcs && start < this.numNodes && end < this.numNodes )
		{
			this.arcGrid[arc][start][end] = value;
		}	
	}
}