//$Header: /teamproj/cvsroot/teamb/bkasrc/au/edu/swin/synergy/plugin/metamodeller/BCreateElement.java,v 1.13 1999/10/16 02:32:53 tp079210 Exp $

   package au.edu.swin.synergy.plugin.metamodeller;

   import javax.swing.*;
   import javax.swing.border.*;
   import java.awt.event.*;
   import java.awt.*;
   import java.util.Vector;
   import javax.swing.SwingUtilities;

	import au.edu.swin.synergy.plugin.dialect.BDialect;

   import au.edu.swin.synergy.kernel.BPlugin;

   import au.edu.swin.synergy.plugin.mod13.event.BCloseWindowCE;

	/**
	 * Panel to allow users to create new Meta elements.
	 * Also provides means to add properties to these Meta elements
	 * @author Shane Fitzgibbon
	 */

   public class BCreateElement extends JPanel
   {
   	/**
   	 * Constant used to indicate that the panel should be a create node panel
   	 */
      public final static int kNode = 1;

   	/**
   	 * Constant used to indicate that the panel should be a create Arc panel
   	 */
      public final static int kArc = 2;

   	/**
   	 * Constant used to indicate that the panel should be a create rule panel
   	 */
      public final static int kRule = 3;

      /**
   	 * The metaelement being created
   	 */
      protected BMetaElement metaElement;

   	/**
   	 * The status of the operation
   	 */
	  private boolean canceled = false;

      JLabel nameLabel;
      JTextField nameField;
      JLabel newPropLabel;
      JLabel propListLabel;
      JList propList;
      JTextField newPropField;
      JButton addButton = new JButton();
      JPanel mainPanel;
      JButton okButton = new JButton();
      JButton cancelButton = new JButton();
      BPropListModel listModel;
      BPlugin plugin;

      public BCreateElement(int type, BPlugin plug)
      {
         this.plugin = plug;
         this.doInit( type );
      }

      public BMetaElement getMetaElement()
      {
      	 metaElement.resetProperties();
		 metaElement.setName(nameField.getText());
		 for ( int i = 0; i < listModel.getSize(); i++)
		 {
			metaElement.addProperty( (String) listModel.getElementAt(i) );
         }
         return metaElement;
      }

	  public boolean getStatus()
	  {
		return canceled;
	  }

	  public void addOKListener( ActionListener listener )
	  {
	  	okButton.addActionListener( listener );
	  }

	  public void addCancelListener( ActionListener listener )
	  {
	  	cancelButton.addActionListener( listener );
	  }

      protected void doInit(int type)
      {
         switch ( type )
         {
            case kNode:
               {
                  doInitNode();
                  break;
               }
            case kArc:
               {
                  doInitArc();
                  break;
               }
            case kRule:
               {
                  doInitRule();
                  break;
               }
            default:
               {
                  doInitNode();
                  break;
               }
         }
      }


      private void doInitNode()
      {
         metaElement = new BMetaNode();
         init(BDialect.getString ( this, "nodename" ) );
      }

      private void doInitArc()
      {
         metaElement = new BMetaArc();
         init(BDialect.getString ( this, "arcname" ) );
      }

      private void doInitRule()
      {
         metaElement = new BMetaRule();
         init(BDialect.getString ( this, "rulename") );
      }


      private void add(JPanel panel, Component c, GridBagConstraints gbc, int x, int y, int w, int h )

      {
         gbc.gridx = x;
         gbc.gridy = y;
         gbc.gridwidth = w;
         gbc.gridheight = h;
         panel.add( c, gbc );
      }

      class BOnOK implements ActionListener
      {
         public void actionPerformed( ActionEvent event )
         {
            metaElement.resetProperties();
            metaElement.setName(nameField.getText());
            for ( int i = 0; i < listModel.getSize(); i++)
            {
               metaElement.addProperty( (String) listModel.getElementAt(i) );
            }
			canceled = false;
            BCloseWindowCE closeWindow = new BCloseWindowCE( this, BCreateElement.this );
            plugin.dispatchEvent( closeWindow );

         }
      }

      class BOnCancel implements ActionListener
      {
         public void actionPerformed( ActionEvent event )
         {

			canceled = true;
            BCloseWindowCE closeWindow = new BCloseWindowCE( this, BCreateElement.this );
            plugin.dispatchEvent( closeWindow );
         }
      }

      class BOnAdd implements ActionListener
      {
         public void actionPerformed( ActionEvent event )
         {
            listModel.addItem( newPropField.getText() );
            newPropField.setText("");

         }
      }

	 private void init( String text )
	 {
		String labelName = text;
		nameLabel = new JLabel( labelName );
		BCreateElement.this.setLayout( new BorderLayout() );
		mainPanel = new JPanel();
		mainPanel.setSize( 488, 309 );
		mainPanel.setLayout( new GridBagLayout());
		GridBagConstraints gbc = new GridBagConstraints();
		gbc.insets = new Insets(0, 5, 0, 5);
		gbc.fill = GridBagConstraints.NONE;
		gbc.weightx = 1.0;
		gbc.weighty = 1.0;
		nameLabel.setHorizontalAlignment(SwingConstants.CENTER);
		add(mainPanel, nameLabel, gbc, 0, 0, 1, 1 );
		nameLabel.setBounds( 60, 36, 118, 32 );
		nameField = new JTextField();
		gbc.fill = GridBagConstraints.HORIZONTAL;
		add(mainPanel, nameField, gbc, 4, 0, 2, 2 );
		nameField.setBounds( 264, 36, 156, 36 );
		newPropLabel = new JLabel(BDialect.getString ( this, "newprop" ));
		newPropLabel.setHorizontalAlignment(SwingConstants.CENTER);
		gbc.fill = GridBagConstraints.NONE;
		add(mainPanel, newPropLabel, gbc, 0, 2, 3, 1 );
		newPropLabel.setBounds( 60, 96, 128, 38 );
		propListLabel = new JLabel(BDialect.getString ( this, "proplist" ));
		propListLabel.setHorizontalAlignment(SwingConstants.CENTER);
		gbc.fill = GridBagConstraints.NONE;
		add(mainPanel, propListLabel, gbc, 4, 2, 1, 1);
		propListLabel.setBounds( 264, 96, 155, 38 );
		listModel= new BPropListModel();
		propList = new JList(listModel);
		JScrollPane listPane = new JScrollPane( propList );
		gbc.fill = GridBagConstraints.BOTH;
		add(mainPanel, listPane, gbc, 4, 3, 2, 4 );
		listPane.setBounds( 60, 144, 126, 36 );
		newPropField = new JTextField();
		gbc.fill = GridBagConstraints.HORIZONTAL;
		gbc.anchor = GridBagConstraints.NORTH;
		add(mainPanel, newPropField, gbc, 0, 3, 2, 1 );
		newPropField.setBounds( 60, 144, 126, 36 );
		addButton.setText(">");
		addButton.addActionListener( new BOnAdd() );
		gbc.fill = GridBagConstraints.NONE;
		add (mainPanel, addButton, gbc, 3, 3, 1, 1 );
		addButton.setBounds( 192, 144, 66, 36 );
		JPanel controlPanel = new JPanel();
		FlowLayout fLayout = new FlowLayout();
		fLayout.setAlignment( FlowLayout.RIGHT );
		controlPanel.setLayout( fLayout );
		okButton.setText( BDialect.getString ( "ok" ) );
		//okButton.addActionListener( new BOnOK() );
		cancelButton.setText( BDialect.getString ( "cancel" ) );
		//cancelButton.addActionListener( new BOnCancel() );
		controlPanel.add(okButton);
		controlPanel.add(cancelButton);
		BCreateElement.this.add( mainPanel, "Center");
		BCreateElement.this.add( controlPanel, "South");
	 }




   }