//$Header: /teamproj/cvsroot/teamb/bkasrc/au/edu/swin/synergy/plugin/metamodeller/BEditElement.java,v 1.12 1999/10/15 10:50:07 tp079479 Exp $

   package au.edu.swin.synergy.plugin.metamodeller;

   import au.edu.swin.synergy.kernel.BPlugin;
   import au.edu.swin.synergy.debug.Debug;

   import javax.swing.*;
   import javax.swing.border.*;
   import javax.swing.event.*;
   import javax.swing.tree.*;
   import java.awt.event.*;
   import java.awt.*;
   import java.util.Vector;
   import javax.swing.SwingUtilities;

	import au.edu.swin.synergy.plugin.dialect.BDialect;
	import au.edu.swin.synergy.plugin.mod13.bwt.BSwingUtilities;

   public class BEditElement extends JPanel
   {
	
		BPlugin plugin;   
		BMetaElement metaElement = null;


		JLabel propNameLabel = null;
		JLabel newPropLabel = null;
		JLabel propListLabel = null;
		JLabel removePropListLabel = null;

		JTextField propNameField = null;
		JTextField newPropField = null;

		JList propList = null;
		JList removeList = null;		

		BPropListModel listModel = null;
		BPropListModel removeListModel = null;

		JButton addPropButton = null;
		JButton	removePropButton = null;
		JButton reAddPropButton = null;
		JTree tree;


      public BEditElement(BPlugin plug, JTree tree)
      {
         super();

		 this.plugin = plug;
		 this.tree = tree;

		 this.setLayout( new GridBagLayout() );

		 this.doInit();
      
      }

	  public void doInit()
	  {
			GridBagConstraints gbc = new GridBagConstraints();

			//////////the name label////////////////
			propNameLabel = new JLabel(BDialect.getString ( this, "elementname" ));
			gbc.gridx = 0;
			gbc.gridy = 0;
			gbc.gridwidth = 1;
			gbc.gridheight = 1;
			gbc.weightx = 0;
			gbc.weighty = 0;
			gbc.fill = GridBagConstraints.HORIZONTAL;
			gbc.anchor = GridBagConstraints.EAST;
			gbc.insets = new Insets(5, 5, 5, 5);
			gbc.ipadx = 2;
			gbc.ipady = 2;
			this.add( propNameLabel, gbc );

			//////////////the name field/////////////////
			propNameField = new JTextField();
			propNameField.addFocusListener( new BNameFocus() );
			gbc.gridx = 1;
			gbc.gridy = 0;
			gbc.gridwidth = 4;
			gbc.gridheight = 1;
			gbc.weightx = 1;
			gbc.weighty = 0;
			gbc.fill = GridBagConstraints.HORIZONTAL;
			gbc.anchor = GridBagConstraints.CENTER;
			gbc.insets = new Insets(5, 5, 5, 5);
			gbc.ipadx = 2;
			gbc.ipady = 2;
			this.add( propNameField, gbc );



			//////////the prop label////////////////
			newPropLabel = new JLabel(BDialect.getString ( this, "newprop" ));
			gbc.gridx = 0;
			gbc.gridy = 1;
			gbc.gridwidth = 1;
			gbc.gridheight = 1;
			gbc.weightx = 0;
			gbc.weighty = 0;
			gbc.fill = GridBagConstraints.HORIZONTAL;
			gbc.anchor = GridBagConstraints.EAST;
			gbc.insets = new Insets(5, 5, 5, 5);
			gbc.ipadx = 2;
			gbc.ipady = 2;
			this.add( newPropLabel, gbc );

			///////////the prop field //////////////////////
			newPropField = new JTextField();
			gbc.gridx = 1;
			gbc.gridy = 1;
			gbc.gridwidth = 3;
			gbc.gridheight = 1;
			gbc.weightx = 1;
			gbc.weighty = 0;
			gbc.fill = GridBagConstraints.HORIZONTAL;
			gbc.anchor = GridBagConstraints.CENTER;
			gbc.insets = new Insets(5, 5, 5, 5);
			gbc.ipadx = 2;
			gbc.ipady = 2;
			this.add( newPropField, gbc );

			//////////////////the add property button/////////////////
			addPropButton = new JButton( BDialect.getString ( this, "addpropbutton" ) );
			addPropButton.addActionListener( new BOnAddProp() );
			gbc.gridx = 4;
			gbc.gridy = 1;
			gbc.gridwidth = 1;
			gbc.gridheight = 1;
			gbc.weightx = 0;
			gbc.weighty = 0;
			gbc.fill = GridBagConstraints.HORIZONTAL;
			gbc.anchor = GridBagConstraints.CENTER;
			gbc.insets = new Insets(5, 5, 5, 5);
			gbc.ipadx = 2;
			gbc.ipady = 2;
			this.add( addPropButton, gbc );

			//////////the removed properties label/////////////////////
			removePropListLabel = new JLabel( BDialect.getString ( this, "removedprops" ) );
			gbc.gridx = 3;
			gbc.gridy = 2;
			gbc.gridwidth = 2;
			gbc.gridheight = 1;
			gbc.weightx = 0;
			gbc.weighty = 0;
			gbc.fill = GridBagConstraints.HORIZONTAL;
			gbc.anchor = GridBagConstraints.CENTER;
			gbc.insets = new Insets(5, 5, 5, 5);
			gbc.ipadx = 2;
			gbc.ipady = 2;
			this.add( removePropListLabel, gbc );



			////////////the property list label/////////////////
			propListLabel = new JLabel(BDialect.getString ( this, "proplist" ));
			gbc.gridx = 0;
			gbc.gridy = 2;
			gbc.gridwidth = 2;
			gbc.gridheight = 1;
			gbc.weightx = 0;
			gbc.weighty = 0;
			gbc.fill = GridBagConstraints.HORIZONTAL;
			gbc.anchor = GridBagConstraints.CENTER;
			gbc.insets = new Insets(5, 5, 5, 5);
			gbc.ipadx = 2;
			gbc.ipady = 2;
			this.add( propListLabel, gbc );


			//////////////////the removed properties list/////////////////
			removeListModel = new BPropListModel();
			removeList = new JList( removeListModel );		
			gbc.gridx = 3;
			gbc.gridy = 3;
			gbc.gridwidth = 2;
			gbc.gridheight = 2;
			gbc.weightx = 1;
			gbc.weighty = 1;
			gbc.fill = GridBagConstraints.BOTH;
			gbc.anchor = GridBagConstraints.CENTER;
			gbc.insets = new Insets(5, 5, 5, 5);
			gbc.ipadx = 2;
			gbc.ipady = 2;
			this.add( new JScrollPane(removeList), gbc );


			//////the remove property button/////////////////
			removePropButton = new JButton(">");
			removePropButton.addActionListener( new BOnRemove() );
			gbc.gridx = 2;
			gbc.gridy = 3;
			gbc.gridwidth = 1;
			gbc.gridheight = 1;
			gbc.weightx = 0;
			gbc.weighty = 0;
			gbc.fill = GridBagConstraints.HORIZONTAL;
			gbc.anchor = GridBagConstraints.CENTER;
			gbc.insets = new Insets(5, 5, 5, 5);
			gbc.ipadx = 2;
			gbc.ipady = 2;
			this.add( removePropButton, gbc );

			//////////the re-add property button ////////////////
			reAddPropButton = new JButton("<");
			reAddPropButton.addActionListener( new BOnReAdd() );
			gbc.gridx = 2;
			gbc.gridy = 4;
			gbc.gridwidth = 1;
			gbc.gridheight = 1;
			gbc.weightx = 0;
			gbc.weighty = 0;
			gbc.fill = GridBagConstraints.HORIZONTAL;
			gbc.anchor = GridBagConstraints.CENTER;
			gbc.insets = new Insets(5, 5, 5, 5);
			gbc.ipadx = 2;
			gbc.ipady = 2;
			this.add( reAddPropButton, gbc );

			
			/////////////the property list/////////////////////////
			listModel = new BPropListModel();
			propList = new JList( listModel );
			gbc.gridx = 0;
			gbc.gridy = 3;
			gbc.gridwidth = 2;
			gbc.gridheight = 2;
			gbc.weightx = 1;
			gbc.weighty = 1;
			gbc.fill = GridBagConstraints.BOTH;
			gbc.anchor = GridBagConstraints.CENTER;
			gbc.insets = new Insets(5, 5, 5, 5);
			gbc.ipadx = 2;
			gbc.ipady = 2;
			this.add( new JScrollPane(propList), gbc );
	  }

	  public void setVisible( BMetaElement element, boolean b )
	  {
		if ( b )
		{
			this.setMetaElement( element );						
		}
		else
		{
			this.metaElement = null;
		}

		super.setVisible(b);
		
	  }

	  public void setMetaElement( BMetaElement element )
	  {
		int i, size;

		this.metaElement = element;

		this.propNameField.setText( element.getName() );

		this.listModel.clear();
		this.removeListModel.clear();

		this.listModel.addVector( element.getProperties() );		

	  }


	  public void onSetName()
	  {

		int i;
		int size;
		TreeModel model;
		boolean branch = false;
		DefaultMutableTreeNode node;

		model = tree.getModel();

		size = model.getChildCount( model.getRoot() );		

		TreePath path = tree.getSelectionPath();
		if ( path != null )
		{
			node = (DefaultMutableTreeNode)path.getLastPathComponent();

			for ( i = 0;i < size; i++ )
			{
				branch |= (node == model.getChild( model.getRoot(), i ) );
			}

			if ( !branch )
			{
				this.metaElement.setName( propNameField.getText() );
				tree.getModel().valueForPathChanged( path, metaElement );
			}			
		}
	  }

	  public void onAddProp()
	  {
		String text = newPropField.getText();
		if ( !text.equals("") )
		{
			listModel.addItem( text );
			newPropField.setText("");
			this.metaElement.addProperty( text );
		}
	  }

	  public void onRemove()
	  {
		int index;

		Object [] selArray;
		int i;


        if ( !propList.isSelectionEmpty() )
        {
			selArray = propList.getSelectedValues();
			for ( i = 0; i < selArray.length; i++ )
			{
				listModel.remove( selArray[i] );
				removeListModel.addItem( selArray[i] );
				this.metaElement.removeProperty( (String)selArray[i] );
			}
			                     
		   this.propList.clearSelection();

        }
	  }

	  public void onReAdd()
	  {
		Object [] selArray;
		int i;

		if ( !removeList.isSelectionEmpty() )
        {			
			selArray = removeList.getSelectedValues();
			for ( i = 0; i < selArray.length; i++ )
			{
           
			   removeListModel.remove( selArray[i] );
			   listModel.addItem( selArray[i] );
			   this.metaElement.addProperty( (String)selArray[i] );
			}
		    this.removeList.clearSelection();
        }
	  }


   
	class BOnAddProp implements ActionListener
	{
		public void actionPerformed( ActionEvent event )
		{
			onAddProp();
		}
	}
   
   
   	/**
   	 * Inner class that listens to the "<" remove button. It takes the selected 
   	 * propery form the property list and places it in the removed list.
   	 */
   
      class BOnRemove implements ActionListener
      {
         public void actionPerformed( ActionEvent event )
         {
			onRemove();
         }
      }
   
   	/**
   	 * Inner class the listens to the ReAdd button.  I takes the selected property
   	 * in the removed list and replaces it in the properties list.
   	 */
   
      class BOnReAdd implements ActionListener
      {
         public void actionPerformed( ActionEvent event )
         {
            onReAdd();
         }
      }

	  class BNameFocus implements FocusListener
	  {
		public void focusGained( FocusEvent e )
		{
		}

		public void focusLost( FocusEvent e )
		{
			BEditElement.this.onSetName();
		}
	  }
   }
