
//$Header: /teamproj/cvsroot/teamb/bkasrc/au/edu/swin/synergy/plugin/metamodeller/BMaxRule.java,v 1.5 1999/10/20 09:57:56 tp079519 Exp $

   package au.edu.swin.synergy.plugin.metamodeller;

	import java.io.Serializable;
	import au.edu.swin.synergy.debug.Debug;

   public class BMaxRule implements Serializable
   {
      public static final int kDefaultValue = -1;
      public static final boolean kDefaultResult = true;
   
      private int rule[][] = null;
      int numNodes;
	  int numArcs;
   
   
      public BMaxRule( int numNodes, int numArcs )
      {
         int i;
		 int j;
      
         this.numNodes = numNodes;
		 this.numArcs = numArcs;
		 Debug.doPrintln("numNodes = " + numNodes);
		 Debug.doPrintln("numArcs = " + numArcs);
         this.rule = new int[numNodes][numArcs];
         for ( i = 0; i < numNodes; i++ )
         {
			for ( j = 0; j < numArcs; j++ )
			{
				this.rule[i][j] = BMaxRule.kDefaultValue;
			}
         }
      }
   
      public final boolean evalMax( int nodeID, int arcID, int max )
      {
         boolean result = BMaxRule.kDefaultResult;
      
         if ( nodeID < this.numNodes && arcID < this.numArcs && this.rule[nodeID][arcID] > 0 )
         {
            result = max < this.rule[nodeID][arcID];
         }
      
         return result;
      }
   
      public final void setMax( int nodeID, int arcID, int max )
      {
         if ( nodeID < this.numNodes && arcID < this.numArcs)
         {
            this.rule[nodeID][arcID] = max;
         }
      }
   }

