	//$Header: /teamproj/cvsroot/teamb/bkasrc/au/edu/swin/synergy/plugin/metamodeller/BMetaGui.java,v 1.58 1999/10/21 06:30:00 tp079511 Exp $

   package au.edu.swin.synergy.plugin.metamodeller;

   import au.edu.swin.synergy.plugin.metamodeller.BMetaModelCellRenderer;

   import au.edu.swin.synergy.kernel.BPlugin;
   import au.edu.swin.synergy.kernel.BCommandEvent;
   import au.edu.swin.synergy.kernel.BCommandComplete;
   import au.edu.swin.synergy.kernel.BBlockingComplete;
	import au.edu.swin.synergy.kernel.event.BBootCE;

   import au.edu.swin.synergy.plugin.mod13.event.BAddWindowCE;
   import au.edu.swin.synergy.plugin.mod13.event.BAddMenuItemCE;
   import au.edu.swin.synergy.plugin.mod13.event.BCloseWindowCE;
   import au.edu.swin.synergy.plugin.mod13.bwt.BWindowAdapter;
   import au.edu.swin.synergy.plugin.mod13.bwt.BWindowEvent;
   import au.edu.swin.synergy.plugin.mod13.bwt.BSwingUtilities;
   import au.edu.swin.synergy.plugin.mod13.event.BAddMenuCE;
   import au.edu.swin.synergy.plugin.mod13.event.BGetFilesCE;

   import au.edu.swin.synergy.debug.Debug;
   import au.edu.swin.synergy.debug.Assertion;

   import javax.swing.*;
   import javax.swing.tree.DefaultMutableTreeNode;
   import javax.swing.tree.DefaultTreeModel;
   import javax.swing.tree.TreeSelectionModel;
   import javax.swing.event.TreeSelectionListener;
   import javax.swing.event.TreeSelectionEvent;
   import javax.swing.event.TreeModelListener;
   import javax.swing.event.TreeModelEvent;
   import javax.swing.tree.TreePath;
   import javax.swing.border.EtchedBorder;
   import java.awt.*;
   import java.awt.event.ActionListener;
   import java.awt.event.ActionEvent;
   import java.awt.event.MouseAdapter;
   import java.awt.event.MouseListener;
   import java.awt.event.MouseEvent;

   import java.io.FileOutputStream;
   import java.io.ObjectOutputStream;
   import java.io.IOException;
   import java.io.File;
   import java.util.Vector;
   import java.lang.reflect.InvocationTargetException;

   import java.io.FileInputStream;
   import java.io.ObjectInputStream;
   import java.io.IOException;

   import au.edu.swin.synergy.lib.io.BSaveable;
   import au.edu.swin.synergy.plugin.dialect.BString;
   import au.edu.swin.synergy.plugin.dialect.BDialect;
   import au.edu.swin.synergy.plugin.dialect.event.BDialectChangeCE;
   import au.edu.swin.synergy.lib.io.BDataFile;
import au.edu.swin.synergy.lib.BStringList;
import au.edu.swin.synergy.lib.io.BFileFilter;

import au.edu.swin.synergy.plugin.help.BHelpItem;
import au.edu.swin.synergy.plugin.help.BHelpUtil;
import au.edu.swin.synergy.plugin.help.BHelpTreeModel;
import au.edu.swin.synergy.plugin.help.event.BRegisterHelpCE;


import au.edu.swin.synergy.plugin.metamodeller.event.BOpenMetamodelCE;


/**
 * class which supplies the gui for creating and editing
 * meta models.
 * @see
 * @concurrency
 * @copyright Synergy Software 1999
 * @rref
 * @author Shane Fitzgibbon
 */


   public class BMetaGui extends BPlugin
   {

		/////////main section.///////////
		JPanel mainPanel = null;
		JPanel dummyPanel = null;
		JLabel dummyLabel = null;
		JTree metaTree = null;
		JScrollPane treeScroll = null;

		JButton addNode = new JButton();
		JButton addArc = new JButton();
		JButton addRule = new JButton();
		JButton okButton = new JButton();
		JButton cancelButton = new JButton();
		JButton nameCancelButton = new JButton();
		JButton nameOkButton = new JButton();


		////////////edit node/arc panel../////////////////
		BEditElement editElementPanel = null;
		
		
		



		//edit rule panel		
		BRuleGui editRulePanel = null;
      
      DefaultMutableTreeNode rootNode;
      DefaultMutableTreeNode nodeNode;
      DefaultMutableTreeNode arcNode;
      DefaultMutableTreeNode ruleNode;
      DefaultTreeModel treeModel;
      JPanel namePanel;
	  JTextField nameField;
      JPopupMenu popup;
	  JLabel nameLabel;
	  

	  private BString filterString = null;


	  private static int nodeCount = 0;
	  private static int ruleCount = 0;
	  private static int arcCount = 0;

   	/**
   	 * The meta model being created
   	 */
      BMetaModel metaModel = null;;

	/**
	 * Reference of the file that was opened
	 */
	 private File tmpFile = null;

   	/**
   	 * This is where constructor like calls for classes that extend BPlugin
   	 */
      public void setup(BStringList params)
      {
         BDoInit doInit = new BDoInit();
         doInit.run();
         SwingUtilities.invokeLater( new BNameInit() );
         registerMenu();
		 doDialect();
      }

	public void registerHelp ()
	{
		try
		{
			BHelpTreeModel tree = new BHelpTreeModel ( "Meta Modeller" );
			String path = "/au/edu/swin/synergy/plugin/metamodeller/help/";

			BHelpItem ml = new BHelpItem ( "Modelling Language", path + "modellang.html" );

			DefaultMutableTreeNode metaModels;
			BHelpItem mm = new BHelpItem ( "Meta Models", path + "metamodel.html" );

			DefaultMutableTreeNode metaModelBuilder;
			BHelpItem mmb = new BHelpItem ( "Meta Model Builder", path + "mmbuilder.html" );
			
			DefaultMutableTreeNode addingItems;
			BHelpItem ai = new BHelpItem ( "Adding Items", path + "addingitems.html" );
			BHelpItem aa = new BHelpItem ( "Add Arc", path + "addarc.html" );
			BHelpItem an = new BHelpItem ( "Add Node", path + "addnode.html" );
			BHelpItem ar = new BHelpItem ( "Add Rule", path + "addrule.html" );
			BHelpItem ap = new BHelpItem ( "Add Property", path + "addproperty.html" );

			DefaultMutableTreeNode modifyingItems;
			BHelpItem mi = new BHelpItem ( "Modifying Items", path + "modifyingitems.html" );
			BHelpItem mr = new BHelpItem ( "Modify Rules", path + "modifyrules.html" );
			BHelpItem ri = new BHelpItem ( "Remove Item ", path + "removeitem.html" );
			BHelpItem rp = new BHelpItem ( "Remove Property", path + "removeproperty.html" );

			BHelpItem nmm = new BHelpItem ( "New Meta Model", path + "newmm.html" );
			BHelpItem omm = new BHelpItem ( "Open Meta Model", path + "openmm.html" );

			DefaultMutableTreeNode notations;
			BHelpItem n = new BHelpItem ( "Notations", path + "notations.html" );
			BHelpItem cn = new BHelpItem ( "Close Notation", path + "closenot.html" );
			BHelpItem nn = new BHelpItem ( "New Notation", path + "newnot.html" );
			BHelpItem on = new BHelpItem ( "Open Notation", path + "opennot.html" );
	
			tree.addHelpItem ( null, ml );
			metaModels = tree.addBranch ( null, "Meta Models" );
			tree.addHelpItem ( metaModels, mm );

			metaModelBuilder = tree.addBranch ( metaModels, "Meta Model Builder" );
			tree.addHelpItem ( metaModelBuilder, mmb );

			addingItems = tree.addBranch ( metaModelBuilder, "Adding Items" );
			tree.addHelpItem ( addingItems, ai );
			tree.addHelpItem ( addingItems, aa );
			tree.addHelpItem ( addingItems, an );
			tree.addHelpItem ( addingItems, ar );
			tree.addHelpItem ( addingItems, ap );

			modifyingItems = tree.addBranch ( metaModelBuilder, "Modifying Items" );
			tree.addHelpItem ( modifyingItems, mi );
			tree.addHelpItem ( modifyingItems, mr );
			tree.addHelpItem ( modifyingItems, ri );
			tree.addHelpItem ( modifyingItems, rp );
		
			tree.addHelpItem ( metaModelBuilder, nmm );
			tree.addHelpItem ( metaModelBuilder, omm );

			notations = tree.addBranch ( metaModels, "Notations" );
			tree.addHelpItem ( notations, n ); 
			tree.addHelpItem ( notations, cn ); 
			tree.addHelpItem ( notations, nn ); 
			tree.addHelpItem ( notations, on ); 
						
			BRegisterHelpCE event = new BRegisterHelpCE ( this, tree );
			dispatchEvent ( event );
		}
		catch ( Exception e )
		{
			e.printStackTrace ();
		}		
	}
      /**
     * Return a list of plugin dependancies
	 *
     * @return a list of plugins such as "au.edu.swin.synergy.plugin.mod13.BWindowManager"
	 * or null if there are no dependancies
     */

    public BStringList getDependancies()
	{
		BStringList result = new BStringList();
		result.add("au.edu.swin.synergy.plugin.mod13.BWindowManager");
		return result;
	}

   	/**
   	 * The method used by th plugin to handle command events
   	 */
      public void onBCommandEvent(java.lang.Object source, BCommandEvent event)
      {
			if ( event instanceof BDialectChangeCE )
			{
				doDialect ();
			}
			else if ( event instanceof BBootCE )
			{
				registerHelp ();
			}
			else if (event instanceof BOpenMetamodelCE)
			{
				BOpenMetamodelCE openEvent = (BOpenMetamodelCE) event;
				File editFile = getOpenMetamodelFile();

				if(editFile != null)
				{
					openEvent.setFileName(editFile.getPath());
				}

				event.doComplete(BCommandComplete.kSuccess);
			}
      }

   	/**
   	 * Sets the metamodel to be displayed by the meta gui then calls a function to
   	 * load the appropriate data into the gui.
   	 * Does nothing if the meta model equals <CODE>null</CODE>
   	 * @param meta the meta model to be displayed
   	 */

      public void setMetaModel( BMetaModel meta ) throws Exception
      {
         if ( meta != null )
         {
            this.metaModel = meta;
			//Reset all the nodes
            nodeNode.removeAllChildren();
            arcNode.removeAllChildren();
            ruleNode.removeAllChildren();
            
            if (metaModel.getName() != "")
            {
               rootNode.setUserObject( metaModel.getName() ); //set root node to meta model name
            }
            Vector nodes = metaModel.getMetaNodes();
            for ( int i = 0; i < nodes.size(); i++)
            {
               BMetaGui.this.addNode( ((BMetaElement) nodes.get(i)) ); //add node to gui tree
            }
            Vector arcs = metaModel.getMetaArcs();
            for ( int i = 0; i < arcs.size(); i++)
            {
               BMetaGui.this.addArc( ((BMetaElement) arcs.get(i)) ); //add arc node to gui tree
            }
            Vector rules = metaModel.getMetaRules();
            for ( int i = 0; i < rules.size(); i++)
            {
               BMetaGui.this.addRule( ((BMetaElement) rules.get(i)) );//add rule to gui tree
            }


			treeModel.nodeStructureChanged( BMetaGui.this.rootNode );

         }
		 else
		 {
			throw new Exception("Meta model was null in setMetaModel");
		 }
         
      }

     /**
      * Private method for adding a componets to a panel that has gridbag as it layout
      */
      private void add( JPanel panel, Component c, GridBagConstraints gbc, int x, int y, int w, int h )
      {
         gbc.gridx = x;
         gbc.gridy = y;
         gbc.gridwidth = w;
         gbc.gridheight = h;
         panel.add( c, gbc );
      }

	public void doDialect ()
	{
		// Swing utilities??? Yes!!
        BSwingUtilities.setUserObject(rootNode, BDialect.getString ( this, "metamodel" ));
        BSwingUtilities.setUserObject(nodeNode, BDialect.getString ( this, "nodes" ));
        BSwingUtilities.setUserObject(arcNode, BDialect.getString ( this, "arcs" ));
        BSwingUtilities.setUserObject(ruleNode, BDialect.getString ( this, "rules" ));

        BSwingUtilities.setJLabelText(nameLabel, BDialect.getString ( this, "metamodelname" ));

        BSwingUtilities.setJButtonText(addNode, BDialect.getString ( this, "addnode" ));
        BSwingUtilities.setJButtonText(addArc, BDialect.getString ( this, "addarc" ));
        BSwingUtilities.setJButtonText(addRule, BDialect.getString ( this, "addrule" ));
        BSwingUtilities.setJButtonText(okButton, BDialect.getString ( "save" ));
        BSwingUtilities.setJButtonText(cancelButton, BDialect.getString ("cancel" ));
        BSwingUtilities.setJButtonText(nameOkButton, BDialect.getString ( "ok" ));
        BSwingUtilities.setJButtonText(nameCancelButton, BDialect.getString ( "cancel" ));

		filterString = new BString( this, "filterdesc" );
	}

   	/**
   	 * Adds a node to the tree
   	 */
      private DefaultMutableTreeNode addNode( Object child )
      {
         return addObject( nodeNode, child, true );
      }

   	/**
   	 * Adds an Arc to the tree
   	 */

      private DefaultMutableTreeNode addArc ( Object child )
      {
         return addObject( arcNode, child, true );
      }

   	/**
   	 * Adds a rule to a tree
   	 */

      private DefaultMutableTreeNode addRule( Object child )
      {
         return addObject( ruleNode, child, true );
      }

   	/**
   	 * generic method for adding a new leaf to a tree
   	 */

      private DefaultMutableTreeNode addObject( DefaultMutableTreeNode parent, Object child, boolean shouldBeVisible)
      {
         DefaultMutableTreeNode childNode = new DefaultMutableTreeNode( child );
         treeModel.insertNodeInto( childNode, parent, parent.getChildCount());
      	//Ensure that user can see new tree node
         if (shouldBeVisible)
         {
			metaTree.setSelectionPath( new TreePath( childNode.getPath() ) );
//            metaTree.scrollPathToVisible( new TreePath(childNode.getPath()) );
         }
         return childNode;
      }

      private void registerMenu()
      {
         JMenuItem createMetaItem = new JMenuItem(  );
         JMenuItem editMetaItem = new JMenuItem(  );
         createMetaItem.addActionListener( new BCreateMetaMenuListener() );
         editMetaItem.addActionListener( new BEditMetaMenuListener() );
         BAddMenuItemCE event = new BAddMenuItemCE( this, createMetaItem, new BString(this, "createmodel"), new BString(this, "menuName") );
		 event.setPreferredMenuMnemonic(new BString(this, "menuKey"));
         event.addMenuItem( editMetaItem, new BString(this, "editmodel") );
         dispatchEvent( event );
      }

	  private void showNodeOrArc( BMetaElement element )
	  {		
		dummyPanel.setVisible( false );
		editRulePanel.setVisible( false );
		editElementPanel.setVisible( element, true );
		mainPanel.revalidate();

		


	  }

	  private void showBlank()
	  {
		
		editRulePanel.setVisible( false );
		editElementPanel.setVisible( false );
		dummyPanel.setVisible( true );
		mainPanel.revalidate();
	  }

	  private void showRule( BMetaElement rule )
	  {		
		dummyPanel.setVisible( false );
		editElementPanel.setVisible( false );

		editRulePanel.setRule( rule, metaModel );
		editRulePanel.setVisible( true );
		mainPanel.revalidate();
		
	  }



   	/**
   	 * Inner class that acts as the completion Event for the main add
   	 * window command event
   	 * Currently doesn't do anything
   	 */
      class BAddWindowCC extends BCommandComplete
      {
         public void doComplete(BCommandEvent event, int status)
         {

         }
      }

   	/**
   	 * Inner class that implemets action listener
   	 * Is the action listener for the Create Meta Model menu item
   	 */

      class BCreateMetaMenuListener implements ActionListener
      {
         public void actionPerformed( java.awt.event.ActionEvent evt )
         {
            if (!namePanel.isShowing())
            {
				nameField.setText("");
				metaModel = new BMetaModel();
               Debug.doPrintln("BMetaGui:BCreateMetaMenuListener:actionPerformed");
               BAddWindowCE addEvent = new BAddWindowCE(this, namePanel, new BString(this, "modellertitle"));
               addEvent.setDialog(true);
               addEvent.setModal(true);
               dispatchEvent(addEvent);//*/
            }
         }
      }

   	/**
   	 * Inner class that implemets action listener
   	 * Is the action listener for the Edit Meta Model menu item
   	 */

      class BEditMetaMenuListener implements ActionListener
      {
         public void actionPerformed( java.awt.event.ActionEvent evt )
         {
            if (!mainPanel.isShowing())
            {
               Debug.doPrintln("BMetaGui:BEditMetaMenuListener:actionPerformed");

				BFileFilter filter = new BFileFilter( BDialect.getString ( this, "fileextension" ), filterString.toString() );
   				BGetFilesCE getFile = new BGetFilesCE(".");
				getFile.setTitle(filterString.toString());
				getFile.setFileFilter(filter);
				getFile.setCompletionObject(new OnOpenFileComplete());
				dispatchEvent(getFile);
            }

         }
      }

	  class OnOpenFileComplete extends BCommandComplete
	  {
	    public void doComplete( BCommandEvent event, int status )
		{
			if(status == BCommandComplete.kSuccess)
			{
	   			BGetFilesCE getFile = (BGetFilesCE) event;
				if(getFile.getSelectedFile() != null)
               {
			   	Debug.doPrintln("Loading file");
                  tmpFile = getFile.getSelectedFile();
				  BDataFile dataFile = new BDataFile( tmpFile.getName() );
                  dataFile.openFileForRead();
                  try
                  {
                     Debug.doPrintln("Calling AutoLoad");
                     BSaveable meta = dataFile.autoLoad();
                     BMetaModel selectedMetaModel = (BMetaModel) meta;
                     BMetaGui.this.setMetaModel( selectedMetaModel );
                     BAddWindowCE addEvent = new BAddWindowCE(this, mainPanel, new BString(this, "modellertitle"));
                     addEvent.addWindowListener( new BMetaWindowListener());
                     dispatchEvent(addEvent);
                  }
				  catch( Exception e )
				  {
					Debug.doPrintln( "Exception " + e );
					e.printStackTrace();
				  }
                     finally

                     {
                        dataFile.close();
                     }


               }
			   else
			   {
			   	Debug.doPrintln("Load file canceled");
			   }

			}
			else
			{
				Debug.doPrintln("Error opening file");
			}

		}
	  }

   	/**
   	 * Inner class that implemets actionlistener
   	 * Is the Listener for the add node button
   	 */

      class BOnAddNode implements ActionListener
      {
         public void actionPerformed( java.awt.event.ActionEvent evt )
         {

			BMetaElement element = new BMetaNode();
			element.setName("Node"+(++nodeCount));
			BMetaGui.this.metaModel.addMetaNode( element );
			BMetaGui.this.addNode( element );			
			BMetaGui.this.showNodeOrArc( element );
         }
      }

   	/**
   	 * Inner class that implemets actionlistener
   	 * Is the Listener for the add arc button
   	 */

      class BOnAddArc implements ActionListener
      {
         public void actionPerformed( java.awt.event.ActionEvent evt )
         {
            BMetaElement element = new BMetaArc();
			element.setName("Arc"+(++arcCount));
			BMetaGui.this.metaModel.addMetaArc( element );
			BMetaGui.this.addArc( element );			
			BMetaGui.this.showNodeOrArc( element );
         }
      }

   	/**
   	 * Inner class that implemets actionlistener
   	 * Is the Listener for the add rule button
   	 */

      class BOnAddRule implements ActionListener
      {
         public void actionPerformed( java.awt.event.ActionEvent evt )
         {
            BMetaElement element = new BMetaRule();
			element.setName("Rule"+(++ruleCount));
			BMetaGui.this.metaModel.addMetaRule( element );
			BMetaGui.this.addRule( element );
			BMetaGui.this.showRule( element );
         }
      }

   	/**
   	 * Inner class that implements the BWindowAdapter
   	 * Listens for when the main panel is closed in the window manager
   	 * Currently doesn't do anything
   	 */

      class BMetaWindowListener extends BWindowAdapter
      {
         public void windowClosing(	BWindowEvent event )
         {
         }
      }


   	
    



      class BMetaTreeListener implements TreeModelListener
      {
         public void treeNodesChanged( TreeModelEvent event )
         {
         }

         public void treeNodesInserted( TreeModelEvent event )
         {
         }

         public void treeNodesRemoved( TreeModelEvent event )
         {
         }

         public void treeStructureChanged( TreeModelEvent event )
         {
         }
      }

   	/**
   	 * Inner class that implements actionlistener
   	 * it listens to the OK button on the main form
   	 */
      class BOnOK implements ActionListener
      {
      	/**
      	 * public method that is triggerd by the OK button the main panel being pressed
      	 * it opens a file chooser so that the user can select where to save the meta model to
      	 * it then saves the meta model to that file.
      	 * finally it closes the meta model window.
      	 */
         public void actionPerformed( ActionEvent event )
         {

            if (metaModel.getName().trim().length() > 0)
            {
				File metaFile = new File(metaModel.getName().trim() + "." + BDialect.getString ( this, "fileextension" ) );
				BFileFilter filter = new BFileFilter( BDialect.getString ( this, "fileextension" ), filterString.toString() );
   				BGetFilesCE getFile;
				if(tmpFile != null)
				{
					getFile = new BGetFilesCE(tmpFile.getPath());
				}
				else
				{
	   				getFile = new BGetFilesCE(metaFile.getPath());
				}
				getFile.setTitle(filterString.toString());
				getFile.setFileFilter(filter);
				getFile.setLoad(false);
				getFile.setSelectedFile(metaFile);
				getFile.setCompletionObject(new OnSaveFileComplete());
				dispatchEvent(getFile);
            }
         }
      }
  	  class OnSaveFileComplete extends BCommandComplete
	  {
	    public void doComplete( BCommandEvent event, int status )
		{
			if(status == BCommandComplete.kSuccess)
			{
				BGetFilesCE getFile = (BGetFilesCE) event;
				if(getFile.getSelectedFile() != null)
               {
                  BDataFile dataFile = new BDataFile(getFile.getSelectedFile().getPath());
                  dataFile.openFileForWrite(false);
                  dataFile.save(metaModel);
                  dataFile.close();

			   // we only close the window if the file is saved
                BCloseWindowCE closeEvent = new BCloseWindowCE( this, mainPanel );
	            dispatchEvent( closeEvent );
            }
		}
		else
		{
			Debug.doPrintln("Error saving file");
		}
		}
	}

   	/**
   	 * Inner class that implements actionlistener
   	 * it listens to the OK button on the main form
   	 */

      class BOnCancel implements ActionListener
      {
      	/**
      	 * public method that is triggered by the cancel button the main panel being pressed
      	 * it closes the metagui window
      	 */

         public void actionPerformed( ActionEvent event )
         {
//            BMetaGui.this.metaModel = new BMetaModel();
//            BMetaGui.this.nameField.setText("");
            BCloseWindowCE closeEvent = new BCloseWindowCE( this, mainPanel );
            dispatchEvent( closeEvent );
         }
      }

   	/**
   	 * Inner class that implemets SwingUtilities.Runnable
   	 * Thread safe way for all gui elements to be initiated
   	 */

      class BDoInit implements Runnable
      {
		public void doMainPanelInit()
		{
			GridBagConstraints gbc = new GridBagConstraints();

			mainPanel = new JPanel();
			mainPanel.setLayout( new GridBagLayout() );

			/////////////the tree pane grid layout.../////////////
			rootNode = new DefaultMutableTreeNode(BDialect.getString ( this, "metamodel" ) );
            nodeNode = new DefaultMutableTreeNode(BDialect.getString ( this, "nodes" ) );
            arcNode = new DefaultMutableTreeNode(BDialect.getString ( this, "arcs" ) );
            ruleNode = new DefaultMutableTreeNode(BDialect.getString ( this, "rules" ) );
            rootNode.add(nodeNode);
            rootNode.add(arcNode);
            rootNode.add(ruleNode);
            treeModel = new DefaultTreeModel(rootNode);
			metaTree = new JTree( treeModel );
			metaTree.getSelectionModel().setSelectionMode(TreeSelectionModel.SINGLE_TREE_SELECTION);
            metaTree.setCellRenderer ( new BMetaModelCellRenderer () );

            metaTree.setShowsRootHandles(true);
            metaTree.addTreeSelectionListener( new BTreeSelectionListener() );

			Dimension d = new Dimension( 150, 329 );
			treeScroll = new JScrollPane( metaTree );
			treeScroll.setMinimumSize(d);
			treeScroll.setMaximumSize(d);
			treeScroll.setPreferredSize(d);

			gbc.gridx = 0;
			gbc.gridy = 0;
			gbc.gridwidth = 1;
			gbc.gridheight = 6;
			gbc.weightx = 0;
			gbc.weighty = 1;
			gbc.fill = GridBagConstraints.BOTH;
			gbc.anchor = GridBagConstraints.CENTER;
			gbc.insets = new Insets(5, 5, 5, 5);
			gbc.ipadx = 2;
			gbc.ipady = 2;
			mainPanel.add( treeScroll, gbc );

			/////////////the main pane grid layout.../////////////
			dummyPanel = new JPanel();
			dummyPanel.setLayout( new BorderLayout() );
			dummyPanel.setBorder( new EtchedBorder() );
			dummyLabel = new JLabel(BDialect.getString ( this, "dummytext" ));
			dummyPanel.add( dummyLabel, BorderLayout.CENTER );
			gbc.gridx = 1;
			gbc.gridy = 0;
			gbc.gridwidth = 1;
			gbc.gridheight = 6;
			gbc.weightx = 3;
			gbc.weighty = 1;
			gbc.fill = GridBagConstraints.BOTH;
			gbc.anchor = GridBagConstraints.CENTER;
			gbc.insets = new Insets(5, 5, 5, 5);
			gbc.ipadx = 2;
			gbc.ipady = 2;
			mainPanel.add( dummyPanel, gbc );

			/////////////the new node grid layout.../////////////
            BSwingUtilities.setJButtonText(addNode, BDialect.getString ( this, "addnode" ));
			addNode.addActionListener( new BOnAddNode());
			gbc.gridx = 2;
			gbc.gridy = 0;
			gbc.gridwidth = 1;
			gbc.gridheight = 1;
			gbc.weightx = 0;
			gbc.weighty = 0;
			gbc.fill = GridBagConstraints.HORIZONTAL;
			gbc.anchor = GridBagConstraints.CENTER;
			gbc.insets = new Insets(5, 5, 5, 5);
			gbc.ipadx = 2;
			gbc.ipady = 2;
			mainPanel.add( addNode, gbc );


			/////////////the new arc grid layout.../////////////
            BSwingUtilities.setJButtonText(addArc, BDialect.getString ( this, "addarc" ));
			addArc.addActionListener( new BOnAddArc() );
			gbc.gridx = 2;
			gbc.gridy = 1;
			gbc.gridwidth = 1;
			gbc.gridheight = 1;
			gbc.weightx = 0;
			gbc.weighty = 0;
			gbc.fill = GridBagConstraints.HORIZONTAL;
			gbc.anchor = GridBagConstraints.CENTER;
			gbc.insets = new Insets(5, 5, 5, 5);
			gbc.ipadx = 2;
			gbc.ipady = 2;
			mainPanel.add( addArc, gbc );

			/////////////the new rule grid layout.../////////////
            BSwingUtilities.setJButtonText(addRule, BDialect.getString ( this, "addrule" ));
			addRule.addActionListener( new BOnAddRule() );
			gbc.gridx = 2;
			gbc.gridy = 2;
			gbc.gridwidth = 1;
			gbc.gridheight = 1;
			gbc.weightx = 0;
			gbc.weighty = 0;
			gbc.fill = GridBagConstraints.HORIZONTAL;
			gbc.anchor = GridBagConstraints.CENTER;
			gbc.insets = new Insets(5, 5, 5, 5);
			gbc.ipadx = 2;
			gbc.ipady = 2;
			mainPanel.add( addRule, gbc );

			/////////////the temp panel grid layout.../////////////
			JPanel tmpPanel = new JPanel();
			gbc.gridx = 2;
			gbc.gridy = 3;
			gbc.gridwidth = 1;
			gbc.gridheight = 1;
			gbc.weightx = 0;
			gbc.weighty = 1;
			gbc.fill = GridBagConstraints.HORIZONTAL;
			gbc.anchor = GridBagConstraints.CENTER;
			gbc.insets = new Insets(5, 5, 5, 5);
			gbc.ipadx = 2;
			gbc.ipady = 2;
			mainPanel.add( tmpPanel, gbc );



			/////////////the ok button grid layout.../////////////
            BSwingUtilities.setJButtonText(okButton, BDialect.getString ( "save" ));
			okButton.addActionListener( new BOnOK() );
			gbc.gridx = 2;
			gbc.gridy = 4;
			gbc.gridwidth = 1;
			gbc.gridheight = 1;
			gbc.weightx = 0;
			gbc.weighty = 0;
			gbc.fill = GridBagConstraints.HORIZONTAL;
			gbc.anchor = GridBagConstraints.CENTER;
			gbc.insets = new Insets(5, 5, 5, 5);
			gbc.ipadx = 2;
			gbc.ipady = 2;
			mainPanel.add( okButton, gbc );

			/////////////the cancel button grid layout.../////////////
            BSwingUtilities.setJButtonText(cancelButton, BDialect.getString ("cancel" ));
			cancelButton.addActionListener( new BOnCancel() );
			gbc.gridx = 2;
			gbc.gridy = 5;
			gbc.gridwidth = 1;
			gbc.gridheight = 1;
			gbc.weightx = 0;
			gbc.weighty = 0;
			gbc.fill = GridBagConstraints.HORIZONTAL;
			gbc.anchor = GridBagConstraints.CENTER;
			gbc.insets = new Insets(5, 5, 5, 5);
			gbc.ipadx = 2;
			gbc.ipady = 2;
			mainPanel.add( cancelButton, gbc );
		}

		public void doEditElementPanelInit()
		{
			GridBagConstraints gbc = new GridBagConstraints();

			editElementPanel = new BEditElement( BMetaGui.this, BMetaGui.this.metaTree );
			editElementPanel.setBorder( new EtchedBorder() );
			editElementPanel.setVisible( false );
			
			gbc.gridx = 1;
			gbc.gridy = 0;
			gbc.gridwidth = 1;
			gbc.gridheight = 6;
			gbc.weightx = 3;
			gbc.weighty = 1;
			gbc.fill = GridBagConstraints.BOTH;
			gbc.anchor = GridBagConstraints.CENTER;
			gbc.insets = new Insets(5, 5, 5, 5);
			gbc.ipadx = 2;
			gbc.ipady = 2;
			mainPanel.add( editElementPanel, gbc );			
		}

		public void doEditRulePanelInit()
		{
			GridBagConstraints gbc = new GridBagConstraints();
			editRulePanel = new BRuleGui( BMetaGui.this, BMetaGui.this.metaTree );
			editRulePanel.setBorder( new EtchedBorder() );
			
			editRulePanel.setVisible( false );
			gbc.gridx = 1;
			gbc.gridy = 0;
			gbc.gridwidth = 1;
			gbc.gridheight = 6;
			gbc.weightx = 3;
			gbc.weighty = 1;
			gbc.fill = GridBagConstraints.BOTH;
			gbc.anchor = GridBagConstraints.CENTER;
			gbc.insets = new Insets(5, 5, 5, 5);
			gbc.ipadx = 2;
			gbc.ipady = 2;
			mainPanel.add( editRulePanel, gbc );
			
		}

         public void run()
         {
			doMainPanelInit();
			doEditElementPanelInit();
			doEditRulePanelInit();

			popup = new JPopupMenu();            
            JMenuItem deleteItem = new JMenuItem( "Delete" );
            deleteItem.addActionListener( new BOnPopupDelete() );
            popup.add( deleteItem );
            MouseListener popupListener = new PopupListener();
            metaTree.addMouseListener(popupListener);


         }
      }


   	/**
   	 * Inner class that immplements SwingUtilities.Runnable
   	 * Thread Safe way of initialising the namePanel
   	 */

      class BNameInit implements Runnable
      {
         public void run()
         {
            namePanel = new JPanel();
            namePanel.setSize(300, 120);
            namePanel.setLayout( new BorderLayout() );
            JPanel inputPanel = new JPanel( new FlowLayout() );
            JPanel buttonPanel = new JPanel();
            buttonPanel.setLayout( new FlowLayout(FlowLayout.RIGHT) );

			nameLabel = new JLabel(BDialect.getString ( this, "metamodelname" ));
            nameField = new JTextField();
            nameField.setPreferredSize( new Dimension( 80, 20 ) );
            BSwingUtilities.setJButtonText(nameOkButton, BDialect.getString ( "ok" ));
            nameOkButton.addActionListener( new BOnNameOK() );
            BSwingUtilities.setJButtonText(nameCancelButton, BDialect.getString ( "cancel" ));
            nameCancelButton.addActionListener( new BOnNameCancel() );
            inputPanel.add( nameLabel);
            inputPanel.add( nameField);
            buttonPanel.add( nameOkButton );
            buttonPanel.add( nameCancelButton );
            namePanel.add( inputPanel, "Center" );
            namePanel.add( buttonPanel, "South" );
         }
      }

   	/**
   	 * Inner class that implemts action listenre
   	 * it listens to the OK button on the name panel
   	 */

      class BOnNameOK implements ActionListener
      {
      	/**
      	 * public method that is triggered by pressing the ok button on the name panel
      	 * it closes the name panel and creates the create panel
      	 */

         public void actionPerformed( ActionEvent event )
         {
            metaModel = new BMetaModel();
			nodeCount = 0;
			arcCount = 0;
			ruleCount =0;
            if ( nameField.getText() != "" )
            {				
               metaModel.setName( nameField.getText() );
               BCloseWindowCE removeEvent = new BCloseWindowCE( this, namePanel );
               dispatchEvent( removeEvent );
               BMetaGui.this.nodeNode.removeAllChildren();
               BMetaGui.this.arcNode.removeAllChildren();
               BMetaGui.this.ruleNode.removeAllChildren();

               BMetaGui.this.treeModel.nodeStructureChanged( BMetaGui.this.rootNode );
               BAddWindowCE addEvent = new BAddWindowCE(this, mainPanel, new BString(this, "modellertitle"));
               addEvent.addWindowListener( new BMetaWindowListener());
               dispatchEvent(addEvent);//*/
            }

			
         }
      }

   	/**
   	 * Inner class that implemts action listenre
   	 * it listens to the Cancel button on the name panel
   	 */

      class BOnNameCancel implements ActionListener
      {
      	/**
      	 * public method that is triggered by pressing the cancel button on the name panel
      	 * it closes the name panel
      	 */
         public void actionPerformed( ActionEvent event )
         {
            BCloseWindowCE closeEvent = new BCloseWindowCE( this, namePanel );
            dispatchEvent( closeEvent );
         }
      }

   	

	  class BTreeSelectionListener implements TreeSelectionListener
	  {
		public void valueChanged(TreeSelectionEvent e)
		{
		   DefaultMutableTreeNode node = (DefaultMutableTreeNode) e.getPath().getLastPathComponent();
		   if (node != null)
           {
              Object nodeInfo = node.getUserObject();

              if ( node.isLeaf() && nodeInfo != null )
              {
                 DefaultMutableTreeNode parent = ( DefaultMutableTreeNode ) node.getParent();
				 if ( parent != null )
				 {
					 String parentName = (String) parent.getUserObject();
					 if ( parentName.equals( "Nodes" ) )
					 {

						BMetaGui.this.showNodeOrArc( (BMetaElement)nodeInfo );

					 }
					 else if ( parentName.equals( "Arcs" ) )
					 {
						BMetaGui.this.showNodeOrArc( (BMetaElement)nodeInfo );
					 }
					 else if ( parentName.equals( "Rules" ) )
					 {
						BMetaGui.this.showRule( (BMetaElement)nodeInfo );
					 }
					 else
					 {
						BMetaGui.this.showBlank();
					 }
				}

              }
			  else
			  {
				BMetaGui.this.showBlank();
			  }
           }
		}
	  }

   	
   	/**
   	 * Class used to load meta model details into the gui
   	 * @pre metaModel is not equal to null
   	 */
      class BLoadMetaModel implements Runnable
      {
         public void run()
         {
            //Reset all the nodes
            BMetaGui.this.nodeNode.removeAllChildren();
            BMetaGui.this.arcNode.removeAllChildren();
            BMetaGui.this.ruleNode.removeAllChildren();
            BMetaGui.this.treeModel.nodeStructureChanged( BMetaGui.this.rootNode );
            if (metaModel.getName() != "")
            {
//               metaLabel.setText( metaModel.getName() );
               rootNode.setUserObject( metaModel.getName() ); //set root node to meta model name
            }
            Vector nodes = metaModel.getMetaNodes();
            for ( int i = 0; i < nodes.size(); i++)
            {
               BMetaGui.this.addNode( ((BMetaElement) nodes.get(i)).getName() ); //add node to gui tree
            }
            Vector arcs = metaModel.getMetaArcs();
            for ( int i = 0; i < arcs.size(); i++)
            {
               BMetaGui.this.addArc( ((BMetaElement) arcs.get(i)).getName() ); //add arc node to gui tree
            }
            Vector rules = metaModel.getMetaRules();
            for ( int i = 0; i < rules.size(); i++)
            {
               BMetaGui.this.addRule( ((BMetaElement) rules.get(i)).getName() );//add rule to gui tree
            }
         }
      }

   	/**
   	 * Inner class that extends java.awt.event.MouseAdapter 
   	 * listens for mouse events that prompt the popup menu
   	 * being displayed
   	 */

      class PopupListener extends MouseAdapter {
         public void mousePressed(MouseEvent e) {
            maybeShowPopup(e);
         }

         public void mouseReleased(MouseEvent e) {
            maybeShowPopup(e);
         }

      	/**
      	 * shows the popup menu if the mouse event is the system
      	 * default popup type and if there is a node selected in the
      	 * JTree
      	 */
         private void maybeShowPopup(MouseEvent e) {
            if (e.isPopupTrigger())
            {
               if ( !BMetaGui.this.metaTree.isSelectionEmpty() )
               {
				  DefaultMutableTreeNode node = (DefaultMutableTreeNode) metaTree.getLastSelectedPathComponent();
				  if(node.isLeaf())
				  {
				    DefaultMutableTreeNode parent = (DefaultMutableTreeNode) node.getParent();
					String parentName = (String) parent.getUserObject();
					if ( parentName.equals( "Nodes" ) || parentName.equals( "Arcs" ) || parentName.equals( "Rules" ) )
					{
						popup.show(e.getComponent(), e.getX(), e.getY());
					}
				  }
               }
            }
         }
      }

   	
   	/**
   	 * Inner class that implements ActionListener
   	 * Listens to the delete menu item in the popup menu
   	 */
      class BOnPopupDelete implements ActionListener
      {
         public void actionPerformed( ActionEvent event )
         {
            DefaultMutableTreeNode node = (DefaultMutableTreeNode) metaTree.getLastSelectedPathComponent();
            if (node != null)
            {
               Object nodeInfo = node.getUserObject();

               if ( node.isLeaf() )
               {
                  DefaultMutableTreeNode parent = ( DefaultMutableTreeNode ) node.getParent();
                  String parentName = (String) parent.getUserObject();
                  if ( parentName.equals( "Nodes" ) )
                  {
                     BMetaGui.this.metaModel.removeNode( (BMetaNode)nodeInfo );
                     BMetaGui.this.treeModel.removeNodeFromParent(node);
                  }
                  else if ( parentName.equals( "Arcs" ) )
                  {
                     BMetaGui.this.metaModel.removeArc( (BMetaArc)nodeInfo);
                     BMetaGui.this.treeModel.removeNodeFromParent(node);
                  }
                  else if ( parentName.equals( "Rules" ) )
                  {
                     BMetaGui.this.metaModel.removeRule( (BMetaRule)nodeInfo  );
                     BMetaGui.this.treeModel.removeNodeFromParent(node);
                  }

               }
            }
         }
      }



	  // open a metamodel file...
	  private File getOpenMetamodelFile()
	  {
		BFileFilter filter = new BFileFilter( BDialect.getString ( this, "fileextension" ), filterString.toString() );
		BGetFilesCE getFile = new BGetFilesCE(".");
		getFile.setTitle(filterString.toString());
		getFile.setFileFilter(filter);
		BBlockingComplete complete = dispatchEventAndWait(getFile);

		if(complete.getStatus() == BCommandComplete.kSuccess)
		{
			getFile = (BGetFilesCE) complete.getEvent();
			return getFile.getSelectedFile();
		}
		else
		{
			return null;
		}
	  }


   }
