//$Header: /teamproj/cvsroot/teamb/bkasrc/au/edu/swin/synergy/plugin/metamodeller/BMetaModel.java,v 1.25 1999/10/17 05:45:26 tp079479 Exp $

   package au.edu.swin.synergy.plugin.metamodeller;

   import java.util.Vector;

   import java.io.Serializable;
   import java.io.File;
   import java.io.FileInputStream;
   import java.io.ObjectInputStream;
   import java.io.IOException;

   import au.edu.swin.synergy.debug.Debug;
   import au.edu.swin.synergy.lib.io.BSaveable;
   import au.edu.swin.synergy.lib.io.BDataFile;

/**
 * class BMetaModel
 * @author Imron Alston
 * @author Shane Fitzgibbon
 * @date 21/7/99
 *
 * The metamodel that describes what a model can be made out of
 *
 * Please complete these missing tags
 * @copyright
 */
   public class BMetaModel implements Serializable, BSaveable
   {

	public static final int kNoRuleViolation = 0;
	public static final int kMaxInRuleViolation = 1;
	public static final int kMaxOutRuleViolation = 2;
	public static final int kConnectionRuleViolation = 3;
	public static final int kCircRefRuleViolation = 4;
	public static final int kStartRuleTypes = 1;
	public static final int kMaxRuleTypes = 4;

	 //don't save the listeners...
     private Vector listeners = null;

    /**
     * the name of this metamodel (e.g. OMT, UML etc ) *
     */
      private String name = null;

    /**
     * the metaNodes *
     */
      private Vector metaNodes = null;

    /**
     * the metaArcs *
     */
      private Vector metaArcs = null;

    /**
     * the metaRules *
     */
      private Vector metaRules = null;


   /**
    * BConnectNodeRule, for connect rule evaluation.
    * The index will correspond to the meta-arc's id-num.
    */
      private BConnectNodeRule connectRule = null;

   /**
    * MaxRule for maxIn rule evaluation.
    * The index will correspond to the meta-node's id-num
    */
      private BMaxRule maxIn = null;

   /**
    * MaxRule for maxOut rule evaluation.
    * The index will correspond to the meta-node's id-num
    */
      private BMaxRule maxOut = null;

   /**
    * CircRule for circ-reference rule evaluation.
    * The index will correspond to the meta-node's id-num
    */
      private BCircRule circRule = null;

	// for BSaveable
	protected static final String kKeyName = "name";
	protected static final String kDefaultName = "untitled";


    /**
     * Construct the vectors for the nodes/arcs and rules..
     * Please complete the missing tags for BMetaModel
     * @param
     * @return
     * @pre
     * @post
     */
      public BMetaModel()
      {
         this.metaNodes = new Vector();
         this.metaArcs = new Vector();
         this.metaRules = new Vector();
      }
    /**
     * Please complete the missing tags for getMetaNodes
     * @param
     * @return
     * @pre
     * @post
     */

      public Vector getMetaNodes()
      {
         return this.metaNodes;
      }

   /**
     * Please complete the missing tags for getMetaNodes
     * @param
     * @return
     * @pre
     * @post
     */


      public BMetaElement getMetaNode(String name)

      {
         for ( int i = 0; i < this.metaNodes.size(); i++ )
         {
            BMetaElement meta = (BMetaElement) this.metaNodes.get(i);
            if ( meta.getName().equals( name ) )
            {
               return meta;
            }
         }
         return null;
      }

	  public int getMetaNodeIndex( String name )
	  {
		for ( int i = 0; i < this.metaNodes.size(); i++ )
         {
            BMetaElement meta = (BMetaElement) this.metaNodes.get(i);
            if ( meta.getName().equals( name ) )
            {
               return i;
            }
         }
         return -1;
	  }


    /**
     * Please complete the missing tags for getMetaArcs
     * @param
     * @return
     * @pre
     * @post
     */

      public Vector getMetaArcs()
      {
         return this.metaArcs;
      }

   	/**
     * Please complete the missing tags for getMetaNodes
     * @param
     * @return
     * @pre
     * @post
     */


      public BMetaElement getMetaArc(String name)
      {
         for ( int i = 0; i < this.metaArcs.size(); i++ )
         {
            BMetaElement meta = (BMetaElement) this.metaArcs.get(i);
            if ( meta.getName().equals( name ) )
            {
               return meta;
            }
         }
         return null;
      }

	public int getMetaArcIndex( String name )
	  {
		for ( int i = 0; i < this.metaArcs.size(); i++ )
         {
            BMetaElement meta = (BMetaElement) this.metaArcs.get(i);
            if ( meta.getName().equals( name ) )
            {
               return i;
            }
         }
         return -1;
	  }



    /**
     * Please complete the missing tags for getMetaRules
     * @param
     * @return
     * @pre
     * @post
     */

      public Vector getMetaRules()
      {
         return this.metaRules;
      }

   	/**
     * Please complete the missing tags for getMetaNodes
     * @param
     * @return
     * @pre
     * @post
     */


      public BMetaElement getMetaRule(String name)

      {
         for ( int i = 0; i < this.metaRules.size(); i++ )
         {
            BMetaElement meta = (BMetaElement) this.metaRules.get(i);
            if ( meta.getName().equals( name ) )
            {
               return meta;
            }
         }
         return null;
      }

	  public int getMetaRuleIndex( String name )
	  {
		for ( int i = 0; i < this.metaRules.size(); i++ )
         {
            BMetaElement meta = (BMetaElement) this.metaRules.get(i);
            if ( meta.getName().equals( name ) )
            {
               return i;
            }
         }
         return -1;
	  }

    /**
     * Please complete the missing tags for setName
     * @param
     * @return
     * @pre
     * @post
     */

      public void setName( String theName )
      {
         this.name = theName;
      }
    /**
     * Please complete the missing tags for addMetaNode
     * @param
     * @return
     * @pre
     * @post
     */

      public void addMetaNode( BMetaElement theNode )
      {
         this.metaNodes.add( theNode );
      }
    /**
     * Please complete the missing tags for addMetaArc
     * @param
     * @return
     * @pre
     * @post
     */

      public void addMetaArc( BMetaElement theArc )
      {
         this.metaArcs.add( theArc );
      }
    /**
     * Please complete the missing tags for addMetaRule
     * @param
     * @return
     * @pre
     * @post
     */

      public void addMetaRule( BMetaElement theRule )
      {
         this.metaRules.add( theRule );
      }

   	/**
   	 * gets the name of the Meta Model
   	 * @return the meta-model name
   	 */

      public String getName()
      {
         return this.name;
      }

   	/**
   	 * Sets the meta node that contains the old node with the new node
   	 * @param newNode The node that is to replace the old node
   	 * @param oldNode The node that is currently in the meta model
   	 * @pre The old node must be part of the meta model
   	 * @return void
   	 */
      public void setNode( BMetaElement newNode, BMetaElement oldNode )
      {
         Debug.doPrintln("bMetaModel:setNOde:oldNode: " + oldNode + " new Node: " + newNode);
         Debug.doPrintln("Setting node index: " + this.metaNodes.indexOf( oldNode ) );
         if ( this.metaNodes.indexOf( oldNode ) != -1 )
         {
            this.metaNodes.set( this.metaNodes.indexOf( oldNode ) , newNode);
         }
      }

   	/**
   	 * Sets the meta arc that contains the old arc with the new arc
   	 * @param oldArc The arc that is currently in the meta model
   	 * @param newArc The node that is to replace the old node
   	 * @pre The old arc must be part of the meta model
   	 * @return void
   	 */
      public void setArc( BMetaElement oldArc, BMetaElement newArc )
      {
         Debug.doPrintln("bMetaModel:setArc:oldArc: " + oldArc + " new Arc: " + newArc);
         Debug.doPrintln("Setting arc index: " + this.metaArcs.indexOf( oldArc ) );
         if ( this.metaArcs.indexOf( oldArc ) != -1 )
         {
            this.metaArcs.set( this.metaArcs.indexOf( oldArc ) , newArc);
         }
      }

   	/**
   	 * Sets the meta rule that contains the old rule with the new rule
   	 * @param oldRule The rule that is currently in the meta model
   	 * @param newRule The rule that is to replace the old rule
   	 * @pre The old rule must be part of the meta model
   	 * @return void
   	 */
      public void setRule( BMetaElement oldRule, BMetaElement newRule )
      {
         Debug.doPrintln("bMetaModel:setRule:oldRule: " + oldRule + " new Rule: " + newRule);
         Debug.doPrintln("Setting rule index: " + this.metaRules.indexOf( oldRule ) );
         if ( this.metaRules.indexOf( oldRule ) != -1 )
         {
            this.metaRules.set( this.metaRules.indexOf( oldRule ) , newRule);
         }
      }

   /***************** Imron's stuff *******************************/

   /**
    * Loads a metamodel from the file specified into the metamodel specified
    * @param String fileName - the name of the metamodel to load.
    * @param BMetaModel metaModel - the metaModel to load into.
    * @return the loaded metamodel, or null on error
    */
/*      public static BMetaModel loadFromFile( String fileName )
      {

         BMetaModel result = null;

         try
         {

            File metaModelFile = new File( fileName );

            FileInputStream inputStream = new FileInputStream(metaModelFile);
            ObjectInputStream objectIn = new ObjectInputStream(inputStream);

            result = (BMetaModel)objectIn.readObject();

         }
            catch(IOException ioException)
            {
               Debug.doPrintln("***ioException " + ioException );
            //            ioException.printStackTrace();

            }
            catch(ClassNotFoundException cnfException)
            {
               Debug.doPrintln("***cnfException " + cnfException );
            //            cnfException.printStackTrace();
            }
            catch( Exception e )
            {
               Debug.doPrintln("***other exception "+ e );
               e.printStackTrace();
            }

         return result;
      }*/

   /*********** Imron's stuff **************/


   	/**
   	 * Removes the meta node that is passed in from the metamodel
   	 * @param the meta element to be removed form the metamodel
   	 */

      public void removeNode( BMetaElement node)
      {
         Debug.doPrintln("BMetaModel:removeNode:node: " + node );
         if ( this.metaNodes.indexOf( node ) != -1 )
         {
            this.metaNodes.remove( node );
         }
      }

   	/**
   	 * Removes the meta arc that is passed in from the metamodel
   	 * @param the meta element to be removed form the metamodel
   	 */

      public void removeArc( BMetaElement arc)
      {
         Debug.doPrintln("BMetaModel:removeArc:arc: " + arc );
         if ( this.metaArcs.indexOf( arc ) != -1 )
         {
            this.metaArcs.remove( arc );
         }
      }

   	/**
   	 * Removes the meta rule that is passed in from the metamodel
   	 * @param the meta element to be removed form the metamodel
   	 */

      public void removeRule( BMetaElement rule)
      {
         Debug.doPrintln("BMetaModel:removeRule:rule: " + rule );
         if ( this.metaRules.indexOf( rule ) != -1 )
         {
            this.metaRules.remove( rule );
         }
      }

      public boolean load(BDataFile file)
      {
         Debug.doPrintln("BMetaModel.load");
         name = file.getData(kKeyName, kDefaultName);
         Debug.doPrintln("Name is : " + name);

         while(true)
         {
            BMetaElement object = (BMetaElement) file.autoLoad();
         	Debug.doPrintln("Got Object form autoload " + object);
            if(object == null)
            {
            	Debug.doPrintln("Load Finished");
               break;
            }
            if (object instanceof BMetaNode)
            {
               Debug.doPrintln("Getting node");
               metaNodes.add(object);
            }
            else if (object instanceof BMetaArc)
            {
               Debug.doPrintln("Getting Arc");
               metaArcs.add(object);
            }
            else if (object instanceof BMetaRule)
            {
               Debug.doPrintln("Getting Rule");
               metaRules.add(object);
            }
         }
		 this.setupRules();

         return true;
      }

      public boolean save(BDataFile file)
      {
         Debug.doPrintln("BMetaModel.save");
         file.addData(kKeyName, name, kDefaultName);

         for(int i=0; i<metaNodes.size(); i++)
         {
            file.save((BSaveable)metaNodes.get(i));
         }

         for(int i=0; i<metaArcs.size(); i++)
         {
            file.save((BSaveable)metaArcs.get(i));
         }

         for(int i=0; i<metaRules.size(); i++)
         {
            file.save((BSaveable)metaRules.get(i));
         }
         return true;
      }

	  public void setupRules()
	  {
		int temp;
		maxIn = new BMaxRule( metaNodes.size(), metaArcs.size() );
		maxOut = new BMaxRule( metaNodes.size(), metaArcs.size() );
		connectRule = new BConnectNodeRule( metaArcs.size(), metaNodes.size() );
		circRule = new BCircRule( metaArcs.size() );
		for(int i=0; i < metaRules.size(); i++)
		{
			
			Vector props = ((BMetaElement)metaRules.get(i)).getProperties();
			int type = new Integer( (String)props.firstElement() ).intValue();

			temp = 0;
			if ( type == 0 )
			{
				try
				{
					temp = Integer.parseInt( props.get(2).toString() );
				}
				catch( NumberFormatException e )
				{
					temp = 0;
				}
				Debug.doPrintln("Setting a maxIn rule");
				maxIn.setMax( metaNodes.indexOf( this.getMetaNode( (String)props.get(1) ) ),metaArcs.indexOf( this.getMetaArc( (String)props.get(3) ) ), temp );
			}
			else if ( type == 1 )
			{
				try
				{
					temp = Integer.parseInt( props.get(2).toString() );
				}
				catch( NumberFormatException e )
				{
					temp = 0;
				}
				Debug.doPrintln("Setting a maxOut rule");
				maxOut.setMax( metaNodes.indexOf( this.getMetaNode( (String)props.get(1) ) ), metaArcs.indexOf( this.getMetaArc( (String)props.get(3) ) ), temp );
			}
			else if ( type == 2 )
			{
				Debug.doPrintln("Setting a connection rule");
				connectRule.setConnect( metaArcs.indexOf( this.getMetaArc( (String)props.get(1) ) ),
										metaNodes.indexOf( this.getMetaNode( (String)props.get(2) ) ),
										metaNodes.indexOf( this.getMetaNode( (String)props.get(4) ) ),
										new Boolean( (String)props.get(3) ).booleanValue() );
			}
			else if ( type == 3 )
			{
				Debug.doPrintln("Setting a circ rule");
				circRule.setCirc( metaArcs.indexOf( this.getMetaArc( (String)props.get(1) ) ),
								  new Boolean( (String)props.get(2) ).booleanValue());
			}
			else
			{
				Debug.doPrintln("Error in BMetaModel:setupRules: incorrect rule type");
			}
		}
      }

	  /**
	   * Evaluates wether the current number of connections coming into a node
	   * excedes the allowed maximum
	   *
	   * @param node the node who's connections are being validated
	   * @param max the number of connections currently coming into the node
	   * @returns the result of evaulating the rule
	   */

	  public boolean evalMaxIn( BMetaElement node, BMetaElement arc, int max )
	  {
		return maxIn.evalMax( metaNodes.indexOf( node ), metaArcs.indexOf( arc ), max );
	  }

	  /**
	   * Evaluates wether the current number of connections going out of a node
	   * excedes the allowed maximum
	   *
	   * @param node the node who's connections are being validated
	   * @param max the number of connections currently going out of the node
	   * @returns the result of evaulating the rule
	   */

	  public boolean evalMaxOut( BMetaElement node, BMetaElement arc, int max )
	  {
		return maxOut.evalMax( metaNodes.indexOf( node ), metaArcs.indexOf(arc), max );
	  }

	  /**
	   * Evaluates wether a connection is allowed to exist
	   *
	   * @param arc the type of arc that the connection is
	   * @param startNode the node that the arc connects from
	   * @param endNode the node that the arc connects to
	   * @returns the validity of this connection
	   */

	  public boolean evalConnection( BMetaElement arc, BMetaElement startNode, BMetaElement endNode )
	  {
		return connectRule.evalConnect( metaArcs.indexOf(arc), metaNodes.indexOf(startNode), metaNodes.indexOf(endNode) );
	  }

	  /**
	   * Evaluates wether a connection is allowed to start..
	   *
	   * @param arc the type of arc that the connection is
	   * @param startNode the node that the arc connects from
	   * @returns the validity of this connection
	   */

	  public boolean evalStartConnection( BMetaElement arc, BMetaElement startNode )
	  {
		return connectRule.evalStartConnect( metaArcs.indexOf(arc), metaNodes.indexOf(startNode) );
  	  }

	  /**
	   * Evaluates wether circular referenceing for a node is allowed
	   *
	   * @param node the node to evaulate
	   * @returns wether this node allows circular referencing
	   */

	  public boolean evalCirc( BMetaElement node )
	  {
		return circRule.evalCirc( metaArcs.indexOf( node ) );
	  }



   }

