//$Header: /teamproj/cvsroot/teamb/bkasrc/au/edu/swin/synergy/plugin/metamodeller/BRuleGui.java,v 1.15 1999/10/12 16:05:32 tp079479 Exp $

   package au.edu.swin.synergy.plugin.metamodeller;

   import javax.swing.*;
   import javax.swing.border.*;
   import javax.swing.tree.*;
   import java.awt.event.*;
   import java.awt.*;
   import javax.swing.SwingUtilities;

   import au.edu.swin.synergy.kernel.BPlugin;
   import au.edu.swin.synergy.plugin.mod13.event.BCloseWindowCE;
   import au.edu.swin.synergy.debug.Debug;

   import au.edu.swin.synergy.plugin.dialect.BDialect;   

   import java.util.Vector;

	/**
	 * class that supplies a gui for creating and
	 * editing meta rules
	 * @author Shane Fitzgibbon
	 * @copyright Synergy Software 1999
	 */
   public class BRuleGui extends JPanel
   {

   	/**
   	 * The rule being created/edited
   	 */
      protected BMetaRule metaRule = null;


   	/**
   	 * the meta model that the rule apply to
   	 */
      protected BMetaModel metaModel;

   	/**
   	 * Reference to a plugin
   	 */
      BPlugin plugin;

	  JTree tree;

	  GridBagLayout layout = null;
	  GridBagLayout ruleLayout = null;
	  GridBagConstraints gbc = null;


      JPanel mainPanel;

	  JLabel ruleNameLabel;
	  JTextField ruleNameField;

	  JLabel ruleTypeLabel;	  
	  JComboBox ruleTypeCombo;

	  ButtonGroup allowedGroup;

	  JRadioButton allowedRadio;
	  JRadioButton disallowedRadio;

	  JComboBox arcCombo;
	  JComboBox startCombo;
	  JComboBox endCombo;

	  JLabel arcLabel;
	  JLabel startLabel;
	  JLabel endLabel;

	  JLabel maxNumLabel;
	  JTextField maxNumField;

	  BOnUpdateRuleValue onUpdate;



   	/**
   	 * Constructor for BRuleGui
   	 * @param plug a reference to the plugin that creates this class
   	 * @param meta the metamodel that this rule is part of
   	 */
      public BRuleGui( BPlugin plug, JTree tree)
      {
         plugin = plug;
		 this.tree =tree;
         doInit();
      }


      private void doInit()
      {
		// Try making this array of BString and change locale.
		String [] types = new String[4];
		types[0] = new String ( BDialect.getString ( this, "maxin" ) );
		types[1] = new String ( BDialect.getString ( this, "maxout" ) );
		types[2] = new String ( BDialect.getString ( this, "nodeconn" ) );
		types[3] = new String ( BDialect.getString ( this, "circ" ) );

		layout = new GridBagLayout();

		setLayout( layout );

		ruleLayout = new GridBagLayout();



		gbc = new GridBagConstraints();

		onUpdate = new BOnUpdateRuleValue();

		

		 
		ruleNameLabel = new JLabel( BDialect.getString ( this, "rulename" ) );		 
		gbc.gridx = 0;
		gbc.gridy = 0;
		gbc.gridwidth = 1;
		gbc.gridheight = 1;
		gbc.weightx = 0;
		gbc.weighty = 0;
		gbc.fill = GridBagConstraints.HORIZONTAL;
		gbc.anchor = GridBagConstraints.CENTER;
		gbc.insets = new Insets(5, 5, 5, 5);
		gbc.ipadx = 2;
		gbc.ipady = 2; 
		add( ruleNameLabel, gbc );

	
		ruleNameField = new JTextField();
		ruleNameField.addFocusListener( new NameFocus() );
		gbc.gridx = 1;
		gbc.gridy = 0;
		gbc.gridwidth = 1;
		gbc.gridheight = 1;
		gbc.weightx = 1;
		gbc.weighty = 0;
		gbc.fill = GridBagConstraints.HORIZONTAL;
		gbc.anchor = GridBagConstraints.CENTER;
		gbc.insets = new Insets(5, 5, 5, 5);
		gbc.ipadx = 2;
		gbc.ipady = 2; 
		add( ruleNameField, gbc );

		ruleTypeLabel = new JLabel( BDialect.getString ( this, "ruletype" ) );
		gbc.gridx = 0;
		gbc.gridy = 1;
		gbc.gridwidth = 1;
		gbc.gridheight = 1;
		gbc.weightx = 0;
		gbc.weighty = 0;
		gbc.fill = GridBagConstraints.HORIZONTAL;
		gbc.anchor = GridBagConstraints.CENTER;
		gbc.insets = new Insets(5, 5, 5, 5);
		gbc.ipadx = 2;
		gbc.ipady = 2; 
		add( ruleTypeLabel, gbc );
		        
		ruleTypeCombo = new JComboBox( types );
		ruleTypeCombo.setSelectedIndex(0);
		ruleTypeCombo.addActionListener( new BOnType() );
		gbc.gridx = 1;
		gbc.gridy = 1;
		gbc.gridwidth = 1;
		gbc.gridheight = 1;
		gbc.weightx = 1;
		gbc.weighty = 0;
		gbc.fill = GridBagConstraints.HORIZONTAL;
		gbc.anchor = GridBagConstraints.CENTER;
		gbc.insets = new Insets(5, 5, 5, 5);
		gbc.ipadx = 2;
		gbc.ipady = 2; 
		add( ruleTypeCombo, gbc );

		mainPanel = new JPanel();
		mainPanel.setLayout( ruleLayout );
		gbc.gridx = 0;
		gbc.gridy = 2;
		gbc.gridwidth = 2;
		gbc.gridheight = 1;
		gbc.weightx = 1;
		gbc.weighty = 1;
		gbc.fill = GridBagConstraints.HORIZONTAL;
		gbc.anchor = GridBagConstraints.CENTER;
		gbc.insets = new Insets(5, 5, 5, 5);
		gbc.ipadx = 2;
		gbc.ipady = 2; 
		add( mainPanel, gbc );

		allowedGroup = new ButtonGroup();

		allowedRadio = new JRadioButton( BDialect.getString ( this, "ruleallowed" ));
		allowedRadio.addActionListener( onUpdate );
		disallowedRadio = new JRadioButton(BDialect.getString ( this, "ruledisallowed" ));
		disallowedRadio.addActionListener( onUpdate );

		allowedGroup.add( allowedRadio );
		allowedGroup.add( disallowedRadio );

		arcCombo = new JComboBox();
		arcCombo.addActionListener( onUpdate );
		startCombo = new JComboBox();
		startCombo.addActionListener( onUpdate );
		endCombo = new JComboBox();
		endCombo.addActionListener( onUpdate );

		arcLabel = new JLabel(BDialect.getString ( this, "connarc" ) );
		startLabel = new JLabel(BDialect.getString( this, "startnode" ) );
		endLabel = new JLabel(BDialect.getString( this, "endnode" ) );
		

		maxNumLabel = new JLabel( BDialect.getString ( this, "maxnodes" ) );
		maxNumField = new JTextField();
		maxNumField.addFocusListener( onUpdate );

      }

	  private void addVectorToCombo( Vector vect, JComboBox combo, boolean clear )
	  {
		int i, size;
		if ( clear )
		{
			if ( combo.getItemCount() > 0 )
			{
				combo.removeAllItems();
			}
		}

		size = vect.size();

		for ( i = 0; i < size; i++ )
		{
			combo.addItem( vect.elementAt( i ) );
		}

	  }

	  public void setMetaModel( BMetaModel meta )
	  {		
		this.metaModel = meta;
		Vector temp;
		
		 temp = getArcs();
		 addVectorToCombo( temp, arcCombo, true );
		 if ( arcCombo.getItemCount() > 0 )
		 {
			arcCombo.setSelectedIndex(0);
		 }

         temp = getNodes();
		 addVectorToCombo( temp, startCombo, true );

		 if ( startCombo.getItemCount() > 0 )
		 {
			startCombo.setSelectedIndex(0);
		 }
		 addVectorToCombo( temp, endCombo, true );
		 if ( endCombo.getItemCount() > 0 )
		 {
			endCombo.setSelectedIndex(0);
		 }

	  }

	  public void setRule( BMetaElement rule, BMetaModel meta )
	  {
		BMetaRule hack = metaRule;
		metaRule = null;
		this.setMetaModel( meta );
		metaRule = hack;
		this.setRule( rule );
	  }

      protected void setRule( BMetaElement rule )
      {
		int type = 0;

		if ( metaModel == null ) return;

         if ( rule instanceof BMetaRule )
         {
            metaRule = (BMetaRule) rule;
            Vector props = rule.getProperties();			

			try
			{
				if ( props.size() > 0 )
				{
					type = Integer.parseInt(props.firstElement().toString());
				}
			}
			catch( Exception e )
			{
			}

			this.ruleNameField.setText( metaRule.getName() );
            ruleTypeCombo.setSelectedIndex( type );

			this.setRuleGui( type );
			
			

			
         }
      }


	public void setRuleGui( int type )
	{		
		switch( type )
		{
			case 0:
				maxNumLabel.setText( BDialect.getString ( this, "maxnodes" ) );				
				doShowMaxRule();
				break;
			case 1:
				maxNumLabel.setText( BDialect.getString ( this, "maxnodesout" ) );				
				doShowMaxRule();
				break;
			case 2:
				doShowConnectionRule();
				break;
			case 3:
				doShowCircRule();
				break;
		}	

		this.revalidate();


	}

   	/**
   	 * method that clears the rulegui
   	 */
      private void clearGui()
      {
		mainPanel.removeAll();
		ruleLayout.invalidateLayout( mainPanel );
	  }



   	/**
   	 * set the gui up to display what is required for the max nodes in rule
   	 */
      private void doShowMaxRule()
      {
		int val = 0;
		int startIndex, arcIndex;

		if ( startCombo.getItemCount() <= 0 || arcCombo.getItemCount() <= 0)
		{
			clearGui();
			return;
		}

		try
		{	
			val = Integer.parseInt( metaRule.getProperties().get(2).toString() );
			startIndex = metaModel.getMetaNodeIndex( metaRule.getProperties().get(1).toString() );	
			arcIndex = metaModel.getMetaArcIndex( metaRule.getProperties().get(3).toString() );
		}
		catch( Exception e )
		{
			val = 0;
			startIndex = 0;
			arcIndex = 0;
		}

		

		clearGui();

		startLabel.setText( BDialect.getString( this, "maxnode" ) );
		gbc.gridx = 0;
		gbc.gridy = 0;
		gbc.gridwidth = 1;
		gbc.gridheight = 1;
		gbc.weightx = 0;
		gbc.weighty = 0;
		gbc.fill = GridBagConstraints.HORIZONTAL;
		gbc.anchor = GridBagConstraints.CENTER;
		gbc.insets = new Insets(5, 5, 5, 5);
		gbc.ipadx = 2;
		gbc.ipady = 2;
		mainPanel.add( startLabel, gbc );
		
		gbc.gridx = 1;
		gbc.gridy = 0;
		gbc.gridwidth = 1;
		gbc.gridheight = 1;
		gbc.weightx = 1;
		gbc.weighty = 0;
		gbc.fill = GridBagConstraints.HORIZONTAL;
		gbc.anchor = GridBagConstraints.CENTER;
		gbc.insets = new Insets(5, 5, 5, 5);
		gbc.ipadx = 2;
		gbc.ipady = 2;
		startCombo.setSelectedIndex( startIndex );
		mainPanel.add( startCombo, gbc );

		
		gbc.gridx = 2;
		gbc.gridy = 0;
		gbc.gridwidth = 1;
		gbc.gridheight = 1;
		gbc.weightx = 0;
		gbc.weighty = 0;
		gbc.fill = GridBagConstraints.HORIZONTAL;
		gbc.anchor = GridBagConstraints.CENTER;
		gbc.insets = new Insets(5, 5, 5, 5);
		gbc.ipadx = 2;
		gbc.ipady = 2;

		if (val == 0)
		{ 
			maxNumField.setText( "" );
		}
		else
		{
			maxNumField.setText("" + val);
		}
		
		mainPanel.add( maxNumLabel, gbc );
		
	    arcLabel.setText( BDialect.getString( this, "connarc" ) );
		gbc.gridx = 0;
		gbc.gridy = 1;
		gbc.gridwidth = 1;
		gbc.gridheight = 1;
		gbc.weightx = 0;
		gbc.weighty = 0;
		gbc.fill = GridBagConstraints.HORIZONTAL;
		gbc.anchor = GridBagConstraints.CENTER;
		gbc.insets = new Insets(5, 5, 5, 5);
		gbc.ipadx = 2;
		gbc.ipady = 2;
		mainPanel.add( arcLabel, gbc );

		gbc.gridx = 1;
		gbc.gridy = 1;
		gbc.gridwidth = 1;
		gbc.gridheight = 1;
		gbc.weightx = 1;
		gbc.weighty = 0;
		gbc.fill = GridBagConstraints.HORIZONTAL;
		gbc.anchor = GridBagConstraints.CENTER;
		gbc.insets = new Insets(5, 5, 5, 5);
		gbc.ipadx = 2;
		gbc.ipady = 2;
		arcCombo.setSelectedIndex( arcIndex );
		mainPanel.add( arcCombo, gbc );
		
		gbc.gridx = 2;
		gbc.gridy = 1;
		gbc.gridwidth = 1;
		gbc.gridheight = 1;
		gbc.weightx = 1;
		gbc.weighty = 0;
		gbc.fill = GridBagConstraints.HORIZONTAL;
		gbc.anchor = GridBagConstraints.CENTER;
		gbc.insets = new Insets(5, 5, 5, 5);
		gbc.ipadx = 2;
		gbc.ipady = 2;         
		mainPanel.add( maxNumField, gbc );
         
      }


   	/**
   	 * Sets up the gui to show the connection rule
   	 */
      private void doShowConnectionRule()
      {

		int arcIndex, startIndex, endIndex;
		boolean bool;

		if ( startCombo.getItemCount() <= 0 || arcCombo.getItemCount() <= 0 || endCombo.getItemCount() <= 0)
		{
			clearGui();
			return;
		}

		
		try
		{
			arcIndex = metaModel.getMetaArcIndex( metaRule.getProperties().elementAt(1).toString() );
			startIndex = metaModel.getMetaNodeIndex( metaRule.getProperties().elementAt(2).toString() );		
			bool = new Boolean( metaRule.getProperties().elementAt(3).toString() ).booleanValue();
			endIndex = metaModel.getMetaNodeIndex( metaRule.getProperties().elementAt(4).toString() );
		}
		catch(Exception e )
		{
			arcIndex = 0;
			startIndex = 0;
			endIndex = 0;
			bool = false;

		}

		clearGui();

        startLabel.setText( BDialect.getString( this, "startnode" ) );
		gbc.gridx = 0;
		gbc.gridy = 0;
		gbc.gridwidth = 1;
		gbc.gridheight = 1;
		gbc.weightx = 0;
		gbc.weighty = 0;
		gbc.fill = GridBagConstraints.HORIZONTAL;
		gbc.anchor = GridBagConstraints.CENTER;
		gbc.insets = new Insets(5, 5, 5, 5);
		gbc.ipadx = 2;
		gbc.ipady = 2;
		mainPanel.add( startLabel, gbc );
		
		gbc.gridx = 1;
		gbc.gridy = 0;
		gbc.gridwidth = 1;
		gbc.gridheight = 1;
		gbc.weightx = 1;
		gbc.weighty = 0;
		gbc.fill = GridBagConstraints.HORIZONTAL;
		gbc.anchor = GridBagConstraints.CENTER;
		gbc.insets = new Insets(5, 5, 5, 5);
		gbc.ipadx = 2;
		gbc.ipady = 2;
		startCombo.setSelectedIndex( startIndex );
		mainPanel.add( startCombo, gbc );

		
		gbc.gridx = 2;
		gbc.gridy = 0;
		gbc.gridwidth = 1;
		gbc.gridheight = 1;
		gbc.weightx = 0;
		gbc.weighty = 0;
		gbc.fill = GridBagConstraints.HORIZONTAL;
		gbc.anchor = GridBagConstraints.CENTER;
		gbc.insets = new Insets(5, 5, 5, 5);
		gbc.ipadx = 2;
		gbc.ipady = 2;
		mainPanel.add( allowedRadio, gbc );
		

	    
		gbc.gridx = 0;
		gbc.gridy = 1;
		gbc.gridwidth = 1;
		gbc.gridheight = 1;
		gbc.weightx = 0;
		gbc.weighty = 0;
		gbc.fill = GridBagConstraints.HORIZONTAL;
		gbc.anchor = GridBagConstraints.CENTER;
		gbc.insets = new Insets(5, 5, 5, 5);
		gbc.ipadx = 2;
		gbc.ipady = 2;
		mainPanel.add( arcLabel, gbc );

		gbc.gridx = 1;
		gbc.gridy = 1;
		gbc.gridwidth = 1;
		gbc.gridheight = 1;
		gbc.weightx = 1;
		gbc.weighty = 0;
		gbc.fill = GridBagConstraints.HORIZONTAL;
		gbc.anchor = GridBagConstraints.CENTER;
		gbc.insets = new Insets(5, 5, 5, 5);
		gbc.ipadx = 2;
		gbc.ipady = 2;

		arcCombo.setSelectedIndex( arcIndex );

		
		mainPanel.add( arcCombo, gbc );

		
		gbc.gridx = 2;
		gbc.gridy = 1;
		gbc.gridwidth = 1;
		gbc.gridheight = 1;
		gbc.weightx = 0;
		gbc.weighty = 0;
		gbc.fill = GridBagConstraints.HORIZONTAL;
		gbc.anchor = GridBagConstraints.CENTER;
		gbc.insets = new Insets(5, 5, 5, 5);
		gbc.ipadx = 2;
		gbc.ipady = 2;         		
		mainPanel.add( disallowedRadio, gbc );
		
		

		if ( bool )
		{
			allowedRadio.doClick();
		}
		else
		{
			disallowedRadio.doClick();
		}


		gbc.gridx = 0;
		gbc.gridy = 2;
		gbc.gridwidth = 1;
		gbc.gridheight = 1;
		gbc.weightx = 0;
		gbc.weighty = 0;
		gbc.fill = GridBagConstraints.HORIZONTAL;
		gbc.anchor = GridBagConstraints.CENTER;
		gbc.insets = new Insets(5, 5, 5, 5);
		gbc.ipadx = 2;
		gbc.ipady = 2;
		mainPanel.add( endLabel, gbc );

		gbc.gridx = 1;
		gbc.gridy = 2;
		gbc.gridwidth = 1;
		gbc.gridheight = 1;
		gbc.weightx = 1;
		gbc.weighty = 0;
		gbc.fill = GridBagConstraints.HORIZONTAL;
		gbc.anchor = GridBagConstraints.CENTER;
		gbc.insets = new Insets(5, 5, 5, 5);
		gbc.ipadx = 2;
		gbc.ipady = 2;
		endCombo.setSelectedIndex( endIndex );
		mainPanel.add( endCombo, gbc );
      }

   	/**
   	 * sets up the gui to show the circ rule
   	 */
      private void doShowCircRule()
      {
		boolean bool;
		int arcIndex;
		
		if ( arcCombo.getItemCount() <= 0 )
		{
			clearGui();
			return;
		}
		
		try
		{
			arcIndex = metaModel.getMetaArcIndex( metaRule.getProperties().elementAt(1).toString() );
			bool = new Boolean( metaRule.getProperties().elementAt(2).toString() ).booleanValue();
		}
		catch( Exception e )
		{
			bool = true;
			arcIndex = 0;
		}        

		clearGui();


		gbc.gridx = 0;
		gbc.gridy = 0;
		gbc.gridwidth = 1;
		gbc.gridheight = 1;
		gbc.weightx = 0;
		gbc.weighty = 0;
		gbc.fill = GridBagConstraints.HORIZONTAL;
		gbc.anchor = GridBagConstraints.CENTER;
		gbc.insets = new Insets(5, 5, 5, 5);
		gbc.ipadx = 2;
		gbc.ipady = 2;
		mainPanel.add( arcLabel, gbc );
		
		gbc.gridx = 1;
		gbc.gridy = 0;
		gbc.gridwidth = 1;
		gbc.gridheight = 1;
		gbc.weightx = 1;
		gbc.weighty = 0;
		gbc.fill = GridBagConstraints.HORIZONTAL;
		gbc.anchor = GridBagConstraints.CENTER;
		gbc.insets = new Insets(5, 5, 5, 5);
		gbc.ipadx = 2;
		gbc.ipady = 2;
		arcCombo.setSelectedIndex(arcIndex);
		mainPanel.add( arcCombo, gbc );
		
		gbc.gridx = 2;
		gbc.gridy = 0;
		gbc.gridwidth = 1;
		gbc.gridheight = 1;
		gbc.weightx = 0;
		gbc.weighty = 0;
		gbc.fill = GridBagConstraints.HORIZONTAL;
		gbc.anchor = GridBagConstraints.CENTER;
		gbc.insets = new Insets(5, 5, 5, 5);
		gbc.ipadx = 2;
		gbc.ipady = 2;		
		mainPanel.add( allowedRadio, gbc );

		if ( bool )
		{
			allowedRadio.doClick();
		}
		else
		{
			disallowedRadio.doClick();
		}
				
		gbc.gridx = 2;
		gbc.gridy = 1;
		gbc.gridwidth = 1;
		gbc.gridheight = 1;
		gbc.weightx = 0;
		gbc.weighty = 0;
		gbc.fill = GridBagConstraints.HORIZONTAL;
		gbc.anchor = GridBagConstraints.CENTER;
		gbc.insets = new Insets(5, 5, 5, 5);
		gbc.ipadx = 2;
		gbc.ipady = 2;         
		mainPanel.add( disallowedRadio, gbc );



      }

      private Vector getNodes()
      {
         Vector nodes = metaModel.getMetaNodes();
         Vector model = new Vector( nodes.size() );
         for ( int i = 0; i < nodes.size(); i++)
         {
            BMetaElement node = (BMetaElement)nodes.get( i );
            model.add( node.getName() );
         }
         return model;
      }

      private Vector getArcs()
      {
         Vector arcs = metaModel.getMetaArcs();
         Vector model = new Vector( arcs.size() );
         for ( int i = 0; i < arcs.size(); i++)
         {
            BMetaElement arc = (BMetaElement)arcs.get( i );
            model.add( arc.getName() );
         }
         return model;
      }


	public void updateRuleType()
	{
		if ( startCombo.getSelectedIndex() != -1 && endCombo.getSelectedIndex() != -1 
		     && arcCombo.getSelectedIndex() != -1 && ruleTypeCombo.getSelectedIndex() != -1 && metaRule != null )
		{
		   
		   metaRule.resetProperties();
		   
		   metaRule.addProperty( Integer.toString( ruleTypeCombo.getSelectedIndex() ) );
		   switch ( ruleTypeCombo.getSelectedIndex() )
		   {
			  case 0:
				 {
					metaRule.addProperty( startCombo.getSelectedItem().toString() );
					metaRule.addProperty( maxNumField.getText() );
					metaRule.addProperty( arcCombo.getSelectedItem().toString() );
					break;
				 }
			  case 1:
				 {
					metaRule.addProperty( startCombo.getSelectedItem().toString() );
					metaRule.addProperty( maxNumField.getText() );
					metaRule.addProperty( arcCombo.getSelectedItem().toString() );
					break;
				 }
			  case 2:
				 {
					metaRule.addProperty( arcCombo.getSelectedItem().toString() );
					metaRule.addProperty( startCombo.getSelectedItem().toString() );
					if (disallowedRadio.isSelected() )
					{
					   metaRule.addProperty( "false" );
					}
					else
					{
					   metaRule.addProperty( "true" );
					}
					metaRule.addProperty( endCombo.getSelectedItem().toString() );
					break;
				 }
			  case 3:
				 {
					metaRule.addProperty( arcCombo.getSelectedItem().toString() );
					if (disallowedRadio.isSelected() )
					{
					   metaRule.addProperty( "false" );
					}
					else
					{
					   metaRule.addProperty( "true" );
					}
					break;
				 }
			  default:
				 {
					break;
				 }
		   }
	    }
		else
		{
			if ( metaRule != null )
			{
				metaRule.resetProperties();		   
				metaRule.addProperty( Integer.toString( -1 ) );
			}
		}
	 }

	 class NameFocus implements FocusListener
	 {
		public void focusGained( FocusEvent e )
		{
		}

		public void focusLost( FocusEvent e )
		{
			if ( metaRule != null )
			{
				metaRule.setName( ruleNameField.getText() );				

				TreePath path = tree.getSelectionPath();
				if ( path != null )
				{
					if ( ((DefaultMutableTreeNode)path.getLastPathComponent()).isLeaf() )
					{
						tree.getModel().valueForPathChanged( path, metaRule );
					}
				}



			}
		}
	 }
	 

   	/**
   	 * Inner class that listens to the rule type combo box and then
   	 * sets up the gui to match the selection
   	 */
      class BOnType implements ActionListener
      {
         public void actionPerformed( ActionEvent event )
         {
            JComboBox cb = (JComboBox) event.getSource();
            if ( cb.getSelectedIndex() != -1 )
            {
               setRuleGui( cb.getSelectedIndex() );
            }
         }
      }

	  class BOnUpdateRuleValue implements ActionListener, FocusListener
	  {
		public void actionPerformed( ActionEvent event )
		{
			updateRuleType();
		}

		public void focusGained( FocusEvent event )
		{
		}

		public void focusLost( FocusEvent event )
		{
			updateRuleType();
		}
	  }

      


   }