// $Header: /teamproj/cvsroot/teamb/bkasrc/au/edu/swin/synergy/plugin/mod13/BWindowManager.java,v 1.60 1999/10/22 00:59:21 tp079210 Exp $

package au.edu.swin.synergy.plugin.mod13;

import java.awt.*;

import java.lang.reflect.InvocationTargetException;

import au.edu.swin.synergy.kernel.BPlugin;
import au.edu.swin.synergy.kernel.BCommandEvent;
import au.edu.swin.synergy.kernel.BCommandComplete;
import au.edu.swin.synergy.kernel.event.BBootCE;

import au.edu.swin.synergy.plugin.command.event.BStandardOutCE;
import au.edu.swin.synergy.plugin.command.event.BHandleStdOutCE;
import au.edu.swin.synergy.plugin.mod13.bwt.BMetalTheme;
import au.edu.swin.synergy.lib.BStringList;

import au.edu.swin.synergy.plugin.test2.event.BTestCE;
import au.edu.swin.synergy.kernel.BKernel;

import au.edu.swin.synergy.lib.BDynamicPane;
import au.edu.swin.synergy.plugin.mod13.event.BAddWindowCE;
import au.edu.swin.synergy.plugin.mod13.event.BCloseWindowCE;
import au.edu.swin.synergy.plugin.mod13.event.BSelectWindowCE;
import au.edu.swin.synergy.plugin.mod13.event.BAddStatusCE;
import au.edu.swin.synergy.plugin.mod13.event.BRemoveStatusCE;
import au.edu.swin.synergy.plugin.mod13.event.BAddPanelCE;
import au.edu.swin.synergy.plugin.mod13.event.BAddMenuCE;
import au.edu.swin.synergy.plugin.mod13.event.BAddToolBarCE;
import au.edu.swin.synergy.plugin.mod13.event.BRemoveToolBarCE;
import au.edu.swin.synergy.plugin.mod13.event.BAddMenuItemCE;
import au.edu.swin.synergy.plugin.mod13.event.BRemoveMenuItemCE;
import au.edu.swin.synergy.plugin.mod13.event.BSelectPanelCE;
import au.edu.swin.synergy.plugin.mod13.event.BRemovePanelCE;
import au.edu.swin.synergy.plugin.mod13.event.BWindowCE;
import au.edu.swin.synergy.plugin.mod13.bwt.BWindowListener;
import au.edu.swin.synergy.plugin.mod13.bwt.BWindowEvent;
import au.edu.swin.synergy.plugin.mod13.bwt.BWindowAdapter;
import au.edu.swin.synergy.plugin.mod13.bwt.BWindowBinder;
import au.edu.swin.synergy.plugin.mod13.bwt.BSwingUtilities;
import au.edu.swin.synergy.plugin.mod13.event.BGetFilesCE;

import au.edu.swin.synergy.plugin.dialect.BDialect;
import au.edu.swin.synergy.plugin.dialect.BString;
import au.edu.swin.synergy.plugin.dialect.event.BDialectChangeCE;

import au.edu.swin.synergy.plugin.command.event.BRegisterCmdCE;

import au.edu.swin.synergy.debug.Debug;

import javax.swing.*;
import javax.swing.event.InternalFrameAdapter;
import javax.swing.event.InternalFrameEvent;
import javax.swing.border.BevelBorder;
import javax.swing.plaf.metal.MetalLookAndFeel;

import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowListener;
import java.awt.event.WindowEvent;
import java.awt.BorderLayout;
import java.awt.FlowLayout;
import java.awt.GridLayout;
import java.awt.Color;
import java.awt.Font;
import java.awt.Dimension;
import java.awt.Toolkit;
import java.awt.Graphics;

import java.util.Hashtable;
import java.util.Vector;


/**
 * Window Manager plugin
 * @Author John Newbigin, Tristan Austin
 * @Copyright Synergy Software 1999
 * @rref Tristans Book
 */


public class BWindowManager extends BPlugin
{
	/**
	 * The frame on which everything resides
	 */
    static JFrame mainFrame = new JFrame();
	
    JMenu fileMenu;
    JMenu editMenu;
    JMenu windowMenu;

    /**
     * The darker of the two synergy blues
     */
    Color synergyDarkBlue =  new Color(0x3A, 0x51, 0x95);

    /**
     * The darker of the two synergy blues
     */
    Color synergyLightBlue =  new Color(0xB8, 0xCC, 0xE8);

    /**
     * The file exit menu item
     */
    JMenuItem exitMenuItem = null;

    /**
     * This is the menu agent that handles all interaction with the menus
     */
    private BMenuAgent menuAgent = null;

    /**
     * The panel agent will handle all requests for changes on the panels
     */
    private BPanelAgent panelAgent = null;

    /**
     * Handles all of the window functionality
     */
    private BWindowAgent windowAgent = null;

    /**
     * The action listener for menu items
     */
    private BExitListener exitListener = new BExitListener();

    /**
     * The synergy metal theme
     */
    private static BMetalTheme synergyPLAF = new BMetalTheme();

    /**
     * Please complete the missing tags for setup
     * @post
     * @pre
     * @throws
     * @return
     * @param
     */
    public void setup(BStringList params)
    {
        Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
        BAddMenuItemCE addMenuItem = null;

		//changed so it fits nicely when running under 1024x768
		mainFrame.setSize( screenSize.width - 50, screenSize.height - 50 );
        mainFrame.setLocation( ( screenSize.width - mainFrame.getSize().width ) / 2, ( screenSize.height - mainFrame.getSize().height ) / 2 );
		MetalLookAndFeel plaf = (MetalLookAndFeel) UIManager.getLookAndFeel();
		plaf.setCurrentTheme( synergyPLAF );
		try
		{
			UIManager.setLookAndFeel(plaf);
			SwingUtilities.updateComponentTreeUI( mainFrame );
		}
		catch(Exception ex)
		{
		}

        //Create the main menu items
        fileMenu = new JMenu( );
        editMenu = new JMenu( );
        windowMenu = new JMenu();

        //Create the exit menu item
        exitMenuItem = new JMenuItem();
        exitMenuItem.addActionListener( this.exitListener );

        //Set the layout of the main frame
        mainFrame.getContentPane().setLayout( new BorderLayout() );

        //Create the panel and window agent now that the main frame's layout has been set
        menuAgent = new BMenuAgent();
		//Read in arguments from conf file
		if (params.getCount() == 2)
		{
			windowAgent = new BWindowAgent(mainFrame, this.windowMenu, params.get(1));
        }
		else
		{
			windowAgent = new BWindowAgent(mainFrame, this.windowMenu, null);
		}
		panelAgent = new BPanelAgent(mainFrame);

        //Add the menus to the menu bar
        this.menuAgent.addMenu( fileMenu, BAddMenuCE.kNormalPolicy, new BString(BAddMenuItemCE.kFileMenu), new BString("filemn") );
        this.menuAgent.addMenu( editMenu, BAddMenuCE.kNormalPolicy, new BString(BAddMenuItemCE.kEditMenu), new BString("editmn") );
        this.menuAgent.addMenu( windowMenu, BAddMenuCE.kAlwaysRightAligned, new BString(BAddMenuItemCE.kWindowMenu), new BString("windowmn") );

        //Set the menu bar on the frame
        mainFrame.setJMenuBar( this.menuAgent.getMenuBar() );

        //Set up the command line
        this.dispatchEvent( new BRegisterCmdCE( this, BDialect.getString(this, "menucmd"), this.menuAgent.getCommandLine() ) );
        this.dispatchEvent( new BRegisterCmdCE( this, BDialect.getString(this, "windowcmd"), this.windowAgent.getCommandLine() ) );
        this.dispatchEvent( new BRegisterCmdCE( this, BDialect.getString(this, "panelcmd"), this.panelAgent.getCommandLine() ) );

        //Register the exit menu item
        addMenuItem = new BAddMenuItemCE(this, exitMenuItem, new BString(this, "exit"), new BString("file"));
        this.menuAgent.addMenuItem(addMenuItem);

        addMenuItem = new BAddMenuItemCE(this, exitMenuItem, new BString(this, "exit"), new BString("window"));

        //Add the listener to the main frame
        mainFrame.addWindowListener( this.exitListener );
        mainFrame.setDefaultCloseOperation(JFrame.DO_NOTHING_ON_CLOSE);

        //Set the text values
        this.doDialect();
    }

    /**
     * This will get the color to use as the highlight color
     * for anything on the interface. It matches the highlight color for text
     *
     * @return The highlight color
     */
    public static Color getHighlightColor()
    {
        return synergyPLAF.getTextHighlightColor();
    }


    /**
     * This method will be called whenever the locale changes or
     * at initialisation in order to make sure everything has the
     * correct names for the current Locale.
     */
    protected void doDialect()
    {
        //Set the aesthetics up
        BSwingUtilities.setFrameIcon(mainFrame, this.windowAgent.getLargeWindowIcon().getImage());
        BSwingUtilities.setFrameTitle(mainFrame, BDialect.getString(this, "frametitle"));

        //Calling doDialect on all the agents
        this.menuAgent.doDialect();
        this.windowAgent.doDialect();
        this.panelAgent.doDialect();

        //Set the mnemonic on the exit menu
        exitMenuItem.setMnemonic((BDialect.getString(this, "exitmn")).charAt(0));
    }

	/**
	 * This will return the component that currently has the focus.
	 *
	 * @return The component with the focus
	 */
	public static Component getFocusOwner()
	{
		return SwingUtilities.findFocusOwner(mainFrame);
	}


    //*/
    /**
     * Please complete the missing tags for onBCommandEvent
     * @post
     * @pre
     * @throws
     * @return
     * @param
     */
    public void onBCommandEvent( Object source, BCommandEvent event )
    {
        BWorkerThread workerThread;

        //Make sure it's one of ours before we send it off to the AWT thread
        if (event instanceof BWindowCE || event instanceof BStandardOutCE || event instanceof BBootCE || event instanceof BDialectChangeCE)
        {
            workerThread = new BWorkerThread(event);

            //Only set auto complete off on window events
            if (!(event instanceof BBootCE))
            {
                //We don't want it to return immediately
                event.setAutoComplete(false);
            }

            //Send the runnable off to the swing utilities
            SwingUtilities.invokeLater(workerThread);
        }
    }

    /**
     * When called, this will shut down the kernel
     * and exit the system
     * Please complete the missing tags for doSystemExit
     * @param
     * @return
     * @pre
     * @post
     */
    private void doSystemExit()
    {
        Debug.doPrintln( "Exit" );

        BExitComplete complete = new BExitComplete();
        BStandardOutCE standardOut = new BStandardOutCE(this, BDialect.getString(this, "reallyQuit"), true, complete);
        standardOut.setMessageType(BStandardOutCE.kQuestion);
        standardOut.setUserResponseOption(BStandardOutCE.kYesNoOption);
        this.dispatchEvent(standardOut);
    }

    /**
     * This is called by the standard out handler when the user is asked
     * if they really wish to quit.
     *
     * @author Tristan Austin
     */
    class BExitComplete extends BCommandComplete
    {
        /**
         * Called when the user has responded to the question
         *
         * @param   event   The standard out event originally fired
         * @param   status  The success status of the event
         */
        public void doComplete( BCommandEvent event, int status )
        {
            BStandardOutCE standardOut = (BStandardOutCE)event;

            //If they hit yes, exit the system
            if (standardOut.getUserResponse() == BStandardOutCE.kYes)
            {
                getKernel().doShutdown();
            }
        }
    }

    /**
     * Handles program flow when the top level frame itself closes
     *
     * @author Tristan Austin
     */
    class BExitListener extends WindowAdapter implements ActionListener
    {
        /**
         * When the user closes the frame directly, this method
         * is called to shut down the kernel.
         *
         * @param   windowEvent The event fired
         */
        public void windowClosing( WindowEvent windowEvent )
        {
            BWindowManager.this.doSystemExit();
        }

        /**
         * Called when a registered component has an action
         * performed on it.
         *
         * @param   actionEvent The event fired
         */
        public void actionPerformed( ActionEvent actionEvent )
        {
            Object source = actionEvent.getSource();

            if( source == exitMenuItem )
            {
                BWindowManager.this.doSystemExit();
            }
        }
    }

    /**
     * All the work is done in a separate Runnable thread so that
     * it can simply be handed off to the Swing awt event thread
     * and everything will take place in the appropriate thread.
     * <p>
     * Possible problems with this is that nothing will be processed at
     * all until the runnable method is invoked in the awt event thread.
     *
     * @author Tristan Austin
     */
    private class BWorkerThread implements Runnable
    {
        /**
         * This is the event that was received by the window manager
         */
        private BCommandEvent event;

        /**
         * Creates a new thread with the given event
         * to process.
         *
         * @param   event   The event to process
         */
        public BWorkerThread(BCommandEvent event)
        {
            this.event = event;
        }

        /**
         * This will be invoked when the thread finally gets
         * to the head of the AWT event queue.
         */
        public void run()
        {
            //Determine what type of event was received
            if( event instanceof BBootCE )
            {
                mainFrame.setVisible(true);
				dispatchEvent(new BHandleStdOutCE(this, false));
                panelAgent.doInitialisation();
            }
            else if( event instanceof BAddPanelCE )
            {
                panelAgent.addPanel( ( BAddPanelCE ) event );
            }
            else if( event instanceof BAddWindowCE )
            {
                windowAgent.addWindow( ( BAddWindowCE ) event );
            }
            else if( event instanceof BSelectWindowCE )
            {
                windowAgent.selectWindow( ( BSelectWindowCE ) event );
            }
            else if( event instanceof BCloseWindowCE )
            {
                windowAgent.closeWindow( ( BCloseWindowCE ) event );
            }
            else if (event instanceof BStandardOutCE)
            {
                windowAgent.doStandardOut((BStandardOutCE)event);
            }
            else if( event instanceof BAddMenuItemCE )
            {
                menuAgent.addMenuItem( ( BAddMenuItemCE ) event );
            }
            else if (event instanceof BRemoveMenuItemCE)
            {
                menuAgent.removeMenuItem((BRemoveMenuItemCE)event);
            }
            else if( event instanceof BRemovePanelCE )
            {
                panelAgent.removePanel( ( BRemovePanelCE ) event );
            }
            else if( event instanceof BSelectPanelCE )
            {
                panelAgent.selectPanel( ( BSelectPanelCE ) event );
            }
            else if( event instanceof BRemoveStatusCE )
            {           
                panelAgent.removeStatus( ( BRemoveStatusCE ) event );
            }
            else if( event instanceof BAddStatusCE )
            {
                panelAgent.addStatus( ( BAddStatusCE ) event );
            }
            else if (event instanceof BRemoveToolBarCE)
            {
                panelAgent.removeToolBar((BRemoveToolBarCE)event);
            }
            else if (event instanceof BAddToolBarCE)
            {
                panelAgent.addToolBar((BAddToolBarCE)event);
            }
            else if (event instanceof BStandardOutCE)
            {
                windowAgent.doStandardOut((BStandardOutCE)event);
            }
            else if (event instanceof BDialectChangeCE)
            {
                BWindowManager.this.doDialect();
            }
			else if (event instanceof BGetFilesCE)
			{
				windowAgent.doGetFile((BGetFilesCE)event);
			}
        }
    }
}
