//$Header: /teamproj/cvsroot/teamb/bkasrc/au/edu/swin/synergy/plugin/mod13/bwt/BMetalTheme.java,v 1.4 1999/10/15 10:26:20 tp079210 Exp $
package au.edu.swin.synergy.plugin.mod13.bwt;

import javax.swing.plaf.metal.*;

import javax.swing.plaf.*;
import javax.swing.*;
import java.awt.*;
import java.util.Properties;
import java.io.InputStream;
import au.edu.swin.synergy.plugin.dialect.BDialect;
import au.edu.swin.synergy.debug.Debug;

public class BMetalTheme extends MetalTheme
{
	private ColorUIResource primary1 = new ColorUIResource(0x3A5195);
    private ColorUIResource primary2 = new ColorUIResource(0xB8CCE8);
    private ColorUIResource primary3 = new ColorUIResource(0x3A5195);
    private ColorUIResource primary4 = new ColorUIResource(0xB8CCE8);

    private ColorUIResource textHighlighter = new ColorUIResource(0xB8CCE8);

    private ColorUIResource secondary1 = new ColorUIResource(0x3A5195);
    private ColorUIResource secondary2 = new ColorUIResource(0x3A5195);
    private ColorUIResource secondary3 = new ColorUIResource(204, 204, 204);

    private FontUIResource controlFont;
    private FontUIResource systemFont;
    private FontUIResource userFont;
    private FontUIResource smallFont;

    public BMetalTheme()
	{
        //Get the colors form the properties file
        Properties colorValues = new Properties();
        InputStream inputStream = getClass().getResourceAsStream("/au/edu/swin/synergy/plugin/mod13/bwt/screencolors.properties");

        try
        {
            colorValues.load(inputStream);
            String currentColor = (String)colorValues.get("primary1");
            int colorValue = Integer.parseInt(currentColor, 16);
            primary1 = new ColorUIResource(colorValue);

            currentColor = (String)colorValues.get("primary2");
            colorValue = Integer.parseInt(currentColor, 16);
            primary2 = new ColorUIResource(colorValue);

            currentColor = (String)colorValues.get("primary3");
            colorValue = Integer.parseInt(currentColor, 16);
            primary3 = new ColorUIResource(colorValue);

            currentColor = (String)colorValues.get("primary4");
            colorValue = Integer.parseInt(currentColor, 16);
            primary4 = new ColorUIResource(colorValue);

            currentColor = (String)colorValues.get("textHighlighter");
            colorValue = Integer.parseInt(currentColor, 16);
            textHighlighter = new ColorUIResource(colorValue);

            currentColor = (String)colorValues.get("secondary1");
            colorValue = Integer.parseInt(currentColor, 16);
            secondary1 = new ColorUIResource(colorValue);

            currentColor = (String)colorValues.get("secondary2");
            colorValue = Integer.parseInt(currentColor, 16);
            secondary2 = new ColorUIResource(colorValue);

            currentColor = (String)colorValues.get("secondary3");
            colorValue = Integer.parseInt(currentColor, 16);
            secondary3 = new ColorUIResource(colorValue);
        }
        catch(Exception exception)
        {
            Debug.doPrintln("Color load error: ", exception);
        }

	  /*try*/ {
        controlFont = new FontUIResource(Font.getFont("swing.plaf.metal.controlFont", new Font("Dialog", Font.BOLD, 12)));
        systemFont = new FontUIResource(Font.getFont("swing.plaf.metal.systemFont", new Font("Dialog", Font.PLAIN, 12)));
        userFont = new FontUIResource(Font.getFont("swing.plaf.metal.userFont", new Font("Dialog", Font.PLAIN, 12)));
        smallFont = new FontUIResource(Font.getFont("swing.plaf.metal.smallFont", new Font("Dialog", Font.PLAIN, 10)));
      } /*catch (Exception e) {
        controlFont = new FontUIResource("Dialog", Font.BOLD, 12);
        systemFont =  new FontUIResource("Dialog", Font.PLAIN, 12);
        userFont =  new FontUIResource("Dialog", Font.PLAIN, 12);
        smallFont = new FontUIResource("Dialog", Font.PLAIN, 10);
      }*/
	}

	public String getName() { return "Synergy"; }

    protected ColorUIResource getPrimary1() { return primary1; }
    protected ColorUIResource getPrimary2() { return primary2; }
    protected ColorUIResource getPrimary3() { return primary3; }


    protected ColorUIResource getSecondary1() { return secondary1; }
    protected ColorUIResource getSecondary2() { return secondary2; }
    protected ColorUIResource getSecondary3() { return secondary3; }

    public FontUIResource getControlTextFont() { return controlFont;}
    public FontUIResource getSystemTextFont() { return systemFont;}
    public FontUIResource getUserTextFont() { return userFont;}
    public FontUIResource getMenuTextFont() { return controlFont;}
    public FontUIResource getWindowTitleFont() { return controlFont;}
    public FontUIResource getSubTextFont() { return smallFont;}

	public ColorUIResource getControlShadow() { return getPrimary3(); }
    public ColorUIResource getTextHighlightColor() { return textHighlighter; }        //0xE2E9FE

    public ColorUIResource getPrimaryControl() { return primary4; }
    public ColorUIResource getWindowTitleBackground() { return primary4; }     //0xA0B7FB//*/
}
