// $Header: /teamproj/cvsroot/teamb/bkasrc/au/edu/swin/synergy/plugin/mod13/bwt/BWindowBinder.java,v 1.1 1999/08/31 02:57:29 tp079210 Exp $


package au.edu.swin.synergy.plugin.mod13.bwt;

import java.awt.event.WindowListener;
import java.awt.event.WindowEvent;

import javax.swing.*;
import javax.swing.event.InternalFrameListener;
import javax.swing.event.InternalFrameEvent;

/**
 * This provides a means of plugins to listen to window events on their
 * own steam. The Plugins will need to have an implementation of a BWindowListener
 * class which is bound to a BWindowBinder. The BWindowBinder is added as a listener
 * to either a Dialog, Window or a JInternalFrame. All events received by
 * this class will be bound to the BWindowListener as they come in.
 *
 * @author Tristan Austin
 * Please complete these missing tags
 * @copyright
 */
public class BWindowBinder implements WindowListener, InternalFrameListener
{
    /**
     * The window listener to redirect all events to
     */
    private BWindowListener windowListener;

    /**
     * This is the content of the window
     */
    private JComponent windowContent;

    /**
     * Creates a new BWindowBinder with the specified window listener
     * to bind events to. The window listener passed in here will be
     * the object which will ultimately receive all the window events.
     *
     * @param   windowListener
     * Please complete the missing tags for BWindowBinder
     * @return
     * @pre
     * @post
     */
    public BWindowBinder( BWindowListener windowListener, JComponent windowContent )
    {
        this.windowListener = windowListener;
        this.windowContent = windowContent;
    }

    /**
     * Invoked the first time a window is made visible.
     *
     * @param   windowEvent The window event fired
     * Please complete the missing tags for windowOpened
     * @return
     * @pre
     * @post
     */
    public void windowOpened( WindowEvent windowEvent )
    {
        this.windowListener.windowOpened( new BWindowEvent( windowEvent.getSource(), this.windowContent ) );
    }
    
    /**
     * Invoked when the user attempts to close the window from the window's system menu. If the program does not explicitly hide or
     * dispose the window while processing this event, the window close operation will be cancelled.
     *
     * @param   windowEvent The window event fired
     * Please complete the missing tags for windowClosing
     * @return
     * @pre
     * @post
     */
    public void windowClosing( WindowEvent windowEvent )
    {
        this.windowListener.windowClosing( new BWindowEvent( windowEvent.getSource(), this.windowContent ) );
    }
    
    /**
     * Invoked when a window has been closed as the result of calling dispose on the window.
     *
     * @param   windowEvent The window event fired
     * Please complete the missing tags for windowClosed
     * @return
     * @pre
     * @post
     */
    public void windowClosed( WindowEvent windowEvent )
    {
        this.windowListener.windowClosed( new BWindowEvent( windowEvent.getSource(), this.windowContent ) );
    }
    
    /**
     * Invoked when a window is changed from a normal to a minimized state. For many platforms, a minimized window is displayed as
     * the icon specified in the window's iconImage property.
     *
     * @param   windowEvent The window event fired
     * Please complete the missing tags for windowIconified
     * @return
     * @pre
     * @post
     */
    public void windowIconified( WindowEvent windowEvent )
    {
        this.windowListener.windowIconified( new BWindowEvent( windowEvent.getSource(), this.windowContent ) );
    }
    
    /**
     * Invoked when a window is changed from a minimized to a normal state.
     *
     * @param   windowEvent The window event fired
     * Please complete the missing tags for windowDeiconified
     * @return
     * @pre
     * @post
     */
    public void windowDeiconified( WindowEvent windowEvent )
    {
        this.windowListener.windowDeiconified( new BWindowEvent( windowEvent.getSource(), this.windowContent ) );
    }
    
    /**
     * Invoked when the window is set to be the user's active window, which means the window (or one of its subcomponents) will
     * receive keyboard events.
     *
     * @param   windowEvent The window event fired
     * Please complete the missing tags for windowActivated
     * @return
     * @pre
     * @post
     */
    public void windowActivated( WindowEvent windowEvent )
    {
        this.windowListener.windowActivated( new BWindowEvent( windowEvent.getSource(), this.windowContent ) );
    }
    
    /**
     * Invoked when a window is no longer the user's active window, which means that keyboard events will no longer be delivered to the
     * window or its subcomponents.
     *
     * @param   windowEvent The window event fired
     * Please complete the missing tags for windowDeactivated
     * @return
     * @pre
     * @post
     */
    public void windowDeactivated( WindowEvent windowEvent )
    {
        this.windowListener.windowDeactivated( new BWindowEvent( windowEvent.getSource(), this.windowContent ) );
    }
    
    /**
     * Invoked the first time a window is made visible.
     *
     * @param   windowEvent The window event fired
     * Please complete the missing tags for internalFrameOpened
     * @return
     * @pre
     * @post
     */
    public void internalFrameOpened( InternalFrameEvent internalFrameEvent )
    {
        this.windowListener.windowOpened( new BWindowEvent( internalFrameEvent.getSource(), this.windowContent ) );
    }
    
    /**
     * Invoked when the user attempts to close the internalFrame from the window's system menu. If the program does not explicitly hide or
     * dispose the window while processing this event, the window close operation will be cancelled.
     *
     * @param   internalFrameEvent The internalFrame event fired
     * Please complete the missing tags for internalFrameClosing
     * @return
     * @pre
     * @post
     */
    public void internalFrameClosing( InternalFrameEvent internalFrameEvent )
    {
        this.windowListener.windowClosing( new BWindowEvent( internalFrameEvent.getSource(), this.windowContent ) );
    }
    
    /**
     * Invoked when a internalFrame has been closed as the result of calling dispose on the internalFrame.
     *
     * @param   internalFrameEvent The internalFrame event fired
     * Please complete the missing tags for internalFrameClosed
     * @return
     * @pre
     * @post
     */
    public void internalFrameClosed( InternalFrameEvent internalFrameEvent )
    {
        this.windowListener.windowClosed( new BWindowEvent( internalFrameEvent.getSource(), this.windowContent ) );
    }
    
    /**
     * Invoked when a internalFrame is changed from a normal to a minimized state. For many platforms, a minimized internalFrame is displayed as
     * the icon specified in the internalFrame's iconImage property.
     *
     * @param   internalFrameEvent The internalFrame event fired
     * Please complete the missing tags for internalFrameIconified
     * @return
     * @pre
     * @post
     */
    public void internalFrameIconified( InternalFrameEvent internalFrameEvent )
    {
        this.windowListener.windowIconified( new BWindowEvent( internalFrameEvent.getSource(), this.windowContent ) );
    }
    
    /**
     * Invoked when a internalFrame is changed from a minimized to a normal state.
     *
     * @param   internalFrameEvent The internalFrame event fired
     * Please complete the missing tags for internalFrameDeiconified
     * @return
     * @pre
     * @post
     */
    public void internalFrameDeiconified( InternalFrameEvent internalFrameEvent )
    {
        this.windowListener.windowDeiconified( new BWindowEvent( internalFrameEvent.getSource(), this.windowContent ) );
    }
    
    /**
     * Invoked when the internalFrame is set to be the user's active internalFrame, which means the internalFrame (or one of its subcomponents) will
     * receive keyboard events.
     *
     * @param   internalFrameEvent The internalFrame event fired
     * Please complete the missing tags for internalFrameActivated
     * @return
     * @pre
     * @post
     */
    public void internalFrameActivated( InternalFrameEvent internalFrameEvent )
    {
        this.windowListener.windowActivated( new BWindowEvent( internalFrameEvent.getSource(), this.windowContent ) );
    }
    
    /**
     * Invoked when a internalFrame is no longer the user's active internalFrame, which means that keyboard events will no longer be delivered to the
     * internalFrame or its subcomponents.
     *
     * @param   internalFrameEvent The internalFrame event fired
     * Please complete the missing tags for internalFrameDeactivated
     * @return
     * @pre
     * @post
     */
    public void internalFrameDeactivated( InternalFrameEvent internalFrameEvent )
    {
        this.windowListener.windowDeactivated( new BWindowEvent( internalFrameEvent.getSource(), this.windowContent ) );
    }
    
    /**
     * This will compare this window binder with another window binder
     * or a BWindowListener. Two window binders are considered equal if
     * they both have the same window listener.
     *
     * @param   target  The object to compare against
     * @return True if they are the same, false otherwise
     * Please complete the missing tags for equals
     * @pre
     * @post
     */
    public boolean equals( Object target )
    {
        boolean equal = false;
        
        //See what type of comparison to make
        if( target instanceof BWindowListener )
        {
            //See if they both represent the same
            equal = ( target == this.windowListener );
        }
        else if( target instanceof BWindowBinder )
        {
            //See if it is the same as this one
            equal = ( this == target );
        }
        
        //Return the result
        return equal;
    }
}
