//$Header:

package au.edu.swin.synergy.plugin.mod13.bwt;

import java.awt.event.WindowListener;

/**
 * Any panels that are added to the Window Manager as
 * windows must implement this interface so that they
 * can be informed of window events.
 *
 * @author Tristan Austin
 * Please complete these missing tags
 * @copyright
 */
public interface BWindowListener
{
    /**
     * Invoked the first time a window is made visible.
     */
    public void windowOpened( BWindowEvent windowEvent );
    
    /**
     * Invoked when the user attempts to close the window from the window's system menu. If the program does not explicitly hide or
     * dispose the window while processing this event, the window close operation will be cancelled.
     */
    public void windowClosing( BWindowEvent windowEvent );
    
    /**
     * Invoked when a window has been closed as the result of calling dispose on the window.
     */
    public void windowClosed( BWindowEvent windowEvent );
    
    /**
     * Invoked when a window is changed from a normal to a minimized state. For many platforms, a minimized window is displayed as
     * the icon specified in the window's iconImage property.
     */
    public void windowIconified( BWindowEvent windowEvent );
    
    /**
     * Invoked when a window is changed from a minimized to a normal state.
     */
    public void windowDeiconified( BWindowEvent windowEvent );
    
    /**
     * Invoked when the window is set to be the user's active window, which means the window (or one of its subcomponents) will
     * receive keyboard events.
     */
    public void windowActivated( BWindowEvent windowEvent );
    
    /**
     * Invoked when a window is no longer the user's active window, which means that keyboard events will no longer be delivered to the
     * window or its subcomponents.
     */
    public void windowDeactivated( BWindowEvent windowEvent );
}
