/**
 * Please complete these missing tags
 * @see
 * @concurrency
 * @copyright
 * @rref
 * @author
 */
// $Header: /teamproj/cvsroot/teamb/bkasrc/au/edu/swin/synergy/plugin/mod13/event/BAddMenuItemCE.java,v 1.12 1999/09/27 07:19:24 tp079210 Exp $

package au.edu.swin.synergy.plugin.mod13.event;

import au.edu.swin.synergy.kernel.BCommandEvent;
import au.edu.swin.synergy.plugin.dialect.BString;
import java.util.Vector;

import javax.swing.*;

// This is the event which is passed around

public class BAddMenuItemCE extends BRemoveMenuItemCE
{
    /**
     * Adds items to a menu called File
     */
    public static String kFileMenu = "file";

    /**
     * Adds items to a menu called Edit
     */
    public static String kEditMenu = "edit";

    /**
     * Adds items to a menu called Window
     */
    public static String kWindowMenu = "window";

    /**
     * Adds items to a menu called Project
     */
    public static String kProjectMenu = "project";

    /**
     * Adds items to a menu called Admin
     */
    public static final String kAdminMenu = "admin";

    /**
     * Adds items to a menu called Messaging
     */
    public static final String kMessagingMenu = "messaging";

    /**
     * Adds items to a menu called Modeller
     */
    public static final String kModellerMenu = "modeller";

    /**
     * If a new menu is required, this will specify where it will be placed
     */
    private int locationPolicy = BAddMenuCE.kNormalPolicy;

    /**
     * The preferred mnemonic for the menu
     */
    private BString menuMnemonic = null;

    /**
     * Creates a new add menu item event with the source, the locale sensitive
     * name of the menu it is to go in. It is assumed that you will add menu
     * items individuall through the <code>addMenuItem()</code> method. Not doing so
     * will result in a menu with no items being created.
     *
     * @param source    The source of the event
     * @param   fMenu   The name of the menu to add it to
     */
    public BAddMenuItemCE( Object source, Object fMenu)
    {
        this(source, null, null, fMenu);
    }

    /**
     * Creates a new add menu item event with the source, the locale sensitive
     * name of the menu it is to go in and the locale sensitive name of the
     * menu item.
     *
     * @param source    The source of the event
     * @param   fMenu   The name of the menu to add it to
     * @param   menuItemName    The name of the menu item itself
     */
    public BAddMenuItemCE( Object source, JMenuItem fMenuItem, Object itemName, Object fMenu)
    {
        super(source, fMenuItem, itemName, fMenu);
    }

    /**
     * This will set the location policy
     * for the menu that may be created as a result
     * of adding these menu items.
     *
     * @param locationPolicy The menu location policy
     */
    public int setLocationPolicy(int locationPolicy)
    {
        return this.locationPolicy = locationPolicy;
    }

    /**
     * This will indicate the location policy
     * for the menu that may be created as a result
     * of adding these menu items.
     *
     * @return The menu location policy
     */
    public int getLocationPolicy()
    {
        return this.locationPolicy;
    }

    /**
     * You can set the mnemonic you prefer for this
     * menu here. It should be noted that if another
     * menu already has the mnemonic specified it will
     * be changed to the next available mnemonic.
     *
     * @param   preferredMnemonic   The preferred mnemonic for this menu
     */
    public void setPreferredMenuMnemonic(BString preferredMenuMnemonic)
    {
        this.menuMnemonic = preferredMenuMnemonic;
    }

    /**
     * This will return the preferred mnemonic for this menu.
     *
     * @return The preferred mnemonic
     */
    public BString getPreferredMenuMnemonic()
    {
        return this.menuMnemonic;
    }

    /**
     * This will put a separator in the menu item
     * in the location relative to calls to addMenuItem.
     * <P>
     * <Blockquote><code>
     * eg. event.addMenuItem(blah1, nameBlah);<BR>
     * event.addMenuItem(blah2, nameBlah);<BR>
     * event.addMenuItem(blah3, nameBlah);<BR>
     * event.addSeparator();<BR>
     * event.addMenuItem(blah4, nameBlah);</code></BLockquote>
     * <p>
     * Will result in a separator in the menu between menu item blah3 and blah4
     */
    public void addSeparator()
    {
        this.addMenuItem(new JSeparator(), null);
    }
}