// $Header: /teamproj/cvsroot/teamb/bkasrc/au/edu/swin/synergy/plugin/mod13/event/BAddPanelCE.java,v 1.8 1999/10/16 02:32:02 tp079210 Exp $


package au.edu.swin.synergy.plugin.mod13.event;

import au.edu.swin.synergy.kernel.BCommandEvent;
import au.edu.swin.synergy.plugin.dialect.BString;

import javax.swing.*;

/**
 * This event will allow other plugins to add panels
 * to the interface without having to use windows
 *
 * @author Tristan Austin
 * Please complete these missing tags
 * @copyright
 */
public class BAddPanelCE extends BWindowCE
{
    /**
     * Places the panel on the left hand side of the main screen
     */
    public static final int kLeft = 0;
    
    /**
     * Place the panel on the bottom of the main screen
     */
    public static final int kBottom = 1;
    
    /**
     * Places the panel on the left hand side of the main screen
     */
    public static final int kRight = 2;
    
    /**
     * Place the panel on the bottom of the main screen
     */
    public static final int kTop = 3;

    /**
     * The panel to add
     */
    private JComponent panel = null;
    
    /**
     * The name of the panel for display purposes
     */
    private Object name = null;
    
    /**
     * The location to place the panel
     */
    private int location = kLeft;

    /**
     * This is the step size for the panel resizing.
     */
    int stepSize = -1;

    /**
     * Indicate whether to place this component on a scroll pane
     */
    boolean useScrollPane = true;

    /**
     * Creates a new add panel event with the given source
     * and the location to place it in the window manager. This
     * defaults to using a scroll pane.
     *
     * @param   source  The source of the event
     * @param   newPanel    The panel to add, this can be any subclass of JComponent at all
     * @param   newLocation The location to place the panel
     * Please complete the missing tags for BAddPanelCE
     * @return
     * @pre
     * @post
     */
    public BAddPanelCE( Object source, JComponent newPanel, Object newName, int newLocation )
    {
        this(source, newPanel, newName, newLocation, true);
    }

    /**
     * Creates a new add panel event with the given source
     * and the location to place it in the window manager
     *
     * @param   source  The source of the event
     * @param   newPanel    The panel to add, this can be any subclass of JComponent at all
     * @param   newLocation The location to place the panel
     * @param   useScrollPane   True to place the component on a scroll pane, false otherwise
     * Please complete the missing tags for BAddPanelCE
     * @return
     * @pre
     * @post
     */
    public BAddPanelCE( Object source, JComponent newPanel, Object newName, int newLocation, boolean useScrollPane )
    {
        super( source );

        this.panel = newPanel;
        this.name = newName;
        this.location = newLocation;
        this.useScrollPane = useScrollPane;
    }

    /**
     * This will return the name of the panel for
     * display purposes.
     * Please complete the missing tags for getName
     * @param
     * @return
     * @pre
     * @post
     */
    public Object getName()
    {
        return this.name;
    }

    /**
     * Indicates whether they wish the component to be placed on a
     * scroll pane or not.
     *
     * @return True if they do, false otherwise
     */
    public boolean getScrollBarPolicy()
    {
        return this.useScrollPane;
    }

    /**
     * When the dynamic pane is resizing, you can specify
     * the incrementing values so that it snaps to certain
     * sizes when the user releases the mouse.
     *
     * @param   stepSize    The step size in pixels
     */
    public void setStepSize(int stepSize)
    {
        this.stepSize = stepSize;
    }

    /**
     * When the dynamic pane is resizing, you can specify
     * the incrementing values so that it snaps to certain
     * sizes when the user releases the mouse.
     * <p>
     * This method will get the step size currently set
     *
     * @param   The step size in pixels, -1 if none
     */
    public int getStepSize()
    {
        return this.stepSize;
    }

    /**
     * Gets the panel to add
     *
     * @return The panel to add
     * Please complete the missing tags for getPanel
     * @param
     * @pre
     * @post
     */
    public JComponent getPanel()
    {
        return this.panel;
    }
    
    /**
     * Gets the location to place this new panel
     *
     * @return   Returns the location as defined in this class
     * Please complete the missing tags for getLocation
     * @param
     * @pre
     * @post
     */
    public int getLocation()
    {
        return this.location;
    }
}
