// $Header: /teamproj/cvsroot/teamb/bkasrc/au/edu/swin/synergy/plugin/mod13/event/BAddToolBarCE.java,v 1.6 1999/10/14 11:46:35 tp079210 Exp $


package au.edu.swin.synergy.plugin.mod13.event;

import au.edu.swin.synergy.kernel.BCommandEvent;
import au.edu.swin.synergy.plugin.dialect.BString;

import javax.swing.*;
import java.util.Vector;

/**
 * Allows the source to add a tool bar to the main frame
 * of the window manager.
 *
 * @author Tristan Austin
 * Please complete these missing tags
 * @copyright
 */
public class BAddToolBarCE extends BWindowCE
{
     /**
      * These are the buttons to add to the toolbar
      */
     private Vector buttons = new Vector();

     /**
      * The lower the priority more right aligned it is
      */
     private int priority = 0;

     /**
     * Creates a new BAddToolBarCE with the given tool bar
     * to add to the window manager.
     *
     * @param   source  The source of the event
     */
    public BAddToolBarCE(Object source)
    {
        this(source, 0);
    }

     /**
     * Creates a new BAddToolBarCE with the given tool bar
     * to add to the window manager.
     *
     * @param   source  The source of the event
     * @param   priority    The value can be any valid int, the higher the value, the more left aligned the tool bar
     */
    public BAddToolBarCE(Object source, int priority)
    {
        super(source);
        this.priority = priority;
    }

    /**
     * Adds the given button the list of things to put on the tool
     * bar. It is assumed that the button has all the listeners already on it
     *
     * @param   button  The button to add to the tool bar with the given name
     */
    public void addButton(JComponent button)
    {
        this.buttons.add(button);
    }

    /**
     * Gets the priority for this toolbars alignment
     *
     * @return The relative priority of the tool bar
     */
    public int getPriority()
    {
        return this.priority;
    }

    /**
     * Gets the list of buttons to put on the tool bar
     *
     * @return  A Vector containing either buttons or separators
     */
    public Vector getButtons()
    {
        return this.buttons;
    }

    /**
     * This will add a separator to the tool bar
     */
    public void addSeparator()
    {
        //This needs to be converted to a toolbar separator
        this.buttons.add(new JSeparator(JSeparator.VERTICAL));
    }
}
