/**
 * Please complete these missing tags
 * @see
 * @concurrency
 * @copyright
 * @rref
 * @author
 */
// $Header: /teamproj/cvsroot/teamb/bkasrc/au/edu/swin/synergy/plugin/mod13/event/BAddWindowCE.java,v 1.11 1999/09/27 07:19:24 tp079210 Exp $

package au.edu.swin.synergy.plugin.mod13.event;

import au.edu.swin.synergy.kernel.BCommandEvent;
import au.edu.swin.synergy.kernel.BCommandComplete;

import au.edu.swin.synergy.plugin.dialect.BString;

import au.edu.swin.synergy.debug.Debug;

import java.awt.event.WindowListener;
import java.util.Vector;
import java.awt.*;

import javax.swing.*;
import javax.swing.event.InternalFrameListener;
import au.edu.swin.synergy.plugin.mod13.bwt.BWindowListener;
import au.edu.swin.synergy.plugin.mod13.bwt.BWindowBinder;

/**
 * This event is passed to the Window Manager with a panel and various
 * properties to add to a Window in the GUI.
 *
 * @author John Newbigin
 */
public class BAddWindowCE extends BCloseWindowCE
{
    /**
     * This will hide the window when the user clicks the close button
     */
    public static int kHideOnClose = WindowConstants.HIDE_ON_CLOSE;

    /**
     * This will make the window do nothing when the user clicks the user, it is
     * up to a listener to deal with it.
     */
    public static int kDoNothingOnClose = WindowConstants.DO_NOTHING_ON_CLOSE;

    /**
     * This will destroy the window complete when the user clicks the close button
     */
    public static int kDisposeOnClose = WindowConstants.DISPOSE_ON_CLOSE;

    /**
     * For dialogs, you can specify the parent dialog by indicating the panel it was on
     */
    private JComponent parentDialogContent = null;

    /**
     * This is the list of window listeners to add to the window created
     */
    private Vector windowListeners = null;

    /**
     * The name to place on the window
     */
    private Object name;

    /**
     * Indicates whether the window should be resizeable
     */
    boolean resizable = true;

    /**
     * Indicates whether the user should be able to close the window
     */
    boolean closable = true;

    /**
     * Indicates whether the user should be able to maximise the window
     */
    boolean maximizable = true;

    /**
     * Indicates whether the user should be able to minimise the window
     */
    boolean iconifiable = true;

    /**
     * Indicates whether the window should be a dialog or not
     */
    boolean isDialog = false;

    /**
     * Indicates whether the window should be modal or not
     */
    boolean isModal = true;

    /**
     * This is what the window will do when the user clicks the close button
     */
    private int closeAction = kHideOnClose;

    /**
     * Please complete the missing tags for BAddWindowCE
     * @post
     * @pre The windowContent needs to implement BWindow in order to receive events
     * @throws
     * @return
     * @param   source  The source of the event
     * @param   windowContent   The component to place on the window
     * @param   fName   The name of the window
     */
    public BAddWindowCE( Object source, JComponent windowContent, Object fName )
    {
        this( source, windowContent, fName, null );
    }

    /**
     * Please complete the missing tags for BAddWindowCE
     * @post
     * @pre The windowContent needs to implement BWindow in order to receive events
     * @throws
     * @return
     * @param   source  The source of the event
     * @param   windowContent   The component to place on the window
     * @param   fName   The name of the window
     * @param   complete    The completion object to be notified when the window is processed
     */
    public BAddWindowCE( Object source, JComponent windowContent, Object fName, BCommandComplete complete )
    {
        super( source, windowContent );
        setCompletionObject( complete );
        // other stuff...
        this.name = fName;
    }

    /**
     * Sets the default close action to that specified. When this
     * is set to do nothing on close, closing the window is
     * up to a BWindow listener to send a BCloseWindowCE to the window manager.
     *
     * @param   closeAction kDisposeOnClose, kDoNothingOnClose, kHideOnClose
     */
    public void setCloseAction(int closeAction)
    {
        this.closeAction = closeAction;
    }

    /**
     * Gets the default close action to that specified. When this
     * is set to do nothing on close, closing the window is
     * up to a BWindow listener to send a BCloseWindowCE to the window manager.
     *
     * @return kDisposeOnClose, kDoNothingOnClose, kHideOnClose
     */
    public int getCloseAction()
    {
        return this.closeAction;
    }

    /**
     * Please complete the missing tags for getResizable
     * @param
     * @return
     * @pre
     * @post
     */

    public boolean getResizable()
    {
        return resizable;
    }
    /**
     * Please complete the missing tags for setResizable
     * @param
     * @return
     * @pre
     * @post
     */
    
    public void setResizable( boolean fResizable )
    {
        resizable = fResizable;
    }
    /**
     * Please complete the missing tags for getClosable
     * @param
     * @return
     * @pre
     * @post
     */
    
    public boolean getClosable()
    {
        return closable;
    }
    /**
     * Please complete the missing tags for setClosable
     * @param
     * @return
     * @pre
     * @post
     */
    
    public void setClosable( boolean fClosable )
    {
        closable = fClosable;
    }
    /**
     * Please complete the missing tags for getMaximizable
     * @param
     * @return
     * @pre
     * @post
     */
    
    public boolean getMaximizable()
    {
        return maximizable;
    }
    /**
     * Please complete the missing tags for setMaximizable
     * @param
     * @return
     * @pre
     * @post
     */
    
    public void setMaximizable( boolean fMaximizable )
    {
        maximizable = fMaximizable;
    }
    /**
     * Please complete the missing tags for getIconifiable
     * @param
     * @return
     * @pre
     * @post
     */
    
    public boolean getIconifiable()
    {
        return iconifiable;
    }
    /**
     * Please complete the missing tags for setIconifiable
     * @param
     * @return
     * @pre
     * @post
     */
    
    public void setIconifiable( boolean fIconifiable )
    {
        iconifiable = fIconifiable;
    }
    
    /**
     * Please complete the missing tags for getName
     * @post
     * @pre
     * @throws
     * @return
     * @param
     */
    
    public Object getName()
    {
        return name;
    }
    
    /**
     * Gets the parent dialog of this panel as identified
     * by the panel given to the window manager earlier.
     *
     * @return The component that is on the parent dialog
     * Please complete the missing tags for getParentDialog
     * @param
     * @pre
     * @post
     */
    public JComponent getParentDialog()
    {
        return this.parentDialogContent;
    }
    
    /**
     * Indicates that the panel should be added to a dialog
     * and be modal.
     *
     * @param   isDialog
     * Please complete the missing tags for setDialog
     * @return
     * @pre
     * @post
     */
    public void setDialog( boolean isDialog )
    {
        this.isDialog = isDialog;
    }

    /**
     * Indicates that the panel should be model or not. If this is
     * not called, it will default to true. This is only used
     * when the setDialog method is called and set to true.
     *
     * @param   isModal
     * @pre
     * @post
     */
    public void setModal( boolean isModal )
    {
        this.isModal = isModal;
    }

    /**
     * Specifies the parent dialog of this dialog. By placing this
     * here, the window manager is able to make the dialog the
     * component passed in is on, the parent of the new dialog
     *
     * @param   parentDialogContent The parent of this new dialog
     * Please complete the missing tags for setParentDialog
     * @return
     * @pre
     * @post
     */
    public void setParentDialog( JComponent parentDialogContent )
    {
        this.parentDialogContent = parentDialogContent;
    }

    /**
     * Indicates whether the window is should be displayed
     * as a modal dialog or not.
     *
     * @return True if it should, false otherwise
     */
    public boolean isModal()
    {
        return this.isModal;
    }

    /**
     * Indicates whether the window is should be displayed
     * as a dialog or not.
     *
     * @return True if it should, false otherwise
     * Please complete the missing tags for isDialog
     * @param
     * @pre
     * @post
     */
    public boolean isDialog()
    {
        return this.isDialog;
    }
    
    /**
     * This will add the given window listener to the list
     * of listeners that will receive notification of window
     * events from the window or dialog this panel ends up on.
     *
     * @param   windowListener  The window listener to add
     * Please complete the missing tags for addWindowListener
     * @return
     * @pre
     * @post
     */
    public void addWindowListener( BWindowListener windowListener )
    {
        //Check to see whether we have a vector or not
        if( this.windowListeners == null )
        {
            //If not, create it
            this.windowListeners = new Vector();
        }
        
        //Add the window binder to the vector
        this.windowListeners.addElement( new BWindowBinder( windowListener, this.getWindowContent() ) );
    }
    
    /**
     * This will remove the given window listener from the list
     * of listeners.
     *
     * @param   windowListener  The window listener to remove
     * Please complete the missing tags for removeWindowListener
     * @return
     * @pre
     * @post
     */
    public void removeWindowListener( BWindowListener windowListener )
    {
        //Check to see whether we have a vector or not
        if( this.windowListeners != null )
        {
            //If there are any window listeners at all, remove it
            this.windowListeners.remove( windowListener );
        }
    }
    
    /**
     * This will add all the window listeners specified in this
     * add window event to the window passed in.
     *
     * @param   window  The window to add the listeners to
     * Please complete the missing tags for addListenersToWindow
     * @return
     * @pre
     * @post
     */
    public void addListenersToWindow( Container window )
    {
        Debug.doPrintln( "Adding listeners to window" );
        //First check to see that we have some
        if( this.windowListeners != null )
        {
            Debug.doPrintln( "There are listeners to addd..." );
            //Run through all the listeners and add them
            for( int i = 0; i < this.windowListeners.size(); i++ )
            {
                //Determine the type of listener to add
                if( window instanceof Window )
                {
                    Debug.doPrintln( "The window is a Window: " + window );
                    //Add a window listener
                    ( ( Window ) ( window ) ).addWindowListener( ( WindowListener ) this.windowListeners.elementAt( i ) );
                }
                else if( window instanceof JInternalFrame )
                {
                    Debug.doPrintln( "The window is an internal frame" );
                    //Add an internal frame listener
                    ( ( JInternalFrame ) ( window ) ).addInternalFrameListener( ( InternalFrameListener ) this.windowListeners.elementAt( i ) );
                }
                else
                {
                    Debug.doPrintln( "The window is neither." );
                    break;
                }
            }
        }
    }
}
