// $Header: /teamproj/cvsroot/teamb/bkasrc/au/edu/swin/synergy/plugin/mod13/event/BRemoveMenuItemCE.java,v 1.7 1999/10/13 01:23:22 tp079210 Exp $

package au.edu.swin.synergy.plugin.mod13.event;

import au.edu.swin.synergy.kernel.BCommandEvent;
import au.edu.swin.synergy.plugin.dialect.BString;
import java.util.Hashtable;
import java.util.Vector;

import javax.swing.*;

/**
 * When a plugin wishes to remove menu items from
 * a particular menu, this event is reuqired. It works
 * exactly the same way as the BAddMenuItemCE but in
 * the reverse, obviously.
 *
 * @author Tristan Austin
 */
public class BRemoveMenuItemCE extends BWindowCE
{
    /**
     * This is the menu items to remove
     */
    Hashtable menuItems = new Hashtable();

    /**
     * This keeps the menu items in the correct order
     */
    Vector menuItemList = new Vector();

    /**
     * The locale sensitive name of the menu
     */
    private Object menuName = null;

    /**
     * Creates a new remove menu item event with the source and the name of the
     * menu to remove the menu items specified later from. You can specify additional
     * menu items to be removed from the same menu by using
     * the addMenuItem method or the setMenuItems method.
     *
     * @param   source  The source of the event
     * @param   fMenuItem    The menu item to remove
     * @param   fMenu   The name of the menu to remove from
     */
     public BRemoveMenuItemCE( Object source, Object fMenu )
     {
        this(source, null, null, fMenu);
     }

    /**
     * Creates a new remove menu item event with the given menu
     * item to remove along with the source and the name of the
     * menu to remove it from. You can specify additional
     * menu items to be removed from the same menu by using
     * the addMenuItem method or the setMenuItems method.
     *
     * @param   source  The source of the event
     * @param   fMenuItem    The menu item to remove
     * @param   fMenu   The name of the menu to remove from
     */
     public BRemoveMenuItemCE( Object source, JMenuItem fMenuItem, Object itemName, Object fMenu )
     {
        super( source );
        // other stuff...

        //Only add it to the list if there is one
        if (fMenuItem != null)
        {
            this.addMenuItem(fMenuItem, itemName);
        }
        menuName = fMenu;
     }



    /**
     * Gets the list of menu items to add to the specified menu
     *
     * @post
     * @pre
     * @return A Vector of menu items to add
     * Please complete the missing tags for getMenuItems
     * @param
     */
    public Vector getMenuItems()
    {
        return menuItemList;
    }

    /**
     * This will get the BString associated with the given
     * menu item.
     *
     * @param   menuItem    The menu item to get the name for
     * @return The name as a BString
     */
    public BString getNameFor(JMenuItem menuItem)
    {
        return (BString)this.menuItems.get(menuItem);
    }

    /**
     * This will return the name for the menu item as an object. The
     * reason it is an object is that it may either be Locale specific
     * or it may simply be a static string.
     * <p>
     * Either way, calling to string on the object returned will yield
     * the name of the menu.
     *
     * @post
     * @pre
     * @throws
     * @return
     * @param
     */
    public Object getMenuName()
    {
        return menuName;
    }
    
    /**
     * This will allow more menu items to be added to the
     * event so be grouped together in the menu
     *
     * @param   menuItem    The menu item to add to the menu specified in the constructor
     * Please complete the missing tags for addMenuItem
     * @return
     * @pre
     * @post
     */
    public void addMenuItem( JComponent menuItem, Object itemName)
    {
        this.menuItemList.add(menuItem);

        //Only map the item name if it has one
        if (itemName != null)
        {
            this.menuItems.put( menuItem, itemName );
        }
    }

    /**
     * This method allows you to add a menu item without specifying
     * a BString object to go with it. It should be realised that using
     * this alternative implies that you will not have locale support
     * in the menu item
     *
     * @param   menuItem    The menu item to add
     */
    public void addMenuItem(JComponent menuItem)
    {
        this.addMenuItem(menuItem, null);
    }
}
