//$Header: /teamproj/cvsroot/teamb/bkasrc/au/edu/swin/synergy/plugin/modeller/BModelArc.java,v 1.57 1999/10/21 23:34:41 tp080510 Exp $


package au.edu.swin.synergy.plugin.modeller;

import au.edu.swin.synergy.lib.io.BDataFile;
import au.edu.swin.synergy.lib.io.BStrokeIO;
import au.edu.swin.synergy.lib.io.BSaveable;
import au.edu.swin.synergy.plugin.metamodeller.BMetaElement;
import au.edu.swin.synergy.plugin.modeller.BModelElement;
import au.edu.swin.synergy.plugin.diagram.BDrawable;
import au.edu.swin.synergy.plugin.diagram.BView;

import au.edu.swin.synergy.debug.Debug;

import au.edu.swin.synergy.shapes.BPropPanel;
import au.edu.swin.synergy.math.BScalarPoint;
import au.edu.swin.synergy.math.BScalarRect;
import au.edu.swin.synergy.math.BScalar;
import au.edu.swin.synergy.plugin.packager.BPackageModel;
import au.edu.swin.synergy.plugin.packager.BPackageArc;
import au.edu.swin.synergy.plugin.diagram.BSizer;
import au.edu.swin.synergy.plugin.conflict.BConflict;

import java.awt.*;
import java.awt.geom.*;
import java.util.Vector;



public class BModelArc extends BModelElement implements BSaveable
{
	private BModelNode startNode = null;
	private BModelNode endNode = null;

	

	/**
	 * These are used for loading only
	 */ 
	private long startNodeID;
	private long endNodeID;
	private String arcType = null;
	private String arcColor = null;
	private String arcStyle = null;
	private BStrokeIO loadedStroke = null;
	


	//use the default pos as the startPos...
	//have another pos for the endpos..
	private BScalarPoint endPos = null;
	
	/**
	 * This is a ref to the actual package
	 */
	private BPackageArc originalPArc = null;

	/**
	 * This is a copy which we can change
	 */
	private BPackageArc pArc = null;

	private int type = BPackageArc.kStraightType;

	

	private BScalarPoint [] ctrlPos = null;

	private int sizer = kNotHit;
	private boolean adding = false;


	//don't need to save these.
	public static int count = 0;
	private BScalarPoint tmpScale = null;
	


	public BModelArc( BPackageArc pArc )
	{
		super( pArc.getMetaElement() );

		int i;

		this.pos.setLocation( pArc.getPos() );

		this.pArc = pArc;
		this.originalPArc = pArc;

		this.endPos = new BScalarPoint();		
		

		Debug.doPrintln("Setting the endPos of the node" );
		this.pArc.setEndPos( this.endPos );
		this.bounds = this.pArc.getBounds();
		this.pos = this.pArc.getPos();
		
		this.ctrlPos = new BScalarPoint[BPackageArc.kNumCtrlPoints];
		for ( i = 0; i < BPackageArc.kNumCtrlPoints; i++ )
		{
			this.ctrlPos[i] = new BScalarPoint();
		}

		this.pArc.setCtrlPoints( this.ctrlPos );

		this.type = pArc.getArcType();

		this.tmpScale = new BScalarPoint();

		

	}


   public Vector getProperties()
   {
      return pArc.getProperties ();
   }

    public BPropPanel getPropertyPanel ()
    {
        return pArc.getPropertyPanel ();
    }

	public BModelArc( BModelArc src )
	{
		this( src.pArc );
		this.copy( src );
	}

	/**
	 * Default constructor for BSaveable
	 */
	public BModelArc()
	{
		super(null);
		int i;


		this.endPos = new BScalarPoint();

		this.ctrlPos = new BScalarPoint[BPackageArc.kNumCtrlPoints];		
		for ( i = 0; i < BPackageArc.kNumCtrlPoints; i++ )
		{
			this.ctrlPos[i] = new BScalarPoint();
		}

		this.tmpScale = new BScalarPoint();


	}


	public void setStartNode( BModelNode start)
	{
		setStartNode( start, true );
	}
	public void setStartNode( BModelNode start, boolean updatePos )
	{
		this.startNode = start;
		this.endPos.setLocation( this.pos );
		if ( updatePos )
		{
			this.ctrlPos[0].setLocation( this.pos );
			this.ctrlPos[1].setLocation( this.pos );
		}


		Debug.doPrintln("************************ the ctrl points were changed 163 ***************");


		if ( start != null )
		{
			start.addOutArc( this );
		}

	}

	public void setEndNode( BModelNode end, boolean updatePos )
	{
		BScalarRect rect;

		this.endNode = end;
		if ( end != null )
		{
			end.addInArc( this );
		}

		if ( this.endNode == this.startNode ) //recursive...make it a curve...
		{
			this.type = BPackageArc.kCurvedType;
			this.pArc.setArcType( this.type );

			rect = end.getBounds();

			if ( updatePos )
			{
				this.ctrlPos[0].setLocation( rect );
				this.ctrlPos[0].decY( 10 );

				this.ctrlPos[1].setLocation( rect );
				this.ctrlPos[1].incW( rect );
				this.ctrlPos[1].incX( 10 );
			}

		   Debug.doPrintln("************************ the ctrl points were changed 197 ***************");
		}
	}

	public void setEndNode( BModelNode end)
	{
		setEndNode( end, true );
	}

	public BModelNode getStartNode()
	{
		return this.startNode;
	}

	public BModelNode getEndNode()
	{
		return this.endNode;
	}

    public BPackageArc getPackageArc()
    {
        return this.pArc;
    }


/////////BDrawable stuff


	public void delete()
	{
		if ( this.startNode != null )
		{
			this.startNode.removeOutArc( this );
		}

		if ( this.endNode != null )
		{
			this.endNode.removeInArc( this );
		}
	}


	/**
	 * Transforms the coordinates of the drawable object
	 * to a new coordinate space, as defined by the
	 * viewport and parent pos.
	 * Subclasses should follow the following equation for
	 * tranforming relevant points etc.
	 *
	 * xformPt.x = ((localPt.x + parentPos.x + pos.x - viewport.x) * viewport.zoom ) + viewport.halfx;
	 *
	 * @param BView viewport - the viewport that this object is going to be drawn in
	 * @param Point parentPos - coordinates of any parent object
	 */
	public void transform( BView viewport, BScalarPoint parentPos, int frameCounter )
	{
		this.pArc.transformArc( this.startNode, this.endNode, viewport, parentPos, frameCounter );
	}


	/**
	 * Renders the transformed coordinates of the drawable
	 * object to a Graphics2D
	 *
	 * @param Graphics2D g2 - the place to render the object to.
	 */
	public void render( Graphics2D g2 )
	{
		this.pArc.render(g2);	
	}

	

	


	/**
	 * Checks to see if a sizer has been hit by a point
	 * Works on xformed values.
	 * Subclasses should determine appropriate places for
	 * the sizer..
	 *
	 * @param Point pt - the point to check the hit against
	 * @return kNotHit - not hit
	 * @return kHitSizer + XX hit the XX sizer where XX is any number.
	 */
	public int checkSizerHit( Point pt )
	{
		
		int result = kNotHit;

		if ( this.adding ) return result;

		result = this.pArc.checkSizerHit( pt );


		return result;

	}

	public void setSelected( boolean b )
	{		
		super.setSelected( b );
		this.pArc.setSelected(b);		
	}



	/**
	 * checks the tranformed bounds...used for hit testing with the mouse..
	 *
	 */
	public int checkXFormBounds( Point pt )
	{		
		int result = kNotHit;

		if ( this.adding ) return result;

		return this.pArc.checkXFormBounds( pt );
	}

	/**
	 * called when the drawable is about to be resized..
	 *
	 * @param int sizerNum - a sizerNum returned from checkSizerHit
	 */
	public void startResize( int sizerNum )
	{
		this.sizer = sizerNum;		
		this.pArc.startResize( sizerNum );
	}

	/**
	 * Called as the drawable is being resized
	 *
	 */
	public void dragResize( BScalarPoint deltaXY )
	{
		this.pArc.dragResize( deltaXY, this.sizer );		
		Debug.doPrintln("ctrl1 is " + ctrlPos[0] );
		Debug.doPrintln("ctrl2 is " + ctrlPos[1] );
		Debug.doPrintln("************************ the ctrl points were changed 333 ***************");
	}



	/**
	 * called when the drawable is about to be added..
	 *
	 */
	public void startAdd()
	{
		this.adding = true;
		this.pArc.startAdd();
	}

	/**
	 * called when the drawable has finished being added..
	 *
	 */
	public void stopAdd()
	{
		super.stopAdd();
		this.adding = false;
		this.pArc.stopAdd();
	}

	public void startMove()
	{
		if ( this.startNode != null )
		{
			this.startNode.startMove();
		}

		if ( this.endNode != null )
		{
			this.endNode.startMove();
		}
	}

	public void dragMove( BScalarPoint deltaXY )
	{

		if ( this.startNode != null )
		{
			this.startNode.dragMove( deltaXY );
		}
		else
		{
			this.pos.incXY( deltaXY );
		}

		if ( this.endNode != null )
		{
			this.endNode.dragMove( deltaXY );
		}
		else
		{
			this.endPos.incXY( deltaXY );
		}

		switch( this.type )
		{
			case BPackageArc.kCurvedType:
				this.ctrlPos[0].incXY( deltaXY );
				this.ctrlPos[1].incXY( deltaXY );
				
				break;
			case BPackageArc.kSteppedType:
				this.ctrlPos[0].incXY( deltaXY );
				this.ctrlPos[1].incXY( deltaXY );
//				this.pArc.updateSteppedVal( deltaXY );
				break;
		}
		Debug.doPrintln("************************ the ctrl points were changed 406 ***************");
		Debug.doPrintln("ctrl1 is " + ctrlPos[0] );
		Debug.doPrintln("ctrl2 is " + ctrlPos[1] );

	}


	public void stopMove()
	{
		if ( this.startNode != null )
		{
			this.startNode.stopMove();
		}

		if ( this.endNode != null )
		{
			this.endNode.stopMove();
		}
	}

	public boolean intersects( BScalarRect point )
	{
		return true;
	}



	/**
	 * Creates and returns a new instance of the BDrawable object
	 *
	 * @return a new instance of this BDrawable object.
	 */
	public BDrawable newInstance()
	{
		return new BModelArc( this );
	}

	public void dragAdd( BScalarPoint deltaXY )
	{
		this.pArc.dragAdd( deltaXY );		
	}


	public void paintIcon( Component c, Graphics g, int x, int y )
	{

	}

	public void copy( BModelArc src )
	{
		super.copy(src);
		Debug.doPrintln("BModelArc::copy -- not doing a full copy!!", Debug.kWarningLevel );
	}



	/**
	 * Loads the BDrawable from a file
	 * @param BDataFile file - the file to load from
	 * @return boolean - true on success, false on failure.
	 */

	protected static final String kKeyStartNode = "startNode"; 
	protected static final String kKeyEndNode = "endNode"; 
	protected static final String kKeyControlPoints = "controlPoints"; 
	protected static final String kKeyType = "type"; 
	protected static final String kKeyColor = "color"; 
	protected static final String kKeyStyle = "style"; 

	public boolean load(BDataFile file)
	{
		Debug.doPrintln("BModelArc - load");
		super.load(file);

		startNodeID = Long.parseLong(file.getData(kKeyStartNode, "0"));
		Debug.doPrintln("Start Node ID = " + startNodeID);
		
		endNodeID = Long.parseLong(file.getData(kKeyEndNode, "0"));
		Debug.doPrintln("End Node ID = " + endNodeID);

		// load the end point object
		endPos = (BScalarPoint)file.autoLoad();
		

		// we need to get the nodes by ID.....(resolve?)
/*		String loadedArcType = file.getData(kKeyType, null);
		if(loadedArcType != null)
		{
			type = Integer.parseInt(loadedArcType);
		}*/

		arcType = file.getData(kKeyType, null);
		arcColor = file.getData(kKeyColor, null);
		arcStyle = file.getData(kKeyStyle, null);

		// I need any stroke info, but it can't be resolved yet...
		loadedStroke = BStrokeIO.loadDefault(file);


		int controlPoints = Integer.parseInt(file.getData(kKeyControlPoints, "0"));
		if(controlPoints == BPackageArc.kNumCtrlPoints)
		{
			for (int i = 0; i < BPackageArc.kNumCtrlPoints; i++ )
			{
				this.ctrlPos[i] = (BScalarPoint)file.autoLoad();
				Debug.doPrintln("Ctrl Point " + i + " was loaded as " + this.ctrlPos[i]);
			}
		}
		else
		{
			Debug.doPrintln("Wrong number of control points");
		}

		return true;
	}
	
	public void resolveLoadedObject(BModel model)
	{
		super.resolveLoadedObject(model);
		Debug.doPrintln("Resolving the package arc..." + name);
	
		// find the pNode with name name
		BPackageModel packageModel = model.getPackageModel();
		originalPArc = (BPackageArc) (packageModel.getPackageItemByName(name));

		// we need to make out own copy of the package node
		pArc = (BPackageArc) originalPArc.newInstance();
		pArc.getPos().setLocation(pos);

		setMetaElement(pArc.getMetaElement());

		// set the stuff that we override in the PackageArc
//		pArc.setArcType(type);
		if(arcType != null)
		{
			type = Integer.parseInt(arcType);
			pArc.setArcType(type);
		}
		if(arcColor != null)
		{
			pArc.setColour(new Color( new Integer( arcColor ).intValue() ));
		}
		if(arcStyle != null)
		{
			pArc.setStyle(new Integer(arcStyle));
		}

		if(loadedStroke != null)
		{
			pArc.setStroke(loadedStroke.getStroke(pArc.getStroke()));
		}

	

		// find the nodes for start and end ID's
		if(startNodeID != 0)
		{
			BModelNode foundNode = (BModelNode)model.getElementByID(startNodeID);
			if(foundNode != null)
			{
				setStartNode(foundNode, false);
			}
			else
			{
				Debug.doPrintln("Could not find start node");
			}
		}

		if(endNodeID != 0)
		{
			BModelNode foundNode = (BModelNode)model.getElementByID(endNodeID);
			if(foundNode != null)
			{
				setEndNode(foundNode, false);
			}
			else
			{
				Debug.doPrintln("Could not find end node");
			}
		}
		pArc.setCtrlPoints( this.ctrlPos );
		pArc.setEndPos( this.endPos );
		
		this.pos = pArc.getPos();
		this.bounds = pArc.getBounds();
		updateBounds();
		resolveText();
	}
	
	/**
	 * Saves the BDrawable to a file
	 * @param BDataFile file - the file to save to
	 * @return boolean - true on success, false on failure.
	 */
	public boolean save(BDataFile file)
	{
		Debug.doPrintln("BModelArc - save");
		super.save(file);
		if(startNode != null)
		{
			file.addData(kKeyStartNode, "" + startNode.getID());
		}
		if(endNode != null)
		{
			file.addData(kKeyEndNode, "" + endNode.getID());
		}


		// save the endpoint
		file.save(endPos);

//		file.addData(kKeyType, "" + type);

		// you can change properties of the arc in the model, so any which
		// do not match the selected package arc should be saved
	    file.addData( kKeyType, "" + /*type*/ pArc.getArcType(), "" + originalPArc.getArcType() );
   		file.addData( kKeyColor, "" + pArc.getColour().getRGB() , "" + originalPArc.getColour().getRGB() );
		file.addData ( kKeyStyle, "" + pArc.getStyle(), "" + originalPArc.getStyle() );

		// save the stroke differences
		BStrokeIO.save(file, pArc.getStroke(), originalPArc.getStroke());

		
		file.addData(kKeyControlPoints, "" + BPackageArc.kNumCtrlPoints);

		// save the control points
		for(int i=0; i < BPackageArc.kNumCtrlPoints; i++)
		{
		   Debug.doPrintln("Ctrl Point " + i + " was saved as " + this.ctrlPos[i]);
			file.save(ctrlPos[i]);
		}

		return true;
	}

	public void updateBounds()
	{
		if ( this.pArc != null )
		{
			this.pArc.updateBounds();

		}
	}

	public int findChanges(BModelElement oldElement)
	{
		BModelArc oldArc = (BModelArc) oldElement;
		int result = BConflict.kNoConflict;

		return result;
	}
}
