package au.edu.swin.synergy.plugin.modeller;

import java.util.Vector;


import au.edu.swin.synergy.lib.io.BSaveable;
import au.edu.swin.synergy.lib.io.BDataFile;
import au.edu.swin.synergy.debug.Debug;

public class BSaveTextArea implements BSaveable
{
    public final static String kName = "Text Area";

	
	private Vector strings = null;
	private String name = null;
	

    /**
    * Used to calc positisons of text within this area
    * depending on the font.
    */


	public BSaveTextArea ()
	{
	}	



	public Vector getRefToStrings()
	{
		return this.strings;
	}

	public void setName(String fName)
	{
		name = fName;
	}

	public void setStrings(Vector fStrings)
	{
		strings = fStrings;
	}

	public Vector getStrings()
	{
		return strings;
	}

	public String getName()
	{
		return name;
	}

	
	protected static final String kKeyText = "AreaString";
	protected static final String kKeyVisible = "Visible";
	
	protected static final String kKeyName = "name";
	protected static final String kDefaultName = "unnamed";

    public boolean load ( BDataFile file )
    {
        Debug.doPrintln ( "BSaveTextArea load..." );
		String str;
		name = file.getData( kKeyName, kDefaultName);
        strings = new Vector ();
        while ( true )
        {
            str = file.getData ( kKeyText, null );
            if ( str == null )
            {
                break;
            }

            strings.add ( str );
        }

        return true;
    }

    public boolean save ( BDataFile file )
    {
        Debug.doPrintln ( "BSaveTextArea save..." );
		file.addData(kKeyName, name);
        for ( int i = 0; i < strings.size (); i++ )
        {
            file.addData ( kKeyText, ( String ) strings.elementAt ( i ) );
        }

        return true;
    }
}
