//$Header: /teamproj/cvsroot/teamb/bkasrc/au/edu/swin/synergy/plugin/modeller/event/BSelectionEvent.java,v 1.1 1999/10/06 05:40:02 tp082177 Exp $
package au.edu.swin.synergy.plugin.modeller.event;

import java.util.EventObject;
import java.util.Vector;

/**
 * A custom event used to indicate when a model element, or group of model
 * elements, have been selected in the Model Editor
 *
 * @author Mattehw Evans
 */
public class BSelectionEvent extends EventObject
{
	/**
	 * The collection of selected model elements
	 */
	Vector selected;

	/** 
	 * Creates an instance of this event with a reference to the source of the event
	 * and the collection of currently selected model elements on 'source'
	 *
	 * @param source the source of this event
	 * @param selected the collection of model elements that contributed to the creation of this event
	 */
	public BSelectionEvent(Object source, Vector selected)
	{
		super(source);
		this.selected = selected;
	}

	/**
	 * Used to retrieve the collection of selected elements that contirbuted to
	 * the creation of an instance of this event.
	 *
	 * @return collection of currently selected model elements in the model editor
	 */
	public Vector getSelected()
	{
		return this.selected;
	}
}
