// $Header:

package au.edu.swin.synergy.plugin.packager;

/**
* Brings together both the line and fill editor panels to provide
* functionality of changing the outline colour and style as well
* as the fill colour for any object.
*
* @author Christian Karolos
* @date 5/9/99
*/
import javax.swing.*;
import java.awt.*;

import au.edu.swin.synergy.shapes.BFillEditorPanel;
import au.edu.swin.synergy.shapes.BLineEditorPanel;
import au.edu.swin.synergy.plugin.diagram.BDrawable;

public class BColourStyleEditor extends JPanel
{
	// Reference to some object we'll be modifiying.
	BDrawable drawable;

	BFillEditorPanel fillEditor = null;
	BLineEditorPanel lineEditor = null;

	public BColourStyleEditor ( BDrawable shape )
	{
		setLayout ( new GridBagLayout () );
		GridBagConstraints c = new GridBagConstraints ();

		drawable = shape;		

		setConst ( c, 0, 0, 2, 1, GridBagConstraints.CENTER );
		
		// First we must check the validity of this panel.  
		// Want it disabled, if called for a line.
		fillEditor = new BFillEditorPanel ( drawable.getColour () );
		add ( fillEditor, c );

		setConst ( c, 0, 1, 4, 1, GridBagConstraints.CENTER );
//		lineEditor = new BLineEditorPanel ( drawable.getBasicStroke (), drawable.getColour () );
		add ( lineEditor, c );
	}

	/**
	* Custom made function for plotting labels and combo boxes on a panel.
	* Panel shouldn't be expandable, so concerning attribs are fixed.
	*/
    public static void setConst( GridBagConstraints gbc, int x, int y, int w, int h, int anc )
    {
        gbc.gridx = x;
        gbc.gridy = y;
        gbc.gridwidth = w;
        gbc.gridheight = h;
        gbc.fill = GridBagConstraints.NONE;
        gbc.anchor = anc;

		// Only a light weight so things don't expand too much.
        gbc.weightx = 0;
        gbc.weighty = 0;
        gbc.ipady = 5;
        gbc.ipadx = 3;
    }	
}
