
//$Header: /teamproj/cvsroot/teamb/bkasrc/au/edu/swin/synergy/plugin/packager/BPackageArc.java,v 1.59 1999/10/21 23:34:42 tp080510 Exp $

package au.edu.swin.synergy.plugin.packager;

import java.awt.*;
import java.awt.geom.Rectangle2D;
import java.lang.Integer;

import au.edu.swin.synergy.lib.BTreeNode;

import au.edu.swin.synergy.shapes.BLineEditorPanel;

import au.edu.swin.synergy.plugin.diagram.BIconView;
import au.edu.swin.synergy.plugin.packager.BPackageArcProperties;
import au.edu.swin.synergy.plugin.metamodeller.BMetaElement;
import au.edu.swin.synergy.math.BScalarPoint;
import au.edu.swin.synergy.math.BScalarRect;
import au.edu.swin.synergy.math.BScalar;
import au.edu.swin.synergy.plugin.packager.BPackageTerminator;
import au.edu.swin.synergy.plugin.diagram.BView;
import au.edu.swin.synergy.plugin.diagram.BSizer;
import au.edu.swin.synergy.plugin.diagram.BDrawable;
import au.edu.swin.synergy.plugin.diagram.BDrawableButton;
import au.edu.swin.synergy.lib.io.BSaveable;
import au.edu.swin.synergy.lib.io.BDataFile;
import au.edu.swin.synergy.debug.Debug;
import au.edu.swin.synergy.plugin.modeller.BModelNode;
import au.edu.swin.synergy.shapes.BPropPanel;
import au.edu.swin.synergy.shapes.BTextArea;


import java.awt.*;
import java.awt.geom.*;


import java.util.Vector;

public class BPackageArc extends BDrawable implements BTreeNode
{
	public static final int kNumCtrlPoints = 2;

	public static final int kStraightType = 0;	
	public static final int kSteppedType = 1;
	public static final int kCurvedType = 2;

    // Used for preview during arc creation.
    public static final int kDefaultHeight = 50;
    public static final int kDefaultWidth = 50;

	private static final BScalar kThirdScale = new BScalar( 0.33333333f );
	private static final BScalar kTwoThirdScale = new BScalar( 0.66666666f );	



	public static final int kHitLen = 6;
	public static final int kHalfHitLen = kHitLen >> 1;

	public static final int kLeftRight = 0;
	public static final int kTopBottom = 1;

	public final static int kPositive = 1;
	public final static int kNegative = -1;

	protected Vector drawables = null;
	protected Vector properties = null;
	protected Object parent;

    protected Color arcColour = Color.black;
    protected BasicStroke arcStroke = new BasicStroke ( 1.0f );
	protected Integer lineStyle = BLineEditorPanel.kSingle;
	protected int arcType = kStraightType;

	protected BMetaElement metaElement = null;

	protected BPackageTerminator startTerminator = null;
	protected BPackageTerminator endTerminator = null;
	protected BPackageTerminator arcTerminator = null;	

	private BScalarPoint steppedVal = null;
	private BScalarPoint steppedScale = null;

	//***********************************
	//****don't need to save this stuff***
	//************************************
	//control points for curved arcs...in view space..	
	private BScalarPoint endPos = null;

	// Temp stuff for rendering different style arcs.
	private int lineSize;
	private int dist;
	private Point tmpStart;
	private Point tmpEnd;
	private int xDirection;
	private int yDirection;
	protected BScalarPoint dir;

	// Temp stuff for rendering properties.
	BScalarPoint arcMidPt = null;
	BScalarPoint textInf = null;
	BScalarPoint tmpPt = null;

	private BScalarPoint [] ctrlPos = null;
	private Point [] ctrlPt = null;
    private Point [] tmpCtrlPt = null;
	private BSizer startSizer = null;
	private BSizer endSizer = null;
	private BSizer ctrlSizer1 = null;
	private BSizer ctrlSizer2 = null;
	private CubicCurve2D.Float curve = null;
	private Point startCenter = null;
	private Point endCenter = null;
	private Point startPt = null;
	private Point endPt = null;
	private BScalarPoint tmpViewPos = null;
	private BScalarPoint tmpPoint = null;
	private Rectangle hitRect = null;

	private int steppingType = kLeftRight;
	private boolean adding = false;

	private int side = BScalarRect.kOutLeft;
	


	
	

	public BPackageArc( BMetaElement element )
	{
		super();
		
		int i, size;
		BTextArea text;
		Vector props;

		this.metaElement = element;

		this.arcMidPt = new BScalarPoint ();
		this.textInf = new BScalarPoint ();
		this.tmpPt = new BScalarPoint ();
		this.dir = new BScalarPoint ();
		this.steppedVal = new BScalarPoint();
		this.steppedScale = new BScalarPoint();
	
		this.drawables = new Vector ();
		this.properties = new Vector();

		if ( element != null )
		{
			this.name = element.getName();

			//set the properties...
			props = element.getProperties();
			size = props.size();

			for ( i = 0; i < size; i++ )
			{
				text = new BTextArea( (String)props.elementAt( i ) );
				text.setParent( this );
				this.properties.add( text );
			}
		}

		this.tmpStart = new Point ();
		this.tmpEnd = new Point ();

		this.startPt = new Point();
		this.endPt = new Point();
		this.startCenter = new Point();
		this.endCenter = new Point();

		this.startSizer = new BSizer();
		this.endSizer = new BSizer();
		this.ctrlSizer1 = new BSizer();
		this.ctrlSizer2 = new BSizer();
		this.curve = new CubicCurve2D.Float();		
		this.tmpViewPos = new BScalarPoint();
		this.tmpPoint = new BScalarPoint();

		this.hitRect = new Rectangle();

//		this.endPos = new BScalarPoint();

        this.tmpCtrlPt = new Point[BPackageArc.kNumCtrlPoints];
		this.ctrlPt = new Point[BPackageArc.kNumCtrlPoints];
		for ( i = 0; i < BPackageArc.kNumCtrlPoints; i++ )
		{		
			this.ctrlPt[i] = new Point();
            this.tmpCtrlPt[i] = new Point ();
		}
	}

	public Vector getProperties ()
	{
		return this.properties;
	}

	public final int getSteppingType()
	{
		return this.steppingType;
	}

	public BPackageTerminator getEndTerminator ()
	{
		return this.endTerminator;
	}
	
	public void setEndTerminator ( BPackageTerminator et )
	{
		if ( et != null )
		{
			this.endTerminator = ( BPackageTerminator ) et.newInstance ();
		}
		else
		{
			this.endTerminator = et;
		}
	}

	public BPackageTerminator getStartTerminator ()
	{
		return this.startTerminator;
	}

	public void setStartTerminator ( BPackageTerminator st )
	{
		if ( st != null )
		{
			this.startTerminator = ( BPackageTerminator ) st.newInstance ();
		}
		else
		{
			this.startTerminator = st;
		}
	}

	public BPackageTerminator getArcTerminator ()
	{
		return this.arcTerminator;
	}

	public void setArcTerminator ( BPackageTerminator at )
	{
		if ( at != null )
		{
			this.arcTerminator = ( BPackageTerminator ) at.newInstance ();
		}
		else
		{
			this.arcTerminator = at;
		}
	}

    public BPropPanel getPropertyPanel ()
	{
		return new BPackageArcProperties ( this );
	}

	public void initCtrlPos()
	{
		int i;
		this.ctrlPos = new BScalarPoint[BPackageArc.kNumCtrlPoints];
		for ( i = 0; i < BPackageArc.kNumCtrlPoints; i++ )
		{
			this.ctrlPos[i] = new BScalarPoint();
		}
		Debug.doPrintln("********************* ctrl Pos was changed 268 **********************");

	}

	public void initEndPos ( BScalarRect rect )
	{
		if ( endPos == null )
		{
			endPos = new BScalarPoint ();
		}
        this.pos.setLocation ( rect );
		this.endPos.setXYtoWH ( rect );
        this.endPos.incXY ( kDefaultWidth, kDefaultHeight );
	}

	public void setEndPos( BScalarPoint theEndPos )
	{		
		this.endPos = theEndPos;

	}

	public BPackageArc( BPackageArc pa )
	{
		this( pa.metaElement );
		this.copy( pa );		
	}

	public Vector getDrawables ()
	{
        Debug.doPrintln ( "GETTING DRAWABLES" );
		return this.drawables;
	}

	public void setCtrlPoints( BScalarPoint [] ctrl )
	{		
		this.ctrlPos = ctrl;
	}

	public void addDrawable ( BDrawable drawable )
	{
	}

	public void removeDrawable ( BDrawable drawable )
	{
		this.removeDrawable ( this.properties.indexOf ( drawable ) );
	}

	public void removeDrawable ( int index )
	{
        Debug.doPrintln ( "REMOVE index "+index+" from array with size "+drawables.size () );
        BTextArea prop;
		if ( index >= 0 )
		{
            prop = ( BTextArea ) this.properties.elementAt ( index );
            prop.setVisible ( false );
		}
	}

    public void setStroke ( BasicStroke stroke )
    {
        arcStroke = stroke;
    }

    public BasicStroke getStroke ()
    {
        return arcStroke;
    }

	public void setArcType ( int type )
	{
		this.arcType = type;
	}

	public int getArcType ()
	{
		return arcType;
	}

	public Integer getStyle ()
	{
		return this.lineStyle;
	}

	public void setStyle ( Integer sStyle )
	{
		this.lineStyle = sStyle;
	}

    public Color getColour ()
    {
        return arcColour;
    }

    public void setColour ( Color c )
    {
        arcColour = c;
    }

	/**
	 * Default constructor for BSaveable
	 */
	public BPackageArc()
	{
		this((BMetaElement)null);
	}

	public BMetaElement getMetaElement()
	{
		return this.metaElement;
	}


	protected int outcode( Rectangle rect, int posX, int posY )
	{
		int result = BScalarRect.kOutNone;

		//x outcode..
		if ( posX <= rect.x ) //less than the left plane??
		{
			result |= BScalarRect.kOutLeft;
		}
		else if ( posX > rect.x + rect.width ) // greater than the right plane..
		{
			result |= BScalarRect.kOutRight;
		}

		//y outcode..
		if ( posY <= rect.y ) //less than the top plane??
		{
			result |= BScalarRect.kOutTop;
		}
		else if ( posY > rect.y + rect.height ) // greater than the bottom plane..
		{
			result |= BScalarRect.kOutBottom;
		}

		return result;
	}

	protected void intercept( Point start, Point end, int plane, int bound, Point icept )
	{
		int dx, dy;

		dx = end.x - start.x;
		dy = end.y - start.y;
		
		switch ( plane )
		{
			case BScalarRect.kOutTop:
			case BScalarRect.kOutBottom:

				icept.y = bound;
				icept.x = start.x + (( bound - start.y ) * dx / dy );
				break;

			case BScalarRect.kOutLeft:
			case BScalarRect.kOutRight:
				icept.x = bound;
				icept.y = start.y + (( bound - start.x ) * dy / dx );
				break;
			default:
				icept.x = start.x;
				icept.y = start.y;
				break;
		}
	}

	public void addTextProperty ( int index, BScalarPoint pos )
	{
		BTextArea t = ( BTextArea ) this.properties.elementAt ( index );

		t.setArc ( this );

		// Must set the current pos b4 calculating where the text is in
		// relation to the arc.
		t.setPos ( pos );
        Debug.doPrintln ( "Init pos: "+pos );
        t.getPos().decXY( this.pos );
        Debug.doPrintln ( "Relative position: "+t.getPos () );
		// Important that the following is called after setpos for it is
		// dependant.
		t.calcDelta ( this.pos, this.endPos );
        Debug.doPrintln ( "Relative position: "+t.getPos () );
		t.setVisible ( true );
	}

    public BScalarPoint getEndPos ()
    {
        return this.endPos;
    }

    public BDrawable getTextProperty ( int index )
    {
        return ( BDrawable ) this.properties.elementAt ( index );
    }

	/**
	 * Transforms the coordinates of the drawable object
	 * to a new coordinate space, as defined by the
	 * viewport and parent pos.
	 * Subclasses should follow the following equation for
	 * tranforming relevant points etc.
	 *
	 * xformPt.x = ((localPt.x + parentPos.x + pos.x - viewport.x) * viewport.zoom ) + viewport.halfx;
	 *
	 * @param BView viewport - the viewport that this object is going to be drawn in
	 * @param Point parentPos - coordinates of any parent object
	 */
	public void transform( BView viewport, BScalarPoint parentPos, int frameCounter )
	{		
		if ( this.lastFrame != frameCounter )
		{
			this.transformArc( null, null, viewport, parentPos, frameCounter );
			this.lastFrame++;
		}
	}

	public void transformArc( BModelNode startNode, BModelNode endNode, BView viewport, BScalarPoint parentPos, int frameCounter )
	{
		if ( this.endPos == null )
		{
			return;
		}

		transformNodePos( startNode, this.pos, this.startCenter, viewport, parentPos, frameCounter );        
        Debug.doPrintln("endNode before " + this.endPos );
		transformNodePos( endNode, this.endPos, this.endCenter, viewport, parentPos, frameCounter );
        Debug.doPrintln("endNode after " + this.endPos );

		switch ( this.arcType )
		{
			case BPackageArc.kCurvedType:
				transformCtrl( viewport, parentPos, frameCounter );
				transformToSide( startNode, this.startCenter, this.ctrlPt[0], this.startPt );
				transformStartTerm( viewport, frameCounter );
				transformToSide( endNode, this.endCenter, this.ctrlPt[1], this.endPt );				
				transformEndTerm( viewport, frameCounter );
				break;

			case BPackageArc.kSteppedType:
				transformSteppedToSide( startNode, endNode, viewport, frameCounter );
				transformStepped( viewport, parentPos, frameCounter );
				break;
			case BPackageArc.kStraightType:
			default:
				transformToSide( startNode, this.startCenter, this.endCenter, this.startPt );
				transformStartTerm( viewport, frameCounter );
				transformToSide( endNode, this.endCenter, this.startCenter, this.endPt );
				transformEndTerm( viewport, frameCounter );
				break;
		}

		// Pointless optimisation???
		if ( properties.size () > 0 )
		{
			transformProperties ( viewport, frameCounter );
		}
        else
        {
            Debug.doPrintln("Not rendering the properties");
        }

		
		if ( this.arcTerminator != null && this.arcType == BPackageArc.kSteppedType )
		{
			this.tmpViewPos.setLocation( this.ctrlPt[0] );
			this.arcTerminator.transform( viewport, this.tmpViewPos, frameCounter );
		}
	}


	protected void transformStartTerm( BView viewport, int frameCounter )
	{
		if ( this.startTerminator != null )
		{		
			this.tmpViewPos.setLocation( this.startPt );
			this.tmpPoint.setXYtoWH( this.startTerminator.getBounds() );
//			this.tmpPoint.half();
			switch( this.side )
			{
				case BScalarRect.kOutBottom:
					this.tmpViewPos.incY( this.tmpPoint );
					break;
				case BScalarRect.kOutLeft:
//					this.tmpViewPos.decX( this.tmpPoint );
					break;
				case BScalarRect.kOutRight:
					this.tmpViewPos.incX( this.tmpPoint );
					break;
				case BScalarRect.kOutTop:
//					this.tmpViewPos.decY( this.tmpPoint );
					break;

			}
			this.startTerminator.transform( viewport, this.tmpViewPos, frameCounter );
		}
	}

	protected void transformEndTerm( BView viewport, int frameCounter )
	{
		if ( this.endTerminator != null )
		{
			this.tmpViewPos.setLocation( this.endPt );
			this.tmpPoint.setXYtoWH( this.endTerminator.getBounds() );
//			this.tmpPoint.half();
			switch( this.side )
			{
				case BScalarRect.kOutBottom:
					this.tmpViewPos.incY( this.tmpPoint );
					break;
				case BScalarRect.kOutLeft:
					this.tmpViewPos.decX( this.tmpPoint );
					break;
				case BScalarRect.kOutRight:
					this.tmpViewPos.incX( this.tmpPoint );
					break;
				case BScalarRect.kOutTop:
					this.tmpViewPos.decY( this.tmpPoint );
					break;

			}
			this.endTerminator.transform( viewport, this.tmpViewPos, frameCounter );
		}
	}

	public void transformProperties ( BView viewport, int frameCounter )
	{
		// Not passing counter through.  This is rendered everytime arc is...therefore it
		// should take not of the counter.

        if ( lastFrame != frameCounter )
        {
		    int size = this.properties.size ();
		    BTextArea tmpArea;

		    // don't need to catch what it returns for it sets and returns a member attribute.
		    for ( int i = 0; i < size; i++ )
		    {
			    tmpArea = ( BTextArea ) this.properties.elementAt ( i );
			    if ( tmpArea.isVisible () )
			    {
                    Debug.doPrintln ( "tf BY ARC, endPos "+endPos );
                    arcMidPt.setLocation ( endPos );
                    arcMidPt.decXY ( this.pos );
                    arcMidPt.scale ( tmpArea.getDeltaXY () );
                    arcMidPt.incXY ( this.pos );
                    arcMidPt.decXY( tmpArea.getPos() );
                
				    tmpArea.arcTransform ( viewport, arcMidPt, frameCounter );
			    }
		    }
        }
	}

	protected void transformNodePos( BModelNode node, BScalarPoint bspt, Point pt, BView viewport, BScalarPoint parentPos, int frameCounter )
	{
		Rectangle xform = null;
		if ( node != null )
		{
			if ( !node.isTransformed( frameCounter ) )
			{
				node.transform( viewport, parentPos, frameCounter );
			}

            bspt.setLocation( node.getPos() );

			xform = node.getXFormedBounds();

			pt.x = xform.x + (xform.width >> 1);
			pt.y = xform.y + (xform.height >> 1 );
		}
		else //endnode is null...
		{
			this.tmpViewPos.setLocation( bspt );
			this.tmpViewPos.incXY( parentPos );
			this.tmpViewPos.decXY( viewport.getViewCoords() );
			this.tmpViewPos.scale( viewport.getOOZ() );
			this.tmpViewPos.incXY( viewport.getHalfWH() );
			this.tmpViewPos.getLocation( pt );
		}
	}

		/**
	 * tranforms a center point to the side of the model's bounding box.
	 * calculates the intesection with the line..
	 *
	 */
	protected void transformToSide( BModelNode node, Point center, Point finalPt, Point outPt )
	{
		Rectangle xform;
		int out;
		int tmpCalc;

		if ( node != null )
		{
			xform = node.getXFormedBounds();

			out = outcode( xform, finalPt.x, finalPt.y );

			switch( out )
			{
				case BScalarRect.kOutTop:
					this.intercept( center, finalPt, BScalarRect.kOutTop, xform.y, outPt );
					this.side = BScalarRect.kOutTop;
					break;
				case BScalarRect.kOutBottom:
					this.intercept( center, finalPt, BScalarRect.kOutBottom, xform.y + xform.height, outPt );
					this.side = BScalarRect.kOutBottom;
					break;
				case BScalarRect.kOutLeft:
					this.intercept( center, finalPt, BScalarRect.kOutLeft, xform.x, outPt );
					this.side = BScalarRect.kOutLeft;
					break;
				case BScalarRect.kOutRight:
					this.intercept( center, finalPt, BScalarRect.kOutRight, xform.x + xform.width, outPt );
					this.side = BScalarRect.kOutRight;
					break;

				case BScalarRect.kOutTop | BScalarRect.kOutLeft:
					this.intercept( center, finalPt, BScalarRect.kOutTop, xform.y, outPt );
					this.side = BScalarRect.kOutTop;
					if ( outPt.x < xform.x )
					{
						this.intercept( center, finalPt, BScalarRect.kOutLeft, xform.x, outPt );
						this.side = BScalarRect.kOutLeft;
					}
					break;
				case BScalarRect.kOutTop | BScalarRect.kOutRight:
					tmpCalc=xform.x + xform.width;
					this.intercept( center, finalPt, BScalarRect.kOutTop, xform.y, outPt );
					this.side = BScalarRect.kOutTop;
					if ( outPt.x > tmpCalc )
					{
						this.intercept( center, finalPt, BScalarRect.kOutRight, tmpCalc, outPt );
						this.side = BScalarRect.kOutRight;
					}
					break;
				case BScalarRect.kOutBottom | BScalarRect.kOutLeft:
					this.intercept( center, finalPt, BScalarRect.kOutBottom, xform.y + xform.height, outPt );
					this.side = BScalarRect.kOutBottom;
					if ( outPt.x < xform.x )
					{
						this.intercept( center, finalPt, BScalarRect.kOutLeft, xform.x, outPt );
						this.side = BScalarRect.kOutLeft;
					}
					break;
				case BScalarRect.kOutBottom | BScalarRect.kOutRight:
					tmpCalc=xform.x + xform.width;
					this.intercept( center, finalPt, BScalarRect.kOutBottom, xform.y + xform.height, outPt );
					this.side = BScalarRect.kOutBottom;
					if ( outPt.x > tmpCalc )
					{
						this.intercept( center, finalPt, BScalarRect.kOutRight, tmpCalc, outPt );
						this.side = BScalarRect.kOutRight;
					}
					break;

				case BScalarRect.kOutNone:
					outPt.setLocation( center );
					this.side = BScalarRect.kOutNone;
//					outPt.x = xform.x + xform.width;
//					outPt.y = xform.y + (xform.height >> 1 );
					break;
			}

			


		}
		else
		{
			outPt.setLocation( center );
		}

	}

	protected void transformSteppedToSide( BModelNode startNode, BModelNode endNode, BView viewport, int frameCounter)	
	{
		Rectangle xform;

		int startBottom, endTop, startRight, endLeft, startLeft, endRight, startTop, endBottom;

		if ( startNode != null )
		{
			xform = startNode.getXFormedBounds();
			startTop = xform.y;
			startBottom = xform.y + xform.height;
			startRight = xform.x + xform.width;
			startLeft = xform.x;
		}
		else
		{
			startTop = startCenter.y;
			startBottom = startCenter.y;
			startRight = startCenter.x;
			startLeft = startCenter.x;
		}

		if ( endNode != null )
		{
			xform = endNode.getXFormedBounds();
			endTop = xform.y;
			endBottom = xform.y + xform.height;
			endLeft = xform.x;
			endRight = xform.x + xform.width;
		}
		else
		{
			endTop = endCenter.y;
			endBottom = endCenter.y;
			endLeft = endCenter.x;
			endRight = endCenter.x;
		}


		this.steppedScale.setLocation( this.steppedVal );
		this.steppedScale.scale( viewport.getOOZ() );

		if ( startBottom < endTop )
		{			
			this.steppingType = kTopBottom;
			this.startPt.x = startCenter.x;
			this.startPt.y = startBottom;
			this.endPt.x = endCenter.x;
			this.endPt.y = endTop;
			this.side = BScalarRect.kOutBottom;
			transformStartTerm( viewport, frameCounter );
			this.side = BScalarRect.kOutTop;
			transformEndTerm( viewport, frameCounter );
			this.steppedScale.clamp( 0, endTop - startBottom );			
		}
		else if ( startTop > endBottom )
		{
			this.steppingType = kTopBottom;
			this.startPt.x = startCenter.x;
			this.startPt.y = startTop;
			this.endPt.x = endCenter.x;
			this.endPt.y = endBottom;
			this.steppedScale.clamp( 0, startTop - endBottom );
			this.side = BScalarRect.kOutTop;
			transformStartTerm( viewport, frameCounter );
			this.side = BScalarRect.kOutBottom;
			transformEndTerm( viewport, frameCounter );

			this.steppedScale.negY();
		}
		else if ( startRight < endLeft )
		{
			this.steppingType = kLeftRight;
			this.startPt.x = startRight;
			this.startPt.y = startCenter.y;
			this.endPt.x = endLeft;
			this.endPt.y = endCenter.y;
			this.steppedScale.clamp( 0, endLeft - startRight );
			this.side = BScalarRect.kOutRight;
			transformStartTerm( viewport, frameCounter );
			this.side = BScalarRect.kOutLeft;
			transformEndTerm( viewport, frameCounter );
		}
		else if ( startLeft > endRight )
		{

			this.steppingType = kLeftRight;
			this.startPt.x = startLeft;
			this.startPt.y = startCenter.y;
			this.endPt.x = endRight;
			this.endPt.y = endCenter.y;
			this.steppedScale.clamp( 0, startLeft - endRight );
			this.side = BScalarRect.kOutLeft;
			transformStartTerm( viewport, frameCounter );
			this.side = BScalarRect.kOutRight;
			transformEndTerm( viewport, frameCounter );
		}

		
		this.steppedScale.incXY( this.startPt );
		

	}

	public void transformCtrl( BView viewport, BScalarPoint parentPos, int frameCounter )
	{
		int i;

		if ( tmpViewPos == null )
		{
			Debug.doPrintln( "tmpViewPos is null ");
			return;
		}

		for ( i = 0; i < kNumCtrlPoints; i++ )
		{
			this.tmpViewPos.setLocation( this.ctrlPos[i] );
			this.tmpViewPos.incXY( parentPos );
			this.tmpViewPos.decXY( viewport.getViewCoords() );
			this.tmpViewPos.scale( viewport.getOOZ() );
			this.tmpViewPos.incXY( viewport.getHalfWH() );
			this.tmpViewPos.getLocation( this.ctrlPt[i] );
		}
	}

	public void transformStepped( BView viewport, BScalarPoint parentPos, int frameCounter )
	{
		int i;

		if ( tmpViewPos == null )
		{
			Debug.doPrintln( "tmpViewPos is null ");
			return;
		}


		this.steppedScale.getLocation( this.ctrlPt[0] );
		this.ctrlPt[1].setLocation( this.ctrlPt[0] );


		if ( this.steppingType == BPackageArc.kLeftRight )
		{					
			this.ctrlPt[0].y = this.startPt.y;
			this.ctrlPt[1].y = this.endPt.y;
		}
		else if (this.steppingType == BPackageArc.kTopBottom )
		{
			this.ctrlPt[0].x = this.startPt.x;
			this.ctrlPt[1].x = this.endPt.x;
		}
		
	}


	/**
	 * Renders the transformed coordinates of the drawable
	 * object to a Graphics2D
	 *
	 * @param Graphics2D g2 - the place to render the object to.
	 */		
	public void render( Graphics2D g2 )
	{      
		// Does funny things, like change border of viewport!?!
		// Keep old then revert...
		BasicStroke tmpStroke = ( BasicStroke ) g2.getStroke ();
		Color tmpColour = g2.getColor ();

		lineSize = ( int ) Math.round ( arcStroke.getLineWidth () );
		dist = lineSize * 2;
        this.calcDirection ();

		tmpStart.setLocation ( startPt );
		tmpEnd.setLocation ( endPt );

        for ( int i = 0; i < kNumCtrlPoints; i++ )
        {
            this.tmpCtrlPt[i].setLocation ( ctrlPt[i] );
        }

		g2.setColor ( arcColour );
		if ( arcStroke != null )
		{
			g2.setStroke( arcStroke );
		}
		switch ( this.arcType )
		{
			case BPackageArc.kCurvedType:            
				renderCurve( g2, lineStyle.intValue () );
				break;
			case BPackageArc.kSteppedType:
				renderStepped( g2, lineStyle.intValue () );
				break;
			default:
				this.renderLine ( g2, lineStyle.intValue () );				
				break;

			
		}
		renderProperties ( g2 );

		if(this.isSelected() )
		{
			renderSizersAndOutLine(g2);
		}


		if ( this.startTerminator != null )
		{
			this.startTerminator.render( g2 );
		}

		if ( this.endTerminator != null )
		{
			this.endTerminator.render( g2 );
		}

		if ( this.arcTerminator != null && this.arcType == BPackageArc.kSteppedType )
		{
			this.arcTerminator.render( g2 );
		}

      g2.setStroke ( tmpStroke );
      g2.setColor ( tmpColour );
	}

	public void renderProperties ( Graphics2D g2 )
	{
		int size = properties.size ();
		BDrawable d;

		for ( int i = 0; i < size; i++ )
		{
			d = ( BDrawable ) properties.elementAt ( i );
			d.render ( g2 );
		}
	}

	public void renderLine ( Graphics2D g2, int style )
	{
		if ( style == BLineEditorPanel.kSingle.intValue () )
		{
			g2.drawLine( tmpStart.x, tmpStart.y, tmpEnd.x, tmpEnd.y );
		}
		else
		{
            
			g2.drawLine( tmpStart.x, tmpStart.y, tmpEnd.x, tmpEnd.y );
			tmpStart.translate ( dist * xDirection, dist * yDirection );
			tmpEnd.translate ( dist * xDirection, dist * yDirection );
			renderLine ( g2, style - 1 );
		}
	}

	public void renderStepped ( Graphics2D g2, int style )
	{
		if ( style == BLineEditorPanel.kSingle.intValue () )
		{
            this.renderStepped ( g2 );
            // Must revert values back to originals....
            startPt.setLocation ( tmpStart );
            endPt.setLocation ( tmpEnd );
            for ( int i = 0; i < kNumCtrlPoints; i++ )
            {
                this.ctrlPt[i].setLocation ( tmpCtrlPt[i] );
            }
		}
		else
		{
            this.renderStepped ( g2 );
			startPt.translate ( dist * xDirection, dist * yDirection );
			endPt.translate ( dist * xDirection, dist * yDirection );
            for ( int i = 0; i < kNumCtrlPoints; i++ )
            {
                this.ctrlPt[i].translate ( dist * xDirection, dist * yDirection );
            }
			renderStepped ( g2, style - 1 );
		}
	}

    public void renderCurve ( Graphics2D g2, int style )
    {
		if ( style == BLineEditorPanel.kSingle.intValue () )
		{
            this.drawCurve ( g2 );
            // Must revert values back to originals....
            startPt.setLocation ( tmpStart );
            endPt.setLocation ( tmpEnd );
            for ( int i = 0; i < kNumCtrlPoints; i++ )
            {
                this.ctrlPt[i].setLocation ( tmpCtrlPt[i] );
            }
		}
		else
		{
            this.drawCurve ( g2 );
			startPt.translate ( dist * xDirection, dist * yDirection );
			endPt.translate ( dist * xDirection, dist * yDirection );
            for ( int i = 0; i < kNumCtrlPoints; i++ )
            {
                this.ctrlPt[i].translate ( dist * xDirection, dist * yDirection );
            }
			renderCurve ( g2, style - 1 );
		}
    }

	

	protected void drawCurve( Graphics2D g2 )
	{
		int cx1, cx2, cy1, cy2;

		cx1 = this.ctrlPt[0].x;
		cx2 = this.ctrlPt[1].x;
		cy1 = this.ctrlPt[0].y;
		cy2 = this.ctrlPt[1].y;

		this.curve.x1 = (float)startPt.x;
		this.curve.y1 = (float)startPt.y;
		this.curve.x2 = (float)endPt.x;
		this.curve.y2 = (float)endPt.y;

		this.curve.ctrlx1 = (float)cx1;
		this.curve.ctrly1 = (float)cy1;
		this.curve.ctrlx2 = (float)cx2;
		this.curve.ctrly2 = (float)cy2;
		ctrlSizer1.setPos( cx1, cy1 );
		ctrlSizer2.setPos( cx2, cy2 );

		g2.draw( this.curve );

	}

	/** 
	* Calculates the direction of the line... comes in handy when
	* rendering multiple line styles.
	*/
	public BScalarPoint calcDirection ()
	{
		// oh oo, now we're getting into the hack code.
		if ( tmpStart.x <= tmpEnd.x )
		{
			this.yDirection = BDrawable.kForward;
		}
		else
		{
			this.yDirection = BDrawable.kBackward;
		}

		if ( tmpStart.y >= tmpEnd.y )
		{
			this.xDirection = BDrawable.kForward;
		}
		else
		{
			this.xDirection = BDrawable.kBackward;
		}

		this.dir.setLocation ( xDirection, yDirection );
		return this.dir;
	}

	public BScalarPoint getInfluence ( BScalarPoint textPt )
	{
		int xInf = kPositive;
		int yInf = kPositive;

/*		this.calcDirection ();

		int out = arcMidPt.outcode ( textPt );

		if ( ( out == Rectangle2D.OUT_RIGHT ) ||
			( out == ( Rectangle2D.OUT_TOP | Rectangle2D.OUT_RIGHT ) ) )
		{
			xInf = kPositive;
			yInf = kNegative;
		}
		else if ( ( out == Rectangle2D.OUT_BOTTOM ) ||
			( out == ( Rectangle2D.OUT_BOTTOM | Rectangle2D.OUT_RIGHT ) ) )
		{
			// Just using default values.			
			xInf = kPositive;
			yInf = kPositive;
		}
		else if ( ( out == Rectangle2D.OUT_LEFT ) ||
			( out == ( Rectangle2D.OUT_BOTTOM | Rectangle2D.OUT_LEFT ) ) )
		{
			xInf = kNegative;
			yInf = kPositive;
		}
		else if ( ( out == Rectangle2D.OUT_TOP ) ||
			( out == ( Rectangle2D.OUT_TOP | Rectangle2D.OUT_LEFT ) ) )
		{
			xInf = kNegative;
			yInf = kNegative;
		}
/**/
		textInf.setLocation ( xInf, yInf );
		return textInf;
	}

	private boolean goingNE ()
	{
		return ( startPt.getX () < endPt.getX () ) && 
			( startPt.getY () >= endPt.getY () );
	}

	private boolean goingSE ()
	{
		return ( startPt.getX () <= endPt.getX () ) &&
			( startPt.getY () < endPt.getY () );
	}

	private boolean goingSW ()
	{
		return ( startPt.getX () > endPt.getX () ) &&
			( startPt.getY () <= endPt.getY () );
	}

	private boolean goingNW ()
	{
		return ( startPt.getX () >= endPt.getX () ) &&
			( startPt.getY () > endPt.getY () );
	}

	public boolean intersects( BScalarRect point )
	{
		return true;
	}

	protected void renderCurve( Graphics2D g2 )
	{
		int cx1, cx2, cy1, cy2;

		cx1 = this.ctrlPt[0].x;
		cx2 = this.ctrlPt[1].x;
		cy1 = this.ctrlPt[0].y;
		cy2 = this.ctrlPt[1].y;

		this.curve.x1 = (float)startPt.x;
		this.curve.y1 = (float)startPt.y;
		this.curve.x2 = (float)endPt.x;
		this.curve.y2 = (float)endPt.y;

		this.curve.ctrlx1 = (float)cx1;
		this.curve.ctrly1 = (float)cy1;
		this.curve.ctrlx2 = (float)cx2;
		this.curve.ctrly2 = (float)cy2;
		ctrlSizer1.setPos( cx1, cy1 );
		ctrlSizer2.setPos( cx2, cy2 );

//		g2.draw( this.curve );
		g2.drawLine( (int)this.curve.x1, (int)this.curve.y1, (int)(this.curve.x2), (int)(this.curve.y2));

	}

	protected void renderStepped( Graphics2D g2 )
	{
		int cx1, cx2, cy1, cy2;

		cx1 = this.ctrlPt[0].x;
		cx2 = this.ctrlPt[1].x;
		cy1 = this.ctrlPt[0].y;
		cy2 = this.ctrlPt[1].y;
				
		ctrlSizer1.setPos( cx1, cy1 );
		ctrlSizer2.setPos( cx2, cy2 );

		g2.drawLine( startPt.x, startPt.y, cx1, cy1 );
		g2.drawLine( cx1, cy1, cx2, cy2 );
		g2.drawLine( cx2, cy2, endPt.x, endPt.y );
		
	}


	protected void renderSizersAndOutLine( Graphics2D g2)
	{
		startSizer.setPos( startPt.x, startPt.y );
		endSizer.setPos( endPt.x, endPt.y );

		g2.setColor( BSizer.kSizerColour );

		startSizer.render( g2 );
		endSizer.render( g2 );

		switch( this.arcType)
		{
			case BPackageArc.kCurvedType:
			case BPackageArc.kSteppedType:
				
				ctrlSizer1.render( g2 );
				ctrlSizer2.render( g2 );
				break;
		}
	}

	/**
	 * checks the tranformed bounds...used for hit testing with the mouse..
	 *
	 */
	public int checkXFormBounds( Point pt )
	{
		int result = kNotHit;
		switch( this.arcType )
		{
			case BPackageArc.kCurvedType:
				result = checkXFormCurvedBounds( pt );
				break;
			case BPackageArc.kSteppedType:
				result = checkXFormSteppedBounds( pt );
				break;
			case BPackageArc.kStraightType:
			default:
				result = checkXFormStraightBounds( pt );
				break;
		}

		return result;
	}

	public int checkXFormCurvedBounds( Point pt )
	{
		this.hitRect.setBounds( pt.x - kHalfHitLen, pt.y - kHalfHitLen, kHitLen, kHitLen );

		if ( this.curve.intersects( this.hitRect ) )
		{
			return kHitBounds;
		}
		else
		{
			return kNotHit;
		}
	}

	public int checkXFormStraightBounds( Point pt )
	{
		this.hitRect.setBounds( pt.x - kHalfHitLen, pt.y - kHalfHitLen, kHitLen, kHitLen );

		if ( this.hitRect.intersectsLine( (double)startPt.x, (double)startPt.y, (double)endPt.x, (double)endPt.y ) )
		{
			return kHitBounds;
		}
		else
		{
			return kNotHit;
		}
	}

	public int checkXFormSteppedBounds( Point pt )
	{
		this.hitRect.setBounds( pt.x - kHalfHitLen, pt.y - kHalfHitLen, kHitLen, kHitLen );

		if ( this.hitRect.intersectsLine( (double)startPt.x, (double)startPt.y, (double)this.ctrlPt[0].x, (double)ctrlPt[0].y ) )
		{
			return kHitBounds;
		}
		else if ( this.hitRect.intersectsLine( (double)ctrlPt[0].x, (double)ctrlPt[0].y, (double)ctrlPt[1].x, (double)ctrlPt[1].y ) )
		{
			return kHitBounds;
		}
		else if ( this.hitRect.intersectsLine( (double)ctrlPt[1].x, (double)ctrlPt[1].y, (double)endPt.x, (double)endPt.y ) )
		{
			return kHitBounds;
		}
		else
		{
			return kNotHit;
		}
	}

	/**
	 * Checks to see if a sizer has been hit by a point
	 * Works on xformed values.
	 * Subclasses should determine appropriate places for
	 * the sizer..
	 *
	 * @param Point pt - the point to check the hit against
	 * @return kNotHit - not hit
	 * @return kHitSizer + XX hit the XX sizer where XX is any number.
	 */
	public int checkSizerHit( Point pt )
	{
		int result = kNotHit;

		switch( this.arcType )
		{
			case BPackageArc.kCurvedType:
			case BPackageArc.kSteppedType:
				result = checkCurvedSizerHit( pt );
				break;
			case BPackageArc.kStraightType:
			default:
				result = checkStraightSizerHit( pt );
				break;
		}

		return result;
	}

	public int checkStraightSizerHit( Point pt )
	{
		if ( this.startSizer.contains( pt )) return kSizerStartArc;
		else if ( this.endSizer.contains( pt )) return kSizerEndArc;

		return kNotHit;
	}

	public int checkCurvedSizerHit( Point pt )
	{		
		if ( this.startSizer.contains( pt )) return kSizerStartArc;
		else if ( this.endSizer.contains( pt )) return kSizerEndArc;
		else if ( this.ctrlSizer1.contains( pt )) return kSizerCtrlPoint1;
		else if ( this.ctrlSizer2.contains( pt )) return kSizerCtrlPoint2;

		return kNotHit;
	}


	public void startAdd()
	{
		this.adding = true;		
	}

	public void dragAdd( BScalarPoint deltaXY )
	{	
		this.endPos.incXY( deltaXY );

		if ( this.arcType == BPackageArc.kCurvedType )
		{
			tmpViewPos.setLocation( deltaXY );
			tmpViewPos.scale( kThirdScale );
			this.ctrlPos[0].incXY( tmpViewPos );

			tmpViewPos.setLocation( deltaXY );
			tmpViewPos.scale( kTwoThirdScale );
			this.ctrlPos[1].incXY( tmpViewPos);		

			Debug.doPrintln("********************* ctrl Pos was changed 1378 **********************");
		}
		else if ( this.arcType == BPackageArc.kSteppedType )
		{
			this.steppedVal.setLocation( endPos );
			this.steppedVal.decXY( pos );
			
			this.steppedVal.half();
			
		}
	}

	public void stopAdd()
	{
		this.adding = false;
	}


	/**
	 * Called as the drawable is being resized
	 *
	 */
	public void dragResize( BScalarPoint deltaXY, int sizer )
	{
		
		if ( this.arcType == kSteppedType )
		{
			switch( sizer )
			{
				case kSizerStartArc:								
					this.pos.incXY( deltaXY );
					break;
				case kSizerEndArc:
					this.endPos.incXY( deltaXY );
					break;
				case kSizerCtrlPoint1:
				case kSizerCtrlPoint2:

					if ( this.steppingType == kLeftRight )
					{
						this.steppedVal.incX( deltaXY );

					}
					else if ( this.steppingType == kTopBottom )
					{
						this.steppedVal.incY( deltaXY );

					} 


					this.tmpViewPos.setLocation( this.endPos );
					this.tmpViewPos.decXY( this.pos );
					this.steppedVal.clamp( this.tmpViewPos );
		
					break;
			}
			Debug.doPrintln("The Stepped Value is " + this.steppedVal );

		}
		else
		{
			switch( sizer )
			{
				case kSizerStartArc:								
					this.pos.incXY( deltaXY );
					break;
				case kSizerEndArc:
					this.endPos.incXY( deltaXY );
					break;
				case kSizerCtrlPoint1:
					this.ctrlPos[0].incXY( deltaXY );
					Debug.doPrintln("********************* ctrl Pos was changed 1449 **********************");
					break;
				case kSizerCtrlPoint2:
					this.ctrlPos[1].incXY( deltaXY );
					Debug.doPrintln("********************* ctrl Pos was changed 1453 **********************");
					break;
			}
		}

		Debug.doPrintln("Package Arc ctrl1 is " + this.ctrlPos[0] );
		Debug.doPrintln("Package Arc ctrl2 is " + this.ctrlPos[1] );

		
	}


	public void paintIcon( Component c, Graphics g, int x, int y )
	{
		int width, height;
		int halfw, halfh;
		int pad = 6;

		width = c.getWidth() - pad;
		height = c.getHeight() - pad;

		halfw = width >> 1;
		halfh = (height + pad) >> 1;

		switch( this.arcType )
		{
			case BPackageArc.kSteppedType:
				startPt.setLocation( pad, pad );
				endPt.setLocation( width, height );
				ctrlPt[0].setLocation( pad, halfh );
				ctrlPt[1].setLocation( width, halfh );				
				break;
			case BPackageArc.kStraightType:
				startPt.setLocation( pad, pad );
				endPt.setLocation( width, height );				
				break;
			case BPackageArc.kCurvedType:
				startPt.setLocation( pad, pad );
				endPt.setLocation( width, height );
				ctrlPt[0].setLocation( pad, halfh );
				ctrlPt[1].setLocation( halfw, halfh );				
				break;
		}

		if ( c instanceof BDrawableButton )
		{						
			BIconView.setHalfWH( BDrawableButton.halfWH );
			iconOOZ.setValue( 1.0f / 1.0f );
			BIconView.setOOZ( iconOOZ );			

			if ( this.startTerminator != null )
			{
				Debug.doPrintln("displaying the start in the icon");
				this.tmpViewPos.setLocation( this.startPt );
				this.startTerminator.transform( BIconView.view, this.tmpViewPos, paintCount++ );
			}

			if ( this.endTerminator != null )
			{
				Debug.doPrintln("displaying the end in the icon");
				this.tmpViewPos.setLocation( this.endPt );
				this.endTerminator.transform( BIconView.view, this.tmpViewPos, paintCount++ );
			}

			if ( this.arcTerminator != null && this.arcType == BPackageArc.kSteppedType )
			{
				Debug.doPrintln("displaying the arc in the icon");
				this.tmpViewPos.setLocation( this.ctrlPt[0] );
				this.arcTerminator.transform( BIconView.view, this.tmpViewPos, paintCount++ );				
			}
			


			Debug.doPrintln("the bounds are " + this.bounds );
		}
		else
		{
			Debug.doPrintln("Not a BDrawableButton");
		}

		render( (Graphics2D)g );
	}


	/**
	 * Creates and returns a new instance of the BDrawable object
	 *
	 * @return a new instance of this BDrawable object.
	 */
	public BDrawable newInstance()
	{
		return new BPackageArc( this );
	}

	public void copy( BPackageArc src )
	{
		super.copy( src );
		
		BDrawable cur = null;
		BTextArea text = null;
		int i;
		int size;

		this.parent = src.parent;

		this.steppedVal.setLocation( src.steppedVal );

		this.arcColour = src.arcColour;
		this.lineStyle = new Integer ( src.lineStyle.intValue () );
		this.arcType = src.arcType;
		this.arcStroke = new BasicStroke( src.arcStroke.getLineWidth(),
									 src.arcStroke.getEndCap(),
									 src.arcStroke.getLineJoin(),
									 src.arcStroke.getMiterLimit(),
									 src.arcStroke.getDashArray(),
									 src.arcStroke.getDashPhase() );

		this.properties.clear ();
		size = src.properties.size();

		for ( i = 0; i < size; i++ )
		{
			text = (BTextArea)src.properties.elementAt( i );
			text.setArc ( this );
			// See if this makes a difference...
			this.properties.add( text.newInstance () );
		}


		if ( src.startTerminator != null )
		{
			this.startTerminator = (BPackageTerminator)src.startTerminator.newInstance();
		}
		if ( src.endTerminator != null )
		{
			this.endTerminator = (BPackageTerminator)src.endTerminator.newInstance();
		}

		if ( src.arcTerminator != null )
		{
			this.arcTerminator = (BPackageTerminator)src.arcTerminator.newInstance();	
		}


	}

	protected static final String kKeyArcType = "arcType";
	protected static final String kDefaultArcType = "1";

	protected static final String kKeyLineStyle = "lineStyle";
	protected static final String kDefaultLineStyle = "1";

	protected static final String kKeyArcColor = "arcColour";
	protected static final String kDefaultArcColor = "" + Color.black.getRGB();

	protected static final String kKeyStrokeWidth = "width";
	protected static final String kDefaultStrokeWidth = "1.0";

	protected static final String kKeyStrokeCap = "cap";
	protected static final String kDefaultStrokeCap = "" + BasicStroke.CAP_SQUARE;

	protected static final String kKeyStrokeJoin = "join";
	protected static final String kDefaultStrokeJoin = "" + BasicStroke.JOIN_MITER;

	protected static final String kKeyStrokeLimit = "limit";
	protected static final String kDefaultStrokeLimit = "10.0";

	protected static final String kKeyStrokePhase = "phase";
	protected static final String kDefaultStrokePhase = "0.0";

	protected static final String kKeyStrokeDash = "dash";
	
   /**
	 * Loads the BDrawable from a file
	 * @param BDataFile file - the file to load from
	 * @return boolean - true on success, false on failure.
	 */
	public boolean load(BDataFile file)
	{
		Debug.doPrintln("BPackageArc load");
		super.load(file);
		while(true)
		{
			String location = file.getData("location", null);
			if(location == null)
			{
				break;
			}

			if(location.equals("properties"))
			{
				while(true)
				{
					BTextArea object = (BTextArea)file.autoLoad();
					if(object == null)
					{
						Debug.doPrintln("Load properties Finished");
						break;
					}
					object.setParent( this );
					// Parent is used for other purposes and cannot be assumed to 
					// ve a package arc.
					object.setArc ( this );
					properties.add( object );
				}
			}
			else if ( location.equals("startTerm" ) )
			{
				startTerminator = (BPackageTerminator)file.autoLoad();
			}
			else if ( location.equals("endTerm"))
			{
				endTerminator = (BPackageTerminator)file.autoLoad();
			}
			else if ( location.equals("arcTerm"))
			{
				arcTerminator = (BPackageTerminator)file.autoLoad();
			}
			else if ( location.equals("step"))
			{
				steppedVal = (BScalarPoint)file.autoLoad();
				Debug.doPrintln("The stepped val was loaded as " + steppedVal );
			}
			else if ( location.equals("other"))
			{
				metaElement = (BMetaElement)file.autoLoad();				
			}
		}


		Debug.doPrintln("Loaded name as " + name );

		


      arcType = Integer.parseInt ( file.getData ( kKeyArcType, kDefaultArcType ) );
		arcColour = new Color( new Integer( file.getData( kKeyArcColor, kDefaultArcColor ) ).intValue() );
		lineStyle = Integer.valueOf ( file.getData ( kKeyLineStyle, kDefaultLineStyle ) );

		// load the stroke bits...
		float width = Float.parseFloat(file.getData(kKeyStrokeWidth, kDefaultStrokeWidth));
		int cap = Integer.parseInt(file.getData(kKeyStrokeCap, kDefaultStrokeCap));
		int join = Integer.parseInt(file.getData(kKeyStrokeJoin, kDefaultStrokeJoin));
		float limit = Float.parseFloat(file.getData(kKeyStrokeLimit, kDefaultStrokeLimit));
		float phase = Float.parseFloat(file.getData(kKeyStrokePhase, kDefaultStrokePhase));

		Vector dashVec = new Vector();
        while ( true )
        {
			String value = file.getData(kKeyStrokeDash, null);
			Debug.doPrintln ( "\nReading dash : " + value );
			if(value == null)
			{
				break;
			}
            dashVec.add (new Float( value ) );
        }


        float [] dashes = null;
		
		if(dashVec.size () > 0)
		{
			dashes = new float[ dashVec.size () ];
	        for ( int i = 0; i < dashVec.size (); i++ )
	        {
		        dashes[ i ] = ( ( Float ) dashVec.elementAt ( i ) ).floatValue ();
	        }
		}
        arcStroke = new BasicStroke ( width, cap, join, limit, dashes, phase );

		return true;
	}

	/**
	 * Saves the BDrawable to a file
	 * @param BDataFile file - the file to save to
	 * @return boolean - true on success, false on failure.
	 */
	public boolean save(BDataFile file)
	{
		Debug.doPrintln("BPackageArc save");
		super.save(file);
		Debug.doPrintln ( "" );
		if ( properties.size() > 0 )
		{
			file.addData("location", "properties");
			for ( int i = 0; i < properties.size(); i++)
			{
				file.save( (BSaveable)properties.get(i) );
			}
		}

		if ( startTerminator != null )
		{		
			file.addData("location", "startTerm" );
			file.save((BSaveable) startTerminator );
		}

		if ( endTerminator != null )
		{
			file.addData("location", "endTerm");
			file.save((BSaveable) endTerminator );
		}

		if ( arcTerminator != null )
		{
			file.addData("location","arcTerm");
			file.save((BSaveable) arcTerminator );
		}

		file.addData("location", "step");
		file.save((BSaveable) steppedVal );
	   Debug.doPrintln("The stepped val was saved as " + steppedVal );

		file.addData("location", "other" );
		file.save((BSaveable) metaElement);
		
		
	    file.addData( kKeyArcType, "" + arcType, kDefaultArcType );
   		file.addData( kKeyArcColor, Integer.toString( arcColour.getRGB() ), kDefaultArcColor );
		file.addData ( kKeyLineStyle, lineStyle.toString (), kDefaultLineStyle );
		
		// the stroke...
		file.addData( kKeyStrokeWidth, "" + arcStroke.getLineWidth(), kDefaultStrokeWidth);
		file.addData( kKeyStrokeCap, "" + arcStroke.getEndCap(), kDefaultStrokeCap);
		file.addData( kKeyStrokeJoin, "" + arcStroke.getLineJoin(), kDefaultStrokeJoin);
		file.addData( kKeyStrokeLimit, "" + arcStroke.getMiterLimit(), kDefaultStrokeLimit);
		file.addData( kKeyStrokePhase, "" + arcStroke.getDashPhase(), kDefaultStrokePhase);

		float[] dash = arcStroke.getDashArray();
		if(dash != null)
		{
			for(int i=0; i< dash.length; i++)
			{
				Debug.doPrintln ( "\nSaving : " + Float.toString ( dash[i] ) );
				file.addData( kKeyStrokeDash, Float.toString ( dash[i]));
			}
		}

		return true;
	}


	/**
	 * updates the bounding region of the drawable
	 * Called when something requires the bounds of
	 * the drawable to be updated.  Subclasses should
	 * determine a suitable way to update themselves.
	 */
	public void updateBounds()
	{
		switch( this.arcType )
		{
			case BPackageArc.kSteppedType:
			case BPackageArc.kCurvedType:
				this.bounds.setBoundsFrom4Points( this.pos, this.endPos, this.ctrlPos[0], this.ctrlPos[1] );
				break;
			
			case BPackageArc.kStraightType:				
			default:
				this.bounds.setBoundsFrom2Points( this.pos, this.endPos );
				break;
		}

	}


	///////////tree node stuff...

	public boolean isLeaf()
	{
		return this.properties.size() <= 0;
	}

	public Object getChildAt( int index )
	{
		return this.properties.elementAt( index );
	}

	public int getChildCount()
	{
		return this.properties.size();
	}

	public Object getParent()
	{
		return this.parent;
	}

	public int getIndexOf( Object node )
	{
		return this.properties.indexOf( node );
	}

	public void setParent( Object parent )
	{
		this.parent = parent;
	}

	public void removeAllChildren()
	{
		this.properties.clear();
	}

	public String getName()
	{
		return this.name;
	}
}

