
//$Header: /teamproj/cvsroot/teamb/bkasrc/au/edu/swin/synergy/plugin/packager/BPackageArcEditor.java,v 1.41 1999/10/17 22:10:12 tp079568 Exp $
package au.edu.swin.synergy.plugin.packager;

import javax.swing.*;
import javax.swing.border.*;
import java.awt.*;
import java.awt.event.*;
import java.util.Vector;

import au.edu.swin.synergy.math.BScalarPoint;	
import au.edu.swin.synergy.math.BScalarRect;

import au.edu.swin.synergy.shapes.BLineEditorPanel;
import au.edu.swin.synergy.shapes.BTextArea;
import au.edu.swin.synergy.plugin.packager.BPackageArc;
import au.edu.swin.synergy.plugin.packager.BPackageModel;
import au.edu.swin.synergy.plugin.packager.event.BIStrokeChangeListener;
import au.edu.swin.synergy.plugin.diagram.BViewport;
import au.edu.swin.synergy.plugin.diagram.BDiagram;
import au.edu.swin.synergy.plugin.diagram.BDrawable;
import au.edu.swin.synergy.plugin.diagram.event.BRegisterViewportCE;

import au.edu.swin.synergy.plugin.packager.BPackageNodeDiagram;

import au.edu.swin.synergy.kernel.BPlugin;
import au.edu.swin.synergy.debug.Debug;

import au.edu.swin.synergy.plugin.dialect.BDialect;

public class BPackageArcEditor extends JPanel implements BDiagram
{
	BLineEditorPanel lineEditor;
	BasicStroke lineStroke;
	Color lineColour;
	Integer lineStyle;

	String[] arcStyles = new String[3];

	JComboBox startNodeBox;
	JComboBox endNodeBox;
	JComboBox arcNodeBox; 
	JComboBox styleBox;
	
	BViewport preview;
//    linePreview preview;

	JLabel arc;
	JLabel pre;
	JLabel arcStyle;
	JLabel begNode;
	JLabel arcNode;
	JLabel endNode;

	BPackageArc packageArc = null;

	BPlugin parent;

	Vector availableTerminators;

	Vector placeable;

	BDrawable curAdd;
	int propIndex = -1;
	BPackageTerminator dummyTerminator;

	public BPackageArcEditor ( BPlugin par )
	{
		this.placeable = new Vector ();
		// Add all items which may be placed on the viewport in; this
		// editor.
		this.placeable.add ( new BTextArea ( 0, 0, 8, 5 ) );

		nodeListRenderer listRenderer = new nodeListRenderer ();

		this.parent = par;
		availableTerminators = new Vector ();
		dummyTerminator = new BPackageTerminator ();
		dummyTerminator.setDummyStatus ( true );

		arc = new JLabel ( BDialect.getString ( this, "arc" ) );
		pre = new JLabel ( BDialect.getString ( this, "prev" ) );
		arcStyle = new JLabel ( BDialect.getString ( this, "arcstyle" ) );
		begNode = new JLabel ( BDialect.getString ( this, "begnode" ) );
		arcNode = new JLabel ( BDialect.getString ( this, "arcnode" ) );
		endNode = new JLabel ( BDialect.getString ( this, "endnode" ) );
		arcStyles[BPackageArc.kStraightType] = BDialect.getString ( this, "straight" );
		arcStyles[BPackageArc.kSteppedType] = BDialect.getString ( this, "stepped" );
		arcStyles[BPackageArc.kCurvedType] = BDialect.getString ( this, "curved" );

		setLayout ( new GridBagLayout () );
		GridBagConstraints c = new GridBagConstraints ();
		
		lineStroke = new BasicStroke ( 4 );
		lineColour = Color.black;
		lineStyle = BLineEditorPanel.kSingle;
		lineEditor = new BLineEditorPanel ( lineStroke, lineColour, lineStyle );
		lineEditor.addColourChangeListener ( new updateColour () );
		lineEditor.addStrokeChangeListener ( new updateStroke () );
		lineEditor.addStyleChangeListener ( new updateStyle () );

		setConst ( c, 0, 0, 4, 1, GridBagConstraints.CENTER, GridBagConstraints.NONE );
		add ( lineEditor, c );
		
		setConst ( c, 0, 1, 1, 1, GridBagConstraints.CENTER, GridBagConstraints.NONE );
		add ( arcStyle, c );

		setConst ( c, 1, 1, 1, 1, GridBagConstraints.CENTER, GridBagConstraints.NONE );
		styleBox = new JComboBox ( arcStyles );
		styleBox.addItemListener ( new validateArcNode () );
		add ( styleBox, c );

		setConst ( c, 2, 1, 1, 1, GridBagConstraints.CENTER, GridBagConstraints.NONE );
		add ( arcNode, c );

		setConst ( c, 3, 1, 1, 1, GridBagConstraints.CENTER, GridBagConstraints.NONE );
		arcNodeBox = new JComboBox ();
		arcNodeBox.setPreferredSize ( new Dimension ( 80, 30 ) );
		arcNodeBox.addItemListener ( new terminatorChange () );
		arcNodeBox.setRenderer ( listRenderer );
		add ( arcNodeBox, c );
		arcNodeBox.setEnabled ( false );

		setConst ( c, 0, 2, 1, 1, GridBagConstraints.CENTER, GridBagConstraints.NONE );
		add ( begNode, c );

//		setConst ( c, 1, 2, 1, 1, GridBagConstraints.CENTER, GridBagConstraints.NONE );
//		add ( pre, c );

		setConst ( c, 3, 2, 1, 1, GridBagConstraints.CENTER, GridBagConstraints.NONE );
		add ( endNode, c );

		setConst ( c, 0, 3, 1, 1, GridBagConstraints.CENTER, GridBagConstraints.NONE );
		startNodeBox = new JComboBox ();
		startNodeBox.setPreferredSize ( new Dimension ( 80, 30 ) );
		startNodeBox.setRenderer ( listRenderer );
		startNodeBox.addItemListener ( new terminatorChange () );
		add ( startNodeBox, c );

		setConst ( c, 1, 2, 2, 2, GridBagConstraints.CENTER, GridBagConstraints.BOTH );
//		preview = new linePreview ();
		preview = new BViewport ( par );
		preview.setBorder ( new EtchedBorder ( EtchedBorder.LOWERED ) );
		preview.setDiagram ( this );
		preview.dontScrollOnInit ();

		// This is initialised in packager plugin setup.  It is assured that it will reach
		// destination.
		par.dispatchEvent ( new BRegisterViewportCE ( this, preview, false ) );
		add ( preview, c );

		setConst ( c, 3, 3, 1, 1, GridBagConstraints.CENTER, GridBagConstraints.NONE );
		endNodeBox = new JComboBox ();
		endNodeBox.setPreferredSize ( new Dimension ( 80, 30 ) );
		endNodeBox.setRenderer ( listRenderer );
		endNodeBox.addItemListener ( new terminatorChange () );
		add ( endNodeBox, c );
	}

	/**
	* Custom made function for plotting labels and combo boxes on a panel.
	* Panel shouldn't be expandable, so concerning attribs are fixed.
	*/
    public static void setConst( GridBagConstraints gbc, int x, int y, int w, int h, int anc, int fill )
    {
        gbc.gridx = x;
        gbc.gridy = y;
        gbc.gridwidth = w;
        gbc.gridheight = h;
        gbc.fill = fill;
        gbc.anchor = anc;
		gbc.insets = new Insets ( 5, 5, 5, 5 );

		// Only a light weight so things don't expand too much.
        gbc.weightx = 1;
        gbc.weighty = 1;
        gbc.ipady = 5;
        gbc.ipadx = 3;
    }

	public void setPackageArc( BPackageArc pArc )
	{
		int i;
		BPackageTerminator term;

		if ( pArc != null )
		{
			lineEditor.enable ( true );
			styleBox.setEnabled ( true );
			startNodeBox.setEnabled ( true );
			endNodeBox.setEnabled ( true );
			arcNodeBox.setEnabled ( true );

			this.packageArc = pArc;
			// Init stuff....
			BScalarRect view = preview.getViewBounds ();

			Debug.doPrintln ( "SETPACKAGEARC::packArcEditor - viewport dimensions = "+ view );
			this.packageArc.initEndPos ( view );

			//temp hack
			packageArc.initCtrlPos();

			init ();
			int index;

			BPackageModelBranch branch = ( BPackageModelBranch ) pArc.getParent ();			
			BPackageModel model = ( BPackageModel ) branch.getParent ();

			availableTerminators.clear ();

			model.addBGroupsToVector ( BPackageModel.kTerminatorBranch, availableTerminators );
			availableTerminators.insertElementAt ( dummyTerminator, 0 );

			startNodeBox.setModel ( new DefaultComboBoxModel ( availableTerminators ) );
			endNodeBox.setModel ( new DefaultComboBoxModel ( availableTerminators ) );
			arcNodeBox.setModel ( new DefaultComboBoxModel ( availableTerminators ) ); 

			int tmpIndex;
			if ( ( term = pArc.getStartTerminator () ) != null )
			{		
				startNodeBox.setSelectedIndex ( getIndex ( term ) );
				index = startNodeBox.getSelectedIndex ();
			}

			if ( ( term = pArc.getEndTerminator () ) != null )
			{
				endNodeBox.setSelectedIndex ( getIndex ( term ) );
				index = endNodeBox.getSelectedIndex ();
			}
			
			if ( styleBox.getSelectedIndex () == BPackageArc.kSteppedType )
			{
				if ( ( term = pArc.getArcTerminator () ) != null )
				{
					arcNodeBox.setSelectedIndex ( getIndex ( term ) );
					index = arcNodeBox.getSelectedIndex ();
				}
			}

			preview.repaint ();
		}
		else 
		{
			Debug.doPrintln ( "arc is null" );
			lineEditor.enable ( false );
			startNodeBox.setEnabled ( false );
			styleBox.setEnabled ( false );
			endNodeBox.setEnabled ( false );
			arcNodeBox.setEnabled ( false );
		}
	}

	private int getIndex ( BPackageTerminator arc )
	{
		String termName = arc.getName ();
		String listName = null;

		// All combo boxes should be the same.
		ComboBoxModel cm = startNodeBox.getModel ();
		int size = cm.getSize ();
		int index = 0;

		if ( !arc.isaDummy () )
		{
			for ( int i = 1; i < size; i++ )
			{
				listName = ( ( BDrawable ) cm.getElementAt ( i ) ).getName ();
				if ( termName.compareTo ( listName ) == 0 )
				{
					// not the best way of doing it, but at them moment....
					index = i;
				}
			}
		}
		else
		{
			// if dummy index must be 0
			index = 0;
		}

		return index;
	}

	public BasicStroke getStroke ()
	{
		return this.lineStroke;
	}

	public Color getColour ()
	{
		return this.lineColour;
	}

	public Integer getLineStyle ()
	{
		return this.lineStyle;
	}

	/** 
	*
	* @pre setPackageArc () has been called.
	*/
	private void init ()
	{
		lineEditor.setColour ( packageArc.getColour () );
		lineEditor.setLineStroke ( packageArc.getStroke () );
		lineEditor.setStyle ( packageArc.getStyle () );
		styleBox.setSelectedIndex ( packageArc.getArcType () );
	}

	// Don't worry about this for the moment.
    public void addDrawable( BDrawable drawable )
	{
	}

	// Also don't worry about this for the moment.
	public void createDrawable( String name, BScalarPoint pos )
	{
	}

	public void setPropIndex ( int index )
	{
		this.propIndex = index;
	}

	public void setInitArcPos ()
	{
		if ( packageArc != null )
		{
//			packageArc.setLocation ();
		}
	}

    public Vector getPlaceableDrawables()
	{
		Debug.doPrintln ( "get placeables" );
		return this.placeable;
	}

	public void addVisibleDrawablesToList( Vector visibleList, BScalarRect bounds )
	{		
		if ( this.packageArc == null ) return;

		Vector drawables;
		BDrawable cur = null;
		BTextArea curProp = null;
		int i, size = 0;

		if ( packageArc.intersects ( bounds ) )
		{
			visibleList.add ( packageArc );
		}

		drawables = packageArc.getProperties ();
		size = drawables.size ();
		for ( i = 0; i < size; i++ )
		{
			curProp = (BTextArea)drawables.elementAt( i );

			if ( curProp.intersects( bounds ) && curProp.isVisible () )
			{
				visibleList.add( curProp );
			}		
		}

	}

	public BDrawable startAdd( BDrawable drawable, BScalarPoint pos, BDrawable under )
	{
		BDrawable d = drawable.newInstance ();
		if ( packageArc != null )
		{
			if ( this.propIndex != BPackageNodeDiagram.kNoIndex )
			{
				if ( drawable instanceof BTextArea )
				{
					packageArc.addTextProperty ( propIndex, pos );
                    d = this.packageArc.getTextProperty ( propIndex );
					this.curAdd = d;
					this.curAdd.startAdd ();
				}
			}
			else
			{
				Debug.doPrintln ( "ARC INDEX HAS NO INDEX" );
			}
		}

		return d;
	}

	public boolean continueAdd( BScalarPoint pos, BDrawable under )
	{
		if ( curAdd != null )
		{
			curAdd.continueAdd ( pos );
		}
		return true;
	}

	public void dragAdd( BScalarPoint deltaXY, BDrawable under )
	{
		if ( curAdd != null )
		{
			curAdd.dragAdd ( deltaXY );
		}
	}

	public boolean stopAdd( BScalarPoint pos, BDrawable under, int modifiers )
	{
		// Find where pos is relative to arc line.
		// Calc offset and set as start pt in drawable.
		if ( curAdd != null )
		{
			curAdd.stopAdd ();
			curAdd = null;
		}

		return true;
	}

	public void delete( BDrawable drawable )
	{
		int index = this.packageArc.getIndexOf ( drawable );

		if ( index >= 0 )
		{
			this.packageArc.removeDrawable ( index );
			if ( drawable instanceof BTextArea )
			{
				( ( BTextArea ) drawable ).setVisible ( false );
			}
		}
	}

	public void bringSelectionToFront( Vector selection )
	{
	}

	public void sendSelectionToBack( Vector selection )
	{
	}
  
	public void refreshPalette ()
	{
		preview.refreshPalette ();

		// Just to make sure these babies are off.
		preview.enableGrid ( false );
		preview.enableRuler ( false );

	}

	/**
	* Panel displaying the current for of the arc in creation.
	*/
	public class linePreview extends JPanel
	{
		public linePreview ()
		{
			setBackground ( Color.white );
			setPreferredSize ( new Dimension ( 120, 60 ) );
		}

		public void paintComponent ( Graphics g )
		{
            
            // THIS SHOULD REALLY PAINT THE BPACKAGEARC ALREADY SET...


			super.paintComponent ( g );
			Graphics2D g2 = ( Graphics2D ) g;

			Dimension d = this.getPreferredSize ();

			int x = 0;
			int y = ( int ) ( ( ( float ) d.getHeight () - lineStroke.getLineWidth () ) / 2.0f );

			g2.setColor ( lineColour );
			g2.setStroke ( lineStroke );

			// Will draw the current line over the panel.
			g2.drawLine ( x, y, x + ( int ) d.getWidth (), y );
		}
	}

	public class nodeListRenderer implements ListCellRenderer
	{
		JLabel arcLab;
		JPanel panel;

		public nodeListRenderer ()
		{
			arcLab = new JLabel ();
			panel = new JPanel ();
			panel.setPreferredSize ( new Dimension ( 60, 30 ) );
			panel.add ( arcLab );
		}

		public Component getListCellRendererComponent ( JList list, Object value, 
			int index, boolean isSelected, boolean cellHasFocus )
		{
			BPackageTerminator arc = ( BPackageTerminator ) value;

			if ( isSelected )
			{
				panel.setBackground ( list.getSelectionBackground () );
				panel.setForeground ( list.getSelectionForeground () );
			}
			else
			{
				panel.setBackground ( list.getBackground () );
				panel.setForeground ( list.getForeground () );
			}

			if ( arc != null )
			{
				if ( arc.isaDummy () )
				{
					arcLab.setIcon ( null );
					arcLab.setText ( "" );
				}
				else
				{
					arcLab.setIcon ( arc );
					arcLab.setText ( arc.getName () );
				}
			}

			return panel;
		}
	}

	public class validateArcNode implements ItemListener
	{
		public void itemStateChanged ( ItemEvent e )
		{
			if ( packageArc != null )
			{
				packageArc.setArcType ( styleBox.getSelectedIndex () );
				Debug.doPrintln("setting the arc type to " + styleBox.getSelectedIndex() );
			}

			if ( e.getStateChange () == ItemEvent.SELECTED )
			{
				String selected = ( String ) e.getItem ();				
				if ( selected == BDialect.getString ( this, "stepped" ) )
				{
					arcNodeBox.setEnabled ( true );
				}
				else
				{
					arcNodeBox.setEnabled ( false );
				}
			}	
		}
	}

	public class terminatorChange implements ItemListener
	{
		BPackageTerminator term;
		public void itemStateChanged ( ItemEvent e ) 
		{
			JComboBox box = ( JComboBox ) e.getSource ();
			if ( packageArc != null )
			{
				if ( e.getStateChange () == ItemEvent.SELECTED )
				{
					if ( box == startNodeBox )
					{
						term = ( BPackageTerminator ) startNodeBox.getSelectedItem ();
						if ( term.isaDummy () )
						{
							packageArc.setStartTerminator ( null );			
						}
						else
						{
							packageArc.setStartTerminator ( term );			
						}
					}
					else if ( box == endNodeBox )
					{
						term = ( BPackageTerminator ) endNodeBox.getSelectedItem ();
						if ( term.isaDummy () )
						{
							packageArc.setEndTerminator ( null );			
						}
						else
						{
							packageArc.setEndTerminator ( term );			
						}
					}
					else if ( box == arcNodeBox )
					{
						term = ( BPackageTerminator ) arcNodeBox.getSelectedItem ();
						if ( term.isaDummy () )
						{
							packageArc.setArcTerminator ( null );
						}
						else
						{
							packageArc.setArcTerminator ( term );			
						}
					}
				}
			}
		}
	}

	public class updateColour implements BIStrokeChangeListener
	{
		public void update ( Object value )
		{			
			Debug.doPrintln ( "Now updating colour" );
			lineColour = ( Color ) value;

            if ( packageArc != null )
            {
                packageArc.setColour ( lineColour );
            }           

			preview.repaint ();


		}
	}

	public class updateStyle implements BIStrokeChangeListener
	{
		public void update ( Object value )
		{
			Debug.doPrintln ( "Now updateing arc style" );
			lineStyle = ( Integer ) value;

			if ( packageArc != null )
			{
				packageArc.setStyle ( lineStyle );
			}
			preview.repaint ();
		}
	}

	public class updateStroke implements BIStrokeChangeListener
	{
		public void update ( Object value )
		{
			Debug.doPrintln ( "Now updateing stroke." );
			lineStroke = ( BasicStroke ) value;

            if ( packageArc != null )
            {
                packageArc.setStroke ( lineStroke );
            }

			preview.repaint ();
		}
	}

}