
//$Header: /teamproj/cvsroot/teamb/bkasrc/au/edu/swin/synergy/plugin/packager/BPackageMenu.java,v 1.15 1999/10/17 11:30:36 tp079210 Exp $
package au.edu.swin.synergy.plugin.packager;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import au.edu.swin.synergy.plugin.mod13.event.BAddMenuItemCE;
import au.edu.swin.synergy.plugin.dialect.BString;
import au.edu.swin.synergy.plugin.dialect.BDialect;
import au.edu.swin.synergy.plugin.command.event.BStandardOutCE;
import au.edu.swin.synergy.plugin.mod13.bwt.BDialog;
import au.edu.swin.synergy.plugin.mod13.bwt.BDialogDone;


import javax.swing.JMenu;
import javax.swing.JMenuItem;
import java.awt.*;
import java.awt.event.*;


import javax.swing.*;
import javax.swing.event.*;


/**
 *
 * class BPackageMenu
 *
 * This class provides a menu for the packager plugin.
 *
 * Please complete these missing tags
 * @author
 * @copyright
 */
public class BPackageMenu
{
    /**
     * When the user selects this menu item, it should display the package editor
     */
    private JMenuItem packageEditorMenuItem = new JMenuItem();

	/**
	 * temp saving of a package.........
	 */
	private JMenuItem packageSaveMenuItem = new JMenuItem();

	/**
	 * new package...
	 */
	private JMenuItem packageNewMenuItem = new JMenuItem();

	/**
	 * close package...
	 */
	private JMenuItem packageCloseMenuItem = new JMenuItem();

	/**
	 * add a new terminator...
	 */
	private JMenuItem packageAddTerminator = new JMenuItem();


    /**
     * The action listener for the menu items
     */
    private BActionListener actionListener = new BActionListener();

    private BPackagePlugin plugin;
    /**
     * Please complete the missing tags for BPackageMenu
     * @param
     * @return
     * @pre
     * @post
     */

    public BPackageMenu( BPackagePlugin plugin )
    {
        BAddMenuItemCE addMenuItems = new BAddMenuItemCE( plugin, new BString(this, "menuName") );
        this.plugin = plugin;

		addMenuItems.setPreferredMenuMnemonic(new BString( this, "menuKey" ));

        //Add the additional menus
		addMenuItems.addMenuItem(this.packageNewMenuItem, new BString( this, "newpackage" ) );
        addMenuItems.addMenuItem(this.packageEditorMenuItem, new BString(this, "editpackage"));
		addMenuItems.addMenuItem(this.packageCloseMenuItem, new BString(this, "closepackage"));
		addMenuItems.addMenuItem(this.packageSaveMenuItem, new BString(this, "savepackage") );
		addMenuItems.addMenuItem(this.packageAddTerminator, new BString(this, "addterminator") );


        //Set up the listeners
        this.packageEditorMenuItem.addActionListener(this.actionListener);
		this.packageSaveMenuItem.addActionListener( this.actionListener );
		this.packageNewMenuItem.addActionListener( this.actionListener );
		this.packageCloseMenuItem.addActionListener( this.actionListener );
		this.packageAddTerminator.addActionListener( this.actionListener );

		//Set the initial values
		this.packageSaveMenuItem.setEnabled(false);
		this.packageCloseMenuItem.setEnabled(false);
		this.packageAddTerminator.setEnabled(false);

        this.plugin.dispatchEvent(addMenuItems);
    }

	/**
	 * Sets the state of the close, save and add terminator
	 * menu items to the given state.
	 *
	 * @param	newState	True to enable, false to disable
	 */
	protected void doMenuEnabling(boolean newState)
	{
		this.packageSaveMenuItem.setEnabled(newState);
		this.packageCloseMenuItem.setEnabled(newState);
		this.packageAddTerminator.setEnabled(newState);
	}
	
    /**
     * Handles program flow when the user selects
     * a menu item.
     *
     * @author Tristan Austin
     */
    private class BActionListener implements ActionListener
    {
        /**
         * This is called when the user selects one of the menu
         * items in this menu
         */
        public void actionPerformed( ActionEvent actionEvent )
        {
            Object source = actionEvent.getSource();

            if (source == BPackageMenu.this.packageEditorMenuItem)
            {
                BPackageMenu.this.plugin.doEditPackage();
            }
			else if ( source == BPackageMenu.this.packageSaveMenuItem )
			{
				BPackageMenu.this.plugin.doSavePackage();
			}
			else if ( source == BPackageMenu.this.packageNewMenuItem )
			{
				BPackageMenu.this.plugin.doNewPackage();
			}
			else if ( source == BPackageMenu.this.packageCloseMenuItem )
			{
				BPackageMenu.this.plugin.doHide();
			}
			else if ( source == BPackageMenu.this.packageAddTerminator )
			{

				BNewTerminatorPanel tPanel = new BNewTerminatorPanel( plugin, new OnDialogDone() );
				tPanel.show();



			}

        }
    }

	private class OnDialogDone implements BDialogDone
	{
		public void onClose( BDialog sender, int status )
		{
			BStandardOutCE errorMsg = null;

			if( status == BDialog.kOK )
			{
				if ( sender instanceof BNewTerminatorPanel )
				{
					if ( ((BNewTerminatorPanel)sender).getTerminatorName().trim().length() <= 0 )
					{
						errorMsg = new BStandardOutCE(this , BDialect.getString( this, "invalidterminatorname"));
						errorMsg.setMessageType( BStandardOutCE.kError );			
						BPackageMenu.this.plugin.dispatchEvent( errorMsg );
					}
					else
					{
						BPackageMenu.this.plugin.doAddTerminator( ((BNewTerminatorPanel)sender).getTerminatorName() );
					}
				}
			}
		}
	}


}

