/**
 * Please complete these missing tags
 * @author
 * @copyright
 */
//$Header: /teamproj/cvsroot/teamb/bkasrc/au/edu/swin/synergy/plugin/packager/BPackageNode.java,v 1.55 1999/10/17 21:56:15 tp079568 Exp $

package au.edu.swin.synergy.plugin.packager;

import au.edu.swin.synergy.plugin.metamodeller.BMetaElement;
import au.edu.swin.synergy.plugin.diagram.BDrawable;
import au.edu.swin.synergy.plugin.diagram.BView;
import au.edu.swin.synergy.plugin.packager.BProperty;
import au.edu.swin.synergy.debug.Debug;

import au.edu.swin.synergy.shapes.BRectangle;
import au.edu.swin.synergy.lib.BTreeNode;
import au.edu.swin.synergy.lib.io.BDataFile;
import au.edu.swin.synergy.lib.io.BSaveable;

import au.edu.swin.synergy.math.BScalarPoint;
import au.edu.swin.synergy.math.BScalarRect;
import au.edu.swin.synergy.math.BScalar;
import au.edu.swin.synergy.plugin.diagram.BSizer;

import au.edu.swin.synergy.shapes.BTextArea;

import java.util.Vector;
import java.awt.*;
import java.awt.geom.*;

public class BPackageNode extends BDrawable implements BTreeNode
{
//	static private BDataFile.ClassMap hack = new BDataFile.ClassMap("au.edu.swin.synergy.plugin.packager.BPackageNode", "packageNode");
	//a vector of all the groups making up this package node..
    private Vector drawables = null;
	private Vector properties = null;

	private Object parent = null; //the parent in the tree...
	private BScalarPoint tmpPoint = null;
	private BMetaElement metaElement = null;

	private BScalarRect viewBounds = null;
	private Rectangle xformedBounds = null;


	private BSizer northWest = null;
	private BSizer northEast = null;
	private BSizer southWest = null;
	private BSizer southEast = null;


    /**
     * Please complete the missing tags for BPackageNode
     * @param
     * @return
     * @pre
     * @post
     */


    public BPackageNode( BMetaElement element )
    {
		this( 0, 0, element );
    }
    /**
     * Please complete the missing tags for BPackageNode
     * @param
     * @return
     * @pre
     * @post
     */

    public BPackageNode( int x, int y, BMetaElement element )
    {
		super();

		int i, size;
		Vector props = null;
		BTextArea text = null;

		this.metaElement = element;

        this.drawables = new Vector();
		this.properties = new Vector();

		this.pos.setLocation( x, y );

		this.tmpPoint= new BScalarPoint();
		this.viewBounds = new BScalarRect();
		this.xformedBounds = new Rectangle();

		this.northWest = new BSizer();
		this.northEast = new BSizer();
		this.southWest = new BSizer();
		this.southEast = new BSizer();

		if ( element != null )
		{
			this.name = element.getName();

			//set the properties...
			props = element.getProperties();
			size = props.size();
			for ( i = 0; i < size; i++ )
			{
				text = new BTextArea( ( String ) props.elementAt ( i ) );
				text.setParent( this );
				this.properties.add( text );
			}
		}
    }

   public Vector getProperties()
   {
        Debug.doPrintln ( "GETTING PROPERTIES" );
      return this.properties;
   }

	protected BPackageNode( BPackageNode pNode )
	{
		this( pNode.metaElement );
		this.copy( pNode );
		this.parent = null;
	}

	/**
	 * This is the default constructor needed for the BSaveable interface
	 */
	public BPackageNode()
	{
		this(0, 0, null);
	}

	public BMetaElement getMetaElement()
	{
		return this.metaElement;
	}

	public final Rectangle getXFormedBounds()
	{
		return this.xformedBounds;
	}

/*	public void addDrawableProperty( int index, BDrawable drawable )
	{
		BProperty prop = (BProperty)this.properties.elementAt( index );
		prop.addDrawable( drawable );
	}*/

	public BDrawable getTextProperty ( int index )
	{
		return ( BTextArea ) this.properties.elementAt ( index );
	}

	public void addTextProperty( int index, BScalarPoint pos )
	{
		Debug.doPrintln ( "ADDING TEXT TO NODE" );
		BTextArea t = (BTextArea)this.properties.elementAt( index );
		t.setVisible ( true );
		t.setPos ( pos );
	}

	/**
	 * Transforms the coordinates of the drawable object
	 * to a new coordinate space, as defined by the
	 * viewport and parent pos.
	 *
	 * @param BViewport viewport - the viewport that this object is going to be drawn in
	 * @param Point parentPos - coordinates of any parent object
	 */
	public void transform( BView viewport, BScalarPoint parentPos, int frameCounter )
	{
		int i, size;
		BDrawable cur = null;
		BScalar zoom = viewport.getOOZ();

		if ( this.lastFrame != frameCounter )
		{

			size = this.drawables.size();

			this.tmpPoint.setLocation( this.pos );
			this.tmpPoint.incXY( parentPos );

			for ( i = 0; i < size; i++ )
			{
				cur = (BDrawable)this.drawables.elementAt( i );
				cur.transform( viewport, this.tmpPoint, frameCounter );
			}

			size = this.properties.size();
			for ( i = 0; i < size; i++ )
			{
				cur = (BDrawable)this.properties.elementAt( i );
				cur.transform( viewport, this.tmpPoint, frameCounter );
			}


			//transform the bounds to viewspace...
			this.viewBounds.setBounds( this.bounds );
			this.viewBounds.incXY( this.pos );
			this.viewBounds.incXY( parentPos );
			this.viewBounds.decXY( viewport.getViewCoords() );

			this.viewBounds.scale( zoom );

			this.viewBounds.incXY( viewport.getHalfWH() );

			this.viewBounds.getBounds( this.xformedBounds );


			this.northWest.setPos( this.xformedBounds.x, this.xformedBounds.y );
			this.northEast.setPos( this.xformedBounds.x + this.xformedBounds.width, this.xformedBounds.y );

			this.southEast.setPos( this.xformedBounds.x, this.xformedBounds.y + this.xformedBounds.height );
			this.southWest.setPos( this.xformedBounds.x + this.xformedBounds.width, this.xformedBounds.y + this.xformedBounds.height );

			this.lastFrame = frameCounter;
		}

	}

	/**
	 * Renders the transformed coordinates of the drawable
	 * object to a Graphics2D
	 *
	 * @param Graphics2D g2 - the place to render the object to.
	 */
	public void render( Graphics2D g2 )
	{
		int i, size;
		BDrawable cur = null;

		size = this.drawables.size();

		for ( i = 0; i < size; i++ )
		{
			cur = (BDrawable)this.drawables.elementAt( i );
			cur.render( g2 );
		}
		
		size = this.properties.size();
		for ( i = 0; i < size; i++ )
		{
			cur = (BDrawable)this.properties.elementAt( i );
			cur.render( g2 );
		}

		if ( this.isSelected() )
		{
			renderOutlineAndSizers( g2 );
		}
	}

	public void renderOutlineAndSizers( Graphics2D g2 )
	{
		g2.setColor( BSizer.kSizerColour );

		this.northWest.render( g2 );
		this.northEast.render( g2 );
		this.southEast.render( g2 );
		this.southWest.render( g2 );
	}

	/**
	 * Checks to see if a point has hit the transformed bounds
	 * of this object
	 * @param Point pt - the point to check the hit against..
	 * @return kNotHit - not hit
	 * @return kHitBounds - hit the main bounds
	 */
	public int checkXFormBounds( Point pt )
	{		
		return this.xformedBounds.contains( pt ) ? kHitBounds : kNotHit;
	}


	/**
	 * Checks to see if a sizer has been hit by a point
	 * Works on xformed values.
	 * Subclasses should determine appropriate places for
	 * the sizer..
	 *
	 * @param Point pt - the point to check the hit against
	 * @return kNotHit - not hit
	 * @return kHitSizer + XX hit the XX sizer where XX is any number.
	 */
	public int checkSizerHit( Point pt )
	{


		if ( this.northWest.contains( pt ) ) return kSizerNorthWest;
		else if ( this.northEast.contains( pt ) ) return kSizerNorthEast;
		else if ( this.southEast.contains( pt ) ) return kSizerSouthEast;
		else if ( this.southWest.contains( pt ) ) return kSizerSouthWest;

		return kNotHit;
	}



	/**
	 * Creates and returns a new instance of the BDrawable object
	 *
	 * @return a new instance of this BDrawable object.
	 */
	public BDrawable newInstance()
	{
		BPackageNode temp = new BPackageNode( this );
		temp.updateBounds();
		return temp;
	}

	/**
	 * Loads the BDrawable from a file
	 * @param BDataFile file - the file to load from
	 * @return boolean - true on success, false on failure.
	 */
	public boolean load(BDataFile file)
	{
		Debug.doPrintln("BPackageNode load");
		super.load(file);

		while(true)
		{
			String location = file.getData("location", null);
			if(location == null)
			{
				break;
			}

			if(location.equals("drawables"))
			{
				while(true)
				{
					Debug.doPrintln("BPackageNode loading drawables");
					BDrawable object = (BDrawable)file.autoLoad();
					if(object == null)
					{
						Debug.doPrintln("Load drawables Finished");
						break;
					}
					Debug.doPrintln("BPackageNode got a drawable");
					drawables.add( object );
				}
			}
			else if(location.equals("properties"))
			{
				Debug.doPrintln ( "SIZE OF properties = " + properties.size () );
				while(true)
				{
					BTextArea object = (BTextArea)file.autoLoad();
					if( object == null )
					{
						Debug.doPrintln("Load properties Finished");
						break;
					}
					Debug.doPrintln("BPackageNode got a property");
					object.setParent( this );
					properties.add( object );
				}
			}
			else if(location.equals("other"))
			{
				Debug.doPrintln("BPackageNode loading other stuff");
				tmpPoint = (BScalarPoint) file.autoLoad();

				metaElement = (BMetaElement) file.autoLoad();
			}
		}

		Debug.doPrintln("BPackageNode load done");
		return true;
	}

	/**
	 * Saves the BDrawable to a file
	 * @param BDataFile file - the file to save to
	 * @return boolean - true on success, false on failure.
	 */
	public boolean save(BDataFile file)
	{
		super.save( file );
		Debug.doPrintln("BPackageNode save");

		if(drawables.size() > 0)
		{
			file.addData("location", "drawables");
			for ( int i = 0; i < drawables.size(); i++)
			{
				file.save( (BSaveable)drawables.get(i) );
			}
		}
		if(properties.size() > 0)
		{
			file.addData("location", "properties");
			BTextArea ta;
			for ( int i = 0; i < properties.size(); i++)
			{
				ta = (BTextArea ) properties.get(i);
				Debug.doPrintln ( "SAVING "+ta.getName ()+" TO FILE" );
				Debug.doPrintln ( "CONTAINS :\n"+ta.getRefToStrings ());
				file.save( (BSaveable)properties.get(i) );
			}
		}

		file.addData("location", "other");
		file.save((BSaveable) tmpPoint);
		file.save((BSaveable) metaElement);

		return true;
	}

	/**
	 * updates the bounding region of the drawable
	 * Called when something requires the bounds of
	 * the drawable to be updated.  Subclasses should
	 * determine a suitable way to update themselves.
	 */
	public void updateBounds()
	{
		int i, drawSize, propSize;
		BDrawable cur = null;
		BTextArea curProp = null;

		drawSize = this.drawables.size();
		for ( i = 0; i < drawSize; i++ )
		{
			cur = (BDrawable)this.drawables.elementAt( i );
			if ( i == 0 )
			{
				this.tmpBounds.setBounds( cur.getBounds() );
				this.tmpBounds.incXY( cur.getPos() );
				this.bounds.setBounds( this.tmpBounds );
			}
			else
			{
				this.tmpBounds.setBounds( cur.getBounds() );
				this.tmpBounds.incXY( cur.getPos() );
				this.bounds.union( this.tmpBounds );
			}
		}

		propSize = this.properties.size ();
		for ( i = 0; i < propSize; i++ )
		{
			curProp = ( BTextArea ) this.properties.elementAt ( i );

			if ( curProp.isVisible () )
			{
				this.tmpBounds.setBounds( curProp.getBounds() );
				this.tmpBounds.incXY( curProp.getPos() );
				
				if ( drawSize == 0 )
				{
					this.bounds.setBounds( this.tmpBounds );				
				}
				else
				{
					this.bounds.union( this.tmpBounds );
				}
			}
		}
	}


    public Vector getDrawables()
    {
        return this.drawables;
    }

    public void addDrawable( BDrawable drawable )
    {
        this.drawables.add( drawable );
		this.tmpBounds.setBounds( drawable.getBounds() );
		this.tmpBounds.incXY( drawable.getPos() );
		this.bounds.union( this.tmpBounds );
    }

	public int getDrawableIndex( BDrawable drawable )
	{
		return this.drawables.indexOf( drawable );
	}

	public void removeDrawable( BDrawable drawable )
	{
		this.removeDrawable( this.drawables.indexOf( drawable ) );
	}

	public void removeDrawable( int index )
	{
		if ( index >= 0 )
		{
			this.drawables.removeElementAt( index );
		}
	}

	/*
	 * this is a really inefficient way to do this
	 * however the selection vector is only small, 
	 * and i'm in a hurry.
	 */
	public void bringSelectionToFront( Vector selection )
	{
		int i, size;
		size = selection.size();
		for ( i = 0; i < size; i++ )
		{
			this.drawables.remove( selection.elementAt( i ) );
		}

		for ( i = size-1; i >= 0; i-- )
		{
			this.drawables.add( selection.elementAt( i ) );
		}
	}

	/*
	 * this is a really inefficient way to do this
	 * however the selection vector is only small, 
	 * and i'm in a hurry.
	 */
	public void sendSelectionToBack( Vector selection )
	{
		int i, size;
		size = selection.size();

		for ( i = 0; i < size; i++ )
		{
			this.drawables.remove( selection.elementAt( i ) );
		}

		for ( i = size-1; i >= 0; i-- )
		{
			this.drawables.add( 0, selection.elementAt( i ) );
		}



	}


    /**
     * Please complete the missing tags for toString
     * @param
     * @return
     * @pre
     * @post
     */

    public String toString()
    {
        return this.name;
    }

	public void setColour( Color colour )
	{
	}

	public void copy( BPackageNode src )
	{
		int i, size;
		BDrawable cur = null;
		BDrawable added = null;

		super.copy( src );

		this.metaElement = src.metaElement;
		size = src.drawables.size();

		for ( i = 0; i < size; i++ )
		{
			cur = (BDrawable)src.drawables.elementAt( i );
			added = cur.newInstance();
			this.drawables.add( added.newInstance() );
		}

		int counter = 0;
		this.properties.clear ();
		size = src.properties.size();
		for ( i = 0; i < size; i++, counter++ )
		{
			cur = (BDrawable)src.properties.elementAt( i );
			// See if this makes a difference...
			this.properties.add( cur.newInstance () );
		}
		this.parent = src.parent;

		this.tmpPoint.setLocation( src.tmpPoint );

	}

///////////tree node stuff...

	public boolean isLeaf()
	{
		return this.properties.size() <= 0;
	}

	public Object getChildAt( int index )
	{
		return this.properties.elementAt( index );
	}

	public int getChildCount()
	{
		return this.properties.size();
	}

	public Object getParent()
	{
		return this.parent;
	}

	public int getIndexOf( Object node )
	{
		return this.properties.indexOf( node );
	}

	public void setParent( Object parent )
	{
		this.parent = parent;
	}

	public void removeAllChildren()
	{
		this.properties.clear();
	}

	public String getName()
	{
		return this.name;
	}

}
