
//$Header: /teamproj/cvsroot/teamb/bkasrc/au/edu/swin/synergy/plugin/packager/BPackagePlugin.java,v 1.75 1999/10/17 22:36:44 tp079210 Exp $

   package au.edu.swin.synergy.plugin.packager;

	import java.awt.*;
   import java.awt.event.*;

	import java.lang.Integer;

   import javax.swing.*;
   import javax.swing.event.*;
   import javax.swing.tree.*;

   import java.io.InputStream;
   import java.io.PrintStream;
   import java.io.File;

   import au.edu.swin.synergy.kernel.BPlugin;
   import au.edu.swin.synergy.kernel.BCommandEvent;
   import au.edu.swin.synergy.kernel.event.BBootCE;
   import au.edu.swin.synergy.kernel.BCommandComplete;
   import au.edu.swin.synergy.kernel.BBlockingComplete;


   import au.edu.swin.synergy.plugin.mod13.event.BAddMenuItemCE;
   import au.edu.swin.synergy.plugin.mod13.event.BAddWindowCE;
   import au.edu.swin.synergy.plugin.mod13.event.BAddPanelCE;
   import au.edu.swin.synergy.plugin.mod13.event.BSelectPanelCE;
   import au.edu.swin.synergy.plugin.mod13.event.BRemovePanelCE;
   import au.edu.swin.synergy.plugin.mod13.event.BCloseWindowCE;
   import au.edu.swin.synergy.plugin.mod13.bwt.BWindowAdapter;
   import au.edu.swin.synergy.plugin.mod13.bwt.BWindowEvent;
   import au.edu.swin.synergy.plugin.mod13.event.BGetFilesCE;

   import au.edu.swin.synergy.plugin.editmanager.event.BRegisterUndoCE;

   import au.edu.swin.synergy.plugin.prefs.event.BAddPrefsCE;

    import au.edu.swin.synergy.plugin.dialect.BString;
	import au.edu.swin.synergy.plugin.dialect.BDialect;
	import au.edu.swin.synergy.plugin.dialect.event.BDialectChangeCE;

   import au.edu.swin.synergy.plugin.diagram.BViewport;
   import au.edu.swin.synergy.plugin.diagram.BViewWindow;
   import au.edu.swin.synergy.plugin.diagram.BDrawablePalette;
   import au.edu.swin.synergy.plugin.diagram.event.BRegisterViewportCE;

   import au.edu.swin.synergy.plugin.command.BOnCommand;
   import au.edu.swin.synergy.plugin.command.event.BRegisterCmdCE;

	import au.edu.swin.synergy.plugin.dialect.BString;

	import au.edu.swin.synergy.plugin.dialect.BDialect;
	import au.edu.swin.synergy.plugin.command.event.BStandardOutCE;


   import au.edu.swin.synergy.lib.BStringList;

   import au.edu.swin.synergy.plugin.metamodeller.BMetaModel;
   import au.edu.swin.synergy.plugin.metamodeller.BMetaElement;

   import au.edu.swin.synergy.plugin.packager.BPackageMenu;
   import au.edu.swin.synergy.plugin.packager.BPackageModel;
   import au.edu.swin.synergy.plugin.packager.BPackagePanel;
   import au.edu.swin.synergy.plugin.packager.BPackageNodeDiagram;

   import au.edu.swin.synergy.plugin.packager.event.BOpenPackageCE;
  import au.edu.swin.synergy.lib.io.BDataFile;
 

	import au.edu.swin.synergy.plugin.packager.BPackageArcEditor;
	import au.edu.swin.synergy.shapes.BTextArea;
	import au.edu.swin.synergy.plugin.modeller.BModel;
   import au.edu.swin.synergy.plugin.modeller.BModelEditor;
   import au.edu.swin.synergy.math.BScalarPoint;

	import au.edu.swin.synergy.lib.io.BSaveable;
	import au.edu.swin.synergy.lib.io.BDataFile;
	import au.edu.swin.synergy.lib.io.BFileFilter;
	import au.edu.swin.synergy.lib.BTreeUtil;
	import au.edu.swin.synergy.lib.BTreeNode;


   import au.edu.swin.synergy.plugin.diagram.BDrawable;

   import au.edu.swin.synergy.debug.Debug;

   import au.edu.swin.synergy.plugin.mod13.bwt.BDialog;
   import au.edu.swin.synergy.plugin.mod13.bwt.BDialogDone;


/**
 * class BPackagePlugin
 *
 * Main controller for the packager plugin.
 * This plugin allows the user to create and
 * edit packages for use with the modeller plugin.
 *
 * @author Imron Alston
 * @date 12/8/99
 *
 * Please complete these missing tags
 * @copyright
 */
   public class BPackagePlugin extends BPlugin
   {
   

   public static final String kNodeTab = "Nodes";
      public static final String kArcTab = "Arcs";
      public static final String kTerminatorTab = "Terminators";
	  

		private static final String kNewPackageStr = "newpackage";
		private static final String kEditPackageStr = "editpackage";
		private static final String kAddPNodeStr = "pkgaddnode";



	  private BPackageMenu menu = null;
      private BPackageModel pModel = null;

      private BPackagePanel packagePanel = null;
      private BViewport nodeEditor = null;
	  private BViewWindow nodeWindow = null;

      private BPackageNodeDiagram nodeDiagram = null;
	  private BPackageArcEditor arcEditor = null;
	  private BPackageTerminatorDiagram terminatorDiagram = null;
	  private BViewport terminatorEditor = null;
	  private BViewWindow terminatorWindow = null;

      private BPackageTree packageTree = null;

      private JMenuItem newPackageMenuItem = null;

	  private BString filterString = null;

	  private BNewTerminatorPanel newTerminatorPanel = null;


		private BMetaModel baseMetaModel = null;

	public BString kPkgExtension;

    /**
     * Indicates whether the gui was initialised
     */
      private boolean isInitialised = false;

    /**
     * Indicates whether the window is currently showing
     */
      private boolean isShowing = false;


    /**
     * This is the object that handles node selections of the tree
     */
      private BTreeListener treeListener = null;

    /**
     * This is called by the Kernel when the package plugin
     * is first loaded. It will register the main menu items
     * for the user to invoke.
     *
     * @pre The plugin has been loaded
     * @post The menus and menu items are registered with the window manager (if it's loaded)
     */
      public void setup(BStringList params)
      {
         BCommandEvent tmpCE = null;

        //Create the menu and menu items
         this.menu = new BPackageMenu( this );

		 tmpCE = new BRegisterCmdCE( this, kNewPackageStr, new BOnNewPackageCommand() );
		 this.dispatchEvent( tmpCE );
		 tmpCE = null;


		 tmpCE = new BRegisterCmdCE( this, kEditPackageStr, new BOnEditPackageCommand() );
		 this.dispatchEvent( tmpCE );
		 tmpCE = null;

		 tmpCE = new BRegisterCmdCE( this, kAddPNodeStr, new BOnAddPNodeCommand() );
		 this.dispatchEvent( tmpCE );
		 tmpCE = null;

		 this.filterString = new BString( this, "filterdesc" );
		kPkgExtension = new BString( this, "fileextension" );
            }

    /**
     * Return a list of plugin dependancies
	 *
     * @return a list of plugins such as "au.edu.swin.synergy.plugin.mod13.BWindowManager"
	 * or null if there are no dependancies
     */

    public BStringList getDependancies()
	{
		BStringList result = new BStringList();
		result.add("au.edu.swin.synergy.plugin.mod13.BWindowManager");
		return result;
	}

    /**
     * This will be called to remove all of the Package Editor interface
     * components, primarily when the user clicks on the close window button
     * in the top right hand corner of the window.
     */
      protected void doHide()
      {
         BRemovePanelCE removePackageCE = null;
         BCloseWindowCE closeWindowCE = null;

         this.packagePanel.unregisterUndomanagers();

        //Create all the events
         removePackageCE = new BRemovePanelCE( this, this.packageTree, BAddPanelCE.kLeft );
         closeWindowCE = new BCloseWindowCE(this, this.packagePanel);

        //Dispatch the events to the window manager
         this.dispatchEvent( removePackageCE );
      //        this.dispatchEvent(closeWindowCE);


		removePackageCE = new BRemovePanelCE( this, this.packageTree, BAddPanelCE.kLeft );
        closeWindowCE = new BCloseWindowCE(this, this.packagePanel);

        //Dispatch the events to the window manager
         this.dispatchEvent( removePackageCE );


        //Set the showing state to true
        this.isShowing = false;
      }

    /**
     * This will create all of the panels and so forth
     * on the first call only. If the gui has already been
     * initialised once, it will return without doing it again
     *
     * @return True if initialisation was succesfull, false otherwise
     */
      private boolean doGUIInitialisation()
      {
		BRegisterViewportCE registerViewportCE = null;
        BRegisterUndoCE registerUndoCE;
        //Check to see if we've already been initialised
         if (!this.isInitialised && this.pModel != null)
         {
            //Create all the items
            this.packagePanel = new BPackagePanel();

            this.nodeDiagram = new BPackageNodeDiagram();
            this.nodeEditor = new BViewport( this );
			this.nodeWindow = new BViewWindow( this.nodeEditor );

			this.terminatorDiagram = new BPackageTerminatorDiagram();
			this.terminatorEditor = new BViewport( this );
			this.terminatorWindow = new BViewWindow( this.terminatorEditor );

			// Just give this a shot.  Hopefully the CC would be called and completed b4
			// the viewport is shown.
            this.packagePanel.add( BPackagePlugin.kNodeTab, this.nodeWindow );//Editor );

			this.arcEditor = new BPackageArcEditor ( this );
			this.packagePanel.add ( BPackagePlugin.kArcTab, this.arcEditor );
			this.packagePanel.add( BPackagePlugin.kTerminatorTab, this.terminatorWindow );

            this.packageTree = new BPackageTree( this.pModel );

            this.treeListener = new BTreeListener();
            this.packageTree.addTreeSelectionListener(this.treeListener);


            //Set the initialised status
            this.isInitialised = true;

			registerViewportCE = new BRegisterViewportCE( this, this.nodeEditor );
			this.dispatchEvent( registerViewportCE );

			registerViewportCE = new BRegisterViewportCE( this, this.terminatorEditor );
			this.dispatchEvent( registerViewportCE );

            //Register the undo managers
            registerUndoCE = new BRegisterUndoCE(this.nodeEditor);
            registerUndoCE.setCompletionObject(new BUndoCompletion(this.nodeEditor, kNodeTab));
            this.dispatchEvent(registerUndoCE);


            registerUndoCE = new BRegisterUndoCE(this.terminatorEditor);
            registerUndoCE.setCompletionObject(new BUndoCompletion(this.terminatorEditor, kTerminatorTab));
            this.dispatchEvent(registerUndoCE);
         }

//		 this.packageTree.requestFocus();

         //Indicate whether we were succesfull or not
         return this.isInitialised;
      }


    /**
     * This will be called to show all of the Package Editor interface
     * components, primarily when the user selects the package editor from
     * the Package menu or when the user creates a new package.
     */
      protected void doDisplay()
      {
         BAddPanelCE addPackageCE = null;
		 BSelectPanelCE selectPanel = null;
         BAddWindowCE addWindowCE = null;
         BMainWindowListener windowListener = null;

        //Make sure the panels are initialised
         if (this.doGUIInitialisation())
         {
            //Only show if not already on the screen
             if (!this.isShowing)
             {
                Debug.doPrintln("Re-creating all the panels and stuff...", Debug.kWarningLevel);

                //Create the window listener
                windowListener = new BMainWindowListener();


				//Create all the events
				addPackageCE = new BAddPanelCE( this, this.packageTree, new BString(this, "PackageTree"), BAddPanelCE.kLeft );
				addWindowCE = new BAddWindowCE( this, this.packagePanel, new BString(this, "packagetitle"));

				//Add the window listener to the main window
				addWindowCE.addWindowListener(windowListener);
				addWindowCE.setCloseAction(BAddWindowCE.kDoNothingOnClose);

				//Dispatch the events to the window manager
				this.dispatchEvent( addPackageCE );
				this.dispatchEvent( addWindowCE );

                //Set the showing state to true
                this.isShowing = true;
             }
         }

		selectPanel = new BSelectPanelCE( this, this.packageTree, BAddPanelCE.kLeft );
		this.dispatchEvent( selectPanel );


		 this.packageTree.setModel( this.pModel );
		TreePath tmp = new TreePath( BTreeUtil.getPathToRoot((BTreeNode)this.pModel.getChildAt( BPackageModel.kNodeBranch ), 0 ));

		 this.packageTree.setSelectionPath( tmp );
		 this.nodeEditor.setDiagram( this.nodeDiagram );
		 this.terminatorEditor.setDiagram( this.terminatorDiagram );
      }

		/**
		 * Sets the meta model this package will be based on to
		 * the model specified.
		 *
		 * @param	newMetaModel	The meta model to base the package on
		 */
/*
   	public void setMetaModel(BMetaModel newMetaModel)
   	{
   		this.baseMetaModel = newMetaModel;
        this.isInitialised = false;

        //If there package model is already created, set the new meta model
        if (this.pModel != null)
        {
            this.pModel.setMetaModel(this.baseMetaModel);
        }
   	}
/**/

    /**
     * This will set the name of the package to
     * the value specified. This will be reflected
     * in the package tree whether it is currently
     * showing or not.
     *
     * @param   newPackageName  The new name for the package
     */
/*
      public void setName(String newPackageName)
      {
         this.packageName = newPackageName;

        //If the model has already been created...
         if (this.pModel != null)
         {
            //Set the package name
            this.pModel.setName(this.packageName);
         }
      }
/**/

    /**
     * Please complete the missing tags for onBCommandEvent
     * @param
     * @return
     * @pre
     * @post
     */

      public void onBCommandEvent( Object source, BCommandEvent event )
      {
		if ( event instanceof BDialectChangeCE )
		{
			doDialect ();
		}
		else if( event instanceof BOpenPackageCE)
		{
			BOpenPackageCE openEvent = (BOpenPackageCE) event;
			File editFile = getOpenPackageFile();

			if(editFile != null)
			{
				openEvent.setFileName(editFile.getPath());
			}

			event.doComplete(BCommandComplete.kSuccess);
		}
      }

	/**
	* Go through all classes and change dialect according to locale.
	*/
	public void doDialect ()
	{
		filterString = new BString( this, "filterdesc" );
		kPkgExtension = new BString( this, "fileextension" );
	}

    /**
     * This will make sure the node editor has the appropriate
     * BDrawable to edit when a package node is selected in the tree.
     *
     * @param   selectedElement The element selected
     */
      private void doNodeSelect(BPackageModelElement selectedElement)
      {
         BDrawable selectedDrawable = selectedElement.getBDrawable();

        //Determine the type of item that was selected
         if (selectedElement.getNodeType() == BPackageModelElement.kPackageNode)
         {
            BPackagePlugin.this.nodeDiagram.setPackageNode( (BPackageNode)selectedDrawable );
            BPackagePlugin.this.nodeEditor.setDiagram( BPackagePlugin.this.nodeDiagram );
         }
         else if (selectedElement.getNodeType() == BPackageModelElement.kPackageArc)
         {

            /*BPackagePlugin.this.arcDiagram.setPackageNode( (BPackageArc)selectedGroup );
            BPackagePlugin.this.arcEditor.setDiagram( BPackagePlugin.this.nodeDiagram );//*/
         }
         else if (selectedElement.getNodeType() == BPackageModelElement.kPackageTerminator)
         {
            /*BPackagePlugin.this.terminatorDiagram.setPackageNode( (BPackageTerminator)selectedGroup );
            BPackagePlugin.this.terminatorEditor.setDiagram( BPackagePlugin.this.nodeDiagram );//*/
         }
      }


	private void doNodeSelect( String nodeName )
	{
		Object obj = this.pModel.getPackageNodeByName( nodeName );

		if ( obj instanceof BPackageNode )
		{
			this.doNodeSelect( (BPackageNode)obj, BPackageNodeDiagram.kNoIndex );
		}
   	}


	  private void doNodeSelect(BPackageNode pNode, int index )
      {
		 this.nodeDiagram.setPropIndex( index );
		 this.packagePanel.setSelectedComponent( this.nodeWindow );//Editor );
         this.nodeDiagram.setPackageNode( pNode );
         this.nodeEditor.setDiagram( this.nodeDiagram );
      }

	  private void doNodeBranchSelect()
	  {
			this.nodeDiagram.setPropIndex( BPackageNodeDiagram.kNoIndex );
	  		this.packagePanel.setSelectedComponent( this.nodeWindow);//Editor );
	  }

	private void doNodePropertySelect( BTextArea pNode )
	{
		int index;

		index = ((BTreeNode)pNode.getParent()).getIndexOf( pNode );				
		this.doNodeSelect( (BPackageNode)pNode.getParent(), index );
	}


	  private void doArcSelect( String metaArcName )
	  	{
	  		Object obj = this.pModel.getPackageArcByName( metaArcName );

	  		if ( obj instanceof BPackageArc )
	  		{
	  			this.doArcSelect( (BPackageArc) obj, BPackageNodeDiagram.kNoIndex );
	  		}
			else
			{
				this.arcEditor.setPackageArc( null );
			}
	  	}

	  	private void doArcSelect( BPackageArc pArc, int index )
	  	{
			Debug.doPrintln ( "SETTING INDEX IN PACKAGE ARC to "+index );
			this.arcEditor.setPropIndex ( index );
	  		this.packagePanel.setSelectedComponent( this.arcEditor );
	  		this.arcEditor.setPackageArc( pArc );
		}



	private void doArcBranchSelect()
	{
		this.arcEditor.setPropIndex ( BPackageNodeDiagram.kNoIndex );
		this.packagePanel.setSelectedComponent( this.arcEditor );
		this.arcEditor.setPackageArc( null );
	}

	private void doArcPropertySelect( BTextArea pArc )
	{
		Debug.doPrintln("BPackagePlugin::doPackageArcSelect() -- NYI! BUT IT IS NOW", Debug.kWarningLevel );
		int index;

		index = ((BTreeNode)pArc.getParent()).getIndexOf( pArc );				
		this.doArcSelect( (BPackageArc)pArc.getParent(), index );
	}


/*			registerViewport = new BRegisterViewportCE( this, modelView );
			addModelCE = new BAddWindowCE( this, modelView, new BString(this, "modeleditortitle"));
			addModelCE.addWindowListener( modelView );

			dispatchEvent( registerViewport );
			dispatchEvent( addModelCE );*/
	private void doTerminatorSelect( String terminatorName )
	{
		Object obj = this.pModel.getPackageTerminatorByName( terminatorName );

		if ( obj instanceof BPackageTerminator )
		{
			this.doTerminatorSelect( (BPackageTerminator) obj );
		}
	}

	private void doTerminatorSelect( BPackageTerminator terminator )
	{
		this.packagePanel.setSelectedComponent( this.terminatorWindow );//Editor );
		this.terminatorDiagram.setTerminator( terminator );
		this.terminatorEditor.setDiagram( this.terminatorDiagram );
	}

	private void doTerminatorBranchSelect()
	{
		this.packagePanel.setSelectedComponent( this.terminatorWindow );
	}






	/**
	 * This will create a new package, with the specified name
	 * using the specified metamodel
	 *
	 * @param String name - the name of the package
	 * @param String metaModelFile - the file containing the metamodel
	 *
	 * @return reference to a new package, or null if there was an error
	 */
	public BPackageModel doCreateNewPackage( String name, String metaModelFileName )
	{
		BPackageModel result = null;
		BMetaModel metaModel = null;
		BDataFile dataFile = null;
		BStandardOutCE errorMsg = null;

		try
		{
			dataFile = new BDataFile( metaModelFileName );
			dataFile.openFileForRead();
			try
			{
				metaModel = (BMetaModel)dataFile.autoLoad();
			}
			catch( Exception e )
			{
			}
			finally
			{
				dataFile.close();
			}
		}
		catch( Exception e )
		{
					
		}

		//check to see if an error occured..
		if ( metaModel == null )
		{
			Debug.doPrintln("Error loading metamodel - " + metaModelFileName, Debug.kWarningLevel );
			errorMsg = new BStandardOutCE(this , BDialect.getString( this, "fileopenerror"));
			errorMsg.setMessageType( BStandardOutCE.kError );			
			this.dispatchEvent( errorMsg );
			return result;
		}

		result = new BPackageModel( metaModel, name );

		result.saveToFile( name + "." + kPkgExtension );


		return result;
	}

	public void doSavePackage( )
	{
		if ( this.pModel != null )
		{
			Debug.doPrintln("Saving package - " + this.pModel.getName() + "." + kPkgExtension);
			this.pModel.saveToFile( this.pModel.getName() + "." + kPkgExtension );
		}

	}


	public void doNewPackage()
	{
		BNewPackageDialog newDialog = new BNewPackageDialog(BPackagePlugin.this);
        BAddWindowCE windowCE = new BAddWindowCE( this, newDialog, new BString(this, "newpackage"));

        //Set the state of the window
        windowCE.setDialog(true);


        BPackagePlugin.this.dispatchEvent( windowCE);
	}

	public void doEditPackage( )
	{
		/*JFileChooser fileChooser = new JFileChooser( "." );
		BFileFilter filter = new BFileFilter( kPkgExtension.toString(), filterString.toString() );

		fileChooser.setFileFilter( filter );

		if ( fileChooser.showOpenDialog(this.packagePanel) == JFileChooser.APPROVE_OPTION )
		{
			this.doEditPackage( fileChooser.getSelectedFile().getName() );
		}*/

		// get out of the AWT thread...
		new Thread(new DoEditPackage()).start();
	}

	class DoEditPackage implements Runnable
	{
		public void run()
		{
			File editFile = getOpenPackageFile();
			if(editFile != null)
			{
				doEditPackage( editFile.getName() );
			}
		}
	}

	/**
	 * Edits the package specified by the packageFileName
	 * @param String packageFileName - the file name of the package to edit
	 *
	 */
	public void doEditPackage( String packageFileName )
	{
		Debug.doPrintln("Loading package - " + packageFileName );

		this.pModel = BPackageModel.loadFromFile( packageFileName );

/*		BDataFile dataFile = new BDataFile( packageFileName );

		dataFile.openFileForRead();
		try
		{
			this.pModel = (BPackageModel)dataFile.autoLoad();
		}
		finally
		{
			dataFile.close();
		}*/


		if ( this.pModel == null )
		{
			Debug.doPrintln("Package couldn't get loaded!", Debug.kWarningLevel);
		}

		this.doDisplay();
	}

	public void doAddPNode( String metaNodeName, BScalarPoint pt )
	{
		Debug.doPrintln("adding pnode" + metaNodeName );

		if ( this.nodeDiagram != null )
		{
			this.nodeDiagram.createDrawable( metaNodeName, pt );
		}
	}

	public void doAddTerminator( String name )
	{
		Debug.doPrintln("About to add a new terminator :)");


		BPackageTerminator term = new BPackageTerminator( name );

		this.pModel.addPackageTerminator( term );





	}





    /**
     * This will listen for the window events on the main
     * package editor window on so that we can handle
     * program flow appropriately.
     *
     * @author Tristan Austin
     */
      private class BMainWindowListener extends BWindowAdapter
      {
        /**
         * When the window is closing, need to make sure we can
         * close off everything else as well.
         *
         * @param   windowEvent The window event indicating what's going on
         */
         public void windowClosing(BWindowEvent windowEvent)
         {
            Object source = windowEvent.getWindowContent();

            //Make sure it was the main window that was closing
            if (source == BPackagePlugin.this.packagePanel)
            {
               BPackagePlugin.this.doHide();
            }
         }

         /**
          * Need to disable the menus when the window is closed
          * as well.
          *
          * @param  windowEvent The window event
          */
         public void windowClosed(BWindowEvent windowEvent)
         {
            BPackagePlugin.this.menu.doMenuEnabling(false);
         }

		/**
		 * When the window is deactivated, that is the user has selected
		 * another window or it has simply lost the focus, this method
		 * is called to update the notation menu items.
		 *
		 * @param	windowEvent	The event fired
		 */
		 public void windowDeactivated(BWindowEvent windowEvent)
		 {
				BPackagePlugin.this.menu.doMenuEnabling(false);
		 }

		 public void windowActivated( BWindowEvent windowEvent )
		 {
			BPackagePlugin.this.nodeEditor.refreshPalette();
			BPackagePlugin.this.menu.doMenuEnabling(true);
		 }
      }

    /**
     * This will listen to the JTree and make sure the
     * editor reflects the currently selected
     */
      private class BTreeListener implements TreeSelectionListener
      {
        /**
         * Called whenever the value of the selection changes.
         *
         * @param selectionEvent The event that characterizes the change.
         */
         public void valueChanged(TreeSelectionEvent selectionEvent)
         {
            TreePath selectedPath = selectionEvent.getPath();
            Object selectedNode = selectedPath.getLastPathComponent();
            BPackageModelElement selectedElement = null;

            //Make sure the item selected was a node
            if (selectedNode instanceof BPackageModelElement)
            {
               BPackagePlugin.this.doNodeSelect((BPackageModelElement)selectedNode);
            }
			else if ( selectedNode instanceof BPackageNode )
			{
				BPackagePlugin.this.doNodeSelect((BPackageNode)selectedNode, BPackageNodeDiagram.kNoIndex);
			}
			else if ( selectedNode instanceof BPackageArc )
			{
				BPackagePlugin.this.doArcSelect((BPackageArc)selectedNode, BPackageNodeDiagram.kNoIndex);
			}
			else if ( selectedNode instanceof BPackageTerminator )
			{
				BPackagePlugin.this.doTerminatorSelect( (BPackageTerminator)selectedNode);
			}
			else if ( selectedNode instanceof BPackageModelBranch )
			{
				switch( BPackagePlugin.this.pModel.getIndexOf( selectedNode ) )
				{
					case BPackageModel.kNodeBranch:
						BPackagePlugin.this.doNodeBranchSelect();
						break;
					case BPackageModel.kArcBranch:
						BPackagePlugin.this.doArcBranchSelect();
						break;
					case BPackageModel.kTerminatorBranch:
						BPackagePlugin.this.doTerminatorBranchSelect();
						break;
				}
			}
			else if ( selectedNode instanceof BTextArea )
			{
				if ( ((BTextArea)selectedNode).getParent() instanceof BPackageNode )
				{
					BPackagePlugin.this.doNodePropertySelect( (BTextArea)selectedNode );
				}
				else if ( ((BTextArea)selectedNode).getParent() instanceof BPackageArc )
				{
					Debug.doPrintln ( "PROPERTY HIT! JUST SO HAPPENS TO BELONG TO AN ARC" );
					BPackagePlugin.this.doArcPropertySelect( (BTextArea)selectedNode ) ;
				}
				else
				{
					Debug.doPrintln("Parent of BTextArea is " + ((BTextArea)selectedNode).getParent() );
				}
			}
			else
			{
				Debug.doPrintln( "selected node is of type " + selectedNode.getClass().getName(), Debug.kWarningLevel );
			}
         }
      }

	  private class BOnNewPackageCommand implements BOnCommand
	  {
		public int onCommand( BStringList params, InputStream in, PrintStream out )
		{
			BPackagePlugin.this.doCreateNewPackage( params.get(1), params.get(2) );
			return 0;
		}

		public String getHelp( BStringList params )
		{
			return "Creates a new package.\nUsage: " + BPackagePlugin.kNewPackageStr + " <packagename> <metamodelfile>";
		}
	  }

	  private class BOnEditPackageCommand implements BOnCommand
	  {
		public int onCommand( BStringList params, InputStream in, PrintStream out )
		{
			BPackagePlugin.this.doEditPackage( params.get(1));
			return 0;
		}

		public String getHelp( BStringList params )
		{
			return "Edits a package.\nUsage: " + BPackagePlugin.kEditPackageStr + " <packagefile>";
		}
	  }

	  private class BOnAddPNodeCommand implements BOnCommand
	  {
		private BScalarPoint tmpPt = new BScalarPoint();

		public int onCommand( BStringList params, InputStream in, PrintStream out )
		{
			if ( params.getCount() > 3 )
			{
				tmpPt.setLocation( Integer.parseInt(params.get(2)), Integer.parseInt(params.get(3) ) );
				BPackagePlugin.this.doAddPNode( params.get(1), tmpPt);
			}
			return 0;
		}

		public String getHelp( BStringList params )
		{
			return "Adds a package node to the current package.\nUsage: " + BPackagePlugin.kAddPNodeStr + " <metanodename> <x coord> <y coord>";
		}
	  }





	  // open a package file...
	  private File getOpenPackageFile()
	  {
		BFileFilter filter = new BFileFilter( BDialect.getString ( this, "fileextension" ), filterString.toString() );
		BGetFilesCE getFile = new BGetFilesCE(".");
		getFile.setTitle(filterString.toString());
		getFile.setFileFilter(filter);
		BBlockingComplete complete = dispatchEventAndWait(getFile);

		if(complete.getStatus() == BCommandComplete.kSuccess)
		{
			getFile = (BGetFilesCE) complete.getEvent();
			return getFile.getSelectedFile();
		}
		else
		{
			return null;
		}
	  }

     /**
       * Gets the edit support from the edit manager and sets it
       * in the specified viewport.
       *
       * @author Tristan Austin
       */
      class BUndoCompletion extends BCommandComplete
      {
            private BViewport viewport;

            private String tab;

            /**
             * Create the completion object for the particular viewport
             *
             * @param   viewport    The viewport he undo support is for
             */
            public BUndoCompletion(BViewport viewport, String tab)
            {
                this.viewport = viewport;
                this.tab = tab;
            }

            /**
             * This will set the undo support for the viewports
             *
             * @param The event object
             * @param the return status
             */
            public void doComplete( BCommandEvent event, int status )
            {
                BRegisterUndoCE registerUndoCE = (BRegisterUndoCE)event;
                this.viewport.setEditSupport(tab, registerUndoCE.getUndoSupport(), registerUndoCE.getUndoListener());
            }
      }
	  


   }
