
//$Header: /teamproj/cvsroot/teamb/bkasrc/au/edu/swin/synergy/plugin/packager/BPackageTerminator.java,v 1.12 1999/10/15 05:06:01 tp079479 Exp $


/**
 *
 * drawable class for the terminators......................
 * @author Imron Alston
 * @copyright Team Synergy 1999
 *
 */

package au.edu.swin.synergy.plugin.packager;


import au.edu.swin.synergy.plugin.diagram.BDrawable;
import au.edu.swin.synergy.plugin.diagram.BView;
import au.edu.swin.synergy.debug.Debug;

import au.edu.swin.synergy.lib.BTreeNode;
import au.edu.swin.synergy.lib.io.BDataFile;
import au.edu.swin.synergy.lib.io.BSaveable;

import au.edu.swin.synergy.math.BScalarPoint;
import au.edu.swin.synergy.math.BScalarRect;
import au.edu.swin.synergy.math.BScalar;

import java.util.Vector;
import java.awt.*;
import java.awt.geom.*;


public class BPackageTerminator extends BDrawable implements BTreeNode, BSaveable, BView
{
	//a vector of all the groups making up this package node..
	    private Vector drawables = null;

		private Object parent = null; //the parent in the tree...
		private BScalarPoint tmpPoint = null;

		private BScalarRect viewBounds = null;
		private Rectangle xformedBounds = null;

		private boolean meaDummy;
	    /**
	     * Please complete the missing tags for BPackageTerminator
	     * @param
	     * @return
	     * @pre
	     * @post
	     */


	    public BPackageTerminator( String name )
	    {
			this( 0, 0, name  );
	    }
	    /**
	     * Please complete the missing tags for BPackageTerminator
	     * @param
	     * @return
	     * @pre
	     * @post
	     */


		 /**
		  * Default constructor for BSaveable
		  */
		 public BPackageTerminator()
		 {
		 	this(0, 0, null);
		 }

	    public BPackageTerminator( int x, int y, String name )
	    {
			super();

			int i, size;
			Vector props = null;

	        this.drawables = new Vector();

			this.pos.setLocation( x, y );

			this.tmpPoint= new BScalarPoint();
			this.viewBounds = new BScalarRect();
			this.xformedBounds = new Rectangle();

			this.name = name;

			this.meaDummy = false;
	    }

		protected BPackageTerminator( BPackageTerminator pTerm )
		{
			this( pTerm.name );
			this.copy( pTerm );
			this.parent = null;
		}

		public void setDummyStatus ( boolean dummy )
		{
			this.meaDummy = dummy;
		}
	
		public boolean isaDummy ()
		{
			return this.meaDummy;
		}

		public final Rectangle getXFormedBounds()
		{
			return this.xformedBounds;
		}

		/**
		 * Transforms the coordinates of the drawable object
		 * to a new coordinate space, as defined by the
		 * viewport and parent pos.
		 *
		 * @param BViewport viewport - the viewport that this object is going to be drawn in
		 * @param Point parentPos - coordinates of any parent object, but this time in view coords.
		 */
		public void transform( BView viewport, BScalarPoint parentPos, int frameCounter )
		{
			int i, size;
			BDrawable cur = null;
			BScalar zoom = viewport.getOOZ();

			if ( this.lastFrame != frameCounter )
			{

				this.ooz = zoom;
				this.z = viewport.getOOZ();
				this.halfWH = parentPos;

				size = this.drawables.size();

				this.tmpPoint.setLocation( 0, 0 );

				for ( i = 0; i < size; i++ )
				{
					cur = (BDrawable)this.drawables.elementAt( i );
					cur.transform( this, this.tmpPoint, frameCounter );
				}

				//transform the bounds to viewspace...
				this.viewBounds.setBounds( this.bounds );
				this.viewBounds.scale( zoom );
				this.viewBounds.incXY( parentPos );
				this.viewBounds.getBounds( this.xformedBounds );

				this.lastFrame = frameCounter;
			}

		}

		/**
		 * Renders the transformed coordinates of the drawable
		 * object to a Graphics2D
		 *
		 * @param Graphics2D g2 - the place to render the object to.
		 */
		public void render( Graphics2D g2 )
		{
			int i, size;
			BDrawable cur = null;

			if ( this.meaDummy == false )
			{
				size = this.drawables.size();

				for ( i = 0; i < size; i++ )
				{
					cur = (BDrawable)this.drawables.elementAt( i );
					cur.render( g2 );
				}

				if ( this.isSelected() )
				{

					renderOutlineAndSizers( g2 );
				}
			}
		}

		public void renderOutlineAndSizers( Graphics2D g2 )
		{
			int x, y, w, h;

			x = this.xformedBounds.x - kSizerHalfW;
			y = this.xformedBounds.y - kSizerHalfH;
			w = kSizerHalfW * 2;
			h = kSizerHalfH * 2;

			g2.setColor( Color.green );

			g2.fillRect( x, y, w, h );

			x += this.xformedBounds.width;
			g2.fillRect( x, y, w, h );

			y += this.xformedBounds.height;
			g2.fillRect( x, y, w, h );

			x -= this.xformedBounds.width;
			g2.fillRect( x, y, w, h );

		}



		/**
		 * Checks to see if a point has hit the transformed bounds
		 * of this object
		 * @param Point pt - the point to check the hit against..
		 * @return kNotHit - not hit
		 * @return kHitBounds - hit the main bounds
		 */
		public int checkXFormBounds( Point pt )
		{
			return this.xformedBounds.contains( pt ) ? kHitBounds : kNotHit;
		}


		/**
		 * Checks to see if a sizer has been hit by a point
		 * Works on xformed values.
		 * Subclasses should determine appropriate places for
		 * the sizer..
		 *
		 * @param Point pt - the point to check the hit against
		 * @return kNotHit - not hit
		 * @return kHitSizer + XX hit the XX sizer where XX is any number.
		 */
		public int checkSizerHit( Point pt )
		{
			int x1, y1, x2, y2;

			x1 = this.xformedBounds.x - kSizerHalfW;
			y1 = this.xformedBounds.y - kSizerHalfH;
			x2 = x1 + kSizerHalfW * 2;
			y2 = y1 + kSizerHalfH * 2;

			if ( pt.x > x1 && pt.x < x2 && pt.y > y1 && pt.y < y2 ) return kSizerNorthWest;

			x1 += this.xformedBounds.width;
			x2 += this.xformedBounds.width;

			if ( pt.x > x1 && pt.x < x2 && pt.y > y1 && pt.y < y2 ) return kSizerNorthEast;

			y1 += this.xformedBounds.height;
			y2 += this.xformedBounds.height;

			if ( pt.x > x1 && pt.x < x2 && pt.y > y1 && pt.y < y2 ) return kSizerSouthEast;

			x1 -= this.xformedBounds.width;
			x2 -= this.xformedBounds.width;

			if ( pt.x > x1 && pt.x < x2 && pt.y > y1 && pt.y < y2 ) return kSizerSouthWest;

			return kNotHit;
		}


		/**
		 * called when the drawable is about to be resized..
		 *
		 * @param int sizerNum - a sizerNum returned from checkSizerHit
		 */
		public void startResize( int sizerNum )
		{
		}

		/**
		 * Called as the drawable is being resized
		 *
		 */
		public void dragResize( BScalarPoint deltaXY )
		{
		}

		/**
		 * called when the drawable has finished being resized..
		 *
		 */
		public void stopResize()
		{
		}


		/**
		 * Creates and returns a new instance of the BDrawable object
		 *
		 * @return a new instance of this BDrawable object.
		 */
		public BDrawable newInstance()
		{
			BPackageTerminator temp = new BPackageTerminator( this );
			temp.updateBounds();
			return temp;
		}

		/**
		 * Loads the BDrawable from a file
		 * @param BDataFile file - the file to load from
		 * @return boolean - true on success, false on failure.
		 */
		public boolean load(BDataFile file)
		{
			Debug.doPrintln("BPackageTerminator load");
			super.load(file);


			while(true)
			{
				BDrawable object = (BDrawable)file.autoLoad();
				if(object == null)
				{
					Debug.doPrintln("Load Finished");
					break;
				}
				drawables.add( object );
			}
			return true;
		}

		/**
		 * Saves the BDrawable to a file
		 * @param BDataFile file - the file to save to
		 * @return boolean - true on success, false on failure.
		 */
		public boolean save(BDataFile file)
		{
			super.save( file );
			Debug.doPrintln("BPackageTerminator save");

			for ( int i = 0; i < drawables.size(); i++)
			{
				file.save( (BSaveable)drawables.get(i) );
			}
			return true;
		}

		/**
		 * updates the bounding region of the drawable
		 * Called when something requires the bounds of
		 * the drawable to be updated.  Subclasses should
		 * determine a suitable way to update themselves.
		 */
		public void updateBounds()
		{
			int i, size;
			BDrawable cur = null;
			size = this.drawables.size();

			for ( i = 0; i < size; i++ )
			{
				cur = (BDrawable)this.drawables.elementAt( i );
				if ( i == 0 )
				{
					this.tmpBounds.setBounds( cur.getBounds() );
					this.tmpBounds.incXY( cur.getPos() );
					this.bounds.setBounds( this.tmpBounds );
					Debug.doPrintln("Initialising the bounds : " + this.bounds);
				}
				else
				{
					this.tmpBounds.setBounds( cur.getBounds() );
					this.tmpBounds.incXY( cur.getPos() );
					this.bounds.union( this.tmpBounds );
					Debug.doPrintln("Updating the bounds : " + this.bounds );
				}


			}

	//		this.bounds.incXY( this.pos );


			Debug.doPrintln( "The new bounds are " + this.getBounds() );


		}


	    public Vector getDrawables()
	    {
	        return this.drawables;
	    }

	    public void addDrawable( BDrawable drawable )
	    {
			Debug.doPrintln( "added drawable bounds " + drawable.getBounds() );
	        this.drawables.add( drawable );
			this.tmpBounds.setBounds( drawable.getBounds() );
			this.tmpBounds.incXY( drawable.getPos() );
			this.bounds.union( this.tmpBounds );

			Debug.doPrintln( "The new bounds are " + this.getBounds() );

	    } 

		public void removeDrawable( BDrawable drawable )
		{
			this.removeDrawable( this.drawables.indexOf( drawable ) );
		}

		public void removeDrawable( int index )
		{
			if ( index >= 0 )
			{
				this.drawables.removeElementAt( index );
			}
		}

		public int getDrawableIndex( BDrawable drawable )
		{
			return this.drawables.indexOf( drawable );
		}

			/*
	 * this is a really inefficient way to do this
	 * however the selection vector is only small, 
	 * and i'm in a hurry.
	 */
	public void bringSelectionToFront( Vector selection )
	{
		int i, size;
		size = selection.size();
		for ( i = 0; i < size; i++ )
		{
			this.drawables.remove( selection.elementAt( i ) );
		}

		for ( i = size-1; i >= 0; i-- )
		{
			this.drawables.add( selection.elementAt( i ) );
		}
	}

	/*
	 * this is a really inefficient way to do this
	 * however the selection vector is only small, 
	 * and i'm in a hurry.
	 */
	public void sendSelectionToBack( Vector selection )
	{
		int i, size;
		size = selection.size();

		for ( i = 0; i < size; i++ )
		{
			this.drawables.remove( selection.elementAt( i ) );
		}

		for ( i = size-1; i >= 0; i-- )
		{
			this.drawables.add( 0, selection.elementAt( i ) );
		}
	}





	    /**
	     * Please complete the missing tags for toString
	     * @param
	     * @return
	     * @pre
	     * @post
	     */

	    public String toString()
	    {
	        return this.name;
	    }

		public void setColour( Color colour )
		{
		}

		public void copy( BPackageTerminator src )
		{
			int i, size;
			BDrawable cur = null;
			BDrawable added = null;

			super.copy( src );

			size = src.drawables.size();

			for ( i = 0; i < size; i++ )
			{
				cur = (BDrawable)src.drawables.elementAt( i );
				added = cur.newInstance();
				this.addDrawable( added );
			}

				this.parent = src.parent;

			this.tmpPoint.setLocation( src.tmpPoint );
			this.meaDummy = src.meaDummy;

		}

	///////////tree node stuff...

		public boolean isLeaf()
		{
			return true;
		}

		public Object getChildAt( int index )
		{
			return null;
		}

		public int getChildCount()
		{
			return 0;
		}

		public Object getParent()
		{
			return this.parent;
		}

		public int getIndexOf( Object node )
		{
			return -1;
		}

		public void setParent( Object parent )
		{
			this.parent = parent;
		}

		public void removeAllChildren()
		{
		}

		public String getName()
		{
			return this.name;
		}

//////////////////////crufty hack for bview stuff///


	private BScalar z = null;
	private BScalar ooz = null;
	private static final BScalarRect tmpRect = new BScalarRect( 0, 0, 0, 0 );
	private static BScalarPoint halfWH = null;

	public BScalar getZ()
	{
		return z;
	}

	public BScalar getOOZ()
	{
		return ooz;
	}

	public int getHalfWidth()
	{
		return 0;
	}

	public int getHalfHeight()
	{
		return 0;
	}

	public int getWidth()
	{
		return 0;
	}

	public int getHeight()
	{
		return 0;
	}

	public int getXPos()
	{
		return 0;
	}

	public int getYPos()
	{
		return 0;
	}

	public BScalarRect getViewCoords()
	{
		return tmpRect;
	}

	public BScalarRect getViewBounds()	
	{
		return tmpRect;
	}

	public BScalarPoint getHalfWH()
	{
		return halfWH;
	}



		
}



