
//Title:        Packager
//Version:
//Copyright:    Copyright (c) 1998
//Author:       Tristan Austin
//Company:      Synergy
//Description:  Allows user to define the look of a meta model

package au.edu.swin.synergy.plugin.packager;

import au.edu.swin.synergy.plugin.metamodeller.BMetaModel;

import java.awt.*;
import javax.swing.*;
import javax.swing.tree.*;

import au.edu.swin.synergy.debug.Debug;
import au.edu.swin.synergy.lib.*;
import au.edu.swin.synergy.plugin.packager.*;
import au.edu.swin.synergy.plugin.packager.BPackageCellRenderer;

/**
 * This panel will contain the tree outlining the contents of the
 * meta model which needs to be implemented as well as indicating
 * those items which have been implemented.
 *
 * @author Tristan Austin
 */
public class BPackageTree extends JTree
{
    BorderLayout borderLayout1 = new BorderLayout();
	BPackageCellRenderer cellRenderer;

    public BPackageTree(BPackageModel packageModel)
    {
        super(packageModel);
	
		this.cellRenderer = new BPackageCellRenderer ( this );
        this.getSelectionModel().setSelectionMode(TreeSelectionModel.SINGLE_TREE_SELECTION);
		this.setCellRenderer ( cellRenderer );
        try  {
           jbInit();
        }
        catch (Exception ex)
        {
            ex.printStackTrace();
        }
    }

    void jbInit() throws Exception
    {
        this.setLayout(borderLayout1);
    }

}

