// $Header: /teamproj/cvsroot/teamb/bkasrc/au/edu/swin/synergy/plugin/prefs/BPrefs.java,v 1.32 1999/10/17 14:10:07 tp079210 Exp $
/**
 * Please complete these missing tags
 * @see
 * @concurrency
 * @copyright Synergy Software 1999
 * @rref
 * @author Shane Fitzgibbon
 * @dispatches BUpdatePrefsCE Command Event which tells plugins to update their preferences
 * @handles BAddPrefsCE Adds a preference panel to the tabbed pane
 * @handles BRemovePrefsCE Remoces a preference panel from the tabbed pane
 */


   package au.edu.swin.synergy.plugin.prefs;

   import java.lang.String;
	import java.util.Vector;
	import java.util.Hashtable;
    import java.net.URL;
	import au.edu.swin.synergy.kernel.event.BBootCE;
   import au.edu.swin.synergy.kernel.BPlugin;
   import au.edu.swin.synergy.kernel.BCommandEvent;
	import au.edu.swin.synergy.kernel.BCommandComplete;

   import au.edu.swin.synergy.plugin.prefs.event.BAddPrefsCE;
   import au.edu.swin.synergy.plugin.prefs.event.BRemovePrefsCE;
   import au.edu.swin.synergy.plugin.prefs.event.BUpdatePrefsCE;

   import au.edu.swin.synergy.plugin.command.event.BRegisterCmdCE;
   import au.edu.swin.synergy.plugin.command.BOnCommand;

   import au.edu.swin.synergy.plugin.mod13.event.BAddWindowCE;
   import au.edu.swin.synergy.plugin.mod13.event.BAddMenuItemCE;
   import au.edu.swin.synergy.plugin.mod13.event.BCloseWindowCE;
   import au.edu.swin.synergy.plugin.mod13.event.BAddToolBarCE;

   import au.edu.swin.synergy.plugin.mod13.bwt.BWindowEvent;
   import au.edu.swin.synergy.plugin.mod13.bwt.BWindowAdapter;
   import au.edu.swin.synergy.plugin.mod13.bwt.BWindowListener;
   import au.edu.swin.synergy.plugin.mod13.bwt.BSwingUtilities;

   import au.edu.swin.synergy.plugin.dialect.BString;

   import au.edu.swin.synergy.debug.Debug;
   import au.edu.swin.synergy.lib.BStringList;

   import au.edu.swin.synergy.plugin.dialect.BString;
   import au.edu.swin.synergy.plugin.dialect.BDialect;
   import au.edu.swin.synergy.plugin.dialect.event.BDialectChangeCE;

	import java.awt.*;
   import javax.swing.*;
   import javax.swing.border.Border;

	import au.edu.swin.synergy.plugin.help.BHelpItem;
	import au.edu.swin.synergy.plugin.help.BHelpUtil;
	import au.edu.swin.synergy.plugin.help.BHelpTreeModel;
	import au.edu.swin.synergy.plugin.help.event.BRegisterHelpCE;

   public class BPrefs extends BPlugin implements java.awt.event.ActionListener
   {
	  /**
	  * Will contain list of BWindowListeners who have registered a prefs panel and 
	  * would like to know when it opens or closes, allowing them to setup init values.
	  */
	  Vector initPrefsListeners;

	  /**
	  * String containing name of internal window.
	  */
	  String windowTitle = null;

	  /**
	  * Must keep reference to menu item.  When local changes, we know what to 
	  * update.
	  */
      JMenuItem prefMenuItem;

      /**
       * The tool bar button
       */
      JButton toolBarButton;

		/**
		* Hashtable used so we keep record of string and index of component in tabbed pane.
		* Whenever locale is changed, we just go through all and reset the name;
		*/
		Hashtable tabStrings;

      JTabbedPane prefTabbedPane;
      JPanel prefPanel;
      JPanel buttonPanel;
      JButton okButton = new JButton();
      JButton cancelButton = new JButton();


    /**
     * Please complete the missing tags for setup
     * @post
     * @pre
     * @throws null
     * @return void
     * @param void there are no params
     */
      public void setup(BStringList params)
      {
         registerMenu();
         doInit();

        BAddToolBarCE addToolBar = new BAddToolBarCE(this);
        addToolBar.addButton(toolBarButton);

        //Set up the screen text
        doDialect ();

        //Dispatches the event to the window manager
        this.dispatchEvent(addToolBar);
      }

      /**
     * Return a list of plugin dependancies
	 * 
     * @return a list of plugins such as "au.edu.swin.synergy.plugin.mod13.BWindowManager"
	 * or null if there are no dependancies
     */

    public BStringList getDependancies()
	{
		BStringList result = new BStringList();
		result.add("au.edu.swin.synergy.plugin.mod13.BWindowManager");
		return result;
	}

    /**
     * Please complete the missing tags for onBCommandEvent
     * @post
     * @pre
     * @throws null
     * @return void
     * @param source The module that created this event
     * @param event The event that is being handled
     */
   
      public void onBCommandEvent( Object source, BCommandEvent event )
      {
        // Debug.doPrintln("BPrefs:onBCommandEvent:source: " + source + " event: " + event);
		if ( event instanceof BBootCE )
		{
			registerHelp ();
		}
         else if( event instanceof BAddPrefsCE )
         {
            Debug.doPrintln( "Got BAddPrefsCE" );
            doAddPref( ( BAddPrefsCE ) event );
         }
         else if( event instanceof BRemovePrefsCE )
         {
            Debug.doPrintln( "Got BRemovePrefsCE" );
            doRemovePref( ( BRemovePrefsCE ) event );
         }
		 else if ( event instanceof BDialectChangeCE )
		 {
			this.doDialect ();
		 }
      }

		private void registerHelp ()
		{
			BHelpTreeModel tree = new BHelpTreeModel ( "Preferences" );
			String path = "/au/edu/swin/synergy/plugin/prefs/help/";
			BHelpItem p = new BHelpItem ( "Preferences", path + "prefs.html" );
			BHelpItem msp = new BHelpItem ( "Setting Messaging System Preferences", path + "prefs_messaging.html" );
			BHelpItem mvp = new BHelpItem ( "Setting Modeller Viewer Preferences", path + "prefs_viewport.html" );
			BHelpItem cp = new BHelpItem ( "Setting Colour Preferences", path + "prefs_colour.html" );
			BHelpItem dp = new BHelpItem ( "Setting Dialect Preferences", path + "prefs_dialect.html" );

			tree.addHelpItem ( null, p );
			tree.addHelpItem ( null, msp );
			tree.addHelpItem ( null, mvp );
			tree.addHelpItem ( null, cp );
			tree.addHelpItem ( null, dp );

			BRegisterHelpCE event = new BRegisterHelpCE ( this, tree );
			dispatchEvent ( event );
		}

      private void doDialect ()
	  {
		  BString newStr;
          JComponent tab;
		  BSwingUtilities.setJMenuItemText ( this.prefMenuItem, BDialect.getString ( this, "menuitem" ) );
		  BSwingUtilities.setJButtonText ( this.okButton, BDialect.getString ( "ok" ) );
		  BSwingUtilities.setJButtonText ( this.cancelButton, BDialect.getString ( "cancel" ) );

          BSwingUtilities.setToolTip(toolBarButton, BDialect.getString(this, "prefsButtonToolTip"));

		  // No go through each panel and update what is displayed.
		  // Still have to be implemented.  Wait see what tristen has added.
		  for ( int i = 0; i < prefTabbedPane.getTabCount (); i++ )
		  {
              tab = (JComponent)prefTabbedPane.getComponentAt ( i );
		      newStr = ( BString ) tabStrings.get ( tab );

              BSwingUtilities.setTitleFor(prefTabbedPane, tab, newStr.toString());
		  }
	  }

      
    /**
     * Please complete the missing tags for actionPerformed
     * @post
     * @pre
     * @throws null
     * @return void
     * @param evt Action event
     */
      public void actionPerformed( java.awt.event.ActionEvent evt )
      {
         Debug.doPrintln( "BPrefs:actionPerformed:evt: " + evt );
         Object source = evt.getSource();
         if( source == okButton )
         {
            Debug.doPrintln( "Got OK Button Event" );
            doDone(true);
         }
         else if( source == cancelButton )
         {
            Debug.doPrintln( "Got Cancel Button Event" );
            doDone(false);
         }
         else if( source == prefMenuItem || source == toolBarButton)
         {
            addWindow();
         }


      }
    /**
     * Please complete the missing tags for doInit
     * @param
     * @return
     * @pre
     * @post
     */
      private void doInit()
      {
		 tabStrings = new Hashtable ();
		 initPrefsListeners = new Vector ();
         prefTabbedPane = new JTabbedPane();
         prefPanel = new JPanel();

		 prefPanel.setSize ( 400, 400 );
		 buttonPanel = new JPanel();
         okButton.addActionListener( this );
         cancelButton.addActionListener( this );
        //prefTabbedPane.setSelectedIndex ( 0 );
         prefPanel.setLayout( new java.awt.BorderLayout() );
         Border etched = BorderFactory.createEtchedBorder();
         prefPanel.setBorder( etched );
         prefPanel.add( prefTabbedPane, "Center" );
		 buttonPanel.setLayout(new FlowLayout(FlowLayout.RIGHT));
         buttonPanel.add( okButton );
         buttonPanel.add( cancelButton );
         prefPanel.add( buttonPanel, "South" );

         toolBarButton = new JButton(BSwingUtilities.getImage(this, "/au/edu/swin/synergy/plugin/prefs/images/preferences.gif"));
         toolBarButton.addActionListener(this);
         toolBarButton.setRequestFocusEnabled(false);
      }
    /**
     * Please complete the missing tags for doAddPref
     * @param
     * @return
     * @pre
     * @post
     */


      private void doAddPref( BAddPrefsCE event )
      {
         Debug.doPrintln( "In doAddPref" );
         Debug.doPrintln( event.getPanel().toString() );
         Debug.doPrintln( event.getName().toString () );
         Debug.doPrintln( event.getTip().toString () );
         this.addTab( event.getPanel(), event.getName(), event.getTip() );
		  BWindowListener listener = event.getWindowListener ();

		  //Make sure a listener was registered b4 adding it to this class...
		  if ( listener != null )
		  {
			Debug.doPrintln ( "Prefs is adding window listener..." );
			this.addWindowListener ( listener );
		  }
      }
    /**
     * Please complete the missing tags for doRemovePref
     * @param
     * @return
     * @pre
     * @post
     */
   
      private void doRemovePref( BRemovePrefsCE event )
      {
         prefTabbedPane.remove( event.getTarget() );
		 initPrefsListeners.remove ( event.getWindowListener () );
      }
    /**
     * Please complete the missing tags for doOK
     * @param
     * @return
     * @pre
     * @post
     */

      private void doDone(boolean ok)
      {
         BUpdatePrefsCE update = new BUpdatePrefsCE( this, ok);
         dispatchEvent( update );
         BCloseWindowCE closeWindow = new BCloseWindowCE( this, prefPanel );
         dispatchEvent( closeWindow );
      }

   
    /**
     * Please complete the missing tags for addWindow
     * @post
     * @pre
     * @throws null
     * @return void
     * @param none The are no params
     */
   
      private void addWindow()
      {
         BAddWindowCE addWindow = new BAddWindowCE( this, prefPanel, new BString(this,  "windowname" ) );
		 addWindow.addWindowListener ( new prefsInit () );
         addWindow.setDialog( true );
         dispatchEvent( addWindow );
      }
    /**
     * Please complete the missing tags for addTab
     * @post
     * @pre
     * @throws null
     * @return void
     * @param content The component to be added to the preferences tabbedPane
     * @param name The string to be displayed on the tab
     * @param toolTip The String to be displayed in a tool tip
     */
   
      private void addTab( JComponent content, Object name, Object toolTip )
      {
         int index;
		 Debug.doPrintln( "In addTab" );
         prefTabbedPane.addTab( name.toString (), null, content, toolTip.toString () );

		 tabStrings.put ( content, name );
      }
    /**
     * Please complete the missing tags for registerMenu
     * @post
     * @pre
     * @throws null
     * @return void
     * @param none
     */
   
      private void registerMenu()
      {
         prefMenuItem = new JMenuItem( );
         prefMenuItem.addActionListener( this );
         BAddMenuItemCE event = new BAddMenuItemCE( this, prefMenuItem, new BString(this, "preferences"), new BString(this, "edit") );
         dispatchEvent( event );
      }
   
	  public void addWindowListener ( BWindowListener listener )
	  {
		  initPrefsListeners.add ( listener );
	  }

	  private class prefsInit extends BWindowAdapter
	  {
		   BWindowListener listener;
		   public void windowClosing ( BWindowEvent e )
		   {
			  for ( int i = 0; i < initPrefsListeners.size (); i++ )
			  {
			      listener = ( BWindowListener ) initPrefsListeners.elementAt ( i );
				  listener.windowClosing ( e );
			  }
		   }

		   public void windowOpened ( BWindowEvent e )
		   {
			   for ( int i = 0; i < initPrefsListeners.size (); i++ )
			   {
				  listener = ( BWindowListener ) initPrefsListeners.elementAt ( i );
				  listener.windowOpened ( e );
			   }
		   }
	  }   
   }



