// $Header: /teamproj/cvsroot/teamb/bkasrc/au/edu/swin/synergy/plugin/repository/event/BGetFilesCE.java,v 1.2 1999/10/17 20:59:01 tp079541 Exp $

package au.edu.swin.synergy.plugin.repository.event;

import au.edu.swin.synergy.plugin.repository.BMetaData;

import au.edu.swin.synergy.kernel.BCommandEvent;
import au.edu.swin.synergy.kernel.BCommandComplete;
import au.edu.swin.synergy.plugin.userdb.BUser;
import au.edu.swin.synergy.lib.BFile;

import java.util.Vector;


/**
 * Gets multiple files
 * @author Shane Fitzgibbon
 */

public class BGetFilesCE extends BFileXferCE
{
	//static final long serialVersionUID = 2256002213932566536L;

	Vector filenames;
	Vector files;
	Vector metaData;
	Vector versions;
	Vector errors;

	/**
	 * Recursively gets all the files in a directory
	 */
    public BGetFilesCE( Object source, String fDirName, BCommandComplete complete )
    {
        super( source, fDirName, complete );
        files = new Vector();
        metaData = new Vector();
        versions = new Vector();
        errors = new Vector();
        filenames = new Vector();
    }

	/**
	 * sets which version no of a file to get
	 */
	public void setVersion(int index, int fVersion)
	{
		if ( index < versions.size() )
		{
			versions.set(index, new Integer(fVersion));
		}
	}

	/**
	 * Gets the version no requested for a file
	 */
	public int getVersion(int index)
	{
		int result = -1; //defualt value
		if( index < versions.size() )
		{
			result = ((Integer)versions.get(index)).intValue();
		}
		return result;
	}

	/**
	 * adds a new file to the event
	 */
	public void addData( BFile data, BMetaData fMetaData , String filename)
	{
		files.add( data );
		metaData.add( fMetaData );
		versions.add( new Integer(-1) );
		errors.add( new Integer(kErrorNoError) );
		filenames.add( filename );
	}


	/**
	 * adds a new file to the event
	 */
	public void addData( BFile data, BMetaData fMetaData, int fVersion, String filename )
	{
		files.add( data );
		metaData.add( fMetaData );
		versions.add( new Integer( fVersion ) );
		errors.add( new Integer(kErrorNoError) );
		filenames.add( filename );
	}

	/**
	 * Gets a BData file form the event
	 */
	public BFile getData( int index )
	{
		if( index < files.size() )
		{
			return (BFile)files.get(index);
		}
		return null;
	}

	/**
	 * Gets BMetaData from the event
	 */
	public BMetaData getMetaData( int index )
	{
		if( index < metaData.size() )
		{
			return (BMetaData)metaData.get(index);
		}
		return null;
	}

	/**
	 * Gets a filename form the event
	 */
	public String getFileName( int index )
	{
		if ( index < filenames.size() )
		{
			return (String)filenames.get(index);
		}
		return null;
	}

	public void addError( int error )
	{
		files.add( null );
		metaData.add( null );
		versions.add( new Integer( -1 ) );
		errors.add( new Integer(error) );
	}

	public int getError( int index )
	{
		if ( index < errors.size() )
		{
			return ((Integer)errors.get(index)).intValue();
		}
		return -1;
	}

	public int getFileCount()
	{
		return files.size();
	}

}