// $Header: /teamproj/cvsroot/teamb/bkasrc/au/edu/swin/synergy/plugin/repository/event/BRepositoryCE.java,v 1.5 1999/10/17 08:14:38 tp079519 Exp $

package au.edu.swin.synergy.plugin.repository.event;

import au.edu.swin.synergy.kernel.BCommandEvent;
import au.edu.swin.synergy.kernel.BCommandComplete;
import au.edu.swin.synergy.plugin.userdb.BUser;

import java.lang.String;
import au.edu.swin.synergy.lib.BStringList;
import au.edu.swin.synergy.plugin.repository.BMetaData;
import au.edu.swin.synergy.plugin.dialect.BString;


/**
 * Get a BFile status
 * @see
 * @concurrency
 * @copyright
 * @rref
 * @author John Newbigin
 */

public abstract class BRepositoryCE extends BCommandEvent
{
	static final long serialVersionUID = 5694277680741704579L;

	public static final int kErrorNoError = 0;
	public static final int kErrorFileNotFound = 1;
	public static final int kErrorSpecifiedVersionShouldNotExist = 2;
	public static final int kErrorSpecifiedVersionDoesNotExist = 3;
	public static final int kErrorAccessDenied = 4;
	public static final int kErrorFileCorrupt = 5;
	public static final int kErrorInvalidFileName = 6;
	public static final int kErrorConflict = 7;
	
	protected String fileName = null;
	protected BMetaData metaData = null;
	protected int error = kErrorNoError;

    public BRepositoryCE( Object source, String fFileName, BCommandComplete complete )
    {
        super( source );
        setCompletionObject( complete );

		fileName = fFileName;
    }

	public String getFileName()
	{
		return fileName;
	}

	public void setMetaData(BMetaData fMetaData)
	{
		metaData = fMetaData;
	}

	public BMetaData getMetaData()
	{	
		return metaData;
	}

	public int getError()
	{
		return error;
	}

	public void setError(int fError)
	{
		error = fError;
	}

	public String getErrorString()
	{
		switch(error)
		{
			case kErrorNoError:
				return new BString(this, "noerror").toString();

			case kErrorFileNotFound:
				return new BString(this, "filenotfound").toString();

			case kErrorSpecifiedVersionShouldNotExist:
				return new BString(this, "fileshouldnotexist").toString();

			case kErrorSpecifiedVersionDoesNotExist:
				return new BString(this, "filedoesnotexist").toString();

			case kErrorAccessDenied:
				return new BString(this, "accessdenied").toString();

			case kErrorFileCorrupt: 
				return new BString(this, "filecorrupt").toString();

			case kErrorInvalidFileName:
				return new BString(this, "invalidfilename").toString();

			default:
				return new BString(this, "unknownerror").toString();
			
		}
	}

}
