//$Header: /teamproj/cvsroot/teamb/bkasrc/au/edu/swin/synergy/plugin/repository/event/BStatDirCE.java,v 1.2 1999/10/17 21:15:04 tp079541 Exp $
package au.edu.swin.synergy.plugin.repository.event;

import au.edu.swin.synergy.kernel.BCommandEvent;
import au.edu.swin.synergy.kernel.BCommandComplete;
import au.edu.swin.synergy.plugin.userdb.BUser;
import au.edu.swin.synergy.debug.Debug;

import java.lang.String;
import java.util.Vector;
import au.edu.swin.synergy.lib.BStringList;
import au.edu.swin.synergy.plugin.repository.BMetaData;
import java.util.*;


/**
 * Get the status of a directory in the repository
 *
 * @author Shane Fitzgibbon
 */

public class BStatDirCE extends BRepositoryCE
{
	/**
	 * The names of the files in the directories
	 */
	Vector filenames;
	Vector metaData;
	Vector groups;
	Vector users;
	Vector sizes;
	Vector dates;
	Vector isDirs;

	public BStatDirCE( Object source, String fFileName, BCommandComplete complete)
	{
		super( source, fFileName, complete );
		filenames = new Vector();
		metaData = new Vector();
		groups = new Vector();
		users = new Vector();
		sizes = new Vector();
		dates = new Vector();
		isDirs = new Vector();
	}

	public void addFile( String fFileName, BMetaData fMetaData, long fSize, long fDate, boolean isDir )
	{
		Debug.doPrintln("BStatDirCE: " + fFileName + " , " + fMetaData + " , " + fSize + " , " + fDate + " , " + isDir);
		filenames.add( fFileName );
		metaData.add( fMetaData );
		sizes.add( new Long(fSize) );
		dates.add( new Long(fDate) );
		isDirs.add( new Boolean(isDir) );
	}

	public String getFileName(int index)
	{
		if( index < filenames.size() )
		{
			return (String)filenames.get(index);
		}
		return null;
	}

	public BMetaData getMetaData(int index )
	{
		if ( index < metaData.size() )
		{
			return (BMetaData)metaData.get(index);
		}
		return null;
	}

	public void setGroups( Vector fGroups )
	{
		groups = fGroups;
	}

	public Vector getGroups()
	{
		return groups;
	}


	public void setUsers( Vector fUsers )
	{
		users = fUsers;
	}

	public long getDate( int index )
	{
		if ( index < dates.size() )
		{
			return ((Long)dates.get( index )).longValue();
		}
		return 0;
	}

	public long getSize( int index )
	{
		if ( index < sizes.size() )
		{
			return ((Long)sizes.get( index)).longValue();
		}
		return 0;
	}


	public boolean isDirectory( int index )
	{
		if ( index < isDirs.size() )
		{
			return ((Boolean)isDirs.get(index)).booleanValue();
		}
		return false;
	}

	public int getCount()
	{
		return filenames.size();
	}
}

