/**
 * This is the event which is passed around
 * when the user manager gets the event, it will create a
 * vector containing the users
 * it then calls the completion object which can do what it
 * wants with the data.
 * the completeion object is run in the thread of the event.
 *
 * @see
 * @concurrency
 * @copyright
 * @rref
 * @author John Newbigin
 */
// $Header: /teamproj/cvsroot/teamb/bkasrc/au/edu/swin/synergy/plugin/roomgui/event/BDoNavigateCE.java,v 1.6 1999/08/28 10:20:24 tp079519 Exp $

package au.edu.swin.synergy.plugin.roomgui.event;

import java.util.Vector;
import au.edu.swin.synergy.kernel.BCommandEvent;
import au.edu.swin.synergy.kernel.BCommandComplete;


public class BDoNavigateCE extends BCommandEvent
{
    // add data elements in here....
    Vector users;

    /**
     * Constructor
     * @param source Source of the event.
	 * @param complete Completion object to be executed once event processed.
     */    
    public BDoNavigateCE( Object source, BCommandComplete complete )
    {
        super( source );
        setCompletionObject( complete );
        // other stuff...
    }

    /**
     * Gets users contained in this event.
     * @pre Users have been set.
     * @return Vector containing users.
     */    
    public Vector getUsers()
    {
        return users;
    }

    /**
     * Set vector of users stored by this event.
     * @pre Vector hasn't previously been set.
     * @param fUsers Users to be set.
     */    
    public void setUsers( Vector fUsers )
    {
        users = fUsers;
    }
}
