/**
 * Please complete these missing tags
 * @see
 * @concurrency
 * @copyright
 * @rref
 */
//$Header: /teamproj/cvsroot/teamb/bkasrc/au/edu/swin/synergy/plugin/rooms/BUser.java,v 1.3 1999/08/28 10:20:24 tp079519 Exp $
//Title:        Cohesion
//Version:      
//Copyright:    Copyright (c) 1998
//Author:       Tristan Austin
//Company:      Synergy
//Description:  Functional prototype for Insync


package au.edu.swin.synergy.plugin.rooms;

import java.lang.String;
import java.io.Serializable;
import au.edu.swin.synergy.lib.UnixCrypt;

/**
 * A BUser provides the details of a particular user
 * including their name, their location (ip address etc.)
 * and other details associated with each user.
 *
 * @author Tristan Austin
 * modified by John Newbigin
 */
public class BUser implements Serializable
{
    /**
     * The constant identifying the privilage "user"
     */
    public static final int kUser = 0;
    
    /**
     * The constant identifying the privilage "administrator"
     */
    public static final int kAdministrator = 1;
    
    /**
     * The username of the user
     */
    private String userName = null;
    
    /**
     * If the client changes the user name, the new version is stored here
     */
    private String oldUserName = null;
    
    /**
     * The password of the user
     */
    private String password = null;
    
    /**
     * The privilage associated with this user
     */
    private int privilage = kUser;
    
    /**
     * The full name of the user
     */
    private String fullName;
    
    /**
     * The email address of the user
     */
    private String emailAddress;
    /**
     * Please complete the missing tags for BUser
     * @post
     * @pre
     * @throws
     * @return
     * @param
     */
    
    /**
     * Creates a user object with the given user name and
     * the ip address of the client machine
     */
    public BUser( String userName )
    {
        this.userName = userName;
        this.oldUserName = userName;
    }
    /**
     * Please complete the missing tags for BUser
     * @post
     * @pre
     * @throws
     * @return
     * @param
     */
    
    /**
     * Creates a user object with no values
     */
    public BUser()
    {
    }
    /**
     * Please complete the missing tags for getPassword
     * @post
     * @pre
     * @throws
     * @return
     */
    
    /**
     * Gets this users password
     *
     * @param   Gets the unecrypted password
     */
    
    public String getPassword()
    {
        return this.password;
    }
    /**
     * Please complete the missing tags for setPassword
     * @post
     * @pre
     * @throws
     * @return
     */
    
    /**
     * Enables the setting to password.
     *
     * @param   password The unencrypted password of the user
     */
    public void setPassword( String fPassword )
    {
        this.password = fPassword;
    }
    /**
     * Please complete the missing tags for getUserName
     * @post
     * @pre
     * @throws
     * @param
     */
    
    /**
     * Gets the user name of this user
     *
     * @return The user name
     */
    public String getUserName()
    {
        return this.userName;
    }
    /**
     * Please complete the missing tags for setUserName
     * @post
     * @pre
     * @throws
     * @return
     */
    
    /**
     * Sets the user name to that specified
     *
     * @param   userName The user name of this user
     */
    public void setUserName( String userName )
    {
        this.userName = userName;
        this.oldUserName = userName;
    }
    /**
     * Please complete the missing tags for getOldUserName
     * @post
     * @pre
     * @throws
     * @return
     * @param
     */
    
    /**
     * Gets the new user name for this user
     */
    public String getOldUserName()
    {
        return this.oldUserName;
    }
    /**
     * Please complete the missing tags for getPrivilage
     * @post
     * @pre
     * @throws
     * @param
     */
    
    /**
     * Supplies the privilage associated with
     * this user.
     *
     * @return The Privilage as defined in this class
     */
    public int getPrivilage()
    {
        return this.privilage;
    }
    /**
     * Please complete the missing tags for getFullName
     * @post
     * @pre
     * @throws
     * @param
     */
    
    /**
     * Gets the full name of the user
     *
     * @return The full name of the user
     */
    public String getFullName()
    {
        return this.fullName;
    }
    /**
     * Please complete the missing tags for getEmailAddress
     * @post
     * @pre
     * @throws
     * @param
     */
    
    /**
     * Gets the users email address
     *
     * @return The users email address
     */
    public String getEmailAddress()
    {
        return emailAddress;
    }
    /**
     * Please complete the missing tags for setNewUserName
     * @post
     * @pre
     * @throws
     * @return
     */
    
    /**
     * Sets the new user name of the user to that specified.
     * This enables, the old user to still be identified so he can
     * be updated rather than adding a new user.
     *
     * @param   newUesrName The new user name for this user
     */
    public void setNewUserName( String newUserName )
    {
        this.oldUserName = this.userName;
        this.userName = newUserName;
    }
    /**
     * Please complete the missing tags for setPrivilage
     * @post
     * @pre
     * @throws
     * @return
     */
    
    /**
     * Sets the privilage of this user to that specified
     *
     * @param   privilage The new privilage of the user
     */
    public void setPrivilage( int privilage )
    {
        this.privilage = privilage;
    }
    /**
     * Please complete the missing tags for setFullName
     * @post
     * @pre
     * @throws
     * @return
     */
    
    /**
     * Sets the users full name to that specified
     *
     * @param   newFullName The new full name of the user
     */
    public void setFullName( String newFullName )
    {
        this.fullName = newFullName;
    }
    /**
     * Please complete the missing tags for setEmailAddress
     * @post
     * @pre
     * @throws
     * @return
     */
    
    /**
     * Sets the users email address
     *
     * @param   newEmailAddress   Their new email address
     */
    public void setEmailAddress( String newEmailAddress )
    {
        this.emailAddress = newEmailAddress;
    }
    /**
     * Please complete the missing tags for doChangePassword
     * @post
     * @pre
     * @throws
     * @return
     * @param
     */
    
    public void doChangePassword( String fPassword )
    {
        this.password = UnixCrypt.crypt( fPassword );
    }
    /**
     * Please complete the missing tags for doCheckPassword
     * @post
     * @pre
     * @throws
     * @return
     * @param
     */
    
    public boolean doCheckPassword( String fPassword )
    {
        return UnixCrypt.matches( this.password, fPassword );
    }
    /**
     * Please complete the missing tags for equals
     * @post
     * @pre
     * @throws
     * @return
     */
    
    /**
     * Determines whether this user is equal to
     * the user passed in.
     *
     * @param   user  The user to compare
     */
    public boolean equals( Object user )
    {
        BUser theUser = ( BUser ) user;
        
        return this.userName.equals( theUser.getUserName() );
    }
    /**
     * Please complete the missing tags for toString
     * @post
     * @pre
     * @throws
     * @param
     */
    
    /**
     * Returns a representation of the user as a string
     *
     * @return The user name of the current user
     */
    public String toString()
    {
        return this.userName;
    }
}
