/**
 * Adds the user to the chat world.
 * @see
 * @concurrency
 * @copyright
 * @rref
 * @author John Newbigin
 */
// $Header: /teamproj/cvsroot/teamb/bkasrc/au/edu/swin/synergy/plugin/rooms/event/BAddUserCE.java,v 1.4 1999/08/28 10:20:24 tp079519 Exp $

package au.edu.swin.synergy.plugin.rooms.event;

import java.util.Vector;
import au.edu.swin.synergy.kernel.BCommandEvent;
import au.edu.swin.synergy.kernel.BCommandComplete;

import au.edu.swin.synergy.plugin.rooms.BRoom;
import au.edu.swin.synergy.plugin.rooms.BChatUser;

public class BAddUserCE extends BCommandEvent
{
	/**
	* User to add.
	*/
    BChatUser user;
    
    /**
     * Constructor
     * @param source Source of event.
	 * @param fUser User wishing to join chat fest.
	 * @param complete Completion object executed once event processed.
     */    
    public BAddUserCE( Object source, BChatUser fUser, BCommandComplete complete )
    {
        super( source );
        setCompletionObject( complete );
        // other stuff...
        
        setUser( fUser );
    }

    /**
     * Returns user contained in this event.
     * @return Chat user.
     * @pre Chat user has been set.
     */    
    public BChatUser getUser()
    {
        return user;
    }

    /**
     * Sets user in this event.
     * @param fUser User to join chat.
     * @pre User has been set.
     */    
    public void setUser( BChatUser fUser )
    {
        user = fUser;
    }
}
