/**
 * Event sent to notify all listeners of messages sent.
 * @see
 * @concurrency
 * @copyright
 * @rref
 * @author John Newbigin.
 */
// $Header: /teamproj/cvsroot/teamb/bkasrc/au/edu/swin/synergy/plugin/rooms/event/BChatMsgCE.java,v 1.5 1999/08/28 10:20:24 tp079519 Exp $

package au.edu.swin.synergy.plugin.rooms.event;

import java.lang.String;
import au.edu.swin.synergy.kernel.BCommandEvent;
import au.edu.swin.synergy.lib.BStringList;

public class BChatMsgCE extends BCommandEvent
{
	/**
	* Message sent across network.
	*/
    String message;

	/**
	* Room name message was sent from.
	*/
    String name;

    /**
     * Constructor
     * @param source Source of event.
	 * @param fMessage Message to be sent.
	 * @param fName Room name.
     */    
    public BChatMsgCE( Object source, String fMessage, String fName )
    {
        super( source );
        // other stuff...
        message = fMessage;
        name = fName;
    }

    /**
     * Returns message contained in event.
     * @pre Message has been set.
     * @return the chat message
     */    
    public String getMessage()
    {
        return message;
    }
    
    /**
     * Returns the name of the user who sent this message
     * @return user name
     */
    
    public String getName()
    {
        return name;
    }
}
