/**
 * Event used for gui creating rooms on server.
 * @see
 * @concurrency
 * @copyright
 * @rref
 * @author John Newbigin
 */
// $Header: /teamproj/cvsroot/teamb/bkasrc/au/edu/swin/synergy/plugin/rooms/event/BCreateRoomCE.java,v 1.4 1999/08/28 10:20:24 tp079519 Exp $

package au.edu.swin.synergy.plugin.rooms.event;

import java.util.Vector;
import au.edu.swin.synergy.kernel.BCommandEvent;
import au.edu.swin.synergy.kernel.BCommandComplete;

import au.edu.swin.synergy.plugin.server.BNetCredentials;

public class BCreateRoomCE extends BCommandEvent
{
	/**
	* Name of room to create.
	*/
    String roomName = null;

    /**
     * Constructor.
     * @param source Source of event.
	 * @param name Name of new room.
	 * @param complete Completion executed when event processed.
     */    
    public BCreateRoomCE( Object source, String name, BCommandComplete complete )
    {
        super( source );
        setCompletionObject( complete );
        roomName = name;
    }

    /**
     * Gets name of room to be created.
     * @return Name of room.
     * @pre Name hasn't been set.
     */    
    public String getName()
    {
        return roomName;
    }

    /**
     * Sets name of room.
     * @param fName Name of room.
     * @pre Name hasn't been set.
     */
    public void setName( String fName )
    {
        roomName = fName;
    }
}
