/**
 * This is the event which is passed around
 * when the user manager gets the event, it will create a
 * vector containing the users
 * it then calls the completion object which can do what it
 * wants with the data.
 * the completeion object is run in the thread of the event.
 * @see
 * @concurrency
 * @copyright
 * @rref
 * @author John Newbigin
 */
// $Header: /teamproj/cvsroot/teamb/bkasrc/au/edu/swin/synergy/plugin/rooms/event/BGetRoomCE.java,v 1.4 1999/08/28 10:20:24 tp079519 Exp $

package au.edu.swin.synergy.plugin.rooms.event;

import java.util.Vector;
import au.edu.swin.synergy.kernel.BCommandEvent;
import au.edu.swin.synergy.kernel.BCommandComplete;

import au.edu.swin.synergy.plugin.rooms.BRoom;

public class BGetRoomCE extends BCommandEvent
{
	/**
	* Room to be returned from server.
	*/    
    BRoom room = null;

	/**
	* Name of room to get.
	*/
    String roomName = null;

    /**
     * Constructor.
     * @param source Source of event.
	 * @param fRoomName Name of room to get.
	 * @param complete Completion object to execute once event handled.
     */    
    public BGetRoomCE( Object source, String fRoomName, BCommandComplete complete )
    {
        super( source );
        setCompletionObject( complete );
        // other stuff...
        roomName = fRoomName;
    }

    /**
     * Get Room information contained in this class.
     * @pre room has been set.
     * @return Room containing room information.
     */    
    public BRoom getRoom()
    {
        return room;
    }

    /**
     * Set room.
     * @post room has been set.
     * @pre room hasn't been set.
     * @param fRoom Room to contained in event.
     */    
    public void setRoom( BRoom fRoom )
    {
        room = fRoom;
    }

    /**
     * Get name of room, of which details are to be received.
     * @return Name of room.
     * @pre Name has been set.
     */    
    public String getName()
    {
        return roomName;
    }
}
