/**
 * This is the event which is passed around
 * when the user manager gets the event, it will create a
 * vector containing the users
 * it then calls the completion object which can do what it
 * wants with the data.
 * the completeion object is run in the thread of the event.
 *
 * @see
 * @concurrency
 * @copyright
 * @rref
 * @author John Newbigin
 */
// $Header: /teamproj/cvsroot/teamb/bkasrc/au/edu/swin/synergy/plugin/rooms/event/BGetRoomsCE.java,v 1.4 1999/08/28 10:20:24 tp079519 Exp $

package au.edu.swin.synergy.plugin.rooms.event;

import java.util.Vector;
import au.edu.swin.synergy.kernel.BCommandEvent;
import au.edu.swin.synergy.kernel.BCommandComplete;


public class BGetRoomsCE extends BCommandEvent
{

	/**
	* Vector of rooms returned by this event.
	*/    
    Vector rooms = null;

    /**
     * Constructor.
     * @param source Source of event.
	 * @param compolete Completion object to be executed once event processed.
     */    
    public BGetRoomsCE( Object source, BCommandComplete complete )
    {
        super( source );
        setCompletionObject( complete );
        // other stuff...
    }

    /**
     * Get rooms contained in this event.
     * @return Vector containing rooms held by this event.
     */    
    public Vector getRooms()
    {
        return rooms;
    }

    /**
     * Set rooms.
     * @param fRooms Vector of rooms to be set in event.
     */    
    public void setRooms( Vector fRooms )
    {
        rooms = fRooms;
    }
}
