/**
 * Event used to store file on server.
 * @see
 * @concurrency
 * @copyright
 * @rref
 * @author Christian Karolos
 */
//$Header

package au.edu.swin.synergy.plugin.rooms.event;

import au.edu.swin.synergy.kernel.BCommandEvent;
import au.edu.swin.synergy.kernel.BCommandComplete;

import au.edu.swin.synergy.lib.BFile;

public class BSendFileCE extends BCommandEvent
{
	/**
	* File to be stored on server.
	*/
    BFile sentFile = null;

	/**
	* Name of file sent to server.
	*/
    String sentFileName = null;

    /**
     * Constructor
     * @param source Source of event.
	 * @param file File to be retrieved by server.
	 * @param complete Completion object to be executed once event processed.
     */    
    public BSendFileCE( Object source, BFile file, BCommandComplete complete )
    {
        super( source );
        setCompletionObject( complete );
        setFile( file );
        sentFileName = file.getFileName();
    }

    /**
     * Gets file stored in this event.
     * @return BFile object containing file.
     * @pre sentFile has been set.
     */    
    public BFile getFile()
    {
        return sentFile;
    }

    /**
     * Sets file in this event.
     * @param file File to set.
     */    
    public void setFile( BFile file )
    {
        sentFile = file;
    }

    /**
     * Returns file name of that stored in this event.
     * @return Name of file.
     * @pre File name has been set.
     */    
    public String getFileName()
    {
        return sentFileName;
    }
}
