//$Header: /teamproj/cvsroot/teamb/bkasrc/au/edu/swin/synergy/plugin/rtp/BCOFileModel.java,v 1.4 1999/10/17 13:55:54 tp079541 Exp $
package au.edu.swin.synergy.plugin.rtp;

import au.edu.swin.synergy.plugin.dialect.BDialect;

import java.util.Vector;

/**
 * Subclass of the Repository file model that has been adapted
 * to suit the needs of the file list in the check out panel
 *
 * @author Shane Fitzgibbon
 * @copyright synergy software 1999
 */
public class BCOFileModel extends BResFileModel
{

	/**
	 * The column headers for the table
	 */

	final String [] columnNames = { "Filename", "Owner", "Type", "Version", "Size" };

	/**
	 * gets the number of columns in the table model
	 *
	 * @returns the number of columns
	 */
	public int getColumnCount()
	{
		return columnNames.length;
	}

	/**
	 * gets the name of each of the columns
	 *
	 * @param index the index of the column
	 */
	public String getColumnName( int index )
	{
		return BDialect.getString( this, columnNames[index] );
	}

	/**
	 * gets the value of a specified cell
	 *
	 * @param row the row that the cell is in
	 * @param column the column the cell is in
	 * @returns the data in the cell specified
	 */
	public Object getValueAt( int row, int column )
	{
		Vector value = (Vector) data.get( row );
		if ( column > 0 )
		{
			column++;
		}
		if ( column == 3 )
		{
			if( ((String)value.get(column)).equals("d") )
			{
				//return new JLabel(folderIcon);
				return folderIcon;
			}
			else if ( ((String)value.get(column)).equals("cmo") )
			{
				//return model Icon
				return modelIcon;
			}
			else //if( ((String)value.get(column)).equals("t") )
			{
				//return new JLabel(fileIcon);
				return fileIcon;
			}
		}
		return value.get( column );
	}
}
