//$Header: /teamproj/cvsroot/teamb/bkasrc/au/edu/swin/synergy/plugin/rtp/BCheckOut.java,v 1.12 1999/10/17 17:25:02 tp079541 Exp $
package au.edu.swin.synergy.plugin.rtp;

import au.edu.swin.synergy.debug.Debug;
import au.edu.swin.synergy.kernel.BPlugin;
import au.edu.swin.synergy.plugin.dialect.BDialect;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;
import java.util.Vector;

public class BCheckOut extends JPanel implements BRepositoryPanel
{
	protected BPlugin plugin;

	BResFileModel fileModel = new BCOFileModel();
	JTable fileTable = new JTable(fileModel);
	JScrollPane tablePane = new JScrollPane( fileTable );
	BDirectoryComboModel dirModel = new BDirectoryComboModel();
	JComboBox dirCombo = new JComboBox(dirModel);
	JLabel dirLabel = new JLabel();
	JLabel titleLabel = new JLabel();
	JPanel repPanel = new JPanel();
	JPanel propPanel = new JPanel();
	JTextArea propText = new JTextArea();
	JScrollPane propPane = new JScrollPane( propText );

	public BCheckOut(BPlugin plug)
	{
		this.plugin = plug;
		doInit();
	}

	private void doInit()
	{
		GridBagConstraints gbc = new GridBagConstraints();
		this.setSize(550,518);
		this.setLayout( new GridBagLayout() );
		repPanel.setLayout(new GridBagLayout() );
		gbc.weightx = 1.0;
		gbc.weighty = 1.0;
		gbc.gridx = 0;
		gbc.gridy = 0;
		gbc.gridwidth = 1;
		gbc.gridheight = 1;
		this.add(repPanel, gbc);
		repPanel.setBounds(0,0,396,516);
		repPanel.setSize(396,516);
		repPanel.add(tablePane,new GridBagConstraints(0,3,2,1,1.0,1.0,java.awt.GridBagConstraints.CENTER,java.awt.GridBagConstraints.BOTH,new Insets(12,12,10,0),372,434));
		tablePane.setBounds(12,72,384,434);
		repPanel.add(dirCombo,new GridBagConstraints(1,1,1,2,0.0,0.0,java.awt.GridBagConstraints.CENTER,java.awt.GridBagConstraints.NONE,new Insets(7,8,0,0),50,-3));
		dirCombo.setBounds(210,36,180,24);
		dirLabel.setText(BDialect.getString(this, "cwd"));
		repPanel.add(dirLabel,new GridBagConstraints(0,1,1,1,0.0,0.0,java.awt.GridBagConstraints.CENTER,java.awt.GridBagConstraints.NONE,new Insets(7,12,0,0),32,6));
		dirLabel.setBounds(12,36,184,21);
		titleLabel.setHorizontalTextPosition(SwingConstants.CENTER);
		titleLabel.setHorizontalAlignment(SwingConstants.CENTER);
		titleLabel.setText(BDialect.getString( this, "currentRep"));
		repPanel.add(titleLabel,new GridBagConstraints(0,0,3,1,1.0,0.0,java.awt.GridBagConstraints.CENTER,java.awt.GridBagConstraints.HORIZONTAL,new Insets(12,12,0,3),281,2));
		titleLabel.setBounds(12,12,381,17);
		propPanel.setLayout(new GridBagLayout());
		gbc.weightx = 0.0;
		gbc.gridx = 1;
		this.add(propPanel, gbc);
		propPanel.setBounds(396,0,148,516);
		propPanel.setSize(148,516);
		propPanel.add(propPane,new GridBagConstraints(0,0,1,1,1.0,1.0,java.awt.GridBagConstraints.CENTER,java.awt.GridBagConstraints.BOTH,new Insets(5,12,0,0),123,493));
		propPane.setBounds(12,5,136,508);

	}

	/**
	 * gets the table model used by the table on this panel
	 *
	 * @returns the BResFileModel used as the table model
	 */
	public BResFileModel getTableModel()
	{
			return this.fileModel;
	}

	/**
	 * put text into the text area on the rirght hand side of the panel
	 *
	 * @param text the text to be displayed
	 */
	public void putText( String text )
	{
		propText.append( text + "\n" );
	}

	public void clearText()
	{
		propText.setText("");
	}

	/**
	 * adds a mouse listener to the tablepane for the popup menu to listen to
	 *
	 * @param popupListener the MouseListener the popup menu uses
	 */
	public void setPopupListener( MouseListener popupListener )
	{
			tablePane.addMouseListener( popupListener );
			fileTable.addMouseListener( popupListener );
	}

	public void addSelectionListener( ListSelectionListener listener )
	{
		fileTable.getSelectionModel().addListSelectionListener( listener );
	}


	/**
	 * checks to see if any files in the table have been selected
	 *
	 * @returns true if any files are selected false otherwise
	 */
	public boolean isFileSelected()
	{
		return !( this.fileTable.getSelectionModel().isSelectionEmpty() );
	}

	/**
	 * gets the file that are selected in the table
	 *
	 * @returns an array of filenames of the files that are selected
	 */
	public String [] getSelectedFiles()
	{
		String [] result;
		Vector temp = new Vector();
		int [] selectedFiles = fileTable.getSelectedRows();
		for ( int i = 0; i < selectedFiles.length; i++ )
		{
			temp.add(fileModel.getFileAt( selectedFiles[i]));
		}
		result = new String[ temp.size() ];
		temp.copyInto( result );
		return result;
	}

	/**
	 * gets the selected file
	 *
	 * @returns the name of the selected file.  If there are multiple selected files it
	 * returns the name of the last one
	 */
	public String getSelectedFile()
	{
		return (String) fileModel.getFileAt(fileTable.getSelectedRow());
	}


	/**
	 * adds a mouse listener to the table
	 *
	 * @param mouseListener the mouse listener to be added
	 */
	public void addMouseListener( MouseListener mouseListener )
	{
			fileTable.addMouseListener( mouseListener );
	}

	/**
	 * sets the text of the current dir combo box
	 *
	 * @param dirName the name of the current directory
	 */
	public void setCurrentDir( String dirName )
	{
		dirCombo.setSelectedItem( dirName );
	}

	public String getCurrentDir()
	{
		return (String)dirCombo.getSelectedItem();
	}


	public void addDir( String dirName )
	{
		if( !dirModel.itemExists( dirName ) )
		{
			dirCombo.addItem( dirName );
		}
	}

	public void removeDir( String dirName )
	{
		dirCombo.removeItem( dirName );
	}

	public void addComboListener ( ActionListener listener )
	{
		dirCombo.addActionListener( listener );
	}

	public String getComboText()
	{
		return (String) dirCombo.getSelectedItem();
	}

}
