//$Header: /teamproj/cvsroot/teamb/bkasrc/au/edu/swin/synergy/plugin/rtp/BRepositoryGui.java,v 1.18 1999/10/17 22:48:08 tp079541 Exp $
package au.edu.swin.synergy.plugin.rtp;

import au.edu.swin.synergy.kernel.BPlugin;
import au.edu.swin.synergy.kernel.BCommandEvent;
import au.edu.swin.synergy.kernel.BCommandComplete;
import au.edu.swin.synergy.kernel.BBlockingComplete;

import au.edu.swin.synergy.plugin.mod13.event.BAddWindowCE;
import au.edu.swin.synergy.plugin.mod13.event.BAddMenuItemCE;
import au.edu.swin.synergy.plugin.mod13.event.BRemoveMenuItemCE;
import au.edu.swin.synergy.plugin.mod13.event.BCloseWindowCE;
import au.edu.swin.synergy.plugin.mod13.bwt.BWindowAdapter;
import au.edu.swin.synergy.plugin.mod13.bwt.BSwingUtilities;
import au.edu.swin.synergy.plugin.mod13.bwt.BDialog;
import au.edu.swin.synergy.plugin.mod13.bwt.BDialogDone;

import au.edu.swin.synergy.plugin.command.event.BStandardOutCE;
import au.edu.swin.synergy.plugin.help.BHelpItem;
import au.edu.swin.synergy.plugin.help.BHelpTreeModel;
import au.edu.swin.synergy.plugin.help.event.BRegisterHelpCE;

import au.edu.swin.synergy.plugin.repository.event.BRepositoryCE;
import au.edu.swin.synergy.plugin.repository.event.BGetFileCE;
import au.edu.swin.synergy.plugin.repository.event.BGetFilesCE;
import au.edu.swin.synergy.plugin.repository.event.BPutFileCE;
import au.edu.swin.synergy.plugin.repository.event.BStatFileCE;
import au.edu.swin.synergy.plugin.repository.event.BSetSecurityCE;
import au.edu.swin.synergy.plugin.repository.BMetaData;
import au.edu.swin.synergy.plugin.repository.BACL;
import au.edu.swin.synergy.plugin.repository.BDescriptor;

import au.edu.swin.synergy.plugin.client.event.BGetUserCE;
import au.edu.swin.synergy.plugin.userdb.BUser;
import au.edu.swin.synergy.plugin.userdb.BGroup;
import au.edu.swin.synergy.plugin.userdb.event.BGetGroupsCE;
import au.edu.swin.synergy.plugin.userdb.event.BGetUsersCE;

import au.edu.swin.synergy.plugin.dialect.BString;
import au.edu.swin.synergy.plugin.dialect.BDialect;

import au.edu.swin.synergy.debug.Debug;
import au.edu.swin.synergy.lib.BFile;
import au.edu.swin.synergy.lib.io.BTextdb;
import au.edu.swin.synergy.lib.io.BTextdbRecord;
import au.edu.swin.synergy.lib.io.BFileFilter;
import au.edu.swin.synergy.lib.BStringList;

import java.util.Vector;
import java.util.Calendar;
import java.util.GregorianCalendar;

import java.io.InputStream;
import java.io.PrintStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.BufferedInputStream;
import java.io.BufferedOutputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;


public class BRepositoryGui
{

	/**
	 * Reference to the plugin to the BKA
	 */
	protected BRepositoryClient client;

	/**
	 * The check in/out panels containing the info
	 */
	protected BCheckIn checkIn;
	protected BCheckOut checkOut;

	/**
	 * panels that show repository info as well as the buttons
	 * to control them
	 */
	JPanel checkInPanel;
	JPanel checkOutPanel;

	/**
	 * Control Buttons
	 */
	JButton checkInOK = new JButton();
	JButton checkInAdd = new JButton();
	JButton checkOutOK = new JButton();
	JButton checkInCancel = new JButton();
	JButton checkOutCancel = new JButton();
	JButton checkOutRevert = new JButton();
	JButton checkOutChange = new JButton();
	JButton checkInChange = new JButton();
	JButton checkInMkdir = new JButton();
	JCheckBox checkOutChkBox = new JCheckBox(BDialect.getString( this, "currentVersion"));

	/**
	 * Mouse Listeners for the popup menus and to test for double clicks
	 */
	MouseListener ciPopupListener;
	MouseListener coPopupListener;
	MouseListener ciMouseListener;
	MouseListener coMouseListener;

	/**
	 * The popup menus
	 */
	JPopupMenu ciPopup;
	JPopupMenu coPopup;
	JMenuItem ciMenu;
	JMenuItem coMenu;

	/**
	 * The make directory stuff
	 */
	JPanel mdPanel;
	JLabel mdLabel;
	BDialog mdDialog;
	JTextField mdTextField;

	/**
	 * The get version stuff
	 */
	BDialog versionDlg;
	JPanel verPanel;
	JLabel verLabel;
	JComboBox versions;

	/**
	 * the file chooser for adding files
	 */
	JFileChooser fileChooser;

	/**
	 * The user who is currently logged in
	 */
	BUser user;

	/**
	 * the current directories that each panel is displaying
	 */
	String ciCurrentDir = "." + File.separator;
	String coCurrentDir = "." + File.separator;

	/**
	 * Constructor for the repository gui
	 * It instanciates the check in and chack out panels
	 * as well as registering the menu items.
	 *
	 * @param plug a BPlugin that is a reference to the client to the BKA
	 */
	public BRepositoryGui( BRepositoryClient plug )
	{
		this.client = plug;
		checkIn = new BCheckIn( (BPlugin)client );
		checkOut = new BCheckOut( (BPlugin)client );
		registerMenu();
		registerHelp();
		fileChooser = new JFileChooser( client.repositoryRoot );
		doInit();
	}

	/**
	 * Initialises the repository client
	 */
	private void doInit()
	{
		checkInPanel = new JPanel( new BorderLayout() );
		JPanel controlPanelCI = new JPanel( new FlowLayout( FlowLayout.RIGHT ) );
		BSwingUtilities.setJButtonText( checkInOK, BDialect.getString( this, "checkin" ) );
		BSwingUtilities.setJButtonText( checkInCancel, BDialect.getString( "close" ) );
		checkInAdd.setText( BDialect.getString( this, "addfile") );
		controlPanelCI.add( checkInAdd );
		checkInAdd.addActionListener( new BOnPopupAdd() );
		checkInMkdir.setText( BDialect.getString( this, "newdir" ) );
		controlPanelCI.add( checkInMkdir );
		checkInMkdir.addActionListener( new BOnPopupMkdir() );
		//checkInChange = new JButton( BDialect.getString( this, "chgowner" ) );
		//controlPanelCI.add( checkInChange );
		//checkInChange.addActionListener( new
		controlPanelCI.add( checkInOK );
		controlPanelCI.add( checkInCancel );
		checkInOK.addActionListener( new BOnCheckInOK() );
		checkInCancel.addActionListener( new BOnCheckInCancel() );
		checkInPanel.add( "Center", checkIn );
		checkInPanel.add( "South", controlPanelCI );
		checkInPanel.setSize( 405, 518 );

		ciPopup = new JPopupMenu();
		coPopup = new JPopupMenu();
		JMenuItem addItem = new JMenuItem(BDialect.getString( this, "addfile" ));
		addItem.addActionListener( new BOnPopupAdd() );
		JMenuItem mdItem = new JMenuItem( BDialect.getString( this, "newdir" ) );
		mdItem.addActionListener( new BOnPopupMkdir() );
		ciPopup.add( addItem );
		ciPopup.add( mdItem );
		JMenuItem getItem = new JMenuItem( BDialect.getString( this, "getfiles" ) );
		getItem.addActionListener( new BOnPopupGet() );
		JMenuItem chmodItem = new JMenuItem( BDialect.getString( this, "chgperm" ) );
		chmodItem.addActionListener( new BOnPopupChmod() );
		coPopup.add( getItem );
		coPopup.add( chmodItem );
		ciPopupListener = new BPopupListener(ciPopup);
		coPopupListener = new BPopupListener(coPopup);
		checkIn.setPopupListener( ciPopupListener );
		checkOut.setPopupListener( coPopupListener );
		ciMouseListener = new BCIMouseListener();
		checkIn.addMouseListener( ciMouseListener );
		checkIn.addDir( ciCurrentDir );
		coMouseListener = new BCOMouseListener();
		checkOut.addMouseListener( coMouseListener );
		checkOut.addDir( coCurrentDir );
		checkIn.addComboListener( new BCIComboListener() );
		checkOut.addComboListener( new BCOComboListener() );

		checkOutPanel = new JPanel( new BorderLayout() );
		JPanel controlPanelCO = new JPanel( new FlowLayout( FlowLayout.RIGHT ) );
		checkOutOK.setText(BDialect.getString(this, "checkout"));
		checkOutCancel.setText(BDialect.getString("close"));
		checkOutRevert.setText( BDialect.getString( this, "revert" ));
		checkOutChange.setText(BDialect.getString( this, "chgperm" ));
		checkOutChkBox.setSelected(true);
		controlPanelCO.add( checkOutChkBox );
		controlPanelCO.add( checkOutChange );
		controlPanelCO.add( checkOutOK );
		checkOutOK.setEnabled( false );
		checkOutChange.setEnabled( false );
		checkOut.addSelectionListener( new BListSelectionListener() );
		//controlPanelCO.add( checkOutRevert );
		controlPanelCO.add( checkOutCancel );
		checkOutChange.addActionListener( new BOnPopupChmod() );
		checkOutOK.addActionListener( new BOnCheckOutOK() );
		checkOutRevert.addActionListener( new BOnCheckOutRevert() );
		checkOutCancel.addActionListener( new BOnCheckOutCancel() );
		checkOutPanel.add( "Center", checkOut );
		checkOutPanel.add( "South", controlPanelCO );
		checkOutPanel.setSize( 570, 520 );
	}

	/**
	 * this is called when the locale is changed
	 */
	public void doDialect()
	{
		BSwingUtilities.setJButtonText( checkInOK, BDialect.getString( this, "checkin" ) );
		BSwingUtilities.setJButtonText( checkInCancel, BDialect.getString( "close" ) );
		BSwingUtilities.setJButtonText( checkOutOK, BDialect.getString("ok") );
		BSwingUtilities.setJButtonText( checkOutCancel, BDialect.getString("close") );
		BSwingUtilities.setJButtonText( checkOutRevert, BDialect.getString( this, "revert" ) );
		BSwingUtilities.setJButtonText( checkOutChange, BDialect.getString( this, "chgperm" ) );
//            BSwingUtilities.setJButtonText( checkInChange, BDialect.getString( this, "chgperm" ) );
		BSwingUtilities.setJButtonText( checkInMkdir, BDialect.getString( this, "newdir" ) );
		BSwingUtilities.setJButtonText( checkInAdd, BDialect.getString( this, "addFiles" ) );
		BSwingUtilities.setJButtonText( checkOutChkBox, BDialect.getString( this, "currentVersion" ) );
	}

	/**
	 * Enables the repository gui menu items once the user has logged in
	 */
	public void doLogin()
	{
		ciMenu.setEnabled( true );
		coMenu.setEnabled( true );
		BGetUserCE getUser  = new BGetUserCE( this, null);
		BBlockingComplete  complete  = client.dispatchEventAndWait( getUser );
		getUser = (BGetUserCE)complete.getEvent();
		this.user = getUser.getUser();
	}

	/**
	 * disables the repository menu items when the user logs out
	 */
	public void doLogout()
	{
		ciMenu.setEnabled( false );
		coMenu.setEnabled( false );
		this.user = null;
	}

	/**
	 * This method registers that registers the repository client menus
	 * with the window manager
	 */
	private void registerMenu()
	{
		BAddMenuItemCE repMenu = new BAddMenuItemCE( this, new BString( this, "network" ) );
		ciMenu = new JMenuItem();
		ciMenu.addActionListener( new BOnCheckInMenu() );
		repMenu.addMenuItem( ciMenu, new BString( this, "checkin" ) );
		coMenu = new JMenuItem();
		coMenu.addActionListener( new BOnCheckOutMenu() );
		repMenu.addMenuItem( coMenu, new BString( this, "checkout" ) );
		ciMenu.setEnabled( false );
		coMenu.setEnabled( false );
		client.dispatchEvent( repMenu );
	}

	private void registerHelp()
	{
		BHelpTreeModel helpModel = new BHelpTreeModel(BDialect.getString( this, "repository" ) );
		BHelpItem helprepository = new BHelpItem(BDialect.getString( this, "repository" ), "/au/edu/swin/synergy/plugin/repository/help/repository.html" );
		BHelpItem helpcheckin = new BHelpItem( BDialect.getString( this, "helpcheckin"), "/au/edu/swin/synergy/plugin/repository/help/addfile.html" );
		BHelpItem helpcheckout = new BHelpItem( BDialect.getString( this, "helpcheckout"), "/au/edu/swin/synergy/plugin/repository/help/checkout.html");
		BHelpItem helpmkdir = new BHelpItem( BDialect.getString( this, "helpmkdir"), "/au/edu/swin/synergy/plugin/repository/help/createdirectory.html");
		BHelpItem helpsetowner = new BHelpItem( BDialect.getString( this, "helpsetowner"), "/au/edu/swin/synergy/plugin/repository/help/ownership.html");
		helpModel.addHelpItem( null, helprepository );
		helpModel.addHelpItem( null, helpcheckin );
		helpModel.addHelpItem( null, helpcheckout );
		helpModel.addHelpItem( null, helpmkdir );
		helpModel.addHelpItem( null, helpsetowner );
		BRegisterHelpCE helpEvent = new BRegisterHelpCE( this, helpModel );
		client.dispatchEvent( helpEvent );
	}


	/**
	 * Gets the names of all the files in a directory from the meta.data file in that directory
	 *
	 * @param dirName the name of the directory to enumerate
	 * @param files a stringlist to load the file names into
	 * @returns the success of the operation
	 */
	private boolean enumerateDirectory(String dirName, BStringList files)
	{
		Debug.doPrintln( "In enumerateDirectory : dirName = " + dirName );
		//String metaFileName = strip(client.makeFile(dirName).getPath()) + File.separator + client.kMetaFileName;
		String metaFileName = client.makeFile(dirName).getPath() + File.separator + client.kMetaFileName;
		Debug.doPrintln("meta file = " + metaFileName);
		BTextdb db = new BTextdb(metaFileName);
		db.openFileForRead();
		try
		{
			while(true)
			{
				BTextdbRecord record = db.getRecord();
				if(record == null)
				{
					Debug.doPrintln("no more records");
					break;
				}
				Debug.doPrintln("Reading record");
				BMetaData metaData = new BMetaData();
				metaData.setClientSide();
				metaData.setRecord(record);
				files.add(dirName + File.separator + metaData.getFileName());
			}
		}
		finally
		{
			db.close();
		}
			return true;
	}//enumerateDirectory

	/**
	 * Strips the last \. off direcotry names
	 *
	 * @param dirName the name of the directory to strip
	 */
	private String strip( String dirName )
	{
		return dirName.substring(dirName.indexOf( File.separator ) + 1, dirName.length() );
	}

	/**
	 * checks to see if the file is a directory
	 *
	 * @param fileName the name of the file being checked
	 * @returns the result
	 */
	private boolean isDir(String fileName)
	{
		// return true if the directory exists
		File theFile = client.makeFile(fileName);
		if(theFile.isDirectory())
		{
			return true;
		}
		else
		{
			/*File parentFile = theFile.getParentFile();
			if(parentFile.isDirectory())
			{
				return true;
			}
			else
			{
				return false;
			}//*/
			return false;
		}
	}//isDir

	/**
	 * checks to see if the file is a directory or if
	 * the files parent is a directory
	 *
	 * @param fileName the name of the file to check
	 * @returns the result
	 */
	private boolean checkDir(String fileName)
	{
		File theFile = client.makeFile(fileName);
		if(theFile.isDirectory())
		{
			return true;
		}
		else
		{
			File parentFile = theFile.getParentFile();
			if( parentFile.isDirectory() )
			{
				return true;
			}
			else
			{
				return false;
			}
		}
	}//checkDir

	/**
	 * keeps the current dir fields in line with the combo boxes
	 */
	private void updateDir()
	{
		this.coCurrentDir = checkOut.getCurrentDir();
		this.ciCurrentDir = checkIn.getCurrentDir();
	}

	/**
	 * Strips the directory of any an necessary stuff
	 */
	private String makeDir(String dirName)
	{
		Debug.doPrintln("IN BRepository:makeDir dir name = " + dirName);
		if ( dirName.lastIndexOf( File.separator ) != -1 )
		{
			return dirName.substring( 0, dirName.lastIndexOf( File.separator ) );
		}
		return dirName;
	}

	/**
	 * Reads the directory details from the client side metadata
	 */
	private void getClientDir( String dirName, BResFileModel fileModel )
	{
		BStringList files = new BStringList();
		if( enumerateDirectory( dirName , files ) )
		{
			for ( int i = 0; i < files.getCount(); i++ )
			{
				BMetaData fileData = client.getClientMetaData( files.get(i) );
				if ( fileData != null )
				{
					if ( fileData.getType().equals( "d" ) )
					{
						fileModel.addDir( fileData.getFileName(), fileData.getDate(), fileData.getOwner(), fileData.getType(), fileData.getVersion());
					}
					else
					{
						long tempSize;
						File tempFile = new File( fileData.getFileName() );
						if ( tempFile.exists() )
						{
							tempSize = tempFile.length();
						}
						else
						{
							tempSize = 0;
						}
						fileModel.addFile( fileData.getFileName(), fileData.getDate(), fileData.getOwner(), fileData.getType(), fileData.getVersion(), tempSize);
					}
				}
				else
				{
					Debug.doPrintln("There is no meta data for " + files.get(i));
				}
			}
		}
	} //getClientDir

	/**
	 * method for copying files
	 *
	 * @param source the file to copy from
	 * @param dest the file to copy to
	 */
	private boolean copyFile( File source, File dest )
	{
		try
		{
			Debug.doPrintln( "Source file is " + source.getAbsolutePath() );
			Debug.doPrintln( "Destination file is " + dest.getAbsolutePath() );
			BufferedInputStream  in = new BufferedInputStream( new FileInputStream( source ) );
			BufferedOutputStream out = new BufferedOutputStream( new FileOutputStream( dest) );
			while( true )
			{
				int data = in.read();
				if( data == -1 )
				{
					break;
				}
				out.write( data );
			}
			in.close();
			out.close();

		}
		catch ( FileNotFoundException exception )
		{
			Debug.doPrintln("File " + source + " not found");
		}
		catch ( IOException exception )
		{
			Debug.doPrintln("Exception in copyFile" + exception);
		}
		return true;
	}





	//=====================================================================================

	/**
	 * Listens to the Check in menu Item and client.dispatches
	 * an add window event
	 */
	class BOnCheckInMenu implements ActionListener
	{
		public void actionPerformed( ActionEvent event )
		{
			BResFileModel fileModel = checkIn.getTableModel();
			fileModel.clear();
			getClientDir(ciCurrentDir, fileModel );

			BAddWindowCE ciWindow = new BAddWindowCE( this, checkInPanel, new BString( this, "checkin" ) );
			//ciWindow.addWindowListener(new BCIWindowListener() );
			ciWindow.setDialog( true );
			ciWindow.setModal( true );
			client.dispatchEvent( ciWindow );
		}
	}

	/**
	 * Listens to the check out menu item and sends an add
	 * add window event to the windwo manager
	 */
	class BOnCheckOutMenu implements ActionListener
	{
		public void actionPerformed( ActionEvent event )
		{
			BResFileModel fileModel = checkOut.getTableModel();
			fileModel.clear();
			client.getDir(coCurrentDir, fileModel );

			BAddWindowCE coWindow = new BAddWindowCE( this, checkOutPanel, new BString( this, "checkout" ) );
			//coWindow.addWindowListener( new BCOWindowListener() );
			coWindow.setDialog( true );
			coWindow.setModal( true );
			client.dispatchEvent( coWindow );
		}
	}

	/**
	 * Listener for the OK button on the CheckIn Panel
	 */
	class BOnCheckInOK implements ActionListener
	{
		public void actionPerformed( ActionEvent event )
		{

			this.doPutFiles(checkIn.getSelectedFiles());
			client.dispatchEvent(new BStandardOutCE(this, BDialect.getString( this, "cicomplete")));
		}

		private void doPutFiles(String[] selectedFiles)
		{
			for( int j = 0; j < selectedFiles.length; j++ )
			{
				Debug.doPrintln("Selected File " + selectedFiles[j] );
			}
			if(selectedFiles.length < 1)
			{
				Debug.doPrintln("Please specify a file");
			}
			int i = 0;
			while(i < selectedFiles.length)
			{
				Debug.doPrintln("putting file " + selectedFiles[i]);
				String filename =  selectedFiles[i] ;
				Debug.doPrintln("UnStripped File name is " + filename);

				if( isDir(filename) )
				{
					//should recursively traverse dir structure
					Debug.doPrintln("Selected File " + filename + " is a directory");
					BStringList filesInDir = new BStringList();
					enumerateDirectory( filename, filesInDir );
					String[] newFiles = new String[filesInDir.getCount()];
					for ( int j = 0; j < filesInDir.getCount(); j++)
					{
						newFiles[j] = filesInDir.get(j);
						Debug.doPrintln( "new File " + j + " = " + newFiles[j]);
					}
					this.doPutFiles( newFiles );
				}
				else
				{//*/
					File source = client.makeFile(filename);
					// look up the metadata....
					BMetaData metaData = client.getClientMetaData(filename);
					if(metaData == null)
					{
						Debug.doPrintln("Putting this file for the first time");
					}
					else
					{
						Debug.doPrintln("Checking date");
						if(source.lastModified() != metaData.getDate())
						{
							Debug.doPrintln("File has been modified");
						}
						else
						{
							Debug.doPrintln("File has not been modified");
							i++;
							continue;
						}

					}
					// read in the data...
					BPutFileCE putEvent = new BPutFileCE(this, filename, new BOnPutComplete());
					BFile data = new BFile(source, BFile.kDefaultCompressionRate );
					data.compress();
					putEvent.setData(data);
					putEvent.setMetaData(metaData);
					client.dispatchEventServer(putEvent);
				}
				i++;
			}//while
			//getClientDirInfo(); //get the directory info from the client metadata
		}
	}


	/**
	 * Listener for the Cancel button on the CheckIn Panel
	 */
	class BOnCheckInCancel implements ActionListener
	{
		public void actionPerformed( ActionEvent event )
		{
			BCloseWindowCE closeCI = new BCloseWindowCE( this, checkInPanel );
			client.dispatchEvent( closeCI );
		}
	}

	/**
	 * Listener for the OK button on the CheckOut Panel
	 */
	class BOnCheckOutOK implements ActionListener
	{
		public void actionPerformed( ActionEvent event )
		{
			BOnPopupGet popupGet = new BOnPopupGet();
			if( checkOut.isFileSelected() )
			{
				popupGet.actionPerformed( event );
			}
		}
	}

	/**
	 * Listener for the Cancel button on the CheckOut Panel
	 */
	class BOnCheckOutCancel implements ActionListener
	{
		public void actionPerformed( ActionEvent event )
		{
			BCloseWindowCE closeCO = new BCloseWindowCE( this, checkOutPanel );
			client.dispatchEvent( closeCO );
		}
	}

	/**
	 * Listener for the revert button on the check out panel
	 */
	class BOnCheckOutRevert implements ActionListener
	{
		public void actionPerformed( ActionEvent event )
		{
		}
	}

	/**
	 * Inner class that extends java.awt.event.MouseAdapter
	 * listens for mouse events that prompt the ciPopup menu
	 * being displayed
	 */

	class BPopupListener extends MouseAdapter
	{
		JPopupMenu popup;

		public  BPopupListener( JPopupMenu pop )
		{
			this.popup = pop;
		}

		public void mousePressed(MouseEvent event)
		{
			maybeShowPopup(event);
		}

		public void mouseReleased(MouseEvent event)
		{
			maybeShowPopup(event);
		}

		/**
		 * shows the ciPopup menu if the mouse event is the system
		 * default ciPopup type and if there is a node selected in the
		 * JTree
		 */
		private void maybeShowPopup(MouseEvent event)
		{
			if (event.isPopupTrigger())
			{
				if ( popup == BRepositoryGui.this.coPopup )
				{
					if ( BRepositoryGui.this.checkOut.isFileSelected() )
					{
						popup.show(event.getComponent(), event.getX(), event.getY());
					}
				}
				else
				{
					popup.show(event.getComponent(), event.getX(), event.getY());
				}
			}
		}
	}


	/**
	 * Action Listener that listens to the add files menu item in the
	 * popupmenu and the add files button in the check in panel
	 */
	class BOnPopupAdd implements ActionListener
	{
		/**
		 * method that is called when add files is selected
		 */
		public void actionPerformed( ActionEvent event )
		{
			fileChooser.setMultiSelectionEnabled( true );
			fileChooser.setFileSelectionMode( JFileChooser.FILES_ONLY );

			if ( fileChooser.showDialog( checkInPanel, BDialect.getString( this, "addfile" ) ) == JFileChooser.APPROVE_OPTION)
			{
				File [] selectedFiles = getSelectedFiles(fileChooser);
				for( int j = 0; j < selectedFiles.length; j++ )
				{
					Debug.doPrintln("Selected File " + selectedFiles[j].getName() );
				}
				if(selectedFiles.length < 1)
				{
					Debug.doPrintln("Please specify a file");
				}
				int i = 0;
				while(i < selectedFiles.length)
				{
					Debug.doPrintln("putting file " + selectedFiles[i].getName());

					File source = selectedFiles[i];
					File dest = client.makeFile(ciCurrentDir + File.separator + source.getName());
					if ( !dest.exists() )
					{
						if( copyFile( source, dest ) )
						{
							BMetaData metaData = new BMetaData();
							metaData.setFileName( selectedFiles[i].getName() );
							metaData.setOwner( user.getUniqueID().intValue() );
							int extension = selectedFiles[i].getName().lastIndexOf(".");
							if(extension > -1)
							{
								String ext = selectedFiles[i].getName().substring(extension + 1);
								Debug.doPrintln("Setting file type to " + ext);
								metaData.setType(ext);
							}
							metaData.setDate( source.lastModified() );

							client.setClientMetaData( ciCurrentDir + File.separator + dest.getName(), metaData );
						}
					}
					else
					{
						Debug.doPrintln( "File " + dest.getName() + "already exists" );
					}

					i++;
					//client.dispatchEventServer(putEvent);

				}//while
				BResFileModel fileModel = checkIn.getTableModel();
				fileModel.clear();
				getClientDir(ciCurrentDir, fileModel ); //get the directory info from the client metadata
			}
			else
			{
				Debug.doPrintln( "File Chooser Canceled" );
			}
		} //BOnPopupAdd::actionPerformed


		/**
		 * this is a workaround to overcome the fact the swings JFileChooser
		 * doesnt allow multiple file selection
		 */
		public File[] getSelectedFiles( JFileChooser chooser )
		{
			Container c1 = (Container) chooser.getComponent(3);
			JList list  = null;
			while( c1 != null )
			{
				Container cont = (Container) c1.getComponent( 0 );
				if ( cont instanceof JList )
				{
					list = (JList) cont;
					break;
				}
				c1 = cont;
			}
			Object [] entries = list.getSelectedValues();
			File [] files = new File[entries.length];
			for ( int i = 0; i < entries.length; i++ )
			{
				if ( entries[i] instanceof File )
				{
					files[i] = (File) entries[i];
				}
			}
			return files;
		}//getSelectedFiles
	}// class BOnPopupAdd

	/**
	 * Action Listener that listens to the make directory menu item and button
	 */
	class BOnPopupMkdir implements ActionListener
	{
		/**
		 * called when the make directory optio is selected
		 */
		public void actionPerformed( ActionEvent event )
		{
			mdPanel = new JPanel();
			mdPanel.setSize( 190, 140 );
			mdLabel = new JLabel( BDialect.getString( this, "newdirmsg" ) );
			mdTextField = new JTextField();
			mdPanel.add ( "Center", mdLabel );
			mdPanel.add( "Center", mdTextField );
			JButton okButton = new JButton( BDialect.getString( "ok" ) );
			JButton cancelButton = new JButton( BDialect.getString( "cancel" ) );
			mdPanel.add( "South", okButton );
			mdPanel.add( "South", cancelButton );
			okButton.addActionListener( new BOnMkdirOK() );
			cancelButton.addActionListener( new BOnMkdirCancel());
			mdTextField.setPreferredSize(new Dimension( 75, 19 ));
			mdDialog = new BDialog( (BPlugin)client, new BOnDirNamed() );
			mdDialog.show( mdPanel, new BString( this, "newdir" ) );
		}
	}

	/**
	 * Listens to the OK button in the make directory dialog
	 */
	class BOnMkdirOK implements ActionListener
	{

		public void actionPerformed( ActionEvent event )
		{
			mdDialog.close( BDialog.kOK );
		}
	}

	/**
	 * listens to the cancel button on the make directory dialog
	 */
	class BOnMkdirCancel implements ActionListener
	{
		public void actionPerformed( ActionEvent event )
		{
			mdDialog.close( BDialog.kCancel );
		}
	}


	class BOnDirNamed implements BDialogDone
	{
		/**
		 * called when the make directory dialog is closed
		 */
		public void onClose( BDialog sender, int status )
		{
			if ( status == BDialog.kOK )
			{
				String dirName = mdTextField.getText();
				if ( dirName != "" )
				{
					File newDir = client.makeFile(ciCurrentDir + File.separator +dirName);
					if( newDir.mkdir() )
					{
						BMetaData metaData = new BMetaData();
						metaData.setType( "d" );
						metaData.setFileName( newDir.getName() );
						metaData.setOwner( user.getUniqueID().intValue() );
						metaData.setDate( newDir.lastModified() );
						client.setClientMetaData( ciCurrentDir + File.separator + dirName, metaData );
						BResFileModel fileModel = checkIn.getTableModel();
						fileModel.clear();
						getClientDir( ciCurrentDir, fileModel );
					}
				}
			}
		}
	}

	/**
	 * Action Listener that listens to the check out option
	 */
	class BOnPopupGet implements ActionListener
	{
		public void actionPerformed( ActionEvent event )
		{
			int i = 0;
			String [] params = checkOut.getSelectedFiles();
			while(i < params.length)
			{
				int versionToGet = -1; // default
				Debug.doPrintln("getting file" + params[i]);
				BResFileModel fileModel = checkOut.getTableModel();
				String fileType = fileModel.getType( params[i] );
				if( !checkOutChkBox.isSelected() )
				{
					versionDlg = new BDialog( client, new BOnVersionSelected(params[i]) );
					verPanel = new JPanel();
					verLabel = new JLabel(BDialect.getString( this, "Version" ) );
					versions = new JComboBox();
					for( int j = fileModel.getVersion( params[i] ); j > 0; j-- )
					{
						versions.addItem(new Integer(j));
					}
					JButton okButton = new JButton(BDialect.getString("ok"));
					JButton cancelButton = new JButton(BDialect.getString("cancel"));
					okButton.addActionListener( new ActionListener(){
						public void actionPerformed( ActionEvent okEvent )
						{
							versionDlg.close(BDialog.kOK);
						}
					});
					cancelButton.addActionListener( new ActionListener(){
						public void actionPerformed( ActionEvent cancelEvent )
						{
							versionDlg.close(BDialog.kCancel);
						}
					});
					verPanel.add( "Center", verLabel );
					verPanel.add( "Center", versions );
					verPanel.add( "South", okButton );
					verPanel.add( "South", cancelButton );
					verPanel.setSize(140, 120);
					versionDlg.show(verPanel, new BString(this, "Version"));
				}
				else
				{
					if( fileType != null )
					{
						if( fileType.equals("d") )
						{
							//traverse tree here
							BGetFilesCE getMultiEvent = new BGetFilesCE( this, params[i], new BOnMultiFileGetComplete() );
							//getMultiEvent.setVersion( versionToGet );
							client.dispatchEventServer( getMultiEvent );
						}
						else
						{
							//not a directory so get file
							BGetFileCE getEvent = new BGetFileCE(this, params[i], new BOnFileGetComplete() );
							getEvent.setVersion(versionToGet);
							client.dispatchEventServer(getEvent);
						}
					}
				}
				i++;
			}

		}

		class BOnVersionSelected implements BDialogDone
		{
			String filename;

			public BOnVersionSelected(String fFilename)
			{
				this.filename = fFilename;
			}

			public void onClose( BDialog dlg, int status )
			{
				if(status == BDialog.kOK)
				{
					int versionToGet = ((Integer) versions.getSelectedItem()).intValue();
					BResFileModel fileModel = checkOut.getTableModel();
					String fileType = fileModel.getType( this.filename );
					if( fileType != null )
					{
						if( fileType.equals("d") )
						{
							//traverse tree here
							BGetFilesCE getMultiEvent = new BGetFilesCE( this, filename, new BOnMultiFileGetComplete() );
							//getMultiEvent.setVersion( versionToGet );
							client.dispatchEventServer( getMultiEvent );
						}
						else
						{
							//not a directory so get file
							BGetFileCE getEvent = new BGetFileCE(this, filename, new BOnFileGetComplete() );
							getEvent.setVersion(versionToGet);
							client.dispatchEventServer(getEvent);
						}
					}
				}
			}
		}

  	}

  	/**
  	 * Completion Object that is run once the files have been got
  	 */
  	class BOnFileGetComplete extends BCommandComplete
	{
		public void doComplete( BCommandEvent event, int status )
		{
			if(status == BCommandComplete.kSuccess)
			{
				BGetFileCE getEvent = (BGetFileCE) event;

				BFile data = getEvent.getData();

				if(getEvent.getError() != BRepositoryCE.kErrorNoError)
				{
					Debug.doPrintln("Get failed.  Error = " + getEvent.getErrorString());
					BStandardOutCE errorMsg = new BStandardOutCE( this, getEvent.getErrorString() );
					errorMsg.setMessageType(BStandardOutCE.kWarning);
					client.dispatchEvent( errorMsg );
				}
				else
				{
					Debug.doPrintln("Got " + getEvent.getFileName());
					File destination = client.makeFile(getEvent.getFileName());
					File directory = destination.getParentFile();
					makePath( directory );
					data.expand(destination);
					getEvent.getMetaData().setDate(destination.lastModified());
					client.setClientMetaData(getEvent.getFileName(), getEvent.getMetaData());
				}
			}
		}

		private boolean makePath( File dir)
		{
			if(!dir.exists())
			{
				File parent = dir.getParentFile();
				if ( !parent.exists() )
				{
					makePath( parent );
				}
				if(dir.mkdir())
				{
					BMetaData metaData = new BMetaData();
					metaData.setType( "d" );
					metaData.setFileName( dir.getName() );
					metaData.setOwner( user.getUniqueID().intValue() );
					metaData.setDate( dir.lastModified() );
					client.setClientMetaData( dir, metaData );
				}
			}
			return true;
		}
	}

	class BOnMultiFileGetComplete extends BCommandComplete
	{
		public void doComplete( BCommandEvent event, int status )
		{
			if(status == BCommandComplete.kSuccess)
			{
				BGetFilesCE getFiles = (BGetFilesCE) event;

				if( getFiles.getError() != BRepositoryCE.kErrorNoError)
				{
					Debug.doPrintln("Get Failed.  Error = " + getFiles.getErrorString());
					BStandardOutCE errorMsg = new BStandardOutCE( this, getFiles.getErrorString() );
					errorMsg.setMessageType( BStandardOutCE.kWarning );
					client.dispatchEvent( errorMsg );
				}
				else
				{
					Debug.doPrintln("Success: got " + getFiles.getFileCount() + " files");
					for (int i = 0; i < getFiles.getFileCount(); i++)
					{
						File destination = client.makeFile(getFiles.getFileName(i));
						File directory = destination.getParentFile();
						makePath( directory );
						BFile data = getFiles.getData(i);
						data.expand(destination);
						getFiles.getMetaData(i).setDate(destination.lastModified());
						client.setClientMetaData(getFiles.getFileName(i), getFiles.getMetaData(i));
					}
				}
			}
		}

		private boolean makePath( File dir)
		{
			if(!dir.exists())
			{
				File parent = dir.getParentFile();
				if ( !parent.exists() )
				{
					makePath( parent );
				}
				if(dir.mkdir())
				{
					BMetaData metaData = new BMetaData();
					metaData.setType( "d" );
					metaData.setFileName( dir.getName() );
					metaData.setOwner( user.getUniqueID().intValue() );
					metaData.setDate( dir.lastModified() );
					client.setClientMetaData( dir, metaData );
				}
			}
			return true;
		}
	}


	/**
	 * Action Listner Listens the the change permissions option in the popup menu
	 * or from the button on the check out panel
	 */
	class BOnPopupChmod implements ActionListener
	{
		public void actionPerformed( ActionEvent event )
		{
			if( checkOut.isFileSelected() )
			{
				String file = checkOut.getSelectedFile();
				Debug.doPrintln("getting file" + file);
				BStatFileCE getStat = new BStatFileCE(this, file, new BOnChangePermPopup());
				client.dispatchEventServer(getStat);
			}
		}
  	}

  	/**
  	 * Listens to double clicks on the file table and if
  	 * it is a directory it moves the file list to that direcectory
  	 */
  	class BCIMouseListener extends MouseAdapter
	{

		public void mouseClicked( MouseEvent event )
		{
			if (event.getClickCount() == 2)
			{
				if ( checkIn.isFileSelected() )
				{
					String fileName = checkIn.getSelectedFile();
					String currentDir = checkIn.getCurrentDir();
					Debug.doPrintln( "File Selected is : " + currentDir + fileName + File.separator );
					//BStatFileCE statEvent = new BStatFileCE( this, fileName, new BCheckIfDirCC( checkIn, fileName ) );
					//client.dispatchEventServer(statEvent);
					if ( isDir( currentDir + fileName + File.separator ) )
					{

						currentDir = currentDir + fileName + File.separator;
						Debug.doPrintln("The new dir will be " + currentDir);
						BResFileModel fileModel = checkIn.getTableModel();
						fileModel.clear();
						getClientDir(currentDir, fileModel );
						checkIn.addDir( currentDir );
						checkIn.setCurrentDir( currentDir );
						updateDir();
					}
				}
			}
		}
	}//BCIMouseListener


	/**
	 * Listens to double clicks on the file table and if
	 * it is a directory it moves the file list to that direcectory
  	 */
	class BCOMouseListener extends MouseAdapter
	{
		public void mouseClicked( MouseEvent event )
		{
			if ( event.getClickCount() == 2 )
			{
				if ( checkOut.isFileSelected() )
				{
					String fileName = checkOut.getSelectedFile();
					Debug.doPrintln( "File Selected is : " + fileName );
					BStatFileCE statEvent = new BStatFileCE( this, fileName, new BCheckIfDirCC( checkOut, fileName ) );
					client.dispatchEventServer(statEvent);
				}
			}
		}
	}//BCOMouseListener


	/**
	 * Completion Object that returns the result of a request to the
	 * server to see if a file is a directory
	 */
	class BCheckIfDirCC extends BCommandComplete
	{
		BRepositoryPanel panel;
		String fileName;
		String currentDir;

		public BCheckIfDirCC( BRepositoryPanel repPanel, String file )
		{
			this.panel = repPanel;
			this.fileName = file;
		}

		public void doComplete( BCommandEvent event, int status )
		{
			BStatFileCE statEvent = (BStatFileCE) event;
			if ( statEvent.isDirectory() )
			{
				currentDir = panel.getCurrentDir();
				currentDir = fileName ;
				Debug.doPrintln("The new dir will be " + currentDir);
				BResFileModel fileModel = this.panel.getTableModel();
				fileModel.clear();
				client.getDir(currentDir, fileModel );
				this.panel.addDir( currentDir );
				this.panel.setCurrentDir( currentDir );
				updateDir();
			}
		}
	}//BCheckIfDirCC


	/**
	 * Action listener for the combo box on the check in panel
	 */
	class BCIComboListener implements ActionListener
	{
		public void actionPerformed( ActionEvent event )
		{
			String fileName = checkIn.getComboText();
			Debug.doPrintln( "Dir Selected is : " + fileName );
			//if ( isDir( fileName ) )
			//{
				ciCurrentDir = fileName;
				BResFileModel fileModel = checkIn.getTableModel();
				fileModel.clear();
				getClientDir(ciCurrentDir, fileModel );
				checkIn.setCurrentDir( ciCurrentDir );
			//}
		}
	}//BCiComboListener

	/**
	 * Action Listener for the combo box on the check out panel
	 */
	class BCOComboListener implements ActionListener
	{
		public void actionPerformed( ActionEvent event )
		{
			String fileName = checkOut.getComboText();
			Debug.doPrintln( "Dir Selected is : " + fileName );
			//if ( isDir( fileName ) )
			//{
				coCurrentDir = fileName;
				BResFileModel fileModel = checkOut.getTableModel();
				fileModel.clear();
				client.getDir(coCurrentDir, fileModel );
				checkOut.setCurrentDir( coCurrentDir );
			//}
		}
	}//BCOComboListener

	/**
	 * This is a list selection listener for the file list in the check out gui
	 */
	class BListSelectionListener implements ListSelectionListener
	{
		public void valueChanged( ListSelectionEvent event )
		{
			if( checkOut.isFileSelected() )
			{
				checkOutOK.setEnabled( true );
				checkOutChange.setEnabled( true );
			}
		}
	}

	//|||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||

	class BOnPutComplete extends BCommandComplete
	{
		public void doComplete( BCommandEvent event, int status)
		{
			if(status == BCommandComplete.kSuccess)
			{
				Debug.doPrintln("OnPutComplete called");
				BPutFileCE putEvent = (BPutFileCE) event;

				if(putEvent.getError() == 0)
				{
					Debug.doPrintln("Success");
					BResFileModel fileModel = checkIn.getTableModel();
					File destination = client.makeFile(putEvent.getFileName());
					putEvent.getMetaData().setDate(destination.lastModified());
					client.setClientMetaData(putEvent.getFileName(), putEvent.getMetaData());
					fileModel.clear();
					getClientDir(ciCurrentDir, fileModel );
				}
				else
				{
					client.dispatchEvent(new BStandardOutCE(this, putEvent.getFileName() + ": " + putEvent.getErrorString(), false, BStandardOutCE.kError, null));
					Debug.doPrintln("Error " + putEvent.getErrorString());
				}
			}
		}
	}

	class BOnChangePermPopup extends BCommandComplete
	{
		public void doComplete( BCommandEvent event, int status )
		{
			if(status == BCommandComplete.kSuccess)
			{
				BStatFileCE getStat = (BStatFileCE) event;

				BMetaData data = getStat.getMetaData();

				if(getStat.getError() != BRepositoryCE.kErrorNoError)
				{
					Debug.doPrintln("Stat failed.  Error = " + getStat.getErrorString());
					BStandardOutCE errorMsg = new BStandardOutCE( this, getStat.getErrorString());
					errorMsg.setMessageType( BStandardOutCE.kWarning );
					client.dispatchEvent( errorMsg );
				}
				else
				{
					Debug.doPrintln("Got Stat " + getStat.getFileName());
					if ( data != null )
					{
						BACL acl = data.getACL();
						BGetUserCE getUser = new BGetUserCE(this, null);
						BBlockingComplete complete = client.dispatchEventAndWait( getUser );
						getUser = (BGetUserCE) complete.getEvent();
						BUser user = getUser.getUser();//*/
						Vector groups = getStat.getGroups();
						Vector groupIDs = new Vector();
						Vector groupNames = new Vector();
						for( int i = 0; i < groups.size(); i++ )
						{
							BGroup group = (BGroup)groups.get(i);
							groupIDs.add( group.getUniqueID() );
							groupNames.add( group.getName() );
						}
						Vector users = getStat.getUsers();
						Vector userIDs = new Vector();
						Vector userNames = new Vector();
						for( int i = 0; i < users.size(); i++ )
						{
							BUser tmpuser = (BUser) users.get(i);
							userIDs.add( tmpuser.getUniqueID() );
							userNames.add( tmpuser.getName() );
						}
						String [] descriptors = acl.getDescriptorsStrings();
						checkOut.clearText();
						for( int i = 0; i < descriptors.length; i++ )
						{
							checkOut.putText(descriptors[i]);
						}
						if( descriptors.length == 0 )
						{
							checkOut.putText(BDialect.getString( this, "nopermset"));
						}
						checkOut.putText(BDialect.getString( this, "owneraccess"));
						BChgPermPanel chmodPanel = new BChgPermPanel( getStat.getFileName(), (String)userNames.get( userIDs.indexOf(new Long(getStat.getMetaData().getOwner())) ), new Long(getStat.getMetaData().getOwner()), user );
						//Debug.doPrintln("Got user " + user.getFullName() + " who is in " + user.getGroups().size() + " Groups" );
						chmodPanel.setDescriptors( acl.getDescriptors() );
						chmodPanel.setGroups( groupIDs, groupNames );
						chmodPanel.setUsers( userIDs, userNames );
						BAddWindowCE addEvent = new BAddWindowCE( this, chmodPanel, new BString( this, "chgperm" ), null );
						addEvent.setDialog( true );
						BBlockingComplete permComplete = client.dispatchEventAndWait( addEvent );

						if (permComplete.getStatus() == BCommandComplete.kSuccess)
						{

							Vector newDescriptors = chmodPanel.getDescriptors();
							Debug.doPrintln("Got " + newDescriptors.size() + " Descriptors");
							BSetSecurityCE securityEvent = new BSetSecurityCE( this, getStat.getFileName(), new BOnPermissionsSet() );
							securityEvent.setMetaData( getStat.getMetaData() );
							securityEvent.getMetaData().setOwner( ((Long)userIDs.get( userNames.indexOf( chmodPanel.getOwner() ) )).intValue() );
							Debug.doPrintln("Owner of file is " + chmodPanel.getOwner() + " ID " + ((Long)userIDs.get( userNames.indexOf( chmodPanel.getOwner() ) )).intValue() );
							securityEvent.getMetaData().getACL().clear();
							for ( int i = 0; i < newDescriptors.size(); i++ )
							{
								Debug.doPrintln( " i == " + i + "newDescriptor size == " + newDescriptors.size());
								if (securityEvent.getMetaData().getACL().addDescriptor( ((BDescriptor) newDescriptors.get(i)).toString() ))
								{
									Debug.doPrintln( "In popupChown: descriptor added " + (BDescriptor) newDescriptors.get(i) );
								}
								else
								{
									Debug.doPrintln( "In popupChown: malformed descriptor " + (BDescriptor) newDescriptors.get(i) );
								}
							}
							descriptors = acl.getDescriptorsStrings();
							checkOut.clearText();
							for( int i = 0; i < descriptors.length; i++ )
							{
								checkOut.putText(descriptors[i]);
							}
							checkOut.putText(BDialect.getString( this, "owneraccess"));
							client.dispatchEventServer(securityEvent);
						}
					}
				}
			}
		} //doComplete
	}//BOnPChangePermPopup





	class BOnPermissionsSet extends BCommandComplete
	{
		public void doComplete( BCommandEvent event, int status )
		{
			if(status == BCommandComplete.kSuccess)
			{
				BSetSecurityCE securityEvent = (BSetSecurityCE) event;
				if(securityEvent.getError() == BRepositoryCE.kErrorNoError)
				{
					Debug.doPrintln("OK");
				}
				else
				{
					Debug.doPrintln("Error " + securityEvent.getErrorString());
					BStandardOutCE errorMsg = new BStandardOutCE( this, securityEvent.getErrorString() );
					errorMsg.setMessageType( BStandardOutCE.kWarning );
					client.dispatchEvent( errorMsg );
				}
			}
		}
	}

}
