//$Header: /teamproj/cvsroot/teamb/bkasrc/au/edu/swin/synergy/plugin/smtpsvr/BSmtp.java,v 1.4 1999/08/28 10:20:25 tp079519 Exp $

package au.edu.swin.synergy.plugin.smtpsvr;

/**
 *  The BSmtp class provides a way of sending e-mail via the Simple Mail Transfer Protocol
 *
 *  smtp session = new smtp("europa");
 *  session.doSendMessage("from", "to", "subject", "message");
 *  // repeat as necessary
 *
 *  session.doFinish();
 *
 * The addresses can be "John Newbigin <jn@it.swin.edu.au>" or just "jn@it.swin.edu.au"
 *
 *  @author John Newbigin
 *
 * Please complete these missing tags
 * @copyright
 */


import java.io.*;
import java.net.*;

public class BSmtp
{
    String server;
    InputStream socketIn;
    OutputStream socketOut;
    
    Socket socket;
    /**
     * Please complete the missing tags for BSmtp
     * @param
     * @return
     * @pre
     * @post
     */
    
    public BSmtp( String server )
    {
        this.server = server;
    }
    
    /**
     * connect to the mail server
     * Please complete the missing tags for connect
     * @param
     * @return
     * @pre
     * @post
     */
    public void connect()
    {
        try
        {
            socket = new Socket( server, 25 );
            socketIn = socket.getInputStream();
            socketOut = socket.getOutputStream();
            
            String s = readString();
            
            if( getCode( s ) == 220 )
            {
                sayHelo();
            }
        }
        catch( Exception e )
        {
            e.printStackTrace();
        }
    }
    /**
     * Please complete the missing tags for sayHelo
     * @param
     * @return
     * @pre
     * @post
     */
    
    int sayHelo() throws IOException
    {
        String str;
        
        writeString( "HELO " + InetAddress.getLocalHost().getHostName() );
        str = readString();
        
        if( getCode( str ) != 250 )
        {
            return 1;
        }
        
        return 0;
    }
    ;
    /**
     * Please complete the missing tags for sayBye
     * @param
     * @return
     * @pre
     * @post
     */
    
    int sayBye() throws IOException
    {
        String str;
        
        writeString( "QUIT" );
        
        str = readString();
        
        if( getCode( str ) != 221 )
        {
            return 1;
        }
        return 0;
    }
    ;
    /**
     * Please complete the missing tags for doFinish
     * @param
     * @return
     * @pre
     * @post
     */
    
    public void doFinish() throws IOException
    {
        sayBye();
        socket.close();
    }
    /**
     * Please complete the missing tags for doSendMessage
     * @param
     * @return
     * @pre
     * @post
     */
    
    public int doSendMessage( String from, String to, String subject, String msg ) throws IOException
    {
        String str;
        
        writeString( "MAIL FROM: " + stripAddress( from ) );
        str = readString();
        
        if( getCode( str ) != 250 )
        {
            return 1;
        }
        
        writeString( "RCPT TO: " + stripAddress( to ) );
        str = readString();
        
        if( getCode( str ) != 250 )
        {
            return 1;
        }
        
        writeString( "DATA" );
        str = readString();
        
        if( getCode( str ) != 354 )
        {
            return 1;
        }
        
        writeString( "To: " + to );
        writeString( "From: " + from );
        writeString( "Subject: " + subject );
        
        int i;
        String line = new String();
        
        for( i = 0; i < msg.length(); i++ )
        {
            char character = msg.charAt( i );
            
            if( character == '\r' )
            {
                // skip it
            }
            else if( character == '\n' )
            {
                sendLine( line );
                line = new String();
            }
            else
            {
                line = line + character;
            }
        }
        
        sendLine( line );
        writeString( "." );
        str = readString();
        
        if( getCode( str ) != 250 )
        {
            return 1;
        }
        
        return 0;
    }
    /**
     * Please complete the missing tags for changeMailServer
     * @param
     * @return
     * @pre
     * @post
     */
    
    public void changeMailServer( String newServer )
    {
        this.server = newServer;
    }
    /**
     * Please complete the missing tags for getCode
     * @param
     * @return
     * @pre
     * @post
     */
    
    /*
  *  Return the number at the start of the string....
  */
    
    int getCode( String str )
    {
        String num = new String();
        
        int i;
        
        for( i = 0; i < str.length(); i++ )
        {
            char character = str.charAt( i );
            
            if( ( character >= '0' ) && ( character <= '9' ) )
            {
                num = num + character;
            }
            else
            {
                break;
            }
        }
        
        return Integer.parseInt( num );
    }
    /**
     * Please complete the missing tags for sendLine
     * @param
     * @return
     * @pre
     * @post
     */
    
    
    void sendLine( String line ) throws IOException
    {
        // we need to escape any line that it just a series of dots....
        int dots = 0;
        
        while( dots < line.length() )
        {
            if( line.charAt( dots ) == '.' )
            {
                dots++;
            }
            else
            {
                break;
            }
        }
        
        if( ( dots == line.length() ) && ( dots > 0 ) )
        {
            line = line + '.';
        }
        
        writeString( line );
    }
    /**
     * Please complete the missing tags for writeString
     * @param
     * @return
     * @pre
     * @post
     */
    
    void writeString( String str ) throws IOException
    {
        socketOut.write( str.getBytes() );
        socketOut.write( "\r\n" .getBytes() );
    }
    /**
     * Please complete the missing tags for readString
     * @param
     * @return
     * @pre
     * @post
     */
    
    String readString() throws IOException
    {
        String str = new String();
        while( true )
        {
            int character = socketIn.read();
            if( ( character == - 1 ) || ( character == 10 ) )
            {
                break;
            }
            else if( character == 13 )
            {
                // skip
            }
            else
            {
                str = str + ( char ) character;
            }
        }
        return str;
    }
    
    /**
     *  If there is a <email@address> then return it, otherwise return the whole string
     * Please complete the missing tags for stripAddress
     * @param
     * @return
     * @pre
     * @post
     */
    private String stripAddress( String str )
    {
        int start = str.indexOf( '<' );
        
        if( start >= 0 )
        {
            int end = str.indexOf( '>' );
            if( end < start )
            {
                // this is an error, but we will return to the end of the string
                end = str.length();
            }
            
            return str.substring( start + 1, end );
        }
        else
        {
            return str;
        }
    }
}
;
