// $Header: /teamproj/cvsroot/teamb/bkasrc/au/edu/swin/synergy/plugin/smtpsvr/BSmtpSvr.java,v 1.9 1999/10/05 12:00:53 tp082177 Exp $

//Title:        BKA
//Version:      
//Copyright:    Copyright (c) 1998
//Author:       Matthew Evans
//Company:      Swinburne School of IT
//Description:  Your description


package au.edu.swin.synergy.plugin.smtpsvr;

import au.edu.swin.synergy.kernel.BPlugin;
import au.edu.swin.synergy.kernel.*;
import au.edu.swin.synergy.debug.Debug;
import au.edu.swin.synergy.plugin.smtpsvr.event.BMailCE;
import au.edu.swin.synergy.plugin.mailclient.BMessage;
import au.edu.swin.synergy.lib.BStringList;
import au.edu.swin.synergy.plugin.userdb.BUser;
import au.edu.swin.synergy.plugin.server.event.BGetUserCE;

/**
 * BSmtpSvr acts as the server for outgoing SMTP mail distribution for
 * cohesion clients
 *
 * @author Matthew Evans
 * Please complete these missing tags
 * @copyright
 */
public class BSmtpSvr extends BPlugin
{
    /**
     * The connection to a mail server
     */
    private BSmtp smtpConnection;
    
    /**
     * Creates a BSmtp object to send messages through
     * Please complete the missing tags for setup
     * @param
     * @return
     * @pre
     * @post
     */
    public void setup(BStringList params)
    {
	 	  if (params.getCount() > 1)
		  {
            smtpConnection = new BSmtp(params.get(1));
        }
    }
    
    /**
     * Listens for mail events, and if one is detected, the event is forwarded
     * to the sendMessage()
     *
     * @param the source of the command event
     * @param the event
     * Please complete the missing tags for onBCommandEvent
     * @return
     * @pre
     * @post
     */
    public void onBCommandEvent( Object source, BCommandEvent event )
    {
        if( event instanceof BMailCE )
        {
            BMailCE mailEvent = ( BMailCE ) event;
            BMessage message = mailEvent.getMessage();
				BGetUserCE getUserEvent = new BGetUserCE(this, event.getConnectionID(), null);
				BBlockingComplete getUserComplete = dispatchEventServerAndWait(getUserEvent);

				if(getUserComplete.getStatus() == BCommandComplete.kSuccess)
				{
					getUserEvent = (BGetUserCE) getUserComplete.getEvent();
					BUser userDetails = getUserEvent.getUser();

					message.setSender(userDetails.getFullName() + " <" + userDetails.getEmailAddress() + ">");
					this.sendMessage(message);
				}
				else
				{
					Debug.doPrintln("error sending SMTP message.");
				}
					
				
            Debug.doPrintln( "BSmtpSvr: onCE: finished sending message" );
            event.doComplete( BCommandEvent.kServerDone );
        }
    }
    
    /**
     * Send the message to any email receivers in te mail event
     *
     * @param the mail event containing the message information
     * Please complete the missing tags for sendMessage
     * @return
     * @pre
     * @post
     */
    public void sendMessage( BMessage mailData )
    {
        BStringList receivers = mailData.getReceivers();
        
        for( int i = 0; i < receivers.getCount(); i++ )
        {
            //check this is an smtp receiver (and not a direct msg receiver)
            if( receivers.get( i ).indexOf( "@" ) != - 1 )
            {
                Debug.doPrintln( "\nBSmtpSvr: sendMessage: sending an SMTP message" );
                try
                {
                    smtpConnection.connect();

                    smtpConnection.doSendMessage( mailData.getSender(), receivers.get( i ),
                    mailData.getSubject(), mailData.getMessage() );
                    
                    smtpConnection.doFinish();
                }
                catch( java.io.IOException ioException )
                {
                    ioException.printStackTrace();
                }
            }
        }
    }
    
}
