/**
 * Please complete these missing tags
 * @see
 * @concurrency
 * @copyright
 * @rref
 */
//$Header: /teamproj/cvsroot/teamb/bkasrc/au/edu/swin/synergy/plugin/userdb/BUser.java,v 1.13 1999/09/12 06:53:36 tp079519 Exp $
//Title:        Cohesion
//Version:
//Copyright:    Copyright (c) 1998
//Author:       Tristan Austin
//Company:      Synergy
//Description:  Functional prototype for Insync


package au.edu.swin.synergy.plugin.userdb;

import java.lang.String;
import java.io.Serializable;
import java.util.Vector;

/**
 * A BUser provides the details of a particular user
 * including their name, their location (ip address etc.)
 * and other details associated with each user.
 *
 * @author Tristan Austin
 * modified by John Newbigin
 */
public class BUser extends BPrivileged implements Serializable
{
	static final long serialVersionUID = -2391485312219133852L;

    /**
     * The password of the user
	 * This is tramsient for security reasons
     */
    transient private String password = null;
    
    /**
     * The full name of the user
     */
    private String fullName;
    
    /**
     * The alias this user likes to go by
     */
    private String alias;
    
    /**
     * The email address of the user
     */
    private String emailAddress;
	
    /**
     * The list of group numbers this user is a member of
     */
    private Vector groups = null;
 
    /**
     * This is simply the default constructor. It may
     * be used to create an empty user to be filled in.
     * Please complete the missing tags for BUser
     * @param
     * @return
     * @pre
     * @post
     */
    public BUser()
    {
        super();
    }
    
    /**
     * Creates a user object with the given user name and
     * the ip address of the client machine
     * Please complete the missing tags for BUser
     * @param
     * @return
     * @pre
     * @post
     */
    public BUser( String userName ) throws BInvalidPropertyException
    {
        super( userName );
    }
    /**
     * Please complete the missing tags for BUser
     * @post
     * @pre
     * @throws
     * @return
     * @param
     */
    
    /**
     * Creates a user object with the given user name and
     * the ip address of the client machine
     */
    public BUser( Long uniqueID, String userName ) throws BInvalidPropertyException
    {
        super( uniqueID, userName );
    }
    /**
     * Please complete the missing tags for getPassword
     * @post
     * @pre
     * @throws
     * @return
     */
    
    /**
     * Gets this users password
     *
     * @param   Gets the unecrypted password
     */
    
    public String getPassword()
    {
        return this.password;
    }
    /**
     * Please complete the missing tags for setPassword
     * @post
     * @pre
     * @throws
     * @return
     */
    
    /**
     * Enables the setting to password.
     *
     * @param   password The unencrypted password of the user
     */
    public void setPassword( String fPassword )
    {
        this.password = fPassword;
    }
    
    
    /**
     * Please complete the missing tags for getFullName
     * @post
     * @pre
     * @throws
     * @param
     */
    
    /**
     * Gets the full name of the user
     *
     * @return The full name of the user
     */
    public String getFullName()
    {
        return this.fullName;
    }
    /**
     * Please complete the missing tags for setFullName
     * @post
     * @pre
     * @throws
     * @return
     */
    
    /**
     * Sets the users full name to that specified
     *
     * @param   newFullName The new full name of the user
     */
    public void setFullName( String newFullName )
    {
        this.fullName = newFullName;
    }
    /**
     * Please complete the missing tags for getEmailAddress
     * @post
     * @pre
     * @throws
     * @param
     */
    
    /**
     * Gets the users email address
     *
     * @return The users email address
     */
    public String getEmailAddress()
    {
        return emailAddress;
    }
    /**
     * Please complete the missing tags for setEmailAddress
     * @post
     * @pre
     * @throws
     * @return
     */
    
    /**
     * Sets the users email address
     *
     * @param   newEmailAddress   Their new email address
     */
    public void setEmailAddress( String newEmailAddress )
    {
        this.emailAddress = newEmailAddress;
    }
    
    /**
     * Gets the alias of this user
     *
     * @return The alias of this user as a String.
     * Please complete the missing tags for getAlias
     * @param
     * @pre
     * @post
     */
    public String getAlias()
    {
        return this.alias;
    }
    
    /**
     * Sets this users alias to the value specified
     *
     * @param   alias   The new alias for this user
     * Please complete the missing tags for setAlias
     * @return
     * @pre
     * @post
     */
    public void setAlias( String alias )
    {
        this.alias = alias;
    }

	public Vector getGroups()
	{
		return groups;
	}

	public void setGroups(Vector fGroups)
	{
		groups = fGroups;
	}

	public boolean isInGroup(int group)
	{
		if(groups != null)
		{
			for(int i=0; i<groups.size(); i++)
			{
				if(((Long)groups.get(i)).intValue() == group)
				{
					return true;
				}
			}
		}
		return false;
	}

}
