/**
 * Please complete these missing tags
 * @see
 * @concurrency
 * @copyright
 * @rref
 * @author
 */
// $Header: /teamproj/cvsroot/teamb/bkasrc/au/edu/swin/synergy/plugin/userdb/event/BAddUserCE.java,v 1.6 1999/09/02 06:33:54 tp079210 Exp $

package au.edu.swin.synergy.plugin.userdb.event;

import java.util.Vector;
import au.edu.swin.synergy.kernel.BCommandEvent;
import au.edu.swin.synergy.kernel.BCommandComplete;
import au.edu.swin.synergy.plugin.userdb.BUser;


/**
 * This is the event which is passed around
 * when the user manager gets the event, it will create a
 * vector containing the users
 * it then calls the completion object which can do what it
 * wants with the data.
 * the completeion object is run in the thread of the event.
 */
public class BAddUserCE extends BUpdateUserCE
{
    /**
     * The user name entered is not a unique user name in the database
     */
    public static final int kNonUniqueUserName = 100;

    /**
     * This is the initial password for the user
     */
    private String initialPassword = "";

    /**
     * Creates a new BAddUserCE object with the updated user.
     *
     * @param   source  The source of the event
     * @param   fUser   The updated user
     * @param   complete    The complete object to call when done
     * Please complete the missing tags for BAddUserCE
     * @return
     * @pre
     * @post
     */
    public BAddUserCE( Object source, BUser fUser, String initialPassword, BCommandComplete complete )
    {
        super( source, fUser, complete );
        this.initialPassword = initialPassword;
    }

    /**
     * Gets the password to be used as the new users
     * initial password. This password will be unecrypted.
     *
     * @return  The unencrypted initial password for the new user
     */
    public String getInitialPassword()
    {
        return this.initialPassword;
    }
}
