// $Header: /teamproj/cvsroot/teamb/bkasrc/au/edu/swin/synergy/plugin/userdb/event/BChangePasswordCE.java,v 1.5 1999/09/02 06:33:54 tp079210 Exp $


package au.edu.swin.synergy.plugin.userdb.event;

import au.edu.swin.synergy.kernel.BCommandEvent;
import au.edu.swin.synergy.kernel.BCommandComplete;

import au.edu.swin.synergy.plugin.userdb.BUser;

/**
 * This will accept the users new and old passwords
 * to update the users with and make sure that the old
 * password matches the stored password before updating
 * the user.
 *
 * @author Tristan Austin
 * Please complete these missing tags
 * @copyright
 */
public class BChangePasswordCE extends BOwnerCE
{
    /**
     * Indicates that the password was succesfully changed
     */
    public static final int kChanged = 0;
    
    /**
     * Indicates that the user could not be found
     */
    public static final int kNoUser = 1;
    
    /**
     * Indicates that the original password was wrong
     */
    public static final int kWrongPassword = 2;

    /**
     * The constant indicating what went wrong, if anything
     */
    private int state = - 1;

    /**
     * The the old password of the user
     */
    private String oldPassword = null;
    
    /**
     * The password to change to
     */
    private String newPassword = null;
    
    /**
     * Creates a new change password event with the old and new passwords along
     * with the source of the event and the completion object to call when it
     * is complete with the success or failure of the process.
     *
     * @pre The new password has been confirmed with the user
     * @param   source  The source of the event
     * @param   oldPassword The old password to check
     * @param   newPassword The password to change to if old password matches
     * @param   complete    The object which will be told of the success or failure of the procedure
     * Please complete the missing tags for BChangePasswordCE
     * @return
     * @post
     */
    public BChangePasswordCE( Object source, BUser user, String oldPassword, String newPassword, BCommandComplete complete )
    {
        super( source, user, complete );
        this.oldPassword = oldPassword;
        this.newPassword = newPassword;
    }

    /**
     * Gets the old password to make sure the real user is updating
     *
     * @return The old password as a plain text string
     * Please complete the missing tags for getOldPassword
     * @param
     * @pre
     * @post
     */
    public String getOldPassword()
    {
        return this.oldPassword;
    }
    /**
     * Gets the new password to set to
     *
     * @return The new password as a plain text String
     * Please complete the missing tags for getNewPassword
     * @param
     * @pre
     * @post
     */
    public String getNewPassword()
    {
        return this.newPassword;
    }
    
    /**
     * Gets the state of the update from the server.
     *
     * @return The state of the change, kChanged, kNoUser, kWrongPassword
     * Please complete the missing tags for getState
     * @param
     * @pre
     * @post
     */
    public int getState()
    {
        return this.state;
    }
    
    /**
     * Sets the state of the update from the server.
     *
     * @param   state   The state of the change, kChanged, kNoUser, kWrongPassword
     * Please complete the missing tags for setState
     * @return
     * @pre
     * @post
     */
    public void setState( int state )
    {
        this.state = state;
    }
}
