

package au.edu.swin.synergy.plugin.userdb.event;

import au.edu.swin.synergy.plugin.userdb.BPrivileged;
import au.edu.swin.synergy.plugin.userdb.BGroup;

/**
 * When a group is updated in a manner that
 * other plugins may be interested, this event is fired.
 * <p>
 * Plugins may be interested in situations where the name
 * changes, so they can update the interface. Other situations
 * may be when a user is added or a simple change occurs which
 * results in others changing. For example, if you add a user
 * to a group, both the user and group are updated to reflect
 * this.
 * <p>
 * Similarly, when a group privilege is changed, the clients
 * may wish to update immediately so as to reflect the change.
 *
 * @author Tristan Austin
 */
public class BGroupUpdatedCE extends BUpdateNotificationCE
{
    /**
     * Creates a new update notification event with
     * the source specified.
     *
     * @param   source  The source of the event
     */
    public BGroupUpdatedCE(Object source, BGroup updatedGroup, int updateType)
    {
        super(source, updatedGroup, updateType);
    }

    /**
     * Gets the user that was updated.
     *
     * @return The user updated
     */
    public BGroup getUpdatedGroup()
    {
        return (BGroup)super.getUpdatedItem();
    }
}
