// $Header: /teamproj/cvsroot/teamb/bkasrc/au/edu/swin/synergy/plugin/userdb/event/BUpdatePrivilegedCE.java,v 1.8 1999/09/23 00:04:08 tp079210 Exp $


package au.edu.swin.synergy.plugin.userdb.event;

import au.edu.swin.synergy.plugin.userdb.BPrivileged;
import au.edu.swin.synergy.kernel.BCommandEvent;
import au.edu.swin.synergy.kernel.BCommandComplete;

import au.edu.swin.synergy.debug.Debug;

import java.util.Vector;

/**
 * This is the super class for all events doing anything at
 * all with any kind of privileged item. This includes both
 * BUsers and BGroups.
 *
 * @author Tristan Austin
 * Please complete these missing tags
 * @copyright
 */
public abstract class BUpdatePrivilegedCE extends BAdminCE
{
    
    /**
     * Indicates success
     */
    public static final int kSuccess = 0;
    
    /**
     * Indicates failure
     */
    public static final int kFailed = 1;
    
    /**
     * Indicates the user trying to update doesn't have the
     * appropriate privilages to make the attempted update
     */
    public static final int kLowPrivilege = 2;
    
    /**
     * Indicates that the user is was not found to update
     */
    public static final int kNotFound = 3;

    /**
     * Indicates the name is too short
     */
    public static final int kNameTooShort = 4;

    /**
     * Indicates the privilege is invalid
     */
    public static final int kInvalidPrivilege = 5;

    /**
     * The user has tried to delete themselves
     */
    public static final int kDeleteSelf = 6;

    /**
     * The user to be updated
     */
    protected BPrivileged item = null;

    /**
     * The actual status of the update
     */
    private int status = - 1;

    /**
     * Please complete the missing tags for BTestCE
     * @post
     * @pre
     * @throws
     * @return
     * @param
     */

    public BUpdatePrivilegedCE( Object source, BPrivileged newItem, BCommandComplete complete )
    {
        super( source );
        setCompletionObject( complete );
        setItem( newItem );
        // other stuff...
    }
    /**
     * Please complete the missing tags for getMessage
     * @post
     * @pre
     * @throws
     * @return
     * @param
     */

    public BPrivileged getItem()
    {
        return item;
    }
    /**
     * Please complete the missing tags for setUsers
     * @post
     * @pre
     * @throws
     * @return
     * @param
     */
    
    public void setItem( BPrivileged newItem )
    {
        item = newItem;
    }
    
    /**
     * Gets the status of the update to the given value.
     *
     * @return   The status   kSuccess, or kFailure
     * Please complete the missing tags for getStatus
     * @param
     * @pre
     * @post
     */
    public int getStatus()
    {
        return this.status;
    }
    
    /**
     * Sets the status of the update to the given value.
     *
     * @param   status   kSuccess, or kFailure
     * Please complete the missing tags for setStatus
     * @return
     * @pre
     * @post
     */
    public void setStatus( int status )
    {
        this.status = status;
    }
}
