// $Header: /teamproj/cvsroot/teamb/bkasrc/au/edu/swin/synergy/plugin/userman/BChangePassword.java,v 1.13 1999/10/13 03:38:21 tp079210 Exp $

//Title:        User Manager
//Version:
//Copyright:    Copyright (c) 1998
//Author:       Tristan Austin
//Company:      Synergy
//Description:  The user manager for CRUDing users

package au.edu.swin.synergy.plugin.userman;

import java.awt.*;
import javax.swing.*;

import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;

import au.edu.swin.synergy.lib.BGridBagConstraints;
import au.edu.swin.synergy.kernel.BPlugin;
import au.edu.swin.synergy.kernel.BCommandComplete;
import au.edu.swin.synergy.kernel.BCommandEvent;
import au.edu.swin.synergy.plugin.command.event.BStandardOutCE;
import au.edu.swin.synergy.plugin.userdb.event.BChangePasswordCE;
import au.edu.swin.synergy.plugin.userdb.BUser;
import au.edu.swin.synergy.plugin.mod13.event.BCloseWindowCE;
import au.edu.swin.synergy.plugin.mod13.bwt.BSwingUtilities;
import au.edu.swin.synergy.plugin.dialect.BDialect;

import au.edu.swin.synergy.debug.Debug;

/**
 * Allows the user to change their passwords. The checking
 * to make sure both entries of the new password match is
 * all handled internally. Once the users new password
 * is confirmed, a change password is event is sent to the
 * server on the condition that there is a BPlugin to dispatch
 * the event on its behalf.
 *
 * @author Tristan Austin
 * Please complete these missing tags
 * @copyright
 */
public class BChangePassword extends JPanel
{
    JLabel originalLabel = new JLabel();
    JLabel newLabel = new JLabel();
    JLabel reenterLabel = new JLabel();
    JPasswordField originalField = new JPasswordField();
    JPasswordField newField = new JPasswordField();
    JPasswordField reenterField = new JPasswordField();
    JButton okButton = new JButton();
    JButton cancelButton = new JButton();
    GridBagLayout gridBagLayout1 = new GridBagLayout();
    
    /**
     * The plugin responsible for dispatching the events
     */
    private BPlugin eventDispatcher = null;
    
    /**
     * The user to change the password of
     */
    private BUser user = null;
    
    /**
     * The action listener for button events
     */
    private BActionListener actionListener = new BActionListener();

	/**
	 * Indicates whether the editting user is admin
	 */
	boolean isAdmin = false;
	
    /**
     * Creates a new password change panel with the provided
     * plugin which may be utilised to dispatch events to
     * the user database.
     *
     * @param   eventDispatcher The plugin to dispatch events via
     * Please complete the missing tags for BChangePassword
     * @return
     * @pre
     * @post
     */
    public BChangePassword( BPlugin eventDispatcher, BUser user, boolean isAdmin )
    {
        this.isAdmin = isAdmin;
		this.jbInit();
        this.eventDispatcher = eventDispatcher;
        this.user = user;
    }

    /**
     * This method is responsible for updating the text on the screen
     * with the appropriate text for the current Locale.
     */
    public void doDialect()
    {
        BSwingUtilities.setJLabelText(originalLabel, BDialect.getString(this, "passwdo") );
        BSwingUtilities.setJLabelText(reenterLabel, BDialect.getString(this, "passwdr") );
        BSwingUtilities.setJLabelText(newLabel, BDialect.getString(this, "passwdn") );
        BSwingUtilities.setJButtonText(okButton, BDialect.getString("ok") );
        BSwingUtilities.setJButtonText(cancelButton, BDialect.getString("cancel") );
    }

    /**
     * This method will initialise the user interface components
     * Please complete the missing tags for jbInit
     * @param
     * @return
     * @pre
     * @post
     */
    void jbInit() 
    {
        this.setSize( 300, 200 );
        this.setLayout( gridBagLayout1 );
		if (!this.isAdmin)
		{
			this.add( originalLabel, new BGridBagConstraints( 0, 0, 1, 1, 0.0, 0.0
			, GridBagConstraints.EAST, GridBagConstraints.NONE, new Insets( 5, 5, 5, 5 ), 0, 0 ) );
        	this.add( originalField, new BGridBagConstraints( 1, 0, 2, 1, 1.0, 0.0
	        , GridBagConstraints.WEST, GridBagConstraints.HORIZONTAL, new Insets( 5, 5, 5, 5 ), 0, 0 ) );
		}
		this.add( newLabel, new BGridBagConstraints( 0, 1, 1, 1, 0.0, 0.0
		, GridBagConstraints.EAST, GridBagConstraints.NONE, new Insets( 5, 5, 5, 5 ), 0, 0 ) );
		this.add( reenterLabel, new BGridBagConstraints( 0, 2, 1, 1, 0.0, 0.0
		, GridBagConstraints.EAST, GridBagConstraints.NONE, new Insets( 5, 5, 5, 5 ), 0, 0 ) );
        this.add( newField, new BGridBagConstraints( 1, 1, 2, 1, 1.0, 0.0
        , GridBagConstraints.WEST, GridBagConstraints.HORIZONTAL, new Insets( 5, 5, 5, 5 ), 0, 0 ) );
        this.add( reenterField, new BGridBagConstraints( 1, 2, 2, 1, 1.0, 0.0
        , GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL, new Insets( 5, 5, 5, 5 ), 0, 0 ) );
        this.add( okButton, new BGridBagConstraints( 2, 3, 1, 1, 0.0, 0.0
        , GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets( 5, 5, 5, 5 ), 0, 0 ) );
        this.add( cancelButton, new BGridBagConstraints( 1, 3, 1, 1, 1.0, 0.0
        , GridBagConstraints.EAST, GridBagConstraints.NONE, new Insets( 5, 5, 5, 5 ), 0, 0 ) );
        
        //Add action listeners
        this.okButton.addActionListener( this.actionListener );
        this.cancelButton.addActionListener( this.actionListener );

        //Put in all the correct text
        this.doDialect();
    }
    
    /**
     * When called, this method will check the new passwords
     * and send them to the user database for updating. If they
     * get a problem it will display the error in a dialog.
     * Please complete the missing tags for doOK
     * @param
     * @return
     * @pre
     * @post
     */
    private void doOK()
    {
        BChangePasswordCE changePWCE = null;
        BStandardOutCE standardOut = null;
        String oldPassword = ( new String( this.originalField.getPassword() ) ).trim();
        String newPassword = ( new String( ( this.newField.getPassword() ) ) ).trim();
        String reenterPassword = ( new String( this.reenterField.getPassword() ) ).trim();

        //Make sure they entered the original password
        if( this.isAdmin || oldPassword.length() > 0 )
        {
            //Check that the new passwords match before continuing
            if( newPassword.equals( reenterPassword ) )
            {
                //Go through and change the passwords
                changePWCE = new BChangePasswordCE( this, this.user, oldPassword, newPassword, new BPasswordChangeComplete() );
                this.eventDispatcher.dispatchEventServer( changePWCE );
            }
            else
            {
                //Indicate to the user that the two passwords don't match
                this.doMessage(BDialect.getString(this, "wrongNewPassword"), BStandardOutCE.kError);
            }
        }
        else
        {
            //Indicate to the user that they need to
            this.doMessage(BDialect.getString(this, "wrongOldPassword"), BStandardOutCE.kError);
        }
    }

    /**
     * This will display a message using standard out
     *
     * @param   message The message to display
     * @param   type    The type of message BStandardOutCE.kError, BStandardOutCE.kInfo, BStandardOutCE.kQuestion, BStandardOutCE.kWarning
     */
    protected void doMessage(String message, int type)
    {
        BStandardOutCE standardOut = new BStandardOutCE(this, message);
        standardOut.setMessageType(type);
        this.eventDispatcher.dispatchEvent(standardOut);
    }

    /**
     * This will simply close the dialog
     * Please complete the missing tags for doClose
     * @param
     * @return
     * @pre
     * @post
     */
    protected void doClose()
    {
        BCloseWindowCE closeCE = new BCloseWindowCE( this, this );
        this.eventDispatcher.dispatchEvent( closeCE );
    }
    
    /**
     * When the password change is complete, the doComplete method
     * of this object will be called. If it is succesfull, it will
     * close the dialog, if not, it will show a dialog indicating
     * why the change failed.
     *
     * @author Tristan Austin
     */
    public class BPasswordChangeComplete extends BCommandComplete
    {
        /**
         * Called by the user database (indirectly) when the change
         * of the password is complete. The status indicates the
         * success or failure of the effort.
         *
         * @param   status  The success of failure of the update
         */
        public void doComplete( BCommandEvent event, int status )
        {
            Debug.doPrintln( "Do complete was called." );
            BChangePasswordCE passwordEvent = ( BChangePasswordCE ) event;
            int changeState = passwordEvent.getState();
            
            //Determine whether we succeeded or failed
            if( changeState == BChangePasswordCE.kWrongPassword )
            {
                //Show the invaild message
                Debug.doPrintln( "Error" );
                doMessage(BDialect.getString(this, "wrongOldPassword"), BStandardOutCE.kError);
            }
            else if( changeState == BChangePasswordCE.kChanged )
            {
                Debug.doPrintln( "Success. Closing window." );
                //Success, simply close the dialog
                BChangePassword.this.doClose();
            }
            else if( changeState == BChangePasswordCE.kNoUser )
            {
                //Show the invaild message
                Debug.doPrintln( "Error: No user" );
                doMessage(BDialect.getString(this, "usernf"), BStandardOutCE.kError);
            }
            else
            {
                //An error has occurred
                Debug.doPrintln( "Invalid return status from change password: " + status, Debug.kErrorLevel );
                doMessage(BDialect.getString(this, "unknownError"), BStandardOutCE.kError);
            }
        }
    }

    /**
     * The action listener that handles the action events on
     * the ok and cancel buttons.
     *
     * @author Tristan Austin
     */
    private class BActionListener implements ActionListener
    {
        /**
         * When the user clicks or depresses one of the buttons
         * this method is called to divert the program flow to
         * the appropriate method to either cancel or change
         * the password.
         *
         * @param   actionEvent The event fired
         */
        public void actionPerformed( ActionEvent actionEvent )
        {
            Object source = actionEvent.getSource();
            
            //Determine which button was pressed
            if( source == BChangePassword.this.okButton )
            {
                BChangePassword.this.doOK();
            }
            else if( source == BChangePassword.this.cancelButton )
            {
                BChangePassword.this.doClose();
            }
        }
    }
}




