// $Header: /teamproj/cvsroot/teamb/bkasrc/au/edu/swin/synergy/plugin/userman/BMemberSelect.java,v 1.6 1999/10/12 10:57:28 tp079210 Exp $

//Title:        User Manager
//Version:
//Copyright:    Copyright (c) 1998
//Author:       Tristan Austin
//Company:      Synergy
//Description:  The user manager for CRUDing users

package au.edu.swin.synergy.plugin.userman;

import java.awt.*;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.util.Vector;
import javax.swing.*;
import au.edu.swin.synergy.kernel.BPlugin;
import au.edu.swin.synergy.lib.BGridBagConstraints;
import au.edu.swin.synergy.plugin.mod13.event.BCloseWindowCE;


/**
 * Provides a means of select either users or groups to
 * set as members to a user or group.
 *
 * @author Tristan Austin
 * Please complete these missing tags
 * @copyright
 */
public class BMemberSelect extends JPanel implements ActionListener
{
    JLabel memberLabel = new JLabel();
    JScrollPane memberScrollPane = new JScrollPane();
    JButton okButton = new JButton();
    JButton cancelButton = new JButton();
    JList memberList = new JList();
    
    /**
     * Indicates whether the user selected ok or cancel
     */
    private boolean isOk = false;
    
    /**
     * Enables us to send events to the window manager
     */
    private BPlugin eventDispatcher;
    GridBagLayout gridBagLayout1 = new GridBagLayout();
    
    /**
     * Creates a new m
     * Please complete the missing tags for BMemberSelect
     * @param
     * @return
     * @pre
     * @post
     */
    public BMemberSelect( BPlugin dispatcher )
    {
        this.eventDispatcher = dispatcher;
        try
        {
            jbInit();
        }
        catch( Exception ex )
        {
            ex.printStackTrace();
        }
    }
    
    /**
     * This will get the selected members so that
     * they may be used externally.
     *
     * @return A Vector of BPrivilege objects
     * Please complete the missing tags for getSelectedMembers
     * @param
     * @pre
     * @post
     */
    public Vector getSelectedMembers()
    {
        Object model [] = this.memberList.getSelectedValues();
        Vector members = new Vector( model.length );
        
        //Run through and everything in the model to the Vector
        for( int i = 0; i < model.length; i++ )
        {
            members.addElement( model [ i ] .toString() );
        }
        
        //Return the list
        return members;
    }
    
    /**
     * Sets the list of members that can be selected
     * by the user.
     *
     * @param   members A Vector of BUser or BGroup objects
     * Please complete the missing tags for setMembers
     * @return
     * @pre
     * @post
     */
    public void setMembers( Vector members )
    {
        this.memberList.setListData( members );
    }
    
    /**
     * Indicates whether the user clicked ok or cancel
     * Please complete the missing tags for isOk
     * @param
     * @return
     * @pre
     * @post
     */
    public boolean isOk()
    {
        return this.isOk;
    }
    
    /**
     * Called when the user clicks on the ok or cancel button.
     * Please complete the missing tags for actionPerformed
     * @param
     * @return
     * @pre
     * @post
     */
    public void actionPerformed( ActionEvent actionEvent )
    {
        Object source = actionEvent.getSource();

        //Determine which button was pressed
        if( source == this.okButton )
        {
            this.isOk = true;
        }
        else
        {
            this.isOk = false;
        }

        this.doClose();
    }

    /**
     * This will close this dialog
     */
    protected void doClose()
    {
        BCloseWindowCE closeWindowCE = new BCloseWindowCE( this, this );

        //Tell the window manager to close the dialog
        this.eventDispatcher.dispatchEvent( closeWindowCE );
    }

    /**
     * Please complete the missing tags for jbInit
     * @param
     * @return
     * @pre
     * @post
     */
    
    void jbInit() throws Exception
    {
        setSize( 200, 300 );
        memberLabel.setText( "Members" );
        okButton.setText( "OK" );
        cancelButton.setText( "Cancel" );
        this.setLayout( gridBagLayout1 );
        this.add( memberLabel, new BGridBagConstraints( 0, 0, 1, 1, 0.0, 0.0
        , GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets( 5, 5, 5, 5 ), 0, 0 ) );
        this.add( memberScrollPane, new BGridBagConstraints( 0, 1, 2, 1, 1.0, 1.0
        , GridBagConstraints.CENTER, GridBagConstraints.BOTH, new Insets( 5, 5, 5, 5 ), 0, 0 ) );
        memberScrollPane.getViewport().add( memberList, null );
        this.add( okButton, new BGridBagConstraints( 1, 2, 1, 1, 0.0, 0.0
        , GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets( 5, 5, 5, 5 ), 0, 0 ) );
        this.add( cancelButton, new BGridBagConstraints( 0, 2, 1, 1, 1.0, 0.0
        , GridBagConstraints.EAST, GridBagConstraints.NONE, new Insets( 5, 5, 5, 5 ), 0, 0 ) );
        
        //Add action listeners
        okButton.addActionListener( this );
        cancelButton.addActionListener( this );
    }
}

