//$Header: /teamproj/cvsroot/teamb/bkasrc/au/edu/swin/synergy/plugin/workspace/BCreateProjectWindow.java,v 1.7 1999/10/17 17:14:21 tp082177 Exp $
package au.edu.swin.synergy.plugin.workspace;

import javax.swing.*;
import java.io.*;
import java.awt.event.*;
import java.awt.*;

import au.edu.swin.synergy.plugin.mod13.event.BCloseWindowCE;
import au.edu.swin.synergy.lib.io.BDataFile;
import au.edu.swin.synergy.lib.io.BFileFilter;
import au.edu.swin.synergy.lib.BGridBagConstraints;
import au.edu.swin.synergy.plugin.modeller.BModel;
import au.edu.swin.synergy.plugin.dialect.BString;
import au.edu.swin.synergy.plugin.dialect.BDialect;
import au.edu.swin.synergy.lib.BStringList;
import au.edu.swin.synergy.debug.Debug;
import au.edu.swin.synergy.plugin.mod13.event.BGetFilesCE;
import au.edu.swin.synergy.kernel.BCommandEvent;
import au.edu.swin.synergy.kernel.BCommandComplete;
import au.edu.swin.synergy.plugin.command.event.BStandardOutCE;
import au.edu.swin.synergy.plugin.mod13.bwt.BSwingUtilities;

/**
 * This class provides the GUI to add new projects to the current workspace.
 *
 * @author Matthew Evans
 */
class BCreateProjectWindow extends JPanel implements ActionListener
{
      JLabel nameLabel = new JLabel();
      JTextField nameField = new JTextField();
      JRadioButton currentRadioButton = new JRadioButton();
      JRadioButton newRadioButton = new JRadioButton();
      JButton browseButton = new JButton();
      JButton okButton = new JButton();
      JButton cancelButton = new JButton();
      //File projectFile;

		BWorkspace parent;

      public BCreateProjectWindow(boolean toNewWorkspace, BWorkspace parent)
      {
		this.parent = parent;
	
		this.setSize(400, 200);		
         this.setLayout(new GridBagLayout());

         this.add(nameLabel, new BGridBagConstraints(0, 0, 1, 1, 0.0, 0.0
              ,GridBagConstraints.SOUTHWEST, GridBagConstraints.NONE, new Insets(5, 5, 5, 5), 0, 0));

         add(nameField, new BGridBagConstraints(1, 0, 1, 1, 0.0, 0.0
              ,GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL, new Insets(5, 5, 5, 5), 0, 0));

         add(browseButton, new BGridBagConstraints(2, 0, 1, 1, 0.0, 0.0
              ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(5, 5, 5, 5), 0, 0));

         ButtonGroup radioGroup = new ButtonGroup();
         radioGroup.add(currentRadioButton);
         radioGroup.add(newRadioButton);

         if (toNewWorkspace)
         {
            currentRadioButton.setEnabled(false);
            newRadioButton.setSelected(true);
         }
         else
            currentRadioButton.setSelected(true);


        this.add(currentRadioButton, new BGridBagConstraints(0, 1, 2, 1, 1.0, 0.0
              ,GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL, new Insets(5, 5, 5, 5), 0, 0));

        this.add(newRadioButton, new BGridBagConstraints(0, 2, 2, 1, 1.0, 0.0
              ,GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL, new Insets(5, 5, 5, 5), 0, 0));


		this.add(okButton, new BGridBagConstraints(3, 2, 1, 1, 0.0, 0.0
              ,GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL, new Insets(5, 5, 5, 5), 0, 0));
		this.add(cancelButton, new BGridBagConstraints(3, 3, 1, 1, 0.0, 0.0
              ,GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL, new Insets(5, 5, 5, 5), 0, 0));

         browseButton.addActionListener(this);
         okButton.addActionListener(this);
         cancelButton.addActionListener(this);
         nameField.addActionListener(this);

         //Do the dialect stuff
         this.doDialect();
      }

      /**
       * Sets all the text in the class 
       */
      protected void doDialect()
      {
          BSwingUtilities.setJButtonText(browseButton, BDialect.getString("browse"));
          BSwingUtilities.setJButtonText(okButton, BDialect.getString("ok"));
          BSwingUtilities.setJButtonText(cancelButton, BDialect.getString("cancel"));
          BSwingUtilities.setJButtonText(currentRadioButton, BDialect.getString(this, "toCurrentWorkspace"));
          BSwingUtilities.setJButtonText(newRadioButton, BDialect.getString(this, "toNewWorkspace"));

          BSwingUtilities.setJLabelText(nameLabel, BDialect.getString(this, "name"));

      }

      public void actionPerformed(ActionEvent event)
      {
         Object source = event.getSource();

         if (source == browseButton)
            setProjectName();
         else if (source == nameField)
            doCreateNewProject();
         else if (source == okButton)
            doCreateNewProject();         
         else if (source == cancelButton)
            closeWindow();
      }
      
      /**
	   * Creates a file browser via the window manager, then, on completion of the
	   * file browser task, the chosen file name (if any) is placed in the name field
	   * of this window, as well as setting the path.
	   */
	  public void setProjectName()
      {
		 BFileFilter filter = new BFileFilter(BDialect.getString(this, "projectfileextension"), BDialect.getString(this, "projectFileFilter")); 
		 BGetFilesCE getFile = new BGetFilesCE(".");
		 getFile.setTitle(BDialect.getString(this, "createproject"));
		 getFile.setFileFilter(filter);
		 getFile.setCompletionObject(new OnNewProjectComplete());
		 parent.dispatchEvent(getFile);
      }

  class OnNewProjectComplete extends BCommandComplete
  {
	   public void doComplete( BCommandEvent event, int status )
		{
			if(status == BCommandComplete.kSuccess)
			{
	   		BGetFilesCE getFile = (BGetFilesCE) event;
				
				if(getFile.getSelectedFile() != null)
            {
			   	Debug.doPrintln("Loading file");
  	            File file = getFile.getSelectedFile();
   	         nameField.setText(file.getPath());
				}
			}
			else
			{
				Debug.doPrintln("Error opening file");
			}
		}
  }
		
      /**
		 * Dispatches a close event to the window manager
		 */
		private void closeWindow()
      {
         BCloseWindowCE closeEvent = new BCloseWindowCE(parent, this);
         parent.dispatchEvent(closeEvent);
      }
      
      /**
		 * Calls addProject in BWorkspace, passing a file with the name in
		 * nameField, and whether it is to be added to the current workspace or
		 * a new workspace is to be created.
		 */
	  private void doCreateNewProject()
      {
         if(nameField.getText().trim().length() == 0)
		 {
			BStandardOutCE nameErrorMessage = new BStandardOutCE(this, BDialect.getString("fileNameErrorMessage"));
            nameErrorMessage.setUserResponseOption(BStandardOutCE.kDefaultOption);
            nameErrorMessage.setMessageType(BStandardOutCE.kQuestion);
			parent.dispatchEvent(nameErrorMessage);
         }
		 else
         {
		 	Debug.doPrintln("Project name is " + nameField.getText());
            File projectFile = new File(nameField.getText());
            parent.addProject(projectFile, newRadioButton.isSelected());
            closeWindow();
         }
      }
      
}

