//$Header: /teamproj/cvsroot/teamb/bkasrc/au/edu/swin/synergy/plugin/workspace/BUpdateWorkspaceWindow.java,v 1.11 1999/10/17 22:43:52 tp082177 Exp $
package au.edu.swin.synergy.plugin.workspace;

import au.edu.swin.synergy.lib.BListModel;
import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.filechooser.*;
import java.io.*;
import java.util.Vector;

import au.edu.swin.synergy.plugin.mod13.event.BCloseWindowCE;
import au.edu.swin.synergy.lib.io.BDataFile;
import au.edu.swin.synergy.lib.io.BFileFilter;
import au.edu.swin.synergy.lib.BGridBagConstraints;
import au.edu.swin.synergy.debug.Debug;
import au.edu.swin.synergy.plugin.modeller.BModel;
import au.edu.swin.synergy.plugin.dialect.BString;
import au.edu.swin.synergy.plugin.dialect.BDialect;
import au.edu.swin.synergy.lib.BStringList;
import au.edu.swin.synergy.plugin.mod13.event.BGetFilesCE;
import au.edu.swin.synergy.plugin.mod13.bwt.BSwingUtilities;
import au.edu.swin.synergy.kernel.BCommandEvent;
import au.edu.swin.synergy.kernel.BCommandComplete;

/**
 * A panel that allows a user to add and remove projects from the workspace,
 * or models from the current project
 *
 * @author Matthew Evans
 */
public class BUpdateWorkspaceWindow extends JPanel implements ActionListener
{
    JLabel titleLabel = new JLabel();
    BListModel currentListModel = new BListModel();
    JList currentList = new JList(currentListModel);
    JButton addButton = new JButton();
    JButton newButton = new JButton();
    JButton removeButton = new JButton();
    JButton okButton = new JButton();
    //JButton cancelButton = new JButton();
    GridBagLayout gridBaglayout1 = new GridBagLayout();
    JFileChooser fileBrowser;
    BFileFilter fileFilter;

	 BWorkspace parent;
	 BWorkspacePanel workspaceGUI;
	 //BWorkspaceTreeModel workspaceTreeModel;
	 BProject currentProject;
    
    boolean okSelected;
	 
	 private int displayType;  
    public static final int kProjects = 0;    
    public static final int kModels = 1;
    
    /** 
     * Creates the update window (for projects and models in the workspace) with a 
	 * reference to the workspace as its parent
     *
     * @param parent the workspace 
	 * @param workspaceTreeModel
	 * @param currentProject
	 * @param displayType
	 */
    public BUpdateWorkspaceWindow(BWorkspace parent, BWorkspacePanel workspaceGUI, BProject currentProject, int displayType)
    {
	  this.parent = parent;
	  this.workspaceGUI = workspaceGUI;
	  this.currentProject = currentProject;
      this.displayType = displayType;
		
      this.setLayout(gridBaglayout1);

      if (displayType == kProjects)
      {
         //titleLabel.setFont(new Font("Dialog", 1, 12));
         currentListModel.setContents(workspaceGUI.getProjects());
      }
      else if (displayType == kModels)
      {
         //titleLabel.setFont(new Font("Dialog", 1, 12));
         currentListModel.setContents(currentProject.getModels());
      }

      //this.add(titleLabel, new BGridBagConstraints(0, 0, 1, 1, 0.0, 0.0
        //      ,GridBagConstraints.CENTER, GridBagConstraints.BOTH, new Insets(5, 5, 5, 5), 0, 0));

      currentList = new JList(currentListModel);
      this.add(currentList, new BGridBagConstraints(0, 0, 1, 3, 1.0, 1.0
              ,GridBagConstraints.CENTER, GridBagConstraints.BOTH, new Insets(5, 5, 5, 5), 0, 0));

      this.add(addButton, new BGridBagConstraints(1, 0, 1, 1, 0.0, 0.0
              ,GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL, new Insets(5, 5, 5, 5), 0, 0));

      this.add(removeButton, new BGridBagConstraints(1, 1, 1, 1, 0.0, 0.0
              ,GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL, new Insets(5, 5, 5, 5), 0, 0));

      //add bottomPanel
      this.add(okButton, new BGridBagConstraints(1, 2, 1, 1, 0.0, 0.0
              ,GridBagConstraints.NORTH, GridBagConstraints.HORIZONTAL, new Insets(5, 5, 5, 5), 0, 0));

      /*JPanel bottomPanel = new JPanel();
      bottomPanel.add(okButton);
		//bottomPanel.add(cancelButton);

      //add bottomPanel
      this.add(bottomPanel, new BGridBagConstraints(0, 4, 2, 1, 0.0, 0.0
              ,GridBagConstraints.CENTER, GridBagConstraints.BOTH, new Insets(5, 5, 5, 5), 0, 0));*/

      addButton.addActionListener(this);
      removeButton.addActionListener(this);
      okButton.addActionListener(this);
      //cancelButton.addActionListener(this);

      this.doDialect();
    }


    public void actionPerformed(ActionEvent event)
    {
        Object source = event.getSource();

        if (source == addButton)
        {
           addElement();
        }
        else if (source == removeButton)
        {
           removeElement();
        }
        /*else if (source == cancelButton)
        {
           closeWindow();
        }*/
        else if (source == okButton)
        {
		  	  okSelected = true;
           closeWindow();
        }
	 }

	 /**
     * This will set the text for this class in the
     * appropriate manner for the current Locale
     */
    protected void doDialect()
    {
		  if (displayType == kProjects)
          {
              BSwingUtilities.setJLabelText(titleLabel, BDialect.getString(this, "currentProjects"));
          }
		  else//kModels
		  {
              Object args[] = new Object[]{currentProject.getName()};
              BSwingUtilities.setJLabelText(titleLabel, BDialect.formatText(BDialect.getString(this, "modelsIn"), args));
		  }

        BSwingUtilities.setJButtonText(addButton, BDialect.getString(this, "add"));

        BSwingUtilities.setJButtonText(removeButton, BDialect.getString(this, "remove"));
        BSwingUtilities.setJButtonText(okButton, BDialect.getString(this, "done"));
    }



	 private void addElement()
    {
	 	BFileFilter filter;
  	   BGetFilesCE getFile = new BGetFilesCE(".");
		
      if (this.displayType == kProjects)
      {
			 filter = new BFileFilter(BDialect.getString(this, "projectfileextension"), BDialect.getString(this, "projectFileFilter"));
  			 getFile.setTitle(BDialect.getString(this, "projectFileTitle"));
      }
      else //if (this.displayType == kModels)
      {
          filter = new BFileFilter(BDialect.getString(this, "modelfileextension"), BDialect.getString(this, "modelFileFilter"));
			getFile.setTitle(BDialect.getString(this, "modelFileTitle"));
      }
		
   		getFile.setFileFilter(filter);
		getFile.setCompletionObject(new OnUpdateComplete());
		parent.dispatchEvent(getFile);
    }

  class OnUpdateComplete extends BCommandComplete
  {
	    public void doComplete( BCommandEvent event, int status )
	    {
			if(status == BCommandComplete.kSuccess)
			{
	   			BGetFilesCE getFile = (BGetFilesCE) event;
				
				if(getFile.getSelectedFile() != null)
            	{
			   		Debug.doPrintln("Loading file");
		         	File file = getFile.getSelectedFile();
          
         	 		if (file.getName().trim().length() > 0)
      	    		{
            	 		if (displayType == kProjects)
             			{
	                		workspaceGUI.addProject(file, false);
   	             			currentListModel.setContents(workspaceGUI.getProjects());
      	       			}
         	    		else if (displayType == kModels)
            	 		{
               	 			currentProject.addModel(file, null);
	                		currentListModel.setContents(currentProject.getModels());
			  	        }
      	    		}
         	 		else
	          		{
   	          			Debug.doPrintln(BDialect.getString(this, "nameError"));      	    
				 	}
				}
			}
			else
			{
				Debug.doPrintln("Error opening file");
			}
		}
  }

	 private void removeElement()
     {
       int index = currentList.getSelectedIndex();
       
       if (index != -1)
       {
          if (displayType == kProjects)
          {
             workspaceGUI.removeProject((BProject) currentListModel.getElementAt(index));
             currentListModel.setContents(workspaceGUI.getProjects());
          }
          else if (displayType == kModels)
          {
             if (currentProject.getModels().size() > 0)
             {
                BModel model = (BModel) currentListModel.getElementAt(index);

				if (model != null)
				{
					Debug.doPrintln("removing...");
					workspaceGUI.removeModelEditor(model);
					currentProject.removeModel(model);
				}
	            
				currentListModel.setContents(currentProject.getModels());
             }
          }
       }
    }
    
    /**
     * Dispatches an event to the serverto close an instantiation of BProjectsWindow
     */
    void closeWindow()
    {
        BCloseWindowCE closeEvent = new BCloseWindowCE( parent, this );
        parent.dispatchEvent( closeEvent );
    }

	 public boolean confirmedUpdate()
	 {
		return this.okSelected;
	 }
}
