 //$Header: /teamproj/cvsroot/teamb/bkasrc/au/edu/swin/synergy/plugin/workspace/BWorkspace.java,v 1.62 1999/10/22 00:25:20 tp079210 Exp $

package au.edu.swin.synergy.plugin.workspace;

import au.edu.swin.synergy.kernel.BPlugin;
import au.edu.swin.synergy.kernel.BCommandEvent;
import au.edu.swin.synergy.kernel.BCommandComplete;
import au.edu.swin.synergy.kernel.event.BBootCE;
import au.edu.swin.synergy.plugin.mod13.event.BAddMenuItemCE;
import au.edu.swin.synergy.plugin.mod13.event.BAddPanelCE;
import au.edu.swin.synergy.plugin.mod13.event.BAddToolBarCE;
import au.edu.swin.synergy.plugin.mod13.event.BAddWindowCE;
import au.edu.swin.synergy.plugin.mod13.event.BAddPanelCE;
import au.edu.swin.synergy.plugin.prefs.event.BAddPrefsCE;
import au.edu.swin.synergy.plugin.prefs.event.BUpdatePrefsCE;
import au.edu.swin.synergy.plugin.mod13.event.BCloseWindowCE;
import au.edu.swin.synergy.plugin.mod13.event.BRemovePanelCE;
import au.edu.swin.synergy.plugin.mod13.bwt.BSwingUtilities;
import au.edu.swin.synergy.debug.Debug;
import au.edu.swin.synergy.lib.io.BDataFile;
import au.edu.swin.synergy.lib.io.BFileFilter;
import au.edu.swin.synergy.plugin.modeller.BModelEditor;
import au.edu.swin.synergy.plugin.mod13.event.BGetFilesCE;
import au.edu.swin.synergy.plugin.diagram.event.BGetViewportCE;
import au.edu.swin.synergy.plugin.diagram.BViewport;
import au.edu.swin.synergy.kernel.event.BShutdownCE;
import au.edu.swin.synergy.lib.BStringList;
import au.edu.swin.synergy.plugin.command.event.BStandardOutCE;

import au.edu.swin.synergy.plugin.workspace.event.BDisplayWorkspaceCE;
import au.edu.swin.synergy.plugin.client.event.BLoginCompleteCE;
import au.edu.swin.synergy.plugin.client.event.BLogoutCompleteCE;
import au.edu.swin.synergy.plugin.dialect.BString;
import au.edu.swin.synergy.plugin.dialect.BDialect;
import au.edu.swin.synergy.plugin.dialect.event.BDialectChangeCE;
import au.edu.swin.synergy.plugin.mod13.bwt.BWindowListener;

import au.edu.swin.synergy.plugin.help.BHelpItem;
import au.edu.swin.synergy.plugin.help.BHelpUtil;
import au.edu.swin.synergy.plugin.help.BHelpTreeModel;
import au.edu.swin.synergy.plugin.help.event.BRegisterHelpCE;

import java.awt.*;
import java.awt.event.*;
import java.awt.print.*;
import javax.swing.*;
import javax.swing.tree.*;
import java.io.*;
import java.util.*;


/**
 * The workspace plugin
 *
 * @author Matthew Evans
 */
public class BWorkspace extends BPlugin
{

   BWorkspacePanel workspacePanel;
   JMenuItem newWorkspaceMenuItem;
   JMenuItem saveAsMenuItem;
   JMenuItem saveAllMenuItem;
   JMenuItem addModelMenuItem;
   JMenuItem createModelMenuItem;
   JMenuItem saveModelMenuItem;
   JMenuItem openWorkspaceMenuItem; 
   JMenuItem closeWorkspaceMenuItem; 
   JMenuItem saveWorkspaceMenuItem; 
   JMenuItem addProjectMenuItem;
   JMenuItem saveProjectMenuItem;
   JMenuItem createProjectMenuItem;
   JMenuItem printMenuItem;
   JMenuItem exitMenuItem;
   JMenuItem changeNotationMenuItem;
   JMenu workspaceManagerMenu;
	
	JButton newWorkspaceButton;
	JButton openWorkspaceButton;
	JButton newProjectButton;
	JButton newModelButton;
	JButton saveButton;
	JButton saveAllButton; 
	JButton openButton; //for many filters
	JButton printButton;
	JButton addProjectButton;
	JButton addModelButton;
	JButton changePackageButton;
	
	boolean backedUpWorkspace;

   	// for BSaveable
	protected static final String kKeyName = "name";
	protected static final String kDefaultName = "untitled";
	protected static final String kKeyWorkspace = "workspace_path";

  /**
   * Initialises the BWorkspace plugin
   */
  public void setup(BStringList params)
  {
  	  addToolBarItems();
	  addMenu();
 	  createWorkspace();
  }

	public void registerHelp ()
	{
		try
		{
			BHelpTreeModel tree = new BHelpTreeModel ( "Workspaces & Projects" );
			String path = "/au/edu/swin/synergy/plugin/workspace/help/";

			BHelpItem wp = new BHelpItem ( "Workspaces & Projects", path + "worknproj.html" );

			DefaultMutableTreeNode project;
			BHelpItem p = new BHelpItem ( "Project", path + "project.html" );
			BHelpItem np = new BHelpItem ( "New Project", path + "newproj.html" );
			BHelpItem op = new BHelpItem ( "Open Project", path + "openproj.html" );
			BHelpItem cp = new BHelpItem ( "Close Project", path + "closeproj.html" );
			BHelpItem sp = new BHelpItem ( "Save Project", path + "saveproj.html" );

			DefaultMutableTreeNode workspace;
			BHelpItem w = new BHelpItem ( "Workspace", path + "workspace.html" );
			BHelpItem nw = new BHelpItem ( "New Workspace", path + "newwksp.html" );
			BHelpItem ow = new BHelpItem ( "Open Workspace", path + "openwksp.html" );
			BHelpItem sw = new BHelpItem ( "Save Workspace", path + "savewksp.html" );
			BHelpItem cw = new BHelpItem ( "Close Workspace", path + "closewksp.html" );

			DefaultMutableTreeNode model;			
			BHelpItem m = new BHelpItem ( "Model", path + "model.html" );
			BHelpItem nm = new BHelpItem ( "New Model", path + "newmodel.html" );
			BHelpItem om = new BHelpItem ( "Open Model", path + "openmodel.html" );
			BHelpItem cm = new BHelpItem ( "Close Model", path + "closemodel.html" );
			BHelpItem sm = new BHelpItem ( "Save Model", path + "savemodel.html" );
	
			tree.addHelpItem ( null, wp );
			project = tree.addBranch ( null, "Project" );
			tree.addHelpItem ( project, p );
			tree.addHelpItem ( project, np );
			tree.addHelpItem ( project, op );
			tree.addHelpItem ( project, cp );
			tree.addHelpItem ( project, sp );
			
			workspace = tree.addBranch ( null, "Workspace" );
			tree.addHelpItem ( workspace, w );
			tree.addHelpItem ( workspace, nw );
			tree.addHelpItem ( workspace, ow );
			tree.addHelpItem ( workspace, sw );
			tree.addHelpItem ( workspace, cw );

			model = tree.addBranch ( null, "Model" );
			tree.addHelpItem ( model, m );
			tree.addHelpItem ( model, nm );
			tree.addHelpItem ( model, om );
			tree.addHelpItem ( model, cm );
			tree.addHelpItem ( model, sm );

			BRegisterHelpCE event = new BRegisterHelpCE ( this, tree );
			dispatchEvent ( event );
		}
		catch ( Exception e )
		{
			e.printStackTrace ();
		}
	}

  /**
     * Return a list of plugin dependancies
	 *
     * @return a list of plugins such as "au.edu.swin.synergy.plugin.mod13.BWindowManager"
	 * or null if there are no dependancies
     */

    public BStringList getDependancies()
	{
		BStringList result = new BStringList();
		result.add("au.edu.swin.synergy.plugin.mod13.BWindowManager");
		result.add("au.edu.swin.synergy.plugin.alias.BCohesionAlias");
		return result;
	}

  /**
   * Catches any relevant events for the BWorkspace plugin
   *
   * @param source the instigator of the event caught by this method
   * @param event the command evend in question
   */
  public void onBCommandEvent( Object source, BCommandEvent event )
  {
/*	if ( event instanceof BCloseWindowCE)
	{
		BCloseWindowCE closeEvent = (BCloseWindowCE) event;

		if (closeEvent.getWindowContent() instanceof BModelEditor)
		{
			Debug.doPrintln("Remove model from list of opened models on workspace...");
			workspacePanel.removeModelEditor((BModelEditor) closeEvent.getWindowContent());
		}
	}
	else */if (event instanceof BShutdownCE && !backedUpWorkspace)
	{
	   event.doComplete(BShutdownCE.kCancelShutdown);

		saveOpenWorkspace();

		this.getKernel().doShutdown();
		backedUpWorkspace = true;
	}
    else if (event instanceof BDialectChangeCE)
    {
        this.doDialect();
    }
	if ( event instanceof BBootCE )
	{
		registerHelp ();
	}
  }

  protected void doDialect()
  {
      newWorkspaceMenuItem.setText(BDialect.getString(this, "newworkspace"));
      openWorkspaceMenuItem.setText(BDialect.getString(this, "openworkspace"));
      closeWorkspaceMenuItem.setText(BDialect.getString(this, "closeworkspace"));
      saveWorkspaceMenuItem.setText(BDialect.getString(this, "saveworkspace"));
      saveProjectMenuItem.setText(BDialect.getString(this, "saveproject"));
      addProjectMenuItem.setText(BDialect.getString(this, "addproject"));
	  addModelMenuItem.setText(BDialect.getString(this, "addmodel"));

      createProjectMenuItem.setText(BDialect.getString(this, "createproject"));
      createModelMenuItem.setText(BDialect.getString(this, "createmodel"));
      saveModelMenuItem.setText(BDialect.getString(this, "savemodel"));
      changeNotationMenuItem.setText(BDialect.getString(this, "changenotation"));

      workspacePanel.doDialect();
  }

	private void saveOpenWorkspace()
	{
        try
        {
            OutputStream output = new FileOutputStream(BDialect.getString(this, "workspaceSettingsFile"));
            Properties preferences = new Properties();

	   		if (workspacePanel != null)
			{
        		 preferences.setProperty(kKeyName, workspacePanel.getName());
            	 preferences.setProperty(kKeyWorkspace, workspacePanel.getPath());
		    }
			else
			{
				 preferences.setProperty(kKeyName, new String(""));
            	 preferences.setProperty(kKeyWorkspace, new String(""));
			}

			preferences.store(output, BDialect.getString(this, "settingsHeader"));
        }
        catch(IOException ioException)
        {
            Debug.doPrintln("Workspace backup save error", ioException);
        }
	}
	
	private void createWorkspace()
	{
       workspacePanel = new BWorkspacePanel(this);
       BAddPanelCE addPanel = new BAddPanelCE( this, workspacePanel, new BString(this, "workspacetitle"), BAddPanelCE.kLeft, false );
       Debug.doPrintln( "\nBWorkspace: addWorkspacePanel: Adding the workspace window" );
       dispatchEvent( addPanel );
		
	   this.createLastWorkspace();
	}	

    private void createLastWorkspace()
    {
        try
        {
			InputStream input = new FileInputStream(BDialect.getString(this, "workspaceSettingsFile"));
			Properties preferences = new Properties();
			preferences.load(input);
		   
			String name = (String)preferences.get(kKeyName);

			if (name != null)
			{
				String workspacePath = (String)preferences.get(kKeyWorkspace);
		 
				if (workspacePath.length() > 0 && name.length() > 0)
				{	
					Debug.doPrintln("name: " + name);
					Debug.doPrintln("path: " + workspacePath);
					workspacePanel.setup(name, workspacePath);
				}
			}
		}
		catch(java.io.IOException ioException)
		{
			Debug.doPrintln("error loading previous workspace...");
		}
    }

  
  /**
   * Dispatches an add menu event with a workspace menu items
   */
  private void addMenu()
  {
      workspaceManagerMenu = new JMenu();
	  JMenu projectMenu = new JMenu();
      JMenu modelsMenu = new JMenu();
	  
      newWorkspaceMenuItem = new JMenuItem((new BString(this, "newworkspace")).toString());
      openWorkspaceMenuItem = new JMenuItem((new BString(this, "openworkspace")).toString());
      closeWorkspaceMenuItem = new JMenuItem((new BString(this, "closeworkspace")).toString());
      saveWorkspaceMenuItem = new JMenuItem((new BString(this, "saveworkspace")).toString());
      saveProjectMenuItem =new JMenuItem((new BString(this, "saveproject")).toString());
      saveAsMenuItem = new JMenuItem( );
      saveAllMenuItem = new JMenuItem( );
      saveModelMenuItem = new JMenuItem( );

      addProjectMenuItem = new JMenuItem((new BString(this, "addproject")).toString());
	  addModelMenuItem = new JMenuItem((new BString(this, "addmodel")).toString());

      createProjectMenuItem = new JMenuItem((new BString(this, "createproject")).toString());
      createModelMenuItem = new JMenuItem((new BString(this, "createmodel")).toString());
      saveModelMenuItem = new JMenuItem((new BString(this, "savemodel")).toString());
      changeNotationMenuItem = new JMenuItem((new BString(this, "changenotation")).toString());

      printMenuItem = new JMenuItem();
      exitMenuItem = new JMenuItem();

	  BAddMenuItemCE menuEvent = new BAddMenuItemCE( this, new BString(this, BAddMenuItemCE.kFileMenu ));
      menuEvent.addMenuItem(printMenuItem, new BString(this, "print"));
      dispatchEvent( menuEvent );

      menuEvent = new BAddMenuItemCE( this, new BString(this, BAddMenuItemCE.kFileMenu ));
      menuEvent.addMenuItem(saveAsMenuItem, new BString(this, "saveAs"));
      menuEvent.addMenuItem(saveAllMenuItem, new BString(this, "saveAll"));
      dispatchEvent( menuEvent );

	  menuEvent = new BAddMenuItemCE( this, new BString(this, BAddMenuItemCE.kProjectMenu));
	  menuEvent.addMenuItem(modelsMenu, new BString(this, "models"));
      modelsMenu.add(createModelMenuItem);
      modelsMenu.add(saveModelMenuItem);
	  modelsMenu.addSeparator();
	  modelsMenu.add(changeNotationMenuItem);
      dispatchEvent( menuEvent );

	  menuEvent = new BAddMenuItemCE( this, new BString(this, BAddMenuItemCE.kProjectMenu ));

	  menuEvent.addMenuItem(workspaceManagerMenu, new BString(this, "workspaceManager"));
      workspaceManagerMenu.add(newWorkspaceMenuItem);
      workspaceManagerMenu.add(saveWorkspaceMenuItem);
	  workspaceManagerMenu.addSeparator();	
      workspaceManagerMenu.add(openWorkspaceMenuItem);
      workspaceManagerMenu.add(closeWorkspaceMenuItem);
	  workspaceManagerMenu.addSeparator();	
	  workspaceManagerMenu.add(addProjectMenuItem);
	
	  menuEvent.addMenuItem(projectMenu, new BString(this, "Projects"));	
	  projectMenu.add(createProjectMenuItem);
	  projectMenu.add(saveProjectMenuItem);
	  projectMenu.addSeparator();
      projectMenu.add(addModelMenuItem);
      dispatchEvent( menuEvent );
	  
	  saveWorkspaceMenuItem.setEnabled(false);
	  closeWorkspaceMenuItem.setEnabled(false);
      saveProjectMenuItem.setEnabled(false);
      createModelMenuItem.setEnabled(false);
      addProjectMenuItem.setEnabled(false);
      addModelMenuItem.setEnabled(false);
	  saveModelMenuItem.setEnabled(false);
	  saveAsMenuItem.setEnabled(false);
	  saveAllMenuItem.setEnabled(false);
	  printMenuItem.setEnabled(false);
	  changeNotationMenuItem.setEnabled(false);

      //Set up the menu action listeners
      newWorkspaceMenuItem.addActionListener( new onOpenWorkspace() );
      openWorkspaceMenuItem.addActionListener( new onOpenWorkspace() );
      closeWorkspaceMenuItem.addActionListener( new onCloseWorkspace() );
      saveWorkspaceMenuItem.addActionListener( new onSaveWorkspace() );
      saveProjectMenuItem.addActionListener( new onSaveProject() );
      saveModelMenuItem.addActionListener( new onSaveModel() );
      saveAsMenuItem.addActionListener( new onSaveAs() );
      saveAllMenuItem.addActionListener( new onSaveAll() );
      addModelMenuItem.addActionListener( new onAddRemoveModels() );
      addProjectMenuItem.addActionListener( new onAddRemoveProjects() );
      createProjectMenuItem.addActionListener( new onCreateNewProject() );
      createModelMenuItem.addActionListener( new onCreateNewModel() );
      changeNotationMenuItem.addActionListener( new onChangePackage() );
	  printMenuItem.addActionListener( new onPrint() );
      exitMenuItem.addActionListener( new onExit() );
      Debug.doPrintln( "\nBWorkspace: addMenu: dispatched add menu event" );
  }


  public void addToolBarItems()
  {
	  Class cl = getClass();
	  String path = new String ( "/au/edu/swin/synergy/plugin/workspace/icons/" );

	  newWorkspaceButton = new JButton(BSwingUtilities.getImage(this, path + "new.gif"));
	  openWorkspaceButton = new JButton(BSwingUtilities.getImage(this, path + "open.gif"));
	  newProjectButton = new JButton(BSwingUtilities.getImage(this, path + "project.gif"));
	  newModelButton = new JButton(BSwingUtilities.getImage(this, path + "modeledit.gif"));
  	  saveButton = new JButton(BSwingUtilities.getImage(this, path + "save.gif"));
	  saveAllButton = new JButton(BSwingUtilities.getImage(this, path + "saveall.gif"));
	  printButton = new JButton(BSwingUtilities.getImage(this, path + "print.gif"));
	  changePackageButton = new JButton(BSwingUtilities.getImage(this, path + "model2.gif"));
	  addProjectButton = new JButton(BSwingUtilities.getImage(this, path + "addremoveproject.gif"));
	  addModelButton = new JButton(BSwingUtilities.getImage(this, path + "addremovemodel.gif"));
	  
	  newWorkspaceButton.setToolTipText((new BString(this, "newworkspace")).toString());
	  openWorkspaceButton.setToolTipText((new BString(this, "openworkspace")).toString());
	  newProjectButton.setToolTipText((new BString(this, "createproject")).toString());
	  newModelButton.setToolTipText((new BString(this, "createmodel")).toString());
	  addModelButton.setToolTipText((new BString(this, "addmodel")).toString());
	  addProjectButton.setToolTipText((new BString(this, "addproject")).toString());
	  changePackageButton.setToolTipText((new BString(this, "changenotation")).toString());
	  saveButton.setToolTipText((new BString(this, "saveworkspace")).toString());
	  saveAllButton.setToolTipText((new BString(this, "saveAll")).toString());
	  printButton.setToolTipText((new BString(this, "print")).toString());

	  BAddToolBarCE addToolBar  = new BAddToolBarCE(this, 200);
      addToolBar.addButton(newWorkspaceButton);
      addToolBar.addButton(openWorkspaceButton);
	  addToolBar.addButton(newProjectButton);
	  addToolBar.addButton(newModelButton);
 	  addToolBar.addSeparator();
      addToolBar.addButton(saveButton);
      addToolBar.addButton(saveAllButton);
 	  addToolBar.addSeparator();
      addToolBar.addButton(addProjectButton);
      addToolBar.addButton(addModelButton);
 	  addToolBar.addSeparator();
      addToolBar.addButton(printButton);
	  dispatchEvent(addToolBar);
	  
	  addToolBar = new BAddToolBarCE(this, 175);
      addToolBar.addButton(changePackageButton);
	  dispatchEvent(addToolBar);
	  
	  newWorkspaceButton.addActionListener(new onOpenWorkspace());
	  openWorkspaceButton.addActionListener(new onOpenWorkspace());
	  newProjectButton.addActionListener(new onCreateNewProject());
	  newModelButton.addActionListener(new onCreateNewModel());
	  saveButton.addActionListener(new onSaveWorkspace());
	  saveAllButton.addActionListener(new onSaveAll());
	  addProjectButton.addActionListener(new onAddRemoveProjects());
	  addModelButton.addActionListener(new onAddRemoveModels());
	  printButton.addActionListener(new onPrint());
	  changePackageButton.addActionListener(new onChangePackage());

		newModelButton.setEnabled(false);
		saveButton.setEnabled(false);
		saveAllButton.setEnabled(false);
		addProjectButton.setEnabled(false);
		addModelButton.setEnabled(false);
		printButton.setEnabled(false);
		changePackageButton.setEnabled(false);
  }
  
  public void addProject(File projectFile, boolean toNewWorkspace)
  {
	 workspacePanel.addProject(projectFile, toNewWorkspace);
  }
  
  public void setProjectReliantItems(boolean enabled)
  {
      addModelMenuItem.setEnabled(enabled);
	  createModelMenuItem.setEnabled(enabled);
	  saveModelMenuItem.setEnabled(enabled);
	  changeNotationMenuItem.setEnabled(enabled);
  	  saveProjectMenuItem.setEnabled(enabled);
	  addModelButton.setEnabled(enabled);
	  newModelButton.setEnabled(enabled);	
  }

  public void setWorkspaceReliantItems(boolean enabled)
  {
	saveWorkspaceMenuItem.setEnabled(enabled);
	saveAsMenuItem.setEnabled(enabled);
	saveAllMenuItem.setEnabled(enabled);
	closeWorkspaceMenuItem.setEnabled(enabled);	
	createProjectMenuItem.setEnabled(enabled);
    addProjectMenuItem.setEnabled(enabled);
	saveButton.setEnabled(enabled);
	saveAllButton.setEnabled(enabled); 
	addProjectButton.setEnabled(enabled);
  } 
   
  public void setModelReliantItems(boolean enabled)
  {
      saveModelMenuItem.setEnabled(enabled);
	  changePackageButton.setEnabled(enabled);
  }

  public void setEditorReliantItems(boolean enabled)
  {
      printMenuItem.setEnabled(enabled);
  	  printButton.setEnabled(enabled);
  }

  class onOpenWorkspace implements ActionListener
  {
    public void actionPerformed(ActionEvent event)
    {
		 BFileFilter filter = new BFileFilter(BDialect.getString(this, "workspacefileextension"), BDialect.getString(this, "workspaceFileFilter")); 
		 BGetFilesCE getFile = null;
       
	   	 if (event.getSource() == newWorkspaceMenuItem || event.getSource() == newWorkspaceButton)
		 {
			getFile = new BGetFilesCE(this, ".", false);
		 	getFile.setTitle(BDialect.getString(this, "newworkspace"));
		 }
		 else
		 {
			getFile = new BGetFilesCE(this, ".", true);
		 	getFile.setTitle(BDialect.getString(this, "openworkspace"));
		 }
		 
		 getFile.setFileFilter(filter);
		 getFile.setCompletionObject(new OnOpenWorkspaceComplete());
		 dispatchEvent(getFile);
    }
  }


  class OnOpenWorkspaceComplete extends BCommandComplete
  {
	 public void doComplete( BCommandEvent event, int status )
	 {
		if(status == BCommandComplete.kSuccess)
		{
	  		BGetFilesCE getFile = (BGetFilesCE) event;
				
			if(getFile.getSelectedFile() != null)
         	{
			    Debug.doPrintln("Loading file");
            	File tmpFile = getFile.getSelectedFile();
	         	workspacePanel.setup(tmpFile.getName(), tmpFile.getPath());
			}
		}
		else
		{
			Debug.doPrintln("Error opening file");
		}
	  }
   }

  

  class onCloseWorkspace implements ActionListener
  {
    public void actionPerformed(ActionEvent event)
    {
  	 workspacePanel.close();
     addProjectMenuItem.setEnabled(false);
     closeWorkspaceMenuItem.setEnabled(false);
     saveWorkspaceMenuItem.setEnabled(false);
     saveProjectMenuItem.setEnabled(false);
     createModelMenuItem.setEnabled(false);
     addModelMenuItem.setEnabled(false);
    }
  }

  class onSaveWorkspace implements ActionListener
  {
    public void actionPerformed(ActionEvent event)
    {
       workspacePanel.saveWorkspace();
    }
  }

  class onSaveProject implements ActionListener
  {
  		public void actionPerformed(ActionEvent event)
		{
			 workspacePanel.saveCurrentProject();
		}
  }
  
  class onSaveModel implements ActionListener
  {
  		public void actionPerformed(ActionEvent event)
		{
		 	Debug.doPrintln("saveModel: NYI");
          	workspacePanel.saveCurrentModel();
		}
  }

  class onAddRemoveModels implements ActionListener
  {
    public void actionPerformed(ActionEvent event)
    {
     	  workspacePanel.updateWorkspace(BUpdateWorkspaceWindow.kModels);
    }
  }
  
  class onCreateNewProject implements ActionListener
  {   
     public void actionPerformed(ActionEvent event)
     {
	  	  workspacePanel.createNewProject();	
     }
  }
  
  class onCreateNewModel implements ActionListener
  {
    public void actionPerformed(ActionEvent event)
    {
		 BString tmpStr = new BString( this, "createmodel" );
		 BAddWindowCE addWindow = new BAddWindowCE( this, new BNewModelWindow(BWorkspace.this, workspacePanel), tmpStr.toString());
	     addWindow.setDialog( true );

	    Debug.doPrintln( "\nBWorkspace: addCreateModelWindow: Adding new model window" );

	    dispatchEvent( addWindow );
	}
  }

  class onAddRemoveProjects implements ActionListener
  {
    public void actionPerformed(ActionEvent event)
    {
      workspacePanel.updateWorkspace(BUpdateWorkspaceWindow.kProjects);
    }
  }

  class onSaveAs implements ActionListener
  {
  		public void actionPerformed(ActionEvent event)
		{
          workspacePanel.saveAs();
		}
  }

  class onSave implements ActionListener
  {
  		public void actionPerformed(ActionEvent event)
		{
          workspacePanel.save();
		}
  }

  class onSaveAll implements ActionListener
  {
  		public void actionPerformed(ActionEvent event)
		{
			 Debug.doPrintln("saveAll: NYI");
             workspacePanel.saveAll();
		}
  }
  
  class onPrint implements ActionListener
  {
    public void actionPerformed(ActionEvent event)
    {
		if(workspacePanel != null)
		{
			if(workspacePanel.getCurrentModelEditor() != null)
			{
				new Thread(new DoPrint(workspacePanel.getCurrentModelEditor().getViewport())).start();
			}
			else
			{
				dispatchEvent( new BStandardOutCE(this, "No model to print"));
			}
		}
		else
		{
			// should the print button be dissabled?
		}

		//printJob.setPrintable(???);
		//dispatchEvent(new BGetViewportCE(this, new BGetViewportComplete()));
    }
  }

//  	class BGetViewportComplete /*extends BCommandComplete*/
	class DoPrint implements Runnable
	{
		BViewport viewport = null;

		public DoPrint(BViewport fViewport)
		{
			viewport = fViewport;
		}

		public void run()
		{
			if(viewport != null)
			{
				PrinterJob printJob = PrinterJob.getPrinterJob();
				printJob.validatePage(printJob.defaultPage());
				if(printJob.printDialog())
				{
					printJob.setPrintable(viewport/*Event.getBViewport()*/);
					try
					{
						printJob.print();
						Debug.doPrintln("Done printing");
						dispatchEvent( new BStandardOutCE(this, "Printing complete"));
					}
					catch(Exception E)
					{
						Debug.doPrintln("printing", E);
						dispatchEvent( new BStandardOutCE(this, "An error occured while printing the viewport"));
					}
				}
			}
			else
			{
				dispatchEvent( new BStandardOutCE(this, "No viewport to print"));
			}
		}
		
/*		public void doComplete( BCommandEvent event, int status )
		{
			if(status == BCommandComplete.kSuccess)
			{
			 	BGetViewportCE viewportEvent = (BGetViewportCE) event;
				if(viewportEvent.getBViewport() != null)
				{
					PrinterJob printJob = PrinterJob.getPrinterJob();
					printJob.validatePage(printJob.defaultPage());
					if(printJob.printDialog())
					{
						printJob.setPrintable(viewportEvent.getBViewport());
						try
						{
							printJob.print();
							Debug.doPrintln("Done printing");
							dispatchEvent( new BStandardOutCE(this, "Printing complete"));
						}
						catch(Exception E)
						{
							Debug.doPrintln("printing", E);
							dispatchEvent( new BStandardOutCE(this, "An error occured while printing the viewport"));
						}
					}
				}
				else
				{
					dispatchEvent( new BStandardOutCE(this, "No viewport to print"));
				}
			}
			else
			{
				// error
				dispatchEvent( new BStandardOutCE(this, "Error retreiving viewport"));
			}
		}*/
	}

  class onExit implements ActionListener
  {
    public void actionPerformed(ActionEvent event)
    {
	  	workspacePanel.close();
		
		//shutdown the cohesion client
		BShutdownCE shutdownCohesion = new BShutdownCE(this);
		BWorkspace.this.dispatchEvent(shutdownCohesion);
    }
  }

	class onChangePackage implements ActionListener
	{
		public void actionPerformed(ActionEvent event)
		{
			workspacePanel.changeCurrentModel();
		}
	}
}
