// $Header: /teamproj/cvsroot/teamb/bkasrc/au/edu/swin/synergy/plugin/workspace/BWorkspaceCellRenderer.java,v 1.6 1999/10/17 07:39:48 tp082177 Exp $
/**
* Provides a simple tree cell renderer for the BWorkspaceTree.
*
* @author Christian Karolos & Matty Evans
* @date 12/10/99
*/
package au.edu.swin.synergy.plugin.workspace;

import java.awt.*;
import javax.swing.*;
import javax.swing.tree.*;

import au.edu.swin.synergy.debug.Debug;
import au.edu.swin.synergy.plugin.modeller.BModel;
import au.edu.swin.synergy.plugin.modeller.BModelNode;
import au.edu.swin.synergy.plugin.modeller.BModelArc;
import au.edu.swin.synergy.plugin.mod13.bwt.BSwingUtilities;
import au.edu.swin.synergy.plugin.mod13.BWindowManager;
import au.edu.swin.synergy.lib.BTreeNode;

public class BWorkspaceCellRenderer extends JPanel implements TreeCellRenderer
{
	public static final int kFontSize = 12;
	public static final int kIconGap = 1;

	JLabel label;
	BWorkspaceTree workspaceTree;
	
	Color backColour;
   Color selectionColour;
	
	ImageIcon workspaceIcon;
	ImageIcon projectIcon;
	ImageIcon modelIcon;
	ImageIcon nodeIcon;
	ImageIcon arcIcon;

	public BWorkspaceCellRenderer ( BWorkspaceTree tree )
	{
		this.workspaceTree = tree;
		label = new JLabel();

		Font nodeFont = new Font ( "system", Font.PLAIN, kFontSize );
		//Rectangle2D fontConstraints = nodeFont.getMaxCharBounds(new FontRenderContext());
		
		label.setFont (nodeFont);
		label.setIconTextGap ( kIconGap );
		String path = new String ( "/au/edu/swin/synergy/plugin/workspace/icons/" );

		backColour = Color.white;
		selectionColour = BWindowManager.getHighlightColor();

		workspaceIcon = BSwingUtilities.getImage(this, path + "workspace.gif"  );
		projectIcon = BSwingUtilities.getImage(this, path + "project.gif" ) ;
		modelIcon = BSwingUtilities.getImage(this, path + "model2.gif"  );
		nodeIcon = BSwingUtilities.getImage(this, path + "node1.gif"  );
		arcIcon = BSwingUtilities.getImage(this, path + "arc1.gif" ) ;

		add ( label );
	}

	
	public Component getTreeCellRendererComponent(JTree tree, Object value, boolean selected, 
		boolean expanded, boolean leaf, int row, boolean hasFocus)
	{
		BTreeNode treeNode = ( BTreeNode ) value;

		label.setText ( value.toString () );

		if (selected)
		{
			setBackground(BWindowManager.getHighlightColor());
		}
		else
		{
			setBackground(this.backColour);
		}

		if (treeNode instanceof BWorkspaceTreeModel)
		{
			label.setIcon(workspaceIcon);
		}
		else if (treeNode instanceof BProject)
		{
			label.setIcon(projectIcon);
		}
		else if ( treeNode instanceof BModel )
		{
			label.setIcon(modelIcon);
		}
		else if ( treeNode instanceof BModelNode )
		{
			label.setIcon(nodeIcon);
		}
		else if ( treeNode instanceof BModelArc )
		{
			label.setIcon(arcIcon);
		}

		return this;
	}

}
