//$Header: /teamproj/cvsroot/teamb/bkasrc/au/edu/swin/synergy/plugin/workspace/BWorkspacePanel.java,v 1.58 1999/10/22 00:33:14 tp079210 Exp $
package au.edu.swin.synergy.plugin.workspace;

import au.edu.swin.synergy.lib.BTreeModel;
import au.edu.swin.synergy.lib.BTreeNode;
import au.edu.swin.synergy.lib.io.BDataFile;
import au.edu.swin.synergy.lib.io.BFileFilter;
import au.edu.swin.synergy.lib.BListModel;
import au.edu.swin.synergy.lib.BComboBoxModel;
import au.edu.swin.synergy.lib.BTreeUtil;
import au.edu.swin.synergy.lib.BGridBagConstraints;
import au.edu.swin.synergy.plugin.mod13.event.BGetFilesCE;

import au.edu.swin.synergy.plugin.mod13.event.BAddMenuItemCE;
import au.edu.swin.synergy.plugin.mod13.event.BAddPanelCE;
import au.edu.swin.synergy.plugin.mod13.event.BAddWindowCE;
import au.edu.swin.synergy.plugin.mod13.event.BAddPanelCE;
import au.edu.swin.synergy.plugin.prefs.event.BAddPrefsCE;
import au.edu.swin.synergy.plugin.mod13.event.BAddStatusCE;
import au.edu.swin.synergy.plugin.prefs.event.BUpdatePrefsCE;
import au.edu.swin.synergy.plugin.mod13.event.BCloseWindowCE;
import au.edu.swin.synergy.plugin.mod13.event.BRemovePanelCE;
import au.edu.swin.synergy.plugin.mod13.event.BSelectWindowCE;
import au.edu.swin.synergy.plugin.mod13.bwt.BSwingUtilities;
import au.edu.swin.synergy.plugin.mod13.bwt.BWindowAdapter;
import au.edu.swin.synergy.plugin.mod13.bwt.BWindowEvent;
import au.edu.swin.synergy.lib.io.BSaveable;
import au.edu.swin.synergy.debug.Debug;

import au.edu.swin.synergy.plugin.diagram.BViewport;
import au.edu.swin.synergy.plugin.diagram.BDiagram;
import au.edu.swin.synergy.plugin.modeller.BModelEditor;
import au.edu.swin.synergy.plugin.metamodeller.BMetaModel;
import au.edu.swin.synergy.plugin.diagram.event.BRegisterViewportCE;
import au.edu.swin.synergy.plugin.diagram.BDrawable;

import au.edu.swin.synergy.plugin.modeller.event.BSelectionListener;
import au.edu.swin.synergy.plugin.modeller.event.BSelectionEvent;
import au.edu.swin.synergy.plugin.workspace.propertybag.*;
import au.edu.swin.synergy.plugin.modeller.BModelElement;
import au.edu.swin.synergy.plugin.modeller.BModelNode;
import au.edu.swin.synergy.shapes.BTextArea;

import au.edu.swin.synergy.plugin.packager.BPackageModel;
import au.edu.swin.synergy.plugin.modeller.BModel;

import au.edu.swin.synergy.plugin.editmanager.event.BRegisterUndoCE;

import au.edu.swin.synergy.plugin.command.event.BStandardOutCE;
import au.edu.swin.synergy.kernel.BCommandComplete;
import au.edu.swin.synergy.kernel.BCommandEvent;
import au.edu.swin.synergy.plugin.dialect.BString;
import au.edu.swin.synergy.plugin.dialect.BDialect;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.tree.*;
import java.io.*;
import java.util.Vector;
import au.edu.swin.synergy.lib.BStringList;
import au.edu.swin.synergy.plugin.packager.event.BOpenPackageCE;


/**
 * The workspace GUI.  This provides a tree representation of a user's 'Workspace',
 * which is an analogy of their current projects.  It allows users to add projects
 * that will group related models, and to remove projects they are no longer working on.
 * It (will) also provides access to components on a model for selection and editting.
 * Editting of components in a model is done via a seperate Property Editor.
 *
 * @author Matthew Evans
 */
class BWorkspacePanel extends JPanel implements ActionListener, BSelectionListener, ItemListener
{
    JScrollPane treeScrollPane = new JScrollPane();
    BWorkspaceTreeModel workspaceTreeModel;
    BProject currentProject;
    BWorkspaceTree workspaceTree;
    JPanel projectPanel = new JPanel();
    JPanel projectButtonsPanel = new JPanel();
    BComboBoxModel projectComboModel;
    JComboBox projectCombo;
    JButton projectsButton = new JButton();
    GridBagLayout gridBagLayout1 = new GridBagLayout();
    File workspaceFile;
    BWorkspace parent;
	WorkspacePopup workspacePopup = new WorkspacePopup();
	ProjectPopup projectPopup = new ProjectPopup();
	ModelPopup modelPopup = new ModelPopup();
	ModelElementPopup elementPopup = new ModelElementPopup();
	JPanel errorPanel = new JPanel();
	JLabel errorLabel = new JLabel();
	JPanel currentProjectPanel = new JPanel();
	JLabel currentProjectLabel = new JLabel();
	EditWindowListener windowListener = new EditWindowListener();
     BModel currentModel;
	 BPropertyBag propertyEditor;

	 boolean initiatedByTree;
	 String path = null;
	 boolean isInitialised = false;

     BModelElement currentElement = null;

    /**
     * Any models that are currently opened in the viewport
     */
    Vector openedModels = new Vector();

	 private int kProjectDepth = 1;
	 private int kModelDepth = 2;
	 private int kModelElementDepth = 3;
	 JSplitPane splitPane;
    /**
     * Creates the workspace panel with a reference to the workspace plugin
     *
     * @param parent the workspace plugin
     */
    public BWorkspacePanel(BWorkspace parent)
    {
      this.parent = parent;

      this.setLayout(gridBagLayout1);

//      projectComboModel = new BComboBoxModel();
//      projectCombo = new JComboBox(projectComboModel);
//      this.add(projectCombo, new BGridBagConstraints(0, 0, 1, 1, 1.0, 0.0
//              ,GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL, new Insets(5, 5, 5, 5), 0, 0));
//      this.add(projectsButton, new BGridBagConstraints(1, 0, 1, 1, 0.0, 0.0
//              ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(5, 5, 5, 5), 0, 0)); ;

	  splitPane = new JSplitPane(JSplitPane.VERTICAL_SPLIT);
/*
      this.add(treeScrollPane, new BGridBagConstraints(0, 0, 2, 1, 1.0, 1.0
              ,GridBagConstraints.CENTER, GridBagConstraints.BOTH, new Insets(5, 5, 5, 5), 0, 0));
*/
		JScrollPane propertyScrollPane = new JScrollPane();
		treeScrollPane.getViewport().add(workspaceTree, null);
		propertyEditor = new BPropertyBag();
		propertyScrollPane.getViewport().add(propertyEditor);

		// in order to resize the property bag properly
		propertyScrollPane.addComponentListener(new BPropertyResizeComponentListener(propertyScrollPane));
		
		splitPane.setBottomComponent(propertyScrollPane);
		splitPane.setTopComponent(treeScrollPane);

/*
		this.add(propertyScrollPane, new BGridBagConstraints(0, 2, 2, 1, 1.0, 1.0
              ,GridBagConstraints.CENTER, GridBagConstraints.BOTH, new Insets(5, 5, 5, 5), 0, 0));//
*/
      this.add(splitPane, new BGridBagConstraints(0, 0, 2, 1, 1.0, 1.0
              ,GridBagConstraints.CENTER, GridBagConstraints.BOTH, new Insets(5, 5, 5, 5), 0, 0));

	  //projectsButton.setEnabled(false);
      //add listeners
      //projectsButton.addActionListener(this);

	  errorLabel.setForeground( Color.gray );

	  ((FlowLayout)errorPanel.getLayout()).setHgap( 1 );
	  ((FlowLayout)errorPanel.getLayout()).setVgap( 1 );
	  ((FlowLayout)errorPanel.getLayout()).setAlignment( FlowLayout.LEFT );

	  errorPanel.add( errorLabel );
//	  errorPanel.setPreferredSize( new Dimension( 100, 20 ) );

	  ((FlowLayout)currentProjectPanel.getLayout()).setHgap( 1 );
	  ((FlowLayout)currentProjectPanel.getLayout()).setVgap( 1 );
	  ((FlowLayout)currentProjectPanel.getLayout()).setAlignment( FlowLayout.LEFT );

	  currentProjectPanel.add( currentProjectLabel );

      BAddStatusCE addStatus = new BAddStatusCE( this, errorPanel, 10 );
	  this.parent.dispatchEvent( addStatus );

	  addStatus = new BAddStatusCE( this, currentProjectPanel, 105 );
	  this.parent.dispatchEvent( addStatus );

      //Set the text to the current locale
      this.doDialect();
    }

	public void paint(Graphics graphics)
	{
		if (!isInitialised)
		{
			splitPane.setDividerLocation(0.5);
			isInitialised = true;
		}
		super.paint(graphics);
	}

	/**
	 * This class is used to resize the property editor properly
	 */
	protected class BPropertyResizeComponentListener implements ComponentListener
	{
		protected JScrollPane pane;

		protected BPropertyResizeComponentListener (JScrollPane pane)
		{
			this.pane = pane;
		}
		
		public void componentResized (ComponentEvent event)
		{
//			propertyEditor.setPreferredSize(new Dimension(pane.getViewport().getExtentSize().width, propertyEditor.getPreferredSize().height));
//			propertyEditor.setSize(new Dimension(pane.getViewport()/*.getExtentSize()*/.getWidth(), propertyEditor.getPreferredSize().height));
			Debug.doPrintln("PropertyEditor resize");
			pane.repaint();
		}
		
		public void componentShown (ComponentEvent event)
		{
			pane.repaint();
		}
		
		public void componentHidden (ComponentEvent event) {	}
		public void componentMoved (ComponentEvent event) {	}
	}

	class MouseListener extends MouseAdapter
	{
	 public void mouseClicked(MouseEvent e) 
	 {
		TreePath selPath = workspaceTree.getPathForLocation(e.getX(), e.getY());
		Debug.doPrintln("Mouse click count = " + e.getClickCount());
         
		if(e.getClickCount() == 2) 
		{
     		onDoubleClick(selPath);
		}
		else if (e.getClickCount() == 1)
		{
			onSingleClick(selPath, e);
		}
	 }
	}

	class EditWindowListener extends BWindowAdapter
	{
		/**
		 * Invoked when a window has been closed as the result of calling dispose on the window.
		 */
		public void windowClosed( BWindowEvent windowEvent )
		{
		}
    
		public void windowClosing( BWindowEvent windowEvent )
		{
			Debug.doPrintln("Edit Window closing");
			removeModelEditor((BModelEditor) windowEvent.getWindowContent());
			Debug.doPrintln("window close complete...");
		}

		/**
		 * Invoked when the window is set to be the user's active window, which means the window (or one of its subcomponents) will
		 * receive keyboard events.
		 */
		public void windowActivated( BWindowEvent windowEvent )
		{
			Debug.doPrintln("Edit Window has been activated");
			BModelEditor editor = (BModelEditor) windowEvent.getWindowContent();
			BViewport viewport = editor.getViewport();
			BModel model = (BModel) viewport.getDiagram();
			workspaceTree.setSelectionPath(new TreePath(BTreeUtil.getPathToRoot(model, 0)));
			currentModel = model;
		}
    
		/**
		 * Invoked when a window is no longer the user's active window, which means that keyboard events will no longer be delivered to the
		 * window or its subcomponents.
		 */
		public void windowDeactivated( BWindowEvent windowEvent )
		{
			Debug.doPrintln("edit window has been deactivated");
		}
	}
	
	/**
	 * When a tree node is double clicked
	 */
	void onDoubleClick(TreePath selPath)
	{
		if(selPath != null)
		{
			Object selected = selPath.getLastPathComponent();
			
			if(selected != null)
			{
				initiatedByTree = true;
				
				if(selected instanceof BModel)
				{
					Debug.doPrintln("Showing model");
					BModel model = (BModel) selected;
					showModel(model);
					setCurrentProject((BProject) model.getParent());
				}

				initiatedByTree = false;
			}
		}
	}

	/**
	 * When a tree node is double clicked
	 */
	void onSingleClick(TreePath selPath, MouseEvent e)
	{
		if (selPath != null)
		{
			Object selected = selPath.getLastPathComponent();
			if(selected != null)
			{
				initiatedByTree = true;
					
				if(selected instanceof BModel)
				{
					workspaceTree.setSelectionPath(selPath);
					BModel model = (BModel) selected;
					parent.setModelReliantItems(true);
					
					setModelFocus(model);
					setCurrentProject((BProject) model.getParent());
					//projectsButton.setEnabled(false);
				
					if(e.getModifiers() == MouseEvent.BUTTON3_MASK)
					{
						Debug.doPrintln("displaying popup");
						modelPopup.show(workspaceTree, e.getX(), e.getY());
					}

				}
				else if (selected instanceof BModelElement)
				{
					BModelElement selectedElement = (BModelElement) selected;
					currentModel = (BModel) selectedElement.getParent();
					parent.setModelReliantItems(true);

					if(e.getModifiers() == MouseEvent.BUTTON3_MASK || e.getModifiers() == MouseEvent.BUTTON2_MASK)
					{
						TreePath[] selectionPaths = workspaceTree.getSelectionPaths();

//						if (selectionPaths == null || selectionPaths.length == 0)
						if (selectionPaths == null || selectionPaths.length == 0 || !isSelected(selPath))
						{
							workspaceTree.addSelectionPath(selPath);
						}
						else if (!isSelected(selPath))
						{
							workspaceTree.setSelectionPath(selPath);
						}

						Debug.doPrintln("displaying popup");
						currentModel = (BModel) selectedElement.getParent();
						elementPopup.show(workspaceTree, e.getX(), e.getY());
					}
					else
					{
						Debug.doPrintln("selecting elements");
						selectModelElements();
					}

					setModelFocus((BModel) selectedElement.getParent());
				}
				else if (selected instanceof BProject)
				{
					workspaceTree.setSelectionPath(selPath);
					Debug.doPrintln("onSingleClick: setting current project");
					setCurrentProject((BProject) selected);
					parent.setModelReliantItems(false);
					//projectsButton.setEnabled(true);

					if(e.getModifiers() == MouseEvent.BUTTON3_MASK || e.getModifiers() == MouseEvent.BUTTON2_MASK)
					{
						Debug.doPrintln("displaying popup");
						projectPopup.show(workspaceTree, e.getX(), e.getY());
					}
				}
				else if (selected instanceof BWorkspaceTreeModel)
				{
					workspaceTree.setSelectionPath(selPath);
					//projectsButton.setEnabled(true);
					parent.setModelReliantItems(false);

					if(e.getModifiers() == MouseEvent.BUTTON3_MASK)
					{
						Debug.doPrintln("displaying popup");
						workspacePopup.show(workspaceTree, e.getX(), e.getY());
					}
				}
				else
				{
					parent.setModelReliantItems(false);
					//projectsButton.setEnabled(false);
				}

				initiatedByTree = false;
			}
		}
	}

	public void itemStateChanged(ItemEvent event)
	{
		if (event.getSource() == projectCombo)
		{
         //currentProject = (BProject) projectCombo.getSelectedItem();
			if (currentProject != null)
			{
				Debug.doPrintln("itemStateChanged: currentProject =" + currentProject.getName(), Debug.kWarningLevel);
				TreePath path = new TreePath( BTreeUtil.getPathToRoot(currentProject, 0) );
				workspaceTree.setSelectionPath(path);
			}
		}
	}

    /**
     * Sets the error label to the correct text for the current Locale
     *
     * @param   element The elementto get the statu sof
     */
    protected void setErrorLabel(BModelElement element)
    {
        if (this.currentElement != null)
        {
            this.errorLabel.setForeground( Color.red );
            switch( element.getRuleStatus() )
            {
                case BMetaModel.kMaxInRuleViolation:
                    this.errorLabel.setText( BDialect.getString( this, "maxinviolation" ));
                    break;
                case BMetaModel.kMaxOutRuleViolation:
                    this.errorLabel.setText( BDialect.getString( this, "maxoutviolation" ));
                    break;
                case BMetaModel.kConnectionRuleViolation:
                    this.errorLabel.setText( BDialect.getString( this, "connectionviolation" ));
                    break;
                case BMetaModel.kCircRefRuleViolation:
                    this.errorLabel.setText( BDialect.getString( this, "circrefviolation" ));
                    break;
                default:
                    this.errorLabel.setForeground( Color.gray );
                    this.errorLabel.setText( BDialect.getString( this, "noviolation" ) );
                    break;
            }
        }
        else
        {
            this.errorLabel.setForeground( Color.gray );
            this.errorLabel.setText( BDialect.getString( this, "noviolation" ) );
        }
    }


	public void actionPerformed(ActionEvent event)
	{
		/*if (event.getSource() == projectCombo && !initiatedByTree)
		{
			currentProject = (BProject) projectCombo.getSelectedItem();
        //setCurrentProject((BProject) projectCombo.getSelectedItem());
		   if (currentProject != null)
			{
	         Debug.doPrintln("ActionEvent: currentProject =" + currentProject.getName(), Debug.kWarningLevel);
				TreePath path = new TreePath( BTreeUtil.getPathToRoot(currentProject, 0) );

				if(workspaceTree != null)
				{

					workspaceTree.setSelectionPath(path);
				}
			}
		}
		else if (event.getSource() == projectsButton)
		{
			Object selectedNode = workspaceTree.getLastSelectedPathComponent();
			
			if (selectedNode instanceof BProject)
			{
         		updateWorkspace(BUpdateWorkspaceWindow.kModels);
			}
			else if(selectedNode == workspaceTreeModel.getRoot())
			{
				updateWorkspace(BUpdateWorkspaceWindow.kProjects);
			}

			if (workspaceTreeModel.getProjectBranches().size() == 0)
			{
			  parent.setProjectReliantItems(false);
			}
		}
		else*/ if (event.getSource() == workspaceTree)
		{
            Debug.doPrintln("tree action");
		}
	}

	 public void onSelection( BSelectionEvent event)
	 {
	 	Vector selected = event.getSelected();
        BModelElement element = null;
		if (selected.size() > 0)
		{
            TreePath[] selectedPaths = new TreePath[selected.size()];

			for (int i = 0; i < selected.size(); i++)
			{
                Debug.doPrintln ( "entered for loop" );
                if ( selected.elementAt (i) instanceof BModelElement )
                {
				    propertyEditor.removeAllProperties();
				    Debug.doPrintln("getting tree path to model " + i);
				    element = (BModelElement) selected.elementAt(i);
                    this.currentElement = element;
				    selectedPaths[i] = new TreePath(BTreeUtil.getPathToRoot(element, 0));

				    if ( selected.size() == 1 && i == 0)
				    {
                        setErrorLabel(element);
                    }
				    else
				    {
                        this.errorLabel.setForeground( Color.gray );
                        this.errorLabel.setText( BDialect.getString( this, "noviolation" ) );
				    }
                }
                else
                {
                    currentElement = null;
                }

				if ( selected.size() == 1 && i == 0)
				{
					setErrorLabel(element);
				}
				else
				{
					this.errorLabel.setForeground( Color.gray );
					this.errorLabel.setText( BDialect.getString( this, "noviolation" ) );
				}
				this.errorPanel.revalidate();
/*<<<<<<< BWorkspacePanel.java
                Debug.doPrintln ( "if on first entry" );
      	       if (i == 0)
         	    {
                    if ( element != null )
                    {
   	                    Vector properties = element.getProperties();
      	              
         	           for (int j = 0; properties != null && j < properties.size(); j++)
		       	       {
                            Debug.doPrintln ( "getting props of selected node" );
               	           BTextArea aProperty = (BTextArea) properties.elementAt(j);
	           	           propertyEditor.addStringProperty(aProperty.getName(), aProperty);
   	                       Debug.doPrintln("property " + j + ": " + aProperty.getName() + " is of class: " + aProperty.getClass().getName());
       	               }
                    }
=======/**/

      	   if (i == 0)
         	{
	          Debug.doPrintln("displaying properties");
   	          Vector properties = element.getProperties();
// ADDED BY PHIL
				if (element instanceof BModelNode)
				{
     	      	element.addProperties(propertyEditor);
				}
// END ADDED BY PHIL
         	  for (int j = 0; properties != null && j < properties.size(); j++)
		      {
               	BTextArea aProperty = (BTextArea) properties.elementAt(j);
	           	propertyEditor.addStringProperty(aProperty.getName(), aProperty);
   	            Debug.doPrintln("property " + j + ": " + aProperty.getName() + " is of class: " + aProperty.getClass().getName());
      	      }
/*>>>>>>> 1.50*/

         	    }

			}
			//highlight the selected elements in the tree (need BModels in the collection to do this).
			Debug.doPrintln("selecting paths");

			workspaceTree.setSelectionPaths(selectedPaths);

			Debug.doPrintln("done");
	}
	else
	{
		propertyEditor.removeAllProperties();
        this.currentElement = null;
	}

 }


	public String getName()
	{
		if (workspaceTreeModel != null)
		{
			return workspaceTreeModel.getName();
		}
		else
		{
			return new String("");
		}
	}

	public String getPath()
	{
		if (workspaceTreeModel != null)
			return this.path;
		else
			return new String("");
	}

    /**
     * This will set the text on the panel to the
     * values appropriate to the current locale
     */
    protected void doDialect()
    {
        BSwingUtilities.setJButtonText(projectsButton, BDialect.getString(this, "updateWorkspaceButton"));
        if (errorLabel != null)
        {
            errorLabel.setText(BDialect.getString( this, "noviolation"));
            this.setErrorLabel(this.currentElement);
        }

        if (currentProjectLabel != null)
        {
            currentProjectLabel.setText(BDialect.getString(this, "currentproject"));
        }

        if (workspacePopup != null)
        {
            workspacePopup.doDialect();
        }

        if (projectPopup != null)
        {
            projectPopup.doDialect();
        }

        if (modelPopup != null)
        {
            modelPopup.doDialect();
        }
    }

	public void selectModelElements()
	{
		Debug.doPrintln("getting selection paths");
		TreePath[] selectionPaths = workspaceTree.getSelectionPaths();
		//BModel currentModel = getCurrentModel();
		Debug.doPrintln("CM 1: " + this.currentModel);
		BModelEditor modelView = this.getCurrentModelEditor();
		workspaceTree.removeSelectionPaths(selectionPaths);
		Debug.doPrintln("Selection paths: " + selectionPaths);
		
		if (modelView != null)
		{
			BViewport viewport = modelView.getViewport();
			viewport.unselectAll();
			Debug.doPrintln("viewport: " + viewport);
			
			for (int i=0; i < selectionPaths.length; i++)
			{
				Object element = selectionPaths[i].getLastPathComponent();
				Debug.doPrintln("selecting element in path: " + element);

				//elements must be model elements which are members of the current model
				if (isElementOfCurrentModel(element))
				{
					Debug.doPrintln("selecting the current element");
					//selects the element on the editor, which in turn selects the element in the tree
					viewport.select( (BModelElement) element, BViewport.kAdditiveSelect);
				}
			}

			viewport.repaint();
		}
		else //select the elements purely on the tree
		{
			for (int i=0; i < selectionPaths.length; i++)
			{
				Object element = selectionPaths[i].getLastPathComponent();
				Debug.doPrintln("selecting element in path: " + element);

				//elements must be model elements which are members of the current model
				if (isElementOfCurrentModel(element))
				{
					Debug.doPrintln("selecting the current element");
					//selects the element on the editor, which in turn selects the element in the tree
					workspaceTree.addSelectionPath(selectionPaths[i]);
				}
			}
		}
		
	}
    
	private boolean isElementOfCurrentModel(Object element)
	{
		Debug.doPrintln("element: " + element);
		Debug.doPrintln("cur model: " + this.currentModel);

		//elements must be model elements which are members of the current model
		if (this.currentModel != null)
		{
			if (element instanceof BModelElement && this.currentModel.getIndexOf(element) != -1)
			{
				return true;
			}
		}
		
		return false;
	}

	public boolean isSelected(TreePath path)
	{
		TreePath[] paths = workspaceTree.getSelectionPaths();
		
		for (int i=0; i < paths.length; i++)
		{
			if (paths[i].getLastPathComponent() == path.getLastPathComponent())
			{
				Debug.doPrintln("found path..");
				return true;
			}
		}

		Debug.doPrintln("path not found..");
		return false;
	}

	public void selectAllModelElements()
	{
		Debug.doPrintln("selectAll: NYI");
		BModelEditor modelEditor = this.getCurrentModelEditor();
		BViewport viewport = null;

		if (modelEditor != null)
		{
			viewport = modelEditor.getViewport();
			viewport.unselectAll();
		}

		BModel currentModel = this.getCurrentModel();
		workspaceTree.clearSelection();
		
		for (int i=0; i < currentModel.getChildCount(); i++)
		{
			if (modelEditor != null)
			{
				viewport.select( (BDrawable) currentModel.getChildAt(i), BViewport.kAdditiveSelect);
				viewport.repaint();
			}
			else
			{
				TreePath path = new TreePath(BTreeUtil.getPathToRoot((BTreeNode) currentModel.getChildAt(i), 0));
				workspaceTree.addSelectionPath(path);
			}
		}
	}

	/**
	 * Delete's all the currently selceted model elemetns for a particular model
	 *
	 * @pre a model element is selected
	 */
	public void deleteSelectedModelElements()
	{
		Debug.doPrintln("deleteSelected: NYI");

		TreePath[] selectionPaths = workspaceTree.getSelectionPaths();

		for (int i=0; i < selectionPaths.length; i++)
		{
			this.getCurrentModel().delete((BDrawable) selectionPaths[i].getLastPathComponent());	
		}
	}

	public BModelEditor getCurrentModelEditor()
	{
		BModel currentModel = this.getCurrentModel();
		Debug.doPrintln("currentModel: " + currentModel);
		BModelEditor modelView;
		BViewport viewport;

		for (int i = 0; i < openedModels.size(); i++)
		{
			modelView = (BModelEditor) openedModels.elementAt(i);
			Debug.doPrintln("modelV: " + modelView);
			
			viewport = modelView.getViewport();
			Debug.doPrintln("viewP: " + viewport);
			BModel model = (BModel) viewport.getDiagram();
			Debug.doPrintln("aModel: " + model);

			if ( model == currentModel)
			{
				return modelView;
			}
		}

		return null;
	}
	
	/**
	 * Returns the model with the current focus.  If no model has the current focus, this 
	 * method will return null.
	 *
	 * @return the model with the current focus.
	 */ 
	public BModel getCurrentModel()
	{
		Object selected = workspaceTree.getLastSelectedPathComponent();

		if (selected instanceof BModel)
		{
			return (BModel) selected;
		}
		else if (selected instanceof BModelElement)
		{
			BModelElement selectedElement = (BModelElement) selected;
			return (BModel) selectedElement.getParent();
		}
		else
		{
			Debug.doPrintln("selectedModel: " + selected);
			return null;
		}
	}

    public void setNewProjectDetails (BProject aProject)
    {
       //projectComboModel.setContents(workspaceTreeModel.getProjectBranches());   
       setCurrentProject(aProject);
    }

	public void setCurrentProject(BProject current)
	{
		currentProject = current;
		currentProjectLabel.setText(BDialect.getString(this, "currentproject") + currentProject.getName());
		currentProjectPanel.revalidate();
		//projectCombo.setSelectedItem(currentProject);
		repaint();
	}

	/**
	 * Displays a model in a window
	 *
	 * @param model the model to show
	 */
	public void showModel(BModel model)
	{
		BRegisterViewportCE registerViewport = null;
		BString header = new BString ( this, "modelheader" );
		String modelHeader = header.toString () + model.getName ();
		BModelEditor	modelView = null;
		BModelEditor	editor = null;
		BViewport		viewport = null;

		BAddWindowCE addModelCE = null;
        BRegisterUndoCE registerUndoCE;

		// first attempt to set the focus of an existing editor
		if (!setModelFocus(model))
		{
			Debug.doPrintln("adding a new editor");
			//an editor for this model does not exist yet... creating one
			viewport = new BViewport( parent );
    		modelView = new BModelEditor(viewport);

	    	viewport.addSelectionListener(this);

            registerUndoCE = new BRegisterUndoCE(viewport);
            registerUndoCE.setCompletionObject(modelView.getRegisterUndoCC());
            parent.dispatchEvent(registerUndoCE);

			viewport.setDiagram( model );

			registerViewport = new BRegisterViewportCE( parent, viewport );
			addModelCE = new BAddWindowCE( parent, modelView, modelHeader);
			addModelCE.addWindowListener(modelView);
			addModelCE.addWindowListener(this.windowListener);

			parent.dispatchEvent( registerViewport );
			parent.dispatchEvent( addModelCE );

			openedModels.addElement(modelView);

			if (openedModels.size() == 1)
				parent.setEditorReliantItems(true);
		}
	}

	public void removeModelEditor(BModelEditor editor)
	{
		openedModels.removeElement(editor);
		propertyEditor.removeAllProperties();

		if (openedModels.size() == 0)
			parent.setEditorReliantItems(false);

		Debug.doPrintln("Edit Window has been closed");
	}

	public boolean setModelFocus(BModel model)
	{
		BModelEditor editor = getCurrentModelEditor();

		if (editor != null)
		{
			this.applyForFocus(editor);
			return true;
		}
		else
		{
			return false;
		}
	}

	public void applyForFocus(JComponent focusWindow)
	{
		BSelectWindowCE setEditorFocus = new BSelectWindowCE(this, focusWindow);
		parent.dispatchEvent(setEditorFocus);
	}

    /**
     * Returns all projects that are currently in the workspace
     *
     * @return a Vector of projects, representing all projects 
     *   currently added to the workspace
     */
    public Vector getProjects()
    {
       return workspaceTreeModel.getProjectBranches();
    }

    /**
     * Returns all models that are in the current project
     *
     * @return a Vector of projects, representing all models in the currently selected Project
     */
	 public Vector getModels()
	 {
 		 return currentProject.getModels();
	 }

  public void updateWorkspace(int displayType)
  {
    BUpdateWorkspaceWindow updateWindow = new BUpdateWorkspaceWindow(parent, this, currentProject, displayType);
    
	String title;
	
	if (displayType == BUpdateWorkspaceWindow.kModels)
	{
		title = BDialect.getString(this, "UpdateModels") + currentProject.getName();
	}
	else
	{
		title = BDialect.getString(this, "UpdateProjects") + workspaceTreeModel.getName();
	}

	BAddWindowCE addWindow = new BAddWindowCE(parent, updateWindow, title);
    addWindow.setDialog( true );

    Debug.doPrintln( "\nBWorkspace: addUpdateWindow: Adding an update window" );

    parent.dispatchEvent( addWindow );
  }

    /**
     * Closes the workspace and performs the necessary preliminary steps required
     * for the workspace to be considered closed
     */
	public void close()
	{
		if (workspaceTreeModel != null)
		{
			Vector projects = workspaceTreeModel.getBranches();

			for (int i = 0; i < projects.size(); i++)
			{
				BProject aProject = (BProject) projects.elementAt(i); 
				aProject.saveModifiedModels(this.parent);
			}

			if (workspaceTreeModel.hasBeenModified())
			{
				BStandardOutCE saveRequest = new BStandardOutCE(this, BDialect.getString(this, "saveWorkspaceRequest"), true, new BSaveWorkspaceCC());
				saveRequest.setUserResponseOption(BStandardOutCE.kYesNoOption);
				saveRequest.setMessageType(BStandardOutCE.kQuestion);
				parent.dispatchEvent(saveRequest);
			}
			
			  for (int i=0; i < openedModels.size(); i++)
			  {
					BCloseWindowCE closeModelEditor = new BCloseWindowCE(this, (BModelEditor) openedModels.elementAt(i));
					parent.dispatchEvent(closeModelEditor);
					Debug.doPrintln("closing window " + i);
			  }
			  
			workspaceTreeModel.removeAllChildren();
			//projectComboModel.doRefresh();
			//projectCombo.removeActionListener(this);
			treeScrollPane.getViewport().remove(workspaceTree);
			workspaceTree = null;
			workspaceTreeModel = null; 
			//projectsButton.setEnabled(false);
			parent.setWorkspaceReliantItems(false);
			parent.setProjectReliantItems(false);
			parent.setModelReliantItems(false);
			parent.setEditorReliantItems(false);
			repaint();
		}
	}

	public void removeModelEditor(BModel model)
	{
		BModelEditor editor = null;
		BViewport viewport;

		for(int i=0; i<openedModels.size(); i++)
		{
			editor = (BModelEditor) openedModels.elementAt(i);
			viewport = editor.getViewport();
			
			if (viewport.getDiagram() == model)
			{
				BCloseWindowCE closeModelEditor = new BCloseWindowCE(this, editor);
				parent.dispatchEvent(closeModelEditor);
				Debug.doPrintln("closing window ");
			}
		}
	}
	
   public void saveWorkspace()
   {
     BDataFile workspaceFile = new BDataFile(workspaceTreeModel.getName() + "." + BDialect.getString(this, "workspacefileextension"));
     workspaceFile.openFileForWrite(false);
	 workspaceFile.save(workspaceTreeModel);
     workspaceFile.close();
   }
  
  public void saveCurrentProject()
  {
     BDataFile projectFile = new BDataFile(currentProject.getPath());
     Debug.doPrintln("current project = " + currentProject.getName());
     projectFile.openFileForWrite(false);
 	 projectFile.save(currentProject);
     projectFile.close();
  }

    public void save()
    {
       Object selected = workspaceTree.getLastSelectedPathComponent();

   	   if(selected != null)
       {
			 BSaveable saveObject = (BSaveable) selected;

            if (selected instanceof BWorkspaceTreeModel)
            {
					saveWorkspace();
            }
            else if (selected instanceof BProject)
            {
					saveCurrentProject();
            }
            else if (selected instanceof BModel || selected instanceof BModelElement)
            {
					saveCurrentModel();
			}
		}
	  }

		 
	/**
	 * Returns the project with the current focus in the workspace (will return null if the workspace contains no projects or is not opened)
	 *
	 * @return the project with the current focus
	 */
	public BProject getCurrentProject()
	{
		return currentProject;
	}
		 
	 /**
	  * Saves the item in the workspace tree with the current focus.  If a model item has the current focus, then it's parent model will be saved.
	  */
	 public void saveAs()
     {
       Object selected = workspaceTree.getLastSelectedPathComponent();

   	   if(selected != null)
       {
			 BFileFilter filter = null;
			 BGetFilesCE getFile = new BGetFilesCE(this, ".");
			 getFile.setLoad(false);
			 BSaveable saveObject = (BSaveable) selected;

            if (selected instanceof BWorkspaceTreeModel)
            {
				filter = new BFileFilter(BDialect.getString(this, "workspacefileextension"), BDialect.getString(this, "workspaceFileFilter"));
				getFile.setTitle(BDialect.getString(this, "saveworkspace"));
            }
            else if (selected instanceof BProject)
            {
				filter = new BFileFilter(BDialect.getString(this, "projectfileextension"), BDialect.getString(this, "projectFileFilter"));
				getFile.setTitle(BDialect.getString(this, "saveProject"));
            }
            else if (selected instanceof BModel || selected instanceof BModelElement)
            {
				filter = new BFileFilter(BDialect.getString(this, "modelfileextension"), BDialect.getString(this, "modelFileFilter"));
				getFile.setTitle(BDialect.getString(this, "saveModel"));

				if (selected instanceof BModelElement)
				{
					BModelElement modelElement = (BModelElement) selected;
					saveObject = (BSaveable) modelElement.getParent(); 
				}
			}

       
			 getFile.setFileFilter(filter);
			 getFile.setCompletionObject(new OnSaveAsComplete(saveObject));
			 parent.dispatchEvent(getFile);
        }
        else
        {
            BStandardOutCE nothingToSave = new BStandardOutCE(this, BDialect.getString(this, "nullSaveError"));
            nothingToSave.setMessageType(BStandardOutCE.kInfo);
            parent.dispatchEvent(nothingToSave);
        }
    }

    /**
	  * Saves all elements in the worksapce tree, including the worksacpe itself.
	  */
	 public void saveAll()
    {
        saveWorkspace();
        
        Vector projectsInWorkspace = workspaceTreeModel.getBranches();
        workspaceTreeModel.setModified(false);

        for (int i = 0; i < projectsInWorkspace.size(); i++)
        {
            BProject aProject = (BProject) projectsInWorkspace.elementAt(i);
            BDataFile projectFile = new BDataFile(aProject.getPath());
            Debug.doPrintln("saving project = " + aProject.getName());
            projectFile.openFileForWrite(false);
            projectFile.save(aProject);
            aProject.save(projectFile);
            projectFile.close();
        }
	 }

	 /**
	  * Saves the model with the current focus.
	  *
	  * @pre a model or model element is selected
	  */
	 public void saveCurrentModel()
    {
      BModel currentModel = this.getCurrentModel();

		if(currentModel != null)
		{
          String path = currentModel.getPath();
          Debug.doPrintln("Saving the model");

	       //save the model to its own file too
	       BDataFile modelData = new BDataFile(path);
	       modelData.openFileForWrite(false);
	       modelData.save(currentModel);
	       modelData.close();

          currentModel.setModified(false);
      }
      else
      {
          BStandardOutCE nothingToSave = new BStandardOutCE(this, BDialect.getString(this, "ModelSelectionSaveError"));
          nothingToSave.setMessageType(BStandardOutCE.kInfo);
          parent.dispatchEvent(nothingToSave);
      }
    }

    public void createNewProject()
    {
       boolean newWorkspace = false;
        
       if (workspaceTreeModel == null)
	  	   newWorkspace = true;   
       else
         newWorkspace = false;
           
       BCreateProjectWindow projectWindow = new BCreateProjectWindow(newWorkspace, parent);
       BAddWindowCE addWindow = new BAddWindowCE( this, projectWindow, new BString(this, "createproject" ));
       addWindow.setDialog( true );

	    Debug.doPrintln( "\nBWorkspace: createProjectAction: Adding a new project window" );

       parent.dispatchEvent( addWindow );
	}

	public void doCreateNewModel( File modelFile, String packageFileName )
	{
		BModel model = currentProject.addModel(modelFile, packageFileName);
		
		if (model == null)
		{
          BStandardOutCE modelLoadError = new BStandardOutCE(this, BDialect.getString(this, "ModelLoadError"));
          modelLoadError.setMessageType(BStandardOutCE.kInfo);
		  parent.dispatchEvent(modelLoadError);
		}
		else
		{
			this.showModel(model);
		}
	}

	public void removeProject (BProject aProject)
	{
		workspaceTreeModel.removeBranch(aProject);
		BModelEditor editor = null;
		BViewport viewport = null;

		if (workspaceTreeModel.getChildCount() == 0)
		{
			parent.setProjectReliantItems(false);
		}

		Vector modelsInProject = aProject.getModels();

		for (int i=0; i < modelsInProject.size(); i++)
		{
			for (int j=0; j < openedModels.size(); j++)	
			{
				editor = (BModelEditor) openedModels.elementAt(j);
				viewport = editor.getViewport();

				if (viewport.getDiagram() == (BDiagram) modelsInProject.elementAt(i))
				{
					BCloseWindowCE closeModelEditor = new BCloseWindowCE(this, editor);
					parent.dispatchEvent(closeModelEditor);
					Debug.doPrintln("closing window " + i);
				}
			}
		}

		currentProjectLabel.setText(BDialect.getString(this, "currentprojcect"));
	}

  /**
   * This method will set up a new workspace for the user.  
	* If a worksapce is already opened, it will be closed before opening the new workspace.
	*
	* @param workspaceName the name of the worksapce to set up.
	* @param path the directory path of the workspace
	*/
  public void setup(String workspaceName, String path)
  {
    //workspace path may have a project file ext., as workspaces are created from projects
	String projectExt = "." + BDialect.getString(this, "projectfileextension");
	String workspaceExt = "." + BDialect.getString(this, "workspacefileextension");
    
	if (path.endsWith(projectExt))
       path = path.substring(0, path.length() - projectExt.length());
     
    //check if ext. is a workspace ext. (opening existing workspace) 
    if (!path.endsWith(workspaceExt))
       path += workspaceExt;
    
	if (workspaceName.endsWith(workspaceExt))
       workspaceName = workspaceName.substring(0, workspaceName.length() - workspaceExt.length());
	else if(workspaceName.endsWith(projectExt))
	   workspaceName = workspaceName.substring(0, workspaceName.length() - projectExt.length());

	this.path = path;
	
	File workspaceFile = new File(path);

      if (workspaceTreeModel == null)
 	  {
	    Debug.doPrintln("Created new workspace");
        workspaceTreeModel = new BWorkspaceTreeModel(workspaceName);
	  }
	  else
      { 
        workspaceTreeModel.removeAllChildren();
	    workspaceTreeModel.setName(workspaceName);	
	    Debug.doPrintln("Reset worksapce... all tree nodes removed...");
	  }

	 if(workspaceFile.exists())
	 {
		BDataFile workspaceData = new BDataFile(workspaceFile.getPath());
		workspaceData.openFileForRead();
		workspaceTreeModel = (BWorkspaceTreeModel) workspaceData.autoLoad();
		workspaceData.close();

		// now, resolve the loadList into Package objects....
	    BStringList loadList = workspaceTreeModel.getLoadList();
		  
		for(int i=0; i < loadList.getCount(); i++)
		{
			Debug.doPrintln("Adding project " + loadList.get(i));
			
			addProject(new File(loadList.get(i)), false);
		} 
 	  }

		if (workspaceTree == null)
		{
		  workspaceTree = new BWorkspaceTree(workspaceTreeModel);
	      treeScrollPane.getViewport().add(workspaceTree, null);
	    //  projectCombo.addActionListener(this);
		  workspaceTree.addMouseListener(new MouseListener());
		  parent.setWorkspaceReliantItems(true);
		}

		//projectComboModel.setContents(workspaceTreeModel.getProjectBranches());
		//projectsButton.setEnabled(true);
  }


  /**
   * Adds a project to the workspace.
   *
   * @param the file name of the project being added
   */
  public void addProject(File projectFile, boolean toNewWorkspace)
  {
     boolean alreadyInWorkspace = false;
     
     //check the file is indeed a project file
     if (!projectFile.getPath().endsWith("." + BDialect.getString(this, "projectfileextension")))
     {
       String path = projectFile.getPath();
       projectFile = new File( path + "." + BDialect.getString(this, "projectfileextension"));
     }
     
     String fileName = projectFile.getName();
     Debug.doPrintln("adding project: " + fileName);
     String projectName = fileName.substring(0, fileName.length()-4);

     if (toNewWorkspace)
     {
	    Debug.doPrintln("New workspace");
       this.setup(projectName, new String(projectFile.getPath()));
     }
     else//to current workspace
     {
	    Debug.doPrintln("existing workspace");
       Vector projects = workspaceTreeModel.getProjectBranches();

       for(int i = 0; i < projects.size(); i++)
       {
          BProject searchProject = (BProject) projects.elementAt(i);
          
          if (searchProject.getName().equals(projectName))
             alreadyInWorkspace = true;
       }
     }
     
     if (alreadyInWorkspace)
     {
        //display error message
		BStandardOutCE notifyExisting = new BStandardOutCE(this, BDialect.getString( this, "projectAlreadyExists" ));
		parent.dispatchEvent(notifyExisting);
     }
     else
     {  
 		Debug.doPrintln("not a duplicate");
        BProject aProject = null;//new BProject(workspaceTreeModel, projectName, projectFile.getPath());
        
        //check if it is an existing project, or one the user is creating
        if (projectFile.exists())
        {
           Debug.doPrintln("project exists");
           BDataFile projectData = new BDataFile(projectFile.getPath());
           projectData.openFileForRead();
   		   aProject = (BProject) projectData.autoLoad();

		   if(aProject == null)
		   {
				BStandardOutCE errorMessage = new BStandardOutCE(this, BDialect.getString( this, "projectLoadError" ));
				parent.dispatchEvent(errorMessage);
				Debug.doPrintln("Error loading file");
			    aProject = new BProject(workspaceTreeModel, projectName, projectFile.getPath());
		   }
		   else
		   {
			    aProject.setParent(workspaceTreeModel);
		   }
			
         projectData.close();
      }
	  else
	  {
 		 aProject = new BProject(workspaceTreeModel, projectName, projectFile.getPath());
	  }
           
      workspaceTreeModel.addBranch(aProject);
      this.setNewProjectDetails(aProject);
 
      if (workspaceTreeModel.getBranches().size() == 1)
      {
		 parent.setProjectReliantItems(true);
      }
    }
  }

	/**
	 *
	 */
	public void changeCurrentModel()
	{
		if(workspaceTree != null)
		{
			BModel currentModel = getCurrentModel();
			
			if (currentModel != null)
			{
				Debug.doPrintln("Lets kick some ass!");

				// first, lets get the package...
				BOpenPackageCE openEvent = new BOpenPackageCE(this, new OnGetNewPackage(currentModel));
				parent.dispatchEvent(openEvent);
				
			}
			else
			{
				Debug.doPrintln("No model selected");
				parent.dispatchEvent(new BStandardOutCE(this, BDialect.getString("noselectedmodel")));
			}
		}
		else
		{
			// the button should be dissabled, but....
		}
		
	}

	/**
	 * If the model is displayed in one or more Model Editors, this method will
	 * refresh the viewport so that changes to a models parent notation can be reflected
	 * automatically
	 *
	 * @param model the model to refresh
	 */
	public void refreshModel(BModel model)
	{
		for (int i=0; i < openedModels.size(); i++)
		{
			BModelEditor modelView = (BModelEditor) openedModels.elementAt(i);
			BViewport viewport = modelView.getViewport();
			
			if (viewport.getDiagram() == (BDiagram) model)
			{
				viewport.refreshPalette();
			}
			viewport.repaint();
		}
	}
	
	class OnGetNewPackage extends BCommandComplete
	{
		BModel model = null;

		public OnGetNewPackage(BModel fModel)
		{
			model = fModel;
		}
		
        public void doComplete( BCommandEvent event, int status )
        {
			if(status == BCommandComplete.kSuccess)
			{
				BOpenPackageCE openEvent = (BOpenPackageCE) event;
				if(openEvent.getFileName() != null)
				{
					// OK, lets load the new package...
					BPackageModel newPackage = BPackageModel.loadFromFile( openEvent.getFileName() );
					if(newPackage != null && model != null)
					{
						int result = model.doChangePackage(newPackage);

						if(result != BModel.kChangePackageOK)
						{
							if(result == BModel.kChangePackageNotCompatible)
							{
								parent.dispatchEvent(new BStandardOutCE(this, BDialect.getString(this, "packagenotcompatible"), false, BStandardOutCE.kError, null));
							}
						}

						// tell the viewports to repaint the model...
						refreshModel(model);
					}
				}
				// else the user canceled
			}
			else
			{
				Debug.doPrintln("Error getting package");
			}
		}
	}

    /**
     * This completion class is defined to complete the necessary steps
     * after a workspace has been selected to save or not by the user whilst 
     * closing it.
     */
    class BSaveWorkspaceCC extends BCommandComplete
    {
        /**
         * When the user has chosen whether to save the workspace layout or not, this method is called
         *
         * @param   event   The event that was originally fired
         * @param   status  The success status of the operation
         */
        public void doComplete( BCommandEvent event, int status )
        {
            Debug.doPrintln( "got list of users" );
            BStandardOutCE saveRequest = (BStandardOutCE) event;

            if (saveRequest.getUserResponse() == BStandardOutCE.kYes)
            {
                BWorkspacePanel.this.saveWorkspace();
            }
        }
    }

	class OnSaveAsComplete extends BCommandComplete
	{
		BSaveable saveObject;

		public OnSaveAsComplete(BSaveable saveObject)
		{
			this.saveObject = saveObject;
		}

		public void doComplete(BCommandEvent event, int status)
		{
			if(status == BCommandComplete.kSuccess)
			{
	   			BGetFilesCE getFile = (BGetFilesCE) event;
					
				if(getFile.getSelectedFile() != null)
				{
				   Debug.doPrintln("Saving as new file");
				   File tempFile = getFile.getSelectedFile();
				   String path = new String(tempFile.getPath());
				   String name = tempFile.getName();

				   //determine if the file ends with the appropriate extension
					String requiredExtension = new String();

					if (saveObject instanceof BWorkspaceTreeModel)
						requiredExtension = BDialect.getString(this, "workspacefileextension");
					else if (saveObject instanceof BProject)
						requiredExtension = BDialect.getString(this, "projectfileextension");
					else if (saveObject instanceof BModel)
						requiredExtension = BModel.kFileExtension;

					if (!path.endsWith("." + requiredExtension))
					{
						path = path + "." + requiredExtension;
					}
					else
					{
						name = name.substring(0, name.length() - requiredExtension.length());
					}

				   BDataFile dataFile = new BDataFile(path);
				   dataFile.openFileForWrite(false);
				   ((BTreeNode) saveObject).setName(name);
				   dataFile.save(saveObject);
				   dataFile.close();
				}
			}
			else
			{
				Debug.doPrintln("Error saving file");
			}
		}
	}

	class ModelElementPopup extends JPopupMenu implements ActionListener
	{
		JMenuItem deleteMenuItem;
		JMenuItem selectAllMenuItem;

		public ModelElementPopup()
		{
			super();

			deleteMenuItem = new JMenuItem((new BString(this, "delete")).toString());
			selectAllMenuItem = new JMenuItem((new BString(this, "selectAll")).toString());

			this.add(selectAllMenuItem);
			this.add(deleteMenuItem);

			selectAllMenuItem.addActionListener(this);
			deleteMenuItem.addActionListener(this);
		}

        protected void doDialect()
        {
            deleteMenuItem.setText(BDialect.getString(this, "delete"));
			selectAllMenuItem.setText(BDialect.getString(this, "selectAll"));
        }


		public void actionPerformed(ActionEvent event)
		{
			if (event.getSource() == deleteMenuItem)
			{
				deleteSelectedModelElements();
			}
			else if (event.getSource() == selectAllMenuItem)
			{
				selectAllModelElements();
			}
		}
	}

	class ModelPopup extends JPopupMenu implements ActionListener
	{
		JMenuItem editMenuItem;
		JMenuItem deleteMenuItem;
		JMenuItem saveMenuItem;
		JMenuItem changeMenuItem;

		public ModelPopup()
		{
			super();

			editMenuItem = new JMenuItem((new BString(this, "edit")).toString());
			deleteMenuItem = new JMenuItem((new BString(this, "delete")).toString());
			saveMenuItem = new JMenuItem((new BString(this, "save")).toString());
			changeMenuItem = new JMenuItem((new BString(this, "changemodel")).toString());

			editMenuItem.addActionListener(this);
			deleteMenuItem.addActionListener(this);
			saveMenuItem.addActionListener(this);
			changeMenuItem.addActionListener(this);
			this.add(editMenuItem);
			this.add(changeMenuItem);
			this.add(saveMenuItem);
			this.add(deleteMenuItem);
		}

        protected void doDialect()
        {
            editMenuItem.setText(BDialect.getString(this, "edit"));
			deleteMenuItem.setText(BDialect.getString(this, "delete"));
			saveMenuItem.setText(BDialect.getString(this, "save"));
			changeMenuItem.setText(BDialect.getString(this, "changemodel"));
        }

		public void actionPerformed(ActionEvent event)
		{
			if (event.getSource() == deleteMenuItem)
			{
				BProject currentProject = getCurrentProject();
				BModel model = getCurrentModel();
				currentProject.removeModel(model);
				removeModelEditor(model);
			}
			else if (event.getSource() == editMenuItem)
			{
				showModel(getCurrentModel());
			}
			else if (event.getSource() == saveMenuItem)
			{
				saveCurrentModel();
			}
			else if (event.getSource() == changeMenuItem)
			{
				changeCurrentModel();
			}
		}
	}

	class ProjectPopup extends JPopupMenu implements ActionListener
	{
		JMenuItem addModelsMenuItem;
		JMenuItem deleteMenuItem;
		JMenuItem saveMenuItem;

		public ProjectPopup()
		{
			super();

			addModelsMenuItem = new JMenuItem((new BString(this, "addmodel")).toString());
			deleteMenuItem = new JMenuItem((new BString(this, "delete")).toString());
			saveMenuItem = new JMenuItem((new BString(this, "save")).toString());

			addModelsMenuItem.addActionListener(this);
			deleteMenuItem.addActionListener(this);
			saveMenuItem.addActionListener(this);
			
			this.add(addModelsMenuItem);
			this.add(saveMenuItem);
			this.add(deleteMenuItem);
		}

        protected void doDialect()
        {
            addModelsMenuItem.setText(BDialect.getString(this, "addmodel"));
			deleteMenuItem.setText(BDialect.getString(this, "delete"));
			saveMenuItem.setText(BDialect.getString(this, "save"));
        }

		public void actionPerformed(ActionEvent event)
		{
			if (event.getSource() == saveMenuItem)
			{
				saveCurrentModel();
			}
			else if (event.getSource() == deleteMenuItem)
			{
				removeProject(getCurrentProject());
			}
			else if (event.getSource() == addModelsMenuItem)
			{
				updateWorkspace(BUpdateWorkspaceWindow.kModels);
			}
		}
	}


	class WorkspacePopup extends JPopupMenu implements ActionListener
	{
		JMenuItem addProjectsMenuItem;
		JMenuItem closeMenuItem;
		JMenuItem saveMenuItem;
		JMenuItem saveAllMenuItem;

		public WorkspacePopup()
		{
			super();

			addProjectsMenuItem = new JMenuItem((new BString(this, "addproject")).toString());
			saveMenuItem = new JMenuItem((new BString(this, "save")).toString());
			saveAllMenuItem = new JMenuItem((new BString(this, "saveAll")).toString());
			closeMenuItem = new JMenuItem((new BString(this, "close")).toString());

			addProjectsMenuItem.addActionListener(this);
			saveAllMenuItem.addActionListener(this);
			saveMenuItem.addActionListener(this);
			closeMenuItem.addActionListener(this);
			
			this.add(addProjectsMenuItem);
			this.add(saveMenuItem);
			this.add(saveAllMenuItem);
			this.add(closeMenuItem);
		}

        protected void doDialect()
        {
            addProjectsMenuItem.setText(BDialect.getString(this, "addproject"));
			saveMenuItem.setText(BDialect.getString(this, "save"));
			saveAllMenuItem.setText(BDialect.getString(this, "saveAll"));
			closeMenuItem.setText(BDialect.getString(this, "close"));
        }

		public void actionPerformed(ActionEvent event)
		{
			if (event.getSource() == saveMenuItem)
			{
				saveWorkspace();
			}
			else if (event.getSource() == saveAllMenuItem)
			{
				saveAll();
			}
			else if (event.getSource() == addProjectsMenuItem)
			{
				updateWorkspace(BUpdateWorkspaceWindow.kProjects);
			}
			else if (event.getSource() == closeMenuItem)
			{
				close();
			}
		}
	}

}
