//$Header: /teamproj/cvsroot/teamb/bkasrc/au/edu/swin/synergy/plugin/workspace/BWorkspaceTreeModel.java,v 1.16 1999/10/17 22:08:02 tp082177 Exp $

package au.edu.swin.synergy.plugin.workspace;

import javax.swing.event.TreeModelListener;
import javax.swing.event.TreeModelEvent;
import javax.swing.tree.TreeModel;
import javax.swing.tree.TreePath;
import java.util.Vector;

import au.edu.swin.synergy.lib.BTreeNode;
import au.edu.swin.synergy.lib.BTreeModel;
import au.edu.swin.synergy.lib.BStringList;
import au.edu.swin.synergy.lib.io.BSaveable;
import au.edu.swin.synergy.lib.io.BDataFile;

import au.edu.swin.synergy.debug.Debug;


/**
 * The tree model for the workspace tree
 *
 * @author Matthew Evans
 */
public class BWorkspaceTreeModel extends BTreeModel implements BTreeNode, BSaveable, TreeModelListener
{
	BStringList loadList = null;
    boolean hasChanged = false;

	String name	= null;

  /**
   * Creates a workspace tree model, and gives it a name
   *
   * @param name the name of the model
   */
  public BWorkspaceTreeModel(String name)
  {
	super(name);
//	this.name = name;
    addTreeModelListener(this);
  }

	/**
	 * Default constructor for BSaveable
	 */
  public BWorkspaceTreeModel()
  {
  	super( "unnamed");
  }


    public Vector getProjectBranches()
    {
       return this.branches;
    }


	public String getName()
	{
		return super.getName();
	}
	
	public void setName(String name)
	{
		super.setName(name);
	}
	
	///////////BTreeNodeStuff

      public boolean isLeaf()
      {
         return false;
      }

      public Object getChildAt( int index )
      {
         return branches.elementAt(index);
      }

      public int getChildCount()
      {
         return branches.size();
      }

      public Object getParent()
      {
         return null;
      }

      public int getIndexOf( Object node )
      {
			for (int i=0; i<branches.size(); i++)
			{
				if (branches.elementAt(i) == node)
				{
					return i;
				}
			}

        return -1;
      }

      public void setParent( Object parent )
      {
      }

	  	public BStringList getLoadList()
		{
			return loadList;
		}

		public boolean load(BDataFile file)
		{
			setName(file.getData("name", "untitled"));

			loadList = new BStringList();

			while(true)
			{
				String projectName = file.getData("project_path", null);
				if(projectName == null)
				{
					break;
				}
				else
				{
					loadList.add(projectName);
				}
			}
			return true;
		}

		public boolean save(BDataFile file)
		{
			file.addData("name", getName());

			Vector branches = getProjectBranches();
			
			for(int i=0; i < branches.size(); i++)
			{
				// to embed, do file.save(branch), but we want to link
		        BProject project = (BProject) branches.get(i);
				file.addData("project_path", project.getPath());

				 Debug.doPrintln("Saving the project");

				 //save the model to its own file too
				 BDataFile projectData = new BDataFile(project.getPath());
				 projectData.openFileForWrite(false);
				 projectData.save(project);
				 projectData.close();
			}

            hasChanged = false;

			return true;
		}

    public void treeNodesChanged(TreeModelEvent event)
    {
        this.hasChanged = true;
    }

    public void treeNodesInserted(TreeModelEvent event)
    {
        this.hasChanged = true;
    }

    public void treeNodesRemoved(TreeModelEvent event)
    {
        this.hasChanged = true;    
    }

    public void treeStructureChanged(TreeModelEvent event)
    {
        this.hasChanged = true;
    }

    public boolean hasBeenModified()
    {
        return hasChanged;
    }

    public void setModified(boolean modified)
    {
        this.hasChanged = modified;
    }
}
