package au.edu.swin.synergy.plugin.workspace.event;

import au.edu.swin.synergy.kernel.BCommandEvent;


/**
 * This event is sent after a user has logged on, and is
 * handled by the BWorkspace plugin, to set the workspace for the 
 * logged in user.
 *
 * @author Matthew Evans
 */
public class BDisplayWorkspaceCE extends BCommandEvent
{
   /**
    * The username of the logged in user
    */
   String userName;
   
   /**
    * Creates the event and sets up the userName of the new user, and
    * identifies the source of the event.
    *
    * @param source the plugin that instigated the event
    * @param username the userName of the new user
    */
   public BDisplayWorkspaceCE(Object source, String userName)
   {
      super(source);
      this.userName = userName;
   }
   
   /**
    * returns the user name of the logged in user
    *
    * @return the username of the logged in user
    */
   public String getUserName()
   {
      return this.userName;
   }
}