// $Header:

package au.edu.swin.synergy.shapes;

/**
* Panel containing the components and the ability to 
* alter the fill colour ( later there should be fill style )
* of a particular object.
*
* @author Christian Karolos
* @date 5/9/99
*/

import javax.swing.*;
import javax.swing.border.TitledBorder;
import javax.swing.border.EtchedBorder;
import java.awt.*;

import au.edu.swin.synergy.lib.BColorCombo;
import au.edu.swin.synergy.plugin.dialect.BDialect;

public class BFillEditorPanel extends JPanel
{
	TitledBorder border;
	JLabel colour;

	BColorCombo colourBox = new BColorCombo ( true );

	public BFillEditorPanel ( Color paint )
	{
		border = new TitledBorder ( new EtchedBorder ( EtchedBorder.LOWERED ), BDialect.getString ( this, "fill" ) );
		JLabel colour = new JLabel ( BDialect.getString ( this, "colour" ) );
		
        setBorder ( border );

		setLayout ( new GridBagLayout () );
		GridBagConstraints c = new GridBagConstraints ();

		setConst ( c, 0, 1, GridBagConstraints.EAST );
		add ( colour, c );

		setConst ( c, 1, 1, GridBagConstraints.WEST );
		add ( colourBox, c );
		colourBox.setSelectedItem ( paint );
	}

	public void setColour ( Color nColour )
	{
		colourBox.setSelectedItem ( nColour );
	}

	public Color getColour ()
	{
		return colourBox.getSelectedColor ();
	}

	/**
	* Custom made function for plotting labels and combo boxes on a panel.
	* Panel shouldn't be expandable, so concerning attribs are fixed.
	*/
    public static void setConst( GridBagConstraints gbc, int x, int y, int anc )
    {
        gbc.gridx = x;
        gbc.gridy = y;
        gbc.gridwidth = 1;
        gbc.gridheight = 1;
        gbc.fill = GridBagConstraints.NONE;
        gbc.anchor = anc;
        gbc.insets = new Insets ( 10, 10, 10, 10 );

		// Only a light weight so things don't expand too much.
        gbc.weightx = 1;
        gbc.weighty = 1;
        gbc.ipady = 10;
        gbc.ipadx = 10;
    }
}