// $Header:

/**
* Abstract class for all property panels for any drawable
* to implement.  Provides a global property panel ( which this
* will be added to ) the ability to call appropriate ok or cancel
* functions, allowing the implementing class to take care of the
* rest.
*
* @author Christian Karolos
* @date 30/9/99
*/

package au.edu.swin.synergy.shapes;

import javax.swing.*;

public abstract class BPropPanel extends JPanel
{
    /**
    * This will be called when the ok button is pressed
    * within the global prop panel.  The implementing class
    * will be able to perform validation and update.
    */
    public abstract boolean okPressed ();

    /**
    * Called when cancel button pressed on global prop panel.
    * Implementing class is given chance to cancel, or perform
    * any operations they see fit on this action.
    */
    public abstract boolean cancelPressed ();
}

