// $Header: /teamproj/cvsroot/teamb/makesrc/au/edu/swin/synergy/make/BFileCopy.java,v 1.6 1999/09/06 08:11:29 tp079519 Exp $
package au.edu.swin.synergy.make;

import java.io.File;
import java.io.FileOutputStream;
import java.io.OutputStream;
import java.io.IOException;
import java.lang.*;
import java.util.Vector;
import java.io.FileInputStream;
import java.io.InputStream;

/**
 * Please complete these missing tags
 * @see
 * @concurrency
 * @copyright
 * @rref
 * @author John Newbigin
 */

class BFileCopy
{
	Vector includeFileTypes = new Vector();
	Vector excludeFileTypes = new Vector();
	
    /**
     * Please complete the missing tags for process
     * @post
     * @pre
     * @throws
     * @returns
     * @param
     */

	private String getLine(InputStream inputStream)
	{
        String str = null;
        while( true )
        {
            int letter;
            try
            {
                letter = inputStream.read();
            }
            catch( Exception e )
            {
				letter = -1;
            }
            
            if( letter == - 1 )
            {
				return str;
            }
            else if( letter == 13 )
            {
                // ignore
            }
            else if( letter == 10 )
            {
                break;
            }
            else
            {
				if(str == null)
				{
					str = new String();
				}
                str = str + ( char ) letter;
            }
            
        }
        return str;
    }

	private void loadConfig(File configFile)
	{
		try
		{
			FileInputStream inputStream = new FileInputStream(configFile);
			
			while(true)
			{
				String line = getLine(inputStream);
				if(line == null)
				{
					break;
				}
				//System.err.println(line);
				if(line.startsWith("!"))
				{
					BFileType type = new BFileType();
					type.setString(line.substring(1));
					excludeFileTypes.add(type);
				}
				else
				{
					BFileType type = new BFileType();
					type.setString(line);
					includeFileTypes.add(type);
				}
			}
		}
		catch(Exception e)
		{
			System.err.println("Error loading config");
		}
	}
	 

	public boolean doProcess(String src, String dest)
	{
		// make File objects
		File srcFile = new File(src);
		File destFile = new File(dest);

		if(srcFile.exists() && destFile.exists())
		{
			// read the configuration
			File configFile = new File(srcFile + File.separator + "package.conf");
			if(configFile.exists())
			{
				System.err.println("Reading package configuration...");
				loadConfig(configFile);
			}
			else
			{
				System.err.println("package.conf does not exits");
				return false;
			}
			int count = processDir(srcFile, destFile);
			System.err.println("Copied " + count + " files");
		}
		else
		{
			System.err.println("Directory does not exist");
		}
		return true;
	}
	
    private int processDir( File src, File dest )
    {
		int result = 0;
        File [] files = src.listFiles();
        
        for( int i = 0; i < files.length; i++ )
        {
			if(files[i].isFile())
			{
				String fileName = files[i].getName();
				if(copyFile(fileName, includeFileTypes) && !copyFile(fileName, excludeFileTypes))
				{
					System.err.println("Copying file " + fileName);
					copyTheFile(files[i], dest);
					result++;
				}
				
/*		        if( fileName.endsWith( ".java" ) || fileName.endsWith( ".jav" ) || fileName.endsWith( ".JAV" ) )
				{
					int dot = fileName.lastIndexOf('.');
					String className = fileName.substring(0, dot);
					File classFile = new File(dest.getPath() + File.separator + className + ".class");
					if(classFile.exists())
					{
						// check dates
						if(files[i].lastModified() > classFile.lastModified())
						{
							// we should delete the class file
							classFile.delete();
							result++;
							System.out.println(files[i].getPath());
						}
					}
					else
					{
						System.out.println(files[i].getPath());
					}
				}*/
			}
			else if(files[i].isDirectory())
			{
				result += processDir(new File(src + File.separator + files[i].getName()), new File(dest + File.separator + files[i].getName()));
			}
        }
		return result;
    }

	private boolean copyFile(String fileName, Vector fileTypes)
	{
		// see if this file is matched by the types in fileTypes
		for(int i=0; i<fileTypes.size(); i++)
		{
			BFileType fileType = (BFileType) fileTypes.get(i);

			if(fileType.match(fileName))
			{
				return true;
			}
		}
		return false;
	}

	private void copyTheFile(File sourceFile, File destDir)
	{
		try
		{
			if(!destDir.exists())
			{
				//System.err.println("Making directory " + destDir.getPath());
				destDir.getAbsoluteFile().mkdirs();
			}
			if(!destDir.exists())
			{
				System.err.println("The directory still does not exits!");
			}
			
			// add the file name
			destDir = new File(destDir.getPath() + File.separator + sourceFile.getName());
			
			//System.out.println("copy " + sourceFile.getPath() + " " + destDir.getPath());
			FileInputStream inputStream = new FileInputStream(sourceFile);
			FileOutputStream outputStream = new FileOutputStream(destDir);
			for(int i=0; i<sourceFile.length(); i++)
			{
				outputStream.write(inputStream.read());
			}
			inputStream.close();
			outputStream.close();
		}
		catch(Exception e)
		{
			System.err.println("Error copying file");
			e.printStackTrace();
		}
	}


	private class BFileType
	{
		private String extention = null;
		private boolean wildcard = false;

		void setString(String data)
		{
			// if it starts with a '*' then it is a wildcard
			if(data.startsWith("*"))
			{
				wildcard = true;
				extention = data.substring(1);
			}
			else
			{
				extention = data;
			}
		}

		boolean match(String fileName)
		{
			if(wildcard)
			{
				if(fileName.endsWith(extention))
				{
					return true;
				}
			}
			else
			{
				if(fileName.equals(extention))
				{
					return true;
				}
			}
			return false;
		}
	}
}
;
