//$Header: /teamproj/cvsroot/teamb/nodebugsrc/au/edu/swin/synergy/debug/DebugTestHarness.java,v 1.1 1999/08/22 21:52:40 tp079519 Exp $

package au.edu.swin.synergy.debug;

/**
 * The test harness for the debug classes
 */
public class DebugTestHarness
{
   /**
    * The method executed when the harness is run
    */
   public static void main(String args[]) throws Exception
   {
      try
      {
         //Initialise the classes
         Debug.doInitialisation();
         Log.doInitialisation();

         //Test the debug class
         Debug.doPrintln("General coder output");
         Debug.doPrintln("Error level 0", Debug.kPrintLevel);
         Debug.doPrintln("Error level 1", Debug.kWarningLevel);
         Debug.doPrintln("Error level 2", Debug.kErrorLevel);
         Debug.doPrintln("Error level 3", Debug.kFatalLevel);
         Debug.doPrintln("A message with an associated debug level", 3);

         //Test the log class
         Log.doPrintln("General logging message");
         Log.doWarning("Look out!");
         Log.doError("Bummer", 2);
         Log.doError("An error has occurred.", "error1", 0);
//         Log.doFataError("Exitting system!");

         //Test the assertion class
         Assertion.doWarning(5 > 7);
         Assertion.doWarning(8 < 3, "Eight is not greater than three");
//         Assertion.doAssert(12 >= 14);
//         Assertion.doAssert(342 > 876, "342 is not less than 876");

      }
      catch(Exception e)
      {
         e.printStackTrace();
      }

      System.out.print("\nPress enter to exit");

      System.in.read();
   }
}